/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensions/common/extensionHostStarter","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensions/node/extensionHostStarter","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],te=function(K){for(var e=[],D=0,T=K.length;D<T;D++)e[D]=Z[K[D]];return e};define(Z[91],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(T,R){if(!T)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(Z[63],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function T(i){const C=[];for(let f in i)D.call(i,f)&&C.push(i[f]);return C}e.values=T;function R(i,C){for(let f in i)if(D.call(i,f)&&C({key:f,value:i[f]},function(){delete i[f]})===!1)return}e.forEach=R;function L(i,C){const f=Object.create(null);for(const E of i){const u=C(E);let S=f[u];S||(S=f[u]=[]),S.push(E)}return f}e.groupBy=L;function k(i){const C=Object.create(null);return i&&i.forEach((f,E)=>{C[E]=f}),C}e.fromMap=k;function P(i,C){const f=[],E=[];for(let u of i)C.has(u)||f.push(u);for(let u of C)i.has(u)||E.push(u);return{removed:f,added:E}}e.diffSets=P;function m(i,C){const f=[],E=[];for(let[u,S]of i)C.has(u)||f.push(S);for(let[u,S]of C)i.has(u)||E.push(S);return{removed:f,added:E}}e.diffMaps=m;class I{constructor(){this.map=new Map}add(C,f){let E=this.map.get(C);E||(E=new Set,this.map.set(C,E)),E.add(f)}delete(C,f){const E=this.map.get(C);!E||(E.delete(f),E.size===0&&this.map.delete(C))}forEach(C,f){const E=this.map.get(C);!E||E.forEach(f)}}e.SetMap=I}),define(Z[64],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(P,m,I)=>{let i=null,C=null;if(typeof I.value=="function"?(i="value",C=I.value):typeof I.get=="function"&&(i="get",C=I.get),!C)throw new Error("not supported");I[i]=k(C,m)}}e.createDecorator=D;function T(k,P,m){let I=null,i=null;if(typeof m.value=="function"?(I="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(I="get",i=m.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;m[I]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,f)}),this[C]}}e.memoize=T;function R(k,P,m){return D((I,i)=>{const C=`$debounce$${i}`,f=`$debounce$result$${i}`;return function(...E){this[f]||(this[f]=m?m():void 0),clearTimeout(this[C]),P&&(this[f]=P(this[f],...E),E=[this[f]]),this[C]=setTimeout(()=>{I.apply(this,E),this[f]=m?m():void 0},k)}})}e.debounce=R;function L(k,P,m){return D((I,i)=>{const C=`$throttle$timer$${i}`,f=`$throttle$result$${i}`,E=`$throttle$lastRun$${i}`,u=`$throttle$pending$${i}`;return function(...S){if(this[f]||(this[f]=m?m():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...S)),this[u])return;const g=this[E]+k;g<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[f]]),this[f]=m?m():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[E]=Date.now(),I.apply(this,[this[f]]),this[f]=m?m():void 0},g-Date.now()))}})}e.throttle=L}),define(Z[9],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function T(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=T;function R(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function L(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=L;function k(a){if(a instanceof Error){let{name:t,message:r}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:n}}return a}e.transformErrorForSerialization=k;const P="Canceled";function m(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=m;class I extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=I;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function f(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=f;function E(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function S(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=S;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function w(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=w;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[17],te([0,1,9]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(_,Y=0){return _[_.length-(1+Y)]}e.tail=T;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function L(_,Y,G=(ne,ee)=>ne===ee){if(_===Y)return!0;if(!_||!Y||_.length!==Y.length)return!1;for(let ne=0,ee=_.length;ne<ee;ne++)if(!G(_[ne],Y[ne]))return!1;return!0}e.equals=L;function k(_,Y,G){let ne=0,ee=_.length-1;for(;ne<=ee;){const X=(ne+ee)/2|0,B=G(_[X],Y);if(B<0)ne=X+1;else if(B>0)ee=X-1;else return X}return-(ne+1)}e.binarySearch=k;function P(_,Y){let G=0,ne=_.length;if(ne===0)return 0;for(;G<ne;){const ee=Math.floor((G+ne)/2);Y(_[ee])?ne=ee:G=ee+1}return G}e.findFirstInSorted=P;function m(_,Y,G){if(_=_|0,_>=Y.length)throw new TypeError("invalid index");let ne=Y[Math.floor(Y.length*Math.random())],ee=[],X=[],B=[];for(let re of Y){const ie=G(re,ne);ie<0?ee.push(re):ie>0?X.push(re):B.push(re)}return _<ee.length?m(_,ee,G):_<ee.length+B.length?B[0]:m(_-(ee.length+B.length),X,G)}e.quickSelect=m;function I(_,Y){const G=[];let ne;for(const ee of _.slice(0).sort(Y))!ne||Y(ne[0],ee)!==0?(ne=[ee],G.push(ne)):ne.push(ee);return G}e.groupBy=I;function i(_,Y,G){const ne=[];function ee(re,ie,ce){if(ie===0&&ce.length===0)return;const ue=ne[ne.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=ie,ue.toInsert.push(...ce)):ne.push({start:re,deleteCount:ie,toInsert:ce})}let X=0,B=0;for(;;){if(X===_.length){ee(X,0,Y.slice(B));break}if(B===Y.length){ee(X,_.length-X,[]);break}const re=_[X],ie=Y[B],ce=G(re,ie);ce===0?(X+=1,B+=1):ce<0?(ee(X,1,[]),X+=1):ce>0&&(ee(X,0,[ie]),B+=1)}return ne}e.sortedDiff=i;function C(_,Y,G){const ne=i(_,Y,G),ee=[],X=[];for(const B of ne)ee.push(..._.slice(B.start,B.start+B.deleteCount)),X.push(...B.toInsert);return{removed:ee,added:X}}e.delta=C;function f(_,Y,G){if(G===0)return[];const ne=_.slice(0,G).sort(Y);return u(_,Y,ne,G,_.length),ne}e.top=f;function E(_,Y,G,ne,ee){return G===0?Promise.resolve([]):new Promise((X,B)=>{(async()=>{const re=_.length,ie=_.slice(0,G).sort(Y);for(let ce=G,ue=Math.min(G+ne,re);ce<re;ce=ue,ue=Math.min(ue+ne,re)){if(ce>G&&await new Promise(ge=>setTimeout(ge)),ee&&ee.isCancellationRequested)throw(0,D.canceled)();u(_,Y,ie,ce,ue)}return ie})().then(X,B)})}e.topAsync=E;function u(_,Y,G,ne,ee){for(const X=G.length;ne<ee;ne++){const B=_[ne];if(Y(B,G[X-1])<0){G.pop();const re=P(G,ie=>Y(B,ie)<0);G.splice(re,0,B)}}}function S(_){return _.filter(Y=>!!Y)}e.coalesce=S;function g(_){let Y=0;for(let G=0;G<_.length;G++)_[G]&&(_[Y]=_[G],Y+=1);_.length=Y}e.coalesceInPlace=g;function b(_,Y,G){_.splice(G,0,_.splice(Y,1)[0])}e.move=b;function y(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=y;function w(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=w;function o(_,Y){if(!Y)return _.filter((ne,ee)=>_.indexOf(ne)===ee);const G=Object.create(null);return _.filter(ne=>{const ee=Y(ne);return G[ee]?!1:(G[ee]=!0,!0)})}e.distinct=o;function a(_){const Y=new Set;return _.filter(G=>Y.has(G)?!1:(Y.add(G),!0))}e.distinctES6=a;function t(_){const Y=Object.create(null);return G=>{const ne=_(G);return Y[ne]?!1:(Y[ne]=!0,!0)}}e.uniqueFilter=t;function r(_,Y){for(let G=_.length-1;G>=0;G--){const ne=_[G];if(Y(ne))return G}return-1}e.lastIndex=r;function n(_,Y){return _.length>0?_[0]:Y}e.firstOrDefault=n;function s(_,Y,G=(ne,ee)=>ne===ee){let ne=0;for(let ee=0,X=Math.min(_.length,Y.length);ee<X&&G(_[ee],Y[ee]);ee++)ne++;return ne}e.commonPrefixLength=s;function c(_){return[].concat(..._)}e.flatten=c;function l(_,Y){let G=typeof Y=="number"?_:0;typeof Y=="number"?G=_:(G=0,Y=_);const ne=[];if(G<=Y)for(let ee=G;ee<Y;ee++)ne.push(ee);else for(let ee=G;ee>Y;ee--)ne.push(ee);return ne}e.range=l;function h(_,Y,G){return _.reduce((ne,ee)=>(ne[Y(ee)]=G?G(ee):ee,ne),Object.create(null))}e.index=h;function d(_,Y){return _.push(Y),()=>p(_,Y)}e.insert=d;function p(_,Y){const G=_.indexOf(Y);if(G>-1)return _.splice(G,1),Y}e.remove=p;function A(_,Y,G){const ne=_.slice(0,Y),ee=_.slice(Y);return ne.concat(G,ee)}e.arrayInsert=A;function O(_,Y){let G;if(typeof Y=="number"){let ne=Y;G=()=>{const ee=Math.sin(ne++)*179426549;return ee-Math.floor(ee)}}else G=Math.random;for(let ne=_.length-1;ne>0;ne-=1){const ee=Math.floor(G()*(ne+1)),X=_[ne];_[ne]=_[ee],_[ee]=X}}e.shuffle=O;function v(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.unshift(Y))}e.pushToStart=v;function U(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.push(Y))}e.pushToEnd=U;function F(_,Y){return Array.isArray(_)?_.map(Y):Y(_)}e.mapArrayOrNot=F;function z(_){return Array.isArray(_)?_:[_]}e.asArray=z;function H(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=H;function M(_,Y){for(const G of _){const ne=Y(G);if(ne!==void 0)return ne}}e.mapFind=M;function j(_,Y,G){const ne=x(_,Y),ee=_.length,X=G.length;_.length=ee+X;for(let B=ee-1;B>=ne;B--)_[B+X]=_[B];for(let B=0;B<X;B++)_[B+ne]=G[B]}e.insertInto=j;function q(_,Y,G,ne){const ee=x(_,Y),X=_.splice(ee,G);return j(_,ee,ne),X}e.splice=q;function x(_,Y){return Y<0?Math.max(Y+_.length,0):Math.min(Y,_.length)}function $(_,Y){let G=Number.MAX_SAFE_INTEGER,ne=0;return _.forEach((ee,X)=>{const B=Y(ee);B<G&&(G=B,ne=X)}),ne}e.minIndex=$;function N(_,Y){let G=Number.MIN_SAFE_INTEGER,ne=0;return _.forEach((ee,X)=>{const B=Y(ee);B>G&&(G=B,ne=X)}),ne}e.maxIndex=N;class W{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let G=this.firstIdx;for(;G<this.items.length&&Y(this.items[G]);)G++;const ne=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,ne}takeFromEndWhile(Y){let G=this.lastIdx;for(;G>=0&&Y(this.items[G]);)G--;const ne=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,ne}}e.ArrayQueue=W}),define(Z[65],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(T){const R=this;let L=!1,k;return function(){return L||(L=!0,k=T.apply(R,arguments)),k}}e.once=D}),define(Z[55],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=R;const L=Object.freeze([]);function k(){return L}T.empty=k;function*P(a){yield a}T.single=P;function m(a){return a||L}T.from=m;function I(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=I;function i(a){return a[Symbol.iterator]().next().value}T.first=i;function C(a,t){for(const r of a)if(t(r))return!0;return!1}T.some=C;function f(a,t){for(const r of a)if(t(r))return r}T.find=f;function*E(a,t){for(const r of a)t(r)&&(yield r)}T.filter=E;function*u(a,t){let r=0;for(const n of a)yield t(n,r++)}T.map=u;function*S(...a){for(const t of a)for(const r of t)yield r}T.concat=S;function*g(a){for(const t of a)for(const r of t)yield r}T.concatNested=g;function b(a,t,r){let n=r;for(const s of a)n=t(n,s);return n}T.reduce=b;function*y(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}T.slice=y;function w(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const n=a[Symbol.iterator]();for(let s=0;s<t;s++){const c=n.next();if(c.done)return[r,T.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return n}}]}T.consume=w;function o(a,t,r=(n,s)=>n===s){const n=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const c=n.next(),l=s.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!r(c.value,l.value))return!1}}T.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(Z[34],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let n=0,s=t.length,c="",l=0,h=16,d=0;function p(H){let M=0,j=0;for(;M<H;){const q=t.charCodeAt(n);if(q>=48&&q<=57)j=j*16+q-48;else if(q>=65&&q<=70)j=j*16+q-65+10;else if(q>=97&&q<=102)j=j*16+q-97+10;else break;n++,M++}return M<H&&(j=-1),j}function A(H){n=H,c="",l=0,h=16,d=0}function O(){const H=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&I(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&I(t.charCodeAt(n)))for(n++;n<t.length&&I(t.charCodeAt(n));)n++;else return d=3,t.substring(H,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&I(t.charCodeAt(n))){for(n++;n<t.length&&I(t.charCodeAt(n));)n++;M=n}else d=3;return t.substring(H,M)}function v(){let H="",M=n;for(;;){if(n>=s){H+=t.substring(M,n),d=2;break}const j=t.charCodeAt(n);if(j===34){H+=t.substring(M,n),n++;break}if(j===92){if(H+=t.substring(M,n),n++,n>=s){d=2;break}switch(t.charCodeAt(n++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const x=p(4);x>=0?H+=String.fromCharCode(x):d=4;break;default:d=5}M=n;continue}if(j>=0&&j<=31)if(m(j)){H+=t.substring(M,n),d=2;break}else d=6;n++}return H}function U(){if(c="",d=0,l=n,n>=s)return l=s,h=17;let H=t.charCodeAt(n);if(P(H)){do n++,c+=String.fromCharCode(H),H=t.charCodeAt(n);while(P(H));return h=15}if(m(H))return n++,c+=String.fromCharCode(H),H===13&&t.charCodeAt(n)===10&&(n++,c+=`
`),h=14;switch(H){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,c=v(),h=10;case 47:const M=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!m(t.charCodeAt(n));)n++;return c=t.substring(M,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const j=s-1;let q=!1;for(;n<j;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,d=1),c=t.substring(M,n),h=13}return c+=String.fromCharCode(H),n++,h=16;case 45:if(c+=String.fromCharCode(H),n++,n===s||!I(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),h=11;default:for(;n<s&&F(H);)n++,H=t.charCodeAt(n);if(l!==n){switch(c=t.substring(l,n),c){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return c+=String.fromCharCode(H),n++,h=16}}function F(H){if(P(H)||m(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=U();while(H>=12&&H<=15);return H}return{setPosition:A,getPosition:()=>n,scan:r?z:U,getToken:()=>h,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,r){const n=[],s=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function d(p,A,O,v){l.value=p,l.offset=A,l.length=O,l.type=v,l.colonOffset=void 0,c=l}try{w(t,{onObjectBegin:(p,A)=>{if(r<=p)throw s;c=void 0,h=r>p,n.push("")},onObjectProperty:(p,A,O)=>{if(r<A||(d(p,A,O,"property"),n[n.length-1]=p,r<=A+O))throw s},onObjectEnd:(p,A)=>{if(r<=p)throw s;c=void 0,n.pop()},onArrayBegin:(p,A)=>{if(r<=p)throw s;c=void 0,n.push(0)},onArrayEnd:(p,A)=>{if(r<=p)throw s;c=void 0,n.pop()},onLiteralValue:(p,A,O)=>{if(r<A||(d(p,A,O,a(p)),r<=A+O))throw s},onSeparator:(p,A,O)=>{if(r<=A)throw s;if(p===":"&&c&&c.type==="property")c.colonOffset=A,h=!1,c=void 0;else if(p===","){const v=n[n.length-1];typeof v=="number"?n[n.length-1]=v+1:(h=!0,n[n.length-1]=""),c=void 0}}})}catch(p){if(p!==s)throw p}return{path:n,previousNode:c,isAtPropertyKey:h,matches:p=>{let A=0;for(let O=0;A<p.length&&O<n.length;O++)if(p[A]===n[O]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}e.getLocation=C;function f(t,r=[],n=L.DEFAULT){let s=null,c=[];const l=[];function h(p){Array.isArray(c)?c.push(p):s!==null&&(c[s]=p)}return w(t,{onObjectBegin:()=>{const p={};h(p),l.push(c),c=p,s=null},onObjectProperty:p=>{s=p},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const p=[];h(p),l.push(c),c=p,s=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:h,onError:(p,A,O)=>{r.push({error:p,offset:A,length:O})}},n),c[0]}e.parse=f;function E(t,r=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(p){s.type==="property"&&(s.length=p-s.offset,s=s.parent)}function l(p){return s.children.push(p),p}w(t,{onObjectBegin:p=>{s=l({type:"object",offset:p,length:-1,parent:s,children:[]})},onObjectProperty:(p,A,O)=>{s=l({type:"property",offset:A,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:p,offset:A,length:O,parent:s})},onObjectEnd:(p,A)=>{s.length=p+A-s.offset,s=s.parent,c(p+A)},onArrayBegin:(p,A)=>{s=l({type:"array",offset:p,length:-1,parent:s,children:[]})},onArrayEnd:(p,A)=>{s.length=p+A-s.offset,s=s.parent,c(p+A)},onLiteralValue:(p,A,O)=>{l({type:a(p),offset:A,length:O,parent:s,value:p}),c(A+O)},onSeparator:(p,A,O)=>{s.type==="property"&&(p===":"?s.colonOffset=A:p===","&&c(A))},onError:(p,A,O)=>{r.push({error:p,offset:A,length:O})}},n);const d=s.children[0];return d&&delete d.parent,d}e.parseTree=E;function u(t,r){if(!t)return;let n=t;for(let s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===s){n=l.children[1],c=!0;break}if(!c)return}else{const c=s;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}e.findNodeAtLocation=u;function S(t){if(!t.parent||!t.parent.children)return[];const r=S(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=S;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const r=Object.create(null);for(let n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=g(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function b(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=b;function y(t,r,n=!1){if(b(t,r,n)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=r;c++){const l=y(s[c],r,n);if(l)return l}return t}}e.findNodeAtOffset=y;function w(t,r,n=L.DEFAULT){const s=k(t,!1);function c(G){return G?()=>G(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(G){return G?ne=>G(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const h=c(r.onObjectBegin),d=l(r.onObjectProperty),p=c(r.onObjectEnd),A=c(r.onArrayBegin),O=c(r.onArrayEnd),v=l(r.onLiteralValue),U=l(r.onSeparator),F=c(r.onComment),z=l(r.onError),H=n&&n.disallowComments,M=n&&n.allowTrailingComma;function j(){for(;;){const G=s.scan();switch(s.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:H||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(G){case 12:case 13:H?q(10):F();break;case 16:q(1);break;case 15:case 14:break;default:return G}}}function q(G,ne=[],ee=[]){if(z(G),ne.length+ee.length>0){let X=s.getToken();for(;X!==17;){if(ne.indexOf(X)!==-1){j();break}else if(ee.indexOf(X)!==-1)break;X=j()}}}function x(G){const ne=s.getTokenValue();return G?v(ne):d(ne),j(),!0}function $(){switch(s.getToken()){case 11:let G=0;try{G=JSON.parse(s.getTokenValue()),typeof G!="number"&&(q(2),G=0)}catch(ne){q(2)}v(G);break;case 7:v(null);break;case 8:v(!0);break;case 9:v(!1);break;default:return!1}return j(),!0}function N(){return s.getToken()!==10?(q(3,[],[2,5]),!1):(x(!1),s.getToken()===6?(U(":"),j(),Y()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){h(),j();let G=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(G||q(4,[],[]),U(","),j(),s.getToken()===2&&M)break}else G&&q(6,[],[]);N()||q(4,[],[2,5]),G=!0}return p(),s.getToken()!==2?q(7,[2],[]):j(),!0}function _(){A(),j();let G=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(G||q(4,[],[]),U(","),j(),s.getToken()===4&&M)break}else G&&q(6,[],[]);Y()||q(4,[],[4,5]),G=!0}return O(),s.getToken()!==4?q(8,[4],[]):j(),!0}function Y(){switch(s.getToken()){case 3:return _();case 1:return W();case 10:return x(!0);default:return $()}}return j(),s.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):Y()?(s.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=w;function o(t,r){let n=k(t),s=[],c,l=0,h;do switch(h=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:l!==h&&s.push(t.substring(l,h)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),l=n.getPosition();break}while(c!==17);return s.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[48],te([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(m,I,i){let C,f,E,u,S;if(I){for(u=I.offset,S=u+I.length,E=u;E>0&&!P(m,E-1);)E--;let l=S;for(;l<m.length&&!P(m,l);)l++;f=m.substring(E,l),C=L(f,i)}else f=m,C=0,E=0,u=0,S=m.length;const g=k(i,m);let b=!1,y=0,w;i.insertSpaces?w=R(" ",i.tabSize||4):w="	";const o=(0,D.createScanner)(f,!1);let a=!1;function t(){return g+R(w,C+y)}function r(){let l=o.scan();for(b=!1;l===15||l===14;)b=b||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function s(l,h,d){!a&&h<S&&d>u&&m.substring(h,d)!==l&&n.push({offset:h,length:d-h,content:l})}let c=r();if(c!==17){const l=o.getTokenOffset()+E,h=R(w,C);s(h,E,l)}for(;c!==17;){let l=o.getTokenOffset()+o.getTokenLength()+E,h=r(),d="";for(;!b&&(h===12||h===13);){const A=o.getTokenOffset()+E;s(" ",l,A),l=o.getTokenOffset()+o.getTokenLength()+E,d=h===12?t():"",h=r()}if(h===2)c!==1&&(y--,d=t());else if(h===4)c!==3&&(y--,d=t());else{switch(c){case 3:case 1:y++,d=t();break;case 5:case 12:d=t();break;case 13:b?d=t():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}b&&(h===12||h===13)&&(d=t())}const p=o.getTokenOffset()+E;s(d,l,p),c=h}return n}e.format=T;function R(m,I){let i="";for(let C=0;C<I;C++)i+=m;return i}function L(m,I){let i=0,C=0;const f=I.tabSize||4;for(;i<m.length;){const E=m.charAt(i);if(E===" ")C++;else if(E==="	")C+=f;else break;i++}return Math.floor(C/f)}function k(m,I){for(let i=0;i<I.length;i++){const C=I.charAt(i);if(C==="\r")return i+1<I.length&&I.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function P(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=P}),define(Z[45],te([0,1,34,48]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(I,i,C){return L(I,i,void 0,C)}e.removeProperty=R;function L(I,i,C,f,E){const u=i.slice(),S=[],g=(0,D.parseTree)(I,S);let b,y;for(;u.length>0&&(y=u.pop(),b=(0,D.findNodeAtLocation)(g,u),b===void 0&&C!==void 0);)typeof y=="string"?C={[y]:C}:C=[C];if(b)if(b.type==="object"&&typeof y=="string"&&Array.isArray(b.children)){const w=(0,D.findNodeAtLocation)(b,[y]);if(w!==void 0)if(C===void 0){if(!w.parent)throw new Error("Malformed AST");const o=b.children.indexOf(w.parent);let a,t=w.parent.offset+w.parent.length;if(o>0){const r=b.children[o-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return k(I,{offset:a,length:t-a,content:""},f)}else return k(I,{offset:w.offset,length:w.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const o=`${JSON.stringify(y)}: ${JSON.stringify(C)}`,a=E?E(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else b.children.length===0?t={offset:b.offset+1,length:0,content:o}:t={offset:b.offset+1,length:0,content:o+","};return k(I,t,f)}}else if(b.type==="array"&&typeof y=="number"&&Array.isArray(b.children))if(C!==void 0){const w=`${JSON.stringify(C)}`;let o;if(b.children.length===0||y===0)o={offset:b.offset+1,length:0,content:b.children.length===0?w:w+","};else{const a=y===-1||y>b.children.length?b.children.length:y,t=b.children[a-1];o={offset:t.offset+t.length,length:0,content:","+w}}return k(I,o,f)}else{const w=y,o=b.children[w];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===w){const t=b.children[w-1],r=t.offset+t.length,n=b.offset+b.length;a={offset:r,length:n-2-r,content:""}}else a={offset:o.offset,length:b.children[w+1].offset-o.offset,content:""};return k(I,a,f)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${b.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return k(I,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(C)},f)}}e.setProperty=L;function k(I,i,C){let f=P(I,i),E=i.offset,u=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;E>0&&!(0,T.isEOL)(f,E-1);)E--;for(;u<f.length&&!(0,T.isEOL)(f,u);)u++}const S=(0,T.format)(f,{offset:E,length:u-E},C);for(let b=S.length-1;b>=0;b--){const y=S[b];f=P(f,y),E=Math.min(E,y.offset),u=Math.max(u,y.offset+y.length),u+=y.content.length-y.length}const g=I.length-(f.length-u)-E;return[{offset:E,length:g,content:f.substring(E,u)}]}e.withFormatting=k;function P(I,i){return I.substring(0,i.offset)+i.content+I.substring(i.offset+i.length)}e.applyEdit=P;function m(I,i){let C=i.slice(0).sort((E,u)=>{const S=E.offset-u.offset;return S===0?E.length-u.length:S}),f=I.length;for(let E=C.length-1;E>=0;E--){let u=C[E];if(u.offset+u.length<=f)I=P(I,u);else throw new Error("Overlapping edit");f=u.offset}return I}e.applyEdits=m}),define(Z[2],te([0,1,65,55]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function k(n){L=n}if(e.setDisposableTracker=k,R){const n="__is_disposable_tracked__";k(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==y.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==y.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function P(n){return L?.trackDisposable(n),n}function m(n){L?.markAsDisposed(n)}function I(n,s){L?.setParent(n,s)}function i(n,s){if(!!L)for(const c of n)L.setParent(c,s)}function C(n){return L?.markAsSingleton(n),n}e.markAsSingleton=C;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function E(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=E;function u(n){if(T.Iterable.is(n)){let s=[];for(const c of n)if(c)try{c.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=u;function S(...n){const s=g(()=>u(n));return i(n,s),s}e.combinedDisposable=S;function g(n){const s=P({dispose:(0,D.once)(()=>{m(s),n()})});return s}e.toDisposable=g;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return I(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new b,P(this),I(this._store,this)}dispose(){m(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&I(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&I(s,null),s}}e.MutableDisposable=w;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(s,...c){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,l));const{object:h}=l,d=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:h,dispose:d}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...c){const l=this.referenceCollection.acquire(s,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[92],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class T{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const k=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,k){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(k){const I=this._last;this._last=P,P.prev=I,I.next=P}else{const I=this._first;this._first=P,P.next=I,I.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const k=L.prev;k.next=L.next,L.next.prev=k}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=T}),function(){function K(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function k(m){L.push(m,Date.now())}function P(){const m=[];for(let I=0;I<L.length;I+=2)m.push({name:L[I],startTime:L[I+1]});return m}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))L.push({name:k.name,startTime:Math.round(R+k.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),define(Z[4],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let T=!1,R=!1,L=!1,k=!1,P=!1,m=!1,I=!1,i,C=D,f,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const S=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=S&&u?.sandboxed,typeof navigator=="object"&&!S)E=navigator.userAgent,T=E.indexOf("Windows")>=0,R=E.indexOf("Macintosh")>=0,I=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=E.indexOf("Linux")>=0,m=!0,i=navigator.language,C=i;else if(typeof u=="object"){T=u.platform==="win32",R=u.platform==="darwin",L=u.platform==="linux",k=L&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,i=D,C=D;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const s=JSON.parse(n),c=s.availableLanguages["*"];i=s.locale,C=c||D,f=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var g;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let y=0;R?y=1:T?y=3:L&&(y=2),e.isWindows=T,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=k,e.isNative=P,e.isWeb=m,e.isIOS=I,e.platform=y,e.userAgent=E,e.language=C;var w;(function(n){function s(){return e.language}n.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function l(){return e.language==="en"}n.isDefault=l})(w=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let d=0,p=c.length;d<p;d++){const A=c[d];if(A.id===h.data.vscodeSetImmediateId){c.splice(d,1),A.callback();return}}});let l=0;return h=>{const d=++l;c.push({id:d,callback:h}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const s=Promise.resolve();return c=>s.then(c)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:T?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(Z[31],te([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;T={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(L){return(0,D.setImmediate)(L)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:T={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick,e.arch=T.arch}),define(Z[8],te([0,1,31]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,R=97,L=90,k=122,P=46,m=47,I=92,i=58,C=63;class f extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const n=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${n} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function E(w,o){if(typeof w!="string")throw new f(o,"string",w)}function u(w){return w===m||w===I}function S(w){return w===m}function g(w){return w>=T&&w<=L||w>=R&&w<=k}function b(w,o,a,t){let r="",n=0,s=-1,c=0,l=0;for(let h=0;h<=w.length;++h){if(h<w.length)l=w.charCodeAt(h);else{if(t(l))break;l=m}if(t(l)){if(!(s===h-1||c===1))if(c===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const d=r.lastIndexOf(a);d===-1?(r="",n=0):(r=r.slice(0,d),n=r.length-1-r.lastIndexOf(a)),s=h,c=0;continue}else if(r.length!==0){r="",n=0,s=h,c=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",n=2)}else r.length>0?r+=`${a}${w.slice(s+1,h)}`:r=w.slice(s+1,h),n=h-s-1;s=h,c=0}else l===P&&c!==-1?++c:c=-1}return r}function y(w,o){if(o===null||typeof o!="object")throw new f("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${w}${t}`:t}e.win32={resolve(...w){let o="",a="",t=!1;for(let r=w.length-1;r>=-1;r--){let n;if(r>=0){if(n=w[r],E(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===I)&&(n=`${o}\\`));const s=n.length;let c=0,l="",h=!1;const d=n.charCodeAt(0);if(s===1)u(d)&&(c=1,h=!0);else if(u(d))if(h=!0,u(n.charCodeAt(1))){let p=2,A=p;for(;p<s&&!u(n.charCodeAt(p));)p++;if(p<s&&p!==A){const O=n.slice(A,p);for(A=p;p<s&&u(n.charCodeAt(p));)p++;if(p<s&&p!==A){for(A=p;p<s&&!u(n.charCodeAt(p));)p++;(p===s||p!==A)&&(l=`\\\\${O}\\${n.slice(A,p)}`,c=p)}}}else c=1;else g(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),c=2,s>2&&u(n.charCodeAt(2))&&(h=!0,c=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(c)}\\${a}`,t=h,h&&o.length>0)break}return a=b(a,!t,"\\",u),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(w){E(w,"path");const o=w.length;if(o===0)return".";let a=0,t,r=!1;const n=w.charCodeAt(0);if(o===1)return S(n)?"\\":w;if(u(n))if(r=!0,u(w.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(w.charCodeAt(c));)c++;if(c<o&&c!==l){const h=w.slice(l,c);for(l=c;c<o&&u(w.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(w.charCodeAt(c));)c++;if(c===o)return`\\\\${h}\\${w.slice(l)}\\`;c!==l&&(t=`\\\\${h}\\${w.slice(l,c)}`,a=c)}}}else a=1;else g(n)&&w.charCodeAt(1)===i&&(t=w.slice(0,2),a=2,o>2&&u(w.charCodeAt(2))&&(r=!0,a=3));let s=a<o?b(w.slice(a),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(w.charCodeAt(o-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(w){E(w,"path");const o=w.length;if(o===0)return!1;const a=w.charCodeAt(0);return u(a)||o>2&&g(a)&&w.charCodeAt(1)===i&&u(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let o,a;for(let n=0;n<w.length;++n){const s=w[n];E(s,"path"),s.length>0&&(o===void 0?o=a=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++r;const n=a.length;n>1&&u(a.charCodeAt(1))&&(++r,n>2&&(u(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&u(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(w,o){if(E(w,"from"),E(o,"to"),w===o)return"";const a=e.win32.resolve(w),t=e.win32.resolve(o);if(a===t||(w=a.toLowerCase(),o=t.toLowerCase(),w===o))return"";let r=0;for(;r<w.length&&w.charCodeAt(r)===I;)r++;let n=w.length;for(;n-1>r&&w.charCodeAt(n-1)===I;)n--;const s=n-r;let c=0;for(;c<o.length&&o.charCodeAt(c)===I;)c++;let l=o.length;for(;l-1>c&&o.charCodeAt(l-1)===I;)l--;const h=l-c,d=s<h?s:h;let p=-1,A=0;for(;A<d;A++){const v=w.charCodeAt(r+A);if(v!==o.charCodeAt(c+A))break;v===I&&(p=A)}if(A!==d){if(p===-1)return t}else{if(h>d){if(o.charCodeAt(c+A)===I)return t.slice(c+A+1);if(A===2)return t.slice(c+A)}s>d&&(w.charCodeAt(r+A)===I?p=A:A===2&&(p=3)),p===-1&&(p=0)}let O="";for(A=r+p+1;A<=n;++A)(A===n||w.charCodeAt(A)===I)&&(O+=O.length===0?"..":"\\..");return c+=p,O.length>0?`${O}${t.slice(c,l)}`:(t.charCodeAt(c)===I&&++c,t.slice(c,l))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const o=e.win32.resolve(w);if(o.length<=2)return w;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const a=o.charCodeAt(2);if(a!==C&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return w},dirname(w){E(w,"path");const o=w.length;if(o===0)return".";let a=-1,t=0;const r=w.charCodeAt(0);if(o===1)return u(r)?w:".";if(u(r)){if(a=t=1,u(w.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(w.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&u(w.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(w.charCodeAt(c));)c++;if(c===o)return w;c!==l&&(a=t=c+1)}}}}else g(r)&&w.charCodeAt(1)===i&&(a=o>2&&u(w.charCodeAt(2))?3:2,t=a);let n=-1,s=!0;for(let c=o-1;c>=t;--c)if(u(w.charCodeAt(c))){if(!s){n=c;break}}else s=!1;if(n===-1){if(a===-1)return".";n=a}return w.slice(0,n)},basename(w,o){o!==void 0&&E(o,"ext"),E(w,"path");let a=0,t=-1,r=!0,n;if(w.length>=2&&g(w.charCodeAt(0))&&w.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=w.length){if(o===w)return"";let s=o.length-1,c=-1;for(n=w.length-1;n>=a;--n){const l=w.charCodeAt(n);if(u(l)){if(!r){a=n+1;break}}else c===-1&&(r=!1,c=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=c))}return a===t?t=c:t===-1&&(t=w.length),w.slice(a,t)}for(n=w.length-1;n>=a;--n)if(u(w.charCodeAt(n))){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":w.slice(a,t)},extname(w){E(w,"path");let o=0,a=-1,t=0,r=-1,n=!0,s=0;w.length>=2&&w.charCodeAt(1)===i&&g(w.charCodeAt(0))&&(o=t=2);for(let c=w.length-1;c>=o;--c){const l=w.charCodeAt(c);if(u(l)){if(!n){t=c+1;break}continue}r===-1&&(n=!1,r=c+1),l===P?a===-1?a=c:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":w.slice(a,r)},format:y.bind(null,"\\"),parse(w){E(w,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return o;const a=w.length;let t=0,r=w.charCodeAt(0);if(a===1)return u(r)?(o.root=o.dir=w,o):(o.base=o.name=w,o);if(u(r)){if(t=1,u(w.charCodeAt(1))){let p=2,A=p;for(;p<a&&!u(w.charCodeAt(p));)p++;if(p<a&&p!==A){for(A=p;p<a&&u(w.charCodeAt(p));)p++;if(p<a&&p!==A){for(A=p;p<a&&!u(w.charCodeAt(p));)p++;p===a?t=p:p!==A&&(t=p+1)}}}}else if(g(r)&&w.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=w,o;if(t=2,u(w.charCodeAt(2))){if(a===3)return o.root=o.dir=w,o;t=3}}t>0&&(o.root=w.slice(0,t));let n=-1,s=t,c=-1,l=!0,h=w.length-1,d=0;for(;h>=t;--h){if(r=w.charCodeAt(h),u(r)){if(!l){s=h+1;break}continue}c===-1&&(l=!1,c=h+1),r===P?n===-1?n=h:d!==1&&(d=1):n!==-1&&(d=-1)}return c!==-1&&(n===-1||d===0||d===1&&n===c-1&&n===s+1?o.base=o.name=w.slice(s,c):(o.name=w.slice(s,n),o.base=w.slice(s,c),o.ext=w.slice(n,c))),s>0&&s!==t?o.dir=w.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let o="",a=!1;for(let t=w.length-1;t>=-1&&!a;t--){const r=t>=0?w[t]:D.cwd();E(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===m)}return o=b(o,!a,"/",S),a?`/${o}`:o.length>0?o:"."},normalize(w){if(E(w,"path"),w.length===0)return".";const o=w.charCodeAt(0)===m,a=w.charCodeAt(w.length-1)===m;return w=b(w,!o,"/",S),w.length===0?o?"/":a?"./":".":(a&&(w+="/"),o?`/${w}`:w)},isAbsolute(w){return E(w,"path"),w.length>0&&w.charCodeAt(0)===m},join(...w){if(w.length===0)return".";let o;for(let a=0;a<w.length;++a){const t=w[a];E(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(w,o){if(E(w,"from"),E(o,"to"),w===o||(w=e.posix.resolve(w),o=e.posix.resolve(o),w===o))return"";const a=1,t=w.length,r=t-a,n=1,s=o.length-n,c=r<s?r:s;let l=-1,h=0;for(;h<c;h++){const p=w.charCodeAt(a+h);if(p!==o.charCodeAt(n+h))break;p===m&&(l=h)}if(h===c)if(s>c){if(o.charCodeAt(n+h)===m)return o.slice(n+h+1);if(h===0)return o.slice(n+h)}else r>c&&(w.charCodeAt(a+h)===m?l=h:h===0&&(l=0));let d="";for(h=a+l+1;h<=t;++h)(h===t||w.charCodeAt(h)===m)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(n+l)}`},toNamespacedPath(w){return w},dirname(w){if(E(w,"path"),w.length===0)return".";const o=w.charCodeAt(0)===m;let a=-1,t=!0;for(let r=w.length-1;r>=1;--r)if(w.charCodeAt(r)===m){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":w.slice(0,a)},basename(w,o){o!==void 0&&E(o,"ext"),E(w,"path");let a=0,t=-1,r=!0,n;if(o!==void 0&&o.length>0&&o.length<=w.length){if(o===w)return"";let s=o.length-1,c=-1;for(n=w.length-1;n>=0;--n){const l=w.charCodeAt(n);if(l===m){if(!r){a=n+1;break}}else c===-1&&(r=!1,c=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=c))}return a===t?t=c:t===-1&&(t=w.length),w.slice(a,t)}for(n=w.length-1;n>=0;--n)if(w.charCodeAt(n)===m){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":w.slice(a,t)},extname(w){E(w,"path");let o=-1,a=0,t=-1,r=!0,n=0;for(let s=w.length-1;s>=0;--s){const c=w.charCodeAt(s);if(c===m){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),c===P?o===-1?o=s:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":w.slice(o,t)},format:y.bind(null,"/"),parse(w){E(w,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return o;const a=w.charCodeAt(0)===m;let t;a?(o.root="/",t=1):t=0;let r=-1,n=0,s=-1,c=!0,l=w.length-1,h=0;for(;l>=t;--l){const d=w.charCodeAt(l);if(d===m){if(!c){n=l+1;break}continue}s===-1&&(c=!1,s=l+1),d===P?r===-1?r=l:h!==1&&(h=1):r!==-1&&(h=-1)}if(s!==-1){const d=n===0&&a?1:n;r===-1||h===0||h===1&&r===s-1&&r===n+1?o.base=o.name=w.slice(d,s):(o.name=w.slice(d,r),o.base=w.slice(d,s),o.ext=w.slice(r,s))}return n>0?o.dir=w.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:K)[T]=D[T]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(T){if(e[T])return e[T].exports;var R=e[T]={i:T,l:!1,exports:{}};return K[T].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(T,R,L){D.o(T,R)||Object.defineProperty(T,R,{enumerable:!0,get:L})},D.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,R){if(1&R&&(T=D(T)),8&R||4&R&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&R&&typeof T!="string")for(var k in T)D.d(L,k,function(P){return T[P]}.bind(null,k));return L},D.n=function(T){var R=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(R,"a",R),R},D.o=function(T,R){return Object.prototype.hasOwnProperty.call(T,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(T){var R;e=K.exports=ee,R=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],I=0,i=I++;m[i]="0|[1-9]\\d*";var C=I++;m[C]="[0-9]+";var f=I++;m[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=I++;m[E]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var u=I++;m[u]="("+m[C]+")\\.("+m[C]+")\\.("+m[C]+")";var S=I++;m[S]="(?:"+m[i]+"|"+m[f]+")";var g=I++;m[g]="(?:"+m[C]+"|"+m[f]+")";var b=I++;m[b]="(?:-("+m[S]+"(?:\\."+m[S]+")*))";var y=I++;m[y]="(?:-?("+m[g]+"(?:\\."+m[g]+")*))";var w=I++;m[w]="[0-9A-Za-z-]+";var o=I++;m[o]="(?:\\+("+m[w]+"(?:\\."+m[w]+")*))";var a=I++,t="v?"+m[E]+m[b]+"?"+m[o]+"?";m[a]="^"+t+"$";var r="[v=\\s]*"+m[u]+m[y]+"?"+m[o]+"?",n=I++;m[n]="^"+r+"$";var s=I++;m[s]="((?:<|>)?=?)";var c=I++;m[c]=m[C]+"|x|X|\\*";var l=I++;m[l]=m[i]+"|x|X|\\*";var h=I++;m[h]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[b]+")?"+m[o]+"?)?)?";var d=I++;m[d]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[y]+")?"+m[o]+"?)?)?";var p=I++;m[p]="^"+m[s]+"\\s*"+m[h]+"$";var A=I++;m[A]="^"+m[s]+"\\s*"+m[d]+"$";var O=I++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=I++;m[v]="(?:~>?)";var U=I++;m[U]="(\\s*)"+m[v]+"\\s+",P[U]=new RegExp(m[U],"g");var F=I++;m[F]="^"+m[v]+m[h]+"$";var z=I++;m[z]="^"+m[v]+m[d]+"$";var H=I++;m[H]="(?:\\^)";var M=I++;m[M]="(\\s*)"+m[H]+"\\s+",P[M]=new RegExp(m[M],"g");var j=I++;m[j]="^"+m[H]+m[h]+"$";var q=I++;m[q]="^"+m[H]+m[d]+"$";var x=I++;m[x]="^"+m[s]+"\\s*("+r+")$|^$";var $=I++;m[$]="^"+m[s]+"\\s*("+t+")$|^$";var N=I++;m[N]="(\\s*)"+m[s]+"\\s*("+r+"|"+m[h]+")",P[N]=new RegExp(m[N],"g");var W=I++;m[W]="^\\s*("+m[h]+")\\s+-\\s+("+m[h]+")\\s*$";var _=I++;m[_]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var Y=I++;m[Y]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)R(G,m[G]),P[G]||(P[G]=new RegExp(m[G]));function ne(Q,ae){if(Q instanceof ee)return Q;if(typeof Q!="string"||Q.length>L||!(ae?P[n]:P[a]).test(Q))return null;try{return new ee(Q,ae)}catch(oe){return null}}function ee(Q,ae){if(Q instanceof ee){if(Q.loose===ae)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ee))return new ee(Q,ae);R("SemVer",Q,ae),this.loose=ae;var oe=Q.trim().match(ae?P[n]:P[a]);if(!oe)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Se=+ve;if(Se>=0&&Se<k)return Se}return ve}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=ne,e.valid=function(Q,ae){var oe=ne(Q,ae);return oe?oe.version:null},e.clean=function(Q,ae){var oe=ne(Q.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Q){return R("SemVer.compare",this.version,this.loose,Q),Q instanceof ee||(Q=new ee(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ee.prototype.compareMain=function(Q){return Q instanceof ee||(Q=new ee(Q,this.loose)),B(this.major,Q.major)||B(this.minor,Q.minor)||B(this.patch,Q.patch)},ee.prototype.comparePre=function(Q){if(Q instanceof ee||(Q=new ee(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],ve=Q.prerelease[ae];if(R("prerelease compare",ae,oe,ve),oe===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(oe===void 0)return-1;if(oe!==ve)return B(oe,ve)}while(++ae)},ee.prototype.inc=function(Q,ae){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ae,oe,ve){typeof oe=="string"&&(ve=oe,oe=void 0);try{return new ee(Q,oe).inc(ae,ve).version}catch(Se){return null}},e.diff=function(Q,ae){if(ue(Q,ae))return null;var oe=ne(Q),ve=ne(ae);if(oe.prerelease.length||ve.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==ve[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==ve[Se])return Se},e.compareIdentifiers=B;var X=/^[0-9]+$/;function B(Q,ae){var oe=X.test(Q),ve=X.test(ae);return oe&&ve&&(Q=+Q,ae=+ae),oe&&!ve?-1:ve&&!oe?1:Q<ae?-1:Q>ae?1:0}function re(Q,ae,oe){return new ee(Q,oe).compare(new ee(ae,oe))}function ie(Q,ae,oe){return re(Q,ae,oe)>0}function ce(Q,ae,oe){return re(Q,ae,oe)<0}function ue(Q,ae,oe){return re(Q,ae,oe)===0}function ge(Q,ae,oe){return re(Q,ae,oe)!==0}function de(Q,ae,oe){return re(Q,ae,oe)>=0}function Ie(Q,ae,oe){return re(Q,ae,oe)<=0}function Pe(Q,ae,oe,ve){var Se;switch(ae){case"===":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q===oe;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q!==oe;break;case"":case"=":case"==":Se=ue(Q,oe,ve);break;case"!=":Se=ge(Q,oe,ve);break;case">":Se=ie(Q,oe,ve);break;case">=":Se=de(Q,oe,ve);break;case"<":Se=ce(Q,oe,ve);break;case"<=":Se=Ie(Q,oe,ve);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(Q,ae){if(Q instanceof Ee){if(Q.loose===ae)return Q;Q=Q.value}if(!(this instanceof Ee))return new Ee(Q,ae);R("comparator",Q,ae),this.loose=ae,this.parse(Q),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(Q,ae){return B(ae,Q)},e.major=function(Q,ae){return new ee(Q,ae).major},e.minor=function(Q,ae){return new ee(Q,ae).minor},e.patch=function(Q,ae){return new ee(Q,ae).patch},e.compare=re,e.compareLoose=function(Q,ae){return re(Q,ae,!0)},e.rcompare=function(Q,ae,oe){return re(ae,Q,oe)},e.sort=function(Q,ae){return Q.sort(function(oe,ve){return e.compare(oe,ve,ae)})},e.rsort=function(Q,ae){return Q.sort(function(oe,ve){return e.rcompare(oe,ve,ae)})},e.gt=ie,e.lt=ce,e.eq=ue,e.neq=ge,e.gte=de,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var Oe={};function Re(Q,ae){if(Q instanceof Re)return Q.loose===ae?Q:new Re(Q.raw,ae);if(Q instanceof Ee)return new Re(Q.value,ae);if(!(this instanceof Re))return new Re(Q,ae);if(this.loose=ae,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Te(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ne(Q,ae,oe,ve,Se,Fe,Le,Me,Ae,V,se,le,he){return((ae=Te(oe)?"":Te(ve)?">="+oe+".0.0":Te(Se)?">="+oe+"."+ve+".0":">="+ae)+" "+(Me=Te(Ae)?"":Te(V)?"<"+(+Ae+1)+".0.0":Te(se)?"<"+Ae+"."+(+V+1)+".0":le?"<="+Ae+"."+V+"."+se+"-"+le:"<="+Me)).trim()}function _e(Q,ae){for(var oe=0;oe<Q.length;oe++)if(!Q[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<Q.length;oe++)if(R(Q[oe].semver),Q[oe].semver!==Oe&&Q[oe].semver.prerelease.length>0){var ve=Q[oe].semver;if(ve.major===ae.major&&ve.minor===ae.minor&&ve.patch===ae.patch)return!0}return!1}return!0}function ze(Q,ae,oe){try{ae=new Re(ae,oe)}catch(ve){return!1}return ae.test(Q)}function $e(Q,ae,oe,ve){var Se,Fe,Le,Me,Ae;switch(Q=new ee(Q,ve),ae=new Re(ae,ve),oe){case">":Se=ie,Fe=Ie,Le=ce,Me=">",Ae=">=";break;case"<":Se=ce,Fe=de,Le=ie,Me="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(Q,ae,ve))return!1;for(var V=0;V<ae.set.length;++V){var se=ae.set[V],le=null,he=null;if(se.forEach(function(me){me.semver===Oe&&(me=new Ee(">=0.0.0")),le=le||me,he=he||me,Se(me.semver,le.semver,ve)?le=me:Le(me.semver,he.semver,ve)&&(he=me)}),le.operator===Me||le.operator===Ae||(!he.operator||he.operator===Me)&&Fe(Q,he.semver)||he.operator===Ae&&Le(Q,he.semver))return!1}return!0}Ee.prototype.parse=function(Q){var ae=this.loose?P[x]:P[$],oe=Q.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+Q);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new ee(oe[2],this.loose):this.semver=Oe},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(Q){return R("Comparator.test",Q,this.loose),this.semver===Oe||(typeof Q=="string"&&(Q=new ee(Q,this.loose)),Pe(Q,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(Q,ae){if(!(Q instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Re(Q.value,ae),ze(this.value,oe,ae);if(Q.operator==="")return oe=new Re(this.value,ae),ze(Q.semver,oe,ae);var ve=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Fe=this.semver.version===Q.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Me=Pe(this.semver,"<",Q.semver,ae)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Ae=Pe(this.semver,">",Q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return ve||Se||Fe&&Le||Me||Ae},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(Q){var ae=this.loose;Q=Q.trim(),R("range",Q,ae);var oe=ae?P[_]:P[W];Q=Q.replace(oe,Ne),R("hyphen replace",Q),Q=Q.replace(P[N],"$1$2$3"),R("comparator trim",Q,P[N]),Q=(Q=(Q=Q.replace(P[U],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var ve=ae?P[x]:P[$],Se=Q.split(" ").map(function(Fe){return function(Le,Me){return R("comp",Le),Le=function(Ae,V){return Ae.trim().split(/\s+/).map(function(se){return function(le,he){R("caret",le,he);var me=he?P[q]:P[j];return le.replace(me,function(be,pe,we,Ce,De){var ke;return R("caret",le,be,pe,we,Ce,De),Te(pe)?ke="":Te(we)?ke=">="+pe+".0.0 <"+(+pe+1)+".0.0":Te(Ce)?ke=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":De?(R("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),ke=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+De+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+De+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+De+" <"+(+pe+1)+".0.0"):(R("no pr"),ke=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+" <"+(+pe+1)+".0.0"),R("caret return",ke),ke})}(se,V)}).join(" ")}(Le,Me),R("caret",Le),Le=function(Ae,V){return Ae.trim().split(/\s+/).map(function(se){return function(le,he){var me=he?P[z]:P[F];return le.replace(me,function(be,pe,we,Ce,De){var ke;return R("tilde",le,be,pe,we,Ce,De),Te(pe)?ke="":Te(we)?ke=">="+pe+".0.0 <"+(+pe+1)+".0.0":Te(Ce)?ke=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":De?(R("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),ke=">="+pe+"."+we+"."+Ce+De+" <"+pe+"."+(+we+1)+".0"):ke=">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0",R("tilde return",ke),ke})}(se,V)}).join(" ")}(Le,Me),R("tildes",Le),Le=function(Ae,V){return R("replaceXRanges",Ae,V),Ae.split(/\s+/).map(function(se){return function(le,he){le=le.trim();var me=he?P[A]:P[p];return le.replace(me,function(be,pe,we,Ce,De,ke){R("xRange",le,be,pe,we,Ce,De,ke);var Qe=Te(we),ye=Qe||Te(Ce),Ue=ye||Te(De);return pe==="="&&Ue&&(pe=""),Qe?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Ue?(ye&&(Ce=0),Ue&&(De=0),pe===">"?(pe=">=",ye?(we=+we+1,Ce=0,De=0):Ue&&(Ce=+Ce+1,De=0)):pe==="<="&&(pe="<",ye?we=+we+1:Ce=+Ce+1),be=pe+we+"."+Ce+"."+De):ye?be=">="+we+".0.0 <"+(+we+1)+".0.0":Ue&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),R("xRange return",be),be})}(se,V)}).join(" ")}(Le,Me),R("xrange",Le),Le=function(Ae,V){return R("replaceStars",Ae,V),Ae.trim().replace(P[Y],"")}(Le,Me),R("stars",Le),Le}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Fe){return!!Fe.match(ve)})),Se=Se.map(function(Fe){return new Ee(Fe,ae)})},Re.prototype.intersects=function(Q,ae){if(!(Q instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(ve){return Q.set.some(function(Se){return Se.every(function(Fe){return ve.intersects(Fe,ae)})})})})},e.toComparators=function(Q,ae){return new Re(Q,ae).set.map(function(oe){return oe.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ee(Q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(_e(this.set[ae],Q))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(Q,ae,oe){var ve=null,Se=null;try{var Fe=new Re(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Fe.test(Le)&&(ve&&Se.compare(Le)!==-1||(Se=new ee(ve=Le,oe)))}),ve},e.minSatisfying=function(Q,ae,oe){var ve=null,Se=null;try{var Fe=new Re(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Fe.test(Le)&&(ve&&Se.compare(Le)!==1||(Se=new ee(ve=Le,oe)))}),ve},e.validRange=function(Q,ae){try{return new Re(Q,ae).range||"*"}catch(oe){return null}},e.ltr=function(Q,ae,oe){return $e(Q,ae,"<",oe)},e.gtr=function(Q,ae,oe){return $e(Q,ae,">",oe)},e.outside=$e,e.prerelease=function(Q,ae){var oe=ne(Q,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(Q,ae,oe){return Q=new Re(Q,oe),ae=new Re(ae,oe),Q.intersects(ae)},e.coerce=function(Q){if(Q instanceof ee)return Q;if(typeof Q!="string")return null;var ae=Q.match(P[O]);return ae==null?null:ne((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(K,e){var D,T,R=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(g){if(D===setTimeout)return setTimeout(g,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch(b){try{return D.call(null,g,0)}catch(y){return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch(g){D=L}try{T=typeof clearTimeout=="function"?clearTimeout:k}catch(g){T=k}})();var m,I=[],i=!1,C=-1;function f(){i&&m&&(i=!1,m.length?I=m.concat(I):C=-1,I.length&&E())}function E(){if(!i){var g=P(f);i=!0;for(var b=I.length;b;){for(m=I,I=[];++C<b;)m&&m[C].run();C=-1,b=I.length}m=null,i=!1,function(y){if(T===clearTimeout)return clearTimeout(y);if((T===k||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(y);try{T(y)}catch(w){try{return T.call(null,y)}catch(o){return T.call(this,y)}}}(g)}}function u(g,b){this.fun=g,this.array=b}function S(){}R.nextTick=function(g){var b=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)b[y-1]=arguments[y];I.push(new u(g,b)),I.length!==1||i||P(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(g){return[]},R.binding=function(g){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(g){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[93],te([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],te([0,1,9,65,2,92,93]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(o){o.None=()=>R.Disposable.None;function a(M){return(j,q=null,x)=>{let $=!1,N;return N=M(W=>{if(!$)return N?N.dispose():$=!0,j.call(q,W)},null,x),$&&N.dispose(),N}}o.once=a;function t(M,j){return h((q,x=null,$)=>M(N=>q.call(x,j(N)),null,$))}o.map=t;function r(M,j){return h((q,x=null,$)=>M(N=>{j(N),q.call(x,N)},null,$))}o.forEach=r;function n(M,j){return h((q,x=null,$)=>M(N=>j(N)&&q.call(x,N),null,$))}o.filter=n;function s(M){return M}o.signal=s;function c(...M){return(j,q=null,x)=>(0,R.combinedDisposable)(...M.map($=>$(N=>j.call(q,N),null,x)))}o.any=c;function l(M,j,q){let x=q;return t(M,$=>(x=j(x,$),x))}o.reduce=l;function h(M){let j;const q=new f({onFirstListenerAdd(){j=M(q.fire,q)},onLastListenerRemove(){j.dispose()}});return q.event}function d(M,j,q=100,x=!1,$){let N,W,_,Y=0;const G=new f({leakWarningThreshold:$,onFirstListenerAdd(){N=M(ne=>{Y++,W=j(W,ne),x&&!_&&(G.fire(W),W=void 0),clearTimeout(_),_=setTimeout(()=>{const ee=W;W=void 0,_=void 0,(!x||Y>1)&&G.fire(ee),Y=0},q)})},onLastListenerRemove(){N.dispose()}});return G.event}o.debounce=d;function p(M,j=(q,x)=>q===x){let q=!0,x;return n(M,$=>{const N=q||!j($,x);return q=!1,x=$,N})}o.latch=p;function A(M,j){return[o.filter(M,j),o.filter(M,q=>!j(q))]}o.split=A;function O(M,j=!1,q=[]){let x=q.slice(),$=M(_=>{x?x.push(_):W.fire(_)});const N=()=>{x&&x.forEach(_=>W.fire(_)),x=null},W=new f({onFirstListenerAdd(){$||($=M(_=>W.fire(_)))},onFirstListenerDidAdd(){x&&(j?setTimeout(N):N())},onLastListenerRemove(){$&&$.dispose(),$=null}});return W.event}o.buffer=O;class v{constructor(j){this.event=j}map(j){return new v(t(this.event,j))}forEach(j){return new v(r(this.event,j))}filter(j){return new v(n(this.event,j))}reduce(j,q){return new v(l(this.event,j,q))}latch(){return new v(p(this.event))}debounce(j,q=100,x=!1,$){return new v(d(this.event,j,q,x,$))}on(j,q,x){return this.event(j,q,x)}once(j,q,x){return a(this.event)(j,q,x)}}function U(M){return new v(M)}o.chain=U;function F(M,j,q=x=>x){const x=(..._)=>W.fire(q(..._)),$=()=>M.on(j,x),N=()=>M.removeListener(j,x),W=new f({onFirstListenerAdd:$,onLastListenerRemove:N});return W.event}o.fromNodeEventEmitter=F;function z(M,j,q=x=>x){const x=(..._)=>W.fire(q(..._)),$=()=>M.addEventListener(j,x),N=()=>M.removeEventListener(j,x),W=new f({onFirstListenerAdd:$,onLastListenerRemove:N});return W.event}o.fromDOMEventEmitter=z;function H(M){return new Promise(j=>a(M)(j))}o.toPromise=H})(P=e.Event||(e.Event={}));class m{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${m._idPool++}`}start(a){this._stopWatch=new k.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let I=-1;function i(o){const a=I;return I=o,{dispose(){I=a}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(a,t=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let t=I;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||a<t)return;this._stacks||(this._stacks=new Map);const r=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(r)||0;if(this._stacks.set(r,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let s,c=0;for(const[l,h]of this._stacks)(!s||c<h)&&(s=l,c=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${c}):`),console.warn(s)}return()=>{const s=this._stacks.get(r)||0;this._stacks.set(r,s-1)}}}class f{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=I>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(a,t,r)=>{this._listeners||(this._listeners=new L.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(t?[a,t]:a);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,t);const c=this._leakageMon?.check(this._listeners.size),l=(0,R.toDisposable)(()=>{c&&c(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return r instanceof R.DisposableStore?r.add(l):Array.isArray(r)&&r.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(n){(0,D.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class E extends f{async fireAsync(a,t,r){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,a]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[n,s]=this._asyncDeliveryQueue.shift(),c=[],l={...s,waitUntil:h=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");r&&(h=r(h,typeof n=="function"?n:n[0])),c.push(h)}};try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(h){(0,D.onUnexpectedError)(h);continue}Object.freeze(c),await Promise.allSettled(c).then(h=>{for(const d of h)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=E;class u extends f{constructor(a){super(a);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class S extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=S;class g extends f{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const t={event:a,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const r=()=>{this.hasListeners&&this.unhook(t);const n=this.events.indexOf(t);this.events.splice(n,1)};return(0,R.toDisposable)((0,T.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(t=>this.emitter.fire(t))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class y{constructor(){this.buffers=[]}wrapEvent(a){return(t,r,n)=>a(s=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>t.call(r,s)):t.call(r,s)},void 0,n)}bufferEvents(a){const t=[];this.buffers.push(t);const r=a();return this.buffers.pop(),t.forEach(n=>n()),r}}e.EventBufferer=y;class w{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(Z[27],te([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(P,m){const I=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(I)}}});var R;(function(P){function m(I){return I===P.None||I===P.Cancelled||I instanceof L?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(Z[49],te([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new T;e.iconRegistry=R;function L(i,C){return new P(i,C)}e.registerCodicon=L;function k(i){return i?i.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=k;class P{constructor(C,f,E){this.id=C,this.definition=f,this.description=E,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,C){const f=["codicon","codicon-"+i];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=m;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(S){if(S instanceof P)return["codicon","codicon-"+S.id];const g=C.exec(S.id);if(!g)return f(P.error);let[,b,y]=g;const w=["codicon","codicon-"+b];return y&&w.push("codicon-modifier-"+y.substr(1)),w}i.asClassNameArray=f;function E(S){return f(S).join(" ")}i.asClassName=E;function u(S){return"."+f(S).join(".")}i.asCSSSelector=u})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[50],te([0,1,9,2]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(w){const o=w;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function L(w){const o=w;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=L;function k(w,o){return new P(w,o)}e.newWriteableStream=k;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(w,o){const a=[];let t;for(;(t=w.read())!==null;)a.push(t);return o(a)}e.consumeReadable=m;function I(w,o,a){const t=[];let r;for(;(r=w.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const n=r;return r=void 0,n}return w.read()}}}e.peekReadable=I;function i(w,o){return new Promise((a,t)=>{const r=[];C(w,{onData:n=>{o&&r.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=i;function C(w,o){w.on("error",a=>o.onError(a)),w.on("end",()=>o.onEnd()),w.on("data",a=>o.onData(a))}e.listenStream=C;function f(w,o){return new Promise((a,t)=>{const r=new T.DisposableStore,n=[],s=h=>{if(n.push(h),n.length>o)return r.dispose(),w.pause(),a({stream:w,buffer:n,ended:!1})},c=h=>t(h),l=()=>a({stream:w,buffer:n,ended:!0});r.add((0,T.toDisposable)(()=>w.removeListener("error",c))),w.on("error",c),r.add((0,T.toDisposable)(()=>w.removeListener("end",l))),w.on("end",l),r.add((0,T.toDisposable)(()=>w.removeListener("data",s))),w.on("data",s)})}e.peekStream=f;function E(w,o){const a=k(o);return a.end(w),a}e.toStream=E;function u(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=u;function S(w){let o=!1;return{read:()=>o?null:(o=!0,w)}}e.toReadable=S;function g(w,o,a){const t=k(a);return C(w,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=g;function b(w,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([w,r]):w)}}}e.prefixedReadable=b;function y(w,o,a){let t=!1;const r=k(a);return C(o,{onData:n=>t?r.write(n):(t=!0,r.write(a([w,n]))),onError:n=>r.error(n),onEnd:()=>{t||(t=!0,r.write(w)),r.end()}}),r}e.prefixedStream=y}),define(Z[25],te([0,1,50]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let R,L;class k{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return T?new k(Buffer.allocUnsafe(s)):new k(new Uint8Array(s))}static wrap(s){return T&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new k(s)}static fromString(s,c){return!(c?.dontUseNodeBuffer||!1)&&T?new k(Buffer.from(s)):(R||(R=new TextEncoder),new k(R.encode(s)))}static concat(s,c){if(typeof c=="undefined"){c=0;for(let d=0,p=s.length;d<p;d++)c+=s[d].byteLength}const l=k.alloc(c);let h=0;for(let d=0,p=s.length;d<p;d++){const A=s[d];l.set(A,h),h+=A.byteLength}return l}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(s,c){return new k(this.buffer.subarray(s,c))}set(s,c){s instanceof k?this.buffer.set(s.buffer,c):this.buffer.set(s,c)}readUInt32BE(s){return I(this.buffer,s)}writeUInt32BE(s,c){i(this.buffer,s,c)}readUInt32LE(s){return C(this.buffer,s)}writeUInt32LE(s,c){f(this.buffer,s,c)}readUInt8(s){return E(this.buffer,s)}writeUInt8(s,c){u(this.buffer,s,c)}}e.VSBuffer=k;function P(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=P;function m(n,s,c){n[c+0]=s&255,s=s>>>8,n[c+1]=s&255}e.writeUInt16LE=m;function I(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=I;function i(n,s,c){n[c+3]=s,s=s>>>8,n[c+2]=s,s=s>>>8,n[c+1]=s,s=s>>>8,n[c]=s}e.writeUInt32BE=i;function C(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=C;function f(n,s,c){n[c+0]=s&255,s=s>>>8,n[c+1]=s&255,s=s>>>8,n[c+2]=s&255,s=s>>>8,n[c+3]=s&255}e.writeUInt32LE=f;function E(n,s){return n[s]}e.readUInt8=E;function u(n,s,c){n[c]=s}e.writeUInt8=u;function S(n){return D.consumeReadable(n,s=>k.concat(s))}e.readableToBuffer=S;function g(n){return D.toReadable(n)}e.bufferToReadable=g;function b(n){return D.consumeStream(n,s=>k.concat(s))}e.streamToBuffer=b;async function y(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await b(n.stream)])}e.bufferedStreamToBuffer=y;function w(n){return D.toStream(n,s=>k.concat(s))}e.bufferToStream=w;function o(n){return D.transform(n,{data:s=>typeof s=="string"?k.fromString(s):k.wrap(s)},s=>k.concat(s))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(s=>k.concat(s),n)}e.newWriteableBufferStream=a;function t(n,s){return D.prefixedReadable(n,s,c=>k.concat(c))}e.prefixedBufferReadable=t;function r(n,s){return D.prefixedStream(n,s,c=>k.concat(c))}e.prefixedBufferStream=r}),define(Z[24],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function R(V,...se){return se.length===0?V:V.replace(T,function(le,he){const me=parseInt(he,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=R;const L=/{([^}]+)}/g;function k(V,se){return V.replace(L,(le,he)=>se[he]??le)}e.format2=k;function P(V){return V.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function m(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function I(V,se){let le=0;const he=se.charCodeAt(0);for(let me=V.length-1;me>=0;me--)V.charCodeAt(me)===he&&le++;return le}e.count=I;function i(V,se,le="\u2026"){return V.length<=se?V:`${V.substr(0,se)}${le}`}e.truncate=i;function C(V,se=" "){const le=f(V,se);return E(le,se)}e.trim=C;function f(V,se){if(!V||!se)return V;const le=se.length;if(le===0||V.length===0)return V;let he=0;for(;V.indexOf(se,he)===he;)he=he+le;return V.substring(he)}e.ltrim=f;function E(V,se){if(!V||!se)return V;const le=se.length,he=V.length;if(le===0||he===0)return V;let me=he,be=-1;for(;be=V.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return V.substring(0,me)}e.rtrim=E;function u(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function S(V){return V.replace(/\*/g,"")}e.stripWildcards=S;function g(V,se,le={}){if(!V)throw new Error("Cannot create regex from empty string");se||(V=m(V)),le.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let he="";return le.global&&(he+="g"),le.matchCase||(he+="i"),le.multiline&&(he+="m"),le.unicode&&(he+="u"),new RegExp(V,he)}e.createRegExp=g;function b(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function y(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function w(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=w;function o(V){return V.split(/\r\n|\r|\n/)}e.splitLines=o;function a(V){for(let se=0,le=V.length;se<le;se++){const he=V.charCodeAt(se);if(he!==32&&he!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(V,se=0,le=V.length){for(let he=se;he<le;he++){const me=V.charCodeAt(he);if(me!==32&&me!==9)return V.substring(se,he)}return V.substring(se,le)}e.getLeadingWhitespace=t;function r(V,se=V.length-1){for(let le=se;le>=0;le--){const he=V.charCodeAt(le);if(he!==32&&he!==9)return le}return-1}e.lastNonWhitespaceIndex=r;function n(V,se){return V<se?-1:V>se?1:0}e.compare=n;function s(V,se,le=0,he=V.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=V.charCodeAt(le),De=se.charCodeAt(me);if(Ce<De)return-1;if(Ce>De)return 1}const pe=he-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstring=s;function c(V,se){return l(V,se,0,V.length,0,se.length)}e.compareIgnoreCase=c;function l(V,se,le=0,he=V.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=V.charCodeAt(le),De=se.charCodeAt(me);if(Ce===De)continue;const ke=Ce-De;if(!(ke===32&&d(De))&&!(ke===-32&&d(Ce)))return h(Ce)&&h(De)?ke:s(V.toLowerCase(),se.toLowerCase(),le,he,me,be)}const pe=he-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstringIgnoreCase=l;function h(V){return V>=97&&V<=122}e.isLowerAsciiLetter=h;function d(V){return V>=65&&V<=90}e.isUpperAsciiLetter=d;function p(V){return h(V)||d(V)}function A(V,se){return V.length===se.length&&O(V,se)}e.equalsIgnoreCase=A;function O(V,se,le=V.length){for(let he=0;he<le;he++){const me=V.charCodeAt(he),be=se.charCodeAt(he);if(me!==be){if(p(me)&&p(be)){const pe=Math.abs(me-be);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function v(V,se){const le=se.length;return se.length>V.length?!1:O(V,se,le)}e.startsWithIgnoreCase=v;function U(V,se){let le,he=Math.min(V.length,se.length);for(le=0;le<he;le++)if(V.charCodeAt(le)!==se.charCodeAt(le))return le;return he}e.commonPrefixLength=U;function F(V,se){let le,he=Math.min(V.length,se.length);const me=V.length-1,be=se.length-1;for(le=0;le<he;le++)if(V.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return he}e.commonSuffixLength=F;function z(V){return 55296<=V&&V<=56319}e.isHighSurrogate=z;function H(V){return 56320<=V&&V<=57343}e.isLowSurrogate=H;function M(V,se){return(V-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function j(V,se,le){const he=V.charCodeAt(le);if(z(he)&&le+1<se){const me=V.charCodeAt(le+1);if(H(me))return M(he,me)}return he}e.getNextCodePoint=j;function q(V,se){const le=V.charCodeAt(se-1);if(H(le)&&se>1){const he=V.charCodeAt(se-2);if(z(he))return M(he,le)}return le}function x(V,se){const le=oe.getInstance(),he=se,me=V.length,be=j(V,me,se);se+=be>=65536?2:1;let pe=le.getGraphemeBreakType(be);for(;se<me;){const we=j(V,me,se),Ce=le.getGraphemeBreakType(we);if(Q(pe,Ce))break;se+=we>=65536?2:1,pe=Ce}return se-he}e.nextCharLength=x;function $(V,se){const le=oe.getInstance(),he=se,me=q(V,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const pe=q(V,se),we=le.getGraphemeBreakType(pe);if(Q(we,be))break;se-=pe>=65536?2:1,be=we}return he-se}e.prevCharLength=$;function N(V,se){const le=oe.getInstance(),he=V.length,me=se,be=j(V,he,se),pe=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=pe;for(;se<he;){const De=j(V,he,se),ke=le.getGraphemeBreakType(De);if(Q(we,ke))break;se+=De>=65536?2:1,we=ke}const Ce=se;for(se=me,we=pe;se>0;){const De=q(V,se),ke=le.getGraphemeBreakType(De);if(Q(ke,we))break;se-=De>=65536?2:1,we=ke}return[se,Ce]}function W(V,se){return se>0&&H(V.charCodeAt(se))?N(V,se-1):N(V,se)}e.getCharContainingOffset=W;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(V){return _.test(V)}e.containsRTL=Y;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ne(V){return G.test(V)}e.containsEmoji=ne;const ee=/^[\t\n\r\x20-\x7E]*$/;function X(V){return ee.test(V)}e.isBasicASCII=X,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=B;function re(V){for(let se=0,le=V.length;se<le;se++)if(ie(V.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=re;function ie(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=ie;function ce(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=ce;function ue(V,se){if(V.length<se)return V;const le=/\b/g;let he=0;for(;le.test(V)&&!(V.length-le.lastIndex<se);)he=le.lastIndex,le.lastIndex+=1;return V.substring(he).replace(/^\s/,"")}e.lcut=ue;const ge=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(V){return V&&(V=V.replace(ge,""),V=V.replace(de,""),V=V.replace(Ie,"")),V}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Oe(V){return Ee(V)?V.substr(1):V}e.stripUTF8BOM=Oe;function Re(V,se){if(!V||!se||V.length<se.length)return!1;const le=se.length,he=V.toLowerCase();let me=0,be=-1;for(;me<le;){const pe=he.indexOf(se[me],be+1);if(pe<0)return!1;be=pe,me++}return!0}e.fuzzyContains=Re;function Te(V,se=!1){return V?(se&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Te;function Ne(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Ne;function _e(V,se=1){if(se===0)return"";let le=-1;do le=V.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?V:(V[le-1]==="\r"&&le--,V.substr(0,le))}e.getNLines=_e;function ze(V){const se=90-65+1;return V=V%(2*se),V<se?String.fromCharCode(97+V):String.fromCharCode(65+V-se)}e.singleLetterHash=ze;function $e(V){return oe.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=$e;function Q(V,se){return V===0?se!==5&&se!==7:V===2&&se===3?!1:V===4||V===2||V===3||se===4||se===2||se===3?!0:!(V===8&&(se===8||se===9||se===11||se===12)||(V===11||V===9)&&(se===9||se===10)||(V===12||V===10)&&se===10||se===5||se===13||se===7||V===1||V===13&&se===14||V===6&&se===6)}e.breakBetweenGraphemeBreakType=Q;var ae;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class oe{constructor(){this._data=ve()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,he=le.length/3;let me=1;for(;me<=he;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}oe._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(V,se){if(V===0)return 0;const le=Fe(V,se);if(le!==void 0)return le;const he=q(se,V);return V-=Le(he),V}e.getLeftDeleteOffset=Se;function Fe(V,se){let le=q(se,V);for(V-=Le(le);Me(le)||le===65039||le===8419;){if(V===0)return;le=q(se,V),V-=Le(le)}if(!!ce(le)){if(V>=0){const he=q(se,V);he===8205&&(V-=Le(he))}return V}}function Le(V){return V>=65536?2:1}function Me(V){return 127995<=V&&V<=127999}var Ae;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={}))}),define(Z[18],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function T(d){return typeof d=="string"}e.isString=T;function R(d){return Array.isArray(d)&&d.every(p=>T(p))}e.isStringArray=R;function L(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=L;function k(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=k;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function m(d){return d===!0||d===!1}e.isBoolean=m;function I(d){return typeof d=="undefined"}e.isUndefined=I;function i(d){return!C(d)}e.isDefined=i;function C(d){return I(d)||d===null}e.isUndefinedOrNull=C;function f(d,p){if(!d)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=f;function E(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=E;function u(...d){const p=[];for(let A=0;A<d.length;A++){const O=d[A];if(C(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);p.push(O)}return p}e.assertAllDefined=u;const S=Object.prototype.hasOwnProperty;function g(d){if(!L(d))return!1;for(let p in d)if(S.call(d,p))return!1;return!0}e.isEmptyObject=g;function b(d){return typeof d=="function"}e.isFunction=b;function y(...d){return d.length>0&&d.every(b)}e.areFunctions=y;function w(d,p){const A=Math.min(d.length,p.length);for(let O=0;O<A;O++)o(d[O],p[O])}e.validateConstraints=w;function o(d,p){if(T(p)){if(typeof d!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(b(p)){try{if(d instanceof p)return}catch{}if(!C(d)&&d.constructor===p||p.length===1&&p.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(d){let p=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)p=p.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return p}e.getAllPropertyNames=a;function t(d){const p=[];for(const A of a(d))typeof d[A]=="function"&&p.push(A);return p}e.getAllMethodNames=t;function r(d,p){const A=v=>function(){const U=Array.prototype.slice.call(arguments,0);return p(v,U)};let O={};for(const v of d)O[v]=A(v);return O}e.createProxyObject=r;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function s(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=s;function c(d){return class{constructor(){return new Proxy({},{get(p,A){if(p[A])return p[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=c;function l(d,p="Unreachable"){throw new Error(p)}e.assertNever=l;function h(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=h}),define(Z[40],te([0,1,8,4,24,18]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function I(n,s=D.posix.sep){if(!n)return"";const c=n.length,l=n.charCodeAt(0);if(k(l)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let d=3;const p=d;for(;d<c&&!k(n.charCodeAt(d));d++);if(p!==d&&!k(n.charCodeAt(d+1))){for(d+=1;d<c;d++)if(k(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,s)}}return s}else if(b(l)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(k(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=I;function i(n){if(!T.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let c=2;const l=c;for(;c<n.length&&(s=n.charCodeAt(c),s!==92);c++);return!(l===c||(s=n.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,s=T.isWindows){const c=s?C:f;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||s&&E.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function S(n,s,c){const l=n===s;return!c||l?l:!n||!s?!1:(0,R.equalsIgnoreCase)(n,s)}e.isEqual=S;function g(n,s,c,l=D.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let d=s.length;return s.charAt(s.length-1)===l&&d--,n.charAt(d)===l}return s.charAt(s.length-1)!==l&&(s+=l),n.indexOf(s)===0}e.isEqualOrParent=g;function b(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=b;function y(n,s){return T.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(s,n)),n=(0,D.normalize)(n),T.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=y;function w(n){const s=(0,D.normalize)(n);return T.isWindows?n.length>3?!1:o(s)&&(n.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=w;function o(n){return T.isWindows?b(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,s,c){return s.length>n.length?-1:n===s?0:(c&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=t;function r(n){const s=n.split(":");let c,l,h;if(s.forEach(d=>{const p=Number(d);(0,L.isNumber)(p)?l===void 0?l=p:h===void 0&&(h=p):c=c?[c,d].join(":"):d}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],te([0,1,18]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const g=Array.isArray(S)?[]:{};return Object.keys(S).forEach(b=>{S[b]&&typeof S[b]=="object"?g[b]=T(S[b]):g[b]=S[b]}),g}e.deepClone=T;function R(S){if(!S||typeof S!="object")return S;const g=[S];for(;g.length>0;){const b=g.shift();Object.freeze(b);for(const y in b)if(L.call(b,y)){const w=b[y];typeof w=="object"&&!Object.isFrozen(w)&&g.push(w)}}return S}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function k(S,g){return P(S,g,new Set)}e.cloneAndChange=k;function P(S,g,b){if((0,D.isUndefinedOrNull)(S))return S;const y=g(S);if(typeof y!="undefined")return y;if((0,D.isArray)(S)){const w=[];for(const o of S)w.push(P(o,g,b));return w}if((0,D.isObject)(S)){if(b.has(S))throw new Error("Cannot clone recursive data-structure");b.add(S);const w={};for(let o in S)L.call(S,o)&&(w[o]=P(S[o],g,b));return b.delete(S),w}return S}function m(S,g,b=!0){return(0,D.isObject)(S)?((0,D.isObject)(g)&&Object.keys(g).forEach(y=>{y in S?b&&((0,D.isObject)(S[y])&&(0,D.isObject)(g[y])?m(S[y],g[y],b):S[y]=g[y]):S[y]=g[y]}),S):g}e.mixin=m;function I(S,g){if(S===g)return!0;if(S==null||g===null||g===void 0||typeof S!=typeof g||typeof S!="object"||Array.isArray(S)!==Array.isArray(g))return!1;let b,y;if(Array.isArray(S)){if(S.length!==g.length)return!1;for(b=0;b<S.length;b++)if(!I(S[b],g[b]))return!1}else{const w=[];for(y in S)w.push(y);w.sort();const o=[];for(y in g)o.push(y);if(o.sort(),!I(w,o))return!1;for(b=0;b<w.length;b++)if(!I(S[w[b]],g[w[b]]))return!1}return!0}e.equals=I;function i(S){const g=new Set;return JSON.stringify(S,(b,y)=>{if((0,D.isObject)(y)||Array.isArray(y)){if(g.has(y))return"[Circular]";g.add(y)}return y})}e.safeStringify=i;function C(S,g,b){const y=g(S);return typeof y=="undefined"?b:y}e.getOrDefault=C;function f(S,g){const b=Object.create(null);return!S||!g||Object.keys(g).forEach(w=>{const o=S[w],a=g[w];I(o,a)||(b[w]=a)}),b}e.distinct=f;function E(S,g){const b=g.toLowerCase(),y=Object.keys(S).find(w=>w.toLowerCase()===b);return y?S[y]:S[g]}e.getCaseInsensitive=E;function u(S,g){const b=Object.create(null);for(const y of Object.keys(S))g(y,S[y])&&(b[y]=S[y]);return b}e.filter=u}),define(Z[5],te([0,1,8,4]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,k=/^\/\//;function P(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,s){return!n&&!s?"file":n}function I(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==C&&(s=C+s):s=C;break}return s}const i="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(s,c,l,h,d,p=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=m(s,p),this.authority=c||i,this.path=I(this.scheme,l||i),this.query=h||i,this.fragment=d||i,P(this,p))}static isUri(s){return s instanceof E?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return w(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:l,path:h,query:d,fragment:p}=s;return c===void 0?c=this.scheme:c===null&&(c=i),l===void 0?l=this.authority:l===null&&(l=i),h===void 0?h=this.path:h===null&&(h=i),d===void 0?d=this.query:d===null&&(d=i),p===void 0?p=this.fragment:p===null&&(p=i),c===this.scheme&&l===this.authority&&h===this.path&&d===this.query&&p===this.fragment?this:new S(c,l,h,d,p)}static parse(s,c=!1){const l=f.exec(s);return l?new S(l[2]||i,r(l[4]||i),r(l[5]||i),r(l[7]||i),r(l[9]||i),c):new S(i,i,i,i,i)}static file(s){let c=i;if(T.isWindows&&(s=s.replace(/\\/g,C)),s[0]===C&&s[1]===C){const l=s.indexOf(C,2);l===-1?(c=s.substring(2),s=C):(c=s.substring(2,l),s=s.substring(l)||C)}return new S("file",c,s,i,i)}static from(s){const c=new S(s.scheme,s.authority,s.path,s.query,s.fragment);return P(c,!0),c}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return T.isWindows&&s.scheme==="file"?l=E.file(D.win32.join(w(s,!0),...c)).path:l=D.posix.join(s.path,...c),s.with({path:l})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof E)return s;{const c=new S(s);return c._formatted=s.external,c._fsPath=s._sep===u?s.fsPath:null,c}}else return s}}e.URI=E;const u=T.isWindows?1:void 0;class S extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(n,s){let c,l=-1;for(let h=0;h<n.length;h++){const d=n.charCodeAt(h);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||s&&d===47)l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c!==void 0&&(c+=n.charAt(h));else{c===void 0&&(c=n.substr(0,h));const p=g[d];p!==void 0?(l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c+=p):l===-1&&(l=h)}}return l!==-1&&(c+=encodeURIComponent(n.substring(l))),c!==void 0?c:n}function y(n){let s;for(let c=0;c<n.length;c++){const l=n.charCodeAt(c);l===35||l===63?(s===void 0&&(s=n.substr(0,c)),s+=g[l]):s!==void 0&&(s+=n[c])}return s!==void 0?s:n}function w(n,s){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,T.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=w;function o(n,s){const c=s?y:b;let l="",{scheme:h,authority:d,path:p,query:A,fragment:O}=n;if(h&&(l+=h,l+=":"),(d||h==="file")&&(l+=C,l+=C),d){let v=d.indexOf("@");if(v!==-1){const U=d.substr(0,v);d=d.substr(v+1),v=U.indexOf(":"),v===-1?l+=c(U,!1):(l+=c(U.substr(0,v),!1),l+=":",l+=c(U.substr(v+1),!1)),l+="@"}d=d.toLowerCase(),v=d.indexOf(":"),v===-1?l+=c(d,!1):(l+=c(d.substr(0,v),!1),l+=d.substr(v))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const v=p.charCodeAt(1);v>=65&&v<=90&&(p=`/${String.fromCharCode(v+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const v=p.charCodeAt(0);v>=65&&v<=90&&(p=`${String.fromCharCode(v+32)}:${p.substr(2)}`)}l+=c(p,!0)}return A&&(l+="?",l+=c(A,!1)),O&&(l+="#",l+=s?O:b(O,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,s=>a(s)):n}}),define(Z[94],te([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(I){const i=I;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=T;function R(I){const i=[];let C;try{const f=JSON.parse(I.arguments),E=f[f.length-1];E&&E.__$stack&&(f.pop(),C=E.__$stack),i.push(...f)}catch(f){i.push("Unable to log remote console arguments",I.arguments)}return{args:i,stack:C}}e.parse=R;function L(I){if(typeof I!="string")return L(R(I).stack);const i=I;if(i){const C=k(i),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=L;function k(I){if(!I)return I;const i=I.indexOf(`
`);return i===-1?I:I.substring(0,i)}function P(I,i){const{args:C,stack:f}=R(I),E=typeof C[0]=="string"&&C.length===1;let u=k(f);u&&(u=`(${u.trim()})`);let S=[];if(typeof C[0]=="string"?u&&E?S=[`%c[${i}] %c${C[0]} %c${u}`,m("blue"),m(""),m("grey")]:S=[`%c[${i}] %c${C[0]}`,m("blue"),m(""),...C.slice(1)]:S=[`%c[${i}]%`,m("blue"),...C],u&&!E&&S.push(u),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,S)}e.log=P;function m(I){return`color: ${I}`}});var mt=this&&this.__classPrivateFieldSet||function(K,e,D,T,R){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},je=this&&this.__classPrivateFieldGet||function(K,e,D,T){if(D==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?T:D==="a"?T.call(K):T?T.value:e.get(K)};define(Z[41],te([0,1,17,24,5]),function(K,e,D,T,R){"use strict";var L,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function m(r,n,s){let c=r.get(n);return c===void 0&&(c=s,r.set(n,c)),c}e.getOrSet=m;function I(r){const n=[];return r.forEach((s,c)=>{n.push(`${c} => ${s}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=I;function i(r){const n=[];return r.forEach(s=>{n.push(s)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=i;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=C;class f{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class E{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var u;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(u||(u={}));class S{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,T.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(n){this._iter=n}static forUris(n=()=>!1){return new b(new S(n))}static forPaths(){return new b(new E)}static forStrings(){return new b(new C)}static forConfigKeys(){return new b(new f)}clear(){this._root=void 0}set(n,s){const c=this._iter.reset(n);let l;for(this._root||(this._root=new g,this._root.segment=c.value()),l=this._root;;){const d=c.cmp(l.segment);if(d>0)l.left||(l.left=new g,l.left.segment=c.value()),l=l.left;else if(d<0)l.right||(l.right=new g,l.right.segment=c.value()),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new g,l.mid.segment=c.value()),l=l.mid;else break}const h=l.value;return l.value=s,l.key=n,h}fill(n,s){const c=s.slice(0);(0,D.shuffle)(c);for(let l of c)this.set(l,n)}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const c=this._iter.reset(n),l=[];let h=this._root;for(;h;){const d=c.cmp(h.segment);if(d>0)l.push([1,h]),h=h.left;else if(d<0)l.push([-1,h]),h=h.right;else if(c.hasNext())c.next(),l.push([0,h]),h=h.mid;else{for(s?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;l.length>0&&h.isEmpty();){let[p,A]=l.pop();switch(p){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}h=A}break}}}findSubstr(n){const s=this._iter.reset(n);let c=this._root,l;for(;c;){const h=s.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(s.hasNext())s.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[s,c]of this)n(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const s=[n];for(;s.length>0;){const c=s.pop();c&&(c.value&&(yield[c.key,c.value]),c.left&&s.push(c.left),c.mid&&s.push(c.mid),c.right&&s.push(c.right))}}}e.TernarySearchTree=b;class y{constructor(n,s){this[L]="ResourceMap",n instanceof y?(this.map=new Map(n.map),this.toKey=s??y.defaultToKey):(this.map=new Map,this.toKey=n??y.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[c,l]of this.map)n(l,R.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=y,y.defaultToKey=r=>r.toString();var w;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const c=this._map.get(n);if(!!c)return s!==0&&this.touch(c,s),c.value}set(n,s,c=0){let l=this._map.get(n);if(l)l.value=s,c!==0&&this.touch(l,c);else{switch(l={key:n,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const c=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>n;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,c=n.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const c=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(c.previous=l,l.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const c=n.next,l=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=l,l.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,c)=>{n.push([c,s])}),n}fromJSON(n){this.clear();for(const[s,c]of n)this.set(s,c)}}e.LinkedMap=o;class a extends o{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class t{constructor(n){P.set(this,void 0),mt(this,P,n,"f")}get size(){return je(this,P,"f").size}forEach(n,s){je(this,P,"f").forEach(n,s)}get(n){return je(this,P,"f").get(n)}has(n){return je(this,P,"f").has(n)}entries(){return je(this,P,"f").entries()}keys(){return je(this,P,"f").keys()}values(){return je(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return je(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(Z[95],te([0,1,25,24,5]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function L(i){return JSON.stringify(i,m)}e.stringify=L;function k(i){let C=JSON.parse(i);return C=I(C),C}e.parse=k;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,T.regExpFlags)(C)}:C}function I(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let f=0;f<i.length;++f)i[f]=I(i[f],C+1);else for(const f in i)Object.hasOwnProperty.call(i,f)&&(i[f]=I(i[f],C+1))}return i}e.revive=I}),define(Z[15],te([0,1,4,5]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,I,i){this._hosts[m]=I,this._ports[m]=i}setConnectionToken(m,I){this._connectionTokens[m]=I}rewrite(m){if(this._delegate)return this._delegate(m);const I=m.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[I],f=this._connectionTokens[I];let E=`path=${encodeURIComponent(m.path)}`;return typeof f=="string"&&(E+=`&tkn=${encodeURIComponent(f)}`),T.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new L;class k{asBrowserUri(m,I){const i=this.toUri(m,I);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,I){const i=this.toUri(m,I);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,I){return T.URI.isUri(m)?m:T.URI.parse(I.toUrl(m))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Z[66],te([0,1,41]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new D.LRUCache(1e4);function R(I){return m(I,"NFC",T)}e.normalizeNFC=R;const L=new D.LRUCache(1e4);function k(I){return m(I,"NFD",L)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function m(I,i,C){if(!I)return I;const f=C.get(I);if(f)return f;let E;return P.test(I)?E=I.normalize(i):E=I,C.set(I,E),E}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(i){return k(i).replace(I,"")}}()}),define(Z[16],te([0,1,40,15,8,4,24,5]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(E){return(0,P.uriToFsPath)(E,!0)}e.originalFSPath=m;class I{constructor(u){this._ignorePathCasing=u}compare(u,S,g=!1){return u===S?0:(0,k.compare)(this.getComparisonKey(u,g),this.getComparisonKey(S,g))}isEqual(u,S,g=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,g)===this.getComparisonKey(S,g)}getComparisonKey(u,S=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,S,g=!1){if(u.scheme===S.scheme){if(u.scheme===T.Schemas.file)return D.isEqualOrParent(m(u),m(S),this._ignorePathCasing(u))&&u.query===S.query&&(g||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return D.isEqualOrParent(u.path,S.path,this._ignorePathCasing(u),"/")&&u.query===S.query&&(g||u.fragment===S.fragment)}return!1}joinPath(u,...S){return P.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===T.Schemas.file?S=P.URI.file(R.dirname(m(u))).path:(S=R.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===T.Schemas.file?S=P.URI.file(R.normalize(m(u))).path:S=R.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))return;if(u.scheme===T.Schemas.file){const y=R.relative(m(u),m(S));return L.isWindows?D.toSlashes(y):y}let g=u.path||"/",b=S.path||"/";if(this._ignorePathCasing(u)){let y=0;for(const w=Math.min(g.length,b.length);y<w&&!(g.charCodeAt(y)!==b.charCodeAt(y)&&g.charAt(y).toLowerCase()!==b.charAt(y).toLowerCase());y++);g=b.substr(0,y)+g.substr(y)}return R.posix.relative(g,b)}resolvePath(u,S){if(u.scheme===T.Schemas.file){const g=P.URI.file(R.resolve(m(u),S));return u.with({authority:g.authority,path:g.path})}return S=D.toPosixPath(S),u.with({path:R.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||(0,k.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=R.sep){if(u.scheme===T.Schemas.file){const g=m(u);return g.length>D.getRoot(g).length&&g[g.length-1]===S}else{const g=u.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=R.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=R.sep){let g=!1;if(u.scheme===T.Schemas.file){const b=m(u);g=b!==void 0&&b.length===D.getRoot(b).length&&b[b.length-1]===S}else{S="/";const b=u.path;g=b.length===1&&b.charCodeAt(b.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(E,u){const S=[];for(let g=0;g<E.length;g++){const b=u(E[g]);E.some((y,w)=>w===g?!1:(0,e.isEqualOrParent)(b,u(y)))||S.push(E[g])}return S}e.distinctParents=i;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function u(S){const g=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(w=>{const[o,a]=w.split(":");o&&a&&g.set(o,a)});const y=S.path.substring(0,S.path.indexOf(";"));return y&&g.set(E.META_DATA_MIME,y),g}E.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(E,u,S){if(u){let g=E.path;return g&&g[0]!==R.posix.sep&&(g=R.posix.sep+g),E.with({scheme:S,authority:u,path:g})}return E.with({scheme:S})}e.toLocalResource=f}),define(Z[6],te([0,1,27,9,3,2,16]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(q){return!!q&&typeof q.then=="function"}e.isThenable=P;function m(q){const x=new D.CancellationTokenSource,$=q(x.token),N=new Promise((W,_)=>{const Y=x.token.onCancellationRequested(()=>{Y.dispose(),x.dispose(),_((0,T.canceled)())});Promise.resolve($).then(G=>{Y.dispose(),x.dispose(),W(G)},G=>{Y.dispose(),x.dispose(),_(G)})});return new class{cancel(){x.cancel()}then(W,_){return N.then(W,_)}catch(W){return this.then(void 0,W)}finally(W){return N.finally(W)}}}e.createCancelablePromise=m;function I(q,x,$){return Promise.race([q,new Promise(N=>x.onCancellationRequested(()=>N($)))])}e.raceCancellation=I;async function i(q){let x=-1;const $=q.map((W,_)=>W.then(Y=>(x=_,Y))),N=await Promise.race($);return q.forEach((W,_)=>{_!==x&&W.cancel()}),N}e.raceCancellablePromises=i;function C(q,x,$){let N;const W=setTimeout(()=>{N?.(void 0),$?.()},x);return Promise.race([q.finally(()=>clearTimeout(W)),new Promise(_=>N=_)])}e.raceTimeout=C;function f(q){return new Promise((x,$)=>{const N=q();P(N)?N.then(x,$):x(N)})}e.asPromise=f;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then($,$).then(N)})}return new Promise(($,N)=>{this.queuedPromise.then($,N)})}return this.activePromise=x(),new Promise(($,N)=>{this.activePromise.then(W=>{this.activePromise=null,$(W)},W=>{this.activePromise=null,N(W)})})}}e.Throttler=E;class u{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=u;class S{constructor(){this.promiseMap=new Map}queue(x,$){const W=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(x)===W&&this.promiseMap.delete(x)});return this.promiseMap.set(x,W),W}}e.SequencerByKey=S;class g{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,$=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,W)=>{this.doResolve=N,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class b{constructor(x){this.delayer=new g(x),this.throttler=new E}trigger(x,$){return this.delayer.trigger(()=>this.throttler.queue(x),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class y{constructor(){this._isOpen=!1,this._promise=new Promise((x,$)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class w extends y{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=w;function o(q,x){return x?new Promise(($,N)=>{const W=setTimeout(()=>{_.dispose(),$()},q),_=x.onCancellationRequested(()=>{clearTimeout(W),_.dispose(),N((0,T.canceled)())})}):m($=>o(q,$))}e.timeout=o;function a(q,x=0){const $=setTimeout(q,x);return(0,L.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=a;function t(q){const x=[];let $=0;const N=q.length;function W(){return $<N?q[$++]():null}function _(Y){Y!=null&&x.push(Y);const G=W();return G?G.then(_):Promise.resolve(x)}return Promise.resolve(null).then(_)}e.sequence=t;function r(q,x=N=>!!N,$=null){let N=0;const W=q.length,_=()=>{if(N>=W)return Promise.resolve($);const Y=q[N++];return Promise.resolve(Y()).then(ne=>x(ne)?Promise.resolve(ne):_())};return _()}e.first=r;function n(q,x=N=>!!N,$=null){if(q.length===0)return Promise.resolve($);let N=q.length;const W=()=>{N=-1;for(const _ of q)_.cancel?.()};return new Promise((_,Y)=>{for(const G of q)G.then(ne=>{--N>=0&&x(ne)?(W(),_(ne)):N===0&&_($)}).catch(ne=>{--N>=0&&(W(),Y(ne))})})}e.firstParallel=n;class s{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise(($,N)=>{this.outstandingPromises.push({factory:x,c:$,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const $=x.factory();$.then(x.c,x.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class c extends s{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor(x,$=k.extUri){const N=$.getComparisonKey(x);let W=this.queues.get(N);return W||(W=new c,R.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(N)}),this.queues.set(N,W)),W}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(x,$){this._token=-1,typeof x=="function"&&typeof $=="number"&&this.setIfNotSet(x,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},$)}setIfNotSet(x,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},$))}}e.TimeoutTimer=h;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,$){this.cancel(),this._token=setInterval(()=>{x()},$)}}e.IntervalTimer=d;class p{constructor(x,$){this.timeoutToken=-1,this.runner=x,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=p;class A{constructor(x,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends p{constructor(x,$){super(x,$);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class v extends L.Disposable{constructor(x,$,N,W){super();this.maxWorkChunkSize=x,this.maxPendingWork=$,this.throttleDelay=N,this.handler=W,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new p(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=v,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const $=setTimeout(()=>x(q));let N=!1;return{dispose(){N||(N=!0,clearTimeout($))}}}}else e.runWhenIdle=(q,x)=>{const $=requestIdleCallback(q,typeof x=="number"?{timeout:x}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback($))}}}}();class U{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function F(q,x,$){let N;for(let W=0;W<$;W++)try{return await q()}catch(_){N=_,await o(x)}throw N}e.retry=F;class z{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,$,N){return this._pending={taskId:x,cancel:()=>N?.(),promise:$},$.then(()=>this.donePending(x),()=>this.donePending(x)),$}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let $,N;const W=new Promise((_,Y)=>{$=_,N=Y});this._next={run:x,promise:W,promiseResolve:$,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,$)=>{this.completeCallback=x,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise($=>{this.completeCallback(x),this.resolved=!0,$()})}error(x){return new Promise($=>{this.errorCallback(x),this.rejected=!0,$()})}cancel(){new Promise(x=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=M;var j;(function(q){async function x($){let N;const W=await Promise.all($.map(_=>_.then(Y=>Y,Y=>{N||(N=Y)})));if(typeof N!="undefined")throw N;return W}q.settled=x})(j=e.Promises||(e.Promises={}))}),define(Z[67],te([0,1,6,40,41,8,24]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",I="/",i="[/\\\\]",C="[^/\\\\]",f=/\//g;function E(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function u(N,W){if(!N)return[];const _=[];let Y=!1,G=!1,ne="";for(const ee of N){switch(ee){case W:if(!Y&&!G){_.push(ne),ne="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":G=!0;break;case"]":G=!1;break}ne+=ee}return ne&&_.push(ne),_}e.splitGlobAware=u;function S(N){if(!N)return"";let W="";const _=u(N,I);if(_.every(Y=>Y===m))W=".*";else{let Y=!1;_.forEach((G,ne)=>{if(G===m){Y||(W+=E(2),Y=!0);return}let ee=!1,X="",B=!1,re="";for(const ie of G){if(ie!=="}"&&ee){X+=ie;continue}if(B&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===I?ce="":ce=k.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":ee=!0;continue;case"[":B=!0;continue;case"}":W+=`(?:${u(X,",").map(ge=>S(ge)).join("|")})`,ee=!1,X="";break;case"]":W+="["+re+"]",B=!1,re="";break;case"?":W+=C;continue;case"*":W+=E(1);continue;default:W+=k.escapeRegExpCharacters(ie)}}ne<_.length-1&&(_[ne+1]!==m||ne+2<_.length)&&(W+=i),Y=!1})}return W}const g=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,w=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(N,W){if(!N)return n;let _;typeof N!="string"?_=N.pattern:_=N,_=_.trim();const Y=`${_}_${!!W.trimForExclusions}`;let G=t.get(Y);if(G)return c(G,N);let ne;if(g.test(_)){const ee=_.substr(4);G=function(X,B){return typeof X=="string"&&X.endsWith(ee)?_:null}}else(ne=b.exec(l(_,W)))?G=h(ne[1],_):(W.trimForExclusions?w:y).test(_)?G=d(_,W):(ne=o.exec(l(_,W)))?G=p(ne[1].substr(1),_,!0):(ne=a.exec(l(_,W)))?G=p(ne[1],_,!1):G=A(_);return t.set(Y,G),c(G,N)}function c(N,W){return typeof W=="string"?N:function(_,Y){return T.isEqualOrParent(_,W.base)?N(L.relative(W.base,_),Y):null}}function l(N,W){return W.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function h(N,W){const _=`/${N}`,Y=`\\${N}`,G=function(ee,X){return typeof ee!="string"?null:X?X===N?W:null:ee===N||ee.endsWith(_)||ee.endsWith(Y)?W:null},ne=[N];return G.basenames=ne,G.patterns=[W],G.allBasenames=ne,G}function d(N,W){const _=$(N.slice(1,-1).split(",").map(X=>s(X,W)).filter(X=>X!==n),N),Y=_.length;if(!Y)return n;if(Y===1)return _[0];const G=function(X,B){for(let re=0,ie=_.length;re<ie;re++)if(_[re](X,B))return N;return null},ne=_.find(X=>!!X.allBasenames);ne&&(G.allBasenames=ne.allBasenames);const ee=_.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return ee.length&&(G.allPaths=ee),G}function p(N,W,_){const Y=L.sep===L.posix.sep,G=Y?N:N.replace(f,L.sep),ne=L.sep+G,ee=L.posix.sep+N,X=_?function(B,re){return typeof B=="string"&&(B===G||B.endsWith(ne)||!Y&&(B===N||B.endsWith(ee)))?W:null}:function(B,re){return typeof B=="string"&&(B===G||!Y&&B===N)?W:null};return X.allPaths=[(_?"*/":"./")+N],X}function A(N){try{const W=new RegExp(`^${S(N)}$`);return function(_){return W.lastIndex=0,typeof _=="string"&&W.test(_)?N:null}}catch(W){return n}}function O(N,W,_){return!N||typeof W!="string"?!1:v(N)(W,void 0,_)}e.match=O;function v(N,W={}){if(!N)return r;if(typeof N=="string"||H(N)){const _=s(N,W);if(_===n)return r;const Y=function(G,ne){return!!_(G,ne)};return _.allBasenames&&(Y.allBasenames=_.allBasenames),_.allPaths&&(Y.allPaths=_.allPaths),Y}return q(N,W)}e.parse=v;function U(N){if(!N)return;let W;return _=>(W||(W=(N()||Promise.resolve([])).then(Y=>Y?z(Y):{})),W.then(Y=>!!Y[_]))}e.hasSiblingPromiseFn=U;function F(N){if(!N)return;let W;return _=>{if(!W){const Y=N();W=Y?z(Y):{}}return!!W[_]}}e.hasSiblingFn=F;function z(N){const W={};for(const _ of N)W[_]=!0;return W}function H(N){const W=N;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=H;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function j(N){return N.allPaths||[]}e.getPathTerms=j;function q(N,W){const _=$(Object.getOwnPropertyNames(N).map(X=>x(X,N[X],W)).filter(X=>X!==n)),Y=_.length;if(!Y)return n;if(!_.some(X=>!!X.requiresSiblings)){if(Y===1)return _[0];const X=function(ie,ce){for(let ue=0,ge=_.length;ue<ge;ue++){const de=_[ue](ie,ce);if(de)return de}return null},B=_.find(ie=>!!ie.allBasenames);B&&(X.allBasenames=B.allBasenames);const re=_.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(X.allPaths=re),X}const G=function(X,B,re){let ie;for(let ce=0,ue=_.length;ce<ue;ce++){const ge=_[ce];ge.requiresSiblings&&re&&(B||(B=L.basename(X)),ie||(ie=B.substr(0,B.length-L.extname(X).length)));const de=ge(X,B,ie,re);if(de)return de}return null},ne=_.find(X=>!!X.allBasenames);ne&&(G.allBasenames=ne.allBasenames);const ee=_.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return ee.length&&(G.allPaths=ee),G}function x(N,W,_){if(W===!1)return n;const Y=s(N,_);if(Y===n)return n;if(typeof W=="boolean")return Y;if(W){const G=W.when;if(typeof G=="string"){const ne=(ee,X,B,re)=>{if(!re||!Y(ee,X))return null;const ie=G.replace("$(basename)",B),ce=re(ie);return(0,D.isThenable)(ce)?ce.then(ue=>ue?N:null):ce?N:null};return ne.requiresSiblings=!0,ne}}return Y}function $(N,W){const _=N.filter(X=>!!X.basenames);if(_.length<2)return N;const Y=_.reduce((X,B)=>{const re=B.basenames;return re?X.concat(re):X},[]);let G;if(W){G=[];for(let X=0,B=Y.length;X<B;X++)G.push(W)}else G=_.reduce((X,B)=>{const re=B.patterns;return re?X.concat(re):X},[]);const ne=function(X,B){if(typeof X!="string")return null;if(!B){let ie;for(ie=X.length;ie>0;ie--){const ce=X.charCodeAt(ie-1);if(ce===47||ce===92)break}B=X.substr(ie)}const re=Y.indexOf(B);return re!==-1?G[re]:null};ne.basenames=Y,ne.patterns=G,ne.allBasenames=Y;const ee=N.filter(X=>!X.basenames);return ee.push(ne),ee}}),define(Z[96],te([0,1,67,15,8,16,24]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],I=[],i=[];function C(s,c=!1){const l=f(s);m.push(l),l.userConfigured?i.push(l):I.push(l),c&&!l.userConfigured&&m.forEach(h=>{h.mime===l.mime||h.userConfigured||(l.extension&&h.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&h.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&h.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&h.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function f(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,D.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(R.posix.sep)>=0:!1}}function E(s){s?(m=m.filter(c=>!c.userConfigured),i=[]):(m=[],I=[],i=[])}e.clearTextMimes=E;function u(s,c){let l;if(s)switch(s.scheme){case T.Schemas.file:l=s.fsPath;break;case T.Schemas.data:l=L.DataUri.parseMetaData(s).get(L.DataUri.META_DATA_LABEL);break;default:l=s.path}if(!l)return[P.unknown];l=l.toLowerCase();const h=(0,R.basename)(l),d=S(l,h,i);if(d)return[d,P.text];const p=S(l,h,I);if(p)return[p,P.text];if(c){const A=g(c);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=u;function S(s,c,l){let h=null,d=null,p=null;for(let A=l.length-1;A>=0;A--){const O=l[A];if(c===O.filenameLowercase){h=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const v=O.filepatternOnPath?s:c;O.filepatternLowercase?.(v)&&(d=O)}O.extension&&(!p||O.extension.length>p.extension.length)&&c.endsWith(O.extensionLowercase)&&(p=O)}return h?h.mime:d?d.mime:p?p.mime:null}function g(s){if((0,k.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let c=m.length-1;c>=0;c--){const l=m[c];if(!l.firstline)continue;const h=s.match(l.firstline);if(h&&h.length>0)return l.mime}return null}function b(s){return s?typeof s=="string"?s===P.binary||s===P.text||s===P.unknown:s.length===1&&b(s[0]):!0}e.isUnspecific=b;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(s){const c=(0,R.extname)(s),l=y[c.toLowerCase()];return l!==void 0?l:a(s)}e.getMediaOrTextMime=o;function a(s){const c=(0,R.extname)(s);return w[c.toLowerCase()]}e.getMediaMime=a;function t(s){for(const c in w)if(w[c]===s)return c}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function n(s,c){const l=r.exec(s);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:c?void 0:s}e.normalizeMimeType=n}),define(Z[97],te([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:T(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:T(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function L(i,C,f){if(!i||f>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return C.transformOutgoing(i);for(let E in i)if(Object.hasOwnProperty.call(i,E)){const u=L(i[E],C,f+1);u!==null&&(i[E]=u)}}return null}function k(i,C){const f=L(i,C,0);return f===null?i:f}e.transformOutgoingURIs=k;function P(i,C,f,E){if(!i||E>200)return null;if(typeof i=="object"){if(i.$mid===1)return f?D.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const S=P(i[u],C,f,E+1);S!==null&&(i[u]=S)}}return null}function m(i,C){const f=P(i,C,!1,0);return f===null?i:f}e.transformIncomingURIs=m;function I(i,C){const f=P(i,C,!0,0);return f===null?i:f}e.transformAndReviveIncomingURIs=I}),define(Z[30],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(m){return D.test(m)}e.isUUID=T;const R=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(m){for(let I=0;I<m.length;I++)m[I]=Math.floor(Math.random()*256);return m};function P(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,I="";return I+=L[R[m++]],I+=L[R[m++]],I+=L[R[m++]],I+=L[R[m++]],I+="-",I+=L[R[m++]],I+=L[R[m++]],I+="-",I+=L[R[m++]],I+=L[R[m++]],I+="-",I+=L[R[m++]],I+=L[R[m++]],I+="-",I+=L[R[m++]],I+=L[R[m++]],I+=L[R[m++]],I+=L[R[m++]],I+=L[R[m++]],I+=L[R[m++]],I}e.generateUuid=P}),define(Z[68],te([0,1,98]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(L="utf8"){this.stringDecoder=new D.StringDecoder(L),this.remaining=null}write(L){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(P.length<1)return k;let m=0,I,i=m;for(;i<P.length;)if(I=P.charCodeAt(i),I===13||I===10){if(k.push(P.substring(m,i)),i++,i<P.length){const C=I;I=P.charCodeAt(i),(C===13&&I===10||C===10&&I===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,k}end(){return this.remaining}}e.LineDecoder=T}),define(Z[99],te([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!T.has(m)}function L(){return new Promise(async(P,m)=>{const I=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(i){m(i)}finally{clearTimeout(I)}})}e.getMac=L;function k(){return new Promise((P,m)=>{try{const I=(0,D.networkInterfaces)();for(let i in I){const C=I[i];if(C){for(const{mac:f}of C)if(R(f))return P(f)}}m("Unable to retrieve mac address (unexpected format)")}catch(I){m(I)}})}}),define(Z[100],te([0,1,35,9,41,30,99]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,C=0;const f=(0,D.networkInterfaces)();for(let E in f){const u=f[E];if(u)for(const{mac:S,internal:g}of u)g||(C+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(i+=1))}this._value=C>0?i/C:0}return this._value}};let P;async function m(){return P||(P=(async()=>await I()||L.generateUuid())()),P}e.getMachineId=m;async function I(){try{const i=await new Promise((f,E)=>{K(["crypto"],f,E)}),C=await(0,k.getMac)();return i.createHash("sha256").update(C,"utf8").digest("hex")}catch(i){T.onUnexpectedError(i);return}}}),define(Z[19],te([0,1,51,35,221,6,40,66,8,4,16,5,30]),function(K,e,D,T,R,L,k,P,m,I,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function u(M,j=E.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===E.UNLINK?g(M):S(M)}async function S(M){try{const j=(0,m.join)((0,T.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(M,j)}catch(q){return g(M)}g(j).catch(q=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function g(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function b(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(M,{recursive:!0})}e.rimrafSync=b;async function y(M,j){return a(await(j?w(M):(0,R.promisify)(D.readdir)(M)))}async function w(M){try{return await(0,R.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const j=[],q=await y(M);for(const x of q){let $=!1,N=!1,W=!1;try{const _=await e.Promises.lstat((0,m.join)(M,x));$=_.isFile(),N=_.isDirectory(),W=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}j.push({name:x,isFile:()=>$,isDirectory:()=>N,isSymbolicLink:()=>W})}return j}function o(M){return a(D.readdirSync(M))}e.readdirSync=o;function a(M){return M.map(j=>typeof j=="string"?I.isMacintosh?(0,P.normalizeNFC)(j):j:(j.name=I.isMacintosh?(0,P.normalizeNFC)(j.name):j.name,j))}async function t(M){const j=await y(M),q=[];for(const x of j)await n.existsDirectory((0,m.join)(M,x))&&q.push(x);return q}function r(M,j=1e3){return new Promise(q=>{let x=!1;const $=setInterval(()=>{x||(x=!0,D.access(M,N=>{x=!1,N&&(clearInterval($),q(void 0))}))},j)})}e.whenDeleted=r;var n;(function(M){async function j($){let N;try{if(N=await e.Promises.lstat($),!N.isSymbolicLink())return{stat:N}}catch(W){}try{return{stat:await e.Promises.stat($),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(I.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw _}throw W}}M.stat=j;async function q($){try{const{stat:N,symbolicLink:W}=await M.stat($);return N.isFile()&&W?.dangling!==!0}catch(N){}return!1}M.existsFile=q;async function x($){try{const{stat:N,symbolicLink:W}=await M.stat($);return N.isDirectory()&&W?.dangling!==!0}catch(N){}return!1}M.existsDirectory=x})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new L.ResourceQueue;function c(M,j,q){return s.queueFor(C.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const x=p(q);return new Promise(($,N)=>h(M,j,x,W=>W?N(W):$()))})}let l=!0;function h(M,j,q,x){if(!l)return D.writeFile(M,j,{mode:q.mode,flag:q.flag},x);D.open(M,q.flag,q.mode,($,N)=>{if($)return x($);D.writeFile(N,j,W=>{if(W)return D.close(N,()=>x(W));D.fdatasync(N,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),l=!1),D.close(N,Y=>x(Y))))})})}function d(M,j,q){const x=p(q);if(!l)return D.writeFileSync(M,j,{mode:x.mode,flag:x.flag});const $=D.openSync(M,x.flag,x.mode);try{D.writeFileSync($,j);try{D.fdatasyncSync($)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{D.closeSync($)}}e.writeFileSync=d;function p(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,j){if(M===j)return;async function q(x){try{const $=await e.Promises.lstat(x);if($.isDirectory()||$.isSymbolicLink())return;await e.Promises.utimes(x,$.atime,new Date)}catch($){}}try{await e.Promises.rename(M,j),await q(j)}catch(x){if(M.toLowerCase()!==j.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await O(M,j,{preserveSymlinks:!1}),await u(M,E.MOVE),await q(j);else throw x}}async function O(M,j,q){return U(M,j,{root:{source:M,target:j},options:q,handledSourcePaths:new Set})}const v=511;async function U(M,j,q){if(q.handledSourcePaths.has(M))return;q.handledSourcePaths.add(M);const{stat:x,symbolicLink:$}=await n.stat(M);if($){if(q.options.preserveSymlinks)try{return await H(M,j,q)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if($.dangling)return}return x.isDirectory()?F(M,j,x.mode&v,q):z(M,j,x.mode&v)}async function F(M,j,q,x){await e.Promises.mkdir(j,{recursive:!0,mode:q});const $=await y(M);for(const N of $)await U((0,m.join)(M,N),(0,m.join)(j,N),x)}async function z(M,j,q){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,q)}async function H(M,j,q){let x=await e.Promises.readlink(M);(0,k.isEqualOrParent)(x,q.root.source,!I.isLinux)&&(x=(0,m.join)(q.root.target,x.substr(q.root.source.length+1))),await e.Promises.symlink(x,j)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return A}get copy(){return O}}}),define(Z[101],te([0,1,51,8,24,19]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const C=(0,T.dirname)(i);if(i===C)return i;const f=((0,T.basename)(i)||i).toLowerCase();try{const u=(0,L.readdirSync)(C).filter(S=>S.toLowerCase()===f);if(u.length===1){const S=k(C);if(S)return(0,T.join)(S,u[0])}else if(u.length>1){const S=u.indexOf(f);if(S>=0){const g=k(C);if(g)return(0,T.join)(g,u[S])}}}catch(E){}return null}e.realcaseSync=k;async function P(i){try{return await L.Promises.realpath(i)}catch(C){const f=I(i);return await L.Promises.access(f,D.constants.R_OK),f}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(C){const f=I(i);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=m;function I(i){return(0,R.rtrim)((0,T.normalize)(i),T.sep)}}),define(Z[69],te([0,1,35,8,19]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:o=!1}={}){return o?I===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=f({useAlternateBitness:o});if(!t)return null;const r=T.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let n=-1,s=null;for(const h of await R.Promises.readdir(r)){let d=-1;if(a){const A=h.indexOf("-");if(A<0)continue;const O=h.substring(0,A);if(!L.test(O)||h.substring(A+1)!=="preview")continue;d=parseInt(O,10)}else{if(!L.test(h))continue;d=parseInt(h,10)}if(d<=n)continue;const p=T.join(r,h,"pwsh.exe");!await R.SymlinkSupport.existsFile(p)||(s=p,n=d)}if(!s)return null;const c=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new C(s,`PowerShell${l}${c}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const s=T.join(a,n,"pwsh.exe");return new C(s,r)}return null}function S(){const o=T.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function g(){const o=T.join(process.env.windir,I===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*b(){let o=await E();o&&(yield o),o=await E({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=S(),o&&(yield o),o=await E({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await E({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=g(),o&&(yield o)}async function*y(){for await(const o of b())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=y;async function w(){for await(const o of y())return o;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Z[102],te([0,1,37,15]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((P,m)=>{let I;const i=new Map;function C(E,u,S,g,b){const y=i.get(u);if(E===k||y){const w={name:f(S),cmd:S,pid:E,ppid:u,load:g,mem:b};i.set(E,w),E===k&&(I=w),y&&(y.children||(y.children=[]),y.children.push(w),y.children.length>1&&(y.children=y.children.sort((o,a)=>o.pid-a.pid)))}}function f(E){const u=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,g=/--crashes-directory/,b=/\\pipe\\winpty-control/,y=/conhost\.exe/,w=/--type=([a-zA-Z-]+)/;if(S.exec(E))return"watcherService ";if(g.exec(E))return"electron-crash-reporter";if(b.exec(E))return"winpty-process";if(y.exec(E))return"console-window-host (Windows internal process)";let o=w.exec(E);if(o&&o.length===2)return o[1]==="renderer"?u.exec(E)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(E),o&&(t+=o+" ");while(o);return t&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${t}`:E}if(process.platform==="win32"){const E=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,S)=>{K(["windows-process-tree"],u,S)}).then(u=>{u.getProcessList(k,S=>{u.getProcessCpuUsage(S,g=>{const b=new Map;g.forEach(y=>{const w=E(y.commandLine||"");b.set(y.pid,{name:f(w),cmd:w,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),I=b.get(k),I?(b.forEach(y=>{const w=b.get(y.ppid);w&&(w.children||(w.children=[]),w.children.push(y))}),b.forEach(y=>{y.children&&(y.children=y.children.sort((w,o)=>w.pid-o.pid))}),P(I)):m(new Error(`Root process ${k} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let E=function(){let u=[I];const S=[];for(;u.length;){const b=u.shift();b&&(S.push(b.pid),b.children&&(u=u.concat(b.children)))}let g=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);g+=" "+S.join(" "),(0,D.exec)(g,{},(b,y,w)=>{if(b||w)m(b||new Error(w.toString()));else{const o=y.toString().split(`
`);for(let a=0;a<S.length;a++){const t=i.get(S[a]);t.load=parseFloat(o[a])}if(!I){m(new Error(`Root process ${k} not found`));return}P(I)}})};(0,D.exec)("which ps",{},(u,S,g)=>{if(u||g)if(process.platform!=="linux")m(u||new Error(g.toString()));else{const b=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(b,{},(y,w,o)=>{y||o?m(y||new Error(o.toString())):(L(w,C),E())})}else{const b=S.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${b} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,o,a)=>{w||a&&!a.includes("screen size is bogus")?m(w||new Error(a.toString())):(L(o,C),process.platform==="linux"?E():I?P(I):m(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function L(k,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=k.toString().split(`
`);for(const i of I){const C=m.exec(i.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[103],te([0,1,51,27,40,2,66,8,4,19]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(u,S,g){return f({path:u,isDirectory:!1},S,g)}e.watchFile=i;function C(u,S,g){return f({path:u,isDirectory:!0},S,g)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function f(u,S,g){if(m.isMacintosh&&(0,R.isEqualOrParent)(u.path,"/Volumes/"))return g(`Refusing to watch ${u.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const b=(0,P.basename)(u.path),y=new Map;let w=!1,o=[(0,L.toDisposable)(()=>{y.forEach(a=>(0,L.dispose)(a)),y.clear()})];try{const a=(0,D.watch)(u.path);o.push((0,L.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;u.isDirectory&&I.Promises.readdir(u.path).then(r=>r.forEach(n=>t.add(n))),a.on("error",(r,n)=>{w||g(`Failed to watch ${u.path} for changes using fs.watch() (${r}, ${n})`)}),a.on("change",(r,n)=>{if(w)return;let s="";if(n&&(s=n.toString(),m.isMacintosh&&(s=(0,k.normalizeNFC)(s))),!s||r!=="change"&&r!=="rename")return;const c=u.isDirectory?(0,P.join)(u.path,s):u.path;if(u.isDirectory)if(r==="rename"){const l=y.get(c);l&&(0,L.dispose)(l);const h=setTimeout(async()=>{y.delete(c);const d=await I.Promises.exists(c);if(w)return;let p;d?t.has(s)?p="changed":(p="added",t.add(s)):(t.delete(s),p="deleted"),S(p,c)},e.CHANGE_BUFFER_DELAY);y.set(c,(0,L.toDisposable)(()=>clearTimeout(h)))}else{let l;t.has(s)?l="changed":(l="added",t.add(s)),S(l,c)}else if(r==="rename"||s!==b){const l=setTimeout(async()=>{const h=await I.Promises.exists(c);w||(h?(S("changed",c),o=[f(u,S,g)]):S("deleted",c))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(o),o=[(0,L.toDisposable)(()=>clearTimeout(l))]}else S("changed",c)})}catch(a){I.Promises.exists(u.path).then(t=>{t&&!w&&g(`Failed to watch ${u.path} for changes using fs.watch() (${a.toString()})`)})}return(0,L.toDisposable)(()=>{w=!0,o=(0,L.dispose)(o)})}async function E(u,S,g,b=512){const y=await I.Promises.open(u,"r"),w=Buffer.allocUnsafe(b),o=new T.CancellationTokenSource(g);let a,t=!1;const r=i(u,async n=>{if(n==="changed"){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:s}=await I.Promises.read(y,w,0,b,null);if(!s||o.token.isCancellationRequested)break;S(w.slice(0,s))}}catch(s){a=new Error(s),o.dispose(!0)}finally{t=!1}}},n=>{a=new Error(n),o.dispose(!0)});return new Promise((n,s)=>{o.token.onCancellationRequested(async()=>{r.dispose(),await I.Promises.close(y),a?s(a):n()})})}e.watchFileContents=E});var fe=this&&this.__decorate||function(K,e,D,T){var R=arguments.length,L=R<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,D,T);else for(var P=K.length-1;P>=0;P--)(k=K[P])&&(L=(R<3?k(L):R>3?k(e,D,L):k(e,D))||L);return R>3&&L&&Object.defineProperty(e,D,L),L};define(Z[36],te([0,1,17,6,25,27,64,9,3,2,95,24,18]),function(K,e,D,T,R,L,k,P,m,I,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function u($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function g($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(b||(b={}));class y{constructor(N){this.buffer=N,this.pos=0}read(N){const W=this.buffer.slice(this.pos,this.pos+N);return this.pos+=W.byteLength,W}}class w{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(o||(o={}));function a($){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE($,0),N}function t($){return $.read(4).readUInt32BE(0)}function r($){const N=R.VSBuffer.alloc(1);return N.writeUInt8($,0),N}const n={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},s=typeof Buffer!="undefined";function c($,N){if(typeof N=="undefined")$.write(n.Undefined);else if(typeof N=="string"){const W=R.VSBuffer.fromString(N);$.write(n.String),$.write(a(W.byteLength)),$.write(W)}else if(s&&Buffer.isBuffer(N)){const W=R.VSBuffer.wrap(N);$.write(n.Buffer),$.write(a(W.byteLength)),$.write(W)}else if(N instanceof R.VSBuffer)$.write(n.VSBuffer),$.write(a(N.byteLength)),$.write(N);else if(Array.isArray(N)){$.write(n.Array),$.write(a(N.length));for(const W of N)c($,W)}else{const W=R.VSBuffer.fromString(JSON.stringify(N));$.write(n.Object),$.write(a(W.byteLength)),$.write(W)}}function l($){switch($.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return $.read(t($)).toString();case o.Buffer:return $.read(t($)).buffer;case o.VSBuffer:return $.read(t($));case o.Array:{const W=t($),_=[];for(let Y=0;Y<W;Y++)_.push(l($));return _}case o.Object:return JSON.parse($.read(t($)).toString())}}class h{constructor(N,W,_=null,Y=1e3){this.protocol=N,this.ctx=W,this.logger=_,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(N,W){this.channels.set(N,W),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const W=this.send([N.type]);this.logger&&this.logger.logOutgoing(W,0,1,g(N.type));return}case 201:case 202:case 204:case 203:{const W=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(W,N.id,1,g(N.type),N.data);return}}}send(N,W=void 0){const _=new w;return c(_,N),c(_,W),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onRawMessage(N){const W=new y(N),_=l(W),Y=l(W),G=_[0];switch(G){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onPromise({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onEventListen({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]})}}onPromise(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const _=new L.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,N.name,N.arg,_.token)}catch(ee){Y=Promise.reject(ee)}const G=N.id;Y.then(ee=>{this.sendResponse({id:G,data:ee,type:201}),this.activeRequests.delete(N.id)},ee=>{ee instanceof Error?this.sendResponse({id:G,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.sendResponse({id:G,data:ee,type:203}),this.activeRequests.delete(N.id)});const ne=(0,I.toDisposable)(()=>_.cancel());this.activeRequests.set(N.id,ne)}onEventListen(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const _=N.id,G=W.listen(this.ctx,N.name,N.arg)(ne=>this.sendResponse({id:_,data:ne,type:204}));this.activeRequests.set(N.id,G)}disposeActiveRequest(N){const W=this.activeRequests.get(N.id);W&&(W.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let W=this.pendingRequests.get(N.channelName);W||(W=[],this.pendingRequests.set(N.channelName,W));const _=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:N,timeoutTimer:_})}flushPendingRequests(N){const W=this.pendingRequests.get(N);if(W){for(const _ of W)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var d;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(N,W=null){this.protocol=N,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=W}getChannel(N){const W=this;return{call(_,Y,G){return W.isDisposed?Promise.reject(P.canceled()):W.requestPromise(N,_,Y,G)},listen(_,Y){return W.isDisposed?Promise.reject(P.canceled()):W.requestEvent(N,_,Y)}}}requestPromise(N,W,_,Y=L.CancellationToken.None){const G=this.lastRequestId++,ee={id:G,type:100,channelName:N,name:W,arg:_};if(Y.isCancellationRequested)return Promise.reject(P.canceled());let X;return new Promise((re,ie)=>{if(Y.isCancellationRequested)return ie(P.canceled());const ce=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(G),re(Pe.data);break;case 202:this.handlers.delete(G);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,ie(Ee);break;case 203:this.handlers.delete(G),ie(Pe.data);break}};this.handlers.set(G,Ie),this.sendRequest(ee)};let ue=null;this.state===b.Idle?ce():(ue=(0,T.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ce()}));const ge=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:G,type:101}),ie(P.canceled())},de=Y.onCancellationRequested(ge);X=(0,I.combinedDisposable)((0,I.toDisposable)(ge),de),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(N,W,_){const Y=this.lastRequestId++,ne={id:Y,type:102,channelName:N,name:W,arg:_};let ee=null;const X=new m.Emitter({onFirstListenerAdd:()=>{ee=(0,T.createCancelablePromise)(re=>this.whenInitialized()),ee.then(()=>{ee=null,this.activeRequests.add(X),this.sendRequest(ne)})},onLastListenerRemove:()=>{ee?(ee.cancel(),ee=null):(this.activeRequests.delete(X),this.sendRequest({id:Y,type:103}))}}),B=re=>X.fire(re.data);return this.handlers.set(Y,B),X.event}sendRequest(N){switch(N.type){case 100:case 102:{const W=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(W,N.id,0,`${u(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const W=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(W,N.id,0,u(N.type));return}}}send(N,W=void 0){const _=new w;return c(_,N),c(_,W),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onBuffer(N){const W=new y(N),_=l(W),Y=l(W),G=_[0];switch(G){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,g(G)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],0,g(G),Y),this.onResponse({type:_[0],id:_[1],data:Y})}}onResponse(N){if(N.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(N.id);W&&W(N)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}fe([k.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class A{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:W,onDidClientDisconnect:_})=>{m.Event.once(W.onMessage)(G=>{const ne=new y(G),ee=l(ne),X=new h(W,ee),B=new p(W);this.channels.forEach((ie,ce)=>X.registerChannel(ce,ie));const re={channelServer:X,channelClient:B,ctx:ee};this._connections.add(re),this._onDidAddConnection.fire(re),_(()=>{X.dispose(),B.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const N=[];return this._connections.forEach(W=>N.push(W)),N}getChannel(N,W){const _=this;return{call(Y,G,ne){let ee;if((0,f.isFunction)(W)){let B=(0,D.getRandomElement)(_.connections.filter(W));ee=B?Promise.resolve(B):m.Event.toPromise(m.Event.filter(_.onDidAddConnection,W))}else ee=W.routeCall(_,Y,G);const X=ee.then(B=>B.channelClient.getChannel(N));return v(X).call(Y,G,ne)},listen(Y,G){if((0,f.isFunction)(W))return _.getMulticastEvent(N,W,Y,G);const ne=W.routeEvent(_,Y,G).then(ee=>ee.channelClient.getChannel(N));return v(ne).listen(Y,G)}}}getMulticastEvent(N,W,_,Y){const G=this;let ne=new I.DisposableStore;const ee=new m.Emitter({onFirstListenerAdd:()=>{ne=new I.DisposableStore;const X=new m.EventMultiplexer,B=new Map,re=ce=>{const ge=ce.channelClient.getChannel(N).listen(_,Y),de=X.add(ge);B.set(ce,de)},ie=ce=>{const ue=B.get(ce);!ue||(ue.dispose(),B.delete(ce))};G.connections.filter(W).forEach(re),m.Event.filter(G.onDidAddConnection,W)(re,void 0,ne),G.onDidRemoveConnection(ie,void 0,ne),X.event(ee.fire,ee,ne),ne.add(X)},onLastListenerRemove:()=>{ne.dispose()}});return ee.event}registerChannel(N,W){this.channels.set(N,W),this._connections.forEach(_=>{_.channelServer.registerChannel(N,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(N,W,_=null){const Y=new w;c(Y,W),N.send(Y.buffer),this.channelClient=new p(N,_),this.channelServer=new h(N,W,_)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,W){this.channelServer.registerChannel(N,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function v($){return{call(N,W,_){return $.then(Y=>Y.call(N,W,_))},listen(N,W){const _=new m.Relay;return $.then(Y=>_.input=Y.listen(N,W)),_.event}}}e.getDelayedChannel=v;function U($){let N=!1;return{call(W,_,Y){return N?$.call(W,_,Y):(0,T.timeout)(0).then(()=>N=!0).then(()=>$.call(W,_,Y))},listen(W,_){if(N)return $.listen(W,_);const Y=new m.Relay;return(0,T.timeout)(0).then(()=>N=!0).then(()=>Y.input=$.listen(W,_)),Y.event}}}e.getNextTickChannel=U;class F{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const W of N.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await m.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=F;var z;(function($){function N(G,ne){const ee=G,X=ne&&ne.disableMarshalling,B=new Map;for(const re in ee)_(re)&&B.set(re,m.Event.buffer(ee[re],!0));return new class{listen(re,ie,ce){const ue=B.get(ie);if(ue)return ue;if(Y(ie)){const ge=ee[ie];if(typeof ge=="function")return ge.call(ee,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const ue=ee[ie];if(typeof ue=="function"){if(!X&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,i.revive)(ce[ge]);return ue.apply(ee,ce)}throw new Error(`Method not found: ${ie}`)}}}$.fromService=N;function W(G,ne){const ee=ne&&ne.disableMarshalling;return new Proxy({},{get(X,B){if(typeof B=="string")return ne?.properties?.has(B)?ne.properties.get(B):Y(B)?function(re){return G.listen(B,re)}:_(B)?G.listen(B):async function(...re){let ie;ne&&!(0,f.isUndefinedOrNull)(ne.context)?ie=[ne.context,...re]:ie=re;const ce=await G.call(B,ie);return ee?ce:(0,i.revive)(ce)};throw new Error(`Property not found: ${String(B)}`)}})}$.toService=W;function _(G){return G[0]==="o"&&G[1]==="n"&&C.isUpperAsciiLetter(G.charCodeAt(2))}function Y(G){return/^onScoped/.test(G)&&C.isUpperAsciiLetter(G.charCodeAt(8))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let N=$.toString();if(N!=="[object Object]")return N}return $}function j($){return Array.isArray($)?$.map(M):M($)}function q($,N,W,_,Y,G,ne){ne=j(ne);const ee=H[Y],X=ee[_%ee.length];let B=[`%c[${$}]%c[${String(N).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(G)?(B=B.concat(ne),B.push(")")):B.push(ne),console.log.apply(console,B)}e.logWithColors=q;class x{constructor(N,W){this._outgoingPrefix=N,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,W,_,Y,G){this._totalOutgoing+=N,q(this._outgoingPrefix,this._totalOutgoing,N,W,_,Y,G)}logIncoming(N,W,_,Y,G){this._totalIncoming+=N,q(this._incomingPrefix,this._totalIncoming,N,W,_,Y,G)}}e.IPCLogger=x}),define(Z[104],te([0,1,25,3,36]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(m){this.port=m,this.onMessage=T.Event.fromDOMEventEmitter(this.port,"message",I=>D.VSBuffer.wrap(I.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class k extends R.IPCClient{constructor(m,I){const i=new L(m);super(i,I);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Z[105],te([0,1,106,3,36,104]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const m=T.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(I,i)=>i);return T.Event.map(m,I=>{const{port1:i,port2:C}=new MessageChannel,E={protocol:new L.Protocol(i),onDidClientDisconnect:T.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[C]),E})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(Z[107],te([0,1,25,9]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((i,C)=>{I.open(P.type||"GET",P.url||"",!0,P.user,P.password),L(I,P),I.responseType="arraybuffer",I.onerror=f=>C(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=f=>{i({res:{statusCode:I.status,headers:k(I)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=f=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(I.timeout=P.timeout),I.send(P.data),m.onCancellationRequested(()=>{I.abort(),C((0,T.canceled)())})})}e.request=R;function L(P,m){if(m.headers){e:for(let I in m.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(I,m.headers[I])}}}function k(P){const m=Object.create(null);for(const I of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const i=I.indexOf(":");m[I.substr(0,i).trim().toLowerCase()]=I.substr(i+1).trim()}return m}}),define(Z[70],te([0,1,6,3,2,18]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(m||(m={}));class I extends R.Disposable{constructor(f,E=Object.create(null)){super();this.database=f,this.options=E,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((E,u)=>this.accept(u,E)),f.deleted?.forEach(E=>this.accept(E,void 0))}accept(f,E){if(this.state===m.Closed)return;let u=!1;(0,L.isUndefinedOrNull)(E)?u=this.cache.delete(f):this.cache.get(f)!==E&&(this.cache.set(f,E),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,E){const u=this.cache.get(f);return(0,L.isUndefinedOrNull)(u)?E:u}getBoolean(f,E){const u=this.get(f);return(0,L.isUndefinedOrNull)(u)?E:u==="true"}getNumber(f,E){const u=this.get(f);return(0,L.isUndefinedOrNull)(u)?E:parseInt(u,10)}async set(f,E){if(this.state===m.Closed)return;if((0,L.isUndefinedOrNull)(E))return this.delete(f);const u=String(E);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===m.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((E,u)=>this.items.set(u,E)),f.delete&&f.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[108],te([10,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],te([0,1,108]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,R=T*60,L=R*24,k=L*7,P=L*30,m=L*365;function I(C,f){typeof C!="number"&&(C=C.getTime());const E=Math.round((new Date().getTime()-C)/1e3);if(E<-30)return(0,D.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,D.localize)(1,null);let u;return E<T?(u=E,f?u===1?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):u===1?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u)):E<R?(u=Math.floor(E/T),f?u===1?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):u===1?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):E<L?(u=Math.floor(E/R),f?u===1?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):u===1?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u)):E<k?(u=Math.floor(E/L),f?u===1?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):u===1?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):E<P?(u=Math.floor(E/k),f?u===1?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):u===1?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u)):E<m?(u=Math.floor(E/P),f?u===1?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):u===1?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):(u=Math.floor(E/m),f?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u))}e.fromNow=I;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[109],te([10,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[38],te([0,1,17,18,109]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(I,i){return i&&(I.stack||I.stacktrace)?R.localize(0,null,P(I),k(I.stack)||k(I.stacktrace)):P(I)}function k(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function m(I=null,i=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const C=D.coalesce(I),f=m(C[0],i);return C.length>1?R.localize(4,null,f,C.length):f}if(T.isString(I))return I;if(I.detail){const C=I.detail;if(C.error)return L(C.error,i);if(C.exception)return L(C.exception,i)}return I.stack?L(I,i):I.message?I.message:R.localize(5,null)}e.toErrorMessage=m}),define(Z[110],te([10,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],te([0,1,37,40,15,26,8,4,31,18,68,19,110]),function(K,e,D,T,R,L,k,P,m,I,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function E(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{r.once("error",s=>{n({success:!1,error:s})}),r.once("exit",(s,c)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?E(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,c)=>{r(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function S(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=S;class g{constructor(a,t,r,n){if(t!==void 0&&r!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=n;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(m.env).forEach(c=>{s[c]=m.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(k.sep);return t!==-1&&(a=a.substring(t+1)),g.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(m.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(t=>{let r,n;const s=new Promise((c,l)=>{r=c,n=l});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(l,h,d)=>{this.childProcess=null;const p=l;p&&p.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:d.toString()}):this.handleExec(r,a,l,h,d)})}else{let c=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,a,n);const d={terminated:this.terminateRequested};I.isNumber(h)&&(d.cmdCode=h),r(d)};if(this.shell&&P.isWindows){const h=L.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let d=!1,p=!1;const A=[];let O=this.ensureQuotes(this.cmd);A.push(O.value),d=O.quoted,this.args&&this.args.forEach(U=>{O=this.ensureQuotes(U),A.push(O.value),p=p&&O.quoted});const v=["/s","/c"];d?p?v.push('"'+A.join(" ")+'"'):A.length>1?v.push('"'+A[0]+'" '+A.slice(1).join(" ")):v.push('"'+A[0]+'"'):v.push(A.join(" ")),c=D.spawn(S(),v,h)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(I.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,r,a,n,!0)))}return s})}handleClose(a,t,r,n){}ensureQuotes(a){return g.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(S(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class b extends g{constructor(a,t,r,n){super(a,t,r,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,n,s){[n,s].forEach((c,l)=>{const h=new i.LineDecoder;h.write(c).forEach(A=>{t({line:A,source:l===0?0:1})});const p=h.end();p&&t({line:p,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,n,s){const c=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",h=>{c.write(h).forEach(p=>r({line:p,source:0}))}),a.stderr.on("data",h=>{l.write(h).forEach(p=>r({line:p,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(a,t,r,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=b;function y(o){let a=[],t=!1;const r=function(n){if(t){a.push(n);return}(!o.send(n,c=>{if(c&&console.error(c),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(h=>r(h))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=y;var w;(function(o){async function a(t,r,n){if(k.isAbsolute(t))return t;if(r===void 0&&(r=m.cwd()),k.dirname(t)!=="."||(n===void 0&&I.isString(m.env.PATH)&&(n=m.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(r,t);async function c(l){if(await C.Promises.exists(l)){let h;try{h=await C.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(h=await C.Promises.lstat(l))}return h?!h.isDirectory():!1}return!1}for(let l of n){let h;if(k.isAbsolute(l)?h=k.join(l,t):h=k.join(r,l,t),await c(h))return h;let d=h+".com";if(await c(d)||(d=h+".exe",await c(d)))return d}return k.join(r,t)}o.findExecutable=a})(w=e.win32||(e.win32={}))}),define(Z[111],te([0,1,35,4,69,71]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(E,u){return E===1?T.isWindows?C():L.getWindowsShell(u):I(E,u)}e.getSystemShell=k;function P(E,u){return E===1?T.isWindows?f(u):L.getWindowsShell(u):I(E,u)}e.getSystemShellSync=P;let m=null;function I(E,u){if(T.isLinux&&E===2||T.isMacintosh&&E===3)return"/bin/bash";if(!m){let S;if(T.isWindows)S="/bin/bash";else{if(S=u.SHELL,!S)try{S=(0,D.userInfo)().shell}catch(g){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}m=S}return m}let i=null;async function C(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function f(E){if(i)return i;const u=T.isWindows&&parseFloat((0,D.release)())>=10,S=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${E.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?g:L.getWindowsShell(E)}}),define(Z[52],te([0,1,37,6,25,27,94,9,3,2,26,4,71,36]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends E.ChannelServer{constructor(b){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(w){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",y=>R.VSBuffer.wrap(Buffer.from(y,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=u;class S{constructor(b,y){this.modulePath=b,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new T.Delayer(w),this.child=null,this._client=null}getChannel(b){const y=this;return{call(w,o,a){return y.requestPromise(b,w,o,a)},listen(w,o){return y.requestEvent(b,w,o)}}}requestPromise(b,y,w,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=(0,T.createCancelablePromise)(s=>a.call(y,w,s)),r=o.onCancellationRequested(()=>t.cancel()),n=(0,I.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,y,w){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const a=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(b).listen(y,w)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,b,y);const w=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,k.isRemoteConsoleLog)(c)){(0,k.log)(c,`IPC Library: ${this.options.serverName}`);return}w.fire(R.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),r=w.event,n={send:t,onMessage:r};this._client=new E.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(h=>(0,I.dispose)(h)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(b){let y=this.channels.get(b);return y||(y=this.client.getChannel(b),this.channels.set(b,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(Z[112],te([10,11]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[113],te([10,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[114],te([10,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[115],te([10,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[116],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[117],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[118],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[119],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[120],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[121],te([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[122],te([10,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[123],te([10,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[124],te([10,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[125],te([10,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[126],te([10,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[127],te([10,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[128],te([10,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[129],te([10,11]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[130],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[131],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[132],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[133],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[134],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[135],te([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[72],te([0,1,56,64,15,8,31,16,5]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(S,g,b){this._args=S,this.paths=g,this.productService=b}get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=k.env.VSCODE_PORTABLE;return S?m.URI.file((0,L.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const b=k.env.VSCODE_PORTABLE;return b?(0,L.join)(b,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(g=>/^[^:/?#]+?:\/\//.test(g)?m.URI.parse(g):m.URI.file((0,L.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?m.URI.parse(S):m.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([T.memoize],I.prototype,"appRoot",null),fe([T.memoize],I.prototype,"userHome",null),fe([T.memoize],I.prototype,"userDataPath",null),fe([T.memoize],I.prototype,"appSettingsHome",null),fe([T.memoize],I.prototype,"tmpDir",null),fe([T.memoize],I.prototype,"userRoamingDataHome",null),fe([T.memoize],I.prototype,"settingsResource",null),fe([T.memoize],I.prototype,"userDataSyncHome",null),fe([T.memoize],I.prototype,"userDataSyncLogResource",null),fe([T.memoize],I.prototype,"sync",null),fe([T.memoize],I.prototype,"machineSettingsResource",null),fe([T.memoize],I.prototype,"globalStorageHome",null),fe([T.memoize],I.prototype,"workspaceStorageHome",null),fe([T.memoize],I.prototype,"keybindingsResource",null),fe([T.memoize],I.prototype,"keyboardLayoutResource",null),fe([T.memoize],I.prototype,"argvResource",null),fe([T.memoize],I.prototype,"snippetsHome",null),fe([T.memoize],I.prototype,"isExtensionDevelopment",null),fe([T.memoize],I.prototype,"untitledWorkspacesHome",null),fe([T.memoize],I.prototype,"installSourcePath",null),fe([T.memoize],I.prototype,"builtinExtensionsPath",null),fe([T.memoize],I.prototype,"extensionsPath",null),fe([T.memoize],I.prototype,"extensionDevelopmentLocationURI",null),fe([T.memoize],I.prototype,"extensionDevelopmentKind",null),fe([T.memoize],I.prototype,"extensionTestsLocationURI",null),fe([T.memoize],I.prototype,"debugExtensionHost",null),fe([T.memoize],I.prototype,"serviceMachineIdResource",null),fe([T.memoize],I.prototype,"telemetryLogResource",null),fe([T.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function i(u,S){return E(u["inspect-extensions"],u["inspect-brk-extensions"],5870,S,u.debugId)}e.parseExtensionHostPort=i;function C(u,S){return E(u["inspect-search"],u["inspect-brk-search"],5876,S)}e.parseSearchPort=C;function f(u,S){return E(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,S)}e.parsePtyHostPort=f;function E(u,S,g,b,y){const o=Number(S||u)||(b?null:g),a=o?Boolean(!!S):!1;return{port:o,break:a,debugId:y}}}),define(Z[136],te([0,1,222,4,114]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,S,g=k){const b={},y=[],w=[];for(let r in S){const n=S[r];n.alias&&(b[r]=n.alias),n.type==="string"||n.type==="string[]"?(y.push(r),n.deprecates&&y.push(n.deprecates)):n.type==="boolean"&&(w.push(r),n.deprecates&&w.push(n.deprecates))}const o=D(u,{string:y,boolean:w,alias:b}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in S){const n=S[r];n.alias&&delete t[n.alias];let s=t[r];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(s||(s=t[n.deprecates]),delete t[n.deprecates]),typeof s!="undefined"&&(n.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):n.type==="string"&&Array.isArray(s)&&(s=s.pop(),g.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)g.onUnknownOption(r);return a}e.parseArgs=P;function m(u,S){let g="";return S.args&&(Array.isArray(S.args)?g=` <${S.args.join("> <")}>`:g=` <${S.args}>`),S.alias?`-${S.alias} --${u}${g}`:`--${u}${g}`}function I(u,S){let g=0,b=[];for(const a in u){const t=u[a],r=m(a,t);g=Math.max(g,r.length),b.push([r,t.description])}let y=g+2+1;if(S-y<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let w=S-y-1,o=[];for(const a of b){let t=a[0],r=C(a[1],w),n=i(y-t.length-2);o.push("  "+t+n+r[0]);for(let s=1;s<r.length;s++)o.push(i(y)+r[s])}return o}e.formatOptions=I;function i(u){return" ".repeat(u)}function C(u,S){let g=[];for(;u.length;){let b=u.length<S?u.length:u.lastIndexOf(" ",S),y=u.slice(0,b).trim();u=u.slice(b),g.push(y)}return g}function f(u,S,g,b,y=!0){const w=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${g}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${S} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),y&&(T.isWindows?o.push((0,R.localize)(35,null,S)):o.push((0,R.localize)(36,null,S)),o.push(""));const a={};for(const t in b){const r=b[t];if(r.description&&r.cat){let n=a[r.cat];n||(a[r.cat]=n={}),n[t]=r}}for(let t in a){const r=t;let n=a[r];n&&(o.push(L[r]),o.push(...I(n,w)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=f;function E(u,S){return`${u||(0,R.localize)(37,null)}
${S||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function K(e,D,T,R){function L(P){const m=k(P),I=[m];return e.isAbsolute(m)||I.unshift(R),e.resolve(...I)}function k(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,T);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(C,"AppData","Roaming")}break;case"darwin":I=e.join(D.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,T)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[137],te([0,138,35,15,16,31]),function(e,D,T,R,L,k){const P=L.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return K(D,T,m.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),T=require("os");module.exports=K(D,T,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[139],te([0,1,35,72,137]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends T.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=L}),define(Z[140],te([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(g){const b=g.match(k);return b?b[1]:null}function i(g){if(g.indexOf("://")===-1){const b=g.match(T);return b?I(b[2]):null}try{const b=D.URI.parse(g);if(b.authority)return I(b.authority)}catch(b){}return null}function C(g,b){const y=new Set;let w;for(;w=P.exec(g);){const a=i(w[1]);a&&y.add(a)}const o=new Set(b);return Array.from(y).map(a=>o.has(a)?a:a.replace(m,"a"))}e.getDomainsOfRemotes=C;function f(g){const b=g.match(L);return b?b[2]:null}function E(g,b,y){return g&&b?(y&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${g}${b}`:`${g}/${b}`):null}function u(g,b){if(g.indexOf("://")===-1){const y=g.match(R);if(y)return E(y[2],y[3],b)}try{const y=D.URI.parse(g);if(y.authority)return E(f(y.authority),y.path,b)}catch(y){}return null}function S(g,b=!1){const y=[];let w;for(;w=P.exec(g);){const o=u(w[1],b);o&&y.push(o)}return y}e.getRemotes=S}),define(Z[141],te([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function R(L,k){const P=m=>{if(typeof m!="string")return;const I=T.exec(m);if(!I)return;const i=k[I[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(L,P)}e.localizeManifest=R}),define(Z[142],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,k,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[L,k,P,m])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class T{constructor(L){this.service=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(Z[73],te([0,1,122]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=L;function k(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=f.match(T);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=k;function P(f){if(!f)return null;let E=f.majorBase,u=f.majorMustEqual,S=f.minorBase,g=f.minorMustEqual,b=f.patchBase,y=f.patchMustEqual;f.hasCaret&&(E===0||(g=!1),y=!1);let w=0;if(f.preRelease){const o=R.exec(f.preRelease);if(o){const[,a,t,r]=o;w=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:E,majorMustEqual:u,minorBase:S,minorMustEqual:g,patchBase:b,patchMustEqual:y,isMinimum:f.hasGreaterEquals,notBefore:w}}e.normalizeVersion=P;function m(f,E,u){let S;typeof f=="string"?S=P(k(f)):S=f;let g;E instanceof Date?g=E.getTime():typeof E=="string"&&(g=new Date(E).getTime());let b;if(typeof u=="string"?b=P(k(u)):b=u,!S||!b)return!1;let y=S.majorBase,w=S.minorBase,o=S.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,n=b.notBefore,s=b.majorMustEqual,c=b.minorMustEqual,l=b.patchMustEqual;return b.isMinimum?y>a?!0:y<a?!1:w>t?!0:w<t||g&&g<n?!1:o>=r:(y===1&&a===0&&(!s||!c||!l)&&(a=1,t=0,r=0,s=!0,c=!1,l=!1),y<a?!1:y>a?!s:w<t?!1:w>t?!c:o<r?!1:o>r?!l:!(g&&g<n))}e.isValidVersion=m;function I(f,E,u,S){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,E,u.engines.vscode,S)}e.isValidExtensionVersion=I;function i(f,E,u){return f==="*"||C(E,u,f)}e.isEngineValid=i;function C(f,E,u,S=[]){let g=P(k(u));if(!g)return S.push(D.localize(0,null,u)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return S.push(D.localize(1,null,u)),!1}else if(!g.majorMustEqual)return S.push(D.localize(2,null,u)),!1;return m(f,E,g)?!0:(S.push(D.localize(3,null,f,u)),!1)}}),define(Z[143],te([0,1,2,15,36,52]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,I,i,C){super();this.folders=m,this.onDidFilesChange=I,this.onLogMessage=i,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new L.Client(T.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[144],te([0,1,2,15,36,52]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,I,i,C,f={}){super();this.folders=m,this.onDidFilesChange=I,this.onLogMessage=i,this.verboseLogging=C,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new L.Client(T.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[145],te([0,1,37,67,15,68]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(m,I,i,C,f){this.watchedFolder=m,this.eventCallback=i,this.logCallback=C,this.verboseLogging=f,this.restartCounter=0,Array.isArray(I)?this.ignored=I.map(E=>(0,T.parse)(E)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${I.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const I=new L.LineDecoder;this.handle.stdout.on("data",i=>{const C=[];for(const f of I.write(i)){const E=f.split("|");if(E.length===2){const u=Number(E[0]),S=E[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(g=>g(S))){this.verboseLogging&&this.log(S);continue}C.push({type:k.changeTypeMap[u],path:S})}else this.log(E[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,C)=>this.onExit(i,C))}onError(m){this.error("process error: "+m.toString())}onExit(m,I){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${I})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Z[146],te([0,1,8,24,145]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L{constructor(P,m,I,i){this.onDidFilesChange=m,this.onLogMessage=I,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,T.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=L}),define(Z[53],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,L=[],k=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(Z[147],te([0,1,53]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function R(k,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),T.push([k,P])}e.registerSingleton=R;function L(){return T}e.getSingletonServiceDescriptors=L}),define(Z[148],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=D;class T{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let k of this._nodes.values())k.outgoing.size===0&&L.push(k);return L}insertEdge(L,k){const P=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),m),m.incoming.set(this._hashFn(L),P)}removeNode(L){const k=this._hashFn(L);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(L){const k=this._hashFn(L);let P=this._nodes.get(k);return P||(P=new D(L),this._nodes.set(k,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[k,P]of this._nodes)L.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,k]of this._nodes){const P=new Set([L]),m=this._findCycle(k,P);if(m)return m}}_findCycle(L,k){for(let[P,m]of L.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const I=this._findCycle(m,k);if(I)return I;k.delete(P)}}}e.Graph=T}),define(Z[7],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(I){return I[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function T(P,m,I,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:I,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:I,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(I,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,I,C,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function L(P){return P}e.refineServiceDecorator=L;function k(P){return function(m,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(P,m,i,!0)}}e.optional=k}),define(Z[149],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(Z[150],te([0,1,4,24,7]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",L.indexOf("Edg/")>=0),k.set("isFirefox",L.indexOf("Firefox")>=0),k.set("isChrome",L.indexOf("Chrome")>=0),k.set("isSafari",L.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(v){return E.create(v)}static equals(v,U){return u.create(v,U)}static notEquals(v,U){return b.create(v,U)}static regex(v,U){return r.create(v,U)}static in(v,U){return S.create(v,U)}static not(v){return y.create(v)}static and(...v){return s.create(v,null)}static or(...v){return c.create(v,null,!0)}static greater(v,U){return w.create(v,U)}static less(v,U){return a.create(v,U)}static deserialize(v,U=!1){if(!!v)return this._deserializeOrExpression(v,U)}static _deserializeOrExpression(v,U){let F=v.split("||");return c.create(F.map(z=>this._deserializeAndExpression(z,U)),null,!0)}static _deserializeAndExpression(v,U){let F=v.split("&&");return s.create(F.map(z=>this._deserializeOne(z,U)),null)}static _deserializeOne(v,U){if(v=v.trim(),v.indexOf("!=")>=0){let F=v.split("!=");return b.create(F[0].trim(),this._deserializeValue(F[1],U))}if(v.indexOf("==")>=0){let F=v.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],U))}if(v.indexOf("=~")>=0){let F=v.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(v.indexOf(" in ")>=0){let F=v.split(" in ");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const F=v.split(">=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const F=v.split(">");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const F=v.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const F=v.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(v)?y.create(v.substr(1).trim()):E.create(v)}static _deserializeValue(v,U){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let F=/^'([^']*)'$/.exec(v);return F?F[1].trim():v}static _deserializeRegexValue(v,U){if((0,T.isFalsyOrWhitespace)(v)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=v.indexOf("/"),z=v.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let H=v.slice(F+1,z),M=v[z+1]==="i"?"i":"";try{return new RegExp(H,M)}catch(j){if(U)throw new Error(`bad regexp-value '${v}', parse error: ${j}`);return console.warn(`bad regexp-value '${v}', parse error: ${j}`),null}}}e.ContextKeyExpr=I;function i(O,v){return O.cmp(v)}class C{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class E{constructor(v,U){this.key=v,this.negated=U,this.type=2}static create(v,U=null){const F=k.get(v);return typeof F=="boolean"?F?f.INSTANCE:C.INSTANCE:new E(v,U)}cmp(v){return v.type!==this.type?this.type-v.type:h(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class u{constructor(v,U,F){this.key=v,this.value=U,this.negated=F,this.type=4}static create(v,U,F=null){if(typeof U=="boolean")return U?E.create(v,F):y.create(v,F);const z=k.get(v);return typeof z=="boolean"?U===(z?"true":"false")?f.INSTANCE:C.INSTANCE:new u(v,U,F)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class S{constructor(v,U){this.key=v,this.valueKey=U,this.type=10,this.negated=null}static create(v,U){return new S(v,U)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const U=v.getValue(this.valueKey),F=v.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?P.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=S;class g{constructor(v){this._actual=v,this.type=11}static create(v){return new g(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new g(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class b{constructor(v,U,F){this.key=v,this.value=U,this.negated=F,this.type=5}static create(v,U,F=null){if(typeof U=="boolean")return U?y.create(v,F):E.create(v,F);const z=k.get(v);return typeof z=="boolean"?U===(z?"true":"false")?C.INSTANCE:f.INSTANCE:new b(v,U,F)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class y{constructor(v,U){this.key=v,this.negated=U,this.type=3}static create(v,U=null){const F=k.get(v);return typeof F=="boolean"?F?C.INSTANCE:f.INSTANCE:new y(v,U)}cmp(v){return v.type!==this.type?this.type-v.type:h(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class w{constructor(v,U,F){this.key=v,this.value=U,this.negated=F,this.type=12}static create(v,U,F=null){return new w(v,U,F)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=w;class o{constructor(v,U,F){this.key=v,this.value=U,this.negated=F,this.type=13}static create(v,U,F=null){return new o(v,U,F)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(v,U,F){this.key=v,this.value=U,this.negated=F,this.type=14}static create(v,U,F=null){return new a(v,U,F)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(v,U,F){this.key=v,this.value=U,this.negated=F,this.type=15}static create(v,U,F=null){return new t(v,U,F)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(v,U){this.key=v,this.regexp=U,this.type=7,this.negated=null}static create(v,U){return new r(v,U)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const U=this.regexp?this.regexp.source:"",F=v.regexp?v.regexp.source:"";return U<F?-1:U>F?1:0}equals(v){if(v.type===this.type){const U=this.regexp?this.regexp.source:"",F=v.regexp?v.regexp.source:"";return this.key===v.key&&U===F}return!1}evaluate(v){let U=v.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(v){this._actual=v,this.type=8}static create(v){return new n(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new n(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class s{constructor(v,U){this.expr=v,this.negated=U,this.type=6}static create(v,U){return s._normalizeArr(v,U)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=i(this.expr[U],v.expr[U]);if(z!==0)return z}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(v.expr[U]))return!1;return!0}return!1}evaluate(v){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(v))return!1;return!0}static _normalizeArr(v,U){const F=[];let z=!1;for(const H of v)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return C.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&z)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const M=F.pop(),j=F.length===0,q=c.create(H.expr.map(x=>s.create([x,M],null)),null,j);q&&(F.push(q),F.sort(i))}return F.length===1?F[0]:new s(F,U)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let U of this.expr)v.push(...U.keys());return v}map(v){return new s(this.expr.map(U=>U.map(v)),null)}negate(){if(!this.negated){const v=[];for(let U of this.expr)v.push(U.negate());this.negated=c.create(v,this,!0)}return this.negated}}class c{constructor(v,U){this.expr=v,this.negated=U,this.type=9}static create(v,U,F){return c._normalizeArr(v,U,F)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=i(this.expr[U],v.expr[U]);if(z!==0)return z}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(v.expr[U]))return!1;return!0}return!1}evaluate(v){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(v))return!0;return!1}static _normalizeArr(v,U,F){let z=[],H=!1;if(v){for(let M=0,j=v.length;M<j;M++){const q=v[M];if(!!q){if(q.type===0){H=!0;continue}if(q.type===1)return f.INSTANCE;if(q.type===9){z=z.concat(q.expr);continue}z.push(q)}}if(z.length===0&&H)return C.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];if(F){for(let M=0;M<z.length;M++)for(let j=M+1;j<z.length;j++)p(z[M],z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0]}return new c(z,U)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let U of this.expr)v.push(...U.keys());return v}map(v){return new c(this.expr.map(U=>U.map(v)),null)}negate(){if(!this.negated){let v=[];for(let U of this.expr)v.push(U.negate());for(;v.length>1;){const U=v.shift(),F=v.shift(),z=[];for(const M of A(U))for(const j of A(F))z.push(s.create([M,j],null));const H=v.length===0;v.unshift(c.create(z,null,H))}this.negated=v[0]}return this.negated}}class l extends E{constructor(v,U,F){super(v,null);this._defaultValue=U,typeof F=="object"?l._info.push({...F,key:v}):F!==!0&&l._info.push({key:v,description:F,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return u.create(this.key,v)}notEqualsTo(v){return b.create(this.key,v)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,v){return O<v?-1:O>v?1:0}function d(O,v,U,F){return O<U?-1:O>U?1:v<F?-1:v>F?1:0}function p(O,v){if(v.type===6&&O.type!==9&&O.type!==6){for(const z of v.expr)if(O.equals(z))return!0}const U=O.negate(),F=A(U).concat(A(v));F.sort(i);for(let z=0;z<F.length;z++){const M=F[z].negate();for(let j=z+1;j<F.length;j++){const q=F[j];if(M.equals(q))return!0}}return!1}e.implies=p;function A(O){return O.type===9?O.expr:[O]}}),define(Z[74],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function T(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=T}),define(Z[75],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[12],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],te([0,1,15,117,7]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var L;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(L=e.TargetPlatform||(e.TargetPlatform={}));function k(y){switch(y){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function P(y){switch(y){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function m(y,w){switch(y){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=m;function I(y,w){return w==="web"&&!y.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function i(y,w,o){return I(w,o)?!1:y==="undefined"||y==="universal"?!0:y==="unknown"?!1:y===o?!0:C(o).includes(y)}e.isTargetPlatformCompatible=i;function C(y){switch(y){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function f(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=f;var E;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=10]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var u;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var S;(function(y){y.Install="install",y.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var g;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class b extends Error{constructor(w,o){super(w);this.code=o,this.name=o}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(K,e){return function(D,T){e(D,T,K)}};define(Z[151],te([0,1,2,28]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=fe([J(0,T.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[152],te([0,1,3,2,26,5,97,28]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function m(S,g){return L.URI.revive(g?g.transformIncoming(S):S)}function I(S,g){return g?g.transformOutgoingURI(S):S}function i(S,g){g=g||k.DefaultURITransformer;const b=S.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...S,manifest:void 0},g),manifest:b}}function C(S,g){return g?(0,R.cloneAndChange)(S,b=>b instanceof L.URI?g.transformOutgoingURI(b):void 0):S}class f{constructor(g,b){this.service=g,this.getUriTransformer=b,this.onInstallExtension=D.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,b){const y=this.getUriTransformer(g);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,w=>w.map(o=>({...o,local:o.local?C(o.local,y):o.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,b,y){const w=this.getUriTransformer(g);switch(b){case"zip":return this.service.zip(i(y[0],w)).then(o=>I(o,w));case"unzip":return this.service.unzip(m(y[0],w));case"install":return this.service.install(m(y[0],w),y[1]);case"getManifest":return this.service.getManifest(m(y[0],w));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(i(y[0],w),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(y[0],w));case"getInstalled":return this.service.getInstalled(y[0]).then(o=>o.map(a=>C(a,w)));case"updateMetadata":return this.service.updateMetadata(i(y[0],w),y[1]).then(o=>C(o,w));case"updateExtensionScope":return this.service.updateExtensionScope(i(y[0],w),y[1]).then(o=>C(o,w));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class E extends T.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire({identifier:b.identifier,source:this.isUriComponents(b.source)?L.URI.revive(b.source):b.source}))),this._register(this.channel.listen("onDidInstallExtensions")(b=>this._onDidInstallExtensions.fire(b.map(y=>({...y,local:y.local?i(y.local,null):y.local,source:this.isUriComponents(y.source)?L.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const b=await this.getTargetPlatform();return g.allTargetPlatforms.some(y=>(0,P.isTargetPlatformCompatible)(y,g.allTargetPlatforms,b))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(b=>L.URI.revive(b)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,b){return Promise.resolve(this.channel.call("install",[g,b])).then(y=>i(y,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,b){return Promise.resolve(this.channel.call("installFromGallery",[g,b])).then(y=>i(y,null))}uninstall(g,b){return Promise.resolve(this.channel.call("uninstall",[g,b]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(b=>b.map(y=>i(y,null)))}updateMetadata(g,b){return Promise.resolve(this.channel.call("updateMetadata",[g,b])).then(y=>i(y,null))}updateExtensionScope(g,b){return Promise.resolve(this.channel.call("updateExtensionScope",[g,b])).then(y=>i(y,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class u{constructor(g){this.service=g}listen(g,b){throw new Error("Invalid listen")}call(g,b,y){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(Z[76],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var L;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[153],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,D.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[77],te([0,1,24,7]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function L(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,f){if(typeof C=="undefined"||C===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof C=="string"||typeof f=="string"){let E=typeof C=="string"?C:C.value,u=typeof f=="string"?f:f.value;return D.equalsIgnoreCase(E,u)}return C._lower===f._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function I(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[32],te([0,1,24,77]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(u,S){return u.uuid&&S.uuid?u.uuid===S.uuid:u.id===S.id?!0:(0,D.compareIgnoreCase)(u.id,S.id)===0}e.areSameExtensions=R;class L{constructor(S,g){this.version=g,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof L?R(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=L;function k(u,S){return`${u}.${S}`}e.getExtensionId=k;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(u,S){return P(k(u,S))}e.getGalleryExtensionId=m;function I(u,S){const g=[],b=y=>{for(const w of g)if(w.some(o=>R(S(o),S(y))))return w;return null};for(const y of u){const w=b(y);w?w.push(y):g.push([y])}return g}e.groupByExtension=I;function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function f(u){const S=new Set;for(const g of u)g.malicious&&S.add(g.id.id);return S}e.getMaliciousExtensionsSet=f;function E(u,S){const g=[],b=S.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const y=b.shift();if(y&&g.every(w=>!R(w.identifier,{id:y}))){const w=u.filter(o=>R(o.identifier,{id:y}));w.length===1&&(g.push(w[0]),b.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=E}),define(Z[154],te([0,1,2,8,19,77]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(m,I){super();this.environmentService=m,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(I.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[14],te([0,1,41,8,24,18,5,124,7]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function I(M){return M.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=E;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function S(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function g(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=g;var b;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(j,q){super(j);this.code=q}}e.FileSystemProviderError=y;function w(M,j){const q=new y(M.toString(),j);return a(q,j),q}e.createFileSystemProviderError=w;function o(M){return M||w((0,P.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=o;function a(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=a;function t(M){if(!M)return b.Unknown;if(M instanceof y)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return b.Unknown;switch(j[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(j,q,x){this.resource=j,this.operation=q,this.target=x}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(j,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of j)switch(x.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>q)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>q)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>q)),this.deleted.set(x.resource,x);break}}contains(j,...q){return this.doContains(j,{includeChildren:!1},...q)}affects(j,...q){return this.doContains(j,{includeChildren:!0},...q)}doContains(j,q,...x){if(!j)return!1;const $=x.length>0;return!!((!$||x.includes(1))&&(this.added?.get(j)||q.includeChildren&&this.added?.findSuperstr(j))||(!$||x.includes(0))&&(this.updated?.get(j)||q.includeChildren&&this.updated?.findSuperstr(j))||(!$||x.includes(2))&&(this.deleted?.findSubstr(j)||q.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function h(M,j,q){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==T.sep&&(j+=T.sep),q?(0,R.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=h;class d extends Error{constructor(j,q,x){super(j);this.fileOperationResult=q,this.options=x}}e.FileOperationError=d;class p extends d{constructor(j,q,x){super(j,2,x);this.stat=q}}e.NotModifiedSinceFileOperationError=p;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=v;async function U(M,j){if(!j.canHandleResource(k.URI.from({scheme:M.scheme})))return new Promise(q=>{const x=j.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===M.scheme&&$.added&&(x.dispose(),q())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(j){return(0,L.isNumber)(j)||(j=0),j<F.KB?(0,P.localize)(1,null,j.toFixed(0)):j<F.MB?(0,P.localize)(2,null,(j/F.KB).toFixed(2)):j<F.GB?(0,P.localize)(3,null,(j/F.MB).toFixed(2)):j<F.TB?(0,P.localize)(4,null,(j/F.GB).toFixed(2)):(0,P.localize)(5,null,(j/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function H(M){return{maxFileSize:M===0?300*F.MB:16*F.GB,maxHeapSize:M===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=H}),define(Z[155],te([0,1,156,50,14]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,I)=>{const i=(0,D.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,T.listenStream)(C,{onData:f=>i.update(f.buffer),onError:f=>I(f),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};L=fe([J(0,R.IFileService)],L),e.ChecksumService=L}),define(Z[157],te([0,1,223,115,136,14]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(f,E){const u={onUnknownOption:g=>{console.warn((0,T.localize)(0,null,g))},onMultipleValues:(g,b)=>{console.warn((0,T.localize)(1,null,g,b))}},S=(0,R.parseArgs)(f,R.OPTIONS,E?u:void 0);return S.goto&&S._.forEach(g=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,T.localize)(2,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function P(f){const E=f.findIndex(u=>!/^-/.test(u));if(E>-1)return[...f.slice(0,E),...f.slice(E+1)]}function m(f){let[,...E]=f;process.env.VSCODE_DEV&&(E=P(E)||[]);const u=!C(process.env);return k(E,u)}e.parseMainProcessArgv=m;function I(f){const[,,...E]=f;return k(E,!0)}e.parseCLIProcessArgv=I;function i(f,...E){const u=f.indexOf("--");return u===-1?f.push(...E):f.splice(u,0,...E),f}e.addArg=i;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(Z[158],te([0,1,37,138,27,38,9,4,30,111,157]),function(K,e,D,T,R,L,k,P,m,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(u,S,g){return S["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(g)&&!S["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async b=>{const y=new R.CancellationTokenSource,w=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),y.dispose(!0),b({})},1e4);try{const o=await E(u,y.token);b(o)}catch(o){(0,k.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),b({})}finally{clearTimeout(w),y.dispose()}})),f)}e.resolveShellEnv=C;let f;async function E(u,S){const g=new Promise(async(b,y)=>{const w=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",w);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const n=await(0,I.getSystemShell)(P.OS,r);if(u.trace("getUnixShellEnvironment#shell",n),S.isCancellationRequested)return y(k.canceled);const s=T.basename(n);let c,l;/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),c);const h=(0,D.spawn)(n,[...l,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(h.kill(),y(k.canceled))),h.on("error",A=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(A)),b({})});const d=[];h.stdout.on("data",A=>d.push(A));const p=[];h.stderr.on("data",A=>p.push(A)),h.on("close",(A,O)=>{const v=Buffer.concat(d).toString("utf8");u.trace("getUnixShellEnvironment#raw",v);const U=Buffer.concat(p).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),A||O)return y(new Error(`Failed to get environment (code ${A}, signal ${O})`));const F=t.exec(v),z=F?F[1]:"{}";try{const H=JSON.parse(z);w?H.ELECTRON_RUN_AS_NODE=w:delete H.ELECTRON_RUN_AS_NODE,o?H.ELECTRON_NO_ATTACH_CONSOLE=o:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",H),b(H)}catch(H){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(H)),y(H)}})});try{return await g}catch(b){return u.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(b)),{}}}}),define(Z[78],te([0,1,4,5,14]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function L(m){return m.map(I=>({type:I.type,resource:T.URI.file(I.path)}))}e.toFileChanges=L;function k(m){const I=new P;for(const i of m)I.processEvent(i);return I.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(I){const i=this.mapPathToChange.get(I.path);if(i){const C=i.type,f=I.type;C===1&&f===2?(this.mapPathToChange.delete(I.path),this.normalized.splice(this.normalized.indexOf(i),1)):C===2&&f===1?i.type=0:C===1&&f===0||(i.type=f)}else this.normalized.push(I),this.mapPathToChange.set(I.path,I)}normalize(){const I=[],i=[];return this.normalized.filter(C=>C.type!==2?(I.push(C),!1):!0).sort((C,f)=>C.path.length-f.path.length).filter(C=>i.some(f=>(0,R.isParent)(C.path,f,!D.isLinux))?!1:(i.push(C.path),!0)).concat(I)}}}),define(Z[159],te([0,1,6,2,8,101,19,103,78]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends T.Disposable{constructor(C,f,E,u){super();this.path=C,this.onDidFilesChange=f,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:f}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(f)try{E=await(0,L.realpath)(E)}catch(u){if(this.onError(u),f.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(E,(u,S)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(S))})},u=>this.onError(u))):this._register((0,P.watchFile)(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,m.normalizeFileChanges)(f);if(this.verboseLogging)for(const u of E)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I}),define(Z[79],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[L,k]of R)this.set(L,k)}set(R,L){const k=this._entries.get(R);return this._entries.set(R,L),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(Z[160],te([0,1,6,9,53,148,7,79]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class I extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class i{constructor(u=new P.ServiceCollection,S=!1,g){this._activeInstantiations=new Set,this._services=u,this._strict=S,this._parent=g,this._services.set(k.IInstantiationService,this)}createChild(u){return new i(u,this._strict,this)}invokeFunction(u,...S){let g=f.traceInvocation(u),b=!1;try{return u({get:(w,o)=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(w,g);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${w}'`);return a}},...S)}finally{b=!0,g.stop()}}createInstance(u,...S){let g,b;return u instanceof R.SyncDescriptor?(g=f.traceCreation(u.ctor),b=this._createInstance(u.ctor,u.staticArguments.concat(S),g)):(g=f.traceCreation(u),b=this._createInstance(u,S,g)),g.stop(),b}_createInstance(u,S=[],g){let b=k._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),y=[];for(const o of b){let a=this._getOrCreateServiceInstance(o.id,g);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);y.push(a)}let w=b.length>0?b[0].index:S.length;if(S.length!==w){console.warn(`[createInstance] First service dependency of ${u.name} at position ${w+1} conflicts with ${S.length} static arguments`);let o=w-S.length;o>0?S=S.concat(new Array(o)):S=S.slice(0,w)}return new u(...[...S,...y])}_setServiceInstance(u,S){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,S);else if(this._parent)this._parent._setServiceInstance(u,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let S=this._services.get(u);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):S}_getOrCreateServiceInstance(u,S){let g=this._getServiceInstanceOrDescriptor(u);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,S.branch(u,!0)):(S.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,S,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,S,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,S,g){const b=new L.Graph(o=>o.id.toString());let y=0;const w=[{id:u,desc:S,_trace:g}];for(;w.length;){const o=w.pop();if(b.lookupOrInsertNode(o),y++>1e3)throw new I(b);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};b.insertEdge(o,r),w.push(r)}}}for(;;){const o=b.roots();if(o.length===0){if(!b.isEmpty())throw new I(b);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,S,g=[],b,y){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(S,g,b,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,S,g,b,y);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(u,S=[],g,b){if(g){const y=new D.IdleValue(()=>this._createInstance(u,S,b));return new Proxy(Object.create(null),{get(w,o){if(o in w)return w[o];let a=y.value,t=a[o];return typeof t!="function"||(t=t.bind(a),w[o]=t),t},set(w,o,a){return y.value[o]=a,!0}})}else return this._createInstance(u,S,b)}}e.InstantiationService=i;var C;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,S){this.type=u,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return m?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return m?new f(0,u.name):f._None}branch(u,S){let g=new f(2,u.toString());return this._dep.push([u,S,g]),g}stop(){let u=Date.now()-this._start;f._totals+=u;let S=!1;function g(y,w){let o=[],a=new Array(y+1).join("	");for(const[t,r,n]of w._dep)if(r&&n){S=!0,o.push(`${a}CREATES -> ${t}`);let s=g(y+1,n);s&&o.push(s)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||S)&&console.log(b.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(Z[161],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,L){this.server=R,this.router=L}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,L){this.server.registerChannel(R,L)}}e.MessagePortMainProcessService=D}),define(Z[162],te([0,1,36,53,147,7]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(E,u,S){const g=S.getChannel(E);return P(u)?new u.channelClientCtor(g):D.ProxyChannel.toService(g,u?.proxyOptions)}}function P(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let m=class extends k{constructor(E,u,S){super(E,u,S)}};m=fe([J(2,e.IMainProcessService)],m);function I(f,E,u){(0,R.registerSingleton)(f,new T.SyncDescriptor(m,[E,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let i=class extends k{constructor(E,u,S){super(E,u,S)}};i=fe([J(2,e.ISharedProcessService)],i);function C(f,E,u){(0,R.registerSingleton)(f,new T.SyncDescriptor(i,[E,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(Z[57],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function T(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const L of R.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=T}),define(Z[163],te([0,1,2,57]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=fe([J(0,T.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[13],te([0,1,38,3,2,4,7]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class I extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let n=0;n<t.length;n++){let s=t[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}r+=(n>0?" ":"")+s}return r}}e.AbstractMessageLogger=i;class C extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class E extends I{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class u extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const n of this.logServices)n.trace(t,...r)}debug(t,...r){for(const n of this.logServices)n.debug(t,...r)}info(t,...r){for(const n of this.logServices)n.info(t,...r)}warn(t,...r){for(const n of this.logServices)n.warn(t,...r)}error(t,...r){for(const n of this.logServices)n.error(t,...r)}critical(t,...r){for(const n of this.logServices)n.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class S extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=S;class g extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,r?.always?m.Trace:this.logLevel,r),this.loggers.set(t.toString(),n),r?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class b{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function y(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=w(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function w(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=w;function o(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(Z[164],te([0,1,6,9,2,8,19,12,13]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends R.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,L.basename)(this.environmentService.logsPath),f=(0,L.dirname)(this.environmentService.logsPath),S=(await k.Promises.readdir(f)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==C),g=S.slice(0,Math.max(0,S.length-9));g.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(b=>k.Promises.rm((0,L.join)(f,b)))))}catch(C){(0,T.onUnexpectedError)(C)}}};I=fe([J(0,P.IEnvironmentService),J(1,m.ILogService)],I),e.LogsDataCleaner=I}),define(Z[165],te([0,1,6,9,2,8,19,12,13]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class dt extends R.Disposable{constructor(C,f,E){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=E,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(C).emptyWorkspaceInfos.map(S=>S.backupFolder),u=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async S=>{S.length!==dt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(S)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${S}.`),await k.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(C){(0,T.onUnexpectedError)(C)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I=fe([J(1,P.INativeEnvironmentService),J(2,m.ILogService)],I),e.StorageDataCleaner=I}),define(Z[166],te([0,1,6,9,2,4,16,58,5,30,19,12,28,32,14,13]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends R.Disposable{constructor(w,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=m.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,o){await this.cleanUpPromise;const a=this.getName(w),t=(0,k.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(w,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",w.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return t}async delete(w){}async rename(w,o,a){try{await i.Promises.rename(w.fsPath,o.fsPath)}catch(t){if(L.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${w} to ${o} with 'EPERM' error. Trying again...`),this.rename(w,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const o=[],a=[];for(const n of w.children){const s=this.parse(n.name);s&&a.push([s,n])}const t=(0,E.groupByExtension)(a,([n])=>n),r=[];for(const n of t)n.sort((s,c)=>P.rcompare(s[0].version,c[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),r.push(n[0][1]);r.sort((n,s)=>n.mtime-s.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?`${new E.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase()}${w.properties.targetPlatform!=="undefined"?`-${w.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(w){const o=g.exec(w);return o&&o[1]&&o[2]?new E.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};b=fe([J(0,C.INativeEnvironmentService),J(1,u.IFileService),J(2,f.IExtensionGalleryService),J(3,S.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[167],te([0,1,37,6,38,3,2,15,8,19,12,13]),function(K,e,D,T,R,L,k,P,m,I,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends k.Disposable{constructor(u,S){super();this.environmentService=u,this.logService=S,this.processesLimiter=new T.Limiter(5)}async postUninstall(u){const S=this.parseScript(u,"uninstall");return S&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${g}`)))),I.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(u,S){const g=`vscode:${S}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[g]=="string"){const b=u.manifest.scripts[g].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${g} should be a node script`),null):{script:(0,m.join)(u.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(u,S,g,b,y){return new Promise((w,o)=>{const a=this.start(u,S,g,y);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?o(n):w(void 0)};a.on("error",n=>{r((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,s)=>{r(n?`post-${S} process exited with code ${n}`:void 0)}),b&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,S,g,b){const y={silent:!0,execArgv:void 0},w=(0,D.fork)(u,[`--type=extension-post-${S}`,...g],y);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const o=L.Event.fromNodeEventEmitter(w.stdout,"data"),a=L.Event.fromNodeEventEmitter(w.stderr,"data");o(n=>this.logService.info(b.identifier.id,b.manifest.version,`post-${S}`,n)),a(n=>this.logService.error(b.identifier.id,b.manifest.version,`post-${S}`,n));const t=L.Event.any(L.Event.map(o,n=>({data:`%c${n}`,format:[""]})),L.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(b.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),w}getExtensionStoragePath(u){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=fe([J(0,i.IEnvironmentService),J(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(Z[168],te([0,1,3,2,16,5,12,32,14,13]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends T.Disposable{constructor(f,E,u,S){super();this.extensionsManagementService=f,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(y=>this.onInstallExtension(y))),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const g=L.URI.file(u.extensionsPath),b=new R.ExtUri(y=>!E.hasCapability(y,1024));this._register(E.watch(g)),this._register(D.Event.filter(E.onDidChangeFilesRaw,y=>y.changes.some(w=>this.doesChangeAffects(w,g,b)))(()=>this.onDidChange()))}doesChangeAffects(f,E,u){return u.isEqual(u.dirname(f.resource),E)?u.isEqual(f.resource,u.joinPath(E,".obsolete"))?!0:!(f.type!==1&&f.type!==2||u.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const E of f)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(E=>!(0,P.areSameExtensions)(E,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,P.areSameExtensions)(E,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),E=f.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,P.areSameExtensions)(g,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),u=this.installedExtensions.filter(S=>this.installingExtensions.some(g=>(0,P.areSameExtensions)(g,S))?!1:f.every(g=>!(0,P.areSameExtensions)(g.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=f.map(S=>S.identifier),(E.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:u})}}};i=fe([J(1,m.IFileService),J(2,k.INativeEnvironmentService),J(3,I.ILogService)],i),e.ExtensionsWatcher=i}),define(Z[169],te([0,1,9,2,3,37,15,98,4,13]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let i=class extends T.Disposable{constructor(E,u){super();this.id=E,this._logService=u,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null}register(E){this._register(E)}start(E){this._process=(0,L.fork)(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],E),this._logService.info(`Starting extension host with pid ${this._process.pid}.`);const u=new P.StringDecoder("utf-8");this._process.stdout?.on("data",g=>{const b=typeof g=="string"?g:u.write(g);this._onStdout.fire(b)});const S=new P.StringDecoder("utf-8");return this._process.stderr?.on("data",g=>{const b=typeof g=="string"?g:S.write(g);this._onStderr.fire(b)}),this._process.on("message",g=>{this._onMessage.fire(g)}),this._process.on("error",g=>{this._onError.fire({error:(0,D.transformErrorForSerialization)(g)})}),this._process.on("exit",(g,b)=>{this._onExit.fire({code:g,signal:b})}),{pid:this._process.pid}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):m.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};i=fe([J(1,I.ILogService)],i);let C=class gt{constructor(E){this._logService=E,this._extHosts=new Map}dispose(){}_getExtHost(E){const u=this._extHosts.get(E);if(!u)throw new Error("Unknown extension host!");return u}onScopedStdout(E){return this._getExtHost(E).onStdout}onScopedStderr(E){return this._getExtHost(E).onStderr}onScopedMessage(E){return this._getExtHost(E).onMessage}onScopedError(E){return this._getExtHost(E).onError}onScopedExit(E){return this._getExtHost(E).onExit}async createExtensionHost(){const E=String(++gt._lastId),u=new i(E,this._logService);return this._extHosts.set(E,u),u.onExit(()=>{setTimeout(()=>{u.dispose(),this._extHosts.delete(E)})}),{id:E}}async start(E,u){return this._getExtHost(E).start(u)}async enableInspectPort(E){return this._getExtHost(E).enableInspectPort()}async kill(E){this._getExtHost(E).kill()}};C._lastId=0,C=fe([J(0,I.ILogService)],C),e.ExtensionHostStarter=C}),define(Z[170],te([0,1,156,17,6,2,15,8,19,12,28,32,57,13]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends L.Disposable{constructor(b,y,w){super();this.extensionManagementService=b,this.logService=w,this.cache=this._register(new S(y,w)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),y=["en",...Object.keys(b)];return(0,T.distinct)(y)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const y=await this.cache.getLanguagePacks();Object.keys(y).some(w=>y[w]&&y[w].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(y);return!(0,T.equals)(Object.keys(b),Object.keys(w))}};u=fe([J(0,i.IExtensionManagementService),J(1,I.INativeEnvironmentService),J(2,E.ILogService)],u),e.LocalizationsService=u;let S=class extends L.Disposable{constructor(b,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(y=>{Object.keys(y).forEach(w=>delete y[w]),this.createLanguagePacksFromExtensions(y,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...y){for(const w of y)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,w);Object.keys(b).forEach(w=>this.updateHash(b[w]))}createLanguagePacksFromExtension(b,y){const w=y.identifier,o=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const a of o)if(y.location.scheme===k.Schemas.file&&(0,f.isValidLocalization)(a)){let t=b[a.languageId];t||(t={hash:"",extensions:[],translations:{}},b[a.languageId]=t);let r=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,w))[0];r?r.version=y.manifest.version:t.extensions.push({extensionIdentifier:w,version:y.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(y.location.fsPath,n.path)}}updateHash(b){if(b){const y=(0,D.createHash)("md5");for(const w of b.extensions)y.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);b.hash=y.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch(o){return{}}}).then(w=>(y=b(w),w)).then(w=>{for(const a of Object.keys(w))w[a]||delete w[a];this.languagePacks=w,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>y,w=>this.logService.error(w))})}};S=fe([J(0,I.INativeEnvironmentService),J(1,E.ILogService)],S)}),define(Z[80],te([0,1,3,5,13]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(f,E,u){switch(E){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=L;class k{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){k.setLevel(this.channel,f)}static setLevel(f,E){return f.call("setLevel",E)}}e.LogLevelChannelClient=k;class P{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,E){throw new Error(`Event not found: ${E}`)}async call(f,E,u){switch(E){case"createLogger":this.createLogger(T.URI.revive(u[0]),u[1]);return;case"log":return this.log(T.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${E}`)}createLogger(f,E){this.loggers.set(f.toString(),this.loggerService.createLogger(f,E))}consoleLog(f,E){let u=console.log;switch(f){case R.LogLevel.Error:u=console.error;break;case R.LogLevel.Warning:u=console.warn;break;case R.LogLevel.Info:u=console.info;break}u.call(console,...E)}log(f,E){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[S,g]of E)switch(S){case R.LogLevel.Trace:u.trace(g);break;case R.LogLevel.Debug:u.debug(g);break;case R.LogLevel.Info:u.info(g);break;case R.LogLevel.Warning:u.warn(g);break;case R.LogLevel.Error:u.error(g);break;case R.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(f,E,u){super(f,E);this.channel=u}createConsoleMainLogger(){return new R.AdapterLogger({log:(f,E)=>{this.channel.call("consoleLog",[f,E])}})}doCreateLogger(f,E,u){return new I(this.channel,f,E,u)}}e.LoggerChannelClient=m;class I extends R.AbstractMessageLogger{constructor(f,E,u,S){super(S?.always);this.channel=f,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[E,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,E){const u=[[f,E]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class i extends R.LogService{constructor(f,E){super(E);this.parent=f,this._register(f.onDidChangeLogLevel(u=>E.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=i}),define(Z[59],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(Z[42],te([0,1,15,4,31,16]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const P=T.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const m=K.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:m.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(Z[81],te([0,1,25,9,125,14,42]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,f,E,u,S,g){let b;try{await m(C,f,E,u,S,g)}catch(y){b=y}finally{b&&S.errorTransformer&&(b=S.errorTransformer(b)),typeof b!="undefined"&&E.error(b),E.end()}}e.readFileIntoStream=P;async function m(C,f,E,u,S,g){I(g);const b=await C.open(f,{create:!1});try{I(g);let y=0,w=0,o=S&&typeof S.length=="number"?S.length:void 0,a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof o=="number"?o:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,r=0;do w=await C.read(b,t,a.buffer,r,a.byteLength-r),t+=w,r+=w,y+=w,typeof o=="number"&&(o-=w),r===a.byteLength&&(await E.write(u(a)),a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof o=="number"?o:S.bufferSize)),r=0);while(w>0&&(typeof o!="number"||o>0)&&I(g)&&i(y,S));if(r>0){let n=r;typeof o=="number"&&(n=Math.min(r,o)),E.write(u(a.slice(0,n)))}}catch(y){throw(0,L.ensureFileSystemProviderError)(y)}finally{await C.close(b)}}function I(C){if(C.isCancellationRequested)throw(0,T.canceled)();return!0}function i(C,f){if(f?.limits){if(typeof f.limits.memory=="number"&&C>f.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&C>f.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[171],te([0,1,17,6,25,27,3,55,2,41,15,172,16,50,123,14,81,13]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Be extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!0)))),this.watchedResources=I.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new m.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await T.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,f.isAbsolutePath)(o))throw new S.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)||(0,S.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),n=a?.resolveTo,s=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,l=await t.stat(o);let h;return this.toFileStat(t,o,l,void 0,!!c,(d,p)=>{if(!h&&(h=I.TernarySearchTree.forUris(()=>!r),h.set(o,!0),n))for(const A of n)h.set(A,!0);return h.get(d.resource)||h.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&s?p===1:!1})}async toFileStat(o,a,t,r,n,s){const{providerExtUri:c}=this.getExtUri(o),l={resource:a,name:c.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&s(l,r)){try{const h=await o.readdir(a),d=await T.Promises.settled(h.map(async([p,A])=>{try{const O=c.joinPath(a,p),v=n?await o.stat(O):{type:A};return await this.toFileStat(o,O,v,h.length,n,s)}catch(O){return this.logService.trace(O),null}}));l.children=(0,D.coalesce)(d)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(o){return T.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new S.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,n.dirname(o));let c;if((0,S.hasReadWriteCapability)(r)&&!(a instanceof R.VSBuffer))if((0,E.isReadableStream)(a)){const l=await(0,E.peekStream)(a,3);l.ended?c=R.VSBuffer.concat(l.buffer):c=l}else c=(0,E.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else c=a;!(0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)&&c instanceof R.VSBuffer?await this.doWriteUnbuffered(r,o,t,c):await this.doWriteBuffered(r,o,t,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c)}catch(s){throw new S.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(s){return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:n.size}))throw new S.FileOperationError((0,u.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,a,t);r(s)}catch(s){n(s)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new L.CancellationTokenSource,n=this.validateReadFile(a,t).then(c=>c,c=>{throw r.cancel(),c});let s;try{return typeof t?.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await n,!((0,S.hasOpenReadWriteCloseCapability)(o)||(0,S.hasFileReadStreamCapability)(o))||(0,S.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,a,t):(0,S.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,a,r.token,t):s=this.readFileBuffered(o,a,r.token,t),{...await n,value:s}}catch(c){s&&await(0,E.consumeStream)(s);const l=(0,u.localize)(8,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(c).toString());throw c instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(l,c.stat,t):new S.FileOperationError(l,(0,S.toFileOperationResult)(c),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const n=o.readFileStream(a,r,t);return(0,E.transform)(n,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new S.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(o,a,t,r=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,a,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new S.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),r)},t),n}readFileUnbuffered(o,a,t){const r=(0,E.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),r.end(R.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,s,a,t,r)}catch(n){return n}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"move",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,s==="move"?2:3,c)),c}async copy(o,a,t){const r=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"copy",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,s==="copy"?3:2,c)),c}async doMoveCopy(o,a,t,r,n,s){if(a.toString()===r.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,r,n,s);if(c&&!l&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),n==="copy"){if(o===t&&(0,S.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:s});else{const h=await this.resolve(a);h.isDirectory?await this.doCopyFolder(o,h,t,r):await this.doCopyFile(o,a,t,r)}return n}else return o===t?(await o.rename(a,r,{overwrite:s}),n):(await this.doMoveCopy(o,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,r);if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await T.Promises.settled(a.children.map(async n=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,s):this.doCopyFile(o,n.resource,t,s)}))}async doValidateMoveCopy(o,a,t,r,n,s){let c=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(c=h.isEqual(a,r)),c&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!c&&h.isEqualOrParent(r,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!c){if(!s)throw new S.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(a,r))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&S.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(r.basename(a)),a=r.dirname(a)}for(let n=t.length-1;n>=0;n--){a=r.joinPath(a,t[n]);try{await o.mkdir(a)}catch(s){if((0,S.toFileSystemProviderErrorCode)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(c){}if(n)this.throwIfFileIsReadonly(o,n);else throw new S.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(r||(r=[]),r.push(n));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!a))}if(r){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(r)&&Be.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let r=!1,n=()=>{r=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,a).then(s=>{r?(0,m.dispose)(s):n=()=>(0,m.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),n=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,n,r):await this.doWriteReadableBufferedQueued(o,n,r)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,n;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(s,c)=>{(0,E.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,r,0)}catch(h){return c(h)}r+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>c(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(o,a,t,r,n,s){let c=0;for(;c<r;)c+=await o.write(a,n+c,t.buffer,s+c,r-c)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){let n;r instanceof R.VSBuffer?n=r:(0,E.isReadableStream)(r)?n=await(0,R.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?n=await(0,R.bufferedStreamToBuffer)(r):n=(0,R.readableToBuffer)(r),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let n,s;try{n=await o.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,d=0;do d=await o.read(n,l,c.buffer,h,c.byteLength-h),await this.doWriteBuffer(t,s,c,d,l,h),l+=d,h+=d,h===c.byteLength&&(h=0);while(d>0)}catch(c){throw(0,S.ensureFileSystemProviderError)(c)}finally{await T.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const n=await t.open(r,{create:!0,unlock:!1});try{const s=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,r){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,L.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new S.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=fe([J(0,b.ILogService)],y),e.FileService=y}),define(Z[173],te([0,1,17,6,25,3,40,2,8,4,16,50,19,126,14,81,159,143,144,78,146,13,42]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends P.Disposable{constructor(s,c){super();this.logService=s,this.options=c,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:c,symbolicLink:l}=await f.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(s){try{const c=await f.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async h=>{try{let d;h.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(s,h.name))).type:d=this.toType(h),l.push([h.name,d])}catch(d){this.logService.trace(d)}})),l}catch(c){throw this.toFileSystemProviderError(c)}}toType(s,c){let l;return c?.dangling?l=u.FileType.Unknown:s.isFile()?l=u.FileType.File:s.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,c&&(l|=u.FileType.SymbolicLink),l}async readFile(s){try{const c=this.toFilePath(s);return await f.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(s,c,l){const h=(0,C.newWriteableStream)(d=>R.VSBuffer.concat(d.map(p=>R.VSBuffer.wrap(p))).buffer);return(0,S.readFileIntoStream)(this,s,h,d=>d.buffer,{...c,bufferSize:this.BUFFER_SIZE},l),h}async writeFile(s,c,l){let h;try{const d=this.toFilePath(s);if(!l.create||!l.overwrite){if(await f.Promises.exists(d)){if(!l.overwrite)throw(0,u.createFileSystemProviderError)((0,E.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.createFileSystemProviderError)((0,E.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(s,{create:!0,unlock:l.unlock}),await this.write(h,0,c,0,c.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(s,d)}finally{typeof h=="number"&&await this.close(h)}}async open(s,c){try{const l=this.toFilePath(s);if((0,u.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:p}=await f.SymlinkSupport.stat(l);p.mode&128||await f.Promises.chmod(l,p.mode|128)}catch(p){this.logService.trace(p)}let h;if((0,u.isFileOpenForWriteOptions)(c)){if(I.isWindows)try{await f.Promises.truncate(l,0),h="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}h||(h="w")}else h="r";const d=await f.Promises.open(l,h);return this.mapHandleToPos.set(d,0),(0,u.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(d,s),d}catch(l){throw(0,u.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(s,l):this.toFileSystemProviderError(l)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await f.Promises.fdatasync(s)}catch(c){this.canFlush=!1,this.logService.error(c)}return await f.Promises.close(s)}catch(c){throw this.toFileSystemProviderError(c)}}async read(s,c,l,h,d){const p=this.normalizePos(s,c);let A=null;try{const O=await f.Promises.read(s,l,h,d,p);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(s,p,A)}}normalizePos(s,c){return c===this.mapHandleToPos.get(s)?null:c}updatePos(s,c,l){const h=this.mapHandleToPos.get(s);typeof h=="number"&&(typeof c=="number"||(typeof l=="number"?this.mapHandleToPos.set(s,h+l):this.mapHandleToPos.delete(s)))}async write(s,c,l,h,d){return(0,T.retry)(()=>this.doWrite(s,c,l,h,d),100,3)}async doWrite(s,c,l,h,d){const p=this.normalizePos(s,c);let A=null;try{const O=await f.Promises.write(s,l,h,d,p);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),O)}finally{this.updatePos(s,p,A)}}async mkdir(s){try{await f.Promises.mkdir(this.toFilePath(s))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(s,c){try{const l=this.toFilePath(s);await this.doDelete(l,c)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(s,c){c.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}async rename(s,c,l){const h=this.toFilePath(s),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(s,c,"move",l.overwrite),await f.Promises.move(h,d)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(2,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(d)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(s,c,l){const h=this.toFilePath(s),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(s,c,"copy",l.overwrite),await f.Promises.copy(h,d,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(3,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(d)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(s,c,l,h){const d=this.toFilePath(s),p=this.toFilePath(c);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(d,p,!0)),A&&l==="copy")throw(0,u.createFileSystemProviderError)((0,E.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!A&&await f.Promises.exists(p)){if(!h)throw(0,u.createFileSystemProviderError)((0,E.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(s,c){return c.recursive?this.watchRecursive(s,c.excludes):this.watchNonRecursive(s)}watchRecursive(s,c){const l={path:this.toFilePath(s),excludes:c},h=(0,D.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,c;this.options?.watcher?.usePolling?(s=y.FileWatcher,c=this.options?.watcher):t.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?I.isWindows?s=o.FileWatcher:s=y.FileWatcher:s=b.FileWatcher,this.recursiveWatcher=new s(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,w.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace,c),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(s){const c=new g.FileWatcher(this.toFilePath(s),h=>this._onDidChangeFile.fire((0,w.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(c,l)}toFilePath(s){return(0,m.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof u.FileSystemProviderError)return s;let c;switch(s.code){case"ENOENT":c=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=u.FileSystemProviderErrorCode.NoPermissions;break;default:c=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(s,c)}async toFileSystemProviderWriteError(s,c){let l=this.toFileSystemProviderError(c);if(s&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await f.SymlinkSupport.stat(this.toFilePath(s));h.mode&128||(l=(0,u.createFileSystemProviderError)(c,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Z[29],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(Z[174],te([0,1,6,9,2,8,19,13,29]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends R.Disposable{constructor(C,f,E){super();this.productService=f,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),E=(0,L.dirname)(C),u=(0,L.basename)(C),S=await k.Promises.readdir(E);await Promise.all(S.map(async g=>{if(g===u)return;const b=(0,L.join)(E,g),y=await k.Promises.stat(b);if(y.isDirectory()&&f-y.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${g}.`),k.Promises.rm(b)}))}catch(f){(0,T.onUnexpectedError)(f)}}};I=fe([J(1,m.IProductService),J(2,P.ILogService)],I),e.CodeCacheCleaner=I}),define(Z[175],te([0,1,6,9,2,8,19,12,13,29]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(f,E,u){super();this.environmentService=f,this.logService=E,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),E=JSON.parse(await k.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(E)){const w=E[y];f[`${w.hash}.${y}`]=!0}const u=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(u))return;const g=await k.Promises.readdir(u);for(const y of g){if(f[y]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await k.Promises.rm((0,L.join)(u,y))}const b=Date.now();for(const y of Object.keys(f)){const w=(0,L.join)(u,y),o=await k.Promises.readdir(w);for(const a of o){if(a==="tcf.json")continue;const t=(0,L.join)(w,a),r=await k.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(y,a)}`),await k.Promises.rm(t))}}}catch(f){(0,T.onUnexpectedError)(f)}}};i=fe([J(0,P.INativeEnvironmentService),J(1,m.ILogService),J(2,I.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(Z[33],te([0,1,91,18]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,P){D.ok(T.isString(k)),D.ok(T.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(Z[82],te([0,1,3,33]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,I){this.schemasById[R(m)]=I,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new L;T.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[39],te([0,1,17,3,18,113,82,33]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=P.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,o=!0){this.registerConfigurations([w],o)}registerConfigurations(w,o=!0){const a=this.doRegisterConfigurations(w,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(w){const o=this.doDeregisterConfigurations(w);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:w,remove:o}){const a=[];a.push(...this.doDeregisterConfigurations(o)),a.push(...this.doRegisterConfigurations(w,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(a))}registerDefaultConfigurations(w){const o=[],a=[];for(const t of w)for(const r in t)if(o.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]={...this.defaultValues[r]||{},...t[r]};const n={type:"object",default:this.defaultValues[r],description:L.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};a.push(E(r)),this.configurationProperties[r]=n,this.defaultLanguageConfigurationOverridesNode.properties[r]=n}else{this.defaultValues[r]=t[r];const n=this.configurationProperties[r];n&&(this.updatePropertyDefaultValue(r,n),this.updateSchema(r,n))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(w){const o=[];for(const a of w)for(const t in a)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const o of w)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(w,o){const a=[];return w.forEach(t=>{a.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),a}doDeregisterConfigurations(w){const o=[],a=t=>{if(t.properties)for(const r in t.properties)o.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,t.properties[r]);t.allOf&&t.allOf.forEach(r=>a(r))};for(const t of w){a(t);const r=this.configurationContributors.indexOf(t);r!==-1&&this.configurationContributors.splice(r,1)}return o}validateAndRegisterProperties(w,o=!0,a,t=3){t=R.isUndefinedOrNull(w.scope)?t:w.scope;let r=[],n=w.properties;if(n)for(let c in n){if(o&&g(c)){delete n[c];continue}const l=n[c];if(this.updatePropertyDefaultValue(c,l),e.OVERRIDE_PROPERTY_PATTERN.test(c)?l.scope=void 0:(l.scope=R.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=R.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(c):l.restricted),n[c].hasOwnProperty("included")&&!n[c].included){this.excludedConfigurationProperties[c]=n[c],delete n[c];continue}else this.configurationProperties[c]=n[c];!n[c].deprecationMessage&&n[c].markdownDeprecationMessage&&(n[c].deprecationMessage=n[c].markdownDeprecationMessage),r.push(c)}let s=w.allOf;if(s)for(let c of s)r.push(...this.validateAndRegisterProperties(c,o,a,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const o=a=>{let t=a.properties;if(t)for(const n in t)this.updateSchema(n,t[n]);let r=a.allOf;r&&r.forEach(o)};o(w)}updateSchema(w,o){switch(e.allSettings.properties[w]=o,o.scope){case 1:e.applicationSettings.properties[w]=o;break;case 2:e.machineSettings.properties[w]=o;break;case 6:e.machineOverridableSettings.properties[w]=o;break;case 3:e.windowSettings.properties[w]=o;break;case 4:e.resourceSettings.properties[w]=o;break;case 5:e.resourceSettings.properties[w]=o,this.resourceLanguageSettingsSchema.properties[w]=o;break}}removeFromSchema(w,o){switch(delete e.allSettings.properties[w],o.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const o=`[${w}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,a),e.allSettings.properties[o]=a,e.applicationSettings.properties[o]=a,e.machineSettings.properties[o]=a,e.machineOverridableSettings.properties[o]=a,e.windowSettings.properties[o]=a,e.resourceSettings.properties[o]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,o){let a=this.defaultValues[w];R.isUndefined(a)&&(a=o.default),R.isUndefined(a)&&(a=u(o.type)),o.default=a}}const f="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(f);function E(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=E;function u(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const S=new C;P.Registry.add(e.Extensions.Configuration,S);function g(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?L.localize(5,null,y):S.getConfigurationProperties()[y]!==void 0?L.localize(6,null,y):null:L.localize(4,null)}e.validateProperty=g;function b(){const y=[],w=S.getConfigurationProperties();for(const o of Object.keys(w))y.push([o,w[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=b}),define(Z[21],te([0,1,26,18,5,39,7,33]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function m(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=m;var I;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(r,n){const s=n?r?n.keys.filter(O=>r.keys.indexOf(O)===-1):[...n.keys]:[],c=r?n?r.keys.filter(O=>n.keys.indexOf(O)===-1):[...r.keys]:[],l=[];if(n&&r){for(const O of r.keys)if(n.keys.indexOf(O)!==-1){const v=b(r.contents,O),U=b(n.contents,O);D.equals(v,U)||l.push(O)}}const h=[],d=O=>{const v={};for(const U of O)for(const F of U.identifiers)v[a(F)]=U;return v},p=n?d(n.overrides):{},A=r?d(r.overrides):{};if(Object.keys(p).length)for(const O of s){const v=p[O];v&&h.push([(0,L.overrideIdentifierFromKey)(O),v.keys])}if(Object.keys(A).length)for(const O of c){const v=A[O];v&&h.push([(0,L.overrideIdentifierFromKey)(O),v.keys])}if(Object.keys(p).length&&Object.keys(A).length)for(const O of l){const v=A[O],U=p[O];if(v&&U){const F=C({contents:v.contents,keys:v.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});h.push([(0,L.overrideIdentifierFromKey)(O),[...F.added,...F.removed,...F.updated]])}}return{added:s,removed:c,updated:l,overrides:h}}e.compare=C;function f(r,n){const s=[];for(const c of Object.keys(r))if(L.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const h in r[c])l[h]=r[c][h];s.push({identifiers:[(0,L.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:E(l,n)})}return s}e.toOverrides=f;function E(r,n){const s=Object.create(null);for(let c in r)u(s,c,r[c],n);return s}e.toValuesTree=E;function u(r,n,s,c){const l=n.split("."),h=l.pop();let d=r;for(let p=0;p<l.length;p++){let A=l[p],O=d[A];switch(typeof O){case"undefined":O=d[A]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${l.slice(0,p+1).join(".")} is ${JSON.stringify(O)}`);return}d=O}if(typeof d=="object"&&d!==null)try{d[h]=s}catch(p){c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function S(r,n){const s=n.split(".");g(r,s)}e.removeFromValueTree=S;function g(r,n){const s=n.shift();if(n.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const c=r[s];typeof c=="object"&&!Array.isArray(c)&&(g(c,n),Object.keys(c).length===0&&delete r[s])}}function b(r,n,s){function c(d,p){let A=d;for(const O of p){if(typeof A!="object"||A===null)return;A=A[O]}return A}const l=n.split("."),h=c(r,l);return typeof h=="undefined"?s:h}e.getConfigurationValue=b;function y(r,n,s){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?T.isObject(r[c])&&T.isObject(n[c])?y(r[c],n[c],s):s&&(r[c]=n[c]):r[c]=n[c])})}e.merge=y;function w(){const r=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=w;function o(){const r=Object.create(null),n=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let s in n){let c=n[s].default;u(r,s,c,l=>console.error(`Conflict in default settings: ${l}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,n,s){const c=r.inspect(n),l=r.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[176],te([0,1,17,3,34,2,41,26,18,5,21,39,33]),function(K,e,D,T,R,L,k,P,m,I,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(t={},r=[],n=[]){this._contents=t,this._keys=r,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const n=this.getContentsForOverrideIdentifer(r);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let n={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[s],l=r[s];l&&(typeof c=="object"&&typeof l=="object"?(c=P.deepClone(c),this.mergeContents(c,l)):c=l),n[s]=c}return new E(n,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),n=P.deepClone(this.overrides),s=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const l of c.overrides){const[h]=n.filter(d=>D.equals(d.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):n.push(P.deepClone(l))}for(const l of c.keys)s.indexOf(l)===-1&&s.push(l)}return new E(r,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const n of Object.keys(r)){if(n in t&&m.isObject(t[n])&&m.isObject(r[n])){this.mergeContents(t[n],r[n]);continue}t[n]=P.deepClone(r[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let n=0;n<r;n++)t.indexOf(this.keys[n])===0&&(r=n);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=E;class u extends E{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),n=[];for(const s of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,i.toValuesTree)(t[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,n)}}e.DefaultConfigurationModel=u;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:n,keys:s,overrides:c,restricted:l}=this.doParseRaw(t,r);this._configurationModel=new E(n,s,c),this._restrictedConfigurations=l||[]}doParseContent(t){let r={},n=null,s=[],c=[],l=[];function h(p){Array.isArray(s)?s.push(p):n!==null&&(s[n]=p)}let d={onObjectBegin:()=>{let p={};h(p),c.push(s),s=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let p=[];h(p),c.push(s),s=p,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:h,onError:(p,A,O)=>{l.push({error:p,offset:A,length:O})}};if(t)try{R.visit(t,d),r=s[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return r}doParseRaw(t,r){const n=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,n,!0,r);t=s.raw;const c=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),h=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:l,overrides:h,restricted:s.restricted}}filter(t,r,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const c={},l=[];for(let h in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const d=this.filter(t[h],r,!1,s);c[h]=d.raw,l.push(...d.restricted)}else{const d=r[h],p=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(h),(p===void 0||s.scopes===void 0||s.scopes.includes(p))&&(s.skipRestricted&&d?.restricted||(c[h]=t[h]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=S;class g extends L.Disposable{constructor(t,r,n,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class b{constructor(t,r,n=new E,s=new E,c=new k.ResourceMap,l=new E,h=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,n){return this.getConsolidateConfigurationModel(r,n).getValue(t)}updateValue(t,r,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new E,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,n){const s=this.getConsolidateConfigurationModel(r,n),c=this.getFolderConfigurationModelForResource(r.resource,n),l=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,v=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,U=r.overrideIdentifier?l.override(r.overrideIdentifier).getValue(t):l.getValue(t),F=s.getValue(t),z=D.distinct(D.flatten(s.overrides.map(H=>H.identifiers))).filter(H=>s.getOverrideValue(t,H)!==void 0);return{defaultValue:h,userValue:d,userLocalValue:p,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:v,memoryValue:U,value:F,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:v!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:l.getValue(t),override:r.overrideIdentifier?l.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const n=r.filter(s=>C.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=(0,C.overrideIdentifierFromKey)(s),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=t.getKeysForOverrideIdentifier(c),d=[...h.filter(p=>l.indexOf(p)===-1),...l.filter(p=>h.indexOf(p)===-1),...l.filter(p=>!P.equals(this._defaultConfiguration.override(c).getValue(p),t.override(c).getValue(p)))];return[c,d]});return this.updateDefaultConfiguration(t),{keys:r,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:c}=(0,i.compare)(this.localUserConfiguration,t),l=[...r,...n,...s];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:c}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:n,removed:s,overrides:c}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const n=this.folderConfigurations.get(t),{added:s,updated:c,removed:l,overrides:h}=(0,i.compare)(n,r);let d=[...s,...c,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,r),{keys:d,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:s,removed:c,overrides:l}=(0,i.compare)(r,void 0);return{keys:[...n,...s,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let n=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const c=this._memoryConfigurationByResource.get(t);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=n.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=n}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const n=r.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:n,overrides:s,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:n,overrides:s,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,h)=>(l.set(I.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new b(r,n,new E,s,c,new E,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new E(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(c=>t.add(c)),s.overrides.forEach(([c,l])=>{const h=(0,k.getOrSet)(r,c,new Set);l.forEach(d=>h.add(d))});const n=[];return r.forEach((s,c)=>n.push([c,[...s.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=y;class w{constructor(t,r,n,s){this.change=t,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(h=>c.add(h)),t.overrides.forEach(([,h])=>h.forEach(d=>c.add(d))),this.affectedKeys=[...c.values()];const l=new E;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let n=(0,i.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(t=t[s],!t)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=w;class o extends w{constructor(t,r,n,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[177],te([0,1,6,3,2,16,21,176,39,33]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(f,E){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,E)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,E){const u=typeof f=="string"?f:void 0,S=(0,k.isConfigurationOverrides)(f)?f:(0,k.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(u,S,void 0)}updateValue(f,E,u,S){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,E,1)}onDidDefaultConfigurationChange(f){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,f);this.trigger(u,E,6)}trigger(f,E,u){const S=new P.ConfigurationChangeEvent(f,{data:E},this.configuration);S.source=u,S.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[178],te([0,1,107,21,13]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};L=fe([J(0,T.IConfigurationService),J(1,R.ILogService)],L),e.RequestService=L}),define(Z[43],te([0,1,25,127,39,7,33]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function m(u){return u.res.statusCode===204}async function I(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return m(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=I;async function i(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(m(u))return null;const g=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(g)}catch(b){throw b.message+=`:
`+g,b}}e.asJson=i;function C(u){E(u)}e.updateProxyConfigurationsScope=C;let f;function E(u){const S=k.Registry.as(R.Extensions.Configuration),g=f;f={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[f],remove:g?[g]:[]})}E(2)}),define(Z[179],te([0,1,27,15,14,43]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(m,I){this.requestService=m,this.fileService=I}async download(m,I,i=D.CancellationToken.None){if(m.scheme===T.Schemas.file||m.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(m,I);return}const C={type:"GET",url:m.toString()},f=await this.requestService.request(C,i);if(f.res.statusCode===200)await this.fileService.writeFile(I,f.stream);else{const E=await(0,L.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${E}`)}}};k=fe([J(0,L.IRequestService),J(1,R.IFileService)],k),e.DownloadService=k}),define(Z[180],te([0,1,17,27,63,2,16,140,14,13,29,43]),function(K,e,D,T,R,L,k,P,m,I,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends L.Disposable{constructor(u,S,g,b){super();this.fileService=u,this.productService=S,this.requestService=g,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const S=[];for(const[g,b]of this.allConfigBasedTips)try{const y=await this.fileService.readFile((0,k.joinPath)(u,g)),w=new Map;(0,R.forEach)(b.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)w.set(r,{extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(y.value.toString(),[...w.keys()]);for(const a of o){const t=w.get(a);t&&S.push(t)}}catch(y){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},T.CancellationToken.None);if(u.res.statusCode!==200)return[];const S=await(0,C.asJson)(u);return S?S.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=fe([J(0,m.IFileService),J(1,i.IProductService),J(2,C.IRequestService),J(3,I.ILogService)],f),e.ExtensionTipsService=f}),define(Z[46],te([0,1,25,30]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,k,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await k.readFile(L.serviceMachineIdResource)).value.toString();m=(0,T.isUUID)(i)?i:null}catch(I){m=null}if(!m){m=(0,T.generateUuid)();try{await k.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(I){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(Z[22],te([0,1,6,3,2,18,70,7]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var C;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class f extends R.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,b){b===m?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:b,target:this.getKeyTargets(g)[b]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,b,y){return this.getStorage(b)?.get(g,y)}getBoolean(g,b,y){return this.getStorage(b)?.getBoolean(g,y)}getNumber(g,b,y){return this.getStorage(b)?.getNumber(g,y)}store(g,b,y,w){if((0,L.isUndefinedOrNull)(b)){this.remove(g,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,w),this.getStorage(y)?.set(g,b)})}remove(g,b){this.withPausedEmitters(()=>{this.updateKeyTarget(g,b,void 0),this.getStorage(b)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,b){const y=[],w=this.getKeyTargets(g);for(const o of Object.keys(w))w[o]===b&&y.push(o);return y}updateKeyTarget(g,b,y){const w=this.getKeyTargets(b);typeof y=="number"?w[g]!==y&&(w[g]=y,this.getStorage(b)?.set(m,JSON.stringify(w))):typeof w[g]=="number"&&(delete w[g],this.getStorage(b)?.set(m,JSON.stringify(w)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const b=this.get(m,g);if(b)try{return JSON.parse(b)}catch(y){}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const g=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return u(g,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends f{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=E;async function u(S,g,b,y){const w=c=>{try{return JSON.parse(c)}catch(l){return c}},o=new Map,a=new Map;S.forEach((c,l)=>{o.set(l,c),a.set(l,w(c))});const t=new Map,r=new Map;g.forEach((c,l)=>{t.set(l,c),r.set(l,w(c))}),console.group(`Storage: Global (path: ${b})`);let n=[];o.forEach((c,l)=>{n.push({key:l,value:c})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${y})`);let s=[];t.forEach((c,l)=>{s.push({key:l,value:c})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=u}),define(Z[181],te([0,1,3,2,18,28,32,22]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends T.Disposable{constructor(C){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(C)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(E=>!(0,k.areSameExtensions)(E,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let E=0;E<f.length;E++){const u=f[E];if((0,k.areSameExtensions)(u,C))return f.splice(E,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};m=fe([J(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class I extends T.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let E;return f===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),E=this.storage[C]):E=this._get(C,f),JSON.parse(E)}set(C,f,E){let u=JSON.stringify(f.map(({id:g,uuid:b})=>({id:g,uuid:b})));this._get(C,E)!==u&&(E===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,E))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const E=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),S=E.filter(b=>!u.some(y=>(0,k.areSameExtensions)(b,y))),g=u.filter(b=>!E.some(y=>(0,k.areSameExtensions)(y,b)));(S.length||g.length)&&this._onDidChange.fire([...S,...g])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,E){f?this.storageService.store(C,f,E,1):this.storageService.remove(C,E)}}e.StorageManager=I}),define(Z[182],te([0,1,3,2]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends T.Disposable{constructor(I,i){super();this.channel=I,this.workspace=i}async getItems(){const I={workspace:this.workspace},i=await this.channel.call("getItems",I);return new Map(i)}updateItems(I){const i={workspace:this.workspace};return I.insert&&(i.insert=Array.from(I.insert.entries())),I.delete&&(i.delete=Array.from(I.delete.values())),this.channel.call("updateItems",i)}}class L extends R{constructor(I){super(I,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(I=>this.onDidChangeGlobalStorage(I)))}onDidChangeGlobalStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(I,i){super(I,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const I={workspace:this.workspace};return this.channel.call("close",I)}}class P extends T.Disposable{constructor(I,i){super();this.channel=I,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[183],te([0,1,6,2,172,16,70,22,182]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class I extends P.AbstractStorageService{constructor(C,f,E){super();this.mainProcessService=f,this.environmentService=E,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new T.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),f=new k.Storage(C.globalStorage);return this._register(f.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),f}createWorkspaceStorage(C){const f=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(f.workspaceStorage){const E=new k.Storage(f.workspaceStorage);return this.workspaceStorageDisposable.value=E.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=C?.id,E}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const f=this.workspaceStorage,E=f?.items??new Map;f&&(await f.close(),f.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[u,S]of E)this.workspaceStorage.set(u,S)}}e.NativeStorageService=I}),define(Z[184],te([0,1,4,31,5,30]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(I){if(D.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,i,C,f,E,u,S,g,b,y){const w=Object.create(null);w["common.machineId"]=S,w.sessionID=(0,L.generateUuid)()+Date.now(),w.commitHash=E,w.version=u,w["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,D.PlatformToString)(D.platform),w["common.nodePlatform"]=T.platform,w["common.nodeArch"]=f,w["common.product"]=y||"desktop";const o=m(g||[]);o&&(w["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(w["common.snap"]="true");const r=k(C);r&&(w["common.platformDetail"]=r);try{const n=await I.readFile(R.URI.file(b));w["common.source"]=n.value.toString().slice(0,30)}catch(n){}return w}e.resolveCommonProperties=P;function m(I){const i=T.env.USERDNSDOMAIN;if(!i)return!1;const C=i.toLowerCase();return I.some(f=>C===f)}e.verifyMicrosoftInternalDomain=m}),define(Z[20],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.LOG=1]="LOG",L[L.USER=2]="USER"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.ERROR="error",L.ON="on"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[185],te([0,1,35,55,34,15,8,4,5,100,19,102,74,14,29,20]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,s=new Map,c=2e4;function l(p,A,O,v){const U=A.substring(p.length+1);return new Promise(async F=>{let z;try{z=await i.Promises.readdir(A,{withFileTypes:!0})}catch(j){F();return}if(v.count>=c){v.count+=z.length,v.maxReached=!0,F();return}let H=z.length;if(H===0){F();return}let M=z;v.count+z.length>c&&(v.maxReached=!0,H=c-v.count,M=z.slice(0,H)),v.count+=z.length;for(const j of M)if(j.isDirectory()){if(O.includes(j.name)||await l(p,(0,k.join)(A,j.name),O,v),--H==0){F();return}}else{const q=j.name.lastIndexOf(".");if(q>=0){const x=j.name.substring(q+1);x&&n.set(x,(n.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(U)!==!1&&x.filePattern.test(j.name)&&s.set(x.tag,(s.get(x.tag)??0)+1);if(--H==0){F();return}}})}const h={count:0,maxReached:!1};await l(a,a,t,h);const d=await w(a);return{configFiles:b(s),fileTypes:b(n),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=g;function b(a){return[...T.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function y(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=y;async function w(a){try{const t=new Map,r=(0,k.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(r),s=[],c=(0,R.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const l of c.configurations){const h=l.type;h&&(t.has(h)?t.set(h,t.get(h)+1):t.set(h,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=w;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[s,c]=n,l=this.formatProcessList(t,s);return r.forEach(h=>{if((0,f.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,c+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(t,h.processes)}`),h.workspaceMetadata){c+=`
|  Remote: ${h.hostName}`;for(const d of Object.keys(h.workspaceMetadata)){const p=h.workspaceMetadata[d];let A=`${p.fileCount} files`;p.maxFilesReached&&(A=`more than ${A}`),c+=`|    Folder (${d}): ${A}`,c+=this.formatWorkspaceStats(p)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(t,r){const{memory:n,vmHint:s,os:c,cpus:l}=y(),h={os:c,memory:n,cpus:l,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(h.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(t,r){const n=[];return(0,C.listProcesses)(t.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,s)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),r.forEach(c=>{if((0,f.isRemoteDiagnosticError)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.formatMachineInfo(c.machineInfo)),c.processes&&n.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const h=c.workspaceMetadata[l];let d=`${h.fileCount} files`;h.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(h))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const r=[],n=60;let s=0;const c=(p,A)=>{const O=` ${p}(${A})`;s+O.length>n?(r.push(l),l="|                 ",s=l.length):s+=O.length,l+=O};let l="|      File types:";const h=10;let d=t.fileTypes.length>h?h:t.fileTypes.length;for(let p=0;p<d;p++){const A=t.fileTypes[p];c(A.name,A.count)}if(r.push(l),t.configFiles.length>=0&&(l="|      Conf files:",s=0,t.configFiles.forEach(p=>{c(p.name,p.count)}),r.push(l)),t.launchConfigFiles.length>0){let p="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{p+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),r.push(p)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],n=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const l=m.URI.revive(c);if(l.scheme===L.Schemas.file){const h=l.fsPath;n.push(g(h,["node_modules",".git"]).then(d=>{let p=`${d.fileCount} files`;d.maxFilesReached&&(p=`more than ${p}`),r.push(`|    Folder (${(0,k.basename)(h)}): ${p}`),r.push(this.formatWorkspaceStats(d))}).catch(d=>{r.push(`|      Error: Unable to collect workspace stats for folder ${h} (${d.toString()})`)}))}else r.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const n=new Map;t.windows.forEach(c=>n.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,n,s,r,0),s.join(`
`)}formatProcessItem(t,r,n,s,c){const l=c===0;let h;l?h=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(h=`${h} (${r.get(s.pid)})`));const d=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(d/E.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(p=>this.formatProcessItem(t,r,n,p,c+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const n=m.URI.revive(r);if(n.scheme!==L.Schemas.file)continue;const s=n.fsPath;try{const c=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=fe([J(0,S.ITelemetryService),J(1,u.IProductService)],o),e.DiagnosticsService=o}),define(Z[186],te([0,1,17,6,27,9,3,2,4,5,116,28,32,13,42,20]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let g=class extends P.Disposable{constructor(a,t,r){super();this.galleryService=a,this.telemetryService=t,this.logService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(r=>(0,C.isTargetPlatformCompatible)(r,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));if(!await this.canInstall(a)){const n=await this.getTargetPlatform(),s=new C.ExtensionManagementError(i.localize(1,null,a.identifier.id,u.default.nameLong,(0,C.TargetPlatformToString)(n)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,s.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,s),s}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,L.getErrorMessage)(n)),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}const r=await this.galleryService.getManifest(a,R.CancellationToken.None);if(r===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(r.version!==a.version){const n=new C.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(r,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,r){if(!I.URI.isUri(t)){let h=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(h)return this.logService.info("Extensions is already requested to install",t.identifier.id),h.waitUntilTaskIsFinished();r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],c=this.createInstallExtensionTask(a,t,r);I.URI.isUri(t)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:t}),this.logService.info("Installing extension:",c.identifier.id),n.push({task:c,manifest:a});let l=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!r.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(O=>(0,f.areSameExtensions)({id:O},c.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const O=this.createInstallExtensionTask(A,p,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(O.identifier,A.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:p}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:A})}}catch(d){if(I.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),this.logService.error(d),d}const h=n.reduce((d,{task:p,manifest:A})=>(d.set(p.identifier.id.toLowerCase(),{task:p,manifest:A}),d),new Map);for(;h.size;){let d;const p=[...h.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(O=>h.has(O.toLowerCase())));p.length?d=h.size===1?p:p.filter(({task:A})=>!(A===c&&!l)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:A})=>A.identifier.id)),d=[...h.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const O=new Date().getTime();try{const v=await A.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(v,A.source,r,R.CancellationToken.None))),!I.URI.isUri(A.source)&&(y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,void 0),m.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(v.manifest.publisher,v.manifest.name,v.manifest.version,"install")}catch(U){}s.push({local:v,identifier:A.identifier,operation:A.operation,source:A.source})}catch(v){throw I.URI.isUri(A.source)||y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,v),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(v),v}finally{h.delete(A.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:d})=>(0,f.areSameExtensions)(d,c.identifier))[0].local}catch(h){if(n.forEach(({task:d})=>d.cancel()),s.length)try{const d=await Promise.allSettled(s.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<d.length;p++){const A=d[p],{identifier:O}=s[p];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,L.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(d),s.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",c.identifier.id,(0,L.getErrorMessage)(h)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:e.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:d}of n)if(!I.URI.isUri(h.source)){const p=new f.ExtensionIdentifierWithVersion(h.identifier,d.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(a){const t=[],r=[],n=await Promise.allSettled(a);for(const s of n)s.status==="fulfilled"?t.push(s.value):r.push(s.reason);if(r.length)throw b(r);return t}async getAllDepsAndPackExtensionsToInstall(a,t,r){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const s=[a,...n.map(h=>h.identifier)],c=[],l=async(h,d)=>{const p=d.extensionDependencies||[],A=[...p];if(d.extensionPack){const O=r?n.find(v=>(0,f.areSameExtensions)(v.identifier,h)):void 0;for(const v of d.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(U=>(0,f.areSameExtensions)({id:U},{id:v}))||A.every(U=>!(0,f.areSameExtensions)({id:U},{id:v}))&&A.push(v)}if(A.length){const O=[...s,...c.map(U=>U.gallery.identifier)],v=A.filter(U=>O.every(F=>!(0,f.areSameExtensions)(F,{id:U})));if(v.length){const U=await this.galleryService.query({names:v,pageSize:A.length},R.CancellationToken.None);for(const F of U.firstPage){if(O.find(j=>(0,f.areSameExtensions)(j,F.identifier)))continue;if(!p.some(j=>(0,f.areSameExtensions)({id:j},F.identifier))&&!await this.canInstall(F)){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}const H=await this.checkAndGetCompatibleVersion(F,!0),M=await this.galleryService.getManifest(H,R.CancellationToken.None);if(M===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${H.identifier.id}`,e.INSTALL_ERROR_VALIDATING);c.push({gallery:H,manifest:M}),await l(H.identifier,M)}}}};return await l(a,t),n=await this.getInstalled(),c.filter(h=>!n.some(d=>(0,f.areSameExtensions)(d.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new C.ExtensionManagementError(i.localize(4,null,a.identifier.id),C.INSTALL_ERROR_MALICIOUS);const r=await this.getTargetPlatform();let n=null;if(await this.galleryService.isExtensionCompatible(a,r)&&(n=a),!n&&t&&(n=await this.galleryService.getCompatibleExtension(a,r)),!n)throw new C.ExtensionManagementError(i.localize(5,null,a.identifier.id,u.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(a){const t=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const r=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(r)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),r.waitUntilTaskIsFinished();const n=(h,d)=>{const p=this.createUninstallExtensionTask(h,d);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),p},s=(h,d)=>{d?this.logService.error("Failed to uninstall extension:",h.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(h),void 0,d),this._onDidUninstallExtension.fire({identifier:h.identifier,error:d?.code})},c=[],l=[];try{c.push(n(a,{}));const h=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,h);for(const p of d)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):c.push(n(p,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(d=>d.extension),h,a),await this.joinAllSettled(c.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(p){}s(d.extension)}catch(p){const A=p instanceof C.ExtensionManagementError?p:new C.ExtensionManagementError((0,L.getErrorMessage)(p),e.ERROR_UNKNOWN);throw s(d.extension,A),A}finally{l.push(d)}}))}catch(h){const d=h instanceof C.ExtensionManagementError?h:new C.ExtensionManagementError((0,L.getErrorMessage)(h),e.ERROR_UNKNOWN);for(const p of c){try{p.cancel()}catch(A){}l.includes(p)||s(p.extension,d)}throw d}finally{for(const h of c)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(a,t,r){for(const n of a){const s=this.getDependents(n,t);if(s.length){const c=s.filter(l=>!a.some(h=>(0,f.areSameExtensions)(h.identifier,l.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(n,c,r))}}}getDependentsErrorMessage(a,t,r){return r===a?t.length===1?i.localize(6,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,r=[]){if(r.indexOf(a)!==-1)return[];r.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const s=t.filter(l=>!l.isBuiltin&&n.some(h=>(0,f.areSameExtensions)({id:h},l.identifier))),c=[];for(const l of s)c.push(...this.getAllPackExtensionsToUninstall(l,t,r));return[...s,...c]}return[]}getDependents(a,t){return t.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(n=>(0,f.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};g=fe([J(0,C.IExtensionGalleryService),J(1,S.ITelemetryService),J(2,E.ILogService)],g),e.AbstractExtensionManagementService=g;function b(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,r)=>new Error(`${t.message}${t.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=b;function y(o,a,t,r,n){const s=n?n instanceof C.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:r,errorcode:s})}e.reportTelemetry=y;class w{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(a=>new Promise((t,r)=>{const n=a.onCancellationRequested(()=>{n.dispose(),r((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=w}),define(Z[187],te([0,1,17,6,63,3,8,4,31,5,118,12,28,180,76,14,13,59,29,43,22,20]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends E.ExtensionTipsService{constructor(c,l,h,d,p,A,O,v,U,F){super(O,v,U,F);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=h,this.storageService=d,this.nativeHostService=p,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,v.exeBasedExtensionTips&&(0,R.forEach)(v.exeBasedExtensionTips,({key:z,value:H})=>{const M=[],j=[],q=[];(0,R.forEach)(H.recommendations,({key:x,value:$})=>{$.important?H.important?M.push({extensionId:x,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):j.push({extensionId:x,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):q.push({extensionId:x,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(z,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:M}),j.length&&this.mediumImportanceExecutableTips.set(z,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:j}),q.length&&this.allOtherExecutableTips.set(z,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:q})}),(0,T.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(c,l){const h=new Map;c.forEach(v=>h.set(v.extensionId.toLowerCase(),v));const{installed:d,uninstalled:p}=this.groupByInstalled([...h.keys()],l);for(const v of d){const U=h.get(v);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:v,exeName:U.exeName})}for(const v of p){const U=h.get(v);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:v,exeName:U.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const v of p){const U=h.get(v);if(U&&(!A[U.exeName]||!A[U.exeName].includes(U.extensionId))){let F=O.get(U.exeName);F||(F=[],O.set(U.exeName,F)),F.push(U)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const d=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,T.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,h=7*24*60*60*1e3;if(l<h){const A=this._register((0,T.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[d,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(p[0].exeName,p);const O=this._register((0,T.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const v=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(v(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const U=this._register((0,T.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(c){const l=c.map(({extensionId:d})=>d.toLowerCase()),h=(0,i.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(r,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(r,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const h=this.getPromptedExecutableTips();h[c]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(c,l){const h=[],d=[],p=l.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return c.forEach(A=>{p.has(A.toLowerCase())?h.push(A):d.push(A)}),{installed:h,uninstalled:d}}async getValidExecutableBasedExtensionTips(c){const l=[],h=new Map;for(const d of c.keys()){const p=c.get(d);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const A=[];P.isWindows?p.windowsPath&&A.push(p.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",d)),A.push((0,k.join)("/usr/bin",d)),A.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const O of A){let v=h.get(O);if(v===void 0&&(v=await this.fileService.exists(I.URI.file(O)),h.set(O,v)),v)for(const{extensionId:U,extensionName:F,isExtensionPack:z}of p.recommendations)l.push({extensionId:U,extensionName:F,isExtensionPack:z,exeName:d,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return l}};n=fe([J(0,C.INativeEnvironmentService),J(1,a.ITelemetryService),J(2,f.IExtensionManagementService),J(3,o.IStorageService),J(4,b.INativeHostService),J(5,u.IExtensionRecommendationNotificationService),J(6,S.IFileService),J(7,y.IProductService),J(8,w.IRequestService),J(9,g.ILogService)],n),e.ExtensionTipsService=n}),define(Z[83],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appender=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class T{constructor(L){this.channel=L}log(L,k){return this.channel.call("log",{eventName:L,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(Z[44],te([0,1,6,26,18,21,20]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryConfiguration=e.getTelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(b,y){return Promise.resolve(void 0)}publicLog2(b,y){return this.publicLog(b,y)}publicLogError(b,y){return Promise.resolve(void 0)}publicLogError2(b,y){return this.publicLogError(b,y)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(y,w,o){}async publicLogError(y,w,o){}}e.NullEndpointTelemetryService=P;function m(...b){return{log:(y,w)=>b.forEach(o=>o.log(y,w)),flush:()=>D.Promises.settled(b.map(y=>y.flush()))}}e.combinedAppender=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(b,y){return y.onDidChangeConfiguration(w=>{w.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:S(w.sourceConfig)})})}e.configurationTelemetry=I;function i(b,y){return y.disableTelemetry||!b.enableTelemetry?0:y.isBuilt?2:1}e.getTelemetryLevel=i;function C(b){const y=b.getValue(k.TELEMETRY_SETTING_ID),w=b.getValue(k.TELEMETRY_OLD_SETTING_ID);return w!==void 0&&w===!1?"off":y??"on"}e.getTelemetryConfiguration=C;function f(b){const y=Object.create(null),w=Object.create(null),o=Object.create(null);u(b,o);for(let a in o){a=a.length>150?a.substr(a.length-149):a;const t=o[a];typeof t=="number"?w[a]=t:typeof t=="boolean"?w[a]=t?1:0:typeof t=="string"?y[a]=t.substring(0,1023):typeof t!="undefined"&&t!==null&&(y[a]=t)}return{properties:y,measurements:w}}e.validateTelemetryData=f;function E(b){if(!b)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{b.indexOf(`${o}+`)===0&&(y=o)}),y}e.cleanRemoteAuthority=E;function u(b,y,w=0,o){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const t=b[a],r=o?o+a:a;Array.isArray(t)?y[r]=(0,T.safeStringify)(t):t instanceof Date?y[r]=t.toISOString():(0,R.isObject)(t)?w<2?u(t,y,w+1,r+"."):y[r]=(0,T.safeStringify)(t):y[r]=t}}function S(b){if(!b)return[];const y=[];return g(y,"",b),y}function g(b,y,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(o=>g(b,y?`${y}.${o}`:o,w[o])):b.push(y)}}),define(Z[188],te([0,1,17,27,9,26,4,31,5,21,12,28,32,73,14,13,29,43,46,22,20,44]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,P.arch);var r;(function(X){X[X.None=0]="None",X[X.IncludeVersions=1]="IncludeVersions",X[X.IncludeFiles=2]="IncludeFiles",X[X.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",X[X.IncludeSharedAccounts=8]="IncludeSharedAccounts",X[X.IncludeVersionProperties=16]="IncludeVersionProperties",X[X.ExcludeNonValidated=32]="ExcludeNonValidated",X[X.IncludeInstallationTargets=64]="IncludeInstallationTargets",X[X.IncludeAssetUri=128]="IncludeAssetUri",X[X.IncludeStatistics=256]="IncludeStatistics",X[X.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",X[X.Unpublished=4096]="Unpublished"})(r||(r={}));function n(...X){return String(X.reduce((B,re)=>B|re,0))}var s;(function(X){X[X.Tag=1]="Tag",X[X.ExtensionId=4]="ExtensionId",X[X.Category=5]="Category",X[X.ExtensionName=7]="ExtensionName",X[X.Target=8]="Target",X[X.Featured=9]="Featured",X[X.SearchText=10]="SearchText",X[X.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class p{constructor(B=d){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,re=this.state.pageSize){return new p({...this.state,pageNumber:B,pageSize:re})}withFilter(B,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new p({...this.state,criteria:ie})}withSortBy(B){return new p({...this.state,sortBy:B})}withSortOrder(B){return new p({...this.state,sortOrder:B})}withFlags(...B){return new p({...this.state,flags:B.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...B){return new p({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue,flags:ge,assetTypes:de}=this.state;return{filters:[{criteria:B,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue}],assetTypes:de,flags:ge}}get searchText(){const B=this.state.criteria.filter(re=>re.filterType===s.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(X,B){const re=(X||[]).filter(ie=>ie.statisticName===B)[0];return re?re.value:0}function O(X){const B="Microsoft.VisualStudio.Code.Translation.";return X.files.filter(ie=>ie.assetType.indexOf(B)===0).reduce((ie,ce)=>{const ue=z(X,ce.assetType);return ue&&ie.push([ce.assetType.substring(B.length),ue]),ie},[])}function v(X){if(X.properties){const B=X.properties.filter(ce=>ce.key===c.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=B.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return z(X,c.Repository)}function U(X){return{uri:`${X.fallbackAssetUri}/${c.VSIX}?redirect=true${X.targetPlatform?`&targetPlatform=${X.targetPlatform}`:""}`,fallbackUri:`${X.fallbackAssetUri}/${c.VSIX}${X.targetPlatform?`?targetPlatform=${X.targetPlatform}`:""}`}}function F(X){const B=z(X,c.Icon);if(B)return B;const re=C.DefaultIconPath;return{uri:re,fallbackUri:re}}function z(X,B){return X.files.filter(ie=>ie.assetType===B)[0]?{uri:`${X.assetUri}/${B}`,fallbackUri:`${X.fallbackAssetUri}/${B}`}:null}function H(X,B){const re=X.properties?X.properties.filter(ce=>ce.key===B):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,f.adoptToGalleryExtensionId)(ce)):[]}function M(X){const B=X.properties?X.properties.filter(re=>re.key===l.Engine):[];return B.length>0&&B[0].value||""}function j(X){const B=X.properties?X.properties.filter(ie=>ie.key===l.LocalizedLanguages):[],re=B.length>0&&B[0].value||"";return re?re.split(","):[]}function q(X){return X.indexOf("preview")!==-1}function x(X){return X.targetPlatform?(0,C.toTargetPlatform)(X.targetPlatform):"undefined"}function $(X){const B=(0,D.distinct)(X.versions.map(x)),re=!!X.tags?.includes(C.WEB_EXTENSION_TAG),ie=B.indexOf("web");return re?ie===-1&&B.push("web"):ie!==-1&&B.splice(ie,1),B}function N(X,B){const re=(0,C.getFallbackTargetPlarforms)(B);for(let ie=0;ie<X.length;ie++){const ce=X[ie];if(ce.version===X[ie-1]?.version){let ue=ie;const ge=x(ce);if(ge===B)for(;ue>0&&X[ue-1].version===ce.version;)ue--;else if(re.includes(ge))for(;ue>0&&X[ue-1].version===ce.version&&x(X[ue-1])!==B;)ue--;ue!==ie&&(X.splice(ie,1),X.splice(ue,0,ce))}}return X}e.sortExtensionVersions=N;function W(X,B,re,ie,ce){const ue=$(X);let ge=X.versions[0];return ge=X.versions.find(de=>de.version===ge.version&&(0,C.isTargetPlatformCompatible)(x(de),ue,ce))||ge,_(X,ge,ue,B,re,ie)}function _(X,B,re,ie,ce,ue){const ge={manifest:z(B,c.Manifest),readme:z(B,c.Details),changelog:z(B,c.Changelog),license:z(B,c.License),repository:v(B),download:U(B),icon:F(B),coreTranslations:O(B)};return{identifier:{id:(0,f.getGalleryExtensionId)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},name:X.extensionName,version:B.version,displayName:X.displayName,publisherId:X.publisher.publisherId,publisher:X.publisher.publisherName,publisherDisplayName:X.publisher.displayName,description:X.shortDescription||"",installCount:A(X.statistics,"install"),rating:A(X.statistics,"averagerating"),ratingCount:A(X.statistics,"ratingcount"),categories:X.categories||[],tags:X.tags||[],releaseDate:Date.parse(X.releaseDate),lastUpdated:Date.parse(X.lastUpdated),allTargetPlatforms:re,assets:ge,properties:{dependencies:H(B,l.Dependency),extensionPack:H(B,l.ExtensionPack),engine:M(B),localizedLanguages:j(B),targetPlatform:x(B)},preview:q(X.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:ue}}}let Y=class{constructor(B,re,ie,ce,ue,ge,de,Ie){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=ue,this.fileService=ge,this.productService=de,this.configurationService=Ie;const Pe=de.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=ee(de.version,de,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,re){const ie=[];let ce=new p().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,B.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...B.map(({id:ge})=>ge.toLowerCase()));B.every(ge=>!ge.version)&&(ce=ce.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ce,t,T.CancellationToken.None);for(let ge=0;ge<ue.length;ge++){const de=ue[ge];if(!de.versions.length)continue;const Ie=(0,f.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Pe=B.find(Ee=>(0,f.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=de.versions.find(Oe=>Oe.version===Pe);Ee&&ie.push(_(de,Ee,$(de),ge,ce))}else ie.push(W(de,ge,ce,void 0,t))}return ie}async getCompatibleExtension(B,re){const ie=(0,C.isIExtensionIdentifier)(B)?null:B;if(ie){if((0,C.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:ue}=ie?ie.identifier:B;let ge=new p().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");ue?ge=ge.withFilter(s.ExtensionId,ue):ge=ge.withFilter(s.ExtensionName,ce);const{galleryExtensions:de}=await this.queryGallery(ge,re,T.CancellationToken.None),[Ie]=de;if(!Ie||!Ie.versions.length)return null;const Pe=$(Ie);if((0,C.isNotWebExtensionInWebTargetPlatform)(Pe,re))return null;for(let Ee of Ie.versions){if(!M(Ee)){const Oe=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:Oe}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,re))return _(Ie,Ee,Pe,0,ge)}return null}async isExtensionCompatible(B,re){if(!(0,C.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,re))return!1;let ie=B.properties.engine;if(!ie){const ce=await this.getManifest(B,T.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,E.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(B,re,ie){if(!(0,C.isTargetPlatformCompatible)(x(B),re,ie))return!1;const ce=await this.getEngine(B);return(0,E.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(B,re){const ie=T.CancellationToken.isCancellationToken(B)?{}:B,ce=T.CancellationToken.isCancellationToken(B)?B:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=ie.text||"";const ge=(0,L.getOrDefault)(ie,Re=>Re.pageSize,50);let de=new p().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,ge).withFilter(s.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Te,Ne)=>(de=de.withFilter(s.Category,Ne||Te),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Te,Ne)=>(de=de.withFilter(s.Tag,Ne||Te),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(s.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),de=de.withFilter(s.SearchText,ue)),de=de.withSortBy(0)):ie.ids?de=de.withFilter(s.ExtensionId,...ie.ids):ie.names?de=de.withFilter(s.ExtensionName,...ie.names):de=de.withSortBy(4),typeof ie.sortBy=="number"&&(de=de.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(de=de.withSortOrder(ie.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(de,t,ce),Ee=Ie.map((Re,Te)=>W(Re,Te,de,ie.source,t)),Oe=async(Re,Te)=>{if(Te.isCancellationRequested)throw(0,R.canceled)();const Ne=de.withPage(Re+1),{galleryExtensions:_e}=await this.queryGallery(Ne,t,Te);return _e.map((ze,$e)=>W(ze,$e,Ne,ie.source,t))};return{firstPage:Ee,total:Pe,pageSize:de.pageSize,getPage:Oe}}async queryGallery(B,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,r.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,n(r.Unpublished));const ce=await this.commonHeadersPromise,ue=JSON.stringify(B.raw),ge={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},de=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:ge},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Oe=await(0,b.asJson)(Ie);if(Oe){const Re=Oe.results[0],Te=Re.extensions;Te.forEach(_e=>N(_e.versions,re));const Ne=Re.resultMetadata&&Re.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return Ee=Ne&&Ne.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Oe){throw Pe=Oe,Oe}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-de,success:!!Ie&&(0,b.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,R.isPromiseCanceledError)(Pe)?"canceled":(0,R.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(B,re,ie,ce){if(!this.isEnabled())return;const ue=k.isWeb?this.api(`/itemName/${B}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${re}/${ie}/stats?statType=${ce}`),ge=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},T.CancellationToken.None)}catch(Pe){}}async download(B,re,ie){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,f.getGalleryExtensionTelemetryData)(B),ue=new Date().getTime(),ge=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),de=ie===1?"install":ie===2?"update":"",Ie=de?{uri:`${B.assets.download.uri}${m.URI.parse(B.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${B.assets.download.fallbackUri}${m.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:B.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(re,Pe.stream),ge(new Date().getTime()-ue)}async getReadme(B,re){if(B.assets.readme){const ie=await this.getAsset(B.assets.readme,{},re);return await(0,b.asText)(ie)||""}return""}async getManifest(B,re){if(B.assets.manifest){const ie=await this.getAsset(B.assets.manifest,{},re),ce=await(0,b.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,re){const ie=z(B,c.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ue=await this.getAsset(ie,{headers:ce});return await(0,b.asJson)(ue)}async getCoreTranslation(B,re){const ie=B.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),ue=await(0,b.asText)(ce);return ue?JSON.parse(ue):null}return null}async getChangelog(B,re){if(B.assets.changelog){const ie=await this.getAsset(B.assets.changelog,{},re);return await(0,b.asText)(ie)||""}return""}async getAllCompatibleVersions(B,re){let ie=new p().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");B.identifier.uuid?ie=ie.withFilter(s.ExtensionId,B.identifier.uuid):ie=ie.withFilter(s.ExtensionName,B.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,T.CancellationToken.None);if(!ce.length)return[];const ue=$(ce[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ue,re))return[];const ge=[];for(const de of ce[0].versions)try{ge[ge.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,ue,re)&&ge.push({version:de.version,date:de.lastUpdated})}catch(Ie){}return ge}async getAsset(B,re={},ie=T.CancellationToken.None){const ce=await this.commonHeadersPromise,ue={type:"GET"},ge={...ce,...re.headers||{}};re={...re,...ue,headers:ge};const de=B.uri,Ie=B.fallbackUri,Pe={...re,url:de};try{const Ee=await this.requestService.request(Pe,ie);if(Ee.res.statusCode===200)return Ee;const Oe=await(0,b.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Oe}`)}catch(Ee){if((0,R.isPromiseCanceledError)(Ee))throw Ee;const Oe=(0,R.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:Oe});const Re={...re,url:Ie};return this.requestService.request(Re,ie)}}async getEngine(B){let re=M(B);if(!re){const ie=await this.getManifestFromRawExtensionVersion(B,T.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,b.asJson)(B),ie=new Map;if(re)for(const ce of re.malicious){const ue=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};ue.malicious=!0,ie.set(ce,ue)}return[...ie.values()]}};Y=fe([J(1,b.IRequestService),J(2,S.ILogService),J(3,i.IEnvironmentService),J(4,o.ITelemetryService),J(5,u.IFileService),J(6,g.IProductService),J(7,I.IConfigurationService)],Y);let G=class extends Y{constructor(B,re,ie,ce,ue,ge,de,Ie){super(B,re,ie,ce,ue,ge,de,Ie)}};G=fe([J(0,w.IStorageService),J(1,b.IRequestService),J(2,S.ILogService),J(3,i.IEnvironmentService),J(4,o.ITelemetryService),J(5,u.IFileService),J(6,g.IProductService),J(7,I.IConfigurationService)],G),e.ExtensionGalleryService=G;let ne=class extends Y{constructor(B,re,ie,ce,ue,ge,de){super(void 0,B,re,ie,ce,ue,ge,de)}};ne=fe([J(0,b.IRequestService),J(1,S.ILogService),J(2,i.IEnvironmentService),J(3,o.ITelemetryService),J(4,u.IFileService),J(5,g.IProductService),J(6,I.IConfigurationService)],ne),e.ExtensionGalleryServiceWithNoStorageService=ne;async function ee(X,B,re,ie,ce,ue){const ge={"X-Market-Client-Id":`VSCode ${X}`,"User-Agent":`VSCode ${X}`},de=await(0,y.getServiceMachineId)(re,ce,ue);return(0,a.getTelemetryLevel)(B,re)>=2&&(0,a.getTelemetryConfiguration)(ie)==="on"&&(ge["X-Market-User-Id"]=de),ge}e.resolveMarketplaceHeaders=ee}),define(Z[84],te([0,1,2,12,13,44]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(m,I,i=""){super();this.prefix=i;const C=m.getLogger(I.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(m.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,I){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,L.validateTelemetryData)(I))}};k=fe([J(0,R.ILoggerService),J(1,T.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(Z[85],te([0,1,2,26,24,128,21,39,42,33,20,44]),function(K,e,D,T,R,L,k,P,m,I,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(u,S){this._configurationService=S,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(g),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(g=>{const b=/^[a-f0-9]+$/i.test(g["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})})}setExperimentProperty(u,S){this._experimentProperties[u]=S}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=(0,C.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=u!=="off",this._userOptIn=u==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let S=u.sessionID,g=u["common.instanceId"],b=u["common.machineId"],y=u["common.firstSessionDate"],w=u["common.msftInternal"];return{sessionId:S,instanceId:g,machineId:b,firstSessionDate:y,msftInternal:w}}dispose(){this._disposables.dispose()}publicLog(u,S,g){return this.isOptedIn?this._commonProperties.then(b=>{S=(0,T.mixin)(S,b),S=(0,T.mixin)(S,this._experimentProperties),S=(0,T.cloneAndChange)(S,y=>{if(typeof y=="string")return this._cleanupInfo(y,g)}),this._appender.log(u,S)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(u,S,g){return this.publicLog(u,S,g)}publicLogError(u,S){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(u,S,!0)}publicLogError2(u,S){return this.publicLogError(u,S)}_anonymizeFilePaths(u){let S=u;const g=[];for(let o of this._cleanupPatterns)for(;;){const a=o.exec(u);if(!a)break;g.push([a.index,o.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(S="";;){const o=y.exec(u);if(!o)break;!b.test(o[0])&&g.every(([a,t])=>o.index<a||o.index>=t)&&(S+=u.substring(w,o.index)+"<REDACTED: user-file-path>",w=y.lastIndex)}return w<u.length&&(S+=u.substr(w)),S}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const S=u.toLowerCase(),g=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(S)?"<REDACTED: secret>":g.test(S)?"<REDACTED: email>":u}_cleanupInfo(u,S){let g=u;S&&(g=this._anonymizeFilePaths(g));for(let b of this._cleanupPatterns)g=g.replace(b,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=fe([J(1,k.IConfigurationService)],f),e.TelemetryService=f,I.Registry.as(P.Extensions.Configuration).registerConfiguration({id:i.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(0,null),properties:{[i.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,L.localize)(1,null),(0,L.localize)(2,null),(0,L.localize)(3,null)],markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(5,null,m.default.nameLong,m.default.privacyStatementUrl):(0,L.localize)(4,null,m.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(P.Extensions.Configuration).registerConfiguration({id:i.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(6,null),properties:{[i.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(8,null,m.default.nameLong,m.default.privacyStatementUrl):(0,L.localize)(7,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(9,null,`\`#${i.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[189],te([0,1,9,26,44]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(P){const m=await new Promise((i,C)=>{K(["applicationinsights"],i,C)});let I;return m.defaultClient?(I=new m.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=m.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),I}class k{constructor(m,I,i){this._eventPrefix=m,this._defaultData=I,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(I=>{m(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(m,I){!this._aiClient||(I=(0,T.mixin)(I,this._defaultData),I=(0,R.validateTelemetryData)(I),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:I.properties,measurements:I.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(I=>{I.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(Z[190],te([0,1,15,52,21,12,13,20,83,84,85,44]),function(K,e,D,T,R,L,k,P,m,I,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(u,S,g,b){this.configurationService=u,this.telemetryService=S,this.loggerService=g,this.environmentService=b,this.customTelemetryServices=new Map}async getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const{machineId:S,sessionId:g}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=S,b["common.vscodesessionid"]=g;const y=[u.id,JSON.stringify(b),u.aiKey],o=new T.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,C.combinedAppender)(new m.TelemetryAppenderClient(o),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${u.id}] `));this.customTelemetryServices.set(u.id,new i.TelemetryService({appender:a,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(u.id)}async publicLog(u,S,g){await(await this.getCustomTelemetryService(u)).publicLog(S,g)}async publicLogError(u,S,g){await(await this.getCustomTelemetryService(u)).publicLogError(S,g)}};f=fe([J(0,R.IConfigurationService),J(1,P.ITelemetryService),J(2,k.ILoggerService),J(3,L.IEnvironmentService)],f),e.CustomEndpointTelemetryService=f}),define(Z[191],te([0,1,6,27,3,2,13]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(I,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((i,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,i),this._onCreateRequest.fire({requestId:f,...I});const E=new T.CancellationTokenSource;(0,D.timeout)(this._timeout,E.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,L.toDisposable)(()=>E.cancel())])})}acceptReply(I,i){const C=this._pendingRequests.get(I);C?(this._pendingRequests.delete(I),(0,L.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),C(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};P=fe([J(1,k.ILogService)],P),e.RequestStore=P}),define(Z[86],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd"})(m=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(g){g.TerminalView="view",g.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(g){g.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(Z[192],te([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(Z[193],te([0,1,35,26,8,4,31,18,19]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=I;async function i(C,f,E,u=k.env,S=m.Promises.exists){if(R.isAbsolute(C))return await S(C)?C:void 0;if(f===void 0&&(f=k.cwd()),R.dirname(C)!=="."){const w=R.join(f,C);return await S(w)?w:void 0}const b=(0,T.getCaseInsensitive)(u,"PATH");if(E===void 0&&(0,P.isString)(b)&&(E=b.split(R.delimiter)),E===void 0||E.length===0){const w=R.join(f,C);return await S(w)?w:void 0}for(let w of E){let o;if(R.isAbsolute(w)?o=R.join(w,C):o=R.join(f,w,C),await S(o))return o;if(L.isWindows){let a=o+".com";if(await S(a)||(a=o+".exe",await S(a)))return a}}const y=R.join(f,C);return await S(y)?y:void 0}e.findExecutable=i}),define(Z[194],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(Z[87],te([0,1,49,3,2,7,33,194]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var m;(function(g){function b(y){return y&&typeof y=="object"&&typeof y.id=="string"}g.isThemeColor=b})(m=e.ThemeColor||(e.ThemeColor={}));function I(g){return{id:g}}e.themeColorFromId=I;var i;(function(g){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||m.isThemeColor(r.color))}g.isThemeIcon=b;const y=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function w(r){const n=y.exec(r);if(!n)return;let[,s]=n;return{id:s}}g.fromString=w;function o(r,n){let s=r.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),n&&(s=`${s}~${n}`),{id:s}}g.modify=o;function a(r,n){return r.id===n.id&&r.color?.id===n.color?.id}g.isEqual=a;function t(r,n){return{id:r.id,color:n?I(n):void 0}}g.asThemeIcon=t,g.asClassNameArray=D.CSSIcon.asClassNameArray,g.asClassName=D.CSSIcon.asClassName,g.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(g){switch(g){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const y=this.themingParticipants.indexOf(b);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new f;k.Registry.add(e.Extensions.ThemingContribution,E);function u(g){return E.onColorThemeChange(g)}e.registerThemingParticipant=u;class S extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,y){let w=this.theme.getColor(b);return w&&y&&(w=y(w,this.theme)),w?w.toString():null}}e.Themable=S}),define(Z[195],te([0,1,49,87]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const I=P.map(i=>({name:i.profileName,description:L(i)}));return m&&I.push(...m.map(i=>({name:i.title,description:k(i)}))),{values:I.map(i=>i.name),markdownDescriptions:I.map(i=>i.description)}}e.createProfileSchemaEnums=R;function L(P){let m=`$(${T.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function k(P){return`$(${T.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[196],te([0,1,49,129,39,33,195]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,g=>g.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,g=>`$(${g.id})`)},color:{description:(0,T.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},I=(0,T.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,T.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,T.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f={id:"terminal",order:100,title:(0,T.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(19,null)}},{type:"string",markdownDescription:(0,T.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(23,null),type:"string"},id:{description:(0,T.localize)(24,null),type:"string"},title:{description:(0,T.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(27,null),type:"string"},id:{description:(0,T.localize)(28,null),type:"string"},title:{description:(0,T.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(31,null),type:"string"},id:{description:(0,T.localize)(32,null),type:"string"},title:{description:(0,T.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(37,null),type:"boolean",default:!0}}};function E(){L.Registry.as(R.Extensions.Configuration).registerConfiguration(f),S()}e.registerTerminalPlatformConfiguration=E;let u;function S(g,b){const y=L.Registry.as(R.Extensions.Configuration);let w;g&&(w=(0,k.createProfileSchemaEnums)(g?.profiles,b));const o=u;u={id:"terminal",order:100,title:(0,T.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?w?.values:void 0,markdownEnumDescriptions:g?.os===3?w?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?w?.values:void 0,markdownEnumDescriptions:g?.os===2?w?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?w?.values:void 0,markdownEnumDescriptions:g?.os===1?w?.markdownDescriptions:void 0}}},y.updateConfigurations({add:[u],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(Z[197],te([0,1,37,49,8,4,19,69,193,87]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(t,r,n,s,c=process.env,l,h,d,p){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},L.isWindows?f(n,l,c,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),p,d):w(l,h,n,t&&typeof t=="object"?{...t}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),p,d,c)}e.detectAvailableProfiles=C;async function f(t,r,n,s,c,l,h,d,p){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let v=!1;(0,m.getWindowsBuildNumber)()>=16299&&(v=!0),await S(d);const U=new Map;t&&(U.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0})),o(l,U);const F=await E(U.entries(),h,r,n,s,p);if(t||!t&&c)try{const z=await b(`${O}\\${v?"wsl":"bash"}.exe`,h);for(const H of z)(!l||!(H.profileName in l))&&F.push(H)}catch(z){s?.info("WSL is not installed, so could not detect WSL profiles")}return F}async function E(t,r,n,s=process.env,c,l){const h=[];for(const[d,p]of t){if(p===null)continue;let A,O,v;if("source"in p){const z=i?.get(p.source);if(!z)continue;A=z.paths,O=p.args||z.args,p.icon?v=u(p.icon):z.icon&&(v=z.icon)}else A=Array.isArray(p.path)?p.path:[p.path],O=L.isWindows||Array.isArray(p.args)?p.args:void 0,v=u(p.icon)||void 0;const U=await l?.(A)||A.slice(),F=await a(d,r,U,n,s,O,p.env,p.overrideName,p.isAutoDetected,c);F?(F.isAutoDetected=p.isAutoDetected,F.icon=v,F.color=p.color,h.push(F)):c?.trace("profile not validated",d,A)}return h}function u(t){return typeof t=="string"?{id:t}:t}async function S(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await g(),icon:I.ThemeIcon.asThemeIcon(T.Codicon.terminalPowershell)}))}async function g(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const n=[],s=await new Promise((h,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(p,A)=>{if(p)return d("Problem occurred when getting wsl distros");h(A)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),l=s.split(c).filter(h=>h.trim().length>0&&h!=="");for(const h of l){if(h===""||h.startsWith("docker-desktop"))continue;const d=`${h} (WSL)`,p={profileName:d,path:t,args:["-d",`${h}`],isDefault:d===r,icon:y(h)};n.push(p)}return n}function y(t){return t.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(T.Codicon.terminalUbuntu):t.includes("Debian")?I.ThemeIcon.asThemeIcon(T.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(T.Codicon.terminalLinux)}async function w(t,r,n,s,c,l,h,d){const p=new Map;if(n){const A=(await t.readFile("/etc/shells")).toString(),O=l||A.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),v=new Map;for(const U of O){let F=(0,R.basename)(U),z=v.get(F)||0;z++,z>1&&(F=`${F} (${z})`),v.set(F,z),p.set(F,{path:U,isAutoDetected:!0})}}return o(s,p),await E(p.entries(),c,t,d,r,h)}function o(t,r){if(!!t)for(const[n,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(n):r.set(n,s)}async function a(t,r,n,s,c,l,h,d,p,A){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return a(t,r,n,s,c,l,h,d,p);const v={profileName:t,path:O,args:l,env:h,overrideName:d,isAutoDetected:p,isDefault:t===r};if((0,R.basename)(O)===O){const F=c.PATH?c.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(O,void 0,F,void 0,s.existsFile)?v:a(t,r,n,s,c,l)}return await s.existsFile((0,R.normalize)(O))?v:a(t,r,n,s,c,l,h,d,p)}}),define(Z[198],te([0,1,3,2,15,4,36,52,21,12,72,158,13,80,20,191,86,196,197]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let o=0,a=class extends T.Disposable{constructor(r,n,s,c,l){super();this._reconnectConstants=r,this._configurationService=n,this._environmentService=s,this._logService=c,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,b.registerTerminalPlatformConfiguration)(),this._shellEnv=L.isWindows?Promise.resolve(process.env):(0,C.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,T.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:o,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?r.debugBrk=n.port:!n.break&&n.port&&(r.debug=n.port));const s=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,r);this._onPtyHostStart.fire(),k.ProxyChannel.toService(s.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(s.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=s.getChannel(g.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const h=k.ProxyChannel.toService(s.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(h.onProcessData(d=>this._onProcessData.fire(d))),this._register(h.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(h.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(h.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(h.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(h.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(h.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(h.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(h.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(h.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(h.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(h.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[s,h]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,n,s,c,l,h,d,p,A,O,v){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(r,n,s,c,l,h,d,p,A,O,v);return clearTimeout(U),o=Math.max(o,F),F}updateTitle(r,n,s){return this._proxy.updateTitle(r,n,s)}updateIcon(r,n,s){return this._proxy.updateIcon(r,n,s)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,n){return this._proxy.shutdown(r,n)}input(r,n){return this._proxy.input(r,n)}processBinary(r,n){return this._proxy.processBinary(r,n)}resize(r,n,s){return this._proxy.resize(r,n,s)}acknowledgeDataEvent(r,n){return this._proxy.acknowledgeDataEvent(r,n)}setUnicodeVersion(r,n){return this._proxy.setUnicodeVersion(r,n)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,n,s,c=!1){const l=await this._shellEnv;return(0,y.detectAvailableProfiles)(n,s,c,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,n){return this._proxy.requestDetachInstance(r,n)}async acceptDetachInstanceReply(r,n){return this._proxy.acceptDetachInstanceReply(r,n)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r){return this._proxy.reviveTerminalProcesses(r)}async refreshProperty(r,n){return this._proxy.refreshProperty(r,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:n})}async acceptPtyHostResolvedVariables(r,n){this._resolveVariablesRequestStore.acceptReply(r,n)}};a=fe([J(1,m.IConfigurationService),J(2,I.IEnvironmentService),J(3,f.ILogService),J(4,u.ITelemetryService)],a),e.PtyHostService=a}),define(Z[54],te([0,1,45]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(k,P,m,I){const i=(0,D.setProperty)(k,P,m,I)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=T;function R(k,P,m){let I=m;for(;I>=0;){if(k.charAt(I)===P.charAt(P.length-1)&&P.length===1)return I+1;if(I--,P.length===2&&I>=0&&k.charAt(I)===P.charAt(0))return I+2}return 0}e.getLineStartOffset=R;function L(k,P,m){let I=m;for(;I>=0;)if(k.charAt(I)===P.charAt(P.length-1)&&P.length===1||(I++,P.length===2&&I>=0&&k.charAt(I)===P.charAt(1)))return I;return k.length-1}e.getLineEndOffset=L}),define(Z[199],te([0,1,26,58]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(C,f,E,u,S){const g=[],b=[],y=[];if(!f){const O=C.filter(({identifier:v})=>S.every(U=>U.toLowerCase()!==v.id.toLowerCase()));return{local:{added:g,removed:b,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}C=C.map(I),f=f.map(I),E=E?E.map(I):null;const w=new Map,o=O=>{O.uuid&&w.set(O.id.toLowerCase(),O.uuid)};C.forEach(({identifier:O})=>o(O)),f.forEach(({identifier:O})=>o(O)),E&&E.forEach(({identifier:O})=>o(O));const a=O=>{const v=O.identifier.uuid||w.get(O.identifier.id.toLowerCase());return v?`uuid:${v}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,v)=>(O.set(a(v),v),O),r=C.reduce(t,new Map),n=f.reduce(t,new Map),s=f.reduce((O,v)=>{const U=a(v);v=(0,D.deepClone)(v);const F=r.get(U);return F&&(F.installed&&(v.installed=!0),v.version||(v.version=F.version)),t(O,v)},new Map),c=E?E.reduce(t,new Map):null,l=u.reduce(t,new Map),h=S.reduce((O,v)=>{const U=w.get(v.toLowerCase());return O.add(U?`uuid:${U}`:`id:${v.toLowerCase()}`)},new Set),d=L(r,n,h);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const O=L(c,r,h),v=L(c,n,h),U=(F,z)=>{const H=r.get(F);if(H){const M=n.get(F);return{...z?M:H,version:(M.version&&T.gt(M.version,H.version),H.version),state:k(H,M,c?.get(F))}}};for(const F of v.removed.values()){const z=r.get(F);z&&b.push(z.identifier)}for(const F of v.added.values())if(O.added.has(F)){if(d.updated.has(F)){const z=U(F,!0);z&&(y.push(i(z,F)),s.set(F,z))}}else{const z=n.get(F);z.installed&&g.push(i(z,F))}for(const F of v.updated.values()){const z=U(F,!0);z&&(y.push(i(z,F)),s.set(F,z))}for(const F of O.added.values())v.added.has(F)||s.set(F,r.get(F));for(const F of O.updated.values())if(!v.removed.has(F)&&!v.updated.has(F)){const z=U(F,!1);z&&(s.get(F)?.installed&&(z.installed=!0),s.set(F,z))}for(const F of O.removed.values())!l.has(F)&&!v.updated.has(F)&&c?.get(F)?.installed&&s.delete(F)}const p=[],A=L(n,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&s.forEach((O,v)=>p.push(i(O,v))),{local:{added:g,removed:b,updated:y},remote:p.length?{added:[...A.added].map(O=>s.get(O)),updated:[...A.updated].map(O=>s.get(O)),removed:[...A.removed].map(O=>n.get(O)),all:p}:null}}e.merge=R;function L(C,f,E,{checkInstalledProperty:u,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=C?[...C.keys()].filter(a=>!E.has(a)):[],b=[...f.keys()].filter(a=>!E.has(a)),y=b.filter(a=>g.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),w=g.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of g){if(w.has(a))continue;const t=C.get(a),r=f.get(a);(!r||t.disabled!==r.disabled||!m(t.state,r.state)||S&&t.version!==r.version||u&&t.installed!==r.installed)&&o.add(a)}return{added:y,removed:w,updated:o}}function k(C,f,E){const u=C.state,S=f.state,g=E?.state;if(!f.version||u&&T.gt(C.version,f.version))return u;if(S&&T.gt(f.version,C.version)||!u)return S;if(!S)return u;const b=(0,D.deepClone)(u),y=g?P(g,S):{added:Object.keys(S).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},w=g?P(g,u):{added:Object.keys(u).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...y.added.values(),...y.updated.values()])b[o]=S[o];for(const o of y.removed.values())w.updated.has(o)||delete b[o];return b}function P(C,f){const E=Object.keys(C),u=Object.keys(f),S=u.filter(y=>E.indexOf(y)===-1).reduce((y,w)=>(y.add(w),y),new Set),g=E.filter(y=>u.indexOf(y)===-1).reduce((y,w)=>(y.add(w),y),new Set),b=new Set;for(const y of E){if(g.has(y))continue;const w=C[y],o=f[y];(0,D.equals)(w,o)||b.add(y)}return{added:S,removed:g,updated:b}}function m(C={},f={}){const{added:E,removed:u,updated:S}=P(C,f);return E.size===0&&u.size===0&&S.size===0}function I(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function i(C,f){const E={identifier:{id:C.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return C.version&&(E.version=C.version),C.disabled&&(E.disabled=!0),C.installed&&(E.installed=!0),C.state&&(E.state=C.state),E}}),define(Z[88],te([0,1,17,3,2,32,7,29,22]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const I=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class tt extends R.Disposable{constructor(f,E){super();this.storageService=f,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(f){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const E=I.exec(f);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const f=this.storageService.keys(0,1);for(const E of f){const u=tt.fromKey(E);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=tt.fromKey(f.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,E){this.storageService.store(tt.toKey(f),JSON.stringify(E),0,1)}getKeysForSync(f){const E=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],u=this.storageService.get(tt.toKey(f),0),S=u?JSON.parse(u):void 0;return S&&E?(0,D.distinct)([...S,...E]):S||E}};i=fe([J(0,m.IStorageService),J(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(Z[89],te([0,1,17,21,7]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return I=I.filter(i=>i!==P&&i!==`-${P}`),m&&I.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}updateSynchronizedExtensions(P,m){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return I=I.filter(i=>i!==P&&i!==`-${P}`),m&&I.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}getIgnoredExtensions(P){const m=P.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),i=[],C=[];if(Array.isArray(I))for(const f of I)f.startsWith("-")?C.push(f.substring(1)):i.push(f);return(0,D.distinct)([...m,...i].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};L=fe([J(0,T.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(Z[200],te([0,1,17,34,26,150,54]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,T.parse)(o)||[]}e.parseKeybindings=P;async function m(o,a,t,r,n){const s=P(o),c=P(a),l=t?P(t):null,h=[...s,...c,...l||[]].map(j=>j.key),d=await n.resolveUserBindings(h);let p=i(s,c,l,d);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const A=f(s),O=f(c),v=l?f(l):null,U=u(A,O,d),F=v?u(v,A,d):{added:[...A.keys()].reduce((j,q)=>(j.add(q),j),new Set),removed:new Set,updated:new Set},z=v?u(v,O,d):{added:[...O.keys()].reduce((j,q)=>(j.add(q),j),new Set),removed:new Set,updated:new Set},H=I(U,F,z);let M=o;for(const j of H.removed.values())H.conflicts.has(j)||(M=y(M,j,r));for(const j of H.added.values()){if(H.conflicts.has(j))continue;const q=O.get(j);if(q.some(x=>x.command!==`-${j}`&&p.conflicts.has(d[x.key]))){H.conflicts.add(j);continue}M=b(M,q,r)}for(const j of H.updated.values()){if(H.conflicts.has(j))continue;const q=O.get(j);if(q.some(x=>x.command!==`-${j}`&&p.conflicts.has(d[x.key]))){H.conflicts.add(j);continue}M=w(M,j,q,r)}return{mergeContent:M,hasChanges:!0,hasConflicts:H.conflicts.size>0}}e.merge=m;function I(o,a,t){const r=new Set,n=new Set,s=new Set,c=new Set;for(const l of a.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(a.updated.has(l)?c.add(l):n.add(l));for(const l of a.added.values())c.has(l)||t.added.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(a.added.has(l)?o.updated.has(l)&&c.add(l):r.add(l));for(const l of a.updated.values())c.has(l)||t.updated.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(a.updated.has(l)?o.updated.has(l)&&c.add(l):s.add(l));return{added:r,removed:n,updated:s,conflicts:c}}function i(o,a,t,r){const n=new Set,s=C(o,r),c=C(a,r),l=t?C(t,r):null,h=E(s,c);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?E(l,s):{added:[...s.keys()].reduce((F,z)=>(F.add(z),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=l?E(l,c):{added:[...c.keys()].reduce((F,z)=>(F.add(z),F),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:O,updated:v,conflicts:U}=I(h,d,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:v,conflicts:U}}function C(o,a){const t=new Map;for(const r of o){const n=a[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function f(o){const a=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(r);n||(n=[],a.set(r,n)),n.push(t)}return a}function E(o,a){const t=[...o.keys()],r=[...a.keys()],n=r.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),s=t.filter(l=>r.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=new Set;for(const l of t){if(s.has(l))continue;const h=o.get(l).map(p=>({...p,key:l})),d=a.get(l).map(p=>({...p,key:l}));(0,D.equals)(h,d,(p,A)=>g(p,A))||c.add(l)}return{added:n,removed:s,updated:c}}function u(o,a,t){const r=[...o.keys()],n=[...a.keys()],s=n.filter(h=>r.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),c=r.filter(h=>n.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),l=new Set;for(const h of r){if(c.has(h))continue;const d=o.get(h).map(A=>({...A,key:t[A.key]})),p=a.get(h).map(A=>({...A,key:t[A.key]}));S(d,p)||l.add(h)}return{added:s,removed:c,updated:l}}function S(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>g(t,r))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>g(t,r)))}function g(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=L.ContextKeyExpr.deserialize(o.when),r=L.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!R.equals(o.args,a.args))}function b(o,a,t){for(const r of a)o=k.edit(o,[-1],r,t);return o}function y(o,a,t){const r=P(o);for(let n=r.length-1;n>=0;n--)(r[n].command===a||r[n].command===`-${a}`)&&(o=k.edit(o,[n],void 0,t));return o}function w(o,a,t,r){const n=P(o),s=n.findIndex(c=>c.command===a||c.command===`-${a}`);for(let c=n.length-1;c>=0;c--)(n[c].command===a||n[c].command===`-${a}`)&&(o=k.edit(o,[c],void 0,r));for(let c=t.length-1;c>=0;c--)o=k.edit(o,[s],t[c],r);return o}}),define(Z[201],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,k,P){const m={},I={},i=new Set;if(!k)return{local:{added:m,updated:I,removed:[...i.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const C=T(L,k);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:m,updated:I,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=T(P,L),E=T(P,k),u={},S={},g=new Set,b=new Set;for(const y of f.removed.values())E.updated.has(y)?m[y]=k[y]:g.add(y);for(const y of E.removed.values())b.has(y)||(f.updated.has(y)?b.add(y):i.add(y));for(const y of f.updated.values())b.has(y)||(E.updated.has(y)?C.updated.has(y)&&b.add(y):S[y]=L[y]);for(const y of E.updated.values())b.has(y)||(f.updated.has(y)?C.updated.has(y)&&b.add(y):L[y]!==void 0&&(I[y]=k[y]));for(const y of f.added.values())b.has(y)||(E.added.has(y)?C.updated.has(y)&&b.add(y):u[y]=L[y]);for(const y of E.added.values())b.has(y)||(f.added.has(y)?C.updated.has(y)&&b.add(y):m[y]=k[y]);return{local:{added:m,removed:[...i.values()],updated:I},remote:{added:u,removed:[...g.values()],updated:S},conflicts:[...b.values()]}}e.merge=D;function T(L,k){const P=L?Object.keys(L):[],m=k?Object.keys(k):[],I=m.filter(f=>P.indexOf(f)===-1).reduce((f,E)=>(f.add(E),f),new Set),i=P.filter(f=>m.indexOf(f)===-1).reduce((f,E)=>(f.add(E),f),new Set),C=new Set;for(const f of P){if(i.has(f))continue;const E=L[f],u=k[f];E!==u&&C.add(f)}return{added:I,removed:i,updated:C}}function R(L,k){const{added:P,removed:m,updated:I}=T(L,k);return P.size===0&&m.size===0&&I.size===0}e.areSame=R}),define(Z[23],te([0,1,17,16,18,134,39,28,7,82,33]),function(K,e,D,T,R,L,k,P,m,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(h=>!!l[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),p=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...d,...p])}e.getDefaultIgnoredSettings=f;function E(){const l="vscode://schemas/ignoredSettings",h=i.Registry.as(k.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(I.Extensions.JSONContribution),p=()=>{const A=C(),O=f().filter(z=>z!==e.CONFIGURATION_SYNC_STORE_KEY),v=Object.keys(k.allSettings.properties).filter(z=>O.indexOf(z)===-1),U=O.filter(z=>A.indexOf(z)===-1),F={items:{type:"string",enum:[...v,...U.map(z=>`-${z}`)]}};d.registerSchema(l,F)};return h.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=E;function u(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=u;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function g(l,h,d){return d.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=g,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(l){const h={};return h[e.HEADER_EXECUTION_ID]=l,h}e.createSyncHeaders=b;var y;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(h,d,p,A){super(h);this.code=d,this.resource=p,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class o extends w{constructor(h,d,p,A,O){super(h,p,void 0,O);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=o;class a extends w{constructor(h,d){super(h,d)}}e.UserDataAutoSyncError=a,function(l){function h(d){if(d instanceof l)return d;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(p&&p[1]){const A=p[2]==="unknown"?void 0:p[2],O=p[3]==="unknown"?void 0:p[3];return new l(d.message,p[1],A,O)}return new l(d.message,"Unknown")}l.toUserDataSyncError=h}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(l){return`sync.enable.${l}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(l,h){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,T.isEqualOrParent)(l,(0,T.joinPath)(h.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Z[47],te([0,1,17,6,25,27,3,34,2,16,24,18,5,130,21,12,14,46,22,20,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=a;let t=class extends m.Disposable{constructor(l,h,d,p,A,O,v,U,F,z){super();this.resource=l,this.fileService=h,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=v,this.telemetryService=U,this.logService=F,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new T.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?I.extUri:I.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,b.getServiceMachineId)(d,h,p)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,L.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const h=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,h={}){await this._sync(l,!0,h)}async preview(l,h={}){return this._sync(l,!1,h)}async apply(l,h={}){try{this.syncHeaders={...h};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,h,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let p="idle";try{const A=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,A);return p=await this.performSync(O,A,h),p==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):p==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(p)}}finally{this.syncHeaders={}}}async replace(l){const h=await this.resolveContent(l);if(!h)return!1;const d=this.parseSyncData(h);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const p=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,p),O=await this.isRemoteDataFromCurrentMachine(A),v=await this.generateSyncPreview({ref:A.ref,syncData:d},p,O,L.CancellationToken.None),U=[];for(const F of v){const z=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:H}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);U.push([F,{...z,remoteChange:H!==0?H:2}])}await this.applyResult(A,p,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const h=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===h}async getLatestRemoteUserData(l,h){if(h){const d=l&&l.latest?l.latest[this.resource]:void 0;if(h.ref===d||d===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(l,h,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,h,d)}catch(p){if(p instanceof o.UserDataSyncError)switch(p.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,h,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(l,h,d)}throw p}}async doSync(l,h,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,T.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(l,h,d,A)));const p=await this.syncPreviewPromise;return this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(p){throw this.syncPreviewPromise=null,p}}async merge(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,L.CancellationToken.None);await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d?.content||""));const p=d&&!d.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,L.CancellationToken.None):void 0;return h.acceptResult=p,h.mergeState=d.hasConflicts?"conflict":p?"accepted":"preview",h.localChange=p?p.localChange:d.localChange,h.remoteChange=p?p.remoteChange:d.remoteChange,h}),this.syncPreviewPromise}async accept(l,h){return await this.updateSyncResourcePreview(l,async d=>{const p=await this.getAcceptResult(d,l,h,L.CancellationToken.None);return d.acceptResult=p,d.mergeState="accepted",d.localChange=p.localChange,d.remoteChange=p.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,L.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=d.localChange,h.remoteChange=d.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(l,h){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const p=d.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:v})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(O,l)||this.extUri.isEqual(v,l));p!==-1&&(this.syncPreviewPromise=(0,T.createCancelablePromise)(async A=>{const O=[...d.resourcePreviews];return O[p]=await h(O[p]),{...d,resourcePreviews:O}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const h=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,h,(d,p)=>this.extUri.isEqual(d.previewResource,p.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return f.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return f.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(l){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const d of h.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,h,d,p){const A=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,h,A,p),v=[];for(const U of O){const F=U.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)v.push({...U,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=d?await this.getMergeResult(U,p):void 0;if(p.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(z?.content||""));const H=z&&!z.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,p):void 0;v.push({...U,acceptResult:H,mergeState:z?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:z?z.localChange:U.localChange,remoteChange:H?H.remoteChange:z?z.remoteChange:U.remoteChange})}}return{remoteUserData:l,lastSyncUserData:h,resourcePreviews:v,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&d&&h.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const p=h;if(p.content===null)return{ref:h.ref,syncData:null};const A=JSON.parse(p.content);if(a(A))return{...h,syncData:A,content:void 0}}catch(l){l instanceof g.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),p={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(p)))}async getRemoteUserData(l){const{ref:h,content:d}=await this.getUserData(l);let p=null;return d!==null&&(p=this.parseSyncData(d)),{ref:h,syncData:p}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}throw new o.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:h}}else{const h=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(l,h){const d=await this.currentMachineIdPromise,p={version:this.version,machineId:d,content:l};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(p),h,this.syncHeaders),{ref:h,syncData:p}}async backupLocal(l){const h={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([J(1,g.IFileService),J(2,S.IEnvironmentService),J(3,y.IStorageService),J(4,o.IUserDataSyncStoreService),J(5,o.IUserDataSyncBackupStoreService),J(6,o.IUserDataSyncResourceEnablementService),J(7,w.ITelemetryService),J(8,o.IUserDataSyncLogService),J(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(l,h,d,p,A,O,v,U,F,z,H){super(h,d,p,A,O,v,U,F,z,H);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,h,d){try{h?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:h):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(p){throw p instanceof g.FileOperationError&&p.fileOperationResult===1||p instanceof g.FileOperationError&&p.fileOperationResult===3?new o.UserDataSyncError(p.message,"LocalPreconditionFailed"):p}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};r=fe([J(2,g.IFileService),J(3,S.IEnvironmentService),J(4,y.IStorageService),J(5,o.IUserDataSyncStoreService),J(6,o.IUserDataSyncBackupStoreService),J(7,o.IUserDataSyncResourceEnablementService),J(8,w.ITelemetryService),J(9,o.IUserDataSyncLogService),J(10,u.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(l,h,d,p,A,O,v,U,F,z,H,M){super(l,h,d,p,A,O,v,U,F,z,M);this.userDataSyncUtilService=H,this._formattingOptions=void 0}hasErrors(l){const h=[];return(0,P.parse)(l,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=fe([J(2,g.IFileService),J(3,S.IEnvironmentService),J(4,y.IStorageService),J(5,o.IUserDataSyncStoreService),J(6,o.IUserDataSyncBackupStoreService),J(7,o.IUserDataSyncResourceEnablementService),J(8,w.ITelemetryService),J(9,o.IUserDataSyncLogService),J(10,o.IUserDataSyncUtilService),J(11,u.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let s=class{constructor(l,h,d,p){this.resource=l,this.environmentService=h,this.logService=d,this.fileService=p,this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?I.extUri:I.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,h,I.extUri)}async initialize({ref:l,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(h);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,h={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};s=fe([J(1,S.IEnvironmentService),J(2,o.IUserDataSyncLogService),J(3,g.IFileService)],s),e.AbstractInitializer=s}),define(Z[202],te([0,1,6,27,9,3,45,48,24,5,21,12,28,32,14,22,20,47,199,88,89,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,h){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const p=(await h.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&p.every(O=>!(0,E.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return d}function r(l,h,d){const p=d.get((0,E.getExtensionId)(l,h),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=r;function n(l,h,d,p){p.store((0,E.getExtensionId)(l,h),JSON.stringify(d),0,1)}e.storeExtensionStorageState=n;let s=class lt extends b.AbstractSynchroniser{constructor(h,d,p,A,O,v,U,F,z,H,M,j,q,x){super("extensions",d,h,p,A,O,j,q,z,M);this.storageService=p,this.extensionManagementService=v,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=H,this.extensionsStorageSyncService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:N})=>!!N)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,d){const p=h.syncData?await t(h.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],O=d?.syncData?await t(d.syncData,this.extensionManagementService):null,v=await this.extensionManagementService.getInstalled(),U=this.getLocalExtensions(v),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(v);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:H}=(0,y.merge)(U,p,O,A,F),M={local:z,remote:H,content:this.getPreviewContent(U,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(U),localExtensions:U,remoteResource:this.remoteResource,remoteContent:p?this.format(p):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,d,p,A){const O=[...d,...p],v=new Set,U=F=>{v.add(F.id.toLowerCase()),F.uuid&&v.add(F.uuid)};O.forEach(({identifier:F})=>U(F)),A.forEach(U);for(const F of h)v.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&v.has(F.identifier.uuid)||O.push(F);return this.format(O)}async getMergeResult(h,d){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,d,p,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(d,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(h){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,y.merge)(h.localExtensions,null,null,h.skippedExtensions,p),{local:O,remote:v}=A;return{content:h.localContent,local:O,remote:v,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:v!==null?2:0}}async acceptRemote(h){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=h.remoteContent?JSON.parse(h.remoteContent):null;if(A!==null){const O=(0,y.merge)(h.localExtensions,A,h.localExtensions,[],p),{local:v,remote:U}=O;return{content:h.remoteContent,local:v,remote:U,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,d,p,A){let{skippedExtensions:O,localExtensions:v}=p[0][0],{local:U,remote:F,localChange:z,remoteChange:H}=p[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(v)),O=await this.updateLocalExtensions(U.added,U.removed,U.updated,O)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(F.all);h=await this.updateRemoteUserData(M,A?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(j=>j.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(j=>j.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(j=>j.identifier.id))}.`:""}`)}d?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:lt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,lt.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),O=this.getLocalExtensions(p).filter(v=>!A.some(U=>(0,E.areSameExtensions)({id:U},v.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let d=await super.resolveContent(h);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(h)),d){const p=this.parseSyncData(d);if(p)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(p))}}return null}format(h){h.sort((A,O)=>!A.identifier.uuid&&O.identifier.uuid?-1:A.identifier.uuid&&!O.identifier.uuid?1:(0,m.compare)(A.identifier.id,O.identifier.id));const d=JSON.stringify(h),p=(0,P.format)(d,void 0,{});return(0,k.applyEdits)(d,p)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(p=>p.installed||p.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,d,p,A){const O=[],v=[],U=await this.extensionManagementService.getInstalled();if(d.length){const z=U.filter(({identifier:H,isBuiltin:M})=>!M&&d.some(j=>(0,E.areSameExtensions)(H,j)));await D.Promises.settled(z.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),O.push(H.identifier)}))}(h.length||p.length)&&await D.Promises.settled([...h,...p].map(async z=>{const H=U.find(j=>(0,E.areSameExtensions)(j.identifier,z.identifier));if(H&&H.isBuiltin){z.state&&H.manifest.version===z.version&&this.updateExtensionState(z.state,H.manifest.publisher,H.manifest.name,H.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),O.push(z.identifier);return}const M=(await this.extensionGalleryService.getExtensions([z.identifier],T.CancellationToken.None))[0];if(z.state&&(H?H.manifest.version===z.version:!!M)){const j=H?H.manifest.publisher:M.publisher,q=H?H.manifest.name:M.name;this.updateExtensionState(z.state,j,q,H?.manifest.version)}if(M)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,M.version)),H||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),v.push(z)))}catch(j){v.push(z),j instanceof f.ExtensionManagementError&&j.code===f.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else v.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const F=[];for(const z of A)O.some(H=>(0,E.areSameExtensions)(H,z.identifier))||F.push(z);for(const z of v)F.some(H=>(0,E.areSameExtensions)(H.identifier,z.identifier))||F.push(z);return F}updateExtensionState(h,d,p,A){const O=r(d,p,this.storageService),v=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(d,p),version:A}):void 0;v?v.forEach(U=>{O[U]=h[U]}):Object.keys(h).forEach(U=>O[U]=h[U]),n(d,p,O,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const d=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:p,isBuiltin:A,manifest:O})=>{const v={identifier:p,version:O.version};d.some(U=>(0,E.areSameExtensions)(U,p))&&(v.disabled=!0),A||(v.installed=!0);try{const U=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:O.version});if(U){const F=r(O.publisher,O.name,this.storageService);v.state=Object.keys(F).reduce((z,H)=>(U.includes(H)&&(z[H]=F[H]),z),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(U))}return v})}};s.EXTENSIONS_DATA_URI=I.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=fe([J(0,C.IEnvironmentService),J(1,u.IFileService),J(2,S.IStorageService),J(3,a.IUserDataSyncStoreService),J(4,a.IUserDataSyncBackupStoreService),J(5,f.IExtensionManagementService),J(6,f.IGlobalExtensionEnablementService),J(7,o.IIgnoredExtensionsManagementService),J(8,a.IUserDataSyncLogService),J(9,f.IExtensionGalleryService),J(10,i.IConfigurationService),J(11,a.IUserDataSyncResourceEnablementService),J(12,g.ITelemetryService),J(13,w.IExtensionsStorageSyncService)],s),e.ExtensionsSynchroniser=s;let c=class extends b.AbstractInitializer{constructor(h,d,p,A,O){super("extensions",A,O,p);this.extensionManagementService=h,this.ignoredExtensionsManagementService=d}async parseExtensions(h){return h.syncData?await t(h.syncData,this.extensionManagementService):null}generatePreview(h,d){const p=[],A=[],O=[];for(const v of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(v.identifier.id))continue;const U=d.find(F=>(0,E.areSameExtensions)(F.identifier,v.identifier));U?(p.push(U),v.disabled&&O.push(v.identifier)):v.installed&&(A.push(v.identifier),v.disabled&&O.push(v.identifier))}return{installedExtensions:p,newExtensions:A,disabledExtensions:O,remoteExtensions:h}}};c=fe([J(0,f.IExtensionManagementService),J(1,o.IIgnoredExtensionsManagementService),J(2,u.IFileService),J(3,C.IEnvironmentService),J(4,a.IUserDataSyncLogService)],c),e.AbstractExtensionsInitializer=c}),define(Z[203],te([0,1,26,23]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,I,i,C){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=L(P,m);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=I?L(I,m):{added:Object.keys(m).reduce((y,w)=>(y.add(w),y),new Set),removed:new Set,updated:new Set},u=I?L(I,P):{added:Object.keys(P).reduce((y,w)=>(y.add(w),y),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},g=D.deepClone(m),b=!I;for(const y of u.added.values())y!==T.SYNC_SERVICE_URL_TYPE&&b&&E.added.has(y)||(g[y]=P[y]);for(const y of u.updated.values())g[y]=P[y];for(const y of u.removed.values())i.unregistered.includes(y)||delete g[y];for(const y of E.added.values()){const w=m[y];if(i.machine.includes(y)){C.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(I&&u.added.has(y))continue;const o=P[y];o&&o.value===w.value||y===T.SYNC_SERVICE_URL_TYPE&&b&&u.added.has(y)||(o?S.updated[y]=w:S.added[y]=w)}for(const y of E.updated.values()){const w=m[y];if(i.machine.includes(y)){C.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(y)||u.removed.has(y))continue;const o=P[y];o&&o.value===w.value||(S.updated[y]=w)}for(const y of E.removed.values()){if(i.machine.includes(y)){C.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}u.updated.has(y)||u.removed.has(y)||S.removed.push(y)}return{local:S,remote:k(g,m)?null:g}}e.merge=R;function L(P,m){const I=Object.keys(P),i=Object.keys(m),C=i.filter(u=>I.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),f=I.filter(u=>i.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),E=new Set;for(const u of I){if(f.has(u))continue;const S=P[u],g=m[u];D.equals(S,g)||E.add(u)}return{added:C,removed:f,updated:E}}function k(P,m){const{added:I,removed:i,updated:C}=L(P,m);return I.size===0&&i.size===0&&C.size===0}}),define(Z[204],te([0,1,25,3,34,45,48,4,5,30,21,12,14,13,46,22,20,47,54,203,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(h){const d=h.storage?Object.keys(h.storage).sort():[],p={};d.forEach(v=>p[v]=h.storage[v]),h.storage=p;const A=JSON.stringify(h),O=(0,k.format)(A,void 0,{});return(0,L.applyEdits)(A,O)}const n=1;let s=class ut extends b.AbstractSynchroniser{constructor(d,p,A,O,v,U,F,z,H){super("globalState",d,v,H,p,A,U,F,O,z);this.storageService=H,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(d.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),T.Event.filter(H.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:H.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,p,A,O){const v=d.syncData?JSON.parse(d.syncData.content):null;p=p===null&&A?d:p;const U=p&&p.syncData?JSON.parse(p.syncData.content):null,F=await this.getLocalGlobalState();v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys(U),{local:H,remote:M}=(0,w.merge)(F.storage,v?v.storage:null,U?U.storage:null,z,this.logService),j={content:null,local:H,remote:M,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:r(F),localUserData:F,remoteResource:this.remoteResource,remoteContent:v?r(v):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(d,p){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,p,A,O){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(p,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const p=JSON.parse(d.remoteContent),{local:A,remote:O}=(0,w.merge)(d.localUserData.storage,p.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:O,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,p,A,O){let{localUserData:v}=A[0][0],{local:U,remote:F,localChange:z,remoteChange:H}=A[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(v)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:F});d=await this.updateRemoteUserData(M,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}p?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ut.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ut.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return r(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let p=await super.resolveContent(d);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(d)),p){const A=this.parseSyncData(p);if(A)switch(this.extUri.basename(d)){case"globalState.json":return r(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},p=await this.getLocalArgvContent(),A=(0,R.parse)(p);for(const O of t)A[O]!==void 0&&(d[`${a}${O}`]={version:1,value:A[O]});for(const O of this.storageService.keys(0,0)){const v=this.storageService.get(O,0);v&&(d[O]={version:1,value:v})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:p,updated:A}){const O={},v={},U=(z,H)=>{for(const M of z){if(M.startsWith(a)){O[M.substring(a.length)]=H?H[M].value:void 0;continue}if(H){const j=H[M];j.value!==String(this.storageService.get(M,0))&&(v[M]=j.value)}else this.storageService.get(M,0)!==void 0&&(v[M]=void 0)}};if(U(Object.keys(d),d),U(Object.keys(A),A),U(p),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(v).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(v))this.storageService.store(z,v[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(v))}}async updateArgv(d){const p=await this.getLocalArgvContent();let A=p;for(const O of Object.keys(d))A=(0,y.edit)(A,[O],d[O],{});p!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const p=this.storageService.keys(0,0),A=this.storageService.keys(0,1),O=[...p,...A],v=d?.storage?Object.keys(d.storage).filter(U=>!U.startsWith(a)&&!O.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!P.isWeb){const U=[...o.ALL_SYNC_RESOURCES.map(F=>(0,o.getEnablementKey)(F)),o.SYNC_SERVICE_URL_TYPE];v.push(...U),A.push(...U)}return{user:p,machine:A,unregistered:v}}};s.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=fe([J(0,f.IFileService),J(1,o.IUserDataSyncStoreService),J(2,o.IUserDataSyncBackupStoreService),J(3,o.IUserDataSyncLogService),J(4,C.IEnvironmentService),J(5,o.IUserDataSyncResourceEnablementService),J(6,g.ITelemetryService),J(7,i.IConfigurationService),J(8,S.IStorageService)],s),e.GlobalStateSynchroniser=s;let c=class extends b.AbstractInitializer{constructor(d,p,A,O){super("globalState",A,O,p);this.storageService=d}async doInitialize(d){const p=d.syncData?JSON.parse(d.syncData.content):null;if(!p){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},O={};for(const v of Object.keys(p.storage))v.startsWith(a)?A[v.substring(a.length)]=p.storage[v].value:this.storageService.get(v,0)===void 0&&(O[v]=p.storage[v].value);if(Object.keys(A).length){let v="{}";try{v=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(U){}for(const U of Object.keys(A))v=(0,y.edit)(v,[U],A[U],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(v))}if(Object.keys(O).length)for(const v of Object.keys(O))this.storageService.store(v,O[v],0,0)}};c=fe([J(0,S.IStorageService),J(1,f.IFileService),J(2,C.IEnvironmentService),J(3,o.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(d,p,A,O,v){this.userDataSyncStoreClient=d,this.storageService=p,this.environmentService=A,this.fileService=O,this.logService=v}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const p=(0,o.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(d,p)}catch(A){if(A instanceof o.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,p)}throw A}}async doSync(d,p){const A=await this.userDataSyncStoreClient.read("globalState",null,p),O=this.parseGlobalState(A)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const v=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:n,machineId:v,content:r(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),A.ref,p)}parseGlobalState({content:d}){if(!d)return null;const p=JSON.parse(d);if((0,b.isSyncData)(p))return p?JSON.parse(p.content):null;throw new Error("Invalid remote data")}};l=fe([J(1,S.IStorageService),J(2,C.IEnvironmentService),J(3,f.IFileService),J(4,E.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[205],te([0,1,17,25,3,34,4,18,131,21,12,14,22,20,47,200,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(k.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let y=class extends u.AbstractJsonFileSynchroniser{constructor(a,t,r,n,s,c,l,h,d,p){super(l.keybindingsResource,"keybindings",c,l,h,a,t,s,p,r,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,n){const s=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),h=await this.getFormattingOptions();let d=null,p=!1,A=!1,O=!1;if(s){let U=l?l.value.toString():"[]";if(U=U||"[]",this.hasErrors(U))throw new g.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==U||c!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,S.merge)(U,s,c,h,this.userDataSyncUtilService);F.hasChanges&&(d=F.mergeContent,O=F.hasConflicts,p=O||F.mergeContent!==U,A=O||F.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const v={content:d,localChange:p?l?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:v.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:v.remoteChange,previewResource:this.previewResource,previewResult:v,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,n){const{fileContent:s}=r[0][0];let{content:c,localChange:l,remoteChange:h}=r[0][1];if(l===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new g.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(c||"[]",s,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(c||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,L.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return b(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,k.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=fe([J(0,g.IUserDataSyncStoreService),J(1,g.IUserDataSyncBackupStoreService),J(2,g.IUserDataSyncLogService),J(3,I.IConfigurationService),J(4,g.IUserDataSyncResourceEnablementService),J(5,C.IFileService),J(6,i.IEnvironmentService),J(7,f.IStorageService),J(8,g.IUserDataSyncUtilService),J(9,E.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let w=class extends u.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,T.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,L.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return b(a,!0)}catch(t){return this.logService.error(t),null}}};w=fe([J(0,C.IFileService),J(1,i.IEnvironmentService),J(2,g.IUserDataSyncLogService)],w),e.KeybindingsInitializer=w}),define(Z[206],te([0,1,17,34,45,48,26,54,23]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function I(l,h,d){let p=[];d?p=C(d):p=i(h);const A=[],O=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const v of p)v.startsWith("-")?O.push(v.substring(1)):A.push(v);return(0,D.distinct)([...l,...A].filter(v=>O.indexOf(v)===-1))}e.getIgnoredSettings=I;function i(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const h=(0,T.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function f(l,h,d,p){if(d.length){const A=c(h),O=(0,T.parse)(h),v=(0,T.parse)(l),U=[];for(const F of d){const z=O[F],H=v[F];z===void 0?l=P.edit(l,[F],void 0,p):H!==void 0?l=P.edit(l,[F],z,p):U.push(a(F,A))}U.sort((F,z)=>F.startOffset-z.startOffset),U.forEach(F=>l=b(F.setting.key,h,l,p))}return l}e.updateIgnoredSettings=f;function E(l,h,d,p,A,O){const v=f(l,h,p,O),U=d!==v,F=d!==h;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:v,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:f(h,l,p,O),remoteContent:null,hasConflicts:!1};if(d===null&&S(l)){const B=u(l,h,p)?null:f(h,l,p,O);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let z=l,H=h;const M=(0,T.parse)(l),j=(0,T.parse)(h),q=d?(0,T.parse)(d):null,x=p.reduce((B,re)=>(B.add(re),B),new Set),$=g(M,j,x),N=g(q,M,x),W=g(q,j,x),_=new Map,Y=new Set,G=B=>{Y.add(B);const re=A.filter(({key:ie})=>ie===B)[0];re?(z=P.edit(z,[B],re.value,O),H=P.edit(H,[B],re.value,O)):_.set(B,{key:B,localValue:M[B],remoteValue:j[B]})};for(const B of N.removed.values())W.updated.has(B)?G(B):H=P.edit(H,[B],void 0,O);for(const B of W.removed.values())Y.has(B)||(N.updated.has(B)?G(B):z=P.edit(z,[B],void 0,O));for(const B of N.updated.values())Y.has(B)||(W.updated.has(B)?$.updated.has(B)&&G(B):H=P.edit(H,[B],M[B],O));for(const B of W.updated.values())Y.has(B)||(N.updated.has(B)?$.updated.has(B)&&G(B):z=P.edit(z,[B],j[B],O));for(const B of N.added.values())Y.has(B)||(W.added.has(B)?$.updated.has(B)&&G(B):H=b(B,z,H,O));for(const B of W.added.values())Y.has(B)||(N.added.has(B)?$.updated.has(B)&&G(B):z=b(B,H,z,O));const ne=_.size>0||!u(z,H,p),ee=ne||!u(z,l,[]),X=ne||!u(H,h,[]);return{localContent:ee?z:null,remoteContent:X?H:null,conflictsSettings:[..._.values()],hasConflicts:ne}}e.merge=E;function u(l,h,d){if(l===h)return!0;const p=(0,T.parse)(l),A=(0,T.parse)(h),O=d.reduce((F,z)=>(F.add(z),F),new Set),v=c(l).filter(F=>!(F.setting&&O.has(F.setting.key))),U=c(h).filter(F=>!(F.setting&&O.has(F.setting.key)));if(v.length!==U.length)return!1;for(let F=0;F<v.length;F++){const z=v[F],H=U[F];if(z.setting&&H.setting){if(z.setting.key!==H.setting.key||!k.equals(p[z.setting.key],A[z.setting.key]))return!1}else if(!z.setting&&!H.setting){if(z.value!==H.value)return!1}else return!1}return!0}e.areSame=u;function S(l){return l?c(l).length===0:!0}e.isEmpty=S;function g(l,h,d){const p=l?Object.keys(l).filter(F=>!d.has(F)):[],A=Object.keys(h).filter(F=>!d.has(F)),O=A.filter(F=>p.indexOf(F)===-1).reduce((F,z)=>(F.add(z),F),new Set),v=p.filter(F=>A.indexOf(F)===-1).reduce((F,z)=>(F.add(z),F),new Set),U=new Set;if(l)for(const F of p){if(v.has(F))continue;const z=l[F],H=h[F];k.equals(z,H)||U.add(F)}return{added:O,removed:v,updated:U}}function b(l,h,d,p){const A=(0,T.parse)(h),O=c(h),v=c(d),U=y(l,O,v);return w(d,l,A[l],U,v,p)}e.addSetting=b;function y(l,h,d){const p=h.findIndex(O=>O.setting?.key===l),A=h[p-1];if(A){if(A.setting){const v=a(A.setting.key,d);if(v)return{index:d.indexOf(v),insertAfter:!0}}else{const v=t(p,h);if(v){const U=a(v.setting.key,d);if(U){const F=r(d.indexOf(U),d),z=n(h,v,h[p]);if(F){const H=n(d,U,F),M=s(z,H);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(F),insertAfter:!1}}else{const H=n(d,U,d[d.length-1]),M=s(z,H);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=h[p+1];if(O)if(O.setting){const v=a(O.setting.key,d);if(v)return{index:d.indexOf(v),insertAfter:!1}}else{const v=r(p,h);if(v){const U=a(v.setting.key,d);if(U){const F=t(d.indexOf(U),d),z=n(h,h[p],v);if(F){const H=n(d,F,U),M=s(z.reverse(),H.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(F),insertAfter:!0}}else{const H=n(d,d[0],U),M=s(z.reverse(),H.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function w(l,h,d,p,A,O){let v;return p.index===-1?v=(0,R.setProperty)(l,[h],d,O):v=o(l,h,d,p,A,O).map(U=>(0,R.withFormatting)(l,U,O)[0]),(0,R.applyEdits)(l,v)}function o(l,h,d,p,A,O){const v=`${JSON.stringify(h)}: ${JSON.stringify(d)}`,U=(0,L.getEOL)(O,l),F=A[p.index];if(p.insertAfter){const z=[];if(F.setting)z.push({offset:F.endOffset,length:0,content:","+v});else{const H=r(p.index,A),M=t(p.index,A),j=M?.setting?.commaOffset;M&&j===void 0&&z.push({offset:M.endOffset,length:0,content:","});const q=j!==void 0&&j>F.endOffset;z.push({offset:q?j+1:F.endOffset,length:0,content:H?U+v+",":U+v})}return z}else{if(F.setting)return[{offset:F.startOffset,length:0,content:v+","}];const z=(A[p.index-1]&&!A[p.index-1].setting?U:"")+v+(r(p.index,A)?",":"")+U;return[{offset:F.startOffset,length:0,content:z}]}}function a(l,h){return h.filter(d=>d.setting?.key===l)[0]}function t(l,h){for(let d=l-1;d>=0;d--)if(h[d].setting)return h[d]}function r(l,h){for(let d=l+1;d<h.length;d++)if(h[d].setting)return h[d]}function n(l,h,d){const p=l.indexOf(h),A=l.indexOf(d);return l.filter((O,v)=>p<v&&v<A)}function s(l,h){if(l.length&&h.length){let d=0;for(;d<h.length&&d<l.length;d++)if(l[d].value!==h[d].value)return h[d-1];return h[d-1]}}function c(l){const h=[];let d=-1,p,A;const O={onObjectBegin:v=>{d++},onObjectProperty:(v,U,F)=>{d===0&&(p=U,A=v)},onObjectEnd:(v,U)=>{d--,d===0&&h.push({startOffset:p,endOffset:v+U,value:l.substring(p,v+U),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(v,U)=>{d++},onArrayEnd:(v,U)=>{d--,d===0&&h.push({startOffset:p,endOffset:v+U,value:l.substring(p,v+U),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(v,U,F)=>{d===0&&h.push({startOffset:p,endOffset:U+F,value:l.substring(p,U+F),setting:{key:A,commaOffset:void 0}})},onSeparator:(v,U,F)=>{if(d===0&&v===","){let z=h.length-1;for(;z>=0&&!h[z].setting;z--);const H=h[z];H&&h.splice(z,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:U}})}},onComment:(v,U)=>{d===0&&h.push({startOffset:v,endOffset:v+U,value:l.substring(v,v+U)})}};return(0,T.visit)(l,O),h}}),define(Z[207],te([0,1,25,3,45,132,21,12,28,14,22,20,47,54,206,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function b(a){const t=JSON.parse(a);return g(t)?t:{settings:a}}e.parseSettingsSyncContent=b;let y=class extends f.AbstractJsonFileSynchroniser{constructor(t,r,n,s,c,l,h,d,p,A,O){super(r.settingsResource,"settings",t,r,n,s,c,p,A,l,h,d);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,n,s){const c=await this.getLocalFileContent(),l=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t);r=r===null&&n?t:r;const d=r?this.getSettingsSyncContent(r):null,p=await this.getIgnoredSettings();let A=null,O=!1,v=!1,U=!1;if(h){let z=c?c.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,u.merge)(z,h.settings,d?d.settings:null,p,[],l);A=H.localContent||H.remoteContent,O=H.localContent!==null,v=H.remoteContent!==null,U=H.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=c.value.toString(),v=!0);const F={content:A,localChange:O?2:0,remoteChange:v?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,u.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,r,n,s){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,u.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,u.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,s){const{fileContent:c}=n[0][0];let{content:l,localChange:h,remoteChange:d}=n[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const p=await this.getFormattingOptions(),A=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,u.updateIgnoredSettings)(l,A?A.settings:"{}",O,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(p){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),n=(0,E.edit)(t.value.toString(),[S.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,u.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const n=this.parseSyncData(r);if(n){const s=this.parseSettingsSyncContent(n.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,u.updateIgnoredSettings)(r,"{}",s,n)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:c})=>!!c)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new S.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(r.content);if(!n||!n.settings)return;let s=n.settings;const c=await this.getFormattingOptions();for(const l in r)if(["version","content","machineId"].indexOf(l)===-1&&r[l]!==void 0){const h=(0,R.setProperty)(s,[l],r[l],c);h.length&&(s=(0,R.applyEdits)(s,h))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(s))}catch(t){}}};y=fe([J(0,I.IFileService),J(1,P.IEnvironmentService),J(2,i.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,S.IUserDataSyncUtilService),J(7,k.IConfigurationService),J(8,S.IUserDataSyncResourceEnablementService),J(9,C.ITelemetryService),J(10,m.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let w=class extends f.AbstractInitializer{constructor(t,r,n){super("settings",r,n,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};w=fe([J(0,I.IFileService),J(1,P.IEnvironmentService),J(2,S.IUserDataSyncLogService)],w),e.SettingsInitializer=w;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[208],te([0,1,25,3,26,21,12,14,22,20,47,201,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends i.AbstractSynchroniser{constructor(g,b,y,w,o,a,t,r,n){super("snippets",b,g,y,w,o,r,n,a,t);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(T.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,b,y,w){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=g.syncData?this.parseSnippets(g.syncData):null;b=b===null&&y?g:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,C.merge)(a,t,r);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(g,b){return g.previewResult}async getAcceptResult(g,b,y,w){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return y===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:y,localChange:y===null?g.fileContent!==null?3:0:2,remoteChange:y===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(g,b,y,w){const o=y.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,w)),o.some(({remoteChange:a})=>a!==0)&&(g=await this.updateRemoteSnippets(o,g,w)),b?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(g,b,y){const w=new Map;for(const o of Object.keys(g.local.added)){const a={content:g.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};w.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.local.updated)){const a={content:g.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.added)){const a={content:g.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.updated)){const a={content:g.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.conflicts){const a={content:b[o]?b[o].value.toString():null,hasConflicts:!0,localChange:b[o]?2:1,remoteChange:y[o]?2:1};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o]||null,localContent:b[o]?b[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b))if(!w.has(o)){const a={content:b[o]?b[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};w.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o]||null,localContent:b[o]?b[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...w.values()]}async getAssociatedResources({uri:g}){let b=await super.resolveContent(g);if(b){const y=this.parseSyncData(b);if(y){const w=this.parseSnippets(y),o=[];for(const a of Object.keys(w)){const t=this.extUri.joinPath(g,a),r=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(r);o.push({resource:t,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let b=await super.resolveContent(g);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(g)),b){const y=this.parseSyncData(b);if(y)return this.parseSnippets(y)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch(g){}return!1}async updateLocalBackup(g){const b={};for(const y of g)y.fileContent&&(b[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(g,b){for(const{fileContent:y,acceptResult:w,localResource:o,remoteResource:a,localChange:t}of g)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(w.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(w.content),b?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(g,b,y){const w=b.syncData?this.parseSnippets(b.syncData):{},o=(0,R.deepClone)(w);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:n}of g)if(n!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);n===3?delete o[s]:o[s]=a.content}return(0,C.areSame)(w,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(o),y?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const b={};for(const y of Object.keys(g))b[y]=g[y].value.toString();return b}async getSnippetsFileContents(){const g={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof P.FileOperationError&&y.fileOperationResult===1)return g;throw y}for(const y of b.children||[]){const w=y.resource,o=this.extUri.extname(w);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,w),t=await this.fileService.readFile(w);g[a]=t}}return g}};E=fe([J(0,k.IEnvironmentService),J(1,P.IFileService),J(2,m.IStorageService),J(3,f.IUserDataSyncStoreService),J(4,f.IUserDataSyncBackupStoreService),J(5,f.IUserDataSyncLogService),J(6,L.IConfigurationService),J(7,f.IUserDataSyncResourceEnablementService),J(8,I.ITelemetryService)],E),e.SnippetsSynchroniser=E;let u=class extends i.AbstractInitializer{constructor(g,b,y){super("snippets",b,y,g)}async doInitialize(g){const b=g.syncData?JSON.parse(g.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const w of Object.keys(b)){const o=b[w];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,w);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};u=fe([J(0,P.IFileService),J(1,k.IEnvironmentService),J(2,f.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[60],te([0,1,3,2,7,23]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends T.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};k=fe([J(0,L.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(Z[209],te([0,1,6,25,56,2,16,21,12,14,23]),function(K,e,D,T,R,L,k,P,m,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends L.Disposable{constructor(E,u,S,g){super();this.environmentService=E,this.fileService=u,this.configurationService=S,this.logService=g,i.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(E){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,E),S=await this.fileService.resolve(u);return S.children?S.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(E,u){if(!u){const S=await this.getAllRefs(E);S.length&&(u=S[S.length-1].ref)}if(u){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,E,u);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(E,u){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,E),g=(0,k.joinPath)(S,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,T.VSBuffer.fromString(u))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(E)}catch(b){}}async cleanUpBackup(E){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(u))return}catch(g){return}const S=await this.fileService.resolve(u);if(S.children){const g=S.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=g.filter(o=>Date.now()-this.getCreationTime(o)>b);const w=g.length-y.length;w<10&&(y=y.slice(10-w)),await D.Promises.settled(y.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};C=fe([J(0,m.IEnvironmentService),J(1,I.IFileService),J(2,P.IConfigurationService),J(3,i.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(Z[210],te([0,1,2,5]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(f){this.service=f}listen(f,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(f,E,u){switch(E){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class L{constructor(f){this.service=f}listen(f,E){throw new Error(`Event not found: ${E}`)}call(f,E,u){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(T.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class k{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(f){this.service=f}listen(f,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(f,E,u){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(f){this.service=f}listen(f,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(f,E,u){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class I{constructor(f){this.service=f}listen(f,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(f,E,u){switch(E){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class i extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:T.URI.revive(f.url),type:f.type,defaultUrl:T.URI.revive(f.defaultUrl),insidersUrl:T.URI.revive(f.insidersUrl),stableUrl:T.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(Z[211],te([0,1,12,13]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends T.AbstractLogger{constructor(k,P){super();this.logger=this._register(k.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}critical(k,...P){this.logger.critical(k,...P)}flush(){this.logger.flush()}};R=fe([J(0,T.ILoggerService),J(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],te([0,1,3,2,4,24,135,12,14,7,29,46,22,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let S=class Xe extends T.Disposable{constructor(b,y,w,o,a,t){super();this.storageService=w,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(b,y,w)}async getMachines(b){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(o=>({...o,isCurrent:o.id===y}))}async addCurrentMachine(b){const y=await this.currentMachineIdPromise,w=await this.readMachinesData(b);w.machines.some(({id:o})=>o===y)||(w.machines.push({id:y,name:this.computeCurrentMachineName(w.machines)}),await this.writeMachinesData(w))}async removeCurrentMachine(b){const y=await this.currentMachineIdPromise,w=await this.readMachinesData(b),o=w.machines.filter(({id:a})=>a!==y);o.length!==w.machines.length&&(w.machines=o,await this.writeMachinesData(w))}async renameMachine(b,y,w){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(w),t=a.machines.find(({id:r})=>r===b);t&&(t.name=y,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===o)&&this.storageService.store(u,y,0,1))}async setEnablement(b,y){const w=await this.readMachinesData(),o=w.machines.find(({id:a})=>a===b);o&&(o.disabled=y?void 0:!0,await this.writeMachinesData(w))}computeCurrentMachineName(b){const y=this.storageService.get(u,0);if(y)return y;const w=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,L.escapeRegExpCharacters)(w)}\\s#(\\d+)`);let a=0;for(const t of b){const r=o.exec(t.name),n=r?parseInt(r[1]):0;a=n>a?n:a}return`${w} #${a+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const y=this.parse(this.userData);if(y.version!==Xe.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(b){const y=JSON.stringify(b),w=await this.userDataSyncStoreService.write(Xe.RESOURCE,y,this.userData?.ref||null);this.userData={ref:w,content:y},this._onDidChange.fire()}async readUserData(b){if(this.userData){const y=b&&b.latest?b.latest[Xe.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Xe.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(y){this.logService.error(y)}return{version:Xe.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=fe([J(0,P.IEnvironmentService),J(1,m.IFileService),J(2,f.IStorageService),J(3,E.IUserDataSyncStoreService),J(4,E.IUserDataSyncLogService),J(5,i.IProductService)],S),e.UserDataSyncMachinesService=S}),define(Z[90],te([0,1,6,56,38,9,3,2,4,16,5,133,12,29,22,20,23,60,61]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const w="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let n=class extends P.Disposable{constructor(h,d,p){super();this.storageService=h,this.environmentService=d,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(h.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||this.storageService.store(w,h,0,1)}onDidStorageChange(h){if(h.scope===0&&w===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=fe([J(0,u.IStorageService),J(1,f.IEnvironmentService),J(2,g.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let s=class extends P.Disposable{constructor(h,d,p,A,O,v,U,F,z,H,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=v,this.userDataSyncAccountService=U,this.telemetryService=F,this.userDataSyncMachinesService=z,this.storageService=H,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=h.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(U.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,(j,q)=>j?[...j,q]:[q],1e3)(j=>this.triggerSync(j,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const h=this.storageService.get(t,0);return h?i.URI.parse(h):void 0}set syncUrl(h){h?this.storageService.store(t,h.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(h){h?this.storageService.store(r,h,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:h,message:d}=this.isAutoSyncEnabled();h?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(h,d,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),h?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(h){this.userDataAutoSyncEnablementService.isEnabled()!==h&&(this.telemetryService.publicLog2(w,{enabled:h}),this.userDataAutoSyncEnablementService.setEnablement(h),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(h){if(!h){this.successiveFailures=0;return}const d=g.UserDataSyncError.toUserDataSyncError(h);d instanceof g.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?m.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(h,d,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...h),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=fe([J(0,E.IProductService),J(1,g.IUserDataSyncStoreManagementService),J(2,g.IUserDataSyncStoreService),J(3,g.IUserDataSyncResourceEnablementService),J(4,g.IUserDataSyncService),J(5,g.IUserDataSyncLogService),J(6,b.IUserDataSyncAccountService),J(7,S.ITelemetryService),J(8,y.IUserDataSyncMachinesService),J(9,u.IStorageService),J(10,g.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class c extends P.Disposable{constructor(h,d,p,A,O,v,U,F){super();this.lastSyncUrl=h,this.interval=d,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=v,this.logService=U,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(h,d){const p=(0,D.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,L.isPromiseCanceledError)(O))return}return this.doSync(h,d,A)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const h=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!h&&(!(0,I.isEqual)(d.defaultUrl,h.defaultUrl)||!(0,I.isEqual)(d.insidersUrl,h.insidersUrl)||!(0,I.isEqual)(d.stableUrl,h.stableUrl))}async doSync(h,d,p){this.logService.info(`Auto Sync: Triggered by ${h}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),p.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(a,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(p.isCancellationRequested)return;const U=v.find(F=>F.isCurrent);if(U?.disabled)throw new g.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new g.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof g.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(a,this.manifest.session,0,1),p.isCancellationRequested)return;U||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(h){return super._register(h)}}c.INTERVAL_SYNCING="Interval"}),define(Z[212],te([0,1,3,2,4,22,20,23]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends T.Disposable{constructor(i,C){super();this.storageService=i,this.telemetryService=C,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,C){if(this.isResourceEnabled(i)!==C){const f=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(f,{enabled:C}),this.storeResourceEnablement(f,C)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,C){this.storageService.store(i,C,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===i.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};m=fe([J(0,L.IStorageService),J(1,k.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(Z[213],te([0,1,17,6,38,9,3,2,16,30,7,22,20,202,204,205,207,208,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const w="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,s,c,l,h,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=s,this.instantiationService=c,this.logService=l,this.telemetryService=h,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(S.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(b.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(E.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(p=>k.Event.map(p.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(p=>k.Event.map(p.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(w,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(p=>k.Event.map(p.onDidChangeLocal,()=>p.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,s){await this.checkEnablement();const c=(0,I.generateUuid)();try{const p=(0,y.createSyncHeaders)(c);s&&(p["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,p)}catch(p){const A=y.UserDataSyncError.toUserDataSyncError(p);throw this.reportUserDataSyncError(A,c),A}let l=!1;const h=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,T.createCancelablePromise)(p=>h.sync(n,c,p)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,I.generateUuid)(),s=(0,y.createSyncHeaders)(n);let c;try{c=await this.userDataSyncStoreService.manifest(null,s)}catch(l){const h=y.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,n),h}return new a(n,c,s,this.synchronisers,this.logService)}async sync(n,s,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,y.createSyncHeaders)(s);for(const d of this.synchronisers){if(c.isCancellationRequested)return;try{await d.sync(n,h)}catch(p){let A=!1;if(p instanceof y.UserDataSyncError)switch(p.code){case"TooLarge":p=new y.UserDataSyncError(p.message,p.code,d.resource),A=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":A=!0;break}const O=y.UserDataSyncError.toUserDataSyncError(p);if(this.reportUserDataSyncError(O,s),A)throw O;this.logService.error(p),this.logService.error(`${d.resource}: ${(0,R.toErrorMessage)(p)}`),this._syncErrors.push([d.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const d=y.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(d,s),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(s){this.logService.error(s)}}async replace(n){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(n))return}async accept(n,s,c,l){await this.checkEnablement();const h=this.getSynchroniser(n);await h.accept(s,c),l&&await h.apply(!1,(0,y.createSyncHeaders)((0,I.generateUuid)()))}async resolveContent(n){for(const s of this.synchronisers){const c=await s.resolveContent(n);if(c)return c}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,s){return this.getSynchroniser(n).getAssociatedResources(s)}getMachineId(n,s){return this.getSynchroniser(n).getMachineId(s)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of n)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(w,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(s){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const s=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([s,c],[l,h])=>s===s&&(0,D.equals)(c,h,(d,p)=>(0,m.isEqual)(d.previewResource,p.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(w,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,s){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof y.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof y.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(s=>s.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=fe([J(0,y.IUserDataSyncStoreService),J(1,y.IUserDataSyncStoreManagementService),J(2,i.IInstantiationService),J(3,y.IUserDataSyncLogService),J(4,f.ITelemetryService),J(5,C.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,s,c,l,h){super();this.id=n,this.manifest=s,this.syncHeaders=c,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,T.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,s){try{return await this.performAction(n,c=>c.accept(n,s))}catch(c){throw this.logService.error(c),c}}async merge(n){try{return n?await this.performAction(n,s=>s.merge(n)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(n){try{return await this.performAction(n,s=>s.discard(n))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,s]of this.previews)for(const c of s.resourcePreviews)c.mergeState==="conflict"&&n.push(c.previewResource);for(const s of n)await this.discard(s);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===s);for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(s){(0,L.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(n,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,U])=>U.resourcePreviews.some(({localResource:F,previewResource:z,remoteResource:H})=>(0,m.isEqual)(n,F)||(0,m.isEqual)(n,z)||(0,m.isEqual)(n,H)));if(c===-1)return this.previews;const[l,h]=this.previews[c],d=h.resourcePreviews.find(({localResource:U,remoteResource:F,previewResource:z})=>(0,m.isEqual)(U,n)||(0,m.isEqual)(F,n)||(0,m.isEqual)(z,n));if(!d)return this.previews;let p=this.synchronizingResources.find(U=>U[0]===l);p||(p=[l,[]],this.synchronizingResources.push(p)),p[1].some(U=>(0,m.isEqual)(U,d.localResource))||(p[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const A=this.synchronisers.find(U=>U.resource===this.previews[c][0]),O=await s(A);O?this.previews.splice(c,1,this.toSyncResourcePreview(A.resource,O)):this.previews.splice(c,1);const v=this.synchronizingResources.findIndex(U=>U[0]===l);return this.synchronizingResources[v][1].splice(p[1].findIndex(U=>(0,m.isEqual)(U,d.localResource)),1),p[1].length||(this.synchronizingResources.splice(v,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===s);let h=c;for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(h=await l.merge(d.previewResource));h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const s=[];for(const c of this.synchronisers){if(n.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&s.push(this.toSyncResourcePreview(c.resource,l))}return s}toSyncResourcePreview(n,s){return[n,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[214],te([0,1,3,2,18,5,23]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,E){try{return await this._call(C,f,E)}catch(u){throw this.logService.error(u),u}}async _call(C,f,E){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],L.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:L.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:L.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),S=E[0],g=this.getManualSyncTask(S);switch(E=E.slice(1),u){case"preview":return g.preview();case"accept":return g.accept(L.URI.revive(E[0]),E[1]);case"merge":return g.merge(L.URI.revive(E[0]));case"discard":return g.discard(L.URI.revive(E[0]));case"discardConflicts":return g.discardConflicts();case"apply":return g.apply();case"pull":return g.pull();case"push":return g.push();case"stop":return g.stop();case"_getStatus":return g.status;case"dispose":return this.disposeManualSyncTask(g)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new T.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:E}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class m extends T.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,E,u){return C.call(f,E,u).then(null,S=>{throw k.UserDataSyncError.toUserDataSyncError(S)})},listen(f,E){return C.listen(f,E)}},this.channel.call("_getInitialData").then(([f,E,u])=>{this.updateStatus(f),this.updateConflicts(E),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([E,u])=>[E,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:E}=await this.channel.call("createManualSyncTask"),u=this,S=new I(C,f,E,{async call(g,b,y){return u.channel.call(`manualSync/${g}`,[C,...(0,R.isArray)(b)?b:[b]],y)},listen(g,b){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${g}`,b),y=>!S.isDiposed()&&y.manualSyncTaskId===C),y=>y.data)}});return S}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,E,u){return this.channel.call("accept",[C,f,E,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:E,uri:u})=>({created:E,uri:L.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:E,uri:u})=>({created:E,uri:L.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:S})=>({resource:L.URI.revive(u),comparableResource:L.URI.revive(S)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,E])=>[f,E.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=m;class I extends T.Disposable{constructor(C,f,E,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=E;const S=this;this.channel={async call(g,b,y){try{const w=await u.call(g,b,y);return S.isDiposed()||(S._status=await u.call("_getStatus")),w}catch(w){throw k.UserDataSyncError.toUserDataSyncError(w)}},listen(g,b){return u.listen(g,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const E=await this.channel.call("accept",[C,f]);return this.deserializePreviews(E)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,E])=>[f,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource),acceptedResource:L.URI.revive(u.acceptedResource)}))}])}}}),define(Z[215],te([0,1,6,27,9,3,2,96,4,16,18,5,30,21,12,14,29,43,46,22,23]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",n="sync.machine-session-id",s=100,c=1e3*60*5;let l=class extends k.Disposable{constructor(v,U,F){super();this.productService=v,this.configurationService=U,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(F.onDidChangeValue,z=>z.key===o.SYNC_SERVICE_URL_TYPE&&z.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(v){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,v,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(v,U){v=m.isWeb&&v?.web?{...v,...v.web}:v;const F={...v||{},...U||{}};if(F&&(0,i.isString)(F.url)&&(0,i.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(z=>(0,i.isArray)(F.authenticationProviders[z].scopes))){const z=F,H=!!z.canSwitch&&!U?.url,M=z.url===z.insidersUrl?"insiders":"stable",j=(H?this.userDataSyncStoreType:void 0)||M,q=U?.url||(j==="insiders"?z.insidersUrl:j==="stable"?z.stableUrl:z.url);return{url:C.URI.parse(q),type:j,defaultType:M,defaultUrl:C.URI.parse(z.url),stableUrl:C.URI.parse(z.stableUrl),insidersUrl:C.URI.parse(z.insidersUrl),canSwitch:H,authenticationProviders:Object.keys(z.authenticationProviders).reduce((x,$)=>(x.push({id:$,scopes:z.authenticationProviders[$].scopes}),x),[])}}}};l=fe([J(0,g.IProductService),J(1,E.IConfigurationService),J(2,w.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let h=class extends l{constructor(v,U,F){super(v,U,F);const z=this.storageService.get(a,0);z&&(this.previousConfigurationSyncStore=JSON.parse(z));const H=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];H?this.storageService.store(a,JSON.stringify(H),0,1):this.storageService.remove(a,0)}async switch(v){v!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=v,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=fe([J(0,g.IProductService),J(1,E.IConfigurationService),J(2,w.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let d=class extends k.Disposable{constructor(v,U,F,z,H,M,j){super();this.requestService=F,this.logService=z,this.storageService=j,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(v),this.commonHeadersPromise=(0,y.getServiceMachineId)(H,M,j).then(q=>{const x={"X-Client-Name":`${U.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(x["X-Client-Commit"]=U.commit),x}),this.session=new A(s,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(v,U){this.authToken={token:v,type:U}}updateUserDataSyncStoreUrl(v){this.userDataSyncStoreUrl=v?(0,I.joinPath)(v,"v1"):void 0}initDonotMakeRequestsUntil(){const v=this.storageService.getNumber(t,0);v&&Date.now()<v&&this.setDonotMakeRequestsUntil(new Date(v))}setDonotMakeRequestsUntil(v){this._donotMakeRequestsUntil?.getTime()!==v?.getTime()&&(this._donotMakeRequestsUntil=v,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(v){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",v),F={},z=await this.request(U.toString(),{type:"GET",headers:F},[],T.CancellationToken.None);return(await(0,b.asJson)(z)||[]).map(({url:M,created:j})=>({ref:(0,I.relativePath)(U,U.with({path:M})),created:j*1e3}))}async resolveContent(v,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",v,U).toString(),z={};z["Cache-Control"]="no-cache";const H=await this.request(F,{type:"GET",headers:z},[],T.CancellationToken.None);return await(0,b.asText)(H)}async delete(v){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",v).toString(),F={};await this.request(U,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async read(v,U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",v,"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const H=await this.request(z,{type:"GET",headers:F},[304],T.CancellationToken.None);let M=null;if(H.res.statusCode===304&&(M=U),M===null){const j=H.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[o.HEADER_OPERATION_ID]);const q=await(0,b.asText)(H);if(!q&&H.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[o.HEADER_OPERATION_ID]);M={ref:j,content:q}}return M}async write(v,U,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",v).toString();z={...z},z["Content-Type"]=P.Mimes.text,F&&(z["If-Match"]=F);const M=await this.request(H,{type:"POST",data:U,headers:z},[],T.CancellationToken.None),j=M.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",M.res.statusCode,M.res.headers[o.HEADER_OPERATION_ID]);return j}async manifest(v,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",v&&(U["If-None-Match"]=v.ref);const z=await this.request(F,{type:"GET",headers:U},[304],T.CancellationToken.None);let H=null;if(z.res.statusCode===304&&(H=v),!H){const j=z.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[o.HEADER_OPERATION_ID]);const q=await(0,b.asText)(z);if(!q&&z.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[o.HEADER_OPERATION_ID]);q&&(H={...JSON.parse(q),ref:j})}const M=this.storageService.get(r,0);return M&&H&&M!==H.session&&this.clearSession(),H===null&&M&&this.clearSession(),H&&this.storageService.store(r,H.session,0,1),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const v=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(v,{type:"DELETE",headers:U},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(n,0)}async request(v,U,F,z){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",v,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because of too many requests (429).`,v,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const H=await this.commonHeadersPromise;U.headers={...U.headers||{},...H,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:v,type:U.type,headers:{...U.headers,authorization:void 0}});let M;try{M=await this.session.request(v,U,z)}catch($){if(!($ instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const W=(0,R.getErrorMessage)($).toLowerCase();W.includes("xhr timeout")?N="RequestTimeout":W.includes("protocol")&&W.includes("not supported")?N="RequestProtocolNotSupported":W.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":W.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)($)&&(N="RequestCanceled"),$=new o.UserDataSyncStoreError(`Connection refused for the request '${v}'.`,v,N,void 0,void 0)}throw this.logService.info("Request failed",v),$}const j=M.res.headers[o.HEADER_OPERATION_ID],q={url:v,status:M.res.statusCode,"execution-id":U.headers[o.HEADER_EXECUTION_ID],"operation-id":j},x=(0,b.isSuccess)(M)||M.res.statusCode&&F.indexOf(M.res.statusCode)!==-1;if(x?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${v}' failed because of Unauthorized (401).`,v,"Unauthorized",M.res.statusCode,j);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,v,"Conflict",M.res.statusCode,j);if(M.res.statusCode===410)throw new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because the requested resource is not longer available (410).`,v,"Gone",M.res.statusCode,j);if(M.res.statusCode===412)throw new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,v,"PreconditionFailed",M.res.statusCode,j);if(M.res.statusCode===413)throw new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because of too large payload (413).`,v,"TooLarge",M.res.statusCode,j);if(M.res.statusCode===426)throw new o.UserDataSyncStoreError(`${U.type} request '${v}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,v,"UpgradeRequired",M.res.statusCode,j);if(M.res.statusCode===429){const $=M.res.headers["retry-after"];throw $?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt($)*1e3)),new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because of too many requests (429).`,v,"TooManyRequestsAndRetryAfter",M.res.statusCode,j)):new o.UserDataSyncStoreError(`${U.type} request '${v}' failed because of too many requests (429).`,v,"RemoteTooManyRequests",M.res.statusCode,j)}if(!x)throw new o.UserDataSyncStoreError("Server returned "+M.res.statusCode,v,"Unknown",M.res.statusCode,j);return M}addSessionHeaders(v){let U=this.storageService.get(n,0);U===void 0&&(U=(0,f.generateUuid)(),this.storageService.store(n,U,0,1)),v["X-Machine-Session-Id"]=U;const F=this.storageService.get(r,0);F!==void 0&&(v["X-User-Session-Id"]=F)}};d=fe([J(1,g.IProductService),J(2,b.IRequestService),J(3,o.IUserDataSyncLogService),J(4,u.IEnvironmentService),J(5,S.IFileService),J(6,w.IStorageService)],d),e.UserDataSyncStoreClient=d;let p=class extends d{constructor(v,U,F,z,H,M,j){super(v.userDataSyncStore?.url,U,F,z,H,M,j);this._register(v.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(v.userDataSyncStore?.url)))}};p=fe([J(0,o.IUserDataSyncStoreManagementService),J(1,g.IProductService),J(2,b.IRequestService),J(3,o.IUserDataSyncLogService),J(4,u.IEnvironmentService),J(5,S.IFileService),J(6,w.IStorageService)],p),e.UserDataSyncStoreService=p;class A{constructor(v,U,F,z){this.limit=v,this.interval=U,this.requestService=F,this.logService=z,this.requests=[],this.startTime=void 0}request(v,U,F){if(this.isExpired()&&this.reset(),U.url=v,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,v,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(v),this.requestService.request(U,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(Z[216],te([0,1,3,59,29,22,20,90,23,60,61]),function(K,e,D,T,R,L,k,P,m,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(E,u,S,g,b,y,w,o,a,t,r,n){super(E,u,S,g,b,w,o,a,t,r,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(y.onDidFocusWindow,()=>"windowFocus"),D.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(s,c)=>s?[...s,c]:[c],1e3)(s=>this.triggerSync(s,!0,!1)))}};C=fe([J(0,R.IProductService),J(1,m.IUserDataSyncStoreManagementService),J(2,m.IUserDataSyncStoreService),J(3,m.IUserDataSyncResourceEnablementService),J(4,m.IUserDataSyncService),J(5,T.INativeHostService),J(6,m.IUserDataSyncLogService),J(7,I.IUserDataSyncAccountService),J(8,k.ITelemetryService),J(9,i.IUserDataSyncMachinesService),J(10,L.IStorageService),J(11,m.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(Z[217],te([0,1,6,3,2]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:I}){super();this.disposables=this._register(new R.DisposableStore),T.Event.latch(T.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>I()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[62],te([0,1,51,6,8,18,19,112,224,225]),function(K,e,D,T,R,L,k,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=r}}e.ExtractError=i;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function f(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function E(a,t,r,n,s,c){const l=R.dirname(t),h=R.join(n,l);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(n,t);let p;return c.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(k.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!c.isCancellationRequested)try{p=(0,D.createWriteStream)(d,{mode:r}),p.once("close",()=>A()),p.once("error",O),a.once("error",O),a.pipe(p)}catch(v){O(v)}}))}function u(a,t,r,n){let s=(0,T.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((l,h)=>{const d=new T.Sequencer,p=A=>{A.isCancellationRequested||(c++,a.readEntry())};a.once("error",h),a.once("close",()=>s.then(()=>{n.isCancellationRequested||a.entryCount===c?l():h(new i("Incomplete",new Error(P.localize(1,null,c,a.entryCount))))},h)),a.readEntry(),a.on("entry",A=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){p(n);return}const O=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(O)){const F=R.join(t,O);s=(0,T.createCancelablePromise)(z=>k.Promises.mkdir(F,{recursive:!0}).then(()=>p(z)).then(void 0,h));return}const v=g(a,A),U=C(A);s=(0,T.createCancelablePromise)(F=>d.queue(()=>v.then(z=>E(z,O,U,t,r,F).then(()=>p(F)))).then(null,h))})})}function S(a,t=!1){return new Promise((r,n)=>{(0,m.open)(a,t?{lazyEntries:!0}:void 0,(s,c)=>{s?n(f(s)):r((0,L.assertIsDefined)(c))})})}function g(a,t){return new Promise((r,n)=>{a.openReadStream(t,(s,c)=>{s?n(f(s)):r((0,L.assertIsDefined)(c))})})}function b(a,t){return new Promise((r,n)=>{const s=new I.ZipFile;t.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const c=(0,D.createWriteStream)(a);s.outputStream.pipe(c),s.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>r(a))})}e.zip=b;function y(a,t,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=S(a,!0);return r.overwrite&&(c=c.then(l=>k.Promises.rm(t).then(()=>l))),c.then(l=>u(l,t,{sourcePathRegex:s},n))}e.extract=y;function w(a,t){return S(a).then(r=>new Promise((n,s)=>{r.on("entry",c=>{c.fileName===t&&g(r,c).then(l=>n(l),l=>s(l))}),r.once("close",()=>s(new Error(P.localize(2,null,t))))}))}function o(a,t){return w(a,t).then(r=>new Promise((n,s)=>{const c=[];r.once("error",s),r.on("data",l=>c.push(l)),r.on("end",()=>n(Buffer.concat(c)))}))}e.buffer=o}),define(Z[218],te([0,1,62,120]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(L){return(0,D.buffer)(L,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error((0,T.localize)(0,null))}})}e.getManifest=R}),define(Z[219],te([0,1,17,6,9,2,15,8,4,16,58,5,30,19,62,121,12,28,32,141,14,13,29]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",n="scanningUser",s="extracting",c="deleting",l="renaming";let h=class extends L.Disposable{constructor(p,A,O,v,U){super();this.beforeRemovingExtension=p,this.fileService=A,this.logService=O,this.environmentService=v,this.productService=U,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const A=[];(p===null||p===0)&&A.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(O).message,r)))),(p===null||p===1)&&A.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(A);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[A,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(v=>!A[new y.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]),p&&(O=(0,y.groupByExtension)(O,U=>U.identifier).map(U=>U.sort((F,z)=>i.rcompare(F.manifest.version,z.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,A,O,v){const U=p.key(),F=P.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),z=P.join(this.extensionsPath,U);try{await E.Promises.rm(z)}catch(M){try{await E.Promises.rm(z)}catch(j){}throw new b.ExtensionManagementError((0,S.localize)(0,null,z,p.id),c)}await this.extractAtLocation(p,A,F,v);let H=await this.scanExtension(C.URI.file(F),1);if(!H)throw new Error((0,S.localize)(1,null,F));await this.storeMetadata(H,{...O,installedTimestamp:Date.now()});try{await this.rename(p,F,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(M){try{await E.Promises.rm(F)}catch(j){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(M)}. Deleted from extracted location`,F),M}try{H=await this.scanExtension(C.URI.file(z),1)}catch(M){}if(H)return H;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,A){return this.setMetadata(p,A),await this.storeMetadata(p,{...A,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const O=P.join(p.location.fsPath,"package.json"),v=await E.Promises.readFile(O,"utf8"),{manifest:U}=await this.parseManifest(v);return U.__metadata=A,await E.Promises.writeFile(O,JSON.stringify(U,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const A=p.map(O=>new y.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{A.forEach(v=>O[v.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(v=>delete v[p.key()]);const O=(await this.scanExtensions(1)).find(v=>new y.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(p))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(v){if(v.code!=="ENOENT")throw v}let O={};if(A)try{O=JSON.parse(A)}catch(v){}return p&&(p(O),Object.keys(O).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await E.Promises.rm(this.uninstalledPath)),O})}async removeExtension(p,A){this.logService.trace(`Deleting ${A} extension from disk`,p.identifier.id,p.location.fsPath),await E.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,A,O,v){this.logService.trace(`Started extracting the extension from ${A} to ${O}`);try{await E.Promises.rm(O)}catch(U){throw new b.ExtensionManagementError(this.joinErrors(U).message,c)}try{await(0,u.extract)(A,O,{sourcePath:"extension",overwrite:!0},v),this.logService.info(`Extracted extension to ${O}:`,p.id)}catch(U){try{await E.Promises.rm(O)}catch(F){}throw new b.ExtensionManagementError(U.message,U instanceof u.ExtractError&&U.type?U.type:s)}}async rename(p,A,O,v){try{await E.Promises.rename(A,O)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<v)return this.logService.info(`Failed renaming ${A} to ${O} with 'EPERM' error. Trying again...`,p.id),this.rename(p,A,O,v);throw new b.ExtensionManagementError(U.message||(0,S.localize)(3,null,A,O),U.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const A=this.scanDevSystemExtensions(),[O,v]=await Promise.all([p,A]);return[...O,...v]}async scanExtensionsInDir(p,A){const O=new T.Limiter(10),v=await this.fileService.resolve(C.URI.file(p));return v.children?(await Promise.all(v.children.filter(F=>F.isDirectory).map(F=>O.queue(async()=>A===1&&(0,I.basename)(F.resource).indexOf(".")===0?null:this.scanExtension(F.resource,A))))).filter(F=>F&&F.identifier):[]}async scanExtension(p,A){try{const O=await this.fileService.resolve(p);if(O.children){const{manifest:v,metadata:U}=await this.readManifest(p.fsPath),F=O.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,z=O.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource,H={id:(0,y.getGalleryExtensionId)(v.publisher,v.name)},M={type:A,identifier:H,manifest:v,location:p,readmeUrl:F,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return U&&(this.setMetadata(M,U),M.installedTimestamp=U.installedTimestamp),M}}catch(O){A!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(O=>p.some(v=>(0,y.areSameExtensions)(O.identifier,{id:v})))}else return[]}setMetadata(p,A){p.publisherDisplayName=A.publisherDisplayName||null,p.publisherId=A.publisherId||null,p.identifier.uuid=A.id,p.isMachineScoped=!!A.isMachineScoped,p.isBuiltin=p.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),O=new Set;for(const F of A)p[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]||O.add(F.identifier.id.toLowerCase());const v=(0,y.groupByExtension)(A,F=>F.identifier);await T.Promises.settled(v.map(async F=>{const z=F.sort((H,M)=>i.rcompare(H.manifest.version,M.manifest.version))[0];O.has(z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(z)}));const U=A.filter(F=>p[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]);await T.Promises.settled(U.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),A=[],O=(0,y.groupByExtension)(p,v=>v.identifier);A.push(...(0,D.flatten)(O.map(v=>v.sort((U,F)=>i.rcompare(U.manifest.version,F.manifest.version)).slice(1)))),await T.Promises.settled(A.map(v=>this.removeExtension(v,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const A=Array.isArray(p)?p:[p];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((O,v)=>new Error(`${O.message}${O.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(k.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const A=[E.Promises.readFile(P.join(p,"package.json"),"utf8").then(F=>this.parseManifest(F)),E.Promises.readFile(P.join(p,"package.nls.json"),"utf8").then(void 0,F=>F.code!=="ENOENT"?Promise.reject(F):"{}").then(F=>JSON.parse(F))],[{manifest:O,metadata:v},U]=await Promise.all(A);return{manifest:(0,w.localizeManifest)(O,U),metadata:v}}parseManifest(p){return new Promise((A,O)=>{try{const v=JSON.parse(p),U=v.__metadata||null;A({manifest:v,metadata:U})}catch(v){O(new Error((0,S.localize)(4,null)))}})}};h=fe([J(1,o.IFileService),J(2,a.ILogService),J(3,g.INativeEnvironmentService),J(4,t.IProductService)],h),e.ExtensionsScanner=h}),define(Z[220],te([0,1,38,9,15,8,4,31,16,58,5,30,19,62,119,75,12,186,28,32,166,167,218,154,219,168,73,14,7,13,42,20]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a,t,r,n,s,c,l,h,d,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const O="unsetUninstalled",v="downloading";let U=class extends b.AbstractExtensionManagementService{constructor(q,x,$,N,W,_,Y){super(q,x,$);this.environmentService=N,this.downloadService=W,this.fileService=Y;const G=this._register(_.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(_.createInstance(n.ExtensionsScanner,ee=>G.postUninstall(ee))),this.manifestCache=this._register(new r.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(_.createInstance(o.ExtensionsDownloader));const ne=this._register(new s.ExtensionsWatcher(this,Y,N,$));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ee,removed:X})=>{ee.length&&this._onDidInstallExtensions.fire(ee.map(B=>({identifier:B.identifier,operation:0,local:B}))),X.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const q=await this.isAlpineLinux(),x=(0,y.getTargetPlatform)(q?"alpine":k.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let q;try{q=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(x){try{q=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch($){this.logService.debug("Error while getting the os-release file.",(0,T.getErrorMessage)($))}}return!!q&&(q.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.collectFiles(q),$=await(0,E.zip)((0,m.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,x);return i.URI.file($)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const x=await this.downloadVsix(q),$=L.resolve(x.fsPath);return(0,t.getManifest)($)}getInstalled(q=null){return this.extensionsScanner.scanExtensions(q)}async install(q,x={}){this.logService.trace("ExtensionManagementService#install",q.toString());const $=await this.downloadVsix(q),N=await(0,t.getManifest)(L.resolve($.fsPath));if(N.engines&&N.engines.vscode&&!(0,c.isEngineValid)(N.engines.vscode,p.default.version,p.default.date))throw new Error(u.localize(0,null,(0,w.getGalleryExtensionId)(N.publisher,N.name),p.default.version));return this.installExtension(N,$,x)}async updateMetadata(q,x){return this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},...x}),this.manifestCache.invalidate(),q}async updateExtensionScope(q,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),q}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(q){if(q.scheme===R.Schemas.file)return q;const x=(0,m.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(q,x),x}createInstallExtensionTask(q,x,$){return i.URI.isUri(x)?new H(q,x,$,this.galleryService,this.extensionsScanner,this.logService):new z(x,$,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(q,x){return new M(q,x,this.extensionsScanner)}async collectFiles(q){const x=async N=>{let W=await f.Promises.readdir(N);W=W.map(G=>L.join(N,G));const _=await Promise.all(W.map(G=>f.Promises.stat(G)));let Y=Promise.resolve([]);return _.forEach((G,ne)=>{const ee=W[ne];G.isFile()&&(Y=Y.then(X=>[...X,ee])),G.isDirectory()&&(Y=Y.then(X=>x(ee).then(B=>[...X,...B])))}),Y};return(await x(q.location.fsPath)).map(N=>({path:`extension/${L.relative(q.location.fsPath,N)}`,localPath:N}))}};U=fe([J(0,y.IExtensionGalleryService),J(1,A.ITelemetryService),J(2,d.ILogService),J(3,g.INativeEnvironmentService),J(4,S.IDownloadService),J(5,h.IInstantiationService),J(6,l.IFileService)],U),e.ExtensionManagementService=U;class F extends b.AbstractExtensionTask{constructor(q,x,$,N){super();this.identifier=q,this.source=x,this.extensionsScanner=$,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(q,x){try{const $=await this.unsetUninstalledAndGetLocal(q.identifierWithVersion);if($)return q.metadata?this.extensionsScanner.saveMetadataForLocalExtension($,q.metadata):$}catch($){throw k.isMacintosh?new y.ExtensionManagementError(u.localize(1,null),O):new y.ExtensionManagementError(u.localize(2,null),O)}return this.extract(q,x)}async unsetUninstalledAndGetLocal(q){if(!await this.isUninstalled(q))return null;this.logService.trace("Removing the extension from uninstalled list:",q.id);const $=await this.extensionsScanner.setInstalled(q);return this.logService.info("Removed the extension from uninstalled list:",q.id),$}async isUninstalled(q){return!!(await this.extensionsScanner.getUninstalledExtensions())[q.key()]}async extract({zipPath:q,identifierWithVersion:x,metadata:$},N){let W=await this.extensionsScanner.extractUserExtension(x,q,$,N);return this.logService.info("Extracting completed.",x.id),W}}class z extends F{constructor(q,x,$,N,W){super(q.identifier,q,N,W);this.gallery=q,this.options=x,this.extensionsDownloader=$}async doRun(q){const $=(await this.extensionsScanner.scanExtensions(null)).find(_=>(0,w.areSameExtensions)(_.identifier,this.gallery.identifier));$&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||$?.isBuiltin;const W=await this.installExtension(N,q);$&&I.neq($.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled($);try{await this.extensionsDownloader.delete(i.URI.file(N.zipPath))}catch(_){}return W}async downloadInstallableExtension(q,x){const $={id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",q.identifier.id),N=(await this.extensionsDownloader.downloadExtension(q,x)).fsPath,this.logService.info("Downloaded extension:",q.identifier.id,N)}catch(W){throw new y.ExtensionManagementError((0,b.joinErrors)(W).message,v)}try{const W=await(0,t.getManifest)(N);return{zipPath:N,identifierWithVersion:new w.ExtensionIdentifierWithVersion(q.identifier,W.version),metadata:$}}catch(W){throw new y.ExtensionManagementError((0,b.joinErrors)(W).message,b.INSTALL_ERROR_VALIDATING)}}}class H extends F{constructor(q,x,$,N,W,_){super({id:(0,w.getGalleryExtensionId)(q.publisher,q.name)},x,W,_);this.manifest=q,this.location=x,this.options=$,this.galleryService=N}async doRun(q){const x=new w.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(_=>(0,w.areSameExtensions)(this.identifier,_.identifier)),W=await this.getMetadata(this.identifier.id,q);if(W.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=2,x.equals(new w.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(_){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const _=await this.unsetUninstalledAndGetLocal(x);if(_)try{await this.extensionsScanner.removeExtension(_,"existing")}catch(Y){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:x,metadata:W},q)}async getMetadata(q,x){try{const $=(await this.galleryService.query({names:[q],pageSize:1},x)).firstPage[0];if($)return{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId}}catch($){}return{}}}class M extends b.AbstractExtensionTask{constructor(q,x,$){super();this.extension=q,this.options=x,this.extensionsScanner=$}async doRun(q){const x=[],$=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new w.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...$.filter(W=>N.equals(new w.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version))))}else x.push(...$.filter(N=>(0,w.areSameExtensions)(N.identifier,this.extension.identifier)));if(!x.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const N of x)try{q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(W){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(W)))}}}}),define(Z[226],te([0,1,106,51,227,35,38,9,2,15,16,5,36,105,174,151,175,163,164,165,149,155,21,177,74,185,75,179,12,139,181,188,28,152,187,220,76,142,14,171,173,53,7,160,79,161,162,57,170,13,80,59,42,29,178,43,22,183,184,20,83,84,85,44,189,190,86,192,198,88,89,90,23,60,209,210,211,61,212,213,214,215,216,217,153,169]),function(K,e,D,T,R,L,k,P,m,I,i,C,f,E,u,S,g,b,y,w,o,a,t,r,n,s,c,l,h,d,p,A,O,v,U,F,z,H,M,j,q,x,$,N,W,_,Y,G,ne,ee,X,B,re,ie,ce,ue,ge,de,Ie,Pe,Ee,Oe,Re,Te,Ne,_e,ze,$e,Q,ae,oe,ve,Se,Fe,Le,Me,Ae,V,se,le,he,me,be,pe,we,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class De extends m.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new E.Server),(0,R.gracefulify)(T),this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye)}async open(){const ye=await this.initServices();(0,Se.registerConfiguration)(),ye.invokeFunction(Ue=>{const qe=Ue.get(ee.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,m.combinedDisposable)(ye.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(g.LanguagePackCachedDataCleaner),ye.createInstance(w.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(y.LogsDataCleaner),ye.createInstance(b.LocalizationsUpdater),ye.createInstance(S.DeprecatedExtensionsCleaner)))}async initServices(){const ye=new W.ServiceCollection,Ue={_serviceBrand:void 0,...re.default};ye.set(ie.IProductService,Ue);const qe=new f.StaticRouter(He=>He==="main"),Ge=new _.MessagePortMainProcessService(this.server,qe);ye.set(Y.IMainProcessService,Ge);const xe=new d.NativeEnvironmentService(this.configuration.args,Ue);ye.set(h.INativeEnvironmentService,xe);const nt=new X.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Ke=new X.LoggerChannelClient(this.configuration.logLevel,nt.onDidChangeLogLevel,Ge.getChannel("logger"));ye.set(ee.ILoggerService,Ke);const rt=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Ke.createLogger((0,i.joinPath)(C.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new X.FollowerLogService(nt,rt));ye.set(ee.ILogService,Ve);const Ye=this._register(new j.FileService(Ve));ye.set(M.IFileService,Ye);const st=this._register(new q.DiskFileSystemProvider(Ve));Ye.registerProvider(I.Schemas.file,st);const We=this._register(new r.ConfigurationService(xe.settingsResource,Ye));ye.set(t.IConfigurationService,We),await We.initialize();const Ze=new de.NativeStorageService(void 0,Ge,xe);ye.set(ge.IStorageService,Ze),await Ze.initialize(),this._register((0,m.toDisposable)(()=>Ze.flush())),ye.set(ue.IRequestService,new x.SyncDescriptor(ce.RequestService)),ye.set(o.IChecksumService,new x.SyncDescriptor(a.ChecksumService));const it=f.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(B.INativeHostService,it),ye.set(c.IDownloadService,new x.SyncDescriptor(l.DownloadService));const at=this._register(new pe.ActiveWindowManager(it)),ot=new f.StaticRouter(He=>at.getActiveClientId().then(ct=>He===ct));ye.set(z.IExtensionRecommendationNotificationService,new H.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ot)));let et,Je,ht=(0,Te.getTelemetryLevel)(Ue,xe);if(ht>=1){Je=new Oe.TelemetryLogAppender(Ke,xe);const{appRoot:He,extensionsPath:ct,installSourcePath:pt}=xe;if(Ue.aiConfig&&Ue.aiConfig.asimovKey&&ht>=2){const ft=new Ne.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>ft.flush())),Je=(0,Te.combinedAppender)(ft,Je)}et=new Re.TelemetryService({appender:Je,commonProperties:(0,Ie.resolveCommonProperties)(Ye,(0,L.release)(),(0,L.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,pt),sendErrorTelemetry:!0,piiPaths:[He,ct]},We)}else et=Te.NullTelemetryService,Je=Te.NullAppender;this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(Je)),ye.set(Pe.ITelemetryService,et);const yt=new _e.CustomEndpointTelemetryService(We,et,Ke,xe);return ye.set(Pe.ICustomEndpointTelemetryService,yt),ye.set(O.IExtensionManagementService,new x.SyncDescriptor(F.ExtensionManagementService)),ye.set(O.IExtensionGalleryService,new x.SyncDescriptor(A.ExtensionGalleryService)),ye.set(O.IExtensionTipsService,new x.SyncDescriptor(U.ExtensionTipsService)),ye.set(G.ILocalizationsService,new x.SyncDescriptor(ne.LocalizationsService)),ye.set(n.IDiagnosticsService,new x.SyncDescriptor(s.DiagnosticsService)),ye.set(Fe.IUserDataSyncAccountService,new x.SyncDescriptor(Fe.UserDataSyncAccountService)),ye.set(Se.IUserDataSyncLogService,new x.SyncDescriptor(Ae.UserDataSyncLogService)),ye.set(Se.IUserDataSyncUtilService,new Me.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ye.set(O.IGlobalExtensionEnablementService,new x.SyncDescriptor(p.GlobalExtensionEnablementService)),ye.set(oe.IIgnoredExtensionsManagementService,new x.SyncDescriptor(oe.IgnoredExtensionsManagementService)),ye.set(ae.IExtensionsStorageSyncService,new x.SyncDescriptor(ae.ExtensionsStorageSyncService)),ye.set(Se.IUserDataSyncStoreManagementService,new x.SyncDescriptor(me.UserDataSyncStoreManagementService)),ye.set(Se.IUserDataSyncStoreService,new x.SyncDescriptor(me.UserDataSyncStoreService)),ye.set(V.IUserDataSyncMachinesService,new x.SyncDescriptor(V.UserDataSyncMachinesService)),ye.set(Se.IUserDataSyncBackupStoreService,new x.SyncDescriptor(Le.UserDataSyncBackupStoreService)),ye.set(Se.IUserDataAutoSyncEnablementService,new x.SyncDescriptor(ve.UserDataAutoSyncEnablementService)),ye.set(Se.IUserDataSyncResourceEnablementService,new x.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ye.set(Se.IUserDataSyncService,new x.SyncDescriptor(le.UserDataSyncService)),ye.set($e.ILocalPtyService,this._register(new Q.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:We.getValue("terminal.integrated.persistentSessionScrollback")??100},We,xe,Ve,et))),ye.set(we.IExtensionHostStarter,this._register(new Ce.ExtensionHostStarter(Ve))),new N.InstantiationService(ye)}initChannels(ye){const Ue=new v.ExtensionManagementChannel(ye.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=f.ProxyChannel.fromService(ye.get(G.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ge=f.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const xe=new v.ExtensionTipsChannel(ye.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",xe);const nt=f.ProxyChannel.fromService(ye.get(o.IChecksumService));this.server.registerChannel("checksum",nt);const Ke=new Me.UserDataSyncMachinesServiceChannel(ye.get(V.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ke);const rt=f.ProxyChannel.fromService(ye.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",rt);const Ve=new Me.UserDataSyncAccountServiceChannel(ye.get(Fe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const Ye=new Me.UserDataSyncStoreManagementServiceChannel(ye.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const st=new he.UserDataSyncChannel(ye.get(Se.IUserDataSyncService),ye.get(ee.ILogService));this.server.registerChannel("userDataSync",st);const We=this._register(ye.get($.IInstantiationService).createInstance(be.UserDataAutoSyncService)),Ze=new Me.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",Ze);const it=ye.get($e.ILocalPtyService),at=f.ProxyChannel.fromService(it);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,at);const ot=f.ProxyChannel.fromService(ye.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,ot)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,P.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ue=>{const qe=(0,k.toErrorMessage)(Ue,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function ke(Qe){const ye=new De(Qe);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ke})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1b9403cd461c9c975bcb9e48d84ba9e4ea86559e/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
