/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/extpath","fs","vs/base/common/process","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function(V){for(var e=[],p=0,L=V.length;p<L;p++)e[p]=Z[V[p]];return e};define(Z[102],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,M){if(!L)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=p}),define(Z[47],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(E){return(n,f,w)=>{let t=null,I=null;if(typeof w.value=="function"?(t="value",I=w.value):typeof w.get=="function"&&(t="get",I=w.get),!I)throw new Error("not supported");w[t]=E(I,f)}}e.createDecorator=p;function L(E,n,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const I=`$memoize$${n}`;f[w]=function(...b){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,b)}),this[I]}}e.memoize=L;function M(E,n,f){return p((w,t)=>{const I=`$debounce$${t}`,b=`$debounce$result$${t}`;return function(...v){this[b]||(this[b]=f?f():void 0),clearTimeout(this[I]),n&&(this[b]=n(this[b],...v),v=[this[b]]),this[I]=setTimeout(()=>{w.apply(this,v),this[b]=f?f():void 0},E)}})}e.debounce=M;function k(E,n,f){return p((w,t)=>{const I=`$throttle$timer$${t}`,b=`$throttle$result$${t}`,v=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...g){if(this[b]||(this[b]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),n&&(this[b]=n(this[b],...g)),this[d])return;const P=this[v]+E;P<=Date.now()?(this[v]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[v]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0},P-Date.now()))}})}e.throttle=k}),define(Z[17],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=p,e.errorHandler=new p;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function M(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=M;function k(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=k;function E(c){if(c instanceof Error){let{name:i,message:a}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:i,message:a,stack:r}}return c}e.transformErrorForSerialization=E;const n="Canceled";function f(c){return c instanceof Error&&c.name===n&&c.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function t(){const c=new Error(n);return c.name=c.message,c}e.canceled=t;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function b(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=b;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function d(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class P extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=P;class S extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=S;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function h(c){const i=c;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function o(c,i=Object.create(null)){const a=new Error(c);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=o}),define(Z[30],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(T,A=0){return T[T.length-(1+A)]}e.tail=L;function M(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=M;function k(T,A,W=(z,X)=>z===X){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let z=0,X=T.length;z<X;z++)if(!W(T[z],A[z]))return!1;return!0}e.equals=k;function E(T,A,W){let z=0,X=T.length-1;for(;z<=X;){const U=(z+X)/2|0,N=W(T[U],A);if(N<0)z=U+1;else if(N>0)X=U-1;else return U}return-(z+1)}e.binarySearch=E;function n(T,A){let W=0,z=T.length;if(z===0)return 0;for(;W<z;){const X=Math.floor((W+z)/2);A(T[X])?z=X:W=X+1}return W}e.findFirstInSorted=n;function f(T,A,W){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let z=A[Math.floor(A.length*Math.random())],X=[],U=[],N=[];for(let Q of A){const J=W(Q,z);J<0?X.push(Q):J>0?U.push(Q):N.push(Q)}return T<X.length?f(T,X,W):T<X.length+N.length?N[0]:f(T-(X.length+N.length),U,W)}e.quickSelect=f;function w(T,A){const W=[];let z;for(const X of T.slice(0).sort(A))!z||A(z[0],X)!==0?(z=[X],W.push(z)):z.push(X);return W}e.groupBy=w;function t(T,A,W){const z=[];function X(Q,J,re){if(J===0&&re.length===0)return;const le=z[z.length-1];le&&le.start+le.deleteCount===Q?(le.deleteCount+=J,le.toInsert.push(...re)):z.push({start:Q,deleteCount:J,toInsert:re})}let U=0,N=0;for(;;){if(U===T.length){X(U,0,A.slice(N));break}if(N===A.length){X(U,T.length-U,[]);break}const Q=T[U],J=A[N],re=W(Q,J);re===0?(U+=1,N+=1):re<0?(X(U,1,[]),U+=1):re>0&&(X(U,0,[J]),N+=1)}return z}e.sortedDiff=t;function I(T,A,W){const z=t(T,A,W),X=[],U=[];for(const N of z)X.push(...T.slice(N.start,N.start+N.deleteCount)),U.push(...N.toInsert);return{removed:X,added:U}}e.delta=I;function b(T,A,W){if(W===0)return[];const z=T.slice(0,W).sort(A);return d(T,A,z,W,T.length),z}e.top=b;function v(T,A,W,z,X){return W===0?Promise.resolve([]):new Promise((U,N)=>{(async()=>{const Q=T.length,J=T.slice(0,W).sort(A);for(let re=W,le=Math.min(W+z,Q);re<Q;re=le,le=Math.min(le+z,Q)){if(re>W&&await new Promise(ie=>setTimeout(ie)),X&&X.isCancellationRequested)throw(0,p.canceled)();d(T,A,J,re,le)}return J})().then(U,N)})}e.topAsync=v;function d(T,A,W,z,X){for(const U=W.length;z<X;z++){const N=T[z];if(A(N,W[U-1])<0){W.pop();const Q=n(W,J=>A(N,J)<0);W.splice(Q,0,N)}}}function g(T){return T.filter(A=>!!A)}e.coalesce=g;function P(T){let A=0;for(let W=0;W<T.length;W++)T[W]&&(T[A]=T[W],A+=1);T.length=A}e.coalesceInPlace=P;function S(T,A,W){T.splice(W,0,T.splice(A,1)[0])}e.move=S;function u(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=u;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function o(T,A){if(!A)return T.filter((z,X)=>T.indexOf(z)===X);const W=Object.create(null);return T.filter(z=>{const X=A(z);return W[X]?!1:(W[X]=!0,!0)})}e.distinct=o;function c(T){const A=new Set;return T.filter(W=>A.has(W)?!1:(A.add(W),!0))}e.distinctES6=c;function i(T){const A=Object.create(null);return W=>{const z=T(W);return A[z]?!1:(A[z]=!0,!0)}}e.uniqueFilter=i;function a(T,A){for(let W=T.length-1;W>=0;W--){const z=T[W];if(A(z))return W}return-1}e.lastIndex=a;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function s(T,A,W=(z,X)=>z===X){let z=0;for(let X=0,U=Math.min(T.length,A.length);X<U&&W(T[X],A[X]);X++)z++;return z}e.commonPrefixLength=s;function l(T){return[].concat(...T)}e.flatten=l;function m(T,A){let W=typeof A=="number"?T:0;typeof A=="number"?W=T:(W=0,A=T);const z=[];if(W<=A)for(let X=W;X<A;X++)z.push(X);else for(let X=W;X>A;X--)z.push(X);return z}e.range=m;function y(T,A,W){return T.reduce((z,X)=>(z[A(X)]=W?W(X):X,z),Object.create(null))}e.index=y;function D(T,A){return T.push(A),()=>R(T,A)}e.insert=D;function R(T,A){const W=T.indexOf(A);if(W>-1)return T.splice(W,1),A}e.remove=R;function F(T,A,W){const z=T.slice(0,A),X=T.slice(A);return z.concat(W,X)}e.arrayInsert=F;function C(T,A){let W;if(typeof A=="number"){let z=A;W=()=>{const X=Math.sin(z++)*179426549;return X-Math.floor(X)}}else W=Math.random;for(let z=T.length-1;z>0;z-=1){const X=Math.floor(W()*(z+1)),U=T[z];T[z]=T[X],T[X]=U}}e.shuffle=C;function G(T,A){const W=T.indexOf(A);W>-1&&(T.splice(W,1),T.unshift(A))}e.pushToStart=G;function ne(T,A){const W=T.indexOf(A);W>-1&&(T.splice(W,1),T.push(A))}e.pushToEnd=ne;function ae(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ae;function K(T){return Array.isArray(T)?T:[T]}e.asArray=K;function ee(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=ee;function _(T,A){for(const W of T){const z=A(W);if(z!==void 0)return z}}e.mapFind=_;function j(T,A,W){const z=B(T,A),X=T.length,U=W.length;T.length=X+U;for(let N=X-1;N>=z;N--)T[N+U]=T[N];for(let N=0;N<U;N++)T[N+z]=W[N]}e.insertInto=j;function $(T,A,W,z){const X=B(T,A),U=T.splice(X,W);return j(T,X,z),U}e.splice=$;function B(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function q(T,A){let W=Number.MAX_SAFE_INTEGER,z=0;return T.forEach((X,U)=>{const N=A(X);N<W&&(W=N,z=U)}),z}e.minIndex=q;function O(T,A){let W=Number.MIN_SAFE_INTEGER,z=0;return T.forEach((X,U)=>{const N=A(X);N>W&&(W=N,z=U)}),z}e.maxIndex=O;class H{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let W=this.firstIdx;for(;W<this.items.length&&A(this.items[W]);)W++;const z=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,z}takeFromEndWhile(A){let W=this.lastIdx;for(;W>=0&&A(this.items[W]);)W--;const z=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,z}}e.ArrayQueue=H}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const M=this;let k=!1,E;return function(){return k||(k=!0,E=L.apply(M,arguments)),E}}e.once=p}),define(Z[64],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function M(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=M;const k=Object.freeze([]);function E(){return k}L.empty=E;function*n(c){yield c}L.single=n;function f(c){return c||k}L.from=f;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(c){return c[Symbol.iterator]().next().value}L.first=t;function I(c,i){for(const a of c)if(i(a))return!0;return!1}L.some=I;function b(c,i){for(const a of c)if(i(a))return a}L.find=b;function*v(c,i){for(const a of c)i(a)&&(yield a)}L.filter=v;function*d(c,i){let a=0;for(const r of c)yield i(r,a++)}L.map=d;function*g(...c){for(const i of c)for(const a of i)yield a}L.concat=g;function*P(c){for(const i of c)for(const a of i)yield a}L.concatNested=P;function S(c,i,a){let r=a;for(const s of c)r=i(r,s);return r}L.reduce=S;function*u(c,i,a=c.length){for(i<0&&(i+=c.length),a<0?a+=c.length:a>c.length&&(a=c.length);i<a;i++)yield c[i]}L.slice=u;function h(c,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,c];const r=c[Symbol.iterator]();for(let s=0;s<i;s++){const l=r.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return r}}]}L.consume=h;function o(c,i,a=(r,s)=>r===s){const r=c[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const l=r.next(),m=s.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!a(l.value,m.value))return!1}}L.equals=o})(p=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function E(i,a=!1){let r=0,s=i.length,l="",m=0,y=16,D=0;function R(ee){let _=0,j=0;for(;_<ee;){const $=i.charCodeAt(r);if($>=48&&$<=57)j=j*16+$-48;else if($>=65&&$<=70)j=j*16+$-65+10;else if($>=97&&$<=102)j=j*16+$-97+10;else break;r++,_++}return _<ee&&(j=-1),j}function F(ee){r=ee,l="",m=0,y=16,D=0}function C(){const ee=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&w(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&w(i.charCodeAt(r)))for(r++;r<i.length&&w(i.charCodeAt(r));)r++;else return D=3,i.substring(ee,r);let _=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&w(i.charCodeAt(r))){for(r++;r<i.length&&w(i.charCodeAt(r));)r++;_=r}else D=3;return i.substring(ee,_)}function G(){let ee="",_=r;for(;;){if(r>=s){ee+=i.substring(_,r),D=2;break}const j=i.charCodeAt(r);if(j===34){ee+=i.substring(_,r),r++;break}if(j===92){if(ee+=i.substring(_,r),r++,r>=s){D=2;break}switch(i.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=R(4);B>=0?ee+=String.fromCharCode(B):D=4;break;default:D=5}_=r;continue}if(j>=0&&j<=31)if(f(j)){ee+=i.substring(_,r),D=2;break}else D=6;r++}return ee}function ne(){if(l="",D=0,m=r,r>=s)return m=s,y=17;let ee=i.charCodeAt(r);if(n(ee)){do r++,l+=String.fromCharCode(ee),ee=i.charCodeAt(r);while(n(ee));return y=15}if(f(ee))return r++,l+=String.fromCharCode(ee),ee===13&&i.charCodeAt(r)===10&&(r++,l+=`
`),y=14;switch(ee){case 123:return r++,y=1;case 125:return r++,y=2;case 91:return r++,y=3;case 93:return r++,y=4;case 58:return r++,y=6;case 44:return r++,y=5;case 34:return r++,l=G(),y=10;case 47:const _=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(i.charCodeAt(r));)r++;return l=i.substring(_,r),y=12}if(i.charCodeAt(r+1)===42){r+=2;const j=s-1;let $=!1;for(;r<j;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,D=1),l=i.substring(_,r),y=13}return l+=String.fromCharCode(ee),r++,y=16;case 45:if(l+=String.fromCharCode(ee),r++,r===s||!w(i.charCodeAt(r)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),y=11;default:for(;r<s&&ae(ee);)r++,ee=i.charCodeAt(r);if(m!==r){switch(l=i.substring(m,r),l){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return l+=String.fromCharCode(ee),r++,y=16}}function ae(ee){if(n(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ee;do ee=ne();while(ee>=12&&ee<=15);return ee}return{setPosition:F,getPosition:()=>r,scan:a?K:ne,getToken:()=>y,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>D}}e.createScanner=E;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function I(i,a){const r=[],s=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function D(R,F,C,G){m.value=R,m.offset=F,m.length=C,m.type=G,m.colonOffset=void 0,l=m}try{h(i,{onObjectBegin:(R,F)=>{if(a<=R)throw s;l=void 0,y=a>R,r.push("")},onObjectProperty:(R,F,C)=>{if(a<F||(D(R,F,C,"property"),r[r.length-1]=R,a<=F+C))throw s},onObjectEnd:(R,F)=>{if(a<=R)throw s;l=void 0,r.pop()},onArrayBegin:(R,F)=>{if(a<=R)throw s;l=void 0,r.push(0)},onArrayEnd:(R,F)=>{if(a<=R)throw s;l=void 0,r.pop()},onLiteralValue:(R,F,C)=>{if(a<F||(D(R,F,C,c(R)),a<=F+C))throw s},onSeparator:(R,F,C)=>{if(a<=F)throw s;if(R===":"&&l&&l.type==="property")l.colonOffset=F,y=!1,l=void 0;else if(R===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(y=!0,r[r.length-1]=""),l=void 0}}})}catch(R){if(R!==s)throw R}return{path:r,previousNode:l,isAtPropertyKey:y,matches:R=>{let F=0;for(let C=0;F<R.length&&C<r.length;C++)if(R[F]===r[C]||R[F]==="*")F++;else if(R[F]!=="**")return!1;return F===R.length}}}e.getLocation=I;function b(i,a=[],r=k.DEFAULT){let s=null,l=[];const m=[];function y(R){Array.isArray(l)?l.push(R):s!==null&&(l[s]=R)}return h(i,{onObjectBegin:()=>{const R={};y(R),m.push(l),l=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const R=[];y(R),m.push(l),l=R,s=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:y,onError:(R,F,C)=>{a.push({error:R,offset:F,length:C})}},r),l[0]}e.parse=b;function v(i,a=[],r=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function m(R){return s.children.push(R),R}h(i,{onObjectBegin:R=>{s=m({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,F,C)=>{s=m({type:"property",offset:F,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:F,length:C,parent:s})},onObjectEnd:(R,F)=>{s.length=R+F-s.offset,s=s.parent,l(R+F)},onArrayBegin:(R,F)=>{s=m({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,F)=>{s.length=R+F-s.offset,s=s.parent,l(R+F)},onLiteralValue:(R,F,C)=>{m({type:c(R),offset:F,length:C,parent:s,value:R}),l(F+C)},onSeparator:(R,F,C)=>{s.type==="property"&&(R===":"?s.colonOffset=F:R===","&&l(F))},onError:(R,F,C)=>{a.push({error:R,offset:F,length:C})}},r);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=v;function d(i,a){if(!i)return;let r=i;for(let s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===s){r=m.children[1],l=!0;break}if(!l)return}else{const l=s;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const a=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=g;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":const a=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(a[r.children[0].value]=P(s))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function S(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=S;function u(i,a,r=!1){if(S(i,a,r)){const s=i.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=a;l++){const m=u(s[l],a,r);if(m)return m}return i}}e.findNodeAtOffset=u;function h(i,a,r=k.DEFAULT){const s=E(i,!1);function l(W){return W?()=>W(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(W){return W?z=>W(z,s.getTokenOffset(),s.getTokenLength()):()=>!0}const y=l(a.onObjectBegin),D=m(a.onObjectProperty),R=l(a.onObjectEnd),F=l(a.onArrayBegin),C=l(a.onArrayEnd),G=m(a.onLiteralValue),ne=m(a.onSeparator),ae=l(a.onComment),K=m(a.onError),ee=r&&r.disallowComments,_=r&&r.allowTrailingComma;function j(){for(;;){const W=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:ee||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(W){case 12:case 13:ee?$(10):ae();break;case 16:$(1);break;case 15:case 14:break;default:return W}}}function $(W,z=[],X=[]){if(K(W),z.length+X.length>0){let U=s.getToken();for(;U!==17;){if(z.indexOf(U)!==-1){j();break}else if(X.indexOf(U)!==-1)break;U=j()}}}function B(W){const z=s.getTokenValue();return W?G(z):D(z),j(),!0}function q(){switch(s.getToken()){case 11:let W=0;try{W=JSON.parse(s.getTokenValue()),typeof W!="number"&&($(2),W=0)}catch(z){$(2)}G(W);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return j(),!0}function O(){return s.getToken()!==10?($(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(ne(":"),j(),A()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function H(){y(),j();let W=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(W||$(4,[],[]),ne(","),j(),s.getToken()===2&&_)break}else W&&$(6,[],[]);O()||$(4,[],[2,5]),W=!0}return R(),s.getToken()!==2?$(7,[2],[]):j(),!0}function T(){F(),j();let W=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(W||$(4,[],[]),ne(","),j(),s.getToken()===4&&_)break}else W&&$(6,[],[]);A()||$(4,[],[4,5]),W=!0}return C(),s.getToken()!==4?$(8,[4],[]):j(),!0}function A(){switch(s.getToken()){case 3:return T();case 1:return H();case 10:return B(!0);default:return q()}}return j(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):A()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=h;function o(i,a){let r=E(i),s=[],l,m=0,y;do switch(y=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:m!==y&&s.push(i.substring(m,y)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),m=r.getPosition();break}while(l!==17);return s.join("")}e.stripComments=o;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[103],x([0,1,40]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let I,b,v,d,g;if(w){for(d=w.offset,g=d+w.length,v=d;v>0&&!n(f,v-1);)v--;let m=g;for(;m<f.length&&!n(f,m);)m++;b=f.substring(v,m),I=k(b,t)}else b=f,I=0,v=0,d=0,g=f.length;const P=E(t,f);let S=!1,u=0,h;t.insertSpaces?h=M(" ",t.tabSize||4):h="	";const o=(0,p.createScanner)(b,!1);let c=!1;function i(){return P+M(h,I+u)}function a(){let m=o.scan();for(S=!1;m===15||m===14;)S=S||m===14,m=o.scan();return c=m===16||o.getTokenError()!==0,m}const r=[];function s(m,y,D){!c&&y<g&&D>d&&f.substring(y,D)!==m&&r.push({offset:y,length:D-y,content:m})}let l=a();if(l!==17){const m=o.getTokenOffset()+v,y=M(h,I);s(y,v,m)}for(;l!==17;){let m=o.getTokenOffset()+o.getTokenLength()+v,y=a(),D="";for(;!S&&(y===12||y===13);){const F=o.getTokenOffset()+v;s(" ",m,F),m=o.getTokenOffset()+o.getTokenLength()+v,D=y===12?i():"",y=a()}if(y===2)l!==1&&(u--,D=i());else if(y===4)l!==3&&(u--,D=i());else{switch(l){case 3:case 1:u++,D=i();break;case 5:case 12:D=i();break;case 13:S?D=i():D=" ";break;case 6:D=" ";break;case 10:if(y===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?D=" ":y!==5&&y!==17&&(c=!0);break;case 16:c=!0;break}S&&(y===12||y===13)&&(D=i())}const R=o.getTokenOffset()+v;s(D,m,R),l=y}return r}e.format=L;function M(f,w){let t="";for(let I=0;I<w;I++)t+=f;return t}function k(f,w){let t=0,I=0;const b=w.tabSize||4;for(;t<f.length;){const v=f.charAt(t);if(v===" ")I++;else if(v==="	")I+=b;else break;t++}return Math.floor(I/b)}function E(f,w){for(let t=0;t<w.length;t++){const I=w.charAt(t);if(I==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=E;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,103]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(w,t,I){return k(w,t,void 0,I)}e.removeProperty=M;function k(w,t,I,b,v){const d=t.slice(),g=[],P=(0,p.parseTree)(w,g);let S,u;for(;d.length>0&&(u=d.pop(),S=(0,p.findNodeAtLocation)(P,d),S===void 0&&I!==void 0);)typeof u=="string"?I={[u]:I}:I=[I];if(S)if(S.type==="object"&&typeof u=="string"&&Array.isArray(S.children)){const h=(0,p.findNodeAtLocation)(S,[u]);if(h!==void 0)if(I===void 0){if(!h.parent)throw new Error("Malformed AST");const o=S.children.indexOf(h.parent);let c,i=h.parent.offset+h.parent.length;if(o>0){const a=S.children[o-1];c=a.offset+a.length}else c=S.offset+1,S.children.length>1&&(i=S.children[1].offset);return E(w,{offset:c,length:i-c,content:""},b)}else return E(w,{offset:h.offset,length:h.length,content:JSON.stringify(I)},b);else{if(I===void 0)return[];const o=`${JSON.stringify(u)}: ${JSON.stringify(I)}`,c=v?v(S.children.map(a=>a.children[0].value)):S.children.length;let i;if(c>0){const a=S.children[c-1];i={offset:a.offset+a.length,length:0,content:","+o}}else S.children.length===0?i={offset:S.offset+1,length:0,content:o}:i={offset:S.offset+1,length:0,content:o+","};return E(w,i,b)}}else if(S.type==="array"&&typeof u=="number"&&Array.isArray(S.children))if(I!==void 0){const h=`${JSON.stringify(I)}`;let o;if(S.children.length===0||u===0)o={offset:S.offset+1,length:0,content:S.children.length===0?h:h+","};else{const c=u===-1||u>S.children.length?S.children.length:u,i=S.children[c-1];o={offset:i.offset+i.length,length:0,content:","+h}}return E(w,o,b)}else{const h=u,o=S.children[h];let c;if(S.children.length===1)c={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===h){const i=S.children[h-1],a=i.offset+i.length,r=S.offset+S.length;c={offset:a,length:r-2-a,content:""}}else c={offset:o.offset,length:S.children[h+1].offset-o.offset,content:""};return E(w,c,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${S.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(w,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(I)},b)}}e.setProperty=k;function E(w,t,I){let b=n(w,t),v=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;v>0&&!(0,L.isEOL)(b,v-1);)v--;for(;d<b.length&&!(0,L.isEOL)(b,d);)d++}const g=(0,L.format)(b,{offset:v,length:d-v},I);for(let S=g.length-1;S>=0;S--){const u=g[S];b=n(b,u),v=Math.min(v,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const P=w.length-(b.length-d)-v;return[{offset:v,length:P,content:b.substring(v,d)}]}e.withFormatting=E;function n(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=n;function f(w,t){let I=t.slice(0).sort((v,d)=>{const g=v.offset-d.offset;return g===0?v.length-d.length:g}),b=w.length;for(let v=I.length-1;v>=0;v--){let d=I[v];if(d.offset+d.length<=b)w=n(w,d);else throw new Error("Overlapping edit");b=d.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const k=new M,E=new M,n=new M;(function(){function u(h,o,c=o,i=c){k.define(h,o),E.define(h,c),n.define(h,i)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function h(r){return k.keyCodeToStr(r)}u.toString=h;function o(r){return k.strToKeyCode(r)}u.fromString=o;function c(r){return E.keyCodeToStr(r)}u.toUserSettingsUS=c;function i(r){return n.keyCodeToStr(r)}u.toUserSettingsGeneral=i;function a(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}u.fromUserSettings=a})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function I(u,h){const o=(h&65535)<<16>>>0;return(u|o)>>>0}e.KeyChord=I;function b(u,h){if(u===0)return null;const o=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new g([v(o,h),v(c,h)]):new g([v(o,h)])}e.createKeybinding=b;function v(u,h){const o=!!(u&2048),c=!!(u&256),i=h===2?c:o,a=!!(u&1024),r=!!(u&512),s=h===2?o:c,l=u&255;return new d(i,a,r,s,l)}e.createSimpleKeybinding=v;class d{constructor(h,o,c,i,a){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=i,this.keyCode=a}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",c=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${o}${c}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw(0,p.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,c=this.parts.length;o<c;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class P{constructor(h,o,c,i,a,r){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=i,this.keyLabel=a,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class S{}e.ResolvedKeybinding=S}),define(Z[2],x([0,1,43,64]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let k=null;function E(r){k=r}if(e.setDisposableTracker=E,M){const r="__is_disposable_tracked__";E(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==u.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==u.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function n(r){return k?.trackDisposable(r),r}function f(r){k?.markAsDisposed(r)}function w(r,s){k?.setParent(r,s)}function t(r,s){if(!!k)for(const l of r)k.setParent(l,s)}function I(r){return k?.markAsSingleton(r),r}e.markAsSingleton=I;class b extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=b;function v(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=v;function d(r){if(L.Iterable.is(r)){let s=[];for(const l of r)if(l)try{l.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new b(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function g(...r){const s=P(()=>d(r));return t(r,s),s}e.combinedDisposable=g;function P(r){const s=n({dispose:(0,p.once)(()=>{f(s),r()})});return s}e.toDisposable=P;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new S,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=h;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class c{constructor(){this.references=new Map}acquire(s,...l){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...l)},this.references.set(s,m));const{object:y}=m,D=(0,p.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:y,dispose:D}}}e.ReferenceCollection=c;class i{constructor(s){this.referenceCollection=s}async acquire(s,...l){const m=this.referenceCollection.acquire(s,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(y){throw m.dispose(),y}}}e.AsyncReferenceCollection=i;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a}),define(Z[104],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(k){this.element=k,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let k=this._first;for(;k!==p.Undefined;){const E=k.next;k.prev=p.Undefined,k.next=p.Undefined,k=E}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,E){const n=new p(k);if(this._first===p.Undefined)this._first=n,this._last=n;else if(E){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==p.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==p.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==p.Undefined&&k.next!==p.Undefined){const E=k.prev;E.next=k.next,k.next.prev=E}else k.prev===p.Undefined&&k.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):k.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):k.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==p.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function V(M){const k=[];typeof M=="number"&&k.push("code/timeOrigin",M);function E(f){k.push(f,Date.now())}function n(){const f=[];for(let w=0;w<k.length;w+=2)f.push({name:k[w],startTime:k[w+1]});return f}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const E of performance.getEntriesByType("mark"))k.push({name:E.name,startTime:Math.round(M+E.startTime)});return k}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Z[3],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,M=!1,k=!1,E=!1,n=!1,f=!1,w=!1,t,I=p,b,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)v=navigator.userAgent,L=v.indexOf("Windows")>=0,M=v.indexOf("Macintosh")>=0,w=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,f=!0,t=navigator.language,I=t;else if(typeof d=="object"){L=d.platform==="win32",M=d.platform==="darwin",k=d.platform==="linux",E=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=p,I=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),l=s.availableLanguages["*"];t=s.locale,I=l||p,b=s._translationsConfigFile}catch(s){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let u=0;M?u=1:L?u=3:k&&(u=2),e.isWindows=L,e.isMacintosh=M,e.isLinux=k,e.isLinuxSnap=E,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=u,e.userAgent=v,e.language=I;var h;(function(r){function s(){return e.language}r.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function m(){return e.language==="en"}r.isDefault=m})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeSetImmediateId)for(let D=0,R=l.length;D<R;D++){const F=l[D];if(F.id===y.data.vscodeSetImmediateId){l.splice(D,1),F.callback();return}}});let m=0;return y=>{const D=++m;l.push({id:D,callback:y}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const s=Promise.resolve();return l=>s.then(l)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||w?2:L?1:3;let c=!0,i=!1;function a(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=a}),define(Z[33],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const M=p.globals.vscode.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(k){return(0,p.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,p.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,33]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,M=97,k=90,E=122,n=46,f=47,w=92,t=58,I=63;class b extends Error{constructor(o,c,i){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const r=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${r} ${a} of type ${c}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function v(h,o){if(typeof h!="string")throw new b(o,"string",h)}function d(h){return h===f||h===w}function g(h){return h===f}function P(h){return h>=L&&h<=k||h>=M&&h<=E}function S(h,o,c,i){let a="",r=0,s=-1,l=0,m=0;for(let y=0;y<=h.length;++y){if(y<h.length)m=h.charCodeAt(y);else{if(i(m))break;m=f}if(i(m)){if(!(s===y-1||l===1))if(l===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==n||a.charCodeAt(a.length-2)!==n){if(a.length>2){const D=a.lastIndexOf(c);D===-1?(a="",r=0):(a=a.slice(0,D),r=a.length-1-a.lastIndexOf(c)),s=y,l=0;continue}else if(a.length!==0){a="",r=0,s=y,l=0;continue}}o&&(a+=a.length>0?`${c}..`:"..",r=2)}else a.length>0?a+=`${c}${h.slice(s+1,y)}`:a=h.slice(s+1,y),r=y-s-1;s=y,l=0}else m===n&&l!==-1?++l:l=-1}return a}function u(h,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const c=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${i}`:`${c}${h}${i}`:i}e.win32={resolve(...h){let o="",c="",i=!1;for(let a=h.length-1;a>=-1;a--){let r;if(a>=0){if(r=h[a],v(r,"path"),r.length===0)continue}else o.length===0?r=p.cwd():(r=p.env[`=${o}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${o}\\`));const s=r.length;let l=0,m="",y=!1;const D=r.charCodeAt(0);if(s===1)d(D)&&(l=1,y=!0);else if(d(D))if(y=!0,d(r.charCodeAt(1))){let R=2,F=R;for(;R<s&&!d(r.charCodeAt(R));)R++;if(R<s&&R!==F){const C=r.slice(F,R);for(F=R;R<s&&d(r.charCodeAt(R));)R++;if(R<s&&R!==F){for(F=R;R<s&&!d(r.charCodeAt(R));)R++;(R===s||R!==F)&&(m=`\\\\${C}\\${r.slice(F,R)}`,l=R)}}}else l=1;else P(D)&&r.charCodeAt(1)===t&&(m=r.slice(0,2),l=2,s>2&&d(r.charCodeAt(2))&&(y=!0,l=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(i){if(o.length>0)break}else if(c=`${r.slice(l)}\\${c}`,i=y,y&&o.length>0)break}return c=S(c,!i,"\\",d),i?`${o}\\${c}`:`${o}${c}`||"."},normalize(h){v(h,"path");const o=h.length;if(o===0)return".";let c=0,i,a=!1;const r=h.charCodeAt(0);if(o===1)return g(r)?"\\":h;if(d(r))if(a=!0,d(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==m){const y=h.slice(m,l);for(m=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return`\\\\${y}\\${h.slice(m)}\\`;l!==m&&(i=`\\\\${y}\\${h.slice(m,l)}`,c=l)}}}else c=1;else P(r)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),c=2,o>2&&d(h.charCodeAt(2))&&(a=!0,c=3));let s=c<o?S(h.slice(c),!a,"\\",d):"";return s.length===0&&!a&&(s="."),s.length>0&&d(h.charCodeAt(o-1))&&(s+="\\"),i===void 0?a?`\\${s}`:s:a?`${i}\\${s}`:`${i}${s}`},isAbsolute(h){v(h,"path");const o=h.length;if(o===0)return!1;const c=h.charCodeAt(0);return d(c)||o>2&&P(c)&&h.charCodeAt(1)===t&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,c;for(let r=0;r<h.length;++r){const s=h[r];v(s,"path"),s.length>0&&(o===void 0?o=c=s:o+=`\\${s}`)}if(o===void 0)return".";let i=!0,a=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++a;const r=c.length;r>1&&d(c.charCodeAt(1))&&(++a,r>2&&(d(c.charCodeAt(2))?++a:i=!1))}if(i){for(;a<o.length&&d(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(h,o){if(v(h,"from"),v(o,"to"),h===o)return"";const c=e.win32.resolve(h),i=e.win32.resolve(o);if(c===i||(h=c.toLowerCase(),o=i.toLowerCase(),h===o))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let r=h.length;for(;r-1>a&&h.charCodeAt(r-1)===w;)r--;const s=r-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===w;)l++;let m=o.length;for(;m-1>l&&o.charCodeAt(m-1)===w;)m--;const y=m-l,D=s<y?s:y;let R=-1,F=0;for(;F<D;F++){const G=h.charCodeAt(a+F);if(G!==o.charCodeAt(l+F))break;G===w&&(R=F)}if(F!==D){if(R===-1)return i}else{if(y>D){if(o.charCodeAt(l+F)===w)return i.slice(l+F+1);if(F===2)return i.slice(l+F)}s>D&&(h.charCodeAt(a+F)===w?R=F:F===2&&(R=3)),R===-1&&(R=0)}let C="";for(F=a+R+1;F<=r;++F)(F===r||h.charCodeAt(F)===w)&&(C+=C.length===0?"..":"\\..");return l+=R,C.length>0?`${C}${i.slice(l,m)}`:(i.charCodeAt(l)===w&&++l,i.slice(l,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const c=o.charCodeAt(2);if(c!==I&&c!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){v(h,"path");const o=h.length;if(o===0)return".";let c=-1,i=0;const a=h.charCodeAt(0);if(o===1)return d(a)?h:".";if(d(a)){if(c=i=1,d(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return h;l!==m&&(c=i=l+1)}}}}else P(a)&&h.charCodeAt(1)===t&&(c=o>2&&d(h.charCodeAt(2))?3:2,i=c);let r=-1,s=!0;for(let l=o-1;l>=i;--l)if(d(h.charCodeAt(l))){if(!s){r=l;break}}else s=!1;if(r===-1){if(c===-1)return".";r=c}return h.slice(0,r)},basename(h,o){o!==void 0&&v(o,"ext"),v(h,"path");let c=0,i=-1,a=!0,r;if(h.length>=2&&P(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(c=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(r=h.length-1;r>=c;--r){const m=h.charCodeAt(r);if(d(m)){if(!a){c=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(r=h.length-1;r>=c;--r)if(d(h.charCodeAt(r))){if(!a){c=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":h.slice(c,i)},extname(h){v(h,"path");let o=0,c=-1,i=0,a=-1,r=!0,s=0;h.length>=2&&h.charCodeAt(1)===t&&P(h.charCodeAt(0))&&(o=i=2);for(let l=h.length-1;l>=o;--l){const m=h.charCodeAt(l);if(d(m)){if(!r){i=l+1;break}continue}a===-1&&(r=!1,a=l+1),m===n?c===-1?c=l:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||a===-1||s===0||s===1&&c===a-1&&c===i+1?"":h.slice(c,a)},format:u.bind(null,"\\"),parse(h){v(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.length;let i=0,a=h.charCodeAt(0);if(c===1)return d(a)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(a)){if(i=1,d(h.charCodeAt(1))){let R=2,F=R;for(;R<c&&!d(h.charCodeAt(R));)R++;if(R<c&&R!==F){for(F=R;R<c&&d(h.charCodeAt(R));)R++;if(R<c&&R!==F){for(F=R;R<c&&!d(h.charCodeAt(R));)R++;R===c?i=R:R!==F&&(i=R+1)}}}}else if(P(a)&&h.charCodeAt(1)===t){if(c<=2)return o.root=o.dir=h,o;if(i=2,d(h.charCodeAt(2))){if(c===3)return o.root=o.dir=h,o;i=3}}i>0&&(o.root=h.slice(0,i));let r=-1,s=i,l=-1,m=!0,y=h.length-1,D=0;for(;y>=i;--y){if(a=h.charCodeAt(y),d(a)){if(!m){s=y+1;break}continue}l===-1&&(m=!1,l=y+1),a===n?r===-1?r=y:D!==1&&(D=1):r!==-1&&(D=-1)}return l!==-1&&(r===-1||D===0||D===1&&r===l-1&&r===s+1?o.base=o.name=h.slice(s,l):(o.name=h.slice(s,r),o.base=h.slice(s,l),o.ext=h.slice(r,l))),s>0&&s!==i?o.dir=h.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",c=!1;for(let i=h.length-1;i>=-1&&!c;i--){const a=i>=0?h[i]:p.cwd();v(a,"path"),a.length!==0&&(o=`${a}/${o}`,c=a.charCodeAt(0)===f)}return o=S(o,!c,"/",g),c?`/${o}`:o.length>0?o:"."},normalize(h){if(v(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f,c=h.charCodeAt(h.length-1)===f;return h=S(h,!o,"/",g),h.length===0?o?"/":c?"./":".":(c&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return v(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let o;for(let c=0;c<h.length;++c){const i=h[c];v(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(v(h,"from"),v(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const c=1,i=h.length,a=i-c,r=1,s=o.length-r,l=a<s?a:s;let m=-1,y=0;for(;y<l;y++){const R=h.charCodeAt(c+y);if(R!==o.charCodeAt(r+y))break;R===f&&(m=y)}if(y===l)if(s>l){if(o.charCodeAt(r+y)===f)return o.slice(r+y+1);if(y===0)return o.slice(r+y)}else a>l&&(h.charCodeAt(c+y)===f?m=y:y===0&&(m=0));let D="";for(y=c+m+1;y<=i;++y)(y===i||h.charCodeAt(y)===f)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(r+m)}`},toNamespacedPath(h){return h},dirname(h){if(v(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f;let c=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===f){if(!i){c=a;break}}else i=!1;return c===-1?o?"/":".":o&&c===1?"//":h.slice(0,c)},basename(h,o){o!==void 0&&v(o,"ext"),v(h,"path");let c=0,i=-1,a=!0,r;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(r=h.length-1;r>=0;--r){const m=h.charCodeAt(r);if(m===f){if(!a){c=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===f){if(!a){c=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":h.slice(c,i)},extname(h){v(h,"path");let o=-1,c=0,i=-1,a=!0,r=0;for(let s=h.length-1;s>=0;--s){const l=h.charCodeAt(s);if(l===f){if(!a){c=s+1;break}continue}i===-1&&(a=!1,i=s+1),l===n?o===-1?o=s:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===c+1?"":h.slice(o,i)},format:u.bind(null,"/"),parse(h){v(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.charCodeAt(0)===f;let i;c?(o.root="/",i=1):i=0;let a=-1,r=0,s=-1,l=!0,m=h.length-1,y=0;for(;m>=i;--m){const D=h.charCodeAt(m);if(D===f){if(!l){r=m+1;break}continue}s===-1&&(l=!1,s=m+1),D===n?a===-1?a=m:y!==1&&(y=1):a!==-1&&(y=-1)}if(s!==-1){const D=r===0&&c?1:r;a===-1||y===0||y===1&&a===s-1&&a===r+1?o.base=o.name=h.slice(D,s):(o.name=h.slice(D,a),o.base=h.slice(D,s),o.ext=h.slice(a,s))}return r>0?o.dir=h.slice(0,r-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[105],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(k,...E){const n=E.reduce((t,I)=>(t[I]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(t=>!n[t]).forEach(t=>{for(let I=0;I<f.length;I++)if(t.search(f[I])!==-1){delete k[t];break}})}e.sanitizeProcessEnvironment=M}),define(Z[78],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var p;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(p=e.ScanCode||(e.ScanCode={}));const L=[],M=Object.create(null),k=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>k[n]||0,toEnum:n=>M[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(f,w,t,I,b){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=I,this.scanCode=b}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(f,w){L[f]=w,M[w]=f,k[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,78]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,f=!1,w=!1,t=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(f=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(w=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(t=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(t=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(t=!0,E=E.substr("cmd-".length),I=!0);while(I);let b;const v=E.indexOf(" ");return v>0?(b=E.substring(0,v),E=E.substring(v)):(b=E,E=""),{remains:E,ctrl:n,shift:f,alt:w,meta:t,key:b}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),f=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(E,n){if(!E)return null;const f=[];let w;do[w,E]=this.parseSimpleKeybinding(E),f.push(w);while(E.length>0);return new p.ChordKeybinding(f)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],I=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const w=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let f;for(;E.length>0;)[f,E]=this.parseSimpleUserBinding(E),n.push(f);return n}}e.KeybindingParser=M}),define(Z[107],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class M{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new M(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Z[4],x([0,1,17,43,2,104,107]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(o){o.None=()=>M.Disposable.None;function c(_){return(j,$=null,B)=>{let q=!1,O;return O=_(H=>{if(!q)return O?O.dispose():q=!0,j.call($,H)},null,B),q&&O.dispose(),O}}o.once=c;function i(_,j){return y(($,B=null,q)=>_(O=>$.call(B,j(O)),null,q))}o.map=i;function a(_,j){return y(($,B=null,q)=>_(O=>{j(O),$.call(B,O)},null,q))}o.forEach=a;function r(_,j){return y(($,B=null,q)=>_(O=>j(O)&&$.call(B,O),null,q))}o.filter=r;function s(_){return _}o.signal=s;function l(..._){return(j,$=null,B)=>(0,M.combinedDisposable)(..._.map(q=>q(O=>j.call($,O),null,B)))}o.any=l;function m(_,j,$){let B=$;return i(_,q=>(B=j(B,q),B))}o.reduce=m;function y(_){let j;const $=new b({onFirstListenerAdd(){j=_($.fire,$)},onLastListenerRemove(){j.dispose()}});return $.event}function D(_,j,$=100,B=!1,q){let O,H,T,A=0;const W=new b({leakWarningThreshold:q,onFirstListenerAdd(){O=_(z=>{A++,H=j(H,z),B&&!T&&(W.fire(H),H=void 0),clearTimeout(T),T=setTimeout(()=>{const X=H;H=void 0,T=void 0,(!B||A>1)&&W.fire(X),A=0},$)})},onLastListenerRemove(){O.dispose()}});return W.event}o.debounce=D;function R(_,j=($,B)=>$===B){let $=!0,B;return r(_,q=>{const O=$||!j(q,B);return $=!1,B=q,O})}o.latch=R;function F(_,j){return[o.filter(_,j),o.filter(_,$=>!j($))]}o.split=F;function C(_,j=!1,$=[]){let B=$.slice(),q=_(T=>{B?B.push(T):H.fire(T)});const O=()=>{B&&B.forEach(T=>H.fire(T)),B=null},H=new b({onFirstListenerAdd(){q||(q=_(T=>H.fire(T)))},onFirstListenerDidAdd(){B&&(j?setTimeout(O):O())},onLastListenerRemove(){q&&q.dispose(),q=null}});return H.event}o.buffer=C;class G{constructor(j){this.event=j}map(j){return new G(i(this.event,j))}forEach(j){return new G(a(this.event,j))}filter(j){return new G(r(this.event,j))}reduce(j,$){return new G(m(this.event,j,$))}latch(){return new G(R(this.event))}debounce(j,$=100,B=!1,q){return new G(D(this.event,j,$,B,q))}on(j,$,B){return this.event(j,$,B)}once(j,$,B){return c(this.event)(j,$,B)}}function ne(_){return new G(_)}o.chain=ne;function ae(_,j,$=B=>B){const B=(...T)=>H.fire($(...T)),q=()=>_.on(j,B),O=()=>_.removeListener(j,B),H=new b({onFirstListenerAdd:q,onLastListenerRemove:O});return H.event}o.fromNodeEventEmitter=ae;function K(_,j,$=B=>B){const B=(...T)=>H.fire($(...T)),q=()=>_.addEventListener(j,B),O=()=>_.removeEventListener(j,B),H=new b({onFirstListenerAdd:q,onLastListenerRemove:O});return H.event}o.fromDOMEventEmitter=K;function ee(_){return new Promise(j=>c(_)(j))}o.toPromise=ee})(n=e.Event||(e.Event={}));class f{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${f._idPool++}`}start(c){this._stopWatch=new E.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(o){const c=w;return w=o,{dispose(){w=c}}}e.setGlobalLeakWarningThreshold=t;class I{constructor(c,i=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let i=w;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||c<i)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(a)||0;if(this._stacks.set(a,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let s,l=0;for(const[m,y]of this._stacks)(!s||l<y)&&(s=m,l=y);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${l}):`),console.warn(s)}return()=>{const s=this._stacks.get(a)||0;this._stacks.set(a,s-1)}}}class b{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=w>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(c,i,a)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(i?[c,i]:c);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,i);const l=this._leakageMon?.check(this._listeners.size),m=(0,M.toDisposable)(()=>{l&&l(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof M.DisposableStore?a.add(m):Array.isArray(a)&&a.push(m),m}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,a]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,a):i[0].call(i[1],a)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class v extends b{async fireAsync(c,i,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,c]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),l=[],m={...s,waitUntil:y=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");a&&(y=a(y,typeof r=="function"?r:r[0])),l.push(y)}};try{typeof r=="function"?r.call(void 0,m):r[0].call(r[1],m)}catch(y){(0,p.onUnexpectedError)(y);continue}Object.freeze(l),await Promise.allSettled(l).then(y=>{for(const D of y)D.status==="rejected"&&(0,p.onUnexpectedError)(D.reason)})}}}}e.AsyncEmitter=v;class d extends b{constructor(c){super(c);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=d;class g extends d{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=g;class P extends b{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=P;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const i={event:c,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const a=()=>{this.hasListeners&&this.unhook(i);const r=this.events.indexOf(i);this.events.splice(r,1)};return(0,M.toDisposable)((0,L.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(i=>this.emitter.fire(i))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class u{constructor(){this.buffers=[]}wrapEvent(c){return(i,a,r)=>c(s=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>i.call(a,s)):i.call(a,s)},void 0,r)}bufferEvents(c){const i=[];this.buffers.push(i);const a=c();return this.buffers.pop(),i.forEach(r=>r()),a}}e.EventBufferer=u;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=M.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Z[23],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var M;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=M.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=E}),define(Z[108],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const b=this._icons.get(I.id);b?I.description?b.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new L;e.iconRegistry=M;function k(t,I){return new n(t,I)}e.registerCodicon=k;function E(t){return t?t.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,b,v){this.id=I,this.definition=b,this.description=v,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,I){const b=["codicon","codicon-"+t];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function b(g){if(g instanceof n)return["codicon","codicon-"+g.id];const P=I.exec(g.id);if(!P)return b(n.error);let[,S,u]=P;const h=["codicon","codicon-"+S];return u&&h.push("codicon-modifier-"+u.substr(1)),h}t.asClassNameArray=b;function v(g){return b(g).join(" ")}t.asClassName=v;function d(g){return"."+b(g).join(".")}t.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[65],x([0,1,17,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=M;function k(h){const o=h;return o?M(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=k;function E(h,o){return new n(h,o)}e.newWriteableStream=E;class n{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,p.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(c);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,o){const c=[];let i;for(;(i=h.read())!==null;)c.push(i);return o(c)}e.consumeReadable=f;function w(h,o,c){const i=[];let a;for(;(a=h.read())!==null&&i.length<c;)i.push(a);return a===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return h.read()}}}e.peekReadable=w;function t(h,o){return new Promise((c,i)=>{const a=[];I(h,{onData:r=>{o&&a.push(r)},onError:r=>{o?i(r):c(void 0)},onEnd:()=>{c(o?o(a):void 0)}})})}e.consumeStream=t;function I(h,o){h.on("error",c=>o.onError(c)),h.on("end",()=>o.onEnd()),h.on("data",c=>o.onData(c))}e.listenStream=I;function b(h,o){return new Promise((c,i)=>{const a=new L.DisposableStore,r=[],s=y=>{if(r.push(y),r.length>o)return a.dispose(),h.pause(),c({stream:h,buffer:r,ended:!1})},l=y=>i(y),m=()=>c({stream:h,buffer:r,ended:!0});a.add((0,L.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),a.add((0,L.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),a.add((0,L.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=b;function v(h,o){const c=E(o);return c.end(h),c}e.toStream=v;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=g;function P(h,o,c){const i=E(c);return I(h,{onData:a=>i.write(o.data(a)),onError:a=>i.error(o.error?o.error(a):a),onEnd:()=>i.end()}),i}e.transform=P;function S(h,o,c){let i=!1;return{read:()=>{const a=o.read();return i?a:(i=!0,a!==null?c([h,a]):h)}}}e.prefixedReadable=S;function u(h,o,c){let i=!1;const a=E(c);return I(o,{onData:r=>i?a.write(r):(i=!0,a.write(c([h,r]))),onError:r=>a.error(r),onEnd:()=>{i||(i=!0,a.write(h)),a.end()}}),a}e.prefixedStream=u}),define(Z[18],x([0,1,65]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let M,k;class E{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new E(Buffer.allocUnsafe(s)):new E(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new E(s)}static fromString(s,l){return!(l?.dontUseNodeBuffer||!1)&&L?new E(Buffer.from(s)):(M||(M=new TextEncoder),new E(M.encode(s)))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let D=0,R=s.length;D<R;D++)l+=s[D].byteLength}const m=E.alloc(l);let y=0;for(let D=0,R=s.length;D<R;D++){const F=s[D];m.set(F,y),y+=F.byteLength}return m}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(s,l){return new E(this.buffer.subarray(s,l))}set(s,l){s instanceof E?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,l){t(this.buffer,s,l)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,l){b(this.buffer,s,l)}readUInt8(s){return v(this.buffer,s)}writeUInt8(s,l){d(this.buffer,s,l)}}e.VSBuffer=E;function n(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=n;function f(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255}e.writeUInt16LE=f;function w(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=w;function t(r,s,l){r[l+3]=s,s=s>>>8,r[l+2]=s,s=s>>>8,r[l+1]=s,s=s>>>8,r[l]=s}e.writeUInt32BE=t;function I(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=I;function b(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255,s=s>>>8,r[l+2]=s&255,s=s>>>8,r[l+3]=s&255}e.writeUInt32LE=b;function v(r,s){return r[s]}e.readUInt8=v;function d(r,s,l){r[l]=s}e.writeUInt8=d;function g(r){return p.consumeReadable(r,s=>E.concat(s))}e.readableToBuffer=g;function P(r){return p.toReadable(r)}e.bufferToReadable=P;function S(r){return p.consumeStream(r,s=>E.concat(s))}e.streamToBuffer=S;async function u(r){return r.ended?E.concat(r.buffer):E.concat([...r.buffer,await S(r.stream)])}e.bufferedStreamToBuffer=u;function h(r){return p.toStream(r,s=>E.concat(s))}e.bufferToStream=h;function o(r){return p.transform(r,{data:s=>typeof s=="string"?E.fromString(s):E.wrap(s)},s=>E.concat(s))}e.streamToBufferReadableStream=o;function c(r){return p.newWriteableStream(s=>E.concat(s),r)}e.newWriteableBufferStream=c;function i(r,s){return p.prefixedReadable(r,s,l=>E.concat(l))}e.prefixedBufferReadable=i;function a(r,s){return p.prefixedStream(r,s,l=>E.concat(l))}e.prefixedBufferStream=a}),define(Z[25],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function M(Y,...se){return se.length===0?Y:Y.replace(L,function(ce,we){const ye=parseInt(we,10);return isNaN(ye)||ye<0||ye>=se.length?ce:se[ye]})}e.format=M;const k=/{([^}]+)}/g;function E(Y,se){return Y.replace(k,(ce,we)=>se[we]??ce)}e.format2=E;function n(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=n;function f(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(Y,se){let ce=0;const we=se.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===we&&ce++;return ce}e.count=w;function t(Y,se,ce="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ce}`}e.truncate=t;function I(Y,se=" "){const ce=b(Y,se);return v(ce,se)}e.trim=I;function b(Y,se){if(!Y||!se)return Y;const ce=se.length;if(ce===0||Y.length===0)return Y;let we=0;for(;Y.indexOf(se,we)===we;)we=we+ce;return Y.substring(we)}e.ltrim=b;function v(Y,se){if(!Y||!se)return Y;const ce=se.length,we=Y.length;if(ce===0||we===0)return Y;let ye=we,De=-1;for(;De=Y.lastIndexOf(se,ye-1),!(De===-1||De+ce!==ye);){if(De===0)return"";ye=De}return Y.substring(0,ye)}e.rtrim=v;function d(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function P(Y,se,ce={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=f(Y)),ce.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(Y,we)}e.createRegExp=P;function S(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function u(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function h(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=h;function o(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=o;function c(Y){for(let se=0,ce=Y.length;se<ce;se++){const we=Y.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function i(Y,se=0,ce=Y.length){for(let we=se;we<ce;we++){const ye=Y.charCodeAt(we);if(ye!==32&&ye!==9)return Y.substring(se,we)}return Y.substring(se,ce)}e.getLeadingWhitespace=i;function a(Y,se=Y.length-1){for(let ce=se;ce>=0;ce--){const we=Y.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function s(Y,se,ce=0,we=Y.length,ye=0,De=se.length){for(;ce<we&&ye<De;ce++,ye++){let Ne=Y.charCodeAt(ce),ze=se.charCodeAt(ye);if(Ne<ze)return-1;if(Ne>ze)return 1}const Fe=we-ce,We=De-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=s;function l(Y,se){return m(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=l;function m(Y,se,ce=0,we=Y.length,ye=0,De=se.length){for(;ce<we&&ye<De;ce++,ye++){let Ne=Y.charCodeAt(ce),ze=se.charCodeAt(ye);if(Ne===ze)continue;const he=Ne-ze;if(!(he===32&&D(ze))&&!(he===-32&&D(Ne)))return y(Ne)&&y(ze)?he:s(Y.toLowerCase(),se.toLowerCase(),ce,we,ye,De)}const Fe=we-ce,We=De-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=m;function y(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=y;function D(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=D;function R(Y){return y(Y)||D(Y)}function F(Y,se){return Y.length===se.length&&C(Y,se)}e.equalsIgnoreCase=F;function C(Y,se,ce=Y.length){for(let we=0;we<ce;we++){const ye=Y.charCodeAt(we),De=se.charCodeAt(we);if(ye!==De){if(R(ye)&&R(De)){const Fe=Math.abs(ye-De);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ye).toLowerCase()!==String.fromCharCode(De).toLowerCase())return!1}}return!0}function G(Y,se){const ce=se.length;return se.length>Y.length?!1:C(Y,se,ce)}e.startsWithIgnoreCase=G;function ne(Y,se){let ce,we=Math.min(Y.length,se.length);for(ce=0;ce<we;ce++)if(Y.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=ne;function ae(Y,se){let ce,we=Math.min(Y.length,se.length);const ye=Y.length-1,De=se.length-1;for(ce=0;ce<we;ce++)if(Y.charCodeAt(ye-ce)!==se.charCodeAt(De-ce))return ce;return we}e.commonSuffixLength=ae;function K(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=K;function ee(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=ee;function _(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=_;function j(Y,se,ce){const we=Y.charCodeAt(ce);if(K(we)&&ce+1<se){const ye=Y.charCodeAt(ce+1);if(ee(ye))return _(we,ye)}return we}e.getNextCodePoint=j;function $(Y,se){const ce=Y.charCodeAt(se-1);if(ee(ce)&&se>1){const we=Y.charCodeAt(se-2);if(K(we))return _(we,ce)}return ce}function B(Y,se){const ce=Be.getInstance(),we=se,ye=Y.length,De=j(Y,ye,se);se+=De>=65536?2:1;let Fe=ce.getGraphemeBreakType(De);for(;se<ye;){const We=j(Y,ye,se),Ne=ce.getGraphemeBreakType(We);if(Ce(Fe,Ne))break;se+=We>=65536?2:1,Fe=Ne}return se-we}e.nextCharLength=B;function q(Y,se){const ce=Be.getInstance(),we=se,ye=$(Y,se);se-=ye>=65536?2:1;let De=ce.getGraphemeBreakType(ye);for(;se>0;){const Fe=$(Y,se),We=ce.getGraphemeBreakType(Fe);if(Ce(We,De))break;se-=Fe>=65536?2:1,De=We}return we-se}e.prevCharLength=q;function O(Y,se){const ce=Be.getInstance(),we=Y.length,ye=se,De=j(Y,we,se),Fe=ce.getGraphemeBreakType(De);se+=De>=65536?2:1;let We=Fe;for(;se<we;){const ze=j(Y,we,se),he=ce.getGraphemeBreakType(ze);if(Ce(We,he))break;se+=ze>=65536?2:1,We=he}const Ne=se;for(se=ye,We=Fe;se>0;){const ze=$(Y,se),he=ce.getGraphemeBreakType(ze);if(Ce(he,We))break;se-=ze>=65536?2:1,We=he}return[se,Ne]}function H(Y,se){return se>0&&ee(Y.charCodeAt(se))?O(Y,se-1):O(Y,se)}e.getCharContainingOffset=H;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(Y){return T.test(Y)}e.containsRTL=A;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return W.test(Y)}e.containsEmoji=z;const X=/^[\t\n\r\x20-\x7E]*$/;function U(Y){return X.test(Y)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=N;function Q(Y){for(let se=0,ce=Y.length;se<ce;se++)if(J(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=Q;function J(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=J;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function le(Y,se){if(Y.length<se)return Y;const ce=/\b/g;let we=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return Y.substring(we).replace(/^\s/,"")}e.lcut=le;const ie=/\x1B\x5B[12]?K/g,oe=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function fe(Y){return Y&&(Y=Y.replace(ie,""),Y=Y.replace(oe,""),Y=Y.replace(ge,"")),Y}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function Pe(Y){return de(Y)?Y.substr(1):Y}e.stripUTF8BOM=Pe;function pe(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ce=se.length,we=Y.toLowerCase();let ye=0,De=-1;for(;ye<ce;){const Fe=we.indexOf(se[ye],De+1);if(Fe<0)return!1;De=Fe,ye++}return!0}e.fuzzyContains=pe;function me(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=me;function be(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=be;function ke(Y,se=1){if(se===0)return"";let ce=-1;do ce=Y.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?Y:(Y[ce-1]==="\r"&&ce--,Y.substr(0,ce))}e.getNLines=ke;function Ae(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Ae;function Ue(Y){return Be.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ue;function Ce(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=Ce;var Ge;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let ye=1;for(;ye<=we;)if(se<ce[3*ye])ye=2*ye;else if(se>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(Y,se){if(Y===0)return 0;const ce=ot(Y,se);if(ce!==void 0)return ce;const we=$(se,Y);return Y-=Ye(we),Y}e.getLeftDeleteOffset=Ze;function ot(Y,se){let ce=$(se,Y);for(Y-=Ye(ce);ut(ce)||ce===65039||ce===8419;){if(Y===0)return;ce=$(se,Y),Y-=Ye(ce)}if(!!re(ce)){if(Y>=0){const we=$(se,Y);we===8205&&(Y-=Ye(we))}return Y}}function Ye(Y){return Y>=65536?2:1}function ut(Y){return 127995<=Y&&Y<=127999}var xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(Z[79],x([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(S){return M(S,0)}e.hash=L;function M(S,u){switch(typeof S){case"object":return S===null?k(349,u):Array.isArray(S)?f(S,u):w(S,u);case"string":return n(S,u);case"boolean":return E(S,u);case"number":return k(S,u);case"undefined":return k(937,u);default:return k(617,u)}}e.doHash=M;function k(S,u){return(u<<5)-u+S|0}function E(S,u){return k(S?433:863,u)}function n(S,u){u=k(149417,u);for(let h=0,o=S.length;h<o;h++)u=k(S.charCodeAt(h),u);return u}e.stringHash=n;function f(S,u){return u=k(104579,u),S.reduce((h,o)=>M(o,h),u)}function w(S,u){return u=k(181387,u),Object.keys(S).sort().reduce((h,o)=>(h=n(o,h),M(S[o],h)),u)}class t{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=M(u,this._value),this._value}}e.Hasher=t;var I;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function b(S,u,h=32){const o=h-u,c=~((1<<o)-1);return(S<<u|(c&S)>>>o)>>>0}function v(S,u=0,h=S.byteLength,o=0){for(let c=0;c<h;c++)S[u+c]=o}function d(S,u,h="0"){for(;S.length<u;)S=h+S;return S}function g(S,u=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((S>>>0).toString(16),u/4)}e.toHexString=g;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const h=u.length;if(h===0)return;const o=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,a,r;for(i!==0?(a=i,r=-1,i=0):(a=u.charCodeAt(0),r=0);;){let s=a;if(p.isHighSurrogate(a))if(r+1<h){const l=u.charCodeAt(r+1);p.isLowSurrogate(l)?(r++,s=p.computeCodePoint(a,l)):s=65533}else{i=a;break}else p.isLowSurrogate(a)&&(s=65533);if(c=this._push(o,c,s),r++,r<h)a=u.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(u,h,o){return o<128?u[h++]=o:o<2048?(u[h++]=192|(o&1984)>>>6,u[h++]=128|(o&63)>>>0):o<65536?(u[h++]=224|(o&61440)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0):(u[h++]=240|(o&1835008)>>>18,u[h++]=128|(o&258048)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=P._bigBlock32,h=this._buffDV;for(let y=0;y<64;y+=4)u.setUint32(y,h.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)u.setUint32(y,b(u.getUint32(y-12,!1)^u.getUint32(y-32,!1)^u.getUint32(y-56,!1)^u.getUint32(y-64,!1),1),!1);let o=this._h0,c=this._h1,i=this._h2,a=this._h3,r=this._h4,s,l,m;for(let y=0;y<80;y++)y<20?(s=c&i|~c&a,l=1518500249):y<40?(s=c^i^a,l=1859775393):y<60?(s=c&i|c&a|i&a,l=2400959708):(s=c^i^a,l=3395469782),m=b(o,5)+s+r+l+u.getUint32(y*4,!1)&4294967295,r=a,a=i,i=b(c,30),c=o,o=m;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(D){return Array.isArray(D)}e.isArray=p;function L(D){return typeof D=="string"}e.isString=L;function M(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=M;function k(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=k;function E(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=E;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function t(D){return!I(D)}e.isDefined=t;function I(D){return w(D)||D===null}e.isUndefinedOrNull=I;function b(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=b;function v(D){if(I(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=v;function d(...D){const R=[];for(let F=0;F<D.length;F++){const C=D[F];if(I(C))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);R.push(C)}return R}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function P(D){if(!k(D))return!1;for(let R in D)if(g.call(D,R))return!1;return!0}e.isEmptyObject=P;function S(D){return typeof D=="function"}e.isFunction=S;function u(...D){return D.length>0&&D.every(S)}e.areFunctions=u;function h(D,R){const F=Math.min(D.length,R.length);for(let C=0;C<F;C++)o(D[C],R[C])}e.validateConstraints=h;function o(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(S(R)){try{if(D instanceof R)return}catch{}if(!I(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(D){let R=[],F=Object.getPrototypeOf(D);for(;Object.prototype!==F;)R=R.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return R}e.getAllPropertyNames=c;function i(D){const R=[];for(const F of c(D))typeof D[F]=="function"&&R.push(F);return R}e.getAllMethodNames=i;function a(D,R){const F=G=>function(){const ne=Array.prototype.slice.call(arguments,0);return R(G,ne)};let C={};for(const G of D)C[G]=F(G);return C}e.createProxyObject=a;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function s(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=s;function l(D){return class{constructor(){return new Proxy({},{get(R,F){if(R[F])return R[F];throw new Error(`Not Implemented: ${D}->${String(F)}`)}})}}}e.NotImplementedProxy=l;function m(D,R="Unreachable"){throw new Error(R)}e.assertNever=m;function y(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=y}),define(Z[31],x([0,1,8,3,25,13]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function w(r,s=p.posix.sep){if(!r)return"";const l=r.length,m=r.charCodeAt(0);if(E(m)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let D=3;const R=D;for(;D<l&&!E(r.charCodeAt(D));D++);if(R!==D&&!E(r.charCodeAt(D+1))){for(D+=1;D<l;D++)if(E(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,s)}}return s}else if(S(m)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let y=r.indexOf("://");if(y!==-1){for(y+=3;y<l;y++)if(E(r.charCodeAt(y)))return r.slice(0,y+1)}return""}e.getRoot=w;function t(r){if(!L.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const m=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(m===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=t;const I=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=L.isWindows){const l=s?I:b;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&v.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,s,l){const m=r===s;return!l||m?m:!r||!s?!1:(0,M.equalsIgnoreCase)(r,s)}e.isEqual=g;function P(r,s,l,m=p.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!(0,M.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let D=s.length;return s.charAt(s.length-1)===m&&D--,r.charAt(D)===m}return s.charAt(s.length-1)!==m&&(s+=m),r.indexOf(s)===0}e.isEqualOrParent=P;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function u(r,s){return L.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(s,r)),r=(0,p.normalize)(r),L.isWindows?(r=(0,M.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,M.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=u;function h(r){const s=(0,p.normalize)(r);return L.isWindows?r.length>3?!1:o(s)&&(r.length===2||s.charCodeAt(2)===92):s===p.posix.sep}e.isRootOrDriveLetter=h;function o(r){return L.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function c(r){return o(r)?r[0]:void 0}e.getDriveLetter=c;function i(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function a(r){const s=r.split(":");let l,m,y;if(s.forEach(D=>{const R=Number(D);(0,k.isNumber)(R)?m===void 0?m=R:y===void 0&&(y=R):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:y!==void 0?y:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Z[44],x([0,1,13]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const P=Array.isArray(g)?[]:{};return Object.keys(g).forEach(S=>{g[S]&&typeof g[S]=="object"?P[S]=L(g[S]):P[S]=g[S]}),P}e.deepClone=L;function M(g){if(!g||typeof g!="object")return g;const P=[g];for(;P.length>0;){const S=P.shift();Object.freeze(S);for(const u in S)if(k.call(S,u)){const h=S[u];typeof h=="object"&&!Object.isFrozen(h)&&P.push(h)}}return g}e.deepFreeze=M;const k=Object.prototype.hasOwnProperty;function E(g,P){return n(g,P,new Set)}e.cloneAndChange=E;function n(g,P,S){if((0,p.isUndefinedOrNull)(g))return g;const u=P(g);if(typeof u!="undefined")return u;if((0,p.isArray)(g)){const h=[];for(const o of g)h.push(n(o,P,S));return h}if((0,p.isObject)(g)){if(S.has(g))throw new Error("Cannot clone recursive data-structure");S.add(g);const h={};for(let o in g)k.call(g,o)&&(h[o]=n(g[o],P,S));return S.delete(g),h}return g}function f(g,P,S=!0){return(0,p.isObject)(g)?((0,p.isObject)(P)&&Object.keys(P).forEach(u=>{u in g?S&&((0,p.isObject)(g[u])&&(0,p.isObject)(P[u])?f(g[u],P[u],S):g[u]=P[u]):g[u]=P[u]}),g):P}e.mixin=f;function w(g,P){if(g===P)return!0;if(g==null||P===null||P===void 0||typeof g!=typeof P||typeof g!="object"||Array.isArray(g)!==Array.isArray(P))return!1;let S,u;if(Array.isArray(g)){if(g.length!==P.length)return!1;for(S=0;S<g.length;S++)if(!w(g[S],P[S]))return!1}else{const h=[];for(u in g)h.push(u);h.sort();const o=[];for(u in P)o.push(u);if(o.sort(),!w(h,o))return!1;for(S=0;S<h.length;S++)if(!w(g[h[S]],P[h[S]]))return!1}return!0}e.equals=w;function t(g){const P=new Set;return JSON.stringify(g,(S,u)=>{if((0,p.isObject)(u)||Array.isArray(u)){if(P.has(u))return"[Circular]";P.add(u)}return u})}e.safeStringify=t;function I(g,P,S){const u=P(g);return typeof u=="undefined"?S:u}e.getOrDefault=I;function b(g,P){const S=Object.create(null);return!g||!P||Object.keys(P).forEach(h=>{const o=g[h],c=P[h];w(o,c)||(S[h]=c)}),S}e.distinct=b;function v(g,P){const S=P.toLowerCase(),u=Object.keys(g).find(h=>h.toLowerCase()===S);return u?g[u]:g[P]}e.getCaseInsensitive=v;function d(g,P){const S=Object.create(null);for(const u of Object.keys(g))P(u,g[u])&&(S[u]=g[u]);return S}e.filter=d}),define(Z[7],x([0,1,8,3]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,k=/^\//,E=/^\/\//;function n(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!M.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function w(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const t="",I="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(s,l,m,y,D,R=!1){typeof s=="object"?(this.scheme=s.scheme||t,this.authority=s.authority||t,this.path=s.path||t,this.query=s.query||t,this.fragment=s.fragment||t):(this.scheme=f(s,R),this.authority=l||t,this.path=w(this.scheme,m||t),this.query=y||t,this.fragment=D||t,n(this,R))}static isUri(s){return s instanceof v?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:m,path:y,query:D,fragment:R}=s;return l===void 0?l=this.scheme:l===null&&(l=t),m===void 0?m=this.authority:m===null&&(m=t),y===void 0?y=this.path:y===null&&(y=t),D===void 0?D=this.query:D===null&&(D=t),R===void 0?R=this.fragment:R===null&&(R=t),l===this.scheme&&m===this.authority&&y===this.path&&D===this.query&&R===this.fragment?this:new g(l,m,y,D,R)}static parse(s,l=!1){const m=b.exec(s);return m?new g(m[2]||t,a(m[4]||t),a(m[5]||t),a(m[7]||t),a(m[9]||t),l):new g(t,t,t,t,t)}static file(s){let l=t;if(L.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const m=s.indexOf(I,2);m===-1?(l=s.substring(2),s=I):(l=s.substring(2,m),s=s.substring(m)||I)}return new g("file",l,s,t,t)}static from(s){const l=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return n(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&s.scheme==="file"?m=v.file(p.win32.join(h(s,!0),...l)).path:m=p.posix.join(s.path,...l),s.with({path:m})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof v)return s;{const l=new g(s);return l._formatted=s.external,l._fsPath=s._sep===d?s.fsPath:null,l}}else return s}}e.URI=v;const d=L.isWindows?1:void 0;class g extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(r,s){let l,m=-1;for(let y=0;y<r.length;y++){const D=r.charCodeAt(y);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47)m!==-1&&(l+=encodeURIComponent(r.substring(m,y)),m=-1),l!==void 0&&(l+=r.charAt(y));else{l===void 0&&(l=r.substr(0,y));const R=P[D];R!==void 0?(m!==-1&&(l+=encodeURIComponent(r.substring(m,y)),m=-1),l+=R):m===-1&&(m=y)}}return m!==-1&&(l+=encodeURIComponent(r.substring(m))),l!==void 0?l:r}function u(r){let s;for(let l=0;l<r.length;l++){const m=r.charCodeAt(l);m===35||m===63?(s===void 0&&(s=r.substr(0,l)),s+=P[m]):s!==void 0&&(s+=r[l])}return s!==void 0?s:r}function h(r,s){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function o(r,s){const l=s?u:S;let m="",{scheme:y,authority:D,path:R,query:F,fragment:C}=r;if(y&&(m+=y,m+=":"),(D||y==="file")&&(m+=I,m+=I),D){let G=D.indexOf("@");if(G!==-1){const ne=D.substr(0,G);D=D.substr(G+1),G=ne.indexOf(":"),G===-1?m+=l(ne,!1):(m+=l(ne.substr(0,G),!1),m+=":",m+=l(ne.substr(G+1),!1)),m+="@"}D=D.toLowerCase(),G=D.indexOf(":"),G===-1?m+=l(D,!1):(m+=l(D.substr(0,G),!1),m+=D.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}m+=l(R,!0)}return F&&(m+="?",m+=l(F,!1)),C&&(m+="#",m+=s?C:S(C,!1)),m}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(i)?r.replace(i,s=>c(s)):r}}),define(Z[109],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function M(w){const t=[];let I;try{const b=JSON.parse(w.arguments),v=b[b.length-1];v&&v.__$stack&&(b.pop(),I=v.__$stack),t.push(...b)}catch(b){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:I}}e.parse=M;function k(w){if(typeof w!="string")return k(M(w).stack);const t=w;if(t){const I=E(t),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(b&&b.length===4)return{uri:p.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=k;function E(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function n(w,t){const{args:I,stack:b}=M(w),v=typeof I[0]=="string"&&I.length===1;let d=E(b);d&&(d=`(${d.trim()})`);let g=[];if(typeof I[0]=="string"?d&&v?g=[`%c[${t}] %c${I[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:g=[`%c[${t}]%`,f("blue"),...I],d&&!v&&g.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,p,L,M){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!M:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?M.call(V,p):M?M.value=p:e.set(V,p),p},je=this&&this.__classPrivateFieldGet||function(V,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(V):L?L.value:e.get(V)};define(Z[37],x([0,1,30,25,7]),function(V,e,p,L,M){"use strict";var k,E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,r,s){let l=a.get(r);return l===void 0&&(l=s,a.set(r,l)),l}e.getOrSet=f;function w(a){const r=[];return a.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=w;function t(a){const r=[];return a.forEach(s=>{r.push(s)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=I;class b{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class v{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class P{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(r){this._iter=r}static forUris(r=()=>!1){return new S(new g(r))}static forPaths(){return new S(new v)}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new b)}clear(){this._root=void 0}set(r,s){const l=this._iter.reset(r);let m;for(this._root||(this._root=new P,this._root.segment=l.value()),m=this._root;;){const D=l.cmp(m.segment);if(D>0)m.left||(m.left=new P,m.left.segment=l.value()),m=m.left;else if(D<0)m.right||(m.right=new P,m.right.segment=l.value()),m=m.right;else if(l.hasNext())l.next(),m.mid||(m.mid=new P,m.mid.segment=l.value()),m=m.mid;else break}const y=m.value;return m.value=s,m.key=r,y}fill(r,s){const l=s.slice(0);(0,p.shuffle)(l);for(let m of l)this.set(m,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),m=[];let y=this._root;for(;y;){const D=l.cmp(y.segment);if(D>0)m.push([1,y]),y=y.left;else if(D<0)m.push([-1,y]),y=y.right;else if(l.hasNext())l.next(),m.push([0,y]),y=y.mid;else{for(s?(y.left=void 0,y.mid=void 0,y.right=void 0):y.value=void 0;m.length>0&&y.isEmpty();){let[R,F]=m.pop();switch(R){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}y=F}break}}}findSubstr(r){const s=this._iter.reset(r);let l=this._root,m;for(;l;){const y=s.cmp(l.segment);if(y>0)l=l.left;else if(y<0)l=l.right;else if(s.hasNext())s.next(),m=l.value||m,l=l.mid;else break}return l&&l.value||m}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const l=s.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&s.push(l.left),l.mid&&s.push(l.mid),l.right&&s.push(l.right))}}}e.TernarySearchTree=S;class u{constructor(r,s){this[k]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[l,m]of this.map)r(m,M.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield M.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[M.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[M.URI.parse(r[0]),r[1]]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class o{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let m=this._map.get(r);if(m)m.value=s,l!==0&&this.touch(m,l);else{switch(m={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let m=this._head;for(;m;){if(s?r.bind(s)(m.value,m.key,this):r(m.value,m.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return m}values(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return m}entries(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(l.previous=m,m.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,m=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=m,m.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=o;class c extends o{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class i{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return je(this,n,"f").size}forEach(r,s){je(this,n,"f").forEach(r,s)}get(r){return je(this,n,"f").get(r)}has(r){return je(this,n,"f").has(r)}entries(){return je(this,n,"f").entries()}keys(){return je(this,n,"f").keys()}values(){return je(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return je(this,n,"f").entries()}}e.ReadonlyMapView=i}),define(Z[110],x([0,1,18,25,7]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(t){return JSON.stringify(t,f)}e.stringify=k;function E(t){let I=JSON.parse(t);return I=w(I),I}e.parse=E;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function w(t,I=0){if(!t||I>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return M.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof p.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let b=0;b<t.length;++b)t[b]=w(t[b],I+1);else for(const b in t)Object.hasOwnProperty.call(t,b)&&(t[b]=w(t[b],I+1))}return t}e.revive=w}),define(Z[10],x([0,1,3,7]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(M=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const I=this._ports[w],b=this._connectionTokens[w];let v=`path=${encodeURIComponent(f.path)}`;return typeof b=="string"&&(v+=`&tkn=${encodeURIComponent(b)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${t}:${I}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new k;class E{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===M.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${M.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?t.with({scheme:M.vscodeFileResource,authority:t.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===M.vscodeFileResource?t.with({scheme:M.file,authority:t.authority!==E.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}E.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new E}),define(Z[66],x([0,1,37]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function M(w){return f(w,"NFC",L)}e.normalizeNFC=M;const k=new p.LRUCache(1e4);function E(w){return f(w,"NFD",k)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function f(w,t,I){if(!w)return w;const b=I.get(w);if(b)return b;let v;return n.test(w)?v=w.normalize(t):v=w,I.set(w,v),v}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return E(t).replace(w,"")}}()}),define(Z[15],x([0,1,31,10,8,3,25,7]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(v){return(0,n.uriToFsPath)(v,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,g,P=!1){return d===g?0:(0,E.compare)(this.getComparisonKey(d,P),this.getComparisonKey(g,P))}isEqual(d,g,P=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,P)===this.getComparisonKey(g,P)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,P=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return p.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(P||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return p.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(P||d.fragment===g.fragment)}return!1}joinPath(d,...g){return n.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(M.dirname(f(d))).path:(g=M.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(M.normalize(f(d))).path:g=M.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const u=M.relative(f(d),f(g));return k.isWindows?p.toSlashes(u):u}let P=d.path||"/",S=g.path||"/";if(this._ignorePathCasing(d)){let u=0;for(const h=Math.min(P.length,S.length);u<h&&!(P.charCodeAt(u)!==S.charCodeAt(u)&&P.charAt(u).toLowerCase()!==S.charAt(u).toLowerCase());u++);P=S.substr(0,u)+P.substr(u)}return M.posix.relative(P,S)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const P=n.URI.file(M.resolve(f(d),g));return d.with({authority:P.authority,path:P.path})}return g=p.toPosixPath(g),d.with({path:M.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,E.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=M.sep){if(d.scheme===L.Schemas.file){const P=f(d);return P.length>p.getRoot(P).length&&P[P.length-1]===g}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=M.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=M.sep){let P=!1;if(d.scheme===L.Schemas.file){const S=f(d);P=S!==void 0&&S.length===p.getRoot(S).length&&S[S.length-1]===g}else{g="/";const S=d.path;P=S.length===1&&S.charCodeAt(S.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(v=>v.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new w(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(v,d){const g=[];for(let P=0;P<v.length;P++){const S=d(v[P]);v.some((u,h)=>h===P?!1:(0,e.isEqualOrParent)(S,d(u)))||g.push(v[P])}return g}e.distinctParents=t;var I;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function d(g){const P=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,c]=h.split(":");o&&c&&P.set(o,c)});const u=g.path.substring(0,g.path.indexOf(";"));return u&&P.set(v.META_DATA_MIME,u),P}v.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function b(v,d,g){if(d){let P=v.path;return P&&P[0]!==M.posix.sep&&(P=M.posix.sep+P),v.with({scheme:g,authority:d,path:P})}return v.with({scheme:g})}e.toLocalResource=b}),define(Z[9],x([0,1,23,17,4,2,15]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n($){return!!$&&typeof $.then=="function"}e.isThenable=n;function f($){const B=new p.CancellationTokenSource,q=$(B.token),O=new Promise((H,T)=>{const A=B.token.onCancellationRequested(()=>{A.dispose(),B.dispose(),T((0,L.canceled)())});Promise.resolve(q).then(W=>{A.dispose(),B.dispose(),H(W)},W=>{A.dispose(),B.dispose(),T(W)})});return new class{cancel(){B.cancel()}then(H,T){return O.then(H,T)}catch(H){return this.then(void 0,H)}finally(H){return O.finally(H)}}}e.createCancelablePromise=f;function w($,B,q){return Promise.race([$,new Promise(O=>B.onCancellationRequested(()=>O(q)))])}e.raceCancellation=w;async function t($){let B=-1;const q=$.map((H,T)=>H.then(A=>(B=T,A))),O=await Promise.race(q);return $.forEach((H,T)=>{T!==B&&H.cancel()}),O}e.raceCancellablePromises=t;function I($,B,q){let O;const H=setTimeout(()=>{O?.(void 0),q?.()},B);return Promise.race([$.finally(()=>clearTimeout(H)),new Promise(T=>O=T)])}e.raceTimeout=I;function b($){return new Promise((B,q)=>{const O=$();n(O)?O.then(B,q):B(O)})}e.asPromise=b;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(q,q).then(O)})}return new Promise((q,O)=>{this.queuedPromise.then(q,O)})}return this.activePromise=B(),new Promise((q,O)=>{this.activePromise.then(H=>{this.activePromise=null,q(H)},H=>{this.activePromise=null,O(H)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(B,q){const H=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(B)===H&&this.promiseMap.delete(B)});return this.promiseMap.set(B,H),H}}e.SequencerByKey=g;class P{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,q=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,H)=>{this.doResolve=O,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class S{constructor(B){this.delayer=new P(B),this.throttler=new v}trigger(B,q){return this.delayer.trigger(()=>this.throttler.queue(B),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class u{constructor(){this._isOpen=!1,this._promise=new Promise((B,q)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o($,B){return B?new Promise((q,O)=>{const H=setTimeout(()=>{T.dispose(),q()},$),T=B.onCancellationRequested(()=>{clearTimeout(H),T.dispose(),O((0,L.canceled)())})}):f(q=>o($,q))}e.timeout=o;function c($,B=0){const q=setTimeout($,B);return(0,k.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=c;function i($){const B=[];let q=0;const O=$.length;function H(){return q<O?$[q++]():null}function T(A){A!=null&&B.push(A);const W=H();return W?W.then(T):Promise.resolve(B)}return Promise.resolve(null).then(T)}e.sequence=i;function a($,B=O=>!!O,q=null){let O=0;const H=$.length,T=()=>{if(O>=H)return Promise.resolve(q);const A=$[O++];return Promise.resolve(A()).then(z=>B(z)?Promise.resolve(z):T())};return T()}e.first=a;function r($,B=O=>!!O,q=null){if($.length===0)return Promise.resolve(q);let O=$.length;const H=()=>{O=-1;for(const T of $)T.cancel?.()};return new Promise((T,A)=>{for(const W of $)W.then(z=>{--O>=0&&B(z)?(H(),T(z)):O===0&&T(q)}).catch(z=>{--O>=0&&(H(),A(z))})})}e.firstParallel=r;class s{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((q,O)=>{this.outstandingPromises.push({factory:B,c:q,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const q=B.factory();q.then(B.c,B.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class l extends s{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor(B,q=E.extUri){const O=q.getComparisonKey(B);let H=this.queues.get(O);return H||(H=new l,M.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(O)}),this.queues.set(O,H)),H}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=m;class y{constructor(B,q){this._token=-1,typeof B=="function"&&typeof q=="number"&&this.setIfNotSet(B,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},q)}setIfNotSet(B,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},q))}}e.TimeoutTimer=y;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,q){this.cancel(),this._token=setInterval(()=>{B()},q)}}e.IntervalTimer=D;class R{constructor(B,q){this.timeoutToken=-1,this.runner=B,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F{constructor(B,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class C extends R{constructor(B,q){super(B,q);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class G extends k.Disposable{constructor(B,q,O,H){super();this.maxWorkChunkSize=B,this.maxPendingWork=q,this.throttleDelay=O,this.handler=H,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const q=setTimeout(()=>B($));let O=!1;return{dispose(){O||(O=!0,clearTimeout(q))}}}}else e.runWhenIdle=($,B)=>{const q=requestIdleCallback($,typeof B=="number"?{timeout:B}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(q))}}}}();class ne{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function ae($,B,q){let O;for(let H=0;H<q;H++)try{return await $()}catch(T){O=T,await o(B)}throw O}e.retry=ae;class K{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,q,O){return this._pending={taskId:B,cancel:()=>O?.(),promise:q},q.then(()=>this.donePending(B),()=>this.donePending(B)),q}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let q,O;const H=new Promise((T,A)=>{q=T,O=A});this._next={run:B,promise:H,promiseResolve:q,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=K;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,q)=>{this.completeCallback=B,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(q=>{this.completeCallback(B),this.resolved=!0,q()})}error(B){return new Promise(q=>{this.errorCallback(B),this.rejected=!0,q()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=_;var j;(function($){async function B(q){let O;const H=await Promise.all(q.map(T=>T.then(A=>A,A=>{O||(O=A)})));if(typeof O!="undefined")throw O;return H}$.settled=B})(j=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,31,37,8,25]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",t="[/\\\\]",I="[^/\\\\]",b=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${t}|${I}+${t}|${t}${I}+)*?`}}function d(O,H){if(!O)return[];const T=[];let A=!1,W=!1,z="";for(const X of O){switch(X){case H:if(!A&&!W){T.push(z),z="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":W=!0;break;case"]":W=!1;break}z+=X}return z&&T.push(z),T}e.splitGlobAware=d;function g(O){if(!O)return"";let H="";const T=d(O,w);if(T.every(A=>A===f))H=".*";else{let A=!1;T.forEach((W,z)=>{if(W===f){A||(H+=v(2),A=!0);return}let X=!1,U="",N=!1,Q="";for(const J of W){if(J!=="}"&&X){U+=J;continue}if(N&&(J!=="]"||!Q)){let re;J==="-"?re=J:(J==="^"||J==="!")&&!Q?re="^":J===w?re="":re=E.escapeRegExpCharacters(J),Q+=re;continue}switch(J){case"{":X=!0;continue;case"[":N=!0;continue;case"}":H+=`(?:${d(U,",").map(ie=>g(ie)).join("|")})`,X=!1,U="";break;case"]":H+="["+Q+"]",N=!1,Q="";break;case"?":H+=I;continue;case"*":H+=v(1);continue;default:H+=E.escapeRegExpCharacters(J)}}z<T.length-1&&(T[z+1]!==f||z+2<T.length)&&(H+=t),A=!1})}return H}const P=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(O,H){if(!O)return r;let T;typeof O!="string"?T=O.pattern:T=O,T=T.trim();const A=`${T}_${!!H.trimForExclusions}`;let W=i.get(A);if(W)return l(W,O);let z;if(P.test(T)){const X=T.substr(4);W=function(U,N){return typeof U=="string"&&U.endsWith(X)?T:null}}else(z=S.exec(m(T,H)))?W=y(z[1],T):(H.trimForExclusions?h:u).test(T)?W=D(T,H):(z=o.exec(m(T,H)))?W=R(z[1].substr(1),T,!0):(z=c.exec(m(T,H)))?W=R(z[1],T,!1):W=F(T);return i.set(A,W),l(W,O)}function l(O,H){return typeof H=="string"?O:function(T,A){return L.isEqualOrParent(T,H.base)?O(k.relative(H.base,T),A):null}}function m(O,H){return H.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function y(O,H){const T=`/${O}`,A=`\\${O}`,W=function(X,U){return typeof X!="string"?null:U?U===O?H:null:X===O||X.endsWith(T)||X.endsWith(A)?H:null},z=[O];return W.basenames=z,W.patterns=[H],W.allBasenames=z,W}function D(O,H){const T=q(O.slice(1,-1).split(",").map(U=>s(U,H)).filter(U=>U!==r),O),A=T.length;if(!A)return r;if(A===1)return T[0];const W=function(U,N){for(let Q=0,J=T.length;Q<J;Q++)if(T[Q](U,N))return O;return null},z=T.find(U=>!!U.allBasenames);z&&(W.allBasenames=z.allBasenames);const X=T.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return X.length&&(W.allPaths=X),W}function R(O,H,T){const A=k.sep===k.posix.sep,W=A?O:O.replace(b,k.sep),z=k.sep+W,X=k.posix.sep+O,U=T?function(N,Q){return typeof N=="string"&&(N===W||N.endsWith(z)||!A&&(N===O||N.endsWith(X)))?H:null}:function(N,Q){return typeof N=="string"&&(N===W||!A&&N===O)?H:null};return U.allPaths=[(T?"*/":"./")+O],U}function F(O){try{const H=new RegExp(`^${g(O)}$`);return function(T){return H.lastIndex=0,typeof T=="string"&&H.test(T)?O:null}}catch(H){return r}}function C(O,H,T){return!O||typeof H!="string"?!1:G(O)(H,void 0,T)}e.match=C;function G(O,H={}){if(!O)return a;if(typeof O=="string"||ee(O)){const T=s(O,H);if(T===r)return a;const A=function(W,z){return!!T(W,z)};return T.allBasenames&&(A.allBasenames=T.allBasenames),T.allPaths&&(A.allPaths=T.allPaths),A}return $(O,H)}e.parse=G;function ne(O){if(!O)return;let H;return T=>(H||(H=(O()||Promise.resolve([])).then(A=>A?K(A):{})),H.then(A=>!!A[T]))}e.hasSiblingPromiseFn=ne;function ae(O){if(!O)return;let H;return T=>{if(!H){const A=O();H=A?K(A):{}}return!!H[T]}}e.hasSiblingFn=ae;function K(O){const H={};for(const T of O)H[T]=!0;return H}function ee(O){const H=O;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=ee;function _(O){return O.allBasenames||[]}e.getBasenameTerms=_;function j(O){return O.allPaths||[]}e.getPathTerms=j;function $(O,H){const T=q(Object.getOwnPropertyNames(O).map(U=>B(U,O[U],H)).filter(U=>U!==r)),A=T.length;if(!A)return r;if(!T.some(U=>!!U.requiresSiblings)){if(A===1)return T[0];const U=function(J,re){for(let le=0,ie=T.length;le<ie;le++){const oe=T[le](J,re);if(oe)return oe}return null},N=T.find(J=>!!J.allBasenames);N&&(U.allBasenames=N.allBasenames);const Q=T.reduce((J,re)=>re.allPaths?J.concat(re.allPaths):J,[]);return Q.length&&(U.allPaths=Q),U}const W=function(U,N,Q){let J;for(let re=0,le=T.length;re<le;re++){const ie=T[re];ie.requiresSiblings&&Q&&(N||(N=k.basename(U)),J||(J=N.substr(0,N.length-k.extname(U).length)));const oe=ie(U,N,J,Q);if(oe)return oe}return null},z=T.find(U=>!!U.allBasenames);z&&(W.allBasenames=z.allBasenames);const X=T.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return X.length&&(W.allPaths=X),W}function B(O,H,T){if(H===!1)return r;const A=s(O,T);if(A===r)return r;if(typeof H=="boolean")return A;if(H){const W=H.when;if(typeof W=="string"){const z=(X,U,N,Q)=>{if(!Q||!A(X,U))return null;const J=W.replace("$(basename)",N),re=Q(J);return(0,p.isThenable)(re)?re.then(le=>le?O:null):re?O:null};return z.requiresSiblings=!0,z}}return A}function q(O,H){const T=O.filter(U=>!!U.basenames);if(T.length<2)return O;const A=T.reduce((U,N)=>{const Q=N.basenames;return Q?U.concat(Q):U},[]);let W;if(H){W=[];for(let U=0,N=A.length;U<N;U++)W.push(H)}else W=T.reduce((U,N)=>{const Q=N.patterns;return Q?U.concat(Q):U},[]);const z=function(U,N){if(typeof U!="string")return null;if(!N){let J;for(J=U.length;J>0;J--){const re=U.charCodeAt(J-1);if(re===47||re===92)break}N=U.substr(J)}const Q=A.indexOf(N);return Q!==-1?W[Q]:null};z.basenames=A,z.patterns=W,z.allBasenames=A;const X=O.filter(U=>!U.basenames);return X.push(z),X}}),define(Z[34],x([0,1,31,10,8,3,15,25,7]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,l,m){if(typeof s=="string"&&(s=f.URI.file(s)),m){const D=m.getWorkspaceFolder(s);if(D){const R=m.getWorkspace().folders.length>1;let F;if((0,E.isEqual)(D.uri,s)?F="":F=(0,E.relativePath)(D.uri,s),R){const C=D.name?D.name:(0,E.basename)(D.uri);F=F?C+" \u2022 "+F:C}return F}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(s.fsPath))return(0,M.normalize)(I(s.fsPath));let y=(0,M.normalize)(s.fsPath);return!k.isWindows&&l?.userHome&&(y=v(y,l.userHome.fsPath)),y}e.getPathLabel=w;function t(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const l=(0,E.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return k.isWindows&&(0,p.isRootOrDriveLetter)(l)?I(l):l}e.getBaseLabel=t;function I(s){return(0,p.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let b=Object.create(null);function v(s,l){if(k.isWindows||!s||!l)return s;let m=b.original===l?b.normalized:void 0;return m||(m=`${(0,n.rtrim)(l,M.posix.sep)}${M.posix.sep}`,b={original:l,normalized:m}),(k.isLinux?s.startsWith(m):(0,n.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=v;function d(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const g="\u2026",P="\\\\",S="~";function u(s,l=M.sep){const m=new Array(s.length);let y=!1;for(let D=0;D<s.length;D++){let R=s[D];if(R===""){m[D]=`.${l}`;continue}if(!R){m[D]=R;continue}y=!0;let F="";R.indexOf(P)===0?(F=R.substr(0,R.indexOf(P)+P.length),R=R.substr(R.indexOf(P)+P.length)):R.indexOf(l)===0?(F=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(S)===0&&(F=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length));const C=R.split(l);for(let G=1;y&&G<=C.length;G++)for(let ne=C.length-G;y&&ne>=0;ne--){y=!1;let ae=C.slice(ne,ne+G).join(l);for(let K=0;!y&&K<s.length;K++)if(K!==D&&s[K]&&s[K].indexOf(ae)>-1){const ee=ne+G===C.length,_=ne>0&&s[K].indexOf(l)>-1?l+ae:ae,j=s[K].endsWith(_);y=!ee||j}if(!y){let K="";(C[0].endsWith(":")||F!=="")&&(ne===1&&(ne=0,G++,ae=C[0]+l+ae),ne>0&&(K=C[0]+l),K=F+K),ne>0&&(K=K+g+l),K=K+ae,ne+G<C.length&&(K=K+l+g),m[D]=K}}y&&(m[D]=R)}return m}e.shorten=u;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(s,l=Object.create(null)){const m=[];let y=!1,D="";for(const R of s)if(R==="$"||y&&R==="{")D&&m.push({value:D,type:h.TEXT}),D="",y=!0;else if(R==="}"&&y){const F=l[D];if(typeof F=="string")F.length&&m.push({value:F,type:h.VARIABLE});else if(F){const C=m[m.length-1];(!C||C.type!==h.SEPARATOR)&&m.push({value:F.label,type:h.SEPARATOR})}D="",y=!1}else D+=R;return D&&!y&&m.push({value:D,type:h.TEXT}),m.filter((R,F)=>{if(R.type===h.SEPARATOR){const C=m[F-1],G=m[F+1];return[C,G].every(ne=>ne&&(ne.type===h.VARIABLE||ne.type===h.TEXT)&&ne.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function c(s,l){return k.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function i(s,l){return k.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):k.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(s){const l=s.indexOf("/")!==-1?M.posix:M.win32,m=l.basename(s),y=l.dirname(s);return m.length?{name:m,parentPath:y}:{name:y,parentPath:""}}e.splitName=r}),define(Z[28],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return p.test(f)}e.isUUID=L;const M=new Uint8Array(16),k=[];for(let f=0;f<256;f++)k.push(f.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){E(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,w="";return w+=k[M[f++]],w+=k[M[f++]],w+=k[M[f++]],w+=k[M[f++]],w+="-",w+=k[M[f++]],w+=k[M[f++]],w+="-",w+=k[M[f++]],w+=k[M[f++]],w+="-",w+=k[M[f++]],w+=k[M[f++]],w+="-",w+=k[M[f++]],w+=k[M[f++]],w+=k[M[f++]],w+=k[M[f++]],w+=k[M[f++]],w+=k[M[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,32,43]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function k(E,n){if(await new Promise((t,I)=>{const b=L.createReadStream(E),v=p.createHash("sha1");b.pipe(v);const d=(0,M.once)((g,P)=>{b.removeAllListeners(),v.removeAllListeners(),g?I(g):t(P)});b.once("error",d),b.once("end",d),v.once("error",d),v.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=k}),define(Z[80],x([0,1,239]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new p.StringDecoder(k),this.remaining=null}write(k){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(n.length<1)return E;let f=0,w,t=f;for(;t<n.length;)if(w=n.charCodeAt(t),w===13||w===10){if(E.push(n.substring(f,t)),t++,t<n.length){const I=w;w=n.charCodeAt(t),(I===13&&w===10||I===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function k(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=k;function E(){return new Promise((n,f)=>{try{const w=(0,p.networkInterfaces)();for(let t in w){const I=w[t];if(I){for(const{mac:b}of I)if(M(b))return n(b)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[67],x([0,1,26,17,37,28,113]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,I=0;const b=(0,p.networkInterfaces)();for(let v in b){const d=b[v];if(d)for(const{mac:g,internal:P}of d)P||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=I>0?t/I:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||k.generateUuid())()),n}e.getMachineId=f;async function w(){try{const t=await new Promise((b,v)=>{V(["crypto"],b,v)}),I=await(0,E.getMac)();return t.createHash("sha256").update(I,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(Z[19],x([0,1,32,26,114,9,31,66,8,3,15,7,28]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function d(_,j=v.UNLINK){if((0,E.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return j===v.UNLINK?P(_):g(_)}async function g(_){try{const j=(0,f.join)((0,L.tmpdir)(),(0,b.generateUuid)());try{await e.Promises.rename(_,j)}catch($){return P(_)}P(j).catch($=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function P(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function S(_){if((0,E.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(_,{recursive:!0})}e.rimrafSync=S;async function u(_,j){return c(await(j?h(_):(0,M.promisify)(p.readdir)(_)))}async function h(_){try{return await(0,M.promisify)(p.readdir)(_,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const j=[],$=await u(_);for(const B of $){let q=!1,O=!1,H=!1;try{const T=await e.Promises.lstat((0,f.join)(_,B));q=T.isFile(),O=T.isDirectory(),H=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}j.push({name:B,isFile:()=>q,isDirectory:()=>O,isSymbolicLink:()=>H})}return j}function o(_){return c(p.readdirSync(_))}e.readdirSync=o;function c(_){return _.map(j=>typeof j=="string"?w.isMacintosh?(0,n.normalizeNFC)(j):j:(j.name=w.isMacintosh?(0,n.normalizeNFC)(j.name):j.name,j))}async function i(_){const j=await u(_),$=[];for(const B of j)await r.existsDirectory((0,f.join)(_,B))&&$.push(B);return $}function a(_,j=1e3){return new Promise($=>{let B=!1;const q=setInterval(()=>{B||(B=!0,p.access(_,O=>{B=!1,O&&(clearInterval(q),$(void 0))}))},j)})}e.whenDeleted=a;var r;(function(_){async function j(q){let O;try{if(O=await e.Promises.lstat(q),!O.isSymbolicLink())return{stat:O}}catch(H){}try{return{stat:await e.Promises.stat(q),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(w.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw T}throw H}}_.stat=j;async function $(q){try{const{stat:O,symbolicLink:H}=await _.stat(q);return O.isFile()&&H?.dangling!==!0}catch(O){}return!1}_.existsFile=$;async function B(q){try{const{stat:O,symbolicLink:H}=await _.stat(q);return O.isDirectory()&&H?.dangling!==!0}catch(O){}return!1}_.existsDirectory=B})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new k.ResourceQueue;function l(_,j,$){return s.queueFor(I.URI.file(_),t.extUriBiasedIgnorePathCase).queue(()=>{const B=R($);return new Promise((q,O)=>y(_,j,B,H=>H?O(H):q()))})}let m=!0;function y(_,j,$,B){if(!m)return p.writeFile(_,j,{mode:$.mode,flag:$.flag},B);p.open(_,$.flag,$.mode,(q,O)=>{if(q)return B(q);p.writeFile(O,j,H=>{if(H)return p.close(O,()=>B(H));p.fdatasync(O,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),m=!1),p.close(O,A=>B(A))))})})}function D(_,j,$){const B=R($);if(!m)return p.writeFileSync(_,j,{mode:B.mode,flag:B.flag});const q=p.openSync(_,B.flag,B.mode);try{p.writeFileSync(q,j);try{p.fdatasyncSync(q)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),m=!1}}finally{p.closeSync(q)}}e.writeFileSync=D;function R(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function F(_,j){if(_===j)return;async function $(B){try{const q=await e.Promises.lstat(B);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(B,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(_,j),await $(j)}catch(B){if(_.toLowerCase()!==j.toLowerCase()&&B.code==="EXDEV"||_.endsWith("."))await C(_,j,{preserveSymlinks:!1}),await d(_,v.MOVE),await $(j);else throw B}}async function C(_,j,$){return ne(_,j,{root:{source:_,target:j},options:$,handledSourcePaths:new Set})}const G=511;async function ne(_,j,$){if($.handledSourcePaths.has(_))return;$.handledSourcePaths.add(_);const{stat:B,symbolicLink:q}=await r.stat(_);if(q){if($.options.preserveSymlinks)try{return await ee(_,j,$)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(q.dangling)return}return B.isDirectory()?ae(_,j,B.mode&G,$):K(_,j,B.mode&G)}async function ae(_,j,$,B){await e.Promises.mkdir(j,{recursive:!0,mode:$});const q=await u(_);for(const O of q)await ne((0,f.join)(_,O),(0,f.join)(j,O),B)}async function K(_,j,$){await e.Promises.copyFile(_,j),await e.Promises.chmod(j,$)}async function ee(_,j,$){let B=await e.Promises.readlink(_);(0,E.isEqualOrParent)(B,$.root.source,!w.isLinux)&&(B=(0,f.join)($.root.target,B.substr($.root.source.length+1))),await e.Promises.symlink(B,j)}e.Promises=new class{get access(){return(0,M.promisify)(p.access)}get stat(){return(0,M.promisify)(p.stat)}get lstat(){return(0,M.promisify)(p.lstat)}get utimes(){return(0,M.promisify)(p.utimes)}get read(){return(0,M.promisify)(p.read)}get readFile(){return(0,M.promisify)(p.readFile)}get write(){return(0,M.promisify)(p.write)}get appendFile(){return(0,M.promisify)(p.appendFile)}get fdatasync(){return(0,M.promisify)(p.fdatasync)}get truncate(){return(0,M.promisify)(p.truncate)}get rename(){return(0,M.promisify)(p.rename)}get copyFile(){return(0,M.promisify)(p.copyFile)}get open(){return(0,M.promisify)(p.open)}get close(){return(0,M.promisify)(p.close)}get symlink(){return(0,M.promisify)(p.symlink)}get readlink(){return(0,M.promisify)(p.readlink)}get chmod(){return(0,M.promisify)(p.chmod)}get mkdir(){return(0,M.promisify)(p.mkdir)}get unlink(){return(0,M.promisify)(p.unlink)}get rmdir(){return(0,M.promisify)(p.rmdir)}get realpath(){return(0,M.promisify)(p.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return d}get move(){return F}get copy(){return C}}}),define(Z[81],x([0,1,32,8,25,19]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(t){const I=(0,L.dirname)(t);if(t===I)return t;const b=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,k.readdirSync)(I).filter(g=>g.toLowerCase()===b);if(d.length===1){const g=E(I);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(b);if(g>=0){const P=E(I);if(P)return(0,L.join)(P,d[g])}}}catch(v){}return null}e.realcaseSync=E;async function n(t){try{return await k.Promises.realpath(t)}catch(I){const b=w(t);return await k.Promises.access(b,p.constants.R_OK),b}}e.realpath=n;function f(t){try{return p.realpathSync(t)}catch(I){const b=w(t);return p.accessSync(b,p.constants.R_OK),b}}e.realpathSync=f;function w(t){return(0,M.rtrim)((0,L.normalize)(t),L.sep)}}),define(Z[115],x([0,1,59]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,t=1){let I=!1;return new Promise(b=>{const v=setTimeout(()=>{if(!I)return I=!0,b(0)},w);M(n,f,t,d=>{if(!I)return I=!0,clearTimeout(v),b(d)})})}e.findFreePort=L;function M(n,f,w,t){if(f===0)return t(0);const I=new p.Socket;I.once("connect",()=>(E(I),M(n+w,f-1,w,t))),I.once("data",()=>{}),I.once("error",b=>(E(I),b.code!=="ECONNREFUSED"?M(n+w,f-1,w,t):t(n))),I.connect(n,"127.0.0.1")}function k(n,f,w){let t=!1,I,b=1;const v=p.createServer({pauseOnConnect:!0});function d(g,P){t||(t=!0,v.removeAllListeners(),v.close(),I&&clearTimeout(I),P(g))}return new Promise(g=>{I=setTimeout(()=>{d(0,g)},w),v.on("listening",()=>{d(n,g)}),v.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&b<f?(n++,b++,v.listen(n,"127.0.0.1")):d(0,g)}),v.on("close",()=>{d(0,g)}),v.listen(n,"127.0.0.1")})}e.findFreePortFaster=k;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,8,19]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class I{constructor(c,i,a){this.exePath=c,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:o=!1,findPreview:c=!1}={}){const i=b({useAlternateBitness:o});if(!i)return null;const a=L.join(i,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(a))return null;let r=-1,s=null;for(const y of await M.Promises.readdir(a)){let D=-1;if(c){const F=y.indexOf("-");if(F<0)continue;const C=y.substring(0,F);if(!k.test(C)||y.substring(F+1)!=="preview")continue;D=parseInt(C,10)}else{if(!k.test(y))continue;D=parseInt(y,10)}if(D<=r)continue;const R=L.join(a,y,"pwsh.exe");!await M.SymlinkSupport.existsFile(R)||(s=R,r=D)}if(!s)return null;const l=i.includes("x86")?" (x86)":"",m=c?" Preview":"";return new I(s,`PowerShell${m}${l}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await M.Promises.readdir(c))if(i.test(r)){const s=L.join(c,r,"pwsh.exe");return new I(s,a)}return null}function g(){const o=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function P(){const o=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*S(){let o=await v();o&&(yield o),o=await v({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=g(),o&&(yield o),o=await v({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await v({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=P(),o&&(yield o)}async function*u(){for await(const o of S())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=u;async function h(){for await(const o of u())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[82],x([0,1,41,10]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(E){return new Promise((n,f)=>{let w;const t=new Map;function I(v,d,g,P,S){const u=t.get(d);if(v===E||u){const h={name:b(g),cmd:g,pid:v,ppid:d,load:P,mem:S};t.set(v,h),v===E&&(w=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((o,c)=>o.pid-c.pid)))}}function b(v){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,S=/\\pipe\\winpty-control/,u=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(v))return"watcherService ";if(P.exec(v))return"electron-crash-reporter";if(S.exec(v))return"winpty-process";if(u.exec(v))return"console-window-host (Windows internal process)";let o=h.exec(v);if(o&&o.length===2)return o[1]==="renderer"?d.exec(v)?"shared-process":"window":o[1];const c=/[a-zA-Z-]+\.js/g;let i="";do o=c.exec(v),o&&(i+=o+" ");while(o);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{V(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(E,g=>{d.getProcessCpuUsage(g,P=>{const S=new Map;P.forEach(u=>{const h=v(u.commandLine||"");S.set(u.pid,{name:b(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),w=S.get(E),w?(S.forEach(u=>{const h=S.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),S.forEach(u=>{u.children&&(u.children=u.children.sort((h,o)=>h.pid-o.pid))}),n(w)):f(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let v=function(){let d=[w];const g=[];for(;d.length;){const S=d.shift();S&&(g.push(S.pid),S.children&&(d=d.concat(S.children)))}let P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);P+=" "+g.join(" "),(0,p.exec)(P,{},(S,u,h)=>{if(S||h)f(S||new Error(h.toString()));else{const o=u.toString().split(`
`);for(let c=0;c<g.length;c++){const i=t.get(g[c]);i.load=parseFloat(o[c])}if(!w){f(new Error(`Root process ${E} not found`));return}n(w)}})};(0,p.exec)("which ps",{},(d,g,P)=>{if(d||P)if(process.platform!=="linux")f(d||new Error(P.toString()));else{const S=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(S,{},(u,h,o)=>{u||o?f(u||new Error(o.toString())):(k(h,I),v())})}else{const S=g.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${S} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,c)=>{h||c&&!c.includes("screen size is bogus")?f(h||new Error(c.toString())):(k(o,I),process.platform==="linux"?v():w?n(w):f(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=M;function k(E,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=E.toString().split(`
`);for(const t of w){const I=f.exec(t.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Z[117],x([0,1,32,23,31,2,66,8,3,19]),function(V,e,p,L,M,k,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function t(d,g,P){return b({path:d,isDirectory:!1},g,P)}e.watchFile=t;function I(d,g,P){return b({path:d,isDirectory:!0},g,P)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function b(d,g,P){if(f.isMacintosh&&(0,M.isEqualOrParent)(d.path,"/Volumes/"))return P(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const S=(0,n.basename)(d.path),u=new Map;let h=!1,o=[(0,k.toDisposable)(()=>{u.forEach(c=>(0,k.dispose)(c)),u.clear()})];try{const c=(0,p.watch)(d.path);o.push((0,k.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const i=new Set;d.isDirectory&&w.Promises.readdir(d.path).then(a=>a.forEach(r=>i.add(r))),c.on("error",(a,r)=>{h||P(`Failed to watch ${d.path} for changes using fs.watch() (${a}, ${r})`)}),c.on("change",(a,r)=>{if(h)return;let s="";if(r&&(s=r.toString(),f.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!s||a!=="change"&&a!=="rename")return;const l=d.isDirectory?(0,n.join)(d.path,s):d.path;if(d.isDirectory)if(a==="rename"){const m=u.get(l);m&&(0,k.dispose)(m);const y=setTimeout(async()=>{u.delete(l);const D=await w.Promises.exists(l);if(h)return;let R;D?i.has(s)?R="changed":(R="added",i.add(s)):(i.delete(s),R="deleted"),g(R,l)},e.CHANGE_BUFFER_DELAY);u.set(l,(0,k.toDisposable)(()=>clearTimeout(y)))}else{let m;i.has(s)?m="changed":(m="added",i.add(s)),g(m,l)}else if(a==="rename"||s!==S){const m=setTimeout(async()=>{const y=await w.Promises.exists(l);h||(y?(g("changed",l),o=[b(d,g,P)]):g("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(o),o=[(0,k.toDisposable)(()=>clearTimeout(m))]}else g("changed",l)})}catch(c){w.Promises.exists(d.path).then(i=>{i&&!h&&P(`Failed to watch ${d.path} for changes using fs.watch() (${c.toString()})`)})}return(0,k.toDisposable)(()=>{h=!0,o=(0,k.dispose)(o)})}async function v(d,g,P,S=512){const u=await w.Promises.open(d,"r"),h=Buffer.allocUnsafe(S),o=new L.CancellationTokenSource(P);let c,i=!1;const a=t(d,async r=>{if(r==="changed"){if(i)return;i=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:s}=await w.Promises.read(u,h,0,S,null);if(!s||o.token.isCancellationRequested)break;g(h.slice(0,s))}}catch(s){c=new Error(s),o.dispose(!0)}finally{i=!1}}},r=>{c=new Error(r),o.dispose(!0)});return new Promise((r,s)=>{o.token.onCancellationRequested(async()=>{a.dispose(),await w.Promises.close(u),c?s(c):r()})})}e.watchFileContents=v}),define(Z[118],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function k(){p.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(n,f,w,t,I)=>{const b=E(n,t,w);b.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{b&&n.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=k;function E(n,f,w){const t=new p.Menu;return w.forEach(I=>{let b;I.type==="separator"?b=new p.MenuItem({type:I.type}):Array.isArray(I.submenu)?b=new p.MenuItem({submenu:E(n,f,I.submenu),label:I.label}):b=new p.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(v,d,g)=>n.sender.send(f,I.id,g)}),t.append(b)}),t}});var ue=this&&this.__decorate||function(V,e,p,L){var M=arguments.length,k=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(V,e,p,L);else for(var n=V.length-1;n>=0;n--)(E=V[n])&&(k=(M<3?E(k):M>3?E(e,p,k):E(e,p))||k);return M>3&&k&&Object.defineProperty(e,p,k),k};define(Z[35],x([0,1,30,9,18,23,47,17,4,2,110,25,13]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function d(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function P(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(S||(S={}));class u{constructor(O){this.buffer=O,this.pos=0}read(O){const H=this.buffer.slice(this.pos,this.pos+O);return this.pos+=H.byteLength,H}}class h{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(o||(o={}));function c(q){const O=M.VSBuffer.alloc(4);return O.writeUInt32BE(q,0),O}function i(q){return q.read(4).readUInt32BE(0)}function a(q){const O=M.VSBuffer.alloc(1);return O.writeUInt8(q,0),O}const r={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},s=typeof Buffer!="undefined";function l(q,O){if(typeof O=="undefined")q.write(r.Undefined);else if(typeof O=="string"){const H=M.VSBuffer.fromString(O);q.write(r.String),q.write(c(H.byteLength)),q.write(H)}else if(s&&Buffer.isBuffer(O)){const H=M.VSBuffer.wrap(O);q.write(r.Buffer),q.write(c(H.byteLength)),q.write(H)}else if(O instanceof M.VSBuffer)q.write(r.VSBuffer),q.write(c(O.byteLength)),q.write(O);else if(Array.isArray(O)){q.write(r.Array),q.write(c(O.length));for(const H of O)l(q,H)}else{const H=M.VSBuffer.fromString(JSON.stringify(O));q.write(r.Object),q.write(c(H.byteLength)),q.write(H)}}function m(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(i(q)).toString();case o.Buffer:return q.read(i(q)).buffer;case o.VSBuffer:return q.read(i(q));case o.Array:{const H=i(q),T=[];for(let A=0;A<H;A++)T.push(m(q));return T}case o.Object:return JSON.parse(q.read(i(q)).toString())}}class y{constructor(O,H,T=null,A=1e3){this.protocol=O,this.ctx=H,this.logger=T,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(O,H){this.channels.set(O,H),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const H=this.send([O.type]);this.logger&&this.logger.logOutgoing(H,0,1,P(O.type));return}case 201:case 202:case 204:case 203:{const H=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(H,O.id,1,P(O.type),O.data);return}}}send(O,H=void 0){const T=new h;return l(T,O),l(T,H),this.sendBuffer(T.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onRawMessage(O){const H=new u(O),T=m(H),A=m(H),W=T[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}: ${T[2]}.${T[3]}`,A),this.onPromise({type:W,id:T[1],channelName:T[2],name:T[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}: ${T[2]}.${T[3]}`,A),this.onEventListen({type:W,id:T[1],channelName:T[2],name:T[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:T[1]})}}onPromise(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const T=new k.CancellationTokenSource;let A;try{A=H.call(this.ctx,O.name,O.arg,T.token)}catch(X){A=Promise.reject(X)}const W=O.id;A.then(X=>{this.sendResponse({id:W,data:X,type:201}),this.activeRequests.delete(O.id)},X=>{X instanceof Error?this.sendResponse({id:W,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:W,data:X,type:203}),this.activeRequests.delete(O.id)});const z=(0,w.toDisposable)(()=>T.cancel());this.activeRequests.set(O.id,z)}onEventListen(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const T=O.id,W=H.listen(this.ctx,O.name,O.arg)(z=>this.sendResponse({id:T,data:z,type:204}));this.activeRequests.set(O.id,W)}disposeActiveRequest(O){const H=this.activeRequests.get(O.id);H&&(H.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let H=this.pendingRequests.get(O.channelName);H||(H=[],this.pendingRequests.set(O.channelName,H));const T=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:O,timeoutTimer:T})}flushPendingRequests(O){const H=this.pendingRequests.get(O);if(H){for(const T of H)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=y;var D;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(O,H=null){this.protocol=O,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=H}getChannel(O){const H=this;return{call(T,A,W){return H.isDisposed?Promise.reject(n.canceled()):H.requestPromise(O,T,A,W)},listen(T,A){return H.isDisposed?Promise.reject(n.canceled()):H.requestEvent(O,T,A)}}}requestPromise(O,H,T,A=k.CancellationToken.None){const W=this.lastRequestId++,X={id:W,type:100,channelName:O,name:H,arg:T};if(A.isCancellationRequested)return Promise.reject(n.canceled());let U;return new Promise((Q,J)=>{if(A.isCancellationRequested)return J(n.canceled());const re=()=>{const ge=fe=>{switch(fe.type){case 201:this.handlers.delete(W),Q(fe.data);break;case 202:this.handlers.delete(W);const de=new Error(fe.data.message);de.stack=fe.data.stack,de.name=fe.data.name,J(de);break;case 203:this.handlers.delete(W),J(fe.data);break}};this.handlers.set(W,ge),this.sendRequest(X)};let le=null;this.state===S.Idle?re():(le=(0,L.createCancelablePromise)(ge=>this.whenInitialized()),le.then(()=>{le=null,re()}));const ie=()=>{le?(le.cancel(),le=null):this.sendRequest({id:W,type:101}),J(n.canceled())},oe=A.onCancellationRequested(ie);U=(0,w.combinedDisposable)((0,w.toDisposable)(ie),oe),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(O,H,T){const A=this.lastRequestId++,z={id:A,type:102,channelName:O,name:H,arg:T};let X=null;const U=new f.Emitter({onFirstListenerAdd:()=>{X=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(U),this.sendRequest(z)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(U),this.sendRequest({id:A,type:103}))}}),N=Q=>U.fire(Q.data);return this.handlers.set(A,N),U.event}sendRequest(O){switch(O.type){case 100:case 102:{const H=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(H,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const H=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(H,O.id,0,d(O.type));return}}}send(O,H=void 0){const T=new h;return l(T,O),l(T,H),this.sendBuffer(T.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onBuffer(O){const H=new u(O),T=m(H),A=m(H),W=T[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,P(W)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],0,P(W),A),this.onResponse({type:T[0],id:T[1],data:A})}}onResponse(O){if(O.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(O.id);H&&H(O)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}ue([E.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class F{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:H,onDidClientDisconnect:T})=>{f.Event.once(H.onMessage)(W=>{const z=new u(W),X=m(z),U=new y(H,X),N=new R(H);this.channels.forEach((J,re)=>U.registerChannel(re,J));const Q={channelServer:U,channelClient:N,ctx:X};this._connections.add(Q),this._onDidAddConnection.fire(Q),T(()=>{U.dispose(),N.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const O=[];return this._connections.forEach(H=>O.push(H)),O}getChannel(O,H){const T=this;return{call(A,W,z){let X;if((0,b.isFunction)(H)){let N=(0,p.getRandomElement)(T.connections.filter(H));X=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(T.onDidAddConnection,H))}else X=H.routeCall(T,A,W);const U=X.then(N=>N.channelClient.getChannel(O));return G(U).call(A,W,z)},listen(A,W){if((0,b.isFunction)(H))return T.getMulticastEvent(O,H,A,W);const z=H.routeEvent(T,A,W).then(X=>X.channelClient.getChannel(O));return G(z).listen(A,W)}}}getMulticastEvent(O,H,T,A){const W=this;let z=new w.DisposableStore;const X=new f.Emitter({onFirstListenerAdd:()=>{z=new w.DisposableStore;const U=new f.EventMultiplexer,N=new Map,Q=re=>{const ie=re.channelClient.getChannel(O).listen(T,A),oe=U.add(ie);N.set(re,oe)},J=re=>{const le=N.get(re);!le||(le.dispose(),N.delete(re))};W.connections.filter(H).forEach(Q),f.Event.filter(W.onDidAddConnection,H)(Q,void 0,z),W.onDidRemoveConnection(J,void 0,z),U.event(X.fire,X,z),z.add(U)},onLastListenerRemove:()=>{z.dispose()}});return X.event}registerChannel(O,H){this.channels.set(O,H),this._connections.forEach(T=>{T.channelServer.registerChannel(O,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class C{constructor(O,H,T=null){const A=new h;l(A,H),O.send(A.buffer),this.channelClient=new R(O,T),this.channelServer=new y(O,H,T)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,H){this.channelServer.registerChannel(O,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function G(q){return{call(O,H,T){return q.then(A=>A.call(O,H,T))},listen(O,H){const T=new f.Relay;return q.then(A=>T.input=A.listen(O,H)),T.event}}}e.getDelayedChannel=G;function ne(q){let O=!1;return{call(H,T,A){return O?q.call(H,T,A):(0,L.timeout)(0).then(()=>O=!0).then(()=>q.call(H,T,A))},listen(H,T){if(O)return q.listen(H,T);const A=new f.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>A.input=q.listen(H,T)),A.event}}}e.getNextTickChannel=ne;class ae{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const H of O.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await f.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=ae;var K;(function(q){function O(W,z){const X=W,U=z&&z.disableMarshalling,N=new Map;for(const Q in X)T(Q)&&N.set(Q,f.Event.buffer(X[Q],!0));return new class{listen(Q,J,re){const le=N.get(J);if(le)return le;if(A(J)){const ie=X[J];if(typeof ie=="function")return ie.call(X,re)}throw new Error(`Event not found: ${J}`)}call(Q,J,re){const le=X[J];if(typeof le=="function"){if(!U&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,t.revive)(re[ie]);return le.apply(X,re)}throw new Error(`Method not found: ${J}`)}}}q.fromService=O;function H(W,z){const X=z&&z.disableMarshalling;return new Proxy({},{get(U,N){if(typeof N=="string")return z?.properties?.has(N)?z.properties.get(N):A(N)?function(Q){return W.listen(N,Q)}:T(N)?W.listen(N):async function(...Q){let J;z&&!(0,b.isUndefinedOrNull)(z.context)?J=[z.context,...Q]:J=Q;const re=await W.call(N,J);return X?re:(0,t.revive)(re)};throw new Error(`Property not found: ${String(N)}`)}})}q.toService=H;function T(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}function A(W){return/^onScoped/.test(W)&&I.isUpperAsciiLetter(W.charCodeAt(8))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let O=q.toString();if(O!=="[object Object]")return O}return q}function j(q){return Array.isArray(q)?q.map(_):_(q)}function $(q,O,H,T,A,W,z){z=j(z);const X=ee[A],U=X[T%X.length];let N=[`%c[${q}]%c[${String(O).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(W)?(N=N.concat(z),N.push(")")):N.push(z),console.log.apply(console,N)}e.logWithColors=$;class B{constructor(O,H){this._outgoingPrefix=O,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,H,T,A,W){this._totalOutgoing+=O,$(this._outgoingPrefix,this._totalOutgoing,O,H,T,A,W)}logIncoming(O,H,T,A,W){this._totalIncoming+=O,$(this._incomingPrefix,this._totalIncoming,O,H,T,A,W)}}e.IPCLogger=B}),define(Z[120],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(M,k){this.sender=M,this.onMessage=k}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(k){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[121],x([0,1,18,4,35]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>p.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class E extends M.IPCClient{constructor(f,w){const t=new k(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=E}),define(Z[83],x([0,1,18,4,2,3,33,35]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=p.VSBuffer.alloc(0)),w}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return t();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let m=p.VSBuffer.alloc(s),y=0,D=0;for(;s>0;){const R=this._chunks[D];if(R.byteLength>s){const F=R.slice(0,s);m.set(F,y),y+=s,l&&(this._chunks[D]=R.slice(s),this._totalLength-=s),s-=s}else m.set(R,y),y+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,s-=R.byteLength}return m}}e.ChunkStream=I;var b;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var v;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,l,m,y){this.type=s,this.id=l,this.ack=m,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends M.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,y=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(m,y,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=p.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._writeSoon(l,s.data)}_bufferAdd(s,l){const m=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,m}_bufferTake(){const s=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends M.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=S;class u extends n.IPCClient{constructor(s,l,m=null){super(s,l,m);this.protocol=s}static fromSocket(s,l){return new u(new S(s),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=u;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,E.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],l=0,m=this._first;for(;m;)s[l++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new o(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const s=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let m=0;for(let y=0;y<i._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=l&&m++;return 1-m/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class a{constructor(s,l=null,m=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,t());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const l=new d(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let l=0,m=s.length;l<m;l++)this._socketWriter.write(s[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,y=l.length;m<y;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new d(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const l=new d(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,t());this._socketWriter.write(s)}}e.PersistentProtocol=a}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,I){const b=M.Event.fromNodeEventEmitter(p.ipcMain,I,(d,g)=>({event:d,message:g})),v=M.Event.filter(b,({event:d})=>d.sender.id===t);return M.Event.map(v,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends E.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const I=M.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:b})=>b);return M.Event.map(I,b=>{const v=b.id,d=w.Clients.get(v);d&&d.dispose();const g=new M.Emitter;w.Clients.set(v,(0,k.toDisposable)(()=>g.fire()));const P=f(v,"vscode:message"),S=M.Event.any(M.Event.signal(f(v,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(b,P),onDidClientDisconnect:S}})}}e.Server=w,w.Clients=new Map}),define(Z[84],x([0,1,14,4,28,121]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends k.Client{constructor(w,t){super({addEventListener:(I,b)=>w.addListener(I,b),removeEventListener:(I,b)=>w.removeListener(I,b),postMessage:I=>w.postMessage(I),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=E;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,M.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(b,v)=>({nonce:v,port:b.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,b=>b.nonce===w)));return I}e.connect=n}),define(Z[85],x([0,1,9,4,2,13]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));function n(I){const b=I;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(f||(f={}));class w extends M.Disposable{constructor(b,v=Object.create(null)){super();this.database=b,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((v,d)=>this.accept(d,v)),b.deleted?.forEach(v=>this.accept(v,void 0))}accept(b,v){if(this.state===f.Closed)return;let d=!1;(0,k.isUndefinedOrNull)(v)?d=this.cache.delete(b):this.cache.get(b)!==v&&(this.cache.set(b,v),d=!0),d&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,v){const d=this.cache.get(b);return(0,k.isUndefinedOrNull)(d)?v:d}getBoolean(b,v){const d=this.get(b);return(0,k.isUndefinedOrNull)(d)?v:d==="true"}getNumber(b,v){const d=this.get(b);return(0,k.isUndefinedOrNull)(d)?v:parseInt(d,10)}async set(b,v){if(this.state===f.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(b);const d=String(v);if(this.cache.get(b)!==d)return this.cache.set(b,d),this.pendingInserts.set(b,d),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===f.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((v,d)=>this.items.set(d,v)),b.delete&&b.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=t}),define(Z[123],x([0,1,9,4,37,8,19]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,I=Object.create(null)){this.path=t,this.options=I,this.name=(0,k.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,I=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(v=>I.set(v.key,v.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(t){const I=await this.whenConnected;return this.doUpdateItems(I,t)}doUpdateItems(t,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,M.mapToString)(I.insert):"0"}), delete(${I.delete?(0,M.setToString)(I.delete):"0"})`),this.transaction(t,()=>{const b=I.insert,v=I.delete;if(b&&b.size>0){const d=[];d.push([]);let g=0;b.forEach((P,S)=>{let u=d[g];u.length>n.MAX_HOST_PARAMETERS&&(g++,u=[],d.push(u)),u.push(S,P)}),d.forEach(P=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,S=>S.run(P),()=>{const S=[];let u=0;return b.forEach((h,o)=>{S.push(o),u+=h.length}),`Keys: ${S.join(", ")} Length: ${u}`})})}if(v&&v.size){const d=[];d.push([]);let g=0;v.forEach(P=>{let S=d[g];S.length>n.MAX_HOST_PARAMETERS&&(g++,S=[],d.push(S)),S.push(P)}),d.forEach(P=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,S=>S.run(P),()=>{const S=[];return v.forEach(u=>{S.push(u)}),`Keys: ${S.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,t)}doClose(t,I){return new Promise((b,v)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?b():!t.isErroneous&&!t.isInMemory?this.backup().then(b,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),b())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const P=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>P(),S=>(P(),Promise.reject(S)))})).then(b,v):v(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return E.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const I=await this.whenConnected,b=await this.get(I,t?"PRAGMA integrity_check":"PRAGMA quick_check"),v=t?b.integrity_check:b.quick_check;return I.isErroneous?`${v} (last error: ${I.lastError})`:I.isInMemory?`${v} (in-memory!)`:v}async connect(t,I=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${I})`);try{return await this.doConnect(t)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&I)return await(0,p.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await E.Promises.unlink(t);try{await E.Promises.rename(this.toBackupPath(t),t)}catch(v){}return await this.doConnect(t)}catch(v){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${v}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,I){t.isErroneous=!0,t.lastError=I,this.logger.error(I)}doConnect(t){return new Promise((I,b)=>{new Promise((v,d)=>{V(["@vscode/sqlite3"],v,d)}).then(v=>{const d={db:new(this.logger.isTracing?v.verbose().Database:v.Database)(t,g=>g?d.db?d.db.close(()=>b(g)):b(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(d),P=>d.db.close(()=>b(P)))),isInMemory:t===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},b)})}exec(t,I){return new Promise((b,v)=>{t.db.exec(I,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),v(d)):b())})}get(t,I){return new Promise((b,v)=>{t.db.get(I,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),v(d)):b(g))})}all(t,I){return new Promise((b,v)=>{t.db.all(I,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),v(d)):b(g))})}transaction(t,I){return new Promise((b,v)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),I(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),v(d)):b())})})}prepare(t,I,b,v){const d=t.db.prepare(I),g=P=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${P} (${I}). Details: ${v()}`)};d.on("error",g),b(d),d.finalize(P=>{P&&g(P),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,M=L*60,k=M*24,E=k*7,n=k*30,f=k*365;function w(I,b){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,p.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(v<30)return(0,p.localize)(1,null);let d;return v<L?(d=v,b?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):v<M?(d=Math.floor(v/L),b?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):v<k?(d=Math.floor(v/M),b?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):v<E?(d=Math.floor(v/k),b?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):v<n?(d=Math.floor(v/E),b?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):v<f?(d=Math.floor(v/n),b?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(v/f),b?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=w;function t(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(Z[126],x([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[68],x([0,1,30,13,126]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(w,t){return t&&(w.stack||w.stacktrace)?M.localize(0,null,n(w),E(w.stack)||E(w.stacktrace)):n(w)}function E(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?M.localize(1,null,w.message):w.message||M.localize(2,null)}function f(w=null,t=!1){if(!w)return M.localize(3,null);if(Array.isArray(w)){const I=p.coalesce(w),b=f(I[0],t);return I.length>1?M.localize(4,null,b,I.length):b}if(L.isString(w))return w;if(w.detail){const I=w.detail;if(I.error)return k(I.error,t);if(I.exception)return k(I.exception,t)}return w.stack?k(w,t):w.message?w.message:M.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(E,n,f){if(n.length===0)return null;const w=[];for(let t=0,I=n.length;t<I;t++){const b=n[t],v=f(b);if(v===null)return null;w[t]=M(b,v,this.modifierLabels[E])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(k,E,n){if(E===null)return"";const f=[];return k.ctrlKey&&f.push(n.ctrlKey),k.shiftKey&&f.push(n.shiftKey),k.altKey&&f.push(n.altKey),k.metaKey&&f.push(n.metaKey),E!==""&&f.push(E),f.join(n.separator)}}),define(Z[129],x([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[69],x([0,1,41,31,10,44,8,3,33,13,80,19,129]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,c){if(n.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const a=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{a.once("error",s=>{r({success:!1,error:s})}),a.once("exit",(s,l)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?v(i.status):1})}else if(n.isLinux||n.isMacintosh)try{const i=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(a=>{p.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,s,l)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class P{constructor(c,i,a,r){if(i!==void 0&&a!==void 0&&r!==void 0)this.cmd=c,this.args=i,this.shell=a,this.options=r;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(f.env).forEach(l=>{s[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(E.sep);return i!==-1&&(c=c.substring(i+1)),P.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let a,r;const s=new Promise((l,m)=>{a=l,r=m});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=p.exec(l,this.options,(m,y,D)=>{this.childProcess=null;const R=m;R&&R.killed?r({killed:this.terminateRequested,stdout:y.toString(),stderr:D.toString()}):this.handleExec(a,c,m,y,D)})}else{let l=null;const m=y=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(y,a,c,r);const D={terminated:this.terminateRequested};w.isNumber(y)&&(D.cmdCode=y),a(D)};if(this.shell&&n.isWindows){const y=k.deepClone(this.options);y.windowsVerbatimArguments=!0,y.detached=!1;let D=!1,R=!1;const F=[];let C=this.ensureQuotes(this.cmd);F.push(C.value),D=C.quoted,this.args&&this.args.forEach(ne=>{C=this.ensureQuotes(ne),F.push(C.value),R=R&&C.quoted});const G=["/s","/c"];D?R?G.push('"'+F.join(" ")+'"'):F.length>1?G.push('"'+F[0]+'" '+F.slice(1).join(" ")):G.push('"'+F[0]+'"'):G.push(F.join(" ")),l=p.spawn(g(),G,y)}else this.cmd&&(l=p.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(w.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",y=>{this.childProcess=null,r({terminated:this.terminateRequested,error:y})}),l.pid&&(this.childProcess.on("close",m),this.handleSpawn(l,a,c,r,!0)))}return s})}handleClose(c,i,a,r){}ensureQuotes(c){return P.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,d(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const i=p.spawn(g(),["/s","/c"]);i.on("error",a=>c(!0)),i.on("exit",a=>c(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class S extends P{constructor(c,i,a,r){super(c,i,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,a,r,s){[r,s].forEach((l,m)=>{const y=new t.LineDecoder;y.write(l).forEach(F=>{i({line:F,source:m===0?0:1})});const R=y.end();R&&i({line:R,source:m===0?0:1})}),c({terminated:this.terminateRequested,error:a})}handleSpawn(c,i,a,r,s){const l=new t.LineDecoder,m=new t.LineDecoder;c.stdout.on("data",y=>{l.write(y).forEach(R=>a({line:R,source:0}))}),c.stderr.on("data",y=>{m.write(y).forEach(R=>a({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=m}handleClose(c,i,a,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&a({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=S;function u(o){let c=[],i=!1;const a=function(r){if(i){c.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),i=!1,c.length>0){const m=c.slice(0);c=[],m.forEach(y=>a(y))}})||n.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=u;var h;(function(o){async function c(i,a,r){if(E.isAbsolute(i))return i;if(a===void 0&&(a=f.cwd()),E.dirname(i)!=="."||(r===void 0&&w.isString(f.env.PATH)&&(r=f.env.PATH.split(E.delimiter)),r===void 0||r.length===0))return E.join(a,i);async function l(m){if(await I.Promises.exists(m)){let y;try{y=await I.Promises.stat(m)}catch(D){D.message.startsWith("EACCES")&&(y=await I.Promises.lstat(m))}return y?!y.isDirectory():!1}return!1}for(let m of r){let y;if(E.isAbsolute(m)?y=E.join(m,i):y=E.join(a,m,i),await l(y))return y;let D=y+".com";if(await l(D)||(D=y+".exe",await l(D)))return D}return E.join(a,i)}o.findExecutable=c})(h=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,69]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(v,d){return v===1?L.isWindows?I():k.getWindowsShell(d):w(v,d)}e.getSystemShell=E;function n(v,d){return v===1?L.isWindows?b(d):k.getWindowsShell(d):w(v,d)}e.getSystemShellSync=n;let f=null;function w(v,d){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(P){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function I(){return t||(t=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),t}function b(v){if(t)return t;const d=L.isWindows&&parseFloat((0,p.release)())>=10,g=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${v.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:k.getWindowsShell(v)}}),define(Z[86],x([0,1,41,9,18,23,109,17,4,2,44,3,69,35]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends v.ChannelServer{constructor(S){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>M.VSBuffer.wrap(Buffer.from(u,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(S,u){this.modulePath=S,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(S){const u=this;return{call(h,o,c){return u.requestPromise(S,h,o,c)},listen(h,o){return u.requestEvent(S,h,o)}}}requestPromise(S,u,h,o=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(S),i=(0,L.createCancelablePromise)(s=>c.call(u,h,s)),a=o.onCancellationRequested(()=>i.cancel()),r=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{a.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(S,u,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const c=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(S).listen(u,h)(c.fire,c),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),I.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,S,u);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,E.isRemoteConsoleLog)(l)){(0,E.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(M.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),a=h.event,r={send:i,onMessage:a};this._client=new v.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,m)=>{process.removeListener("exit",s),this.activeRequests.forEach(y=>(0,w.dispose)(y)),this.activeRequests.clear(),l!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:m})})}return this._client}getCachedChannel(S){let u=this.channels.get(S);return u||(u=this.client.getChannel(S),this.channels.set(S,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Z[131],x([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[137],x([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[138],x([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[139],x([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[140],x([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[141],x([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[142],x([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[143],x([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[144],x([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[145],x([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[146],x([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[147],x([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[148],x([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[149],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[150],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[151],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[152],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[153],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[154],x([0,1,4,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class k extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},w])}}e.ExtensionHostDebugChannelClient=k}),define(Z[155],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=p;class L{constructor(E){this.channel=E}click(E,n,f){return this.channel.call("click",[E,n,f])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,f){return this.channel.call("getElementXY",[E,n,f])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class M{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=M}),define(Z[156],x([0,1,125,47,10,8,33,15,7]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(g,P,S){this._args=g,this.paths=P,this.productService=S}get appRoot(){return(0,k.dirname)(M.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=E.env.VSCODE_PORTABLE;return g?f.URI.file((0,k.join)(g,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,k.resolve)(g):(0,k.normalize)((0,k.join)(M.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,k.resolve)(g):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,k.resolve)(g);const P=E.env.VSCODE_EXTENSIONS;if(P)return P;const S=E.env.VSCODE_PORTABLE;return S?(0,k.join)(S,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(P=>/^[^:/?#]+?:\/\//.test(P)?f.URI.parse(P):f.URI.file((0,k.normalize)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,k.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([L.memoize],w.prototype,"appRoot",null),ue([L.memoize],w.prototype,"userHome",null),ue([L.memoize],w.prototype,"userDataPath",null),ue([L.memoize],w.prototype,"appSettingsHome",null),ue([L.memoize],w.prototype,"tmpDir",null),ue([L.memoize],w.prototype,"userRoamingDataHome",null),ue([L.memoize],w.prototype,"settingsResource",null),ue([L.memoize],w.prototype,"userDataSyncHome",null),ue([L.memoize],w.prototype,"userDataSyncLogResource",null),ue([L.memoize],w.prototype,"sync",null),ue([L.memoize],w.prototype,"machineSettingsResource",null),ue([L.memoize],w.prototype,"globalStorageHome",null),ue([L.memoize],w.prototype,"workspaceStorageHome",null),ue([L.memoize],w.prototype,"keybindingsResource",null),ue([L.memoize],w.prototype,"keyboardLayoutResource",null),ue([L.memoize],w.prototype,"argvResource",null),ue([L.memoize],w.prototype,"snippetsHome",null),ue([L.memoize],w.prototype,"isExtensionDevelopment",null),ue([L.memoize],w.prototype,"untitledWorkspacesHome",null),ue([L.memoize],w.prototype,"installSourcePath",null),ue([L.memoize],w.prototype,"builtinExtensionsPath",null),ue([L.memoize],w.prototype,"extensionsPath",null),ue([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],w.prototype,"extensionDevelopmentKind",null),ue([L.memoize],w.prototype,"extensionTestsLocationURI",null),ue([L.memoize],w.prototype,"debugExtensionHost",null),ue([L.memoize],w.prototype,"serviceMachineIdResource",null),ue([L.memoize],w.prototype,"telemetryLogResource",null),ue([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(d,g){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId)}e.parseExtensionHostPort=t;function I(d,g){return v(d["inspect-search"],d["inspect-brk-search"],5876,g)}e.parseSearchPort=I;function b(d,g){return v(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g)}e.parsePtyHostPort=b;function v(d,g,P,S,u){const o=Number(g||d)||(S?null:P),c=o?Boolean(!!g):!1;return{port:o,break:c,debugId:u}}}),define(Z[87],x([0,1,240,3,134]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,P=E){const S={},u=[],h=[];for(let a in g){const r=g[a];r.alias&&(S[a]=r.alias),r.type==="string"||r.type==="string[]"?(u.push(a),r.deprecates&&u.push(r.deprecates)):r.type==="boolean"&&(h.push(a),r.deprecates&&h.push(r.deprecates))}const o=p(d,{string:u,boolean:h,alias:S}),c={},i=o;c._=o._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in g){const r=g[a];r.alias&&delete i[r.alias];let s=i[a];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(s||(s=i[r.deprecates]),delete i[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),P.onMultipleValues(a,s)),c[a]=s),delete i[a]}for(let a in i)P.onUnknownOption(a);return c}e.parseArgs=n;function f(d,g){let P="";return g.args&&(Array.isArray(g.args)?P=` <${g.args.join("> <")}>`:P=` <${g.args}>`),g.alias?`-${g.alias} --${d}${P}`:`--${d}${P}`}function w(d,g){let P=0,S=[];for(const c in d){const i=d[c],a=f(c,i);P=Math.max(P,a.length),S.push([a,i.description])}let u=P+2+1;if(g-u<25)return S.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=g-u-1,o=[];for(const c of S){let i=c[0],a=I(c[1],h),r=t(u-i.length-2);o.push("  "+i+r+a[0]);for(let s=1;s<a.length;s++)o.push(t(u)+a[s])}return o}e.formatOptions=w;function t(d){return" ".repeat(d)}function I(d,g){let P=[];for(;d.length;){let S=d.length<g?d.length:d.lastIndexOf(" ",g),u=d.slice(0,S).trim();d=d.slice(S),P.push(u)}return P}function b(d,g,P,S,u=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${P}`];o.push(""),o.push(`${(0,M.localize)(32,null)}: ${g} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),o.push(""),u&&(L.isWindows?o.push((0,M.localize)(35,null,g)):o.push((0,M.localize)(36,null,g)),o.push(""));const c={};for(const i in S){const a=S[i];if(a.description&&a.cat){let r=c[a.cat];r||(c[a.cat]=r={}),r[i]=a}}for(let i in c){const a=i;let r=c[a];r&&(o.push(k[a]),o.push(...w(r,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=b;function v(d,g){return`${d||(0,M.localize)(37,null)}
${g||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(Z[157],x([0,1,59,154,87]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class k extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f,w){const t=(0,M.parseArgs)(n,M.OPTIONS);t.debugRenderer=w;const I=t.extensionDevelopmentPath;if(!I)return{success:!1};let b;const v=Object.keys(f);for(let h of v){let o=f[h];o===null||(b||(b=Object.create(null)),b[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:t,userEnv:b});if(!w)return{success:!0};const g=d.win;if(!g)return{success:!0};const P=g.webContents.debugger;let S=P.isAttached()?Infinity:0;const u=(0,p.createServer)(h=>{S++==0&&P.attach();let o=!1;const c=r=>{o||h.write(JSON.stringify(r)+"\0")},i=(r,s,l,m)=>c({method:s,params:l,sessionId:m});g.on("close",()=>{P.removeListener("message",i),h.end(),o=!0}),P.addListener("message",i);let a=Buffer.alloc(0);h.on("data",r=>{a=Buffer.concat([a,r]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const m=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}P.sendCommand(l.method,l.params,l.sessionId).then(m=>c({id:l.id,sessionId:l.sessionId,result:m})).catch(m=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:m.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{o=!0,--S==0&&P.detach()})});return await new Promise(h=>u.listen(0,h)),g.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=k}),function(){"use strict";function V(e,p,L,M){function k(n){const f=E(n),w=[f];return e.isAbsolute(f)||w.unshift(M),e.resolve(...w)}function E(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(I,"AppData","Roaming")}break;case"darwin":w=e.join(p.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[158],x([0,159,26,10,15,33]),function(e,p,L,M,k,E){const n=k.dirname(M.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(k.joinPath(n,"package.json").fsPath);return V(p,L,f.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=V(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[160],x([0,1,26,156,158]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,M.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=k}),define(Z[161],x([0,1,32,26,8]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function k(E){const n=(0,M.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){E&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=k}),define(Z[162],x([0,1,137]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function k(b){return b=b.trim(),b==="*"||L.test(b)}e.isValidVersionStr=k;function E(b){if(!k(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=b.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=E;function n(b){if(!b)return null;let v=b.majorBase,d=b.majorMustEqual,g=b.minorBase,P=b.minorMustEqual,S=b.patchBase,u=b.patchMustEqual;b.hasCaret&&(v===0||(P=!1),u=!1);let h=0;if(b.preRelease){const o=M.exec(b.preRelease);if(o){const[,c,i,a]=o;h=Date.UTC(Number(c),Number(i)-1,Number(a))}}return{majorBase:v,majorMustEqual:d,minorBase:g,minorMustEqual:P,patchBase:S,patchMustEqual:u,isMinimum:b.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(b,v,d){let g;typeof b=="string"?g=n(E(b)):g=b;let P;v instanceof Date?P=v.getTime():typeof v=="string"&&(P=new Date(v).getTime());let S;if(typeof d=="string"?S=n(E(d)):S=d,!g||!S)return!1;let u=g.majorBase,h=g.minorBase,o=g.patchBase,c=S.majorBase,i=S.minorBase,a=S.patchBase,r=S.notBefore,s=S.majorMustEqual,l=S.minorMustEqual,m=S.patchMustEqual;return S.isMinimum?u>c?!0:u<c?!1:h>i?!0:h<i||P&&P<r?!1:o>=a:(u===1&&c===0&&(!s||!l||!m)&&(c=1,i=0,a=0,s=!0,l=!1,m=!1),u<c?!1:u>c?!s:h<i?!1:h>i?!l:o<a?!1:o>a?!m:!(P&&P<r))}e.isValidVersion=f;function w(b,v,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:I(b,v,d.engines.vscode,g)}e.isValidExtensionVersion=w;function t(b,v,d){return b==="*"||I(v,d,b)}e.isEngineValid=t;function I(b,v,d,g=[]){let P=n(E(d));if(!P)return g.push(p.localize(0,null,d)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return g.push(p.localize(1,null,d)),!1}else if(!P.majorMustEqual)return g.push(p.localize(2,null,d)),!1;return f(b,v,P)?!0:(g.push(p.localize(3,null,b,d)),!1)}}),define(Z[163],x([0,1,2,10,35,86]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends p.Disposable{constructor(f,w,t,I){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[164],x([0,1,2,10,35,86]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends p.Disposable{constructor(f,w,t,I,b={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[165],x([0,1,41,111,10,80]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(f,w,t,I,b){this.watchedFolder=f,this.eventCallback=t,this.logCallback=I,this.verboseLogging=b,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(v=>(0,L.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,p.spawn)(M.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",V).fsPath,f);const w=new k.LineDecoder;this.handle.stdout.on("data",t=>{const I=[];for(const b of w.write(t)){const v=b.split("|");if(v.length===2){const d=Number(v[0]),g=v[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(g))){this.verboseLogging&&this.log(g);continue}I.push({type:E.changeTypeMap[d],path:g})}else this.log(v[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,I)=>this.onExit(t,I))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(Z[166],x([0,1,8,25,165]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(n,f,w,t){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(p.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,p.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new M.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[70],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(M,k=[],E=!1){this.ctor=M,this.staticArguments=k,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=p}),define(Z[167],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=p;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let E of this._nodes.values())E.outgoing.size===0&&k.push(E);return k}insertEdge(k,E){const n=this.lookupOrInsertNode(k),f=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),f),f.incoming.set(this._hashFn(k),n)}removeNode(k){const E=this._hashFn(k);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(k){const E=this._hashFn(k);let n=this._nodes.get(E);return n||(n=new p(k),this._nodes.set(E,n)),n}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[E,n]of this._nodes)k.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,E]of this._nodes){const n=new Set([k]),f=this._findCycle(E,n);if(f)return f}}_findCycle(k,E){for(let[n,f]of k.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const w=this._findCycle(f,E);if(w)return w;E.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(p=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function L(n,f,w,t){f[p.DI_TARGET]===f?f[p.DI_DEPENDENCIES].push({id:n,index:w,optional:t}):(f[p.DI_DEPENDENCIES]=[{id:n,index:w,optional:t}],f[p.DI_TARGET]=f)}function M(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const f=function(w,t,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,I,!1)};return f.toString=()=>n,p.serviceIds.set(n,f),f}e.createDecorator=M;function k(n){return n}e.refineServiceDecorator=k;function E(n){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=E}),define(Z[71],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[88],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(k){this.machineId=k}encryption(){return new Promise((k,E)=>V(["vscode-encrypt"],k,E))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch(E){return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch(E){return k}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,136,5]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function E(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function n(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(u,h){switch(u){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(u,h){return h==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function t(u,h,o){return w(h,o)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===o?!0:I(o).includes(u)}e.isTargetPlatformCompatible=t;function I(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=b;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var d;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var P;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[170],x([0,1,25,5]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=M;function k(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,b){if(typeof I=="undefined"||I===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof I=="string"||typeof b=="string"){let v=typeof I=="string"?I:I.value,d=typeof b=="string"?b:b.value;return p.equalsIgnoreCase(v,d)}return I._lower===b._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[171],x([0,1,25,170]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,p.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=M;class k{constructor(g,P){this.version=P,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof k?M(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=k;function E(d,g){return`${d}.${g}`}e.getExtensionId=E;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,g){return n(E(d,g))}e.getGalleryExtensionId=f;function w(d,g){const P=[],S=u=>{for(const h of P)if(h.some(o=>M(g(o),g(u))))return h;return null};for(const u of d){const h=S(u);h?h.push(u):P.push([u])}return P}e.groupByExtension=w;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function I(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function b(d){const g=new Set;for(const P of d)P.malicious&&g.add(P.id.id);return g}e.getMaliciousExtensionsSet=b;function v(d,g){const P=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const u=S.shift();if(u&&P.every(h=>!M(h.identifier,{id:u}))){const h=d.filter(o=>M(o.identifier,{id:u}));h.length===1&&(P.push(h[0]),S.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=v}),define(Z[89],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[172],x([0,1,41,10,8,3,105,19,69,138,89]),function(V,e,p,L,M,k,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=w.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends b{openTerminal(o,c){return this.spawnTerminal(p,o,f.getWindowsShell(),c)}spawnTerminal(o,c,i,a){const r=c.windowsExec||v.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=M.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return o.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(s==="wt"||s==="wt.exe")&&l.push("-d ."),new Promise((m,y)=>{const D=P(process),R=o.spawn(i,l,{cwd:a,env:D});R.on("error",y),R.on("exit",()=>m())})}runInTerminal(o,c,i,a,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:v.getDefaultTerminalWindows();return new Promise((l,m)=>{const y=`"${c} - ${I}"`,D=`""${i.join('" "')}" & pause"`,R=["/c","start",y,"/wait",s,"/c",D],F=Object.assign({},P(process),a);Object.keys(F).filter(ne=>F[ne]===null).forEach(ne=>delete F[ne]);const C={cwd:c,env:F,windowsVerbatimArguments:!0};p.spawn(v.CMD,R,C).on("error",ne=>{m(S(ne))}),l(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class d extends b{openTerminal(o,c){return this.spawnTerminal(p,o,c)}runInTerminal(o,c,i,a,r){const s=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(s===t.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const y=s===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`,V).fsPath,"-t",o||I,"-w",c];for(let G of i)R.push("-a"),R.push(G);if(a){const G=Object.assign({},P(process),a);for(let ne in G){const ae=G[ne];ae===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${ae}`))}}let F="";const C=p.spawn(d.OSASCRIPT,R);C.on("error",G=>{m(S(G))}),C.stderr.on("data",G=>{F+=G.toString()}),C.on("exit",G=>{if(G===0)l(void 0);else if(F){const ne=F.split(`
`,1);m(new Error(ne[0]))}else m(new Error(w.localize(1,null,y,G)))})}else m(new Error(w.localize(2,null,s)))})}spawnTerminal(o,c,i){const a=c.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const l=["-a",a];i&&l.push(i);const m=P(process),y=o.spawn("/usr/bin/open",l,{cwd:i,env:m});y.on("error",s),y.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends b{openTerminal(o,c){return this.spawnTerminal(p,o,c)}runInTerminal(o,c,i,a,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let y=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const R=`${u(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;y.push(`''${R}''`);const F=Object.assign({},P(process),a);Object.keys(F).filter(ae=>F[ae]===null).forEach(ae=>delete F[ae]);const C={cwd:c,env:F};let G="";const ne=p.spawn(D,y,C);ne.on("error",ae=>{m(S(ae))}),ne.stderr.on("data",ae=>{G+=ae.toString()}),ne.on("exit",ae=>{if(ae===0)l(void 0);else if(G){const K=G.split(`
`,1);m(new Error(K[0]))}else m(new Error(w.localize(4,null,D,ae)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{k.isLinux?await n.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,c,i){const a=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{a.then(l=>{const m=P(process),y=o.spawn(l,[],{cwd:i,env:m});y.on("error",s),y.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function P(h){const o={...h.env};return(0,E.sanitizeProcessEnvironment)(o),o}function S(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function u(h){let o="";for(let c of h)c.indexOf(" ")>=0?o+='"'+c+'"':o+=c,o+=" ";return o}}),define(Z[20],x([0,1,37,8,25,13,7,140,5]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(_){return _.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var I;(function(_){_[_.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var b;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=v;function d(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function P(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=P;var S;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(j,$){super(j);this.code=$}}e.FileSystemProviderError=u;function h(_,j){const $=new u(_.toString(),j);return c($,j),$}e.createFileSystemProviderError=h;function o(_){return _||h((0,n.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=o;function c(_,j){return _.name=j?`${j} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=c;function i(_){if(!_)return S.Unknown;if(_ instanceof u)return _.code;const j=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!j)return S.Unknown;switch(j[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=i;function a(_){if(_ instanceof D)return _.fileOperationResult;switch(i(_)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(j,$,B){this.resource=j,this.operation=$,this.target=B}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var l;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(j,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of j)switch(B.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>$)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>$)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>$)),this.deleted.set(B.resource,B);break}}contains(j,...$){return this.doContains(j,{includeChildren:!1},...$)}affects(j,...$){return this.doContains(j,{includeChildren:!0},...$)}doContains(j,$,...B){if(!j)return!1;const q=B.length>0;return!!((!q||B.includes(1))&&(this.added?.get(j)||$.includeChildren&&this.added?.findSuperstr(j))||(!q||B.includes(0))&&(this.updated?.get(j)||$.includeChildren&&this.updated?.findSuperstr(j))||(!q||B.includes(2))&&(this.deleted?.findSubstr(j)||$.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function y(_,j,$){return!_||!j||_===j||j.length>_.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),$?(0,M.startsWithIgnoreCase)(_,j):_.indexOf(j)===0)}e.isParent=y;class D extends Error{constructor(j,$,B){super(j);this.fileOperationResult=$,this.options=B}}e.FileOperationError=D;class R extends D{constructor(j,$,B){super(j,2,B);this.stat=$}}e.NotModifiedSinceFileOperationError=R;var F;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=G;async function ne(_,j){if(!j.canHandleResource(E.URI.from({scheme:_.scheme})))return new Promise($=>{const B=j.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===_.scheme&&q.added&&(B.dispose(),$())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(j){return(0,k.isNumber)(j)||(j=0),j<ae.KB?(0,n.localize)(1,null,j.toFixed(0)):j<ae.MB?(0,n.localize)(2,null,(j/ae.KB).toFixed(2)):j<ae.GB?(0,n.localize)(3,null,(j/ae.MB).toFixed(2)):j<ae.TB?(0,n.localize)(4,null,(j/ae.GB).toFixed(2)):(0,n.localize)(5,null,(j/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var K;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function ee(_){return{maxFileSize:_===0?300*ae.MB:16*ae.GB,maxHeapSize:_===0?700*ae.MB:2*700*ae.MB}}e.getPlatformLimits=ee}),define(Z[54],x([0,1,241,135,87,20]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(b,v){const d={onUnknownOption:P=>{console.warn((0,L.localize)(0,null,P))},onMultipleValues:(P,S)=>{console.warn((0,L.localize)(1,null,P,S))}},g=(0,M.parseArgs)(b,M.OPTIONS,v?d:void 0);return g.goto&&g._.forEach(P=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,L.localize)(2,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(b){const v=b.findIndex(d=>!/^-/.test(d));if(v>-1)return[...b.slice(0,v),...b.slice(v+1)]}function f(b){let[,...v]=b;process.env.VSCODE_DEV&&(v=n(v)||[]);const d=!I(process.env);return E(v,d)}e.parseMainProcessArgv=f;function w(b){const[,,...v]=b;return E(v,!0)}e.parseCLIProcessArgv=w;function t(b,...v){const d=b.indexOf("--");return d===-1?b.push(...v):b.splice(d,0,...v),b}e.addArg=t;function I(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Z[90],x([0,1,41,159,23,68,17,3,28,130,54]),function(V,e,p,L,M,k,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function I(d,g,P){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(P)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(P)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async S=>{const u=new M.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),S({})},1e4);try{const o=await v(d,u.token);S(o)}catch(o){(0,E.isPromiseCanceledError)(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),S({})}finally{clearTimeout(h),u.dispose()}})),b)}e.resolveShellEnv=I;let b;async function v(d,g){const P=new Promise(async(S,u)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",a);const r=await(0,w.getSystemShell)(n.OS,a);if(d.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return u(E.canceled);const s=L.basename(r);let l,m;/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,m=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),l);const y=(0,p.spawn)(r,[...m,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(y.kill(),u(E.canceled))),y.on("error",F=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(F)),S({})});const D=[];y.stdout.on("data",F=>D.push(F));const R=[];y.stderr.on("data",F=>R.push(F)),y.on("close",(F,C)=>{const G=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const ne=Buffer.concat(R).toString("utf8");if(ne.trim()&&d.trace("getUnixShellEnvironment#stderr",ne),F||C)return u(new Error(`Failed to get environment (code ${F}, signal ${C})`));const ae=i.exec(G),K=ae?ae[1]:"{}";try{const ee=JSON.parse(K);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ee),S(ee)}catch(ee){d.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(ee)),u(ee)}})});try{return await P}catch(S){return d.error("getUnixShellEnvironment#error",(0,k.toErrorMessage)(S)),{}}}}),define(Z[91],x([0,1,3,7,20]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=k;function E(f){const w=new n;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const t=this.mapPathToChange.get(w.path);if(t){const I=t.type,b=w.type;I===1&&b===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(t),1)):I===2&&b===1?t.type=0:I===1&&b===0||(t.type=b)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],t=[];return this.normalized.filter(I=>I.type!==2?(w.push(I),!1):!0).sort((I,b)=>I.path.length-b.path.length).filter(I=>t.some(b=>(0,M.isParent)(I.path,b,!p.isLinux))?!1:(t.push(I.path),!0)).concat(w)}}}),define(Z[173],x([0,1,9,2,8,81,19,117,91]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(I,b,v,d){super();this.path=I,this.onDidFilesChange=b,this.onLogMessage=v,this.verboseLogging=d,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:b}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(b)try{v=await(0,k.realpath)(v)}catch(d){if(this.onError(d),b.dangling)return}I.isDirectory()?this._register((0,n.watchFolder)(v,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(g))})},d=>this.onError(d))):this._register((0,n.watchFile)(v,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,f.normalizeFileChanges)(b);if(this.verboseLogging)for(const d of v)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[72],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...M){this._entries=new Map;for(let[k,E]of M)this.set(k,E)}set(M,k){const E=this._entries.get(M);return this._entries.set(M,k),E}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=p}),define(Z[174],x([0,1,9,17,70,167,5,72]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new n.ServiceCollection,g=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=P,this._services.set(E.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...g){let P=b.traceInvocation(d),S=!1;try{return d({get:(h,o)=>{if(S)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(h,P);if(!c&&o!==E.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return c}},...g)}finally{S=!0,P.stop()}}createInstance(d,...g){let P,S;return d instanceof M.SyncDescriptor?(P=b.traceCreation(d.ctor),S=this._createInstance(d.ctor,d.staticArguments.concat(g),P)):(P=b.traceCreation(d),S=this._createInstance(d,g,P)),P.stop(),S}_createInstance(d,g=[],P){let S=E._util.getServiceDependencies(d).sort((o,c)=>o.index-c.index),u=[];for(const o of S){let c=this._getOrCreateServiceInstance(o.id,P);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);u.push(c)}let h=S.length>0?S[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let o=h-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,h)}return new d(...[...g,...u])}_setServiceInstance(d,g){if(this._services.get(d)instanceof M.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,g.branch(d,!0)):(g.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,g,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,P){const S=new k.Graph(o=>o.id.toString());let u=0;const h=[{id:d,desc:g,_trace:P}];for(;h.length;){const o=h.pop();if(S.lookupOrInsertNode(o),u++>1e3)throw new w(S);for(let c of E._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(c.id);if(!i&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),i instanceof M.SyncDescriptor){const a={id:c.id,desc:i,_trace:o._trace.branch(c.id,!0)};S.insertEdge(o,a),h.push(a)}}}for(;;){const o=S.roots();if(o.length===0){if(!S.isEmpty())throw new w(S);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof M.SyncDescriptor){const a=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,a)}S.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,P=[],S,u){if(this._services.get(d)instanceof M.SyncDescriptor)return this._createServiceInstance(g,P,S,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,P,S,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],P,S){if(P){const u=new p.IdleValue(()=>this._createInstance(d,g,S));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let c=u.value,i=c[o];return typeof i!="function"||(i=i.bind(c),h[o]=i),i},set(h,o,c){return u.value[o]=c,!0}})}else return this._createInstance(d,g,S)}}e.InstantiationService=t;var I;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(I||(I={}));class b{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return f?new b(0,d.name):b._None}branch(d,g){let P=new b(2,d.toString());return this._dep.push([d,g,P]),P}stop(){let d=Date.now()-this._start;b._totals+=d;let g=!1;function P(u,h){let o=[],c=new Array(u+1).join("	");for(const[i,a,r]of h._dep)if(a&&r){g=!0,o.push(`${c}CREATES -> ${i}`);let s=P(u+1,r);s&&o.push(s)}else o.push(`${c}uses -> ${i}`);return o.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(S.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Z[175],x([0,1,17,128,57]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class k extends M.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,p.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new M.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=k}),define(Z[176],x([0,1,57,175]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return p.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=p.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return M.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=p.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=M}),define(Z[177],x([0,1,9]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(M,k){if(M.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let f of M){if(f===!0)return Promise.resolve(!0);(0,p.isThenable)(f)&&E.push(f.then(w=>{w&&(n=!0)},w=>{k(w),n=!0}))}return p.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,68,4,2,3,5]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}a+=(r>0?" ":"")+s}return a}}e.AbstractMessageLogger=t;class I extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!k.isWindows}trace(i,...a){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}debug(i,...a){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}info(i,...a){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}warn(i,...a){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...a):console.warn(`[main ${n()}]`,i,...a))}error(i,...a){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}critical(i,...a){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class b extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=b;class v extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,p.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const r of this.logServices)r.trace(i,...a)}debug(i,...a){for(const r of this.logServices)r.debug(i,...a)}info(i,...a){for(const r of this.logServices)r.info(i,...a)}warn(i,...a){for(const r of this.logServices)r.warn(i,...a)}error(i,...a){for(const r of this.logServices)r.error(i,...a)}critical(i,...a){for(const r of this.logServices)r.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends M.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=g;class P extends M.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,a?.always?f.Trace:this.logLevel,a),this.loggers.set(i.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class S{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=S;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const i=h(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function h(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function o(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(V,e){return function(p,L){e(p,L,V)}};define(Z[178],x([0,1,9,18,40,77,48,20,5,6]),function(V,e,p,L,M,k,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(b){b.ERROR_INVALID_FILE="ERROR_INVALID_FILE",b.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(v,d,g){this.environmentService=v,this.fileService=d,this.logService=g,this.queue=new p.Queue}async updateSettings(v,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,v,d))}async doWrite(v,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,v.toString(),d);const{value:P,mtime:S,etag:u}=await this.fileService.readFile(v,{atomic:!0});let h=P.toString();const o=[];if((0,M.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(d,h,g)[0];if(c){h=h.substring(0,c.offset)+c.content+h.substring(c.offset+c.length);try{await this.fileService.writeFile(v,L.VSBuffer.fromString(h),{etag:u,mtime:S})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:v,path:d},g,P){return d.length?(0,k.setProperty)(g,d,v,P):[{content:JSON.stringify(v,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:g.length,offset:0}]}};I=ue([te(0,E.IEnvironmentService),te(1,n.IFileService),te(2,w.ILogService)],I),e.UserConfigurationFileService=I}),define(Z[92],x([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(k,E){switch(E){case p.LogLevel.Trace:return k.trace;case p.LogLevel.Debug:return k.debug;case p.LogLevel.Info:return k.info;case p.LogLevel.Warning:return k.warn;case p.LogLevel.Error:return k.error;case p.LogLevel.Critical:return k.critical;default:throw new Error("Invalid log level")}}class M extends p.AbstractLogger{constructor(E=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:f}of this.buffer)L(E,n).apply(E,f);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(p.LogLevel.Trace,E,...n)}debug(E,...n){this._log(p.LogLevel.Debug,E,...n)}info(E,...n){this._log(p.LogLevel.Info,E,...n)}warn(E,...n){this._log(p.LogLevel.Warning,E,...n)}error(E,...n){this._log(p.LogLevel.Error,E,...n)}critical(E,...n){this._log(p.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Z[179],x([0,1,9,18,15,20,5,92,6]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*k.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(v,d,g,P,S){super();this.name=v,this.resource=d,this.donotUseFormatters=P,this.fileService=S,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=v.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(v,d){this._log(v,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const v=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,g=new Date;return`${g.getFullYear()}-${v(g.getMonth()+1)}-${v(g.getDate())} ${v(g.getHours())}:${v(g.getMinutes())}:${v(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(v){return""}}stringifyLogLevel(v){switch(v){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(v){let d="";for(let g=0;g<v.length;g++){let P=v[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch(S){}d+=(g>0?" ":"")+P}return d}};t=ue([te(4,k.IFileService)],t),e.FileLogger=t;let I=class extends f.AbstractLoggerService{constructor(v,d,g){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(v,d,g){const P=new n.BufferLogService(d);return(0,k.whenProviderRegistered)(v,this.fileService).then(()=>P.logger=this.instantiationService.createInstance(t,(0,M.basename)(v),v,P.getLevel(),!!g?.donotUseFormatters)),P}};I=ue([te(0,f.ILogService),te(1,E.IInstantiationService),te(2,k.IFileService)],I),e.FileLoggerService=I}),define(Z[180],x([0,1,4,7,6]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(b){this.service=b,this.onDidChangeLogLevel=p.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(b,v,d){switch(v){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=k;class E{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){E.setLevel(this.channel,b)}static setLevel(b,v){return b.call("setLevel",v)}}e.LogLevelChannelClient=E;class n{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,v){throw new Error(`Event not found: ${v}`)}async call(b,v,d){switch(v){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${v}`)}createLogger(b,v){this.loggers.set(b.toString(),this.loggerService.createLogger(b,v))}consoleLog(b,v){let d=console.log;switch(b){case M.LogLevel.Error:d=console.error;break;case M.LogLevel.Warning:d=console.warn;break;case M.LogLevel.Info:d=console.info;break}d.call(console,...v)}log(b,v){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,P]of v)switch(g){case M.LogLevel.Trace:d.trace(P);break;case M.LogLevel.Debug:d.debug(P);break;case M.LogLevel.Info:d.info(P);break;case M.LogLevel.Warning:d.warn(P);break;case M.LogLevel.Error:d.error(P);break;case M.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends M.AbstractLoggerService{constructor(b,v,d){super(b,v);this.channel=d}createConsoleMainLogger(){return new M.AdapterLogger({log:(b,v)=>{this.channel.call("consoleLog",[b,v])}})}doCreateLogger(b,v,d){return new w(this.channel,b,v,d)}}e.LoggerChannelClient=f;class w extends M.AbstractMessageLogger{constructor(b,v,d,g){super(g?.always);this.channel=b,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,v){const d=[[b,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class t extends M.LogService{constructor(b,v){super(v);this.parent=b,this._register(b.onDidChangeLogLevel(d=>v.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=t}),define(Z[93],x([0,1,20,6]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function M(f,w,t,I){try{const b=await new Promise((v,d)=>{V(["spdlog"],v,d)});return b.setFlushOn(L.LogLevel.Trace),b.createAsyncRotatingLogger(f,w,t,I)}catch(b){console.error(b)}return null}function k(f,w,t,I){const b=V.__$__nodeRequire("spdlog");return b.setFlushOn(L.LogLevel.Trace),b.createRotatingLogger(f,w,t,I)}e.createRotatingLogger=k;function E(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,t,I,b){super();this.name=w,this.filepath=t,this.rotating=I,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*p.ByteSize.MB;return M(this.name,this.filepath,t,w).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:b,message:v}of this.buffer)E(this._logger,b,v);this.buffer=[]}})}log(w,t){this._logger?E(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[181],x([0,1,10,15,28,20,179,6,93]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(I,b){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=b}doCreateLogger(I,b,v){if(I.scheme===p.Schemas.file){const d=new f.SpdLogLogger(v?.name||(0,M.generateUuid)(),I.fsPath,!v?.donotRotate,b);return v?.donotUseFormatters&&d.clearFormatters(),d}else return new E.FileLogger(v?.name??(0,L.basename)(I),I,b,!!v?.donotUseFormatters,this.fileService)}};w=ue([te(0,n.ILogService),te(1,k.IFileService)],w),e.LoggerService=w}),define(Z[182],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function M(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function k(E){return!p(E)&&!L(E)&&!M(E)}e.isMenubarMenuItemAction=k}),define(Z[45],x([0,1,10,3,33,15]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,k.dirname)(p.FileAccess.asFileUri("",V));E=V.__$__nodeRequire((0,k.joinPath)(n,"product.json").fsPath);const f=V.__$__nodeRequire((0,k.joinPath)(n,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:f.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(Z[94],x([0,1,18,17,141,20,45]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,b,v,d,g,P){let S;try{await f(I,b,v,d,g,P)}catch(u){S=u}finally{S&&g.errorTransformer&&(S=g.errorTransformer(S)),typeof S!="undefined"&&v.error(S),v.end()}}e.readFileIntoStream=n;async function f(I,b,v,d,g,P){w(P);const S=await I.open(b,{create:!1});try{w(P);let u=0,h=0,o=g&&typeof g.length=="number"?g.length:void 0,c=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,a=0;do h=await I.read(S,i,c.buffer,a,c.byteLength-a),i+=h,a+=h,u+=h,typeof o=="number"&&(o-=h),a===c.byteLength&&(await v.write(d(c)),c=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),a=0);while(h>0&&(typeof o!="number"||o>0)&&w(P)&&t(u,g));if(a>0){let r=a;typeof o=="number"&&(r=Math.min(a,o)),v.write(d(c.slice(0,r)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await I.close(S)}}function w(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function t(I,b){if(b?.limits){if(typeof b.limits.memory=="number"&&I>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,M.localize)(0,null,E.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&I>b.limits.size)throw(0,k.createFileSystemProviderError)((0,M.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[183],x([0,1,30,9,18,23,4,64,2,37,10,73,15,65,139,20,94,6]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ve extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!0)))),this.watchedResources=w.TernarySearchTree.forUris(c=>{const i=this.getProvider(c.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const i=new f.DisposableStore;return i.add(c.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(c)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&i.add(c.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,f.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){c.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(c)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,c){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return n.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,b.isAbsolutePath)(o))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,o.toString()),i}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c)||(0,g.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(o,c){const i=await this.withProvider(o),a=this.isPathCaseSensitive(i),r=c?.resolveTo,s=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,m=await i.stat(o);let y;return this.toFileStat(i,o,m,void 0,!!l,(D,R)=>{if(!y&&(y=w.TernarySearchTree.forUris(()=>!a),y.set(o,!0),r))for(const F of r)y.set(F,!0);return y.get(D.resource)||y.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?R===1:!1})}async toFileStat(o,c,i,a,r,s){const{providerExtUri:l}=this.getExtUri(o),m={resource:c,name:l.basename(c),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(m.isDirectory&&s(m,a)){try{const y=await o.readdir(c),D=await L.Promises.settled(y.map(async([R,F])=>{try{const C=l.joinPath(c,R),G=r?await o.stat(C):{type:F};return await this.toFileStat(o,C,G,y.length,r,s)}catch(C){return this.logService.trace(C),null}}));m.children=(0,p.coalesce)(D)}catch(y){this.logService.trace(y),m.children=[]}return m}return m}async resolveAll(o){return L.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(i){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(i){return i}return!0}async doValidateCreateFile(o,c){if(!c?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=M.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const a=await this.writeFile(o,c);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,a)),a}async writeFile(o,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(a);try{await this.validateWriteFile(a,o,i)||await this.mkdirp(a,r.dirname(o));let l;if((0,g.hasReadWriteCapability)(a)&&!(c instanceof M.VSBuffer))if((0,v.isReadableStream)(c)){const m=await(0,v.peekStream)(c,3);m.ended?l=M.VSBuffer.concat(m.buffer):l=m}else l=(0,v.peekReadable)(c,m=>M.VSBuffer.concat(m),3);else l=c;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof M.VSBuffer?await this.doWriteUnbuffered(a,o,i,l):await this.doWriteBuffered(a,o,i,l instanceof M.VSBuffer?(0,M.bufferToReadable)(l):l)}catch(s){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch(s){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:r.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,i);return r}async readFile(o,c){const i=await this.withReadProvider(o);return c?.atomic?this.doReadFileAtomic(i,o,c):this.doReadFile(i,o,c)}async doReadFileAtomic(o,c,i){return new Promise((a,r)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,c,i);a(s)}catch(s){r(s)}})})}async doReadFile(o,c,i){const a=await this.doReadFileStream(o,c,{...i,preferUnbuffered:!0});return{...a,value:await(0,M.streamToBuffer)(a.value)}}async readFileStream(o,c){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,c)}async doReadFileStream(o,c,i){const a=new k.CancellationTokenSource,r=this.validateReadFile(c,i).then(l=>l,l=>{throw a.cancel(),l});let s;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&i?.preferUnbuffered?s=this.readFileUnbuffered(o,c,i):(0,g.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,c,a.token,i):s=this.readFileBuffered(o,c,a.token,i),{...await r,value:s}}catch(l){s&&await(0,v.consumeStream)(s);const m=(0,d.localize)(8,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,i):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(o,c,i,a=Object.create(null)){const r=o.readFileStream(c,a,i);return(0,v.transform)(r,{data:s=>s instanceof M.VSBuffer?s:M.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},s=>M.VSBuffer.concat(s))}readFileBuffered(o,c,i,a=Object.create(null)){const r=(0,M.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,c,r,s=>s,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},i),r}readFileUnbuffered(o,c,i){const a=(0,v.newWriteableStream)(r=>M.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(c);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(c,r.byteLength,i),a.end(M.VSBuffer.wrap(r))}catch(r){a.error(r),a.end()}})(),a}async validateReadFile(o,c){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,c);if(typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&c.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,c);return this.validateReadFileLimits(o,i.size,c),i}validateReadFileLimits(o,c,i){if(i?.limits){let a;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(a=9),typeof i.limits.size=="number"&&c>i.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,c,i){return this.doCanMoveCopy(o,c,"move",i)}async canCopy(o,c,i){return this.doCanMoveCopy(o,c,"copy",i)}async doCanMoveCopy(o,c,i,a){if(o.toString()!==c.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,o,s,c,i,a)}catch(r){return r}return!0}async move(o,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,r,c,"move",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,c,i){const a=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,r,c,"copy",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,c,i,a,r,s){if(c.toString()===a.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,c,i,a,r,s);if(l&&!m&&s&&await this.del(a,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a)),r==="copy"){if(o===i&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(c,a,{overwrite:s});else{const y=await this.resolve(c);y.isDirectory?await this.doCopyFolder(o,y,i,a):await this.doCopyFile(o,c,i,a)}return r}else return o===i?(await o.rename(c,a,{overwrite:s}),r):(await this.doMoveCopy(o,c,i,a,"copy",s),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,i,a){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,c,i,a);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,c,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,c,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,c,i,a)}async doCopyFolder(o,c,i,a){await i.mkdir(a),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async r=>{const s=this.getExtUri(i).providerExtUri.joinPath(a,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),i,s):this.doCopyFile(o,r.resource,i,s)}))}async doValidateMoveCopy(o,c,i,a,r,s){let l=!1;if(o===i){const{providerExtUri:y,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(l=y.isEqual(c,a)),l&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(c),this.resourceForError(a)));if(!l&&y.isEqualOrParent(a,c))throw new Error((0,d.localize)(15,null,this.resourceForError(c),this.resourceForError(a)))}const m=await this.exists(a);if(m&&!l){if(!s)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(c),this.resourceForError(a)),4);if(o===i){const{providerExtUri:y}=this.getExtUri(o);if(y.isEqualOrParent(c,a))throw new Error((0,d.localize)(17,null,this.resourceForError(c),this.resourceForError(a)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,i)),i}async mkdirp(o,c){const i=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(c,a.dirname(c));)try{if(((await o.stat(c)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(a.basename(c)),c=a.dirname(c)}for(let r=i.length-1;r>=0;r--){c=a.joinPath(c,i[r]);try{await o.mkdir(c)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(i){return i}return!0}async doValidateDelete(o,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let r;try{r=await i.stat(o)}catch(l){}if(r)this.throwIfFileIsReadonly(o,r);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!c?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return i}async del(o,c){const i=await this.doValidateDelete(o,c),a=!!c?.useTrash,r=!!c?.recursive;await i.delete(o,{recursive:r,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,c){this._onDidChangeFilesRaw.fire({changes:o});let i,a;{for(const r of o)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(a||(a=[]),a.push(r));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!c))}if(a){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(a)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let a=!1,r=()=>{a=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(o,c).then(s=>{a?(0,f.dispose)(s):r=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return c.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,f.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),i}async doWatch(o,c){const i=await this.withProvider(o),a=this.toWatchKey(i,o,c),r=this.activeWatchers.get(a)||{count:0,disposable:i.watch(o,c)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,c,i){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(c),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,v.isReadableStream)(a)||(0,v.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,r,a):await this.doWriteReadableBufferedQueued(o,r,a)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,c,i){let a=0,r;if((0,v.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=M.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,c,s,s.byteLength,a,0),a+=s.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(s,l)=>{(0,v.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(o,c,m,m.byteLength,a,0)}catch(y){return l(y)}a+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>l(m),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,c,i){let a=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(o,c,r,r.byteLength,a,0),a+=r.byteLength}async doWriteBuffer(o,c,i,a,r,s){let l=0;for(;l<a;)l+=await o.write(c,r+l,i.buffer,s+l,a-l)}async doWriteUnbuffered(o,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,i,a))}async doWriteUnbufferedQueued(o,c,i,a){let r;a instanceof M.VSBuffer?r=a:(0,v.isReadableStream)(a)?r=await(0,M.streamToBuffer)(a):(0,v.isReadableBufferedStream)(a)?r=await(0,M.bufferedStreamToBuffer)(a):r=(0,M.readableToBuffer)(a),await o.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,i,a))}async doPipeBufferedQueued(o,c,i,a){let r,s;try{r=await o.open(c,{create:!1}),s=await i.open(a,{create:!0,unlock:!1});const l=M.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,y=0,D=0;do D=await o.read(r,m,l.buffer,y,l.byteLength-y),await this.doWriteBuffer(i,s,l,D,m,y),m+=D,y+=D,y===l.byteLength&&(y=0);while(D>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,i,a))}async doPipeUnbufferedQueued(o,c,i,a){return i.writeFile(a,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,i,a))}async doPipeUnbufferedToBufferedQueued(o,c,i,a){const r=await i.open(a,{create:!0,unlock:!1});try{const s=await o.readFile(c);await this.doWriteBuffer(i,r,M.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(o,c,i,a){const r=await(0,M.streamToBuffer)(this.readFileBuffered(o,c,k.CancellationToken.None));await this.doWriteUnbuffered(i,a,void 0,r)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(c)),6);return o}throwIfFileIsReadonly(o,c){if((c.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=ue([te(0,S.ILogService)],u),e.FileService=u}),define(Z[184],x([0,1,30,9,18,4,31,2,8,3,15,65,19,142,20,94,173,163,164,91,166,6,45]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends n.Disposable{constructor(s,l){super();this.logService=s,this.options=l,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:m}=await b.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,m),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await b.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),m=[];return await Promise.all(l.map(async y=>{try{let D;y.isSymbolicLink()?D=(await this.stat((0,t.joinPath)(s,y.name))).type:D=this.toType(y),m.push([y.name,D])}catch(D){this.logService.trace(D)}})),m}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let m;return l?.dangling?m=d.FileType.Unknown:s.isFile()?m=d.FileType.File:s.isDirectory()?m=d.FileType.Directory:m=d.FileType.Unknown,l&&(m|=d.FileType.SymbolicLink),m}async readFile(s){try{const l=this.toFilePath(s);return await b.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,m){const y=(0,I.newWriteableStream)(D=>M.VSBuffer.concat(D.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,y,D=>D.buffer,{...l,bufferSize:this.BUFFER_SIZE},m),y}async writeFile(s,l,m){let y;try{const D=this.toFilePath(s);if(!m.create||!m.overwrite){if(await b.Promises.exists(D)){if(!m.overwrite)throw(0,d.createFileSystemProviderError)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,d.createFileSystemProviderError)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(s,{create:!0,unlock:m.unlock}),await this.write(y,0,l,0,l.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof y=="number"&&await this.close(y)}}async open(s,l){try{const m=this.toFilePath(s);if((0,d.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:R}=await b.SymlinkSupport.stat(m);R.mode&128||await b.Promises.chmod(m,R.mode|128)}catch(R){this.logService.trace(R)}let y;if((0,d.isFileOpenForWriteOptions)(l)){if(w.isWindows)try{await b.Promises.truncate(m,0),y="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}y||(y="w")}else y="r";const D=await b.Promises.open(m,y);return this.mapHandleToPos.set(D,0),(0,d.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(D,s),D}catch(m){throw(0,d.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,m):this.toFileSystemProviderError(m)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await b.Promises.fdatasync(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await b.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,m,y,D){const R=this.normalizePos(s,l);let F=null;try{const C=await b.Promises.read(s,m,y,D,R);return typeof C=="number"?F=C:F=C.bytesRead,F}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,R,F)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,m){const y=this.mapHandleToPos.get(s);typeof y=="number"&&(typeof l=="number"||(typeof m=="number"?this.mapHandleToPos.set(s,y+m):this.mapHandleToPos.delete(s)))}async write(s,l,m,y,D){return(0,L.retry)(()=>this.doWrite(s,l,m,y,D),100,3)}async doWrite(s,l,m,y,D){const R=this.normalizePos(s,l);let F=null;try{const C=await b.Promises.write(s,m,y,D,R);return typeof C=="number"?F=C:F=C.bytesWritten,F}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,R,F)}}async mkdir(s){try{await b.Promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const m=this.toFilePath(s);await this.doDelete(m,l)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(s,l){l.recursive?await b.Promises.rm(s,b.RimRafMode.MOVE):await b.Promises.unlink(s)}async rename(s,l,m){const y=this.toFilePath(s),D=this.toFilePath(l);if(y!==D)try{await this.validateTargetDeleted(s,l,"move",m.overwrite),await b.Promises.move(y,D)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,v.localize)(2,null,(0,f.basename)(y),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,l,m){const y=this.toFilePath(s),D=this.toFilePath(l);if(y!==D)try{await this.validateTargetDeleted(s,l,"copy",m.overwrite),await b.Promises.copy(y,D,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,v.localize)(3,null,(0,f.basename)(y),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(s,l,m,y){const D=this.toFilePath(s),R=this.toFilePath(l);let F=!1;if(!!(this.capabilities&1024)||(F=(0,E.isEqual)(D,R,!0)),F&&m==="copy")throw(0,d.createFileSystemProviderError)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!F&&await b.Promises.exists(R)){if(!y)throw(0,d.createFileSystemProviderError)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l.excludes):this.watchNonRecursive(s)}watchRecursive(s,l){const m={path:this.toFilePath(s),excludes:l},y=(0,p.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,l;this.options?.watcher?.usePolling?(s=u.FileWatcher,l=this.options?.watcher):i.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?w.isWindows?s=o.FileWatcher:s=u.FileWatcher:s=S.FileWatcher,this.recursiveWatcher=new s(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===c.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new P.FileWatcher(this.toFilePath(s),y=>this._onDidChangeFile.fire((0,h.toFileChanges)(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===c.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,n.combinedDisposable)(l,m)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof d.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=d.FileSystemProviderErrorCode.NoPermissions;break;default:l=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let m=this.toFileSystemProviderError(l);if(s&&m.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await b.SymlinkSupport.stat(this.toFilePath(s));y.mode&128||(m=(0,d.createFileSystemProviderError)(l,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.logService.trace(y)}return m}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=a}),define(Z[21],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[185],x([0,1,58,6,21]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let k=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,I]=w;let b=this.trustedExtensionUrlPublicKeys.get(n);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[n],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...b])}const v=Buffer.from(decodeURIComponent(I),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=v.slice(0,6),g=v.readUIntBE(0,6),P=Date.now()-g;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const S=v.slice(6),u=p.createVerify("SHA256");u.write(d),u.write(Buffer.from(t)),u.end();for(let h=0;h<b.length;h++){let o=b[h];if(o!==null){if(typeof o=="string")try{o=p.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),b[h]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,c),b[h]=null;continue}if(u.verify(o,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};k=ue([te(0,M.IProductService),te(1,L.ILogService)],k),e.ExtensionUrlTrustService=k}),define(Z[55],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[186],x([0,1,14,2,37,10,3,15,7,28,48,6]),function(V,e,p,L,M,k,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=M.TernarySearchTree.forUris(()=>!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=p.session;d.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(g,P)=>this.handleResourceRequest(g,P)),d.protocol.interceptFileProtocol(k.Schemas.file,(g,P)=>this.handleFileRequest(g,P)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const P=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${P.fsPath} from ${k.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const P=f.URI.parse(d.url),S=k.FileAccess.asFileUri(P);return this.validRoots.findSubstr(S)?g({path:S.fsPath}):this.validExtensions.has((0,n.extname)(S))?g({path:S.fsPath}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),P=g.toString(),S=async()=>d;return p.ipcMain.handle(P,S),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:g,update:u=>d=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),p.ipcMain.removeHandler(P)}}}};b=ue([te(0,t.INativeEnvironmentService),te(1,I.ILogService)],b),e.ProtocolMainService=b}),define(Z[38],x([0,1,102,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(E,n){p.ok(L.isString(E)),p.ok(L.isObject(n)),p.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new M}),define(Z[187],x([0,1,4,38]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class k{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[M(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new k;L.Registry.add(e.Extensions.JSONContribution,E)}),define(Z[49],x([0,1,30,4,13,132,187,38]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=n.Registry.as(E.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const c=this.doRegisterConfigurations(h,o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const c=[];c.push(...this.doDeregisterConfigurations(o)),c.push(...this.doRegisterConfigurations(h,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(c))}registerDefaultConfigurations(h){const o=[],c=[];for(const i of h)for(const a in i)if(o.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...i[a]};const r={type:"object",default:this.defaultValues[a],description:k.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};c.push(v(a)),this.configurationProperties[a]=r,this.defaultLanguageConfigurationOverridesNode.properties[a]=r}else{this.defaultValues[a]=i[a];const r=this.configurationProperties[a];r&&(this.updatePropertyDefaultValue(a,r),this.updateSchema(a,r))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const c of h)for(const i in c)if(o.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const c=[];return h.forEach(i=>{c.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),c}doDeregisterConfigurations(h){const o=[],c=i=>{if(i.properties)for(const a in i.properties)o.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,i.properties[a]);i.allOf&&i.allOf.forEach(a=>c(a))};for(const i of h){c(i);const a=this.configurationContributors.indexOf(i);a!==-1&&this.configurationContributors.splice(a,1)}return o}validateAndRegisterProperties(h,o=!0,c,i=3){i=M.isUndefinedOrNull(h.scope)?i:h.scope;let a=[],r=h.properties;if(r)for(let l in r){if(o&&P(l)){delete r[l];continue}const m=r[l];if(this.updatePropertyDefaultValue(l,m),e.OVERRIDE_PROPERTY_PATTERN.test(l)?m.scope=void 0:(m.scope=M.isUndefinedOrNull(m.scope)?i:m.scope,m.restricted=M.isUndefinedOrNull(m.restricted)?!!c?.restrictedConfigurations?.includes(l):m.restricted),r[l].hasOwnProperty("included")&&!r[l].included){this.excludedConfigurationProperties[l]=r[l],delete r[l];continue}else this.configurationProperties[l]=r[l];!r[l].deprecationMessage&&r[l].markdownDeprecationMessage&&(r[l].deprecationMessage=r[l].markdownDeprecationMessage),a.push(l)}let s=h.allOf;if(s)for(let l of s)a.push(...this.validateAndRegisterProperties(l,o,c,i));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=c=>{let i=c.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let a=c.allOf;a&&a.forEach(o)};o(h)}updateSchema(h,o){switch(e.allSettings.properties[h]=o,o.scope){case 1:e.applicationSettings.properties[h]=o;break;case 2:e.machineSettings.properties[h]=o;break;case 6:e.machineOverridableSettings.properties[h]=o;break;case 3:e.windowSettings.properties[h]=o;break;case 4:e.resourceSettings.properties[h]=o;break;case 5:e.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete e.allSettings.properties[h],o.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,c={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let c=this.defaultValues[h];M.isUndefined(c)&&(c=o.default),M.isUndefined(c)&&(c=d(o.type)),o.default=c}}const b="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function v(u){return u.substring(1,u.length-1)}e.overrideIdentifierFromKey=v;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new I;n.Registry.add(e.Extensions.Configuration,g);function P(u){return u.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(u)?k.localize(5,null,u):g.getConfigurationProperties()[u]!==void 0?k.localize(6,null,u):null:k.localize(4,null)}e.validateProperty=P;function S(){const u=[],h=g.getConfigurationProperties();for(const o of Object.keys(h))u.push([o,h[o].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=S}),define(Z[16],x([0,1,44,13,7,49,5,38]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function f(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationOverrides=f;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function I(a,r){const s=r?a?r.keys.filter(C=>a.keys.indexOf(C)===-1):[...r.keys]:[],l=a?r?a.keys.filter(C=>r.keys.indexOf(C)===-1):[...a.keys]:[],m=[];if(r&&a){for(const C of a.keys)if(r.keys.indexOf(C)!==-1){const G=S(a.contents,C),ne=S(r.contents,C);p.equals(G,ne)||m.push(C)}}const y=[],D=C=>{const G={};for(const ne of C)for(const ae of ne.identifiers)G[c(ae)]=ne;return G},R=r?D(r.overrides):{},F=a?D(a.overrides):{};if(Object.keys(R).length)for(const C of s){const G=R[C];G&&y.push([(0,k.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(F).length)for(const C of l){const G=F[C];G&&y.push([(0,k.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(R).length&&Object.keys(F).length)for(const C of m){const G=F[C],ne=R[C];if(G&&ne){const ae=I({contents:G.contents,keys:G.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});y.push([(0,k.overrideIdentifierFromKey)(C),[...ae.added,...ae.removed,...ae.updated]])}}return{added:s,removed:l,updated:m,overrides:y}}e.compare=I;function b(a,r){const s=[];for(const l of Object.keys(a))if(k.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const y in a[l])m[y]=a[l][y];s.push({identifiers:[(0,k.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:v(m,r)})}return s}e.toOverrides=b;function v(a,r){const s=Object.create(null);for(let l in a)d(s,l,a[l],r);return s}e.toValuesTree=v;function d(a,r,s,l){const m=r.split("."),y=m.pop();let D=a;for(let R=0;R<m.length;R++){let F=m[R],C=D[F];switch(typeof C){case"undefined":C=D[F]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(C)}`);return}D=C}if(typeof D=="object"&&D!==null)try{D[y]=s}catch(R){l(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(a,r){const s=r.split(".");P(a,s)}e.removeFromValueTree=g;function P(a,r){const s=r.shift();if(r.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const l=a[s];typeof l=="object"&&!Array.isArray(l)&&(P(l,r),Object.keys(l).length===0&&delete a[s])}}function S(a,r,s){function l(D,R){let F=D;for(const C of R){if(typeof F!="object"||F===null)return;F=F[C]}return F}const m=r.split("."),y=l(a,m);return typeof y=="undefined"?s:y}e.getConfigurationValue=S;function u(a,r,s){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(r[l])?u(a[l],r[l],s):s&&(a[l]=r[l]):a[l]=r[l])})}e.merge=u;function h(){const a=n.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=h;function o(){const a=Object.create(null),r=n.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let s in r){let l=r[s].default;d(a,s,l,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=o;function c(a){return`[${a}]`}e.keyFromOverrideIdentifier=c;function i(a,r,s){const l=a.inspect(r),m=a.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=i}),define(Z[188],x([0,1,30,4,40,2,37,44,13,7,16,49,38]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},a=[],r=[]){this._contents=i,this._keys=a,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const r=this.getContentsForOverrideIdentifer(a);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let r={};for(const s of p.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[s],m=a[s];m&&(typeof l=="object"&&typeof m=="object"?(l=n.deepClone(l),this.mergeContents(l,m)):l=m),r[s]=l}return new v(r,this.keys,this.overrides)}merge(...i){const a=n.deepClone(this.contents),r=n.deepClone(this.overrides),s=[...this.keys];for(const l of i){this.mergeContents(a,l.contents);for(const m of l.overrides){const[y]=r.filter(D=>p.equals(D.identifiers,m.identifiers));y?this.mergeContents(y.contents,m.contents):r.push(n.deepClone(m))}for(const m of l.keys)s.indexOf(m)===-1&&s.push(m)}return new v(a,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,a){for(const r of Object.keys(a)){if(r in i&&f.isObject(i[r])&&f.isObject(a[r])){this.mergeContents(i[r],a[r]);continue}i[r]=n.deepClone(a[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let r=0;r<a;r++)i.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class d extends v{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))I.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,a,r)}}e.DefaultConfigurationModel=d;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:r,keys:s,overrides:l,restricted:m}=this.doParseRaw(i,a);this._configurationModel=new v(r,s,l),this._restrictedConfigurations=m||[]}doParseContent(i){let a={},r=null,s=[],l=[],m=[];function y(R){Array.isArray(s)?s.push(R):r!==null&&(s[r]=R)}let D={onObjectBegin:()=>{let R={};y(R),l.push(s),s=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let R=[];y(R),l.push(s),s=R,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:y,onError:(R,F,C)=>{m.push({error:R,offset:F,length:C})}};if(i)try{M.visit(i,D),a=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return a}doParseRaw(i,a){const r=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,a);i=s.raw;const l=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(i),y=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:m,overrides:y,restricted:s.restricted}}filter(i,a,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const l={},m=[];for(let y in i)if(I.OVERRIDE_PROPERTY_PATTERN.test(y)&&r){const D=this.filter(i[y],a,!1,s);l[y]=D.raw,m.push(...D.restricted)}else{const D=a[y],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(y),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&D?.restricted||(l[y]=i[y]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=g;class P extends k.Disposable{constructor(i,a,r,s){super();this.userSettingsResource=i,this.scopes=a,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class S{constructor(i,a,r=new v,s=new v,l=new E.ResourceMap,m=new v,y=new E.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=y,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new E.ResourceMap,this._userConfiguration=null}getValue(i,a,r){return this.getConsolidateConfigurationModel(a,r).getValue(i)}updateValue(i,a,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new v,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,a===void 0?s.removeValue(i):s.setValue(i,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,r){const s=this.getConsolidateConfigurationModel(a,r),l=this.getFolderConfigurationModelForResource(a.resource,r),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,y=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),F=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=r?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,G=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,ne=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(i):m.getValue(i),ae=s.getValue(i),K=p.distinct(p.flatten(s.overrides.map(ee=>ee.identifiers))).filter(ee=>s.getOverrideValue(i,ee)!==void 0);return{defaultValue:y,userValue:D,userLocalValue:R,userRemoteValue:F,workspaceValue:C,workspaceFolderValue:G,memoryValue:ne,value:ae,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:l?.freeze().getValue(i),override:a.overrideIdentifier?l?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:m.getValue(i),override:a.overrideIdentifier?m.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const r=a.filter(s=>I.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,I.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),y=i.getKeysForOverrideIdentifier(l),D=[...y.filter(R=>m.indexOf(R)===-1),...m.filter(R=>y.indexOf(R)===-1),...m.filter(R=>!n.equals(this._defaultConfiguration.override(l).getValue(R),i.override(l).getValue(R)))];return[l,D]});return this.updateDefaultConfiguration(i),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),m=[...a,...r,...s];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...a,...r,...s];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...a,...r,...s];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(i,a){const r=this.folderConfigurations.get(i),{added:s,updated:l,removed:m,overrides:y}=(0,t.compare)(r,a);let D=[...s,...l,...m];return(D.length||!r)&&this.updateFolderConfiguration(i,a),{keys:D,overrides:y}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:l,overrides:m}=(0,t.compare)(a,void 0);return{keys:[...r,...s,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let r=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const s=a.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(i);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(a=r.merge(s),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=r}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const r=a.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(a);return i.push([a,{contents:r,overrides:s,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((m,y)=>(m.set(w.URI.revive(y[0]),this.parseConfigurationModel(y[1])),m),new E.ResourceMap);return new S(a,r,new v,s,l,new v,new E.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,a=new Map;for(const s of c)s.keys.forEach(l=>i.add(l)),s.overrides.forEach(([l,m])=>{const y=(0,E.getOrSet)(a,l,new Set);m.forEach(D=>y.add(D))});const r=[];return a.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=u;class h{constructor(i,a,r,s){this.change=i,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(y=>l.add(y)),i.overrides.forEach(([,y])=>y.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const m=new v;this.affectedKeys.forEach(y=>m.setValue(y,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!n.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let r=(0,t.toValuesTree)({[a]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(i,a,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[189],x([0,1,9,4,2,15,16,188,49,38]),function(V,e,p,L,M,k,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends M.Disposable{constructor(b,v){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,v)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,v){const d=typeof b=="string"?b:void 0,g=(0,E.isConfigurationOverrides)(b)?b:(0,E.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(d,g,void 0)}updateValue(b,v,d,g){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,v,1)}onDidDefaultConfigurationChange(b){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,b);this.trigger(d,v,6)}trigger(b,v,d){const g=new n.ConfigurationChangeEvent(b,{data:v},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(Z[190],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(E,n=L.Unknown,f){super(E);this._message=E,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(E){return E instanceof M&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof M&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof M&&E.isHandled}}e.RemoteAuthorityResolverError=M}),define(Z[191],x([0,1,9,18,23,17,4,2,28,83,190]),function(V,e,p,L,M,k,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var b;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function v(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const A=new M.CancellationTokenSource;return setTimeout(()=>A.cancel(),T),A.token}function g(T,A){if(T.isCancellationRequested||A.isCancellationRequested)return M.CancellationToken.Cancelled;const W=new M.CancellationTokenSource;return T.onCancellationRequested(()=>W.cancel()),A.onCancellationRequested(()=>W.cancel()),W.token}class P{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((W,z)=>{this._resolvePromise=W,this._rejectPromise=z}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function S(T,A){const W=new P(A);return W.registerDisposable(T.onControlMessage(z=>{const X=JSON.parse(z.toString()),U=$(X);U?W.reject(U):W.resolve(X)})),W.promise}function u(T,A,W,z,X,U){const N=new P(U);return A.connect(W,z,X,(Q,J)=>{N.didTimeout?(Q&&T.error(Q),J?.dispose()):Q||!J?N.reject(Q):N.resolve(J)}),N.promise}function h(T,A){const W=new P(A);return T.then(z=>{W.didTimeout||W.resolve(z)},z=>{W.didTimeout||W.reject(z)}),W.promise}async function o(T,A,W,z){const X=O(T,A);T.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let U;try{U=await u(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,z)}catch(re){throw T.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),T.logService.error(re),re}T.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let N,Q;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(U,null),N=T.reconnectionProtocol,Q=!1):(N=new w.PersistentProtocol(U,null),Q=!0),T.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const J={type:"auth",auth:T.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(J)));try{const re=await S(N,g(z,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const oe=new Error("Unexpected handshake message");throw oe.code="VSCODE_CONNECTION_ERROR",oe}T.logService.trace(`${X} 4/6. received SignRequest control message.`);const le=await h(T.signService.sign(re.data),z),ie={type:"connectionType",commit:T.commit,signedData:le,desiredConnectionType:A};return W&&(ie.args=W),T.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ie))),{protocol:N,ownsProtocol:Q}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(T.logService.error(`${X} the handshake timed out. Error:`),T.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${X} received error control message when negotiating connection. Error:`),T.logService.error(re)),Q&&j(N),re}}async function c(T,A,W,z){const X=Date.now(),U=O(T,A),{protocol:N,ownsProtocol:Q}=await o(T,A,W,z),J=new P(z);return J.registerDisposable(N.onControlMessage(re=>{const le=JSON.parse(re.toString()),ie=$(le);ie?(T.logService.error(`${U} received error control message when negotiating connection. Error:`),T.logService.error(ie),Q&&j(N),J.reject(ie)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${H(X)}!`),J.resolve({protocol:N,firstMessage:le}))})),J.promise}async function i(T,A){const{protocol:W}=await c(T,1,void 0,A);return{protocol:W}}async function a(T,A,W){const{protocol:z,firstMessage:X}=await c(T,2,A,W),U=X&&X.debugPort;return{protocol:z,debugPort:U}}async function r(T,A,W){const z=Date.now(),X=O(T,3),{protocol:U}=await o(T,3,A,W);return T.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${H(z)}!`),U}async function s(T,A,W){const{host:z,port:X,connectionToken:U}=await T.addressProvider.getAddress();return{commit:T.commit,host:z,port:X,connectionToken:U,reconnectionToken:A,reconnectionProtocol:W,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function l(T,A,W){try{const z=(0,f.generateUuid)(),X=await s(T,z,null),{protocol:U}=await i(X,M.CancellationToken.None);return new ee(T,A,W,z,U)}catch(z){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(z),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentManagement=l;async function m(T,A){try{const W=(0,f.generateUuid)(),z=await s(T,W,null),{protocol:X,debugPort:U}=await a(z,A,M.CancellationToken.None);return new _(T,A,W,X,U)}catch(W){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(W),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=m;async function y(T,A,W){const z=await s(T,(0,f.generateUuid)(),null);return await r(z,{host:A,port:W},M.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function D(T){return(0,p.createCancelablePromise)(A=>new Promise((W,z)=>{const X=setTimeout(W,T*1e3);A.onCancellationRequested(()=>{clearTimeout(X),W()})}))}var R;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(A,W){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=F;class C{constructor(A,W,z,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.durationSeconds=z,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class G{constructor(A,W,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=z,this.type=2}}e.ReconnectionRunningEvent=G;class ne{constructor(A,W,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=z,this.type=4}}e.ConnectionGainEvent=ne;class ae{constructor(A,W,z,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=z,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class K extends n.Disposable{constructor(A,W,z,X){super();this._connectionType=A,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=z,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(X.onSocketClose(U=>{const N=q(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const U=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${U} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(A,W,z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=W,this._permanentFailureHandled=z,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const A=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const X=z<W.length?W[z]:W[W.length-1];try{if(X>0){const N=D(X);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,N)),this._options.logService.info(`${A} waiting for ${X} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this._options.logService.info(`${A} resolving connection...`);const U=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,d(I)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,k.isPromiseCanceledError)(U)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,t.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(A,W,z){this._onDidStateChange.fire(new ae(this.reconnectionToken,A,W,z)),j(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class ee extends K{constructor(A,W,z,X,U){super(1,A,X,U);this.client=this._register(new w.Client(U,{remoteAuthority:W,clientId:z},A.ipcLogger))}async _reconnect(A,W){await i(A,W)}}e.ManagementPersistentConnection=ee;class _ extends K{constructor(A,W,z,X,U){super(2,A,z,X);this._startArguments=W,this.debugPort=U}async _reconnect(A,W){await a(A,this._startArguments,W)}}e.ExtensionHostPersistentConnection=_;function j(T){try{T.acceptDisconnect();const A=T.getSocket();T.dispose(),A.dispose()}catch(A){(0,k.onUnexpectedError)(A)}}function $(T){if(T&&T.type==="error"){const A=new Error(`Connection error: ${T.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function B(T,A){for(;T.length<A;)T+=" ";return T}function q(T,A,W){return`[remote-connection][${B(v(T),13)}][${A.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function O(T,A){return`${q(A,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function H(T){return`${Date.now()-T} ms`}}),define(Z[74],x([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===p.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function M(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=M;function k(w){return w.scheme!==p.Schemas.file&&w.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=k;function E(w){if(w.folders.length)return w.folders.every(t=>k(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&k(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=E;function n(w){return E(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return E(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[95],x([0,1,4,3,5,6]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService");var E;(function(v){v.Http="http",v.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=t;function I(v,d){return d?d!==1&&v<1024:!L.isWindows&&v<1024}e.isPortPrivileged=I;let b=class{constructor(d){this.logService=d,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],P=Array.from(this._tunnels.values());for(let S of P){const u=Array.from(S.values());for(let h of u){const o=await h.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,P,S,u=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${P} on local port ${S}.`),!d)return;g||(g="localhost");const c=this.retainOrCreateTunnel(d,g,P,S,u,h,o);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const P=g.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,g,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const S=P.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),S}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const P=this._tunnels.get(d);if(P&&P.has(g)){const S=P.get(g);S.refcount=0,await this.tryDisposeTunnel(d,g,S)}}addTunnelToMap(d,g,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,g){const P=this._tunnels.get(d);P&&(await P.get(g)||P.delete(g),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let P=[d];w(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):t(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const S=P.map(u=>this._tunnels.get(u));for(const u of S){const h=u?.get(g);if(h)return h}}canTunnel(d){return!!f(d)}createWithProvider(d,g,P,S,u,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${P} on local port ${S}.`);const i={elevationRequired:u?I(S===void 0?P:S):!1},a={remoteAddress:{host:g,port:P},localAddressPort:S,public:h,protocol:o},r=d.forwardPort(a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,P,r),r}};b=ue([te(0,k.ILogService)],b),e.AbstractTunnelService=b}),define(Z[50],x([0,1,18,146,49,5,38]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,p.streamToBuffer)(d.stream)).toString()}e.asText=w;async function t(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const P=(await(0,p.streamToBuffer)(d.stream)).toString();try{return JSON.parse(P)}catch(S){throw S.message+=`:
`+P,S}}e.asJson=t;function I(d){v(d)}e.updateProxyConfigurationsScope=I;let b;function v(d){const g=E.Registry.as(M.Extensions.Configuration),P=b;b={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[b],remove:P?[P]:[]})}v(2)}),define(Z[192],x([0,1,193,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function k(E,n,f={}){const w=(0,p.parse)(E),t=f.proxyUrl||M(w,n);if(!t)return null;const I=(0,p.parse)(t);if(!/^https?:$/.test(I.protocol||""))return null;const b={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((v,d)=>{V(["http-proxy-agent"],v,d)}))(b):new(await new Promise((v,d)=>{V(["https-proxy-agent"],v,d)}))(b)}e.getProxyAgent=k}),define(Z[194],x([0,1,18,28]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(k,E,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await E.readFile(k.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await E.writeFile(k.serviceMachineIdResource,p.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=M}),define(Z[75],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[195],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((M,k)=>V(["vsda"],M,k))}async sign(M){try{const k=await this.vsda(),E=new k.signer;if(E)return E.sign(M)}catch(k){}return M}}e.SignService=p}),define(Z[39],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,33,13,5,177,6,39]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var v;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class lt extends k.Disposable{constructor(P,S){super();this.logService=P,this.stateMainService=S,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",P);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",S),p.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",P),p.app.removeListener("window-all-closed",S),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(S){P.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(P)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let S=this.phaseWhen.get(P);S||(S=new L.Barrier,this.phaseWhen.set(P,S)),await S.wait()}registerWindow(P){const S=new k.DisposableStore;this.windowCounter++,S.add(P.onWillLoad(h=>this._onWillLoadWindow.fire({window:P,workspace:h.workspace,reason:h.reason})));const u=(0,f.assertIsDefined)(P.win);u.on("close",h=>{const o=P.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),h.preventDefault(),this.unload(P,1).then(c=>{if(c){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(P),P.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,S){await this.unload(P,3)||P.reload(S)}async unload(P,S){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const u=this._quitRequested?2:S;let h=await this.onBeforeUnloadWindowInRenderer(P,u);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(P,u),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,u),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,S){return new Promise(u=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,c=`vscode:cancel${h}`;p.ipcMain.once(o,()=>{u(!1)}),p.ipcMain.once(c,()=>{u(!0)}),P.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:c,reason:S})})}onBeforeUnloadWindowInMain(P,S){const u=[];return this._onBeforeUnloadWindow.fire({reason:S,window:P,veto(h){u.push(h)}}),(0,t.handleVetos)(u,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(P,S){return new Promise(u=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(o,()=>u()),P.send("vscode:onWillUnload",{replyChannel:o,reason:S})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(P?.addArgs&&S.push(...P.addArgs),P?.removeArgs)for(const o of P.removeArgs){const c=S.indexOf(o);c>=0&&S.splice(c,1)}const u=()=>{try{if(E.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:S})};p.app.once("quit",u),await this.quit(!0)&&p.app.removeListener("quit",u)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const S of p.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let u;S.webContents&&!S.webContents.isDestroyed()?u=new Promise(h=>S.once("closed",h)):u=Promise.resolve(),S.destroy(),await u}})()]),p.app.exit(P)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([te(0,I.ILogService),te(1,b.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[196],x([0,1,4,2,5,22]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let E=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,I)=>{V(["native-keymap"],t,I)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ue([te(0,k.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(Z[96],x([0,1,9,4,2,13,85,5]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var I;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class b extends M.Disposable{constructor(P={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,S){S===f?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:S,target:this.getKeyTargets(P)[S]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,S,u){return this.getStorage(S)?.get(P,u)}getBoolean(P,S,u){return this.getStorage(S)?.getBoolean(P,u)}getNumber(P,S,u){return this.getStorage(S)?.getNumber(P,u)}store(P,S,u,h){if((0,k.isUndefinedOrNull)(S)){this.remove(P,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,u,h),this.getStorage(u)?.set(P,S)})}remove(P,S){this.withPausedEmitters(()=>{this.updateKeyTarget(P,S,void 0),this.getStorage(S)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,S){const u=[],h=this.getKeyTargets(P);for(const o of Object.keys(h))h[o]===S&&u.push(o);return u}updateKeyTarget(P,S,u){const h=this.getKeyTargets(S);typeof u=="number"?h[P]!==u&&(h[P]=u,this.getStorage(S)?.set(f,JSON.stringify(h))):typeof h[P]=="number"&&(delete h[P],this.getStorage(S)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const S=this.get(f,P);if(S)try{return JSON.parse(S)}catch(u){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(P=w.NONE){this._onWillSaveState.fire({reason:P}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(P,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends b{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=v;async function d(g,P,S,u){const h=l=>{try{return JSON.parse(l)}catch(m){return l}},o=new Map,c=new Map;g.forEach((l,m)=>{o.set(m,l),c.set(m,h(l))});const i=new Map,a=new Map;P.forEach((l,m)=>{i.set(m,l),a.set(m,h(l))}),console.group(`Storage: Global (path: ${S})`);let r=[];o.forEach((l,m)=>{r.push({key:m,value:l})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let s=[];i.forEach((l,m)=>{s.push({key:m,value:l})}),console.table(s),console.groupEnd(),console.log(a)}e.logStorage=d}),define(Z[197],x([0,1,3,33,7,28]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(w){if(p.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,t,I,b,v,d,g,P,S,u){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,k.generateUuid)()+Date.now(),h.commitHash=v,h.version=d,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,p.PlatformToString)(p.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=b,h["common.product"]=u||"desktop";const o=f(P||[]);o&&(h["common.msftInternal"]=o);let c=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(h["common.snap"]="true");const a=E(I);a&&(h["common.platformDetail"]=a);try{const r=await w.readFile(M.URI.file(S));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const I=t.toLowerCase();return w.some(b=>I===b)}e.verifyMicrosoftInternalDomain=f}),define(Z[29],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.LOG=1]="LOG",k[k.USER=2]="USER"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(k){k.OFF="off",k.ERROR="error",k.ON="on"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[198],x([0,1,26,64,40,10,8,3,7,67,19,82,71,20,21,29]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(c,i){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,s=new Map,l=2e4;function m(R,F,C,G){const ne=F.substring(R.length+1);return new Promise(async ae=>{let K;try{K=await t.Promises.readdir(F,{withFileTypes:!0})}catch(j){ae();return}if(G.count>=l){G.count+=K.length,G.maxReached=!0,ae();return}let ee=K.length;if(ee===0){ae();return}let _=K;G.count+K.length>l&&(G.maxReached=!0,ee=l-G.count,_=K.slice(0,ee)),G.count+=K.length;for(const j of _)if(j.isDirectory()){if(C.includes(j.name)||await m(R,(0,E.join)(F,j.name),C,G),--ee==0){ae();return}}else{const $=j.name.lastIndexOf(".");if($>=0){const B=j.name.substring($+1);B&&r.set(B,(r.get(B)??0)+1)}for(const B of a)B.relativePathPattern?.test(ne)!==!1&&B.filePattern.test(j.name)&&s.set(B.tag,(s.get(B.tag)??0)+1);if(--ee==0){ae();return}}})}const y={count:0,maxReached:!1};await m(c,c,i,y);const D=await h(c);return{configFiles:S(s),fileTypes:S(r),fileCount:y.count,maxFilesReached:y.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=P;function S(c){return[...L.Iterable.map(c.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function u(){const c={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},i=p.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=u;async function h(c){try{const i=new Map,a=(0,E.join)(c,".vscode","launch.json"),r=await t.Promises.readFile(a),s=[],l=(0,M.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,M.getNodeType)(l)==="object"&&l.configurations)for(const m of l.configurations){const y=m.type;y&&(i.has(y)?i.set(y,i.get(y)+1):i.set(y,1))}return S(i)}catch(i){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&a.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),a.push(`Memory (System):  ${(p.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||a.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,I.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,l]=r,m=this.formatProcessList(i,s);return a.forEach(y=>{if((0,b.isRemoteDiagnosticError)(y))m+=`
${y.errorMessage}`,l+=`
${y.errorMessage}`;else if(m+=`

Remote: ${y.hostName}`,y.processes&&(m+=`
${this.formatProcessList(i,y.processes)}`),y.workspaceMetadata){l+=`
|  Remote: ${y.hostName}`;for(const D of Object.keys(y.workspaceMetadata)){const R=y.workspaceMetadata[D];let F=`${R.fileCount} files`;R.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${D}): ${F}`,l+=this.formatWorkspaceStats(R)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(i,a){const{memory:r,vmHint:s,os:l,cpus:m}=u(),y={os:l,memory:r,cpus:m,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return n.isWindows||(y.load=`${p.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(i,a){const r=[];return(0,I.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),a.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const y=l.workspaceMetadata[m];let D=`${y.fileCount} files`;y.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${m}): ${D}`),r.push(this.formatWorkspaceStats(y))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const a=[],r=60;let s=0;const l=(R,F)=>{const C=` ${R}(${F})`;s+C.length>r?(a.push(m),m="|                 ",s=m.length):s+=C.length,m+=C};let m="|      File types:";const y=10;let D=i.fileTypes.length>y?y:i.fileTypes.length;for(let R=0;R<D;R++){const F=i.fileTypes[R];l(F.name,F.count)}if(a.push(m),i.configFiles.length>=0&&(m="|      Conf files:",s=0,i.configFiles.forEach(R=>{l(R.name,R.count)}),a.push(m)),i.launchConfigFiles.length>0){let R="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{R+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),a.push(R)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(a-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const m=f.URI.revive(l);if(m.scheme===k.Schemas.file){const y=m.fsPath;r.push(P(y,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),a.push(`|    Folder (${(0,E.basename)(y)}): ${R}`),a.push(this.formatWorkspaceStats(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${y} (${D.toString()})`)}))}else a.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const r=new Map;i.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,r,s,a,0),s.join(`
`)}formatProcessItem(i,a,r,s,l){const m=l===0;let y;m?y=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(y=`${y} (${a.get(s.pid)})`));const D=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(i,a,r,R,l+1))}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const r=f.URI.revive(a);if(r.scheme!==k.Schemas.file)continue;const s=r.fsPath;try{const l=await P(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};o=ue([te(0,g.ITelemetryService),te(1,d.IProductService)],o),e.DiagnosticsService=o}),define(Z[199],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(k){this.appender=k}listen(k,E){throw new Error(`Event not found: ${E}`)}call(k,E,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(k){this.channel=k}log(k,E){return this.channel.call("log",{eventName:k,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[60],x([0,1,9,44,13,16,29]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryConfiguration=e.getTelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(S,u){return Promise.resolve(void 0)}publicLog2(S,u){return this.publicLog(S,u)}publicLogError(S,u){return Promise.resolve(void 0)}publicLogError2(S,u){return this.publicLogError(S,u)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class n{async publicLog(u,h,o){}async publicLogError(u,h,o){}}e.NullEndpointTelemetryService=n;function f(...S){return{log:(u,h)=>S.forEach(o=>o.log(u,h)),flush:()=>p.Promises.settled(S.map(u=>u.flush()))}}e.combinedAppender=f,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(S,u){return u.onDidChangeConfiguration(h=>{h.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(h.source),configurationKeys:g(h.sourceConfig)})})}e.configurationTelemetry=w;function t(S,u){return u.disableTelemetry||!S.enableTelemetry?0:u.isBuilt?2:1}e.getTelemetryLevel=t;function I(S){const u=S.getValue(E.TELEMETRY_SETTING_ID),h=S.getValue(E.TELEMETRY_OLD_SETTING_ID);return h!==void 0&&h===!1?"off":u??"on"}e.getTelemetryConfiguration=I;function b(S){const u=Object.create(null),h=Object.create(null),o=Object.create(null);d(S,o);for(let c in o){c=c.length>150?c.substr(c.length-149):c;const i=o[c];typeof i=="number"?h[c]=i:typeof i=="boolean"?h[c]=i?1:0:typeof i=="string"?u[c]=i.substring(0,1023):typeof i!="undefined"&&i!==null&&(u[c]=i)}return{properties:u,measurements:h}}e.validateTelemetryData=b;function v(S){if(!S)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{S.indexOf(`${o}+`)===0&&(u=o)}),u}e.cleanRemoteAuthority=v;function d(S,u,h=0,o){if(!!S)for(let c of Object.getOwnPropertyNames(S)){const i=S[c],a=o?o+c:c;Array.isArray(i)?u[a]=(0,L.safeStringify)(i):i instanceof Date?u[a]=i.toISOString():(0,M.isObject)(i)?h<2?d(i,u,h+1,a+"."):u[a]=(0,L.safeStringify)(i):u[a]=i}}function g(S){if(!S)return[];const u=[];return P(u,"",S),u}function P(S,u,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(o=>P(S,u?`${u}.${o}`:o,h[o])):S.push(u)}}),define(Z[200],x([0,1,30,23,17,44,3,33,7,16,48,168,171,162,20,6,21,50,194,96,29,60]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=E.isWeb?"web":(0,I.getTargetPlatform)(E.platform,n.arch);var a;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(a||(a={}));function r(...U){return String(U.reduce((N,Q)=>N|Q,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class R{constructor(N=D){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Q=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Q})}withFilter(N,...Q){const J=[...this.state.criteria,...Q.length?Q.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new R({...this.state,criteria:J})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Q,J)=>Q|J,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le,flags:ie,assetTypes:oe}=this.state;return{filters:[{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le}],assetTypes:oe,flags:ie}}get searchText(){const N=this.state.criteria.filter(Q=>Q.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(U,N){const Q=(U||[]).filter(J=>J.statisticName===N)[0];return Q?Q.value:0}function C(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf(N)===0).reduce((J,re)=>{const le=K(U,re.assetType);return le&&J.push([re.assetType.substring(N.length),le]),J},[])}function G(U){if(U.properties){const N=U.properties.filter(re=>re.key===l.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=N.filter(re=>Q.test(re.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return K(U,l.Repository)}function ne(U){return{uri:`${U.fallbackAssetUri}/${l.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${l.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ae(U){const N=K(U,l.Icon);if(N)return N;const Q=I.DefaultIconPath;return{uri:Q,fallbackUri:Q}}function K(U,N){return U.files.filter(J=>J.assetType===N)[0]?{uri:`${U.assetUri}/${N}`,fallbackUri:`${U.fallbackAssetUri}/${N}`}:null}function ee(U,N){const Q=U.properties?U.properties.filter(re=>re.key===N):[],J=Q.length>0&&Q[0].value;return J?J.split(",").map(re=>(0,b.adoptToGalleryExtensionId)(re)):[]}function _(U){const N=U.properties?U.properties.filter(Q=>Q.key===m.Engine):[];return N.length>0&&N[0].value||""}function j(U){const N=U.properties?U.properties.filter(J=>J.key===m.LocalizedLanguages):[],Q=N.length>0&&N[0].value||"";return Q?Q.split(","):[]}function $(U){return U.indexOf("preview")!==-1}function B(U){return U.targetPlatform?(0,I.toTargetPlatform)(U.targetPlatform):"undefined"}function q(U){const N=(0,p.distinct)(U.versions.map(B)),Q=!!U.tags?.includes(I.WEB_EXTENSION_TAG),J=N.indexOf("web");return Q?J===-1&&N.push("web"):J!==-1&&N.splice(J,1),N}function O(U,N){const Q=(0,I.getFallbackTargetPlarforms)(N);for(let J=0;J<U.length;J++){const re=U[J];if(re.version===U[J-1]?.version){let le=J;const ie=B(re);if(ie===N)for(;le>0&&U[le-1].version===re.version;)le--;else if(Q.includes(ie))for(;le>0&&U[le-1].version===re.version&&B(U[le-1])!==N;)le--;le!==J&&(U.splice(J,1),U.splice(le,0,re))}}return U}e.sortExtensionVersions=O;function H(U,N,Q,J,re){const le=q(U);let ie=U.versions[0];return ie=U.versions.find(oe=>oe.version===ie.version&&(0,I.isTargetPlatformCompatible)(B(oe),le,re))||ie,T(U,ie,le,N,Q,J)}function T(U,N,Q,J,re,le){const ie={manifest:K(N,l.Manifest),readme:K(N,l.Details),changelog:K(N,l.Changelog),license:K(N,l.License),repository:G(N),download:ne(N),icon:ae(N),coreTranslations:C(N)};return{identifier:{id:(0,b.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:F(U.statistics,"install"),rating:F(U.statistics,"averagerating"),ratingCount:F(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:Q,assets:ie,properties:{dependencies:ee(N,m.Dependency),extensionPack:ee(N,m.ExtensionPack),engine:_(N),localizedLanguages:j(N),targetPlatform:B(N)},preview:$(U.flags),telemetryData:{index:(re.pageNumber-1)*re.pageSize+J,querySource:le}}}let A=class{constructor(N,Q,J,re,le,ie,oe,ge){this.requestService=Q,this.logService=J,this.environmentService=re,this.telemetryService=le,this.fileService=ie,this.productService=oe,this.configurationService=ge;const fe=oe.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=X(oe.version,oe,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Q){const J=[];let re=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,N.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...N.map(({id:ie})=>ie.toLowerCase()));N.every(ie=>!ie.version)&&(re=re.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(re,i,L.CancellationToken.None);for(let ie=0;ie<le.length;ie++){const oe=le[ie];if(!oe.versions.length)continue;const ge=(0,b.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),fe=N.find(de=>(0,b.areSameExtensions)(de,{id:ge}))?.version;if(fe){const de=oe.versions.find(Pe=>Pe.version===fe);de&&J.push(T(oe,de,q(oe),ie,re))}else J.push(H(oe,ie,re,void 0,i))}return J}async getCompatibleExtension(N,Q){const J=(0,I.isIExtensionIdentifier)(N)?null:N;if(J){if((0,I.isNotWebExtensionInWebTargetPlatform)(J.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(J,Q))return J}const{id:re,uuid:le}=J?J.identifier:N;let ie=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?ie=ie.withFilter(s.ExtensionId,le):ie=ie.withFilter(s.ExtensionName,re);const{galleryExtensions:oe}=await this.queryGallery(ie,Q,L.CancellationToken.None),[ge]=oe;if(!ge||!ge.versions.length)return null;const fe=q(ge);if((0,I.isNotWebExtensionInWebTargetPlatform)(fe,Q))return null;for(let de of ge.versions){if(!_(de)){const Pe=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(de,fe,Q))return T(ge,de,fe,0,ie)}return null}async isExtensionCompatible(N,Q){if(!(0,I.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Q))return!1;let J=N.properties.engine;if(!J){const re=await this.getManifest(N,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");J=re.engines.vscode}return(0,v.isEngineValid)(J,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Q,J){if(!(0,I.isTargetPlatformCompatible)(B(N),Q,J))return!1;const re=await this.getEngine(N);return(0,v.isEngineValid)(re,this.productService.version,this.productService.date)}async query(N,Q){const J=L.CancellationToken.isCancellationToken(N)?{}:N,re=L.CancellationToken.isCancellationToken(N)?N:Q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=J.text||"";const ie=(0,k.getOrDefault)(J,pe=>pe.pageSize,50);let oe=new R().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ie).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(oe=oe.withFilter(s.Category,be||me),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(oe=oe.withFilter(s.Tag,be||me),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(s.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),oe=oe.withFilter(s.SearchText,le)),oe=oe.withSortBy(0)):J.ids?oe=oe.withFilter(s.ExtensionId,...J.ids):J.names?oe=oe.withFilter(s.ExtensionName,...J.names):oe=oe.withSortBy(4),typeof J.sortBy=="number"&&(oe=oe.withSortBy(J.sortBy)),typeof J.sortOrder=="number"&&(oe=oe.withSortOrder(J.sortOrder));const{galleryExtensions:ge,total:fe}=await this.queryGallery(oe,i,re),de=ge.map((pe,me)=>H(pe,me,oe,J.source,i)),Pe=async(pe,me)=>{if(me.isCancellationRequested)throw(0,M.canceled)();const be=oe.withPage(pe+1),{galleryExtensions:ke}=await this.queryGallery(be,i,me);return ke.map((Ae,Ue)=>H(Ae,Ue,be,J.source,i))};return{firstPage:de,total:fe,pageSize:oe.pageSize,getPage:Pe}}async queryGallery(N,Q,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,a.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(a.Unpublished));const re=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ie={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},oe=new Date().getTime();let ge,fe,de=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ie},J),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:de};const Pe=await(0,S.asJson)(ge);if(Pe){const pe=Pe.results[0],me=pe.extensions;me.forEach(ke=>O(ke.versions,Q));const be=pe.resultMetadata&&pe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return de=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:de}}return{galleryExtensions:[],total:de}}catch(Pe){throw fe=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-oe,success:!!ge&&(0,S.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:fe?(0,M.isPromiseCanceledError)(fe)?"canceled":(0,M.getErrorMessage)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(N,Q,J,re){if(!this.isEnabled())return;const le=E.isWeb?this.api(`/itemName/${N}.${Q}/version/${J}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Q}/${J}/stats?statType=${re}`),ie=E.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:le,headers:ge},L.CancellationToken.None)}catch(fe){}}async download(N,Q,J){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,b.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ie=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:de}),oe=J===1?"install":J===2?"update":"",ge=oe?{uri:`${N.assets.download.uri}${f.URI.parse(N.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${N.assets.download.fallbackUri}${f.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:N.assets.download,fe=await this.getAsset(ge);await this.fileService.writeFile(Q,fe.stream),ie(new Date().getTime()-le)}async getReadme(N,Q){if(N.assets.readme){const J=await this.getAsset(N.assets.readme,{},Q);return await(0,S.asText)(J)||""}return""}async getManifest(N,Q){if(N.assets.manifest){const J=await this.getAsset(N.assets.manifest,{},Q),re=await(0,S.asText)(J);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,Q){const J=K(N,l.Manifest);if(!J)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.getAsset(J,{headers:re});return await(0,S.asJson)(le)}async getCoreTranslation(N,Q){const J=N.assets.coreTranslations.filter(re=>re[0]===Q.toUpperCase())[0];if(J){const re=await this.getAsset(J[1]),le=await(0,S.asText)(re);return le?JSON.parse(le):null}return null}async getChangelog(N,Q){if(N.assets.changelog){const J=await this.getAsset(N.assets.changelog,{},Q);return await(0,S.asText)(J)||""}return""}async getAllCompatibleVersions(N,Q){let J=new R().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?J=J.withFilter(s.ExtensionId,N.identifier.uuid):J=J.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:re}=await this.queryGallery(J,Q,L.CancellationToken.None);if(!re.length)return[];const le=q(re[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,Q))return[];const ie=[];for(const oe of re[0].versions)try{ie[ie.length-1]?.version!==oe.version&&await this.isRawExtensionVersionCompatible(oe,le,Q)&&ie.push({version:oe.version,date:oe.lastUpdated})}catch(ge){}return ie}async getAsset(N,Q={},J=L.CancellationToken.None){const re=await this.commonHeadersPromise,le={type:"GET"},ie={...re,...Q.headers||{}};Q={...Q,...le,headers:ie};const oe=N.uri,ge=N.fallbackUri,fe={...Q,url:oe};try{const de=await this.requestService.request(fe,J);if(de.res.statusCode===200)return de;const Pe=await(0,S.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Pe}`)}catch(de){if((0,M.isPromiseCanceledError)(de))throw de;const Pe=(0,M.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:Pe});const pe={...Q,url:ge};return this.requestService.request(pe,J)}}async getEngine(N){let Q=_(N);if(!Q){const J=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Q=J.engines.vscode}return Q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,S.asJson)(N),J=new Map;if(Q)for(const re of Q.malicious){const le=J.get(re)||{id:{id:re},malicious:!0,slow:!1};le.malicious=!0,J.set(re,le)}return[...J.values()]}};A=ue([te(1,S.IRequestService),te(2,g.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,P.IProductService),te(7,w.IConfigurationService)],A);let W=class extends A{constructor(N,Q,J,re,le,ie,oe,ge){super(N,Q,J,re,le,ie,oe,ge)}};W=ue([te(0,h.IStorageService),te(1,S.IRequestService),te(2,g.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,P.IProductService),te(7,w.IConfigurationService)],W),e.ExtensionGalleryService=W;let z=class extends A{constructor(N,Q,J,re,le,ie,oe){super(void 0,N,Q,J,re,le,ie,oe)}};z=ue([te(0,S.IRequestService),te(1,g.ILogService),te(2,t.IEnvironmentService),te(3,o.ITelemetryService),te(4,d.IFileService),te(5,P.IProductService),te(6,w.IConfigurationService)],z),e.ExtensionGalleryServiceWithNoStorageService=z;async function X(U,N,Q,J,re,le){const ie={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},oe=await(0,u.getServiceMachineId)(Q,re,le);return(0,c.getTelemetryLevel)(N,Q)>=2&&(0,c.getTelemetryConfiguration)(J)==="on"&&(ie["X-Market-User-Id"]=oe),ie}e.resolveMarketplaceHeaders=X}),define(Z[201],x([0,1,2,44,25,147,16,49,45,38,29,60]),function(V,e,p,L,M,k,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(P),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const S=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!S})})}setExperimentProperty(d,g){this._experimentProperties[d]=g}setEnabled(d){this._enabled=d}_updateUserOptIn(){const d=(0,I.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=d!=="off",this._userOptIn=d==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,P=d["common.instanceId"],S=d["common.machineId"],u=d["common.firstSessionDate"],h=d["common.msftInternal"];return{sessionId:g,instanceId:P,machineId:S,firstSessionDate:u,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(d,g,P){return this.isOptedIn?this._commonProperties.then(S=>{g=(0,L.mixin)(g,S),g=(0,L.mixin)(g,this._experimentProperties),g=(0,L.cloneAndChange)(g,u=>{if(typeof u=="string")return this._cleanupInfo(u,P)}),this._appender.log(d,g)},S=>{console.error(S)}):Promise.resolve(void 0)}publicLog2(d,g,P){return this.publicLog(d,g,P)}publicLogError(d,g){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(d,g,!0)}publicLogError2(d,g){return this.publicLogError(d,g)}_anonymizeFilePaths(d){let g=d;const P=[];for(let o of this._cleanupPatterns)for(;;){const c=o.exec(d);if(!c)break;P.push([c.index,o.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(g="";;){const o=u.exec(d);if(!o)break;!S.test(o[0])&&P.every(([c,i])=>o.index<c||o.index>=i)&&(g+=d.substring(h,o.index)+"<REDACTED: user-file-path>",h=u.lastIndex)}return h<d.length&&(g+=d.substr(h)),g}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const g=d.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(g)?"<REDACTED: secret>":P.test(g)?"<REDACTED: email>":d}_cleanupInfo(d,g){let P=d;g&&(P=this._anonymizeFilePaths(P));for(let S of this._cleanupPatterns)P=P.replace(S,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=ue([te(1,E.IConfigurationService)],b),e.TelemetryService=b,w.Registry.as(n.Extensions.Configuration).registerConfiguration({id:t.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(0,null),properties:{[t.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,k.localize)(1,null),(0,k.localize)(2,null),(0,k.localize)(3,null)],markdownDescription:f.default.privacyStatementUrl?(0,k.localize)(5,null,f.default.nameLong,f.default.privacyStatementUrl):(0,k.localize)(4,null,f.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(n.Extensions.Configuration).registerConfiguration({id:t.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(6,null),properties:{[t.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,k.localize)(8,null,f.default.nameLong,f.default.privacyStatementUrl):(0,k.localize)(7,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(9,null,`\`#${t.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[202],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[203],x([0,1,108,4,2,5,38,202]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var f;(function(P){function S(u){return u&&typeof u=="object"&&typeof u.id=="string"}P.isThemeColor=S})(f=e.ThemeColor||(e.ThemeColor={}));function w(P){return{id:P}}e.themeColorFromId=w;var t;(function(P){function S(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||f.isThemeColor(a.color))}P.isThemeIcon=S;const u=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function h(a){const r=u.exec(a);if(!r)return;let[,s]=r;return{id:s}}P.fromString=h;function o(a,r){let s=a.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),r&&(s=`${s}~${r}`),{id:s}}P.modify=o;function c(a,r){return a.id===r.id&&a.color?.id===r.color?.id}P.isEqual=c;function i(a,r){return{id:a.id,color:r?w(r):void 0}}P.asThemeIcon=i,P.asClassNameArray=p.CSSIcon.asClassNameArray,P.asClassName=p.CSSIcon.asClassName,P.asCSSSelector=p.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function I(P){switch(P){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,M.toDisposable)(()=>{const u=this.themingParticipants.indexOf(S);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new b;E.Registry.add(e.Extensions.ThemingContribution,v);function d(P){return v.onColorThemeChange(P)}e.registerThemingParticipant=d;class g extends M.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,u){let h=this.theme.getColor(S);return h&&u&&(h=u(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Z[61],x([0,1,14,3,5,39]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",t="themeBackground",I="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let b=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?E:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:I,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const P of p.BrowserWindow.getAllWindows())if(P.id===d){P.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};b=ue([te(0,k.IStateMainService)],b),e.ThemeMainService=b}),define(Z[42],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(k){k.Uninitialized="uninitialized",k.Idle="idle",k.CheckingForUpdates="checking for updates",k.AvailableForDownload="available for download",k.Downloading="downloading",k.Downloaded="downloaded",k.Updating="updating",k.Ready="ready"})(L=e.StateType||(e.StateType={}));var M;(function(k){k[k.Setup=0]="Setup",k[k.Archive=1]="Archive",k[k.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(k,E)=>({type:"idle",updateType:k,error:E}),CheckingForUpdates:k=>({type:"checking for updates",explicit:k}),AvailableForDownload:k=>({type:"available for download",update:k}),Downloading:k=>({type:"downloading",update:k}),Downloaded:k=>({type:"downloaded",update:k}),Updating:k=>({type:"updating",update:k}),Ready:k=>({type:"ready",update:k})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[204],x([0,1,3,148,49,38]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[205],x([0,1,4,42]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=M;class k{constructor(n){this.channel=n,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=k}),define(Z[97],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[206],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(p.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class M{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=M;class k{constructor(n){this.next=n}async routeCall(n,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const I=p.URI.revive(w);if(I&&I.query){const b=/\bwindowId=(\d+)/.exec(I.query);if(b){const v=b[1],d=new RegExp(`window:${v}`),g=n.connections.find(P=>d.test(P.ctx));if(g)return g}}}return this.next.routeCall(n,f,w,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=k}),define(Z[207],x([0,1,9,2,7,21]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const I=[...this.handlers.values()];return(0,p.first)(I.map(b=>()=>b.handleURL(w,t)),void 0,!1).then(b=>b||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=E;let n=class extends E{constructor(w){super();this.productService=w}create(w){let{authority:t,path:I,query:b,fragment:v}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&I&&I.indexOf("/")!==0&&(I=`/${I}`),M.URI.from({scheme:this.productService.urlProtocol,authority:t,path:I,query:b,fragment:v})}};n=ue([te(0,k.IProductService)],n),e.NativeURLService=n}),define(Z[208],x([0,1,14,9,4,2,3,7]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(I){return null}}class w{constructor(I,b,v,d,g){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=k.Disposable.None,this.disposables=new k.DisposableStore,this.uris=I,E.isWindows){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,u)}const P=M.Event.map(M.Event.fromNodeEventEmitter(p.app,"open-url",(u,h)=>({event:u,url:h})),({event:u,url:h})=>(u.preventDefault(),h));this.disposables.add(P(u=>{const h=f(u);!h||this.urlService.open(h,{originalUrl:u})})),v.getWindows().filter(u=>u.isReady).length>0?this.flush():M.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||I.push(b);I.length!==0&&(this.uris=I,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[209],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[210],x([0,1,14,2,10,7]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(M.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=k.URI.parse(f.url),I=E.validWebviewFilePaths.get(t.path);if(typeof I=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${I}`,v=M.FileAccess.asFileUri(b,V);return w(decodeURIComponent(v.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[62],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function M(w){return!!w.folderUri}e.isFolderToOpen=M;function k(w){return!!w.fileUri}e.isFileToOpen=k;function E(w){const t=n(w),I=w.getValue("window.menuBarVisibility");return I==="default"||t==="native"&&I==="compact"||p.isMacintosh&&p.isNative?"classic":I}e.getMenuBarVisibility=E;function n(w){if(p.isWeb)return"custom";const t=w.getValue("window");if(t){if(p.isMacintosh&&t.nativeTabs===!0||p.isMacintosh&&t.nativeFullScreen===!1)return"native";const v=t.titleBarStyle;if(v==="native"||v==="custom")return v}return p.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var M;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var k;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(k=e.OpenContext||(e.OpenContext={}));const E=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=E;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[211],x([0,1,14,4,2,210,36]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends M.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let I;if(typeof w.windowId=="number"){const{windowId:b}=w,v=this.windowsMainService.getWindowById(b);if(!v?.win)throw new Error(`Invalid windowId: ${b}`);I=v.win.webContents}else{const{webContentsId:b}=w;if(I=p.webContents.fromId(b),!I)throw new Error(`Invalid webContentsId: ${b}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,I,b){const v=this.getFrameByName(w,t),d=v;if(typeof d.findInFrame=="function"){d.findInFrame(I,{findNext:b.findNext,forward:b.forward});const g=(P,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),v.removeListener("found-in-frame",g))};v.on("found-in-frame",g)}}async stopFindInFrame(w,t,I){const v=this.getFrameByName(w,t);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const I=this.windowsMainService.getWindowById(w.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${w}`);const b=I.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===t);if(!b)throw new Error(`Unknown frame: ${t}`);return b}};n=ue([te(0,E.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[212],x([0,1,9,4,2]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends M.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new M.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>w()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[213],x([0,1,37,15,7,5]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var E;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(b){const v=b;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=n;function f(b){const v=b;return!!(v&&typeof v=="object"&&M.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(v,d,g,P){this._id=v,this._configuration=g,this._ignorePathCasing=P,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class t{constructor(v,d){this.raw=d,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function I(b){return new t({uri:b,index:0,name:(0,L.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=I}),define(Z[27],x([0,1,31,40,77,34,10,8,3,15,7,151,5,74,213]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(_){return(typeof _=="string"?(0,n.extname)(_):(0,w.extname)(_))===g}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function S(_){return _.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function u(_){return _.hasOwnProperty("folderUri")}e.isRecentFolder=u;function h(_){return _.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(_){const j=_;return typeof j?.id=="string"&&t.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(_){if(_.configuration)return{id:_.id,configPath:_.configuration};if(_.folders.length===1)return{id:_.id,uri:_.folders[0].uri}}e.toWorkspaceIdentifier=c;function i(_){const j=_;return typeof j?.id=="string"&&t.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=i;function a(_){const j=_;if(j?.uri)return{id:j.id,uri:t.URI.revive(j.uri)};const $=_;if($?.configPath)return{id:$.id,configPath:t.URI.revive($.configPath)};if(_?.id)return{id:_.id}}e.reviveIdentifier=a;function r(_,j){return w.extUriBiasedIgnorePathCase.isEqualOrParent(_,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(_){return l(_)||m(_)}e.isStoredWorkspaceFolder=s;function l(_){const j=_;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=l;function m(_){const j=_;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=m;function y(_,j,$,B,q=!f.isWindows,O){if(_.scheme!==B.scheme)return{name:$,uri:_.toString(!0)};let H=j?void 0:O.relativePath(B,_);if(H!==void 0)H.length===0?H=".":f.isWindows&&_.scheme===E.Schemas.file&&!q&&(H=H.replace(/\//g,"\\"));else if(_.scheme===E.Schemas.file)H=_.fsPath,f.isWindows&&(H=(0,k.normalizeDriveLetter)(H),q&&(H=(0,p.toSlashes)(H)));else{if(!O.isEqualAuthority(_.authority,B.authority))return{name:$,uri:_.toString(!0)};H=_.path}return{name:$,path:H}}e.getStoredWorkspaceFolder=y;function D(_,j,$){let B=[],q=new Set;const O=$.dirname(j);for(let H of _){let T;if(l(H))H.path&&(T=$.resolvePath(O,H.path));else if(m(H))try{T=t.URI.parse(H.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(A){console.warn(A)}if(T){let A=$.getComparisonKey(T);if(!q.has(A)){q.add(A);const W=H.name||$.basenameOrAuthority(T);B.push(new d.WorkspaceFolder({uri:T,name:W,index:B.length},H))}}}return B}e.toWorkspaceFolders=D;function R(_,j,$,B,q){let O=F(j,_);const H=q.dirname(j),T=q.dirname(B),A=[],W=C(O.folders);for(const N of O.folders){const Q=l(N)?q.resolvePath(H,N.path):t.URI.parse(N.uri);let J;$?J=!1:J=!l(N)||(0,n.isAbsolute)(N.path),A.push(y(Q,J,N.name,T,W,q))}const z={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},X=M.setProperty(_,["folders"],A,z);let U=M.applyEdits(_,X);return O.remoteAuthority===(0,v.getRemoteAuthority)(B)&&(U=M.applyEdits(U,M.removeProperty(U,["remoteAuthority"],z))),U}e.rewriteWorkspaceFileForNewLocation=R;function F(_,j){let $=L.parse(j);if($&&Array.isArray($.folders))$.folders=$.folders.filter(B=>s(B));else throw new Error(`${_} looks like an invalid workspace file.`);return $}function C(_){return f.isWindows?_.some(j=>l(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function G(_){return _.workspace&&typeof _.workspace=="object"&&typeof _.workspace.id=="string"&&typeof _.workspace.configPath=="string"}function ne(_){return typeof _.folderUri=="string"}function ae(_){return typeof _.fileUri=="string"}function K(_,j){const $={workspaces:[],files:[]};if(_){const B=function(O,H){for(let T=0;T<O.length;T++)try{H(O[T],T)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(O[T])}: ${A.toString()}. Skip entry.`)}},q=_;if(Array.isArray(q.entries))B(q.entries,O=>{const H=O.label,T=O.remoteAuthority;G(O)?$.workspaces.push({label:H,remoteAuthority:T,workspace:{id:O.workspace.id,configPath:t.URI.parse(O.workspace.configPath)}}):ne(O)?$.workspaces.push({label:H,remoteAuthority:T,folderUri:t.URI.parse(O.folderUri)}):ae(O)&&$.files.push({label:H,remoteAuthority:T,fileUri:t.URI.parse(O.fileUri)})});else{const O=_;Array.isArray(O.workspaces3)&&B(O.workspaces3,(H,T)=>{const A=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[T]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?$.workspaces.push({label:A,workspace:{id:H.id,configPath:t.URI.parse(H.configURIPath)}}):typeof H=="string"&&$.workspaces.push({label:A,folderUri:t.URI.parse(H)})}),Array.isArray(O.files2)&&B(O.files2,(H,T)=>{const A=Array.isArray(O.fileLabels)&&O.fileLabels[T]||void 0;typeof H=="string"&&$.files.push({label:A,fileUri:t.URI.parse(H)})})}}return $}e.restoreRecentlyOpened=K;function ee(_){const j={entries:[]};for(const $ of _.workspaces)u($)?j.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):j.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of _.files)j.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return j}e.toStoreData=ee}),define(Z[51],x([0,1,5,27]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function M(k){const E=k;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=M}),define(Z[52],x([0,1,14,9,79,34,2,66,8,3,13,19,133,5,6,39,27]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let S=class gt{constructor(h,o){this.stateMainService=h,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,o){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},o)}pickFolder(h,o){return this.doPick({...h,pickFolders:!0,title:(0,b.localize)(1,null)},o)}pickFile(h,o){return this.doPick({...h,pickFiles:!0,title:(0,b.localize)(2,null)},o)}pickWorkspace(h,o){const c=(0,b.localize)(3,null),i=(0,k.mnemonicButtonLabel)((0,b.localize)(4,null)),a=P.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:c,filters:a,buttonLabel:i},o)}async doPick(h,o){const c={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};c.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(c.properties=void 0,h.pickFiles&&h.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&c.properties.push("treatPackageAsDirectory");const i=o||p.BrowserWindow.getFocusedWindow(),a=await this.showOpenDialog(c,(0,t.withNullAsUndefined)(i));if(a&&a.filePaths&&a.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(a.filePaths[0])),a.filePaths}getWindowDialogQueue(h){if(h){let o=this.windowDialogQueues.get(h.id);return o||(o=new L.Queue,this.windowDialogQueues.set(h.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(h,o){return this.getWindowDialogQueue(o).queue(async()=>o?p.dialog.showMessageBox(o,h):p.dialog.showMessageBox(h))}async showSaveDialog(h,o){const c=this.acquireFileDialogLock(h,o);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let i;return o?i=await p.dialog.showSaveDialog(o,h):i=await p.dialog.showSaveDialog(h),i.filePath=this.normalizePath(i.filePath),i})}finally{(0,E.dispose)(c)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(o=>this.normalizePath(o))}async showOpenDialog(h,o){h.defaultPath&&(await I.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const c=this.acquireFileDialogLock(h,o);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let i;return o?i=await p.dialog.showOpenDialog(o,h):i=await p.dialog.showOpenDialog(h),i.filePaths=this.normalizePaths(i.filePaths),i})}finally{(0,E.dispose)(c)}}acquireFileDialogLock(h,o){if(!o)return E.Disposable.None;let c=this.windowFileDialogLocks.get(o.id);c||(c=new Set,this.windowFileDialogLocks.set(o.id,c));const i=(0,M.hash)(h);if(!c.has(i))return c.add(i),(0,E.toDisposable)(()=>{c?.delete(i),c?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=ue([te(0,g.IStateMainService),te(1,d.ILogService)],S),e.DialogMainService=S}),define(Z[214],x([0,1,4,2,27]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),k.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(t=>{const I=this.storageMainService.globalStorage.get(t.key);typeof I=="string"?f.set(t.key,I):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const t=(0,M.reviveIdentifier)(w.workspace),I=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(I.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[v,d]of b.insert)I.set(v,d);b.delete&&b.delete.forEach(v=>I.delete(v));break}case"close":{if(t)return I.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=k,k.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,4,2,8,28,19,85,123,6,96,29,27]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class v extends L.Disposable{constructor(S){super();this.logService=S,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const S=await this.doCreate();this.storage.dispose(),this.storage=S,this._register(S.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(S);const u=S.getBoolean(t.IS_NEW_KEY);u===void 0?S.set(t.IS_NEW_KEY,!0):u&&S.set(t.IS_NEW_KEY,!1)}catch(S){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${S}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?S=>this.logService.trace(S):void 0,logError:S=>this.logService.error(S)}}doInit(S){return S.init()}get items(){return this.storage.items}get(S,u){return this.storage.get(S,u)}set(S,u){return this.storage.set(S,u)}delete(S){return this.storage.delete(S)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends v{constructor(S,u,h){super(u);this.options=S,this.environmentService=h}async doCreate(){let S;return this.options.useInMemoryStorage?S=f.SQLiteStorageDatabase.IN_MEMORY_PATH:S=(0,M.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}))}async doInit(S){await super.doInit(S),this.updateTelemetryState(S)}updateTelemetryState(S){S.get(I.instanceStorageKey,void 0)===void 0&&S.set(I.instanceStorageKey,(0,k.generateUuid)()),S.get(I.firstSessionDateStorageKey,void 0)===void 0&&S.set(I.firstSessionDateStorageKey,new Date().toUTCString());const o=S.get(I.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();S.set(I.lastSessionDateStorageKey,typeof o=="undefined"?null:o),S.set(I.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends v{constructor(S,u,h,o){super(h);this.workspace=S,this.options=u,this.environmentService=o}async doCreate(){const{storageFilePath:S,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}),{hint:u?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const S=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,M.join)(S,g.WORKSPACE_STORAGE_NAME);return await E.Promises.exists(S)?{storageFilePath:u,wasCreated:!1}:(await E.Promises.mkdir(S,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(S),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(S){let u;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const h=(0,M.join)(S,g.WORKSPACE_META_NAME);await E.Promises.exists(h)||await E.Promises.writeFile(h,JSON.stringify(u,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[98],x([0,1,43,2,48,5,22,6,215]),function(V,e,p,L,M,k,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(I,b,v){super();this.logService=I,this.environmentService=b,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)I.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new f.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let b=this.mapWorkspaceToStorage.get(I.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),b=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,b),(0,p.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),b}};w=ue([te(0,n.ILogService),te(1,M.IEnvironmentService),te(2,E.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[99],x([0,1,15,7,27]),function(V,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function k(f,w,t){for(const b of f){const v=b.openedWorkspace;if((0,M.isWorkspaceIdentifier)(v)){const d=t(v);if(d){if(d.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return b}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(w,v.configPath))return b}}const I=f.filter(b=>(0,M.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(w,b.openedWorkspace.uri));if(I.length)return I.sort((b,v)=>-(b.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=k;function E(f,w){for(const t of f)if((0,M.isWorkspaceIdentifier)(t.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,M.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=E;function n(f,w){const t=I=>w.some(b=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(I)));for(const I of f)if(I.config?.extensionDevelopmentPath?.some(b=>t(b)))return I}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class mt extends L.Disposable{constructor(h,o,c,i,a){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=c,this.logService=i,this.configurationService=a,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const c=P(h);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(c=>{const i=(0,b.isWorkspaceIdentifier)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,a=(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&c.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(c.folderUri,h.openedWorkspace.uri);(i||a)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,b.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),c=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),i&&M.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,b.isWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(y.length)return y[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(D=>D.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(y.length)return y[0]}else if(h.backupPath){const y=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(y.length)return y[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!o&&m)return m.uiState}let c;const i=p.screen.getAllDisplays();if(i.length===1)c=i[0];else{if(M.isMacintosh){const l=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(l)}!c&&o&&(c=p.screen.getDisplayMatching(o.getBounds())),c||(c=p.screen.getPrimaryDisplay()||i[0])}let a=(0,I.defaultWindowState)();a.x=Math.round(c.bounds.x+c.bounds.width/2-a.width/2),a.y=Math.round(c.bounds.y+c.bounds.height/2-a.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")a.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")a.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,s=a.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};v.windowsStateStorageKey="windowsState",v=ue([te(0,I.IWindowsMainService),te(1,t.IStateMainService),te(2,f.ILifecycleMainService),te(3,w.ILogService),te(4,n.IConfigurationService)],v),e.WindowsStateHandler=v;function d(u){const h={openedWindows:[]},o=u||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(c=>g(c))),h}e.restoreWindowsState=d;function g(u){const h={uiState:u.uiState};return u.backupPath&&(h.backupPath=u.backupPath),u.remoteAuthority&&(h.remoteAuthority=u.remoteAuthority),u.folder&&(h.folderUri=E.URI.parse(u.folder)),u.workspaceIdentifier&&(h.workspace={id:u.workspaceIdentifier.id,configPath:E.URI.parse(u.workspaceIdentifier.configURIPath)}),h}function P(u){return{lastActiveWindow:u.lastActiveWindow&&S(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&S(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(h=>S(h))}}e.getWindowsStateStoreData=P;function S(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(Z[100],x([0,1,58,32,10,3,15]),function(V,e,p,L,M,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function t(){let I=w.scheme===M.Schemas.file?(0,E.originalFSPath)(w):w.toString();return k.isLinux||(I=I.toLowerCase()),(0,p.createHash)("md5").update(I).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,t){function I(){if(w.scheme!==M.Schemas.file)return(0,p.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(d){return}let v;return k.isLinux?v=t.ino:k.isMacintosh?v=t.birthtime.getTime():k.isWindows&&(typeof t.birthtimeMs=="number"?v=Math.floor(t.birthtimeMs):v=t.birthtime.getTime()),(0,p.createHash)("md5").update(w.fsPath).update(v?String(v):"").digest("hex")}const b=I();if(typeof b=="string")return{id:b,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,8,3,28,35,83,217]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(y){this.socket=y,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const D=R=>y(k.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(y){const D=R=>{y({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(y){return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(y){if(!this.socket.destroyed)try{this.socket.write(y.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((y,D)=>{if(this.socket.bufferSize===0){y();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),y()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var P;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var S;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(S||(S={}));class u extends f.Disposable{constructor(y,D,R,F){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=y,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=F,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,E.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,E.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._totalOutgoingDataBytes+=y.byteLength,this._zlibDeflate?(this._zlibDeflate.write(y.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(k.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(y,!1)}_write(y,D){let R=2;y.byteLength<126?R+=0:y.byteLength<2**16?R+=2:R+=8;const F=k.VSBuffer.alloc(R);if(D?F.writeUInt8(194,0):F.writeUInt8(130,0),y.byteLength<126)F.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){F.writeUInt8(126,1);let C=1;F.writeUInt8(y.byteLength>>>8&255,++C),F.writeUInt8(y.byteLength>>>0&255,++C)}else{F.writeUInt8(127,1);let C=1;F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(y.byteLength>>>24&255,++C),F.writeUInt8(y.byteLength>>>16&255,++C),F.writeUInt8(y.byteLength>>>8&255,++C),F.writeUInt8(y.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=F.byteLength+y.byteLength,this.socket.write(k.VSBuffer.concat([F,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._totalIncomingWireBytes+=y.byteLength,this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),F=(D.readUInt8(0)&128)>>>7,C=D.readUInt8(1),G=(C&128)>>>7,ne=C&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=F,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),F=(R&128)>>>7;let C=R&127,G=1;C===126?C=D.readUInt8(++G)*2**8+D.readUInt8(++G):C===127&&(C=D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G));let ne=0;F&&(ne=D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G)),this._state.state=3,this._state.readLen=C,this._state.mask=ne}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);h(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(k.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function h(m,y){if(y===0)return;let D=m.byteLength>>>2;for(let ae=0;ae<D;ae++){const K=m.readUInt32BE(ae*4);m.writeUInt32BE(K^y,ae*4)}let R=D*4,F=m.byteLength-R;const C=y>>>24&255,G=y>>>16&255,ne=y>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(R)^C,R),F>=2&&m.writeUInt8(m.readUInt8(R+1)^G,R+1),F>=3&&m.writeUInt8(m.readUInt8(R+2)^ne,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const m=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):y=(0,w.join)((0,M.tmpdir)(),`vscode-ipc-${m}.sock`),a(y),y}e.createRandomIPCHandle=c;function i(m,y,D){const R=(0,p.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${y}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${y}.sock`):F=(0,w.join)(m,`${D}-${y}.sock`),a(F),F}e.createStaticIPCHandle=i;function a(m){const y=o[t.platform];typeof y=="number"&&m.length>=y&&console.warn(`WARNING: IPC handle "${m}" is longer than ${y} chars, try a shorter --user-data-dir`)}class r extends b.IPCServer{constructor(y){super(r.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const D=n.Event.fromNodeEventEmitter(y,"connection");return n.Event.map(D,R=>({protocol:new v.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(m){return new Promise((y,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(m,()=>{R.removeListener("error",D),y(new r(R))})})}e.serve=s;function l(m,y){return new Promise((D,R)=>{const F=(0,L.createConnection)(m,()=>{F.removeListener("error",R),D(v.Client.fromSocket(new g(F),y))});F.once("error",R)})}e.connect=l}),define(Z[218],x([0,1,56]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class M{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,I){return this.channel.call("click",[f,w,t,I])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,I){return this.channel.call("getElementXY",[f,w,t,I])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=M;class k{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=k;async function E(n){const f=await(0,p.connect)(n,"driverClient"),w=f.getChannel("driver"),t=new M(w);return{client:f,driver:t}}e.connect=E}),define(Z[219],x([0,1,9,4,106,57,2,3,78,35,56,155,218,176,22,36]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(h){return h<21}let S=class{constructor(o,c,i,a){this.windowServer=o,this.options=c,this.windowsMainService=i,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,c){await this.whenUnfrozen(o);const i=M.KeybindingParser.parseUserBinding(c);for(let a of i)await this._dispatchKeybinding(o,a)}async _dispatchKeybinding(o,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const a=i.win.webContents,r=new k.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new v.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),m=[];c.ctrlKey&&m.push("ctrl"),c.metaKey&&m.push("meta"),c.shiftKey&&m.push("shift"),c.altKey&&m.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:m}),P(c.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:m}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:m}),await(0,p.timeout)(100)}async click(o,c,i,a){await(await this.getWindowDriver(o)).click(c,i,a)}async doubleClick(o,c){await(await this.getWindowDriver(o)).doubleClick(c)}async setValue(o,c,i){await(await this.getWindowDriver(o)).setValue(c,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,c){return await(await this.getWindowDriver(o)).isActiveElement(c)}async getElements(o,c,i){return await(await this.getWindowDriver(o)).getElements(c,i)}async getElementXY(o,c,i,a){return await(await this.getWindowDriver(o)).getElementXY(c,i,a)}async typeInEditor(o,c,i){await(await this.getWindowDriver(o)).typeInEditor(c,i)}async getTerminalBuffer(o,c){return await(await this.getWindowDriver(o)).getTerminalBuffer(c)}async writeInTerminal(o,c,i){await(await this.getWindowDriver(o)).writeInTerminal(c,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const c=`window:${o}`,i=new w.StaticRouter(r=>r===c),a=this.windowServer.getChannel("windowDriver",i);return new I.WindowDriverChannelClient(a)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};S=ue([te(2,g.IWindowsMainService),te(3,d.ILifecycleMainService)],S),e.Driver=S;async function u(h,o,c,i){const a=c.driverVerbose,r=i.createInstance(S,h,{verbose:a}),s=new b.WindowDriverRegistryChannel(r);h.registerChannel("windowDriverRegistry",s);const l=await(0,t.serve)(o),m=new b.DriverChannel(r);return l.registerChannel("driver",m),(0,E.combinedDisposable)(l,h)}e.serve=u}),define(Z[24],x([0,1,47,8,56,48,160,5]),function(V,e,p,L,M,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(k.IEnvironmentService);class f extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([p.memoize],f.prototype,"cachedLanguagesPath",null),ue([p.memoize],f.prototype,"backupHome",null),ue([p.memoize],f.prototype,"backupWorkspacesPath",null),ue([p.memoize],f.prototype,"mainIPCHandle",null),ue([p.memoize],f.prototype,"mainLockfile",null),ue([p.memoize],f.prototype,"sandbox",null),ue([p.memoize],f.prototype,"driverVerbose",null),ue([p.memoize],f.prototype,"disableUpdates",null),ue([p.memoize],f.prototype,"disableKeytar",null),ue([p.memoize],f.prototype,"codeCachePath",null),ue([p.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[220],x([0,1,58,32,31,10,8,3,15,7,19,51,16,24,20,6,27]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(h,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,a)=>(0,M.isEqual)(i,a,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(h.folderURIWorkspaces)&&(c=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const c=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(h,o){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(o))try{L.renameSync(o,h)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,c=this.workspaces.findIndex(i=>i.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(h,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const c=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,E.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,c=[];for(let i of h){const a=i.workspace;if(!(0,P.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const r=this.getBackupPath(a.id);await this.doHasBackups(r)?a.configPath.scheme!==k.Schemas.file||await t.Promises.exists(a.configPath.fsPath)?c.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let i of h){const a=this.backupUriComparer.getComparisonKey(i);if(!c.has(a)){c.add(a);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==k.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let i of h){const a=i.backupFolder;if(typeof a!="string")return[];if(!c.has(a)){c.add(a);const r=this.getBackupPath(a);await this.doHasBackups(r)?o.push(i):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await t.Promises.rename(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{L.renameSync(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,I.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await t.Promises.readdir(h);for(const c of o)try{if((await t.Promises.readdir((0,E.join)(h,c))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===k.Schemas.file?o=n.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,p.createHash)("md5").update(o).digest("hex")}};S=ue([te(0,v.IEnvironmentMainService),te(1,b.IConfigurationService),te(2,g.ILogService)],S),e.BackupMainService=S}),define(Z[221],x([0,1,59,56]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,k,E,n){const f=t=>n(t,void 0),w=p.createConnection({host:M,port:k},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const I=t.toString("base64");let b=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${k}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];w.write(b.join(`\r
`)+`\r
\r
`);const v=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",v),n(void 0,new L.NodeSocket(w)))};w.on("data",v)});w.once("error",f)}}}),define(Z[222],x([0,1,59,9,2,115,16,6,21,191,95,221,75]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function v(S,u,h,o,c){return new d(S,u,h,o,c).waitForReady()}class d extends M.Disposable{constructor(u,h,o,c,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=p.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let u=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(u){u.pause();const h=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemoteHost,this.tunnelRemotePort),o=h.getSocket().socket,c=h.readEntireBuffer();h.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),o.end()}),u.on("close",()=>o.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),o.destroy()}),o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),u.pipe(o),o.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),o.end()})}}let g=class extends t.AbstractTunnelService{constructor(u,h,o,c,i){super(h);this.socketFactory=u,this.signService=o,this.productService=c,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,h,o,c,i,a,r){const s=this.getTunnelFromMap(h,o);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,c,i,a,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},m=v(l,this.defaultTunnelHost,h,o,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,m),m}}};g=ue([te(1,n.ILogService),te(2,b.ISignService),te(3,f.IProductService),te(4,E.IConfigurationService)],g),e.BaseTunnelService=g;let P=class extends g{constructor(u,h,o,c){super(I.nodeSocketFactory,u,h,o,c)}};P=ue([te(0,n.ILogService),te(1,b.ISignService),te(2,f.IProductService),te(3,E.IConfigurationService)],P),e.TunnelService=P}),define(Z[223],x([0,1,193,18,17,2,13,16,48,90,6,192,217]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends k.Disposable{constructor(g,P,S){super();this.environmentService=P,this.logService=S,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,P){this.logService.trace("RequestService#request",g.url);const{proxyUrl:S,strictSSL:u}=this,h={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=g.agent?g.agent:await(0,I.getProxyAgent)(g.url||"",h,{proxyUrl:S,strictSSL:u});return g.agent=o,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,P)}async getNodeRequest(g){return((0,p.parse)(g.url).protocol==="https:"?await new Promise((u,h)=>{V(["https"],u,h)}):await new Promise((u,h)=>{V(["http"],u,h)})).request}_request(g,P){return new Promise(async(S,u)=>{let h;const o=(0,p.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,E.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),h=c(i,a=>{const r=(0,E.isNumber)(g.followRedirects)?g.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&r>0&&a.headers.location)this._request({...g,url:a.headers.location,followRedirects:r-1},P).then(S,u);else{let s=a;a.headers["content-encoding"]==="gzip"&&(s=a.pipe((0,b.createGunzip)())),S({res:a,stream:(0,L.streamToBufferReadableStream)(s)})}}),h.on("error",u),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),P.onCancellationRequested(()=>{h.abort(),u((0,M.canceled)())})})}async resolveProxy(g){}};v=ue([te(0,n.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,t.ILogService)],v),e.RequestService=v}),define(Z[224],x([0,1,14,223]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(E){return p.net.request}class k extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:M},f)}}e.RequestMainService=k}),define(Z[225],x([0,1,14,9,4,2,10,13,84,24,22,6,45,55,61]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends k.Disposable{constructor(S,u,h,o,c,i,a){super();this.machineId=S,this.userEnv=u,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=c,this.themeMainService=i,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),p.ipcMain.on("vscode:createSharedProcessMessageChannel",async(S,u)=>this.onWindowConnection(S,u))}async onWindowConnection(S,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(S.sender.isDestroyed())return h.close();S.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[h])}onWillShutdown(){const S=this.window;!S||(!S.isDestroyed()&&!S.webContents.isDestroyed()&&S.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(S.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{S.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(S=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),S()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(S=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),S()}))})()),this._whenIpcReady}createWindow(){const S=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),S.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=S=>{this.logService.trace("SharedProcess#close prevented"),S.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(S,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(S,u,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:u}})))}async connect(){await this.whenIpcReady;const S=(0,n.assertIsDefined)(this.window);return(0,f.connect)(S)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ue([te(2,w.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,I.ILogService),te(5,d.IThemeMainService),te(6,v.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[226],x([0,1,9,18,8,13,7,24,20,6]),function(V,e,p,L,M,k,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(v,d,g){this.storagePath=v,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,d){const g=this.storage[v];return(0,k.isUndefinedOrNull)(g)?d:g}setItem(v,d){this.setItems([{key:v,data:d}])}setItems(v){let d=!1;for(const{key:g,data:P}of v)this.storage[g]!==P&&((0,k.isUndefinedOrNull)(P)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=P,d=!0));d&&this.save()}removeItem(v){(0,k.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(v){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),v)}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let I=class yt{constructor(v,d,g){this.fileStorage=new t(E.URI.file((0,M.join)(v.userDataPath,yt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(v,d){return this.fileStorage.getItem(v,d)}setItem(v,d){this.fileStorage.setItem(v,d)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=ue([te(0,n.IEnvironmentMainService),te(1,w.ILogService),te(2,f.IFileService)],I),e.StateMainService=I}),define(Z[76],x([0,1,9,23,4,16,24,22,6,21,50,42]),function(V,e,p,L,M,k,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,g,P){return`${P.updateUrl}/api/update/${d}/${g}/${P.commit}`}e.createUpdateURL=b;let v=class{constructor(g,P,S,u,h,o){this.lifecycleMainService=g,this.configurationService=P,this.environmentMainService=S,this.requestService=u,this.logService=h,this.productService=o,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(g);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};v=ue([te(0,n.ILifecycleMainService),te(1,k.IConfigurationService),te(2,E.IEnvironmentMainService),te(3,t.IRequestService),te(4,f.ILogService),te(5,w.IProductService)],v),e.AbstractUpdateService=v}),define(Z[227],x([0,1,14,47,4,2,16,24,22,6,21,50,29,42,76]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(S,u,h,o,c,i,a){super(S,u,o,c,i,a);this.telemetryService=h,this.disposables=new k.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"error",(S,u)=>u)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(S,u,h)=>({url:u,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(S,u,h,o)=>({releaseNotes:u,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(v.State.Idle(1,h))}buildUpdateFeedUrl(S){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(u,S,this.productService);try{p.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(S){this.setState(v.State.CheckingForUpdates(S)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(v.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([L.memoize],g.prototype,"onRawError",null),ue([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([te(0,f.ILifecycleMainService),te(1,E.IConfigurationService),te(2,b.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,I.IRequestService),te(5,w.ILogService),te(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(Z[228],x([0,1,41,32,9,4,8,24,22,6,29,42]),function(V,e,p,L,M,k,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(g,P,S){if(this.lifecycleMainService=g,this.logService=S,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,M.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=ue([te(0,f.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,w.ILogService)],b);let v=class extends b{constructor(g,P,S,u,h,o){super(S,u,h);this.snap=g,this.snapRevision=P,this.telemetryService=o;const c=(0,L.watch)(E.dirname(this.snap)),i=k.Event.fromNodeEventEmitter(c,"change",(l,m)=>m),a=k.Event.filter(i,l=>l==="current"),s=k.Event.debounce(a,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{s.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+E.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((S,u)=>(0,L.realpath)(`${E.dirname(this.snap)}/current`,(h,o)=>h?u(h):S(o))),P=E.basename(g);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=ue([te(2,f.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,w.ILogService),te(5,t.ITelemetryService)],v),e.SnapUpdateService=v}),define(Z[46],x([0,1,14,32,4,40,34,2,10,8,3,15,13,19,153,51,52,24,5,6,21,99,27,100]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(l,m,y,D,R){super();this.environmentMainService=l,this.logService=m,this.backupMainService=y,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>v.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const y=m(l.fsPath);return y instanceof Promise?y.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,y)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const y=this.doParseStoredWorkspace(l,m),D=(0,a.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(y.folders,D.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:y.remoteAuthority,transient:y.transient}}catch(y){this.logService.warn(y.toString())}}doParseStoredWorkspace(l,m){const y=(0,k.parse)(m);if(y&&Array.isArray(y.folders))y.folders=y.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return y}async createUntitledWorkspace(l,m){const{workspace:y,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=y.configPath.fsPath;return await v.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await v.Promises.writeFile(R,JSON.stringify(D,null,"	")),y}createUntitledWorkspaceSync(l,m){const{workspace:y,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=y.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,v.writeFileSync)(R,JSON.stringify(D,null,"	")),y}newUntitledWorkspace(l=[],m){const y=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,I.joinPath)(this.untitledWorkspacesHome,y),R=(0,I.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),F=[];for(const C of l)F.push((0,i.getStoredWorkspaceFolder)(C.uri,!0,C.name,D,!t.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(R),storedWorkspace:{folders:F,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,I.originalFSPath)(l.configPath);try{(0,v.rimrafSync)((0,w.dirname)(m));const y=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(y)&&(0,v.writeFileSync)((0,w.join)(y,"obsolete"),"")}catch(y){this.logService.warn(`Unable to delete untitled workspace ${m} (${y}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(y=>(0,I.joinPath)(this.untitledWorkspacesHome,y,i.UNTITLED_WORKSPACE_NAME));for(const y of m){const D=(0,a.getWorkspaceIdentifier)(y),R=this.resolveLocalWorkspaceSync(y);R?l.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,y){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,y))return;const R=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(y));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,m,y){if(!y)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,y))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(m,y)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,I.basename)(y)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,b.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let y;return l.config.extensionDevelopmentPath||(y=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=y,{workspace:m,backupPath:y}}};r=ue([te(0,S.IEnvironmentMainService),te(1,h.ILogService),te(2,g.IBackupMainService),te(3,P.IDialogMainService),te(4,o.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[101],x([0,1,14,30,23,3,13,7,19,16,54,5,6,97,36,27,46]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let S=class{constructor(h,o,c,i,a){this.logService=h,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=a}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),k.isMacintosh&&p.app.focus({steal:!0});const c=this.parseOpenUrl(h);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:a,url:r}of c)this.urlService.open(a,{originalUrl:r})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(h,o){const c=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const a=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:c,cli:h,userEnv:o,waitMarkerFileURI:a,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let s=!1;if(h["new-window"]||h["unity-launch"])s=!0;else if(h["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!k.isMacintosh}if(s)i=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:a,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:c,cli:h,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:a,gotoLineMode:h.goto,remoteAuthority:r});if(a&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return p.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?h.push(this.codeWindowToInfo(c)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(a=>{const r=i.remoteAuthority;if(r){const s=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:s,args:l}),p.ipcMain.once(s,(m,y)=>{y||a({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),a(y)}),setTimeout(()=>{a({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else a(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const o=[],c=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),c=(0,E.assertIsDefined)(h.win);return this.browserWindowToInfo(c,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],c){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:c}}};S=ue([te(0,b.ILogService),te(1,d.IWindowsMainService),te(2,v.IURLService),te(3,P.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],S),e.LaunchMainService=S}),define(Z[53],x([0,1,41,14,26,114,47,4,34,2,10,8,3,7,81,67,19,145,52,24,5,22,6,21,29,61,36,27,46]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i,a,r,s,l,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let D=class ct extends w.Disposable{constructor(F,C,G,ne,ae,K,ee,_,j,$){super();this.sharedProcess=F,this.windowsMainService=C,this.dialogMainService=G,this.lifecycleMainService=ne,this.environmentMainService=ae,this.telemetryService=K,this.logService=ee,this.productService=_,this.themeMainService=j,this.workspacesManagementMainService=$,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,q)=>q.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,q)=>q.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,q)=>q.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,q)=>q.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,q,O)=>O),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const C=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(F,C,G){return Array.isArray(C)?this.doOpenWindow(F,C,G):this.doOpenEmptyWindow(F,C)}async doOpenWindow(F,C,G=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0})}async doOpenEmptyWindow(F,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},C)}async toggleFullScreen(F){const C=this.windowById(F);C&&C.toggleFullScreen()}async handleTitleDoubleClick(F){const C=this.windowById(F);C&&C.handleTitleDoubleClick()}async isMaximized(F){const C=this.windowById(F);return C?.win?C.win.isMaximized():!1}async maximizeWindow(F){const C=this.windowById(F);C?.win&&C.win.maximize()}async unmaximizeWindow(F){const C=this.windowById(F);C?.win&&C.win.unmaximize()}async minimizeWindow(F){const C=this.windowById(F);C?.win&&C.win.minimize()}async focusWindow(F,C){C&&typeof C.windowId=="number"&&(F=C.windowId);const G=this.windowById(F);G&&G.focus({force:C?.force??!1})}async setMinimumSize(F,C,G){const ne=this.windowById(F);if(ne?.win){const[ae,K]=ne.win.getSize(),[ee,_]=ne.win.getMinimumSize(),[j,$]=[C??ee,G??_],[B,q]=[Math.max(ae,j),Math.max(K,$)];(ee!==j||_!==$)&&ne.win.setMinimumSize(j,$),(ae!==B||K!==q)&&ne.win.setSize(B,q)}}async saveWindowSplash(F,C){this.themeMainService.saveWindowSplash(F,C)}async installShellCommand(F){const{source:C,target:G}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await P.SymlinkSupport.stat(C);if(ne&&!ne.dangling){const ae=await(0,d.realpath)(C);if(G===ae)return}await P.Promises.unlink(C)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await P.Promises.symlink(G,C)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:ae}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${C}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(K)}catch(K){throw new Error((0,S.localize)(3,null,C))}}}async uninstallShellCommand(F){const{source:C}=await this.getShellCommandLink();try{await P.Promises.unlink(C)}catch(G){switch(G.code){case"EACCES":const{response:ne}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const ae=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(ae)}catch(ae){throw new Error((0,S.localize)(7,null,C))}break;case"ENOENT":break;default:throw G}}}async getShellCommandLink(){const F=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await P.Promises.exists(F))throw new Error((0,S.localize)(8,null,F));return{source:C,target:F}}async showMessageBox(F,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(F))}async showSaveDialog(F,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(F))}async showOpenDialog(F,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(F))}toBrowserWindow(F){const C=this.windowById(F);if(C?.win)return C.win}async pickFileFolderAndOpen(F,C){const G=await this.dialogMainService.pickFileFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(G.map(async ne=>await P.SymlinkSupport.existsDirectory(ne)?{folderUri:v.URI.file(ne)}:{fileUri:v.URI.file(ne)})),C,F))}async pickFolderAndOpen(F,C){const G=await this.dialogMainService.pickFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({folderUri:v.URI.file(ne)})),C,F))}async pickFileAndOpen(F,C){const G=await this.dialogMainService.pickFile(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({fileUri:v.URI.file(ne)})),C,F))}async pickWorkspaceAndOpen(F,C){const G=await this.dialogMainService.pickWorkspace(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({workspaceUri:v.URI.file(ne)})),C,F))}doOpenPicked(F,C,G){this.windowsMainService.open({context:3,contextWindowId:G,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(F,C,G){const ne=F?F.length:0;this.telemetryService.publicLog(C,{...G,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(F,C){L.shell.showItemInFolder(C)}async setRepresentedFilename(F,C){const G=this.windowById(F);G&&G.setRepresentedFilename(C)}async setDocumentEdited(F,C){const G=this.windowById(F);G&&G.setDocumentEdited(C)}async openExternal(F,C){return b.isLinuxSnap?this.safeSnapOpenExternal(C):L.shell.openExternal(C),!0}safeSnapOpenExternal(F){const C=process.env.GDK_PIXBUF_MODULE_FILE,G=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=G}moveItemToTrash(F,C){return L.shell.trashItem(C)}async isAdmin(){let F;return b.isWindows?F=(await new Promise((C,G)=>{V(["native-is-elevated"],C,G)}))():F=process.getuid()===0,F}async writeElevated(F,C,G,ne){const ae=await new Promise((K,ee)=>{V(["sudo-prompt"],K,ee)});return new Promise((K,ee)=>{const _=[`"${this.cliPath}"`];ne?.unlock&&_.push("--file-chmod"),_.push("--file-write",`"${C.fsPath}"`,`"${G.fsPath}"`);const j={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ae.exec(_.join(" "),j,($,B,q)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),q&&this.logService.trace(`[sudo-prompt] received stderr: ${q}`),$?ee($):K(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(F,C,G){process.kill(C,G)}async readClipboardText(F,C){return L.clipboard.readText(C)}async writeClipboardText(F,C,G){return L.clipboard.writeText(C,G)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,C){return L.clipboard.writeFindText(C)}async writeClipboardBuffer(F,C,G,ne){return L.clipboard.writeBuffer(C,Buffer.from(G),ne)}async readClipboardBuffer(F,C){return L.clipboard.readBuffer(C)}async hasClipboard(F,C,G){return L.clipboard.has(C,G)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,C){const G=this.windowById(F);G&&G.updateTouchBar(C)}async notifyReady(F){const C=this.windowById(F);C&&C.setReady()}async relaunch(F,C){return this.lifecycleMainService.relaunch(C)}async reload(F,C){const G=this.windowById(F);if(G){if((0,m.isWorkspaceIdentifier)(G.openedWorkspace)){const ne=G.openedWorkspace.configPath;if(ne.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(G,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,C){const G=this.windowById(C);if(G?.win)return G.win.close()}async quit(F){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(F,C){await this.lifecycleMainService.kill(C)}async resolveProxy(F,C){const ne=this.windowById(F)?.win?.webContents?.session;if(ne)return ne.resolveProxy(C)}async openDevTools(F,C){const G=this.windowById(F);G?.win&&G.win.webContents.openDevTools(C)}async toggleDevTools(F){const C=this.windowById(F);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(F,C){const G=this.windowById(F);G?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&G.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,C,G,ne){if(!b.isWindows)return;const ae=await new Promise((K,ee)=>{V(["vscode-windows-registry"],K,ee)});try{return ae.GetStringRegKey(C,G,ne)}catch{return}}async getPassword(F,C,G){const ne=await this.withKeytar(),ae=await ne.getPassword(C,G);if(ae)try{let{content:K,hasNextChunk:ee}=JSON.parse(ae);if(!K||!ee)return ae;let _=1;for(;ee;){const j=await ne.getPassword(C,`${G}-${_}`),$=JSON.parse(j);K+=$.content,ee=$.hasNextChunk,_++}return K}catch{return ae}return ae}async setPassword(F,C,G,ne){const ae=await this.withKeytar(),K=3,ee=async(_,j,$)=>{let B=0,q;for(;B<K;)try{await ae.setPassword(_,j,$);return}catch(O){q=O,this.logService.warn("Error attempting to set a password: ",O),B++,await new Promise(H=>setTimeout(H,200))}throw q};if(b.isWindows&&ne.length>ct.MAX_PASSWORD_LENGTH){let _=0,j=0,$=!0;for(;$;){const B=ne.substring(_,_+ct.PASSWORD_CHUNK_SIZE);_+=ct.PASSWORD_CHUNK_SIZE,$=ne.length-_>0;const q={content:B,hasNextChunk:$};await ee(C,j?`${G}-${j}`:G,JSON.stringify(q)),j++}}else await ee(C,G,ne);this._onDidChangePassword.fire({service:C,account:G})}async deletePassword(F,C,G){const ae=await(await this.withKeytar()).deletePassword(C,G);return ae&&this._onDidChangePassword.fire({service:C,account:G}),ae}async findPassword(F,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(F,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((F,C)=>{V(["keytar"],F,C)})}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,ue([E.memoize],D.prototype,"cliPath",null),D=ue([te(1,l.IWindowsMainService),te(2,u.IDialogMainService),te(3,c.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,i.ILogService),te(7,a.IProductService),te(8,s.IThemeMainService),te(9,y.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Z[229],x([0,1,14,23,4,79,2,28,88,6,53,21,36]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let d=class extends E.Disposable{constructor(P,S,u,h,o){super();this.logService=P,this.windowsMainService=S,this.nativeHostMainService=u,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=M.Event.fromNodeEventEmitter(p.app,"login",(S,u,h,o,c)=>({event:S,webContents:u,req:h,authInfo:o,callback:c}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:S,req:u,callback:h}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(P);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const S=String((0,k.hash)({scheme:P.scheme,host:P.host,port:P.port}));let u,h;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(a){const r=JSON.parse(await this.encryptionMainService.decrypt(a));u=r.username,h=r.password}}catch(a){this.logService.error(a)}if(this.state!==v.StoredCredentialsUsed&&typeof u=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:u,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const c={authInfo:P,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=v.LoginDialogShown;const i=await new Promise(a=>{const r=async(s,l,m)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),m){const y={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(y));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(D){this.logService.error(D)}a({username:y.username,password:y.password})}else a(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};d=ue([te(0,w.ILogService),te(1,b.IWindowsMainService),te(2,t.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,I.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[230],x([0,1,14,26,34,2,10,3,82,143,71,52,24,5,101,6,53,45,21,55,62]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let c=class St{constructor(a,r,s,l,m,y,D,R,F){this.userEnv=a,this.environmentMainService=r,this.launchMainService=s,this.logService=l,this.diagnosticsService=m,this.dialogMainService=y,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),p.ipcMain.on("vscode:listProcesses",async a=>{const r=[];try{const s=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,t.isRemoteDiagnosticError)(m)?r.push({name:m.hostName,rootProcess:m}):m.processes&&r.push({name:m.hostName,rootProcess:m.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(a,"vscode:listProcessesResponse",r)}),p.ipcMain.on("vscode:issueReporterClipboard",async a=>{const r={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",s.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const r=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",r)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(a,r)=>{const{id:s,from:l,args:m}=r;let y;switch(l){case"issueReporter":y=this.issueReporterParentWindow;break;case"processExplorer":y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}y&&y.webContents.send("vscode:runAction",{id:s,from:l,args:m})}),p.ipcMain.on("vscode:openExternal",(a,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),p.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async a=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",r.windows)})}safeSend(a,r,...s){a.sender.isDestroyed()||a.sender.send(r,...s)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new k.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:S.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new k.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:S.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,r,s){const l=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:s.title,backgroundColor:s.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,r)}getWindowPosition(a,r,s){let l;const m=p.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(n.isMacintosh){const R=p.screen.getCursorScreenPoint();l=p.screen.getDisplayNearestPoint(R)}!l&&a&&(l=p.screen.getDisplayMatching(a.getBounds())),l||(l=p.screen.getPrimaryDisplay()||m[0])}const y={width:r,height:s},D=l.bounds;return y.x=D.x+D.width/2-y.width/2,y.y=D.y+D.height/2-y.height/2,D.width>0&&D.height>0&&(y.x<D.x&&(y.x=D.x),y.y<D.y&&(y.y=D.y),y.x>D.x+D.width&&(y.x=D.x),y.y>D.y+D.height&&(y.y=D.y),y.width>D.width&&(y.width=D.width),y.height>D.height&&(y.height=D.height)),y}async getPerformanceInfo(){try{const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,r)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ue([te(1,b.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,g.ILogService),te(4,t.IDiagnosticsService),te(5,I.IDialogMainService),te(6,P.INativeHostMainService),te(7,h.IProtocolMainService),te(8,u.IProductService)],c),e.IssueMainService=c}),define(Z[231],x([0,1,23,16,24,22,6,53,21,50,29,42,76]),function(V,e,p,L,M,k,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends b.AbstractUpdateService{constructor(g,P,S,u,h,o,c,i){super(g,P,u,h,o,i);this.telemetryService=S,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,b.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(I.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(w.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const S=g?P.message||P:void 0;this.setState(I.State.Idle(1,S))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(I.State.Idle(1))}};v=ue([te(0,k.ILifecycleMainService),te(1,L.IConfigurationService),te(2,t.ITelemetryService),te(3,M.IEnvironmentMainService),te(4,w.IRequestService),te(5,E.ILogService),te(6,n.INativeHostMainService),te(7,f.IProductService)],v),e.LinuxUpdateService=v}),define(Z[232],x([0,1,41,32,26,9,23,47,8,7,112,19,16,24,20,22,6,53,21,50,29,42,76]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(m,y=1e3){for(;!m();)await(0,k.timeout)(y)}let r;function s(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends i.AbstractUpdateService{constructor(y,D,R,F,C,G,ne,ae,K){super(y,D,F,C,G,K);this.telemetryService=R,this.fileService=ne,this.nativeHostMainService=ae}get cachePath(){const y=f.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(y,{recursive:!0}).then(()=>y)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(y){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),s()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,y,this.productService)}doCheckForUpdates(y){!this.url||(this.setState(c.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},E.CancellationToken.None).then(h.asJson).then(D=>{const R=s();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(c.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(F=>I.Promises.exists(F).then(C=>{if(C)return Promise.resolve(F);const G=D.url,ne=D.hash,ae=`${F}.tmp`;return this.requestService.request({url:G},E.CancellationToken.None).then(K=>this.fileService.writeFile(w.URI.file(ae),K.stream)).then(ne?()=>(0,t.checksum)(ae,D.hash):()=>{}).then(()=>I.Promises.rename(ae,F)).then(()=>F)})).then(F=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:F},C&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y});const R=y?D.message||D:void 0;this.setState(c.State.Idle(s(),R))}))}async doDownloadUpdate(y){y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(c.State.Idle(s()))}async getUpdatePackagePath(y){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${y}.exe`)}async cleanup(y=null){const D=y?G=>!new RegExp(`${this.productService.quality}-${y}\\.exe$`).test(G):()=>!0,R=await this.cachePath,C=(await I.Promises.readdir(R)).filter(D).map(async G=>{try{await I.Promises.unlink(f.join(R,G))}catch(ne){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const y=this.state.update;this.setState(c.State.Updating(y));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${y.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(s()))});const F=`${this.productService.win32MutexName}-ready`,C=await new Promise((G,ne)=>{V(["windows-mutex"],G,ne)});a(()=>C.isActive(F)).then(()=>this.setState(c.State.Ready(y)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};ue([n.memoize],l.prototype,"cachePath",null),l=ue([te(0,g.ILifecycleMainService),te(1,b.IConfigurationService),te(2,o.ITelemetryService),te(3,v.IEnvironmentMainService),te(4,h.IRequestService),te(5,P.ILogService),te(6,d.IFileService),te(7,S.INativeHostMainService),te(8,u.IProductService)],l),e.Win32UpdateService=l}),define(Z[233],x([0,1,14,9,23,4,34,2,10,8,73,3,7,149,51,16,52,24,54,200,20,22,6,21,55,98,29,203,61,62,36,27,46]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i,a,r,s,l,m,y,D,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(G||(G={}));let ne=class extends n.Disposable{constructor(K,ee,_,j,$,B,q,O,H,T,A,W,z,X){super();this.logService=ee,this.environmentMainService=_,this.fileService=j,this.configurationService=B,this.themeMainService=q,this.workspacesManagementMainService=O,this.backupMainService=H,this.telemetryService=T,this.dialogMainService=A,this.lifecycleMainService=W,this.productService=z,this.protocolMainService=X,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[U,N]=this.restoreWindowState(K.state);this.windowState=U,this.logService.trace("window#ctor: using window state",U);const Q=this.windowState.mode===0||this.windowState.mode===3,J=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(J?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),I.isMacintosh&&(re.acceptFirstMouse=!0,J?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=I.isMacintosh&&J?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const ie=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ie&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(re.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(re),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&ie&&this._win.setSheetOffset(22),I.isMacintosh&&N&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}Q&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:U=>$.globalStorage.get(U),store:(U,N)=>$.globalStorage.set(U,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){I.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){I.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){I.isMacintosh&&K?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function ee(){_.dispose(),j.dispose(),K()}const _=this.onDidClose(()=>ee()),j=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",($,B,q)=>this.onWindowError(3,{reason:q,exitCode:B})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),ee=$=>{for(let B=$;B;B=B.parent)if(B.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},_=$=>$.resourceType==="xhr"||ee($.frame);this._win.webContents.session.webRequest.onBeforeRequest(($,B)=>{const q=b.URI.parse($.url);return q.path.endsWith(".svg")&&!K.has(q.scheme)?B({cancel:!_($)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived(($,B)=>{const q=$.responseHeaders,O=q["content-type"]||q["Content-Type"];if(O&&Array.isArray(O)){const H=b.URI.parse($.url);if(H.path.endsWith(".svg")&&K.has(H.scheme))return q["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:q});if(!H.path.includes(f.Schemas.vscodeRemoteResource)&&O.some(T=>T.toLowerCase().includes("image/svg")))return B({cancel:!_($)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async($,B)=>{const q=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign($.requestHeaders,q)})})}async onWindowError(K,ee){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:ee?.reason,code:ee?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,v.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,v.localize)(2,null))],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;_.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):_.response===2&&this.destroyWindow()}else if(K===2){let _;ee?_=(0,v.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):_=(0,v.localize)(5,null);const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,v.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,v.localize)(8,null))],message:_,detail:(0,v.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;j.response===0?this.reload():j.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const _=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||_!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=_;const j=ee||"",$=_?`${_},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(K){I.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,ee),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:ee.isReload?3:_?2:1})}updateConfiguration(K,ee){const _=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(_){const j=(0,u.isLaunchedFromCli)(_)&&!(0,u.isLaunchedFromCli)(K.userEnv),$=this.isExtensionDevelopmentHost;(j||$)&&(K.userEnv={..._,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(K["disable-extensions"]=ee.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),K.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&K&&(ee.verbose=K.verbose,ee.debugId=K.debugId,ee["inspect-extensions"]=K["inspect-extensions"],ee["inspect-brk-extensions"]=K["inspect-brk-extensions"],ee["extensions-dir"]=K["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,F.isWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.configPath;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.uri;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let _;try{_=p.screen.getDisplayMatching(this.getBounds())}catch(B){}const j=(0,R.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let ee;if(!I.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?K.mode=0:K.mode=1,ee===1||ee===0){let _;ee===1?_=this.getBounds():_=this._win.getNormalBounds(),K.x=_.x,K.y=_.y,K.width=_.width,K.height=_.height}return K}restoreWindowState(K){(0,t.mark)("code/willRestoreCodeWindowState");let ee=!1;if(K)try{const _=p.screen.getAllDisplays();ee=_.length>1,K=this.validateWindowState(K,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),ee]}validateWindowState(K,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const $=this.getWorkingArea(ee[0]);if($){let B=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!$||(K.x<$.x&&(K.x=$.x),K.y<$.y&&(K.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),B(),K.width>$.width&&(K.width=$.width),K.height>$.height&&(K.height=$.height),K.x>$.x+$.width-128&&(K.x=$.x+$.width-K.width),K.y>$.y+$.height-128&&(K.y=$.y+$.height-K.height),B()}return K}if(K.display&&K.mode===3){const $=ee.find(B=>B.id===K.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=$.bounds.x,B.y=$.bounds.y,B}}let _,j;try{_=p.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),j=this.getWorkingArea(_)}catch($){}if(_&&j&&K.x+K.width>j.x&&K.y+K.height>j.y&&K.x<j.x+j.width&&K.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,ee]=this._win.getPosition(),[_,j]=this._win.getSize();return{x:K,y:ee,width:_,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,ee=!0){I.isMacintosh||(K==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,v.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const ee=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,ee,..._){this.isReady?this.send(K,..._):this.ready().then(()=>{ee.isCancellationRequested||this.send(K,..._)})}send(K,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${K} for window that is destroyed`);return}this._win.webContents.send(K,...ee)}}updateTouchBar(K){!I.isMacintosh||this.touchBarGroups.forEach((ee,_)=>{const j=K[_];ee.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!I.isMacintosh){for(let K=0;K<10;K++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const ee=this.createTouchBarGroupSegments(K),_=new p.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:_.segments[j].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(K=[]){return K.map(_=>{let j;_.icon&&!m.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===f.Schemas.file&&(j=p.nativeImage.createFromPath(b.URI.revive(_.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let $;return typeof _.title=="string"?$=_.title:$=_.title.value,{id:_.id,label:j?void 0:$,icon:j}})}dispose(){super.dispose(),this._win=null}};ne=ue([te(1,i.ILogService),te(2,S.IEnvironmentMainService),te(3,o.IFileService),te(4,s.IStorageMainService),te(5,g.IConfigurationService),te(6,y.IThemeMainService),te(7,C.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,l.ITelemetryService),te(10,P.IDialogMainService),te(11,c.ILifecycleMainService),te(12,a.IProductService),te(13,r.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[63],x([0,1,14,30,9,4,34,2,10,3,15,7,19,152,5,22,6,39,27,46]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class He extends n.Disposable{constructor(m,y,D,R){super();this.stateMainService=m,this.logService=y,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const y=[],D=[];for(let R of m)if((0,u.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&a(y,R.workspace)===-1&&y.push(R);else if((0,u.isRecentFolder)(R))r(y,R.folderUri)===-1&&y.push(R);else{const F=s(D,R.fileUri)>=0,C=R.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,t.basename)(R.fileUri))>=0;!F&&!C&&(D.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&p.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(y,D),y.length>He.MAX_TOTAL_RECENT_ENTRIES&&(y.length=He.MAX_TOTAL_RECENT_ENTRIES),D.length>He.MAX_TOTAL_RECENT_ENTRIES&&(D.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:y,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const y=C=>{const G=i(C);for(const ne of m)if(t.extUriBiasedIgnorePathCase.isEqual(ne,G))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(y),F=D.files.filter(y);(R.length!==D.workspaces.length||F.length!==D.files.length)&&(this.saveRecentlyOpened({files:F,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;p.app.clearRecentDocuments();const m=this.getRecentlyOpened(),y=[];let D=0;for(let F=0;F<m.workspaces.length&&D<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;F++){const C=i(m.workspaces[F]);if(C.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(C);await b.Promises.exists(G)&&(y.push(G),D++)}}const R=[];for(let F=0;F<m.files.length&&D<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;F++){const C=i(m.files[F]);if(C.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(C);if(He.COMMON_FILES_FILTER.includes((0,t.basename)(C))||y.includes(G))continue;await b.Promises.exists(G)&&(R.push(G),D++)}}R.reverse().forEach(F=>p.app.addRecentDocument(F)),y.reverse().forEach(F=>p.app.addRecentDocument(F))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const y=[],D=[],R=m?.config?.workspace;(0,u.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?y.push({workspace:R}):(0,u.isSingleFolderWorkspaceIdentifier)(R)&&y.push({folderUri:R.uri});const F=m?.config?.filesToOpenOrCreate;if(F)for(let C of F){const G=C.fileUri;G&&s(D,G)===-1&&D.push({fileUri:G})}return this.addEntriesFromStorage(y,D),{workspaces:y,files:D}}addEntriesFromStorage(m,y){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let F=(0,u.isRecentFolder)(R)?r(m,R.folderUri):a(m,R.workspace);F>=0?m[F].label=m[F].label||R.label:m.push(R)}for(let R of D.files){let F=s(y,R.fileUri);F>=0?y[F].label=y[F].label||R.label:y.push(R)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const y=(0,u.toStoreData)(m);this.stateMainService.setItem(He.recentlyOpenedStorageKey,y)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let y=[];for(let F of p.app.getJumpListSettings().removedItems){const C=F.args;if(C){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);G&&y.push(I.URI.parse(G[2]))}}this.removeRecentlyOpened(y);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(F=>{const C=(0,u.isRecentWorkspace)(F)?F.workspace:F.folderUri,{title:G,description:ne}=this.getWindowsJumpListLabel(C,F.label);let ae;return I.URI.isUri(C)?ae=`--folder-uri "${C.toString()}"`:(D=!0,ae=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&m.push({type:"custom",name:D?(0,v.localize)(2,null):(0,v.localize)(3,null),items:R})}m.push({type:"recent"});try{p.app.setJumpList(m)}catch(y){this.logService.warn("updateWindowsJumpList#setJumpList",y)}}getWindowsJumpListLabel(m,y){if(y)return{title:(0,E.splitName)(y).name,description:y};if(I.URI.isUri(m))return{title:(0,t.basename)(m),description:c(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,v.localize)(4,null),description:""};let D=(0,t.basename)(m.configPath);return D.endsWith(u.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,D),description:c(m.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ue([te(0,S.IStateMainService),te(1,P.ILogService),te(2,h.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(l){return l.scheme==="file"?(0,E.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,m){return l.findIndex(y=>(0,u.isRecentWorkspace)(y)&&y.workspace.id===m.id)}function r(l,m){return l.findIndex(y=>(0,u.isRecentFolder)(y)&&t.extUriBiasedIgnorePathCase.isEqual(y.folderUri,m))}function s(l,m){return l.findIndex(y=>t.extUriBiasedIgnorePathCase.isEqual(y.fileUri,m))}}),define(Z[234],x([0,1,14,9,23,34,3,7,144,16,24,22,6,182,53,21,39,29,42,62,36,63]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class wt{constructor(l,m,y,D,R,F,C,G,ne,ae,K){this.updateService=l,this.configurationService=m,this.windowsMainService=y,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=F,this.stateMainService=C,this.lifecycleMainService=G,this.logService=ne,this.nativeHostMainService=ae,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(E.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(F,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(F,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(F,C,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(F,C,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const y=this.productService.reportIssueUrl;y&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(y,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(E.language){const F=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${F}lang=${E.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!E.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!E.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!E.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=p.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(E.isMacintosh?new p.Menu:null);return}const m=new p.Menu;let y;if(E.isMacintosh){const R=new p.Menu;y=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),m.append(y)}if(E.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),m.append(F)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),m.append(F)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),m.append(F)}if(this.shouldDrawMenu("View")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),m.append(F)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),m.append(F)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),m.append(F)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),m.append(F)}let D;if(this.shouldDrawMenu("Window")){const R=new p.Menu;D=new p.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),m.append(F)}m.items&&m.items.length>0?p.Menu.setApplicationMenu(m):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),y=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const ee=new p.Menu;this.setMenuById(ee,"Preferences"),D=new p.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ee})}const R=new p.Menu,F=new p.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),C=new p.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new p.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new p.MenuItem({label:f.localize(15,null),role:"unhide"}),ae=new p.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[m];K.push(...y),D&&K.push(r(),D),K.push(r(),F,r(),C,G,ne,r(),ae),K.forEach(ee=>l.append(ee))}shouldDrawMenu(l){if(!E.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(y=>{if((0,v.isMenubarMenuItemSeparator)(y))l.append(r());else if((0,v.isMenubarMenuItemSubmenu)(y)){const D=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(y.label),submenu:D});this.setMenu(D,y.submenu.items),l.append(R)}else(0,v.isMenubarMenuItemRecentAction)(y)?l.append(this.createOpenRecentMenuItem(y)):(0,v.isMenubarMenuItemAction)(y)&&(y.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),E.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[y.id]?l.append(new p.MenuItem(this.likeAction(y.id,{label:this.mnemonicLabel(y.label),click:this.fallbackMenuHandlers[y.id]}))):l.append(this.createMenuItem(y.label,y.id,!1,y.checked)):l.append(this.createMenuItem(y.label,y.id,y.enabled!==!1,!!y.checked)):l.append(this.createMenuItem(y.label,y.id,y.enabled!==!1,!!y.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(y=>l.append(y)),l.append(r()))}createOpenRecentMenuItem(l){const m=n.URI.revive(l.uri),y=l.id,D=y==="openRecentFile"?{fileUri:m}:y==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new p.MenuItem(this.likeAction(y,{label:l.label,click:(R,F,C)=>{const G=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!E.isMacintosh&&(l.ctrlKey||l.shiftKey)||E.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,y){const D={label:this.mnemonicLabel(l),role:y,enabled:!0};return new p.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(l){const m=new p.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),y=new p.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new p.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),F=[];this.currentEnableNativeTabs&&(F.push(r()),F.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),F.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,y,r(),R,...F,r(),D].forEach(C=>l.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,y,D){const R=this.mnemonicLabel(l),F=typeof m=="function"?m:(K,ee,_)=>{const j=K?K.userSettingsLabel:null;let $=m;Array.isArray(m)&&($=this.isOptionClick(_)?m[1]:m[0]),j&&_.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:j}):this.runActionInRenderer({type:"commandId",commandId:$})},C=typeof y=="boolean"?y:this.windowsMainService.getWindowCount()>0,G=typeof D=="boolean"?D:!1,ne={label:R,click:F,enabled:C};G&&(ne.type="checkbox",ne.checked=G);let ae;return typeof m=="string"?ae=m:Array.isArray(m)&&(ae=m[0]),E.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ne.role="cut":ae==="editor.action.clipboardCopyAction"?ne.role="copy":ae==="editor.action.clipboardPasteAction"&&(ne.role="paste"),ae==="undo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:K=>K.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:K=>K.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(F,{inDevTools:K=>K.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ae,ne))}makeContextAwareClickHandler(l,m){return(y,D,R)=>{const F=p.BrowserWindow.getFocusedWindow();if(!F)return m.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return m.inDevTools(F.webContents.devToolsWebContents);l(y,D||F,R)}}runActionInRenderer(l){let m=p.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const y=m?this.windowsMainService.getWindowById(m.id):void 0;if(y){if(this.logService.trace("menubar#runActionInRenderer",l),E.isMacintosh&&!this.environmentMainService.isBuilt&&!y.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};y.sendWhenReady("vscode:runAction",M.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};y.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const y=typeof l=="string"?this.keybindings[l]:void 0;if(y?.label){if(y.isNative!==!1)m.accelerator=y.label,m.userSettingsLabel=y.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${y.label}]`:m.label=`${m.label} [${y.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,y=!m.accelerator){y&&(m=this.withKeybinding(l,m));const D=m.click;return m.click=(R,F,C)=>{this.reportMenuActionTelemetry(l),D&&D(R,F,C)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,k.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=ue([te(0,u.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,S.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,P.IStateMainService),te(7,I.ILifecycleMainService),te(8,b.ILogService),te(9,d.INativeHostMainService),te(10,g.IProductService)],a),e.Menubar=a;function r(){return new p.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,5,22,6,234]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let E=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(k.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};E=ue([te(0,p.IInstantiationService),te(1,L.ILifecycleMainService),te(2,M.ILogService)],E),e.MenubarMainService=E}),define(Z[236],x([0,1,14,32,26,30,23,4,31,43,34,2,10,8,73,3,33,15,13,7,150,51,16,52,24,20,5,22,6,45,21,55,74,39,62,233,99,216,27,100,63,46]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i,a,r,s,l,m,y,D,R,F,C,G,ne,ae,K,ee,_,j,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(T){return(0,_.isWorkspaceIdentifier)(T?.workspace)}function O(T){return(0,_.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let H=class Je extends I.Disposable{constructor(A,W,z,X,U,N,Q,J,re,le,ie,oe,ge,fe,de){super();this.machineId=A,this.initialUserEnv=W,this.logService=z,this.stateMainService=X,this.environmentMainService=U,this.lifecycleMainService=N,this.backupMainService=Q,this.configurationService=J,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=le,this.instantiationService=ie,this.dialogMainService=oe,this.fileService=ge,this.productService=fe,this.protocolMainService=de,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new I.DisposableStore;if(W.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const z of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(h.URI.file(z)));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(h.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,W){let z=this.environmentMainService.args;const X=W?.remoteAuthority||void 0,U=!0,N=W?.forceReuseWindow,Q=!N;return this.open({...A,cli:z,forceEmpty:U,forceNewWindow:Q,forceReuseWindow:N,remoteAuthority:X})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],z=[],X=[],U=[],N=[];let Q,J=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const fe of re)O(fe)?A.addMode?W.push(fe):z.push(fe):q(fe)?X.push(fe):fe.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:fe.remoteAuthority}),Q.filesToOpenOrCreate.push(fe)):fe.backupPath?N.push({backupFolder:(0,v.basename)(fe.backupPath),remoteAuthority:fe.remoteAuthority}):J++;A.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&A.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...U),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ie}=this.doOpen(A,X,z,N,J,Q,W);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${z.length}, emptyToRestore: ${N.length}, emptyToOpen: ${J})`),le.length>1)if(ie)ie.focus();else{const fe=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,Pe=!0;if(fe){const pe=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),de=!1,Pe=!1)}if(de)for(let pe=le.length-1;pe>=0;pe--){const me=le[pe];if(!(me.openedWorkspace&&U.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(be=>me.backupPath&&be.backupFolder===(0,v.basename)(me.backupPath)))){me.focus(),Pe=!1;break}}Pe&&le[le.length-1].focus()}const oe=Q&&Q.filesToDiff.length>0;if(!le.some(fe=>fe.isExtensionDevelopmentHost)&&!oe&&!A.noRecentEntry){const fe=[];for(const de of re)q(de)&&!de.transient?fe.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):O(de)?fe.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&fe.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(fe)}const ge=A.waitMarkerFileURI;return A.context===0&&ge&&le.length===1&&le[0]&&(async()=>{await le[0].whenClosedOrLoaded;try{await this.fileService.del(ge)}catch(fe){}})(),le}doOpen(A,W,z,X,U,N,Q){const J=[];let re;function le(pe,me){J.push(pe),me&&(re=pe,N=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Q.length>0){const pe=Q[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(pe);me&&le(this.doAddFoldersToExistingWindow(me,Q.map(be=>be.workspace.uri)))}const ge=z.length+W.length+X.length;if(N&&ge===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0],me=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let be;pe?.fileUri&&!oe&&((A.context===4||A.context===0||A.context===1)&&(be=(0,K.findWindowOnFile)(me,pe.fileUri,ke=>ke.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(me))),be?(0,_.isWorkspaceIdentifier)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,_.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,be,N),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const fe=(0,k.distinct)(W,pe=>pe.workspace.id);if(fe.length>0){const pe=(0,k.coalesce)(fe.map(me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(pe.length>0){const me=pe[0],be=N?.remoteAuthority===me.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,me,be),!!be),ie=!0}fe.forEach(me=>{if(pe.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===me.workspace.id))return;const be=me.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(A,me,ie,ke),!!ke),ie=!0})}const de=(0,k.distinct)(z,pe=>S.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(de.length>0){const pe=(0,k.coalesce)(de.map(me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(pe.length>0){const me=pe[0],be=N?.remoteAuthority===me.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,me,be),!!be),ie=!0}de.forEach(me=>{if(pe.some(Ae=>(0,_.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,me.workspace.uri)))return;const be=me.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(A,me,ie,ke),!!ke),ie=!0})}const Pe=(0,k.distinct)(X,pe=>pe.backupFolder);if(Pe.length>0&&Pe.forEach(pe=>{const me=pe.remoteAuthority,be=N?.remoteAuthority===me?N:void 0;le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:pe}),!!be),ie=!0}),J.length===0||N){N&&!U&&U++;const pe=N?N.remoteAuthority:A.remoteAuthority;for(let me=0;me<U;me++)le(this.doOpenEmpty(A,ie,pe,N),!!N),ie=!0}return{windows:(0,k.distinct)(J),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,W,z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const X={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToWait:z?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",E.CancellationToken.None,X),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const z={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,z),A}doOpenEmpty(A,W,z,X,U){return!W&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:z,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:U})}doOpenFolderOrWorkspace(A,W,z,X,U){return!z&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:U})}getPathsToOpen(A){let W,z=!1,X=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(A),z=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),z=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),X=!0),!A.addMode&&z){const U=W.filter(N=>O(N));if(U.length>1){const N=U[0].remoteAuthority;if(U.every(Q=>Q.remoteAuthority===N)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(U.map(J=>({uri:J.workspace.uri})));W.push({workspace:Q,remoteAuthority:N}),W=W.filter(J=>!O(J))}}}return A.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(U=>q(U)||O(U)||U.backupPath)),W}doExtractPathsFromAPI(A){const W=[],z={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const X of(0,k.coalesce)(A.urisToOpen||[])){const U=this.resolveOpenable(X,z);if(U)U.label=X.label,W.push(U);else{const N=this.resourceFromOpenable(X),Q={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:N.scheme===b.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:N.scheme===b.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(N.fsPath,this.environmentMainService)):(0,o.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,u.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(A){const W=[],z={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},X=A["folder-uri"];if(X)for(const Q of X){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable({folderUri:J},z);re&&W.push(re)}}const U=A["file-uri"];if(U)for(const Q of U){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable((0,_.hasWorkspaceFileExtension)(Q)?{workspaceUri:J}:{fileUri:J},z);re&&W.push(re)}}const N=A._;for(const Q of N){const J=z.remoteAuthority?this.doResolvePathRemote(Q,z):this.doResolveFilePath(Q,z);J&&W.push(J)}return W}cliArgToUri(A){try{const W=h.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const z=[];for(const X of W)if(X.workspace){const U=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});q(U)&&z.push(U)}else if(X.folderUri){const U=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});O(U)&&z.push(U)}else A!=="folders"&&X.backupPath&&z.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return z}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,W=Object.create(null)){let z=this.resourceFromOpenable(A);return z.scheme===b.Schemas.file?((0,ne.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(z.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let z=this.resourceFromOpenable(A);const X=(0,C.getRemoteAuthority)(z)||W.remoteAuthority;if(z=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(z)),(0,ne.isFileToOpen)(A)){if(W.gotoLineMode){const{path:U,line:N,column:Q}=(0,f.parseLineAndColumnAware)(z.path);return{fileUri:z.with({path:U}),selection:N?{startLineNumber:N,startColumn:Q||1}:void 0,remoteAuthority:X}}return{fileUri:z,remoteAuthority:X}}else if((0,ne.isWorkspaceToOpen)(A))return{workspace:(0,j.getWorkspaceIdentifier)(z),remoteAuthority:X};return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:X}}resourceFromOpenable(A){return(0,ne.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ne.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,W){let z,X;W.gotoLineMode&&({path:A,line:z,column:X}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,v.normalize)(A),(0,P.cwd)());try{const U=(0,L.statSync)(A);if(U.isFile()){if(!W.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(A));if(N)return N.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(A),selection:z?{startLineNumber:z,startColumn:X||1}:void 0,exists:!0}}else if(U.isDirectory())return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(h.URI.file(A),U),exists:!0}}catch(U){const N=h.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),W.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(A,W){const z=A.charCodeAt(0),X=W.remoteAuthority;let U,N;W.gotoLineMode&&({path:A,line:U,column:N}=(0,f.parseLineAndColumnAware)(A)),z!==47&&((0,f.isWindowsDriveLetter)(z)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const Q=h.URI.from({scheme:b.Schemas.vscodeRemote,authority:X,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,_.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:Q,selection:U?{startLineNumber:U,startColumn:N||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,j.getWorkspaceIdentifier)(Q),remoteAuthority:X};if(W.gotoLineMode||v.posix.basename(A).indexOf(".")!==-1)return{fileUri:Q,selection:U?{startLineNumber:U,startColumn:N||1}:void 0,remoteAuthority:X}}return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:X}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),z=W?.openFoldersInNewWindow||"default",X=W?.openFilesInNewWindow||"off";let U=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(z==="on"||z==="off")&&(U=z==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(N=X==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(A,W){const z=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(z)return this.lifecycleMainService.reload(z,W.cli),z.focus(),[z];let X=W.cli["folder-uri"]||[],U=W.cli["file-uri"]||[],N=W.cli._;if(!N.length&&!X.length&&!U.length&&!W.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=le&&(le.workspace||le.folderUri);ie&&(h.URI.isUri(ie)?ie.scheme===b.Schemas.file?N=[ie.fsPath]:X=[ie.toString()]:ie.configPath.scheme===b.Schemas.file?N=[(0,S.originalFSPath)(ie.configPath)]:U=[ie.configPath.toString()])}let Q=W.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=h.URI.parse(le),oe=(0,C.getRemoteAuthority)(ie);oe&&(Q?oe!==Q&&this.logService.error("more than one extension development path authority"):Q=oe)}N=N.filter(le=>{const ie=h.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,C.getRemoteAuthority)(ie)===Q}),X=X.filter(le=>{const ie=this.cliArgToUri(le);return ie&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,C.getRemoteAuthority)(ie)===Q:!1}),U=U.filter(le=>{const ie=this.cliArgToUri(le);return ie&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,C.getRemoteAuthority)(ie)===Q:!1}),W.cli._=N,W.cli["folder-uri"]=X,W.cli["file-uri"]=U;const J=!N.length&&!X.length&&!U.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:J,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:Q};return this.open(re)}openInBrowserWindow(A){const W=this.configurationService.getValue("window"),z={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,v.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let X;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const U=X.config;!z.extensionDevelopmentPath&&U&&!!U.extensionDevelopmentPath&&(z.extensionDevelopmentPath=U.extensionDevelopmentPath,z.verbose=U.verbose,z["inspect-brk-extensions"]=U["inspect-brk-extensions"],z.debugId=U.debugId,z["inspect-extensions"]=U["inspect-extensions"],z["extensions-dir"]=U["extensions-dir"])}else{const U=this.windowsStateHandler.getNewWindowState(z);(0,d.mark)("code/willCreateCodeWindow");const N=X=this.instantiationService.createInstance(ae.CodeWindow,{state:U,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(N)}Je.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Q=(0,u.assertIsDefined)(N.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return z.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then(U=>{U||this.doOpenInBrowserWindow(X,z,A)}):this.doOpenInBrowserWindow(X,z,A),X}doOpenInBrowserWindow(A,W,z){if(!W.extensionDevelopmentPath)if((0,_.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,_.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const X=z.emptyWindowBackupInfo&&z.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,W.remoteAuthority)}A.load(W)}onWindowClosed(A){const W=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=p.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===A))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(z=>z.lastFocusTime));return A.find(z=>z.lastFocusTime===W)}sendToFocused(A,...W){const z=this.getFocusedWindow()||this.getLastActiveWindow();z&&z.sendWhenReady(A,E.CancellationToken.None,...W)}sendToAll(A,W,z){for(const X of this.getWindows())z&&z.indexOf(X.id)>=0||X.sendWhenReady(A,E.CancellationToken.None,W)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(z=>z.id===A);return(0,k.firstOrDefault)(W)}getWindowByWebContents(A){const W=p.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};H.WINDOWS=[],H=ue([te(2,y.ILogService),te(3,G.IStateMainService),te(4,r.IEnvironmentMainService),te(5,m.ILifecycleMainService),te(6,c.IBackupMainService),te(7,i.IConfigurationService),te(8,$.IWorkspacesHistoryMainService),te(9,B.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,a.IDialogMainService),te(12,s.IFileService),te(13,R.IProductService),te(14,F.IProtocolMainService)],H),e.WindowsMainService=H}),define(Z[237],x([0,1,51,36,63,46]),function(V,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(f,w,t,I){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=ue([te(0,k.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,M.IWorkspacesHistoryMainService),te(3,p.IBackupMainService)],E),e.WorkspacesMainService=E}),define(Z[238],x([0,1,14,32,26,18,17,31,43,40,34,2,10,8,3,15,13,7,28,67,119,35,122,84,229,131,51,220,16,178,157,71,52,219,88,24,54,90,169,185,89,172,20,70,5,72,230,196,101,22,6,180,235,53,21,74,225,75,39,214,98,197,29,199,201,60,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,63,237,46]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i,a,r,s,l,m,y,D,R,F,C,G,ne,ae,K,ee,_,j,$,B,q,O,H,T,A,W,z,X,U,N,Q,J,re,le,ie,oe,ge,fe,de,Pe,pe,me,be,ke,Ae,Ue,Ce,Ge,Be,st,Ze,ot,Ye,ut,xe,Y,se,ce,we,ye,De,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ne=class extends I.Disposable{constructor(he,Se,Ee,ve,Ie,Le,Me,Re,Te,$e){super();this.mainProcessNodeIpcServer=he,this.userEnv=Se,this.mainInstantiationService=Ee,this.logService=ve,this.environmentMainService=Ie,this.lifecycleMainService=Le,this.configurationService=Me,this.stateMainService=Re,this.fileService=Te,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const he=ve=>ve?.startsWith(`${b.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((ve,Ie,Le,Me)=>he(Me.requestingUrl)?Le(Se.has(Ie)):Le(!1)),p.session.defaultSession.setPermissionCheckHandler((ve,Ie,Le,Me)=>he(Me.requestingUrl)?Se.has(Ie):!1);const Ee=p.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,E.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,E.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,o.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Ee,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),p.app.on("activate",(Ee,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Ee,ve)=>{ve.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),ve.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],Se;p.app.on("open-file",(Ee,ve)=>{this.logService.trace("app#open-file: ",ve),Ee.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],Se=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const ve=this.windowsMainService?.getWindowByWebContents(Ee.sender);let Ie,Le;return ve?.config?(Ie=ve.config,Le={...process.env,...ve.config.userEnv}):(Ie=this.environmentMainService.args,Le=process.env),(0,ee.resolveShellEnv)(this.logService,Ie,Le)}),p.ipcMain.handle("vscode:writeNlsFile",(Ee,ve,Ie)=>{const Le=this.validateNlsPath([ve]);if(!Le||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,k.VSBuffer.fromString(Ie))}),p.ipcMain.handle("vscode:readNlsFile",async(Ee,...ve)=>{const Ie=this.validateNlsPath(ve);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(he){let Se;for(const Ee of he)typeof Ee=="string"&&(typeof Se!="string"?Se=Ee:Se=(0,v.join)(Se,Ee));if(!(typeof Se!="string"||!(0,v.isAbsolute)(Se)||!(0,n.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return S.URI.file(Se)}onUnexpectedError(he){if(he){const Se={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;d.isWindows&&he&&p.app.setAppUserModelId(he);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new i.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:ve,sharedProcessReady:Ie,sharedProcessClient:Le}=this.setupSharedProcess(Ee),Me=await this.initServices(Ee,ve,Ie);if(this.environmentMainService.driverHandle){const Te=await(0,G.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,Se,Le));const Re=Me.invokeFunction(Te=>this.openFirstWindow(Te,Se));Me.invokeFunction(Te=>this.afterWindowOpen(Te,ve)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let he=this.stateMainService.getItem(pe.machineIdKey);return(!he||d.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,h.getMachineId)(),this.stateMainService.setItem(pe.machineIdKey,he)),he}setupSharedProcess(he){const Se=this._register(this.mainInstantiationService.createInstance(ie.SharedProcess,he,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ie,"main")})(),ve=(async()=>(await Se.whenReady(),Ee))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:Ee}}async initServices(he,Se,Ee){const ve=new T.ServiceCollection;switch(process.platform){case"win32":ve.set(Ae.IUpdateService,new O.SyncDescriptor(st.Win32UpdateService));break;case"linux":d.isLinuxSnap?ve.set(Ae.IUpdateService,new O.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ae.IUpdateService,new O.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":ve.set(Ae.IUpdateService,new O.SyncDescriptor(Ce.DarwinUpdateService));break}ve.set(se.IWindowsMainService,new O.SyncDescriptor(ce.WindowsMainService,[he,this.userEnv])),ve.set(C.IDialogMainService,new O.SyncDescriptor(C.DialogMainService)),ve.set(z.ILaunchMainService,new O.SyncDescriptor(z.LaunchMainService)),ve.set(F.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Ee.then(Le=>Le.getChannel("diagnostics"))))),ve.set(A.IIssueMainService,new O.SyncDescriptor(A.IssueMainService,[this.userEnv])),ve.set(ne.IEncryptionMainService,new O.SyncDescriptor(ne.EncryptionMainService,[he])),ve.set(W.IKeyboardLayoutMainService,new O.SyncDescriptor(W.KeyboardLayoutMainService)),ve.set(J.INativeHostMainService,new O.SyncDescriptor(J.NativeHostMainService,[Se])),ve.set(xe.IWebviewManagerService,new O.SyncDescriptor(Y.WebviewMainService)),ve.set(ye.IWorkspacesService,new O.SyncDescriptor(Fe.WorkspacesMainService)),ve.set(We.IWorkspacesManagementMainService,new O.SyncDescriptor(We.WorkspacesManagementMainService)),ve.set(De.IWorkspacesHistoryMainService,new O.SyncDescriptor(De.WorkspacesHistoryMainService)),ve.set(Q.IMenubarMainService,new O.SyncDescriptor(Q.MenubarMainService)),ve.set(_.IExtensionUrlTrustService,new O.SyncDescriptor(j.ExtensionUrlTrustService)),ve.set(de.IStorageMainService,new O.SyncDescriptor(de.StorageMainService)),d.isWindows?ve.set($.IExternalTerminalMainService,new O.SyncDescriptor(B.WindowsExternalTerminalService)):d.isMacintosh?ve.set($.IExternalTerminalMainService,new O.SyncDescriptor(B.MacExternalTerminalService)):d.isLinux&&ve.set($.IExternalTerminalMainService,new O.SyncDescriptor(B.LinuxExternalTerminalService));const Ie=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(l.IBackupMainService,Ie),ve.set(Ze.IURLService,new O.SyncDescriptor(Ye.NativeURLService)),(0,ke.getTelemetryLevel)(this.productService,this.environmentMainService)>=2){const Le=(0,c.getDelayedChannel)(Ee.then(Ke=>Ke.getChannel("telemetryAppender"))),Me=new me.TelemetryAppenderClient(Le),Re=(0,Pe.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:Me,commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};ve.set(pe.ITelemetryService,new O.SyncDescriptor(be.TelemetryService,[$e]))}else ve.set(pe.ITelemetryService,ke.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(he,Se,Ee){const ve=c.ProxyChannel.fromService(he.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve),Se.registerChannel(D.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ue.UpdateChannel(he.get(Ae.IUpdateService));Se.registerChannel("update",Ie);const Le=c.ProxyChannel.fromService(he.get(A.IIssueMainService));Se.registerChannel("issue",Le);const Me=c.ProxyChannel.fromService(he.get(ne.IEncryptionMainService));Se.registerChannel("encryption",Me);const Re=c.ProxyChannel.fromService(he.get(oe.ISignService));Se.registerChannel("sign",Re);const Te=c.ProxyChannel.fromService(he.get(W.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Te),this.nativeHostMainService=he.get(J.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",$e),Ee.then(qe=>qe.registerChannel("nativeHost",$e));const Ke=c.ProxyChannel.fromService(he.get(ye.IWorkspacesService));Se.registerChannel("workspaces",Ke);const et=c.ProxyChannel.fromService(he.get(Q.IMenubarMainService));Se.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(he.get(Ze.IURLService));Se.registerChannel("url",tt);const ht=c.ProxyChannel.fromService(he.get(_.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",ht);const _e=c.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));Se.registerChannel("webview",_e);const it=this._register(new fe.StorageDatabaseChannel(this.logService,he.get(de.IStorageMainService)));Se.registerChannel("storage",it),Ee.then(qe=>qe.registerChannel("storage",it));const nt=c.ProxyChannel.fromService(he.get($.IExternalTerminalMainService));Se.registerChannel("externalTerminal",nt);const Xe=new N.LogLevelChannel(he.get(U.ILogService));Se.registerChannel("logLevel",Xe),Ee.then(qe=>qe.registerChannel("logLevel",Xe));const rt=new N.LoggerChannel(he.get(U.ILoggerService));Se.registerChannel("logger",rt),Ee.then(qe=>qe.registerChannel("logger",rt));const at=new R.ElectronExtensionHostDebugBroadcastChannel(he.get(se.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",at)}openFirstWindow(he,Se){const Ee=this.windowsMainService=he.get(se.IWindowsMainService),ve=he.get(Ze.IURLService),Ie=he.get(J.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:S.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Re=this,Te=this.environmentMainService,$e=this.productService;ve.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:S.URI.parse(Oe.query).path,query:""})),Re.shouldBlockURI(Oe))return!0;const vt=Re.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=Ee.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&Ee.getWindowCount()===0){const[ft]=Ee.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,le.getRemoteAuthority)(Oe)});return await ft.ready(),ve.open(Oe,Qe)}return!1}});const Ke=this._register(new we.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=Se.getChannel("urlHandler",tt);ve.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(Me,ve,Ee,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,K.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],qe=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?S.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?Ee.open({context:nt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?Ee.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:qe,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?Ee.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:qe,waitMarkerFileURI:dt,initialStartup:!0}):Ee.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:qe,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===b.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,t.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===b.Schemas.file)return{fileUri:S.URI.file(he.fsPath)};if(he.authority===b.Schemas.vscodeRemote){const Se=he.path.indexOf(v.posix.sep,1);if(Se!==-1){const Ee=he.path.substring(1,Se),ve=he.path.substring(Se),Ie=S.URI.from({scheme:b.Schemas.vscodeRemote,authority:Ee,path:ve,query:he.query,fragment:he.fragment});return(0,ye.hasWorkspaceFileExtension)(ve)?{workspaceUri:Ie}:/:[\d]+$/.test(ve)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,L.statSync)(he).isDirectory())return{folderUri:S.URI.file(he)};if((0,ye.hasWorkspaceFileExtension)(he))return{workspaceUri:S.URI.file(he)}}catch(Se){}return{fileUri:S.URI.file(he)}}async afterWindowOpen(he,Se){this.lifecycleMainService.phase=3;let Ee=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const ve=he.get(pe.ITelemetryService);this._register(Se.onDidError(({type:Me,details:Re})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Te)),ve.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:Se.isVisible(),shuttingdown:Ee})}));const Ie=this.productService.win32MutexName;if(d.isWindows&&Ie)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const Le=he.get(Ae.IUpdateService);(Le instanceof st.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof Ce.DarwinUpdateService)&&Le.initialize(),(0,ee.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Re))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],tt=Re.substring(0,Re.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(tt))}}catch(Me){this.logService.error(Me)}}stopTracingEventually(he,Se){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=he.get(C.IDialogMainService);let ve=!1;const Ie=async Me=>{if(ve)return;ve=!0;const Re=await p.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Re),buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Ie(!0),3e4);Promise.all(Se.map(Me=>Me.ready())).then(()=>{clearTimeout(Le),Ie(!1)})}};Ne=ue([te(2,H.IInstantiationService),te(3,U.ILogService),te(4,ae.IEnvironmentMainService),te(5,X.ILifecycleMainService),te(6,y.IConfigurationService),te(7,ge.IStateMainService),te(8,q.IFileService),te(9,re.IProductService)],Ne),e.CodeApplication=Ne}),define(Z[242],x([0,1,14,32,30,9,68,17,31,43,34,10,8,73,3,33,25,19,35,56,238,11,16,189,198,24,54,161,20,183,184,70,174,72,22,92,6,181,93,45,21,55,186,95,222,50,224,75,195,39,226,60,61,204]),function(V,e,p,L,M,k,E,n,f,w,t,I,b,v,d,g,P,S,u,h,o,c,i,a,r,s,l,m,y,D,R,F,C,G,ne,ae,K,ee,_,j,$,B,q,O,H,T,A,W,z,X,U,N,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(ie){console.error(ie.message),p.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(me=>console.error(me));const[ie,oe,ge,fe,de,Pe,pe]=this.createServices();try{try{await this.initServices(ge,fe,de)}catch(me){throw this.handleStartupDataDirError(ge,pe.nameLong,me),me}await ie.invokeFunction(async me=>{const be=me.get(K.ILogService),ke=me.get(ne.ILifecycleMainService),Ae=me.get(y.IFileService),Ue=await this.claimInstance(be,ge,ke,ie,pe,!0);return S.Promises.writeFile(ge.mainLockfile,String(process.pid)).catch(Ce=>{be.warn(`Error writing main lockfile: ${Ce.stack}`)}),Pe.logger=new _.SpdLogLogger("main",(0,b.join)(ge.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(ke.onWillShutdown)(Ce=>{Ae.dispose(),fe.dispose(),Ce.join(S.Promises.unlink(ge.mainLockfile).catch(()=>{}))}),ie.createInstance(o.CodeApplication,Ue,oe).startup()})}catch(me){ie.invokeFunction(this.quit,me)}}createServices(){const ie=new G.ServiceCollection,oe={_serviceBrand:void 0,...j.default};ie.set($.IProductService,oe);const ge=new s.EnvironmentMainService(this.resolveArgs(),oe),fe=this.patchEnvironment(ge);ie.set(s.IEnvironmentMainService,ge);const de=new ae.BufferLogService,Pe=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ge)),de]);process.once("exit",()=>Pe.dispose()),ie.set(K.ILogService,Pe);const pe=new D.FileService(Pe);ie.set(y.IFileService,pe);const me=new R.DiskFileSystemProvider(Pe);pe.registerProvider(I.Schemas.file,me),ie.set(K.ILoggerService,new ee.LoggerService(Pe,pe));const be=new a.ConfigurationService(ge.settingsResource,pe);ie.set(i.IConfigurationService,be),ie.set(ne.ILifecycleMainService,new F.SyncDescriptor(ne.LifecycleMainService));const ke=new U.StateMainService(ge,Pe,pe);return ie.set(X.IStateMainService,ke),ie.set(T.IRequestService,new F.SyncDescriptor(A.RequestMainService)),ie.set(Q.IThemeMainService,new F.SyncDescriptor(Q.ThemeMainService)),ie.set(W.ISignService,new F.SyncDescriptor(z.SignService)),ie.set(O.ITunnelService,new F.SyncDescriptor(H.TunnelService)),ie.set(B.IProtocolMainService,new F.SyncDescriptor(q.ProtocolMainService)),[new C.InstantiationService(ie,!0),fe,ge,be,ke,de,oe]}patchEnvironment(ie){const oe={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ge=>{const fe=process.env[ge];typeof fe=="string"&&(oe[ge]=fe)}),Object.assign(process.env,oe),oe}initServices(ie,oe,ge){return k.Promises.settled([Promise.all([ie.extensionsPath,ie.codeCachePath,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(fe=>fe?S.Promises.mkdir(fe,{recursive:!0}):void 0)),oe.initialize(),ge.init()])}async claimInstance(ie,oe,ge,fe,de,Pe){let pe;try{(0,v.mark)("code/willStartMainServer"),pe=await(0,h.serve)(oe.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,w.once)(ge.onWillShutdown)(()=>pe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(oe,de.nameLong,me),me;let be;try{be=await(0,h.connect)(oe.mainIPCHandle,"main")}catch(Ue){if(!Pe||d.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,de.nameShort),(0,c.localize)(1,null),de.nameLong),Ue;try{(0,L.unlinkSync)(oe.mainIPCHandle)}catch(Ce){throw ie.warn("Could not delete obsolete instance handle",Ce),Ce}return this.claimInstance(ie,oe,ge,fe,de,!1)}if(oe.extensionTestsLocationURI&&!oe.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ie.error(Ue),be.dispose(),new Error(Ue)}let ke;!oe.args.wait&&!oe.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,de.nameShort),(0,c.localize)(3,null),de.nameLong)},1e4));const Ae=u.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(oe.args.status)return fe.invokeFunction(async()=>{const Ue=new r.DiagnosticsService(N.NullTelemetryService,de),Ce=await Ae.getMainProcessInfo(),Ge=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ue.getDiagnostics(Ce,Ge);throw console.log(Be),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ie),ie.trace("Sending env to running instance..."),await Ae.start(oe.args,process.env),be.dispose(),ke&&clearTimeout(ke),new n.ExpectedError("Sent env to running instance. Terminating...")}if(oe.args.status)throw ie.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),pe}handleStartupDataDirError(ie,oe,ge){if(ge.code==="EACCES"||ge.code==="EPERM"){const fe=(0,M.coalesce)([ie.userDataPath,ie.extensionsPath,h.XDG_RUNTIME_DIR]).map(de=>(0,t.getPathLabel)(de,ie));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,E.toErrorMessage)(ge),fe.join(`
`)),oe)}}showStartupWarningDialog(ie,oe,ge){p.dialog.showMessageBoxSync({title:ge,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ie,detail:oe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ie,oe){if(d.isWindows){const ge=await ie.getMainProcessId();oe.trace("Sending some foreground love to the running instance:",ge);try{(await new Promise((fe,de)=>{V(["windows-foreground-love"],fe,de)})).allowSetForegroundWindow(ge)}catch(fe){oe.error(fe)}}}quit(ie,oe){const ge=ie.get(K.ILogService),fe=ie.get(ne.ILifecycleMainService);let de=0;oe&&(oe.isExpected?oe.message&&ge.trace(oe.message):(de=1,oe.stack?ge.error(oe.stack):ge.error(`Startup error: ${oe.toString()}`))),fe.kill(de)}resolveArgs(){const ie=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ie.wait&&!ie.waitMarkerFilePath){const oe=(0,m.createWaitMarkerFile)(ie.verbose);oe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",oe),ie.waitMarkerFilePath=oe)}return ie}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const oe=this.doValidatePaths(ie._,ie.goto);ie._=oe}return ie}doValidatePaths(ie,oe){const ge=(0,g.cwd)(),fe=ie.map(pe=>{let me=String(pe),be;oe&&(be=(0,f.parseLineAndColumnAware)(me),me=be.path),me&&(me=this.preparePath(ge,me));const ke=(0,f.sanitizeFilePath)(me,ge),Ae=(0,b.basename)(ke);return Ae&&!(0,f.isValidBasename)(Ae)?null:oe&&be?(be.path=ke,this.toPath(be)):ke}),de=d.isWindows||d.isMacintosh,Pe=(0,M.distinct)(fe,pe=>pe&&de?pe.toLowerCase():pe||"");return(0,M.coalesce)(Pe)}preparePath(ie,oe){return d.isWindows&&(oe=(0,P.rtrim)(oe,'"')),oe=(0,P.trim)((0,P.trim)(oe," "),"	"),d.isWindows&&(oe=(0,b.resolve)(ie,oe),oe=(0,P.rtrim)(oe,".")),oe}toPath(ie){const oe=[ie.path];return typeof ie.line=="number"&&oe.push(String(ie.line)),typeof ie.column=="number"&&oe.push(String(ie.column)),oe.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1b9403cd461c9c975bcb9e48d84ba9e4ea86559e/core/vs/code/electron-main/main.js.map
