/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/argvHelper","vs/base/node/watcher","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function($){for(var t=[],O=0,b=$.length;O<b;O++)t[O]=Z[$[O]];return t};define(Z[58],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function O(b,y){if(!b)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}t.ok=O}),define(Z[45],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function O(D){return(T,c,g)=>{let m=null,P=null;if(typeof g.value=="function"?(m="value",P=g.value):typeof g.get=="function"&&(m="get",P=g.get),!P)throw new Error("not supported");g[m]=D(P,c)}}t.createDecorator=O;function b(D,T,c){let g=null,m=null;if(typeof c.value=="function"?(g="value",m=c.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",m=c.get),!m)throw new Error("not supported");const P=`$memoize$${T}`;c[g]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[P]}}t.memoize=b;function y(D,T,c){return O((g,m)=>{const P=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...R){this[d]||(this[d]=c?c():void 0),clearTimeout(this[P]),T&&(this[d]=T(this[d],...R),R=[this[d]]),this[P]=setTimeout(()=>{g.apply(this,R),this[d]=c?c():void 0},D)}})}t.debounce=y;function I(D,T,c){return O((g,m)=>{const P=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,R=`$throttle$lastRun$${m}`,u=`$throttle$pending$${m}`;return function(...l){if(this[d]||(this[d]=c?c():void 0),(this[R]===null||this[R]===void 0)&&(this[R]=-Number.MAX_VALUE),T&&(this[d]=T(this[d],...l)),this[u])return;const S=this[R]+D;S<=Date.now()?(this[R]=Date.now(),g.apply(this,[this[d]]),this[d]=c?c():void 0):(this[u]=!0,this[P]=setTimeout(()=>{this[u]=!1,this[R]=Date.now(),g.apply(this,[this[d]]),this[d]=c?c():void 0},S-Date.now()))}})}t.throttle=I}),define(Z[59],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var O;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(O=t.ScanError||(t.ScanError={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b=t.SyntaxKind||(t.SyntaxKind={}));var y;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(y=t.ParseErrorCode||(t.ParseErrorCode={}));var I;(function(e){e.DEFAULT={allowTrailingComma:!0}})(I=t.ParseOptions||(t.ParseOptions={}));function D(e,i=!1){let n=0,r=e.length,a="",v=0,w=16,F=0;function p(ee){let ue=0,ce=0;for(;ue<ee;){const G=e.charCodeAt(n);if(G>=48&&G<=57)ce=ce*16+G-48;else if(G>=65&&G<=70)ce=ce*16+G-65+10;else if(G>=97&&G<=102)ce=ce*16+G-97+10;else break;n++,ue++}return ue<ee&&(ce=-1),ce}function C(ee){n=ee,a="",v=0,w=16,F=0}function N(){const ee=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&g(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&g(e.charCodeAt(n)))for(n++;n<e.length&&g(e.charCodeAt(n));)n++;else return F=3,e.substring(ee,n);let ue=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&g(e.charCodeAt(n))){for(n++;n<e.length&&g(e.charCodeAt(n));)n++;ue=n}else F=3;return e.substring(ee,ue)}function V(){let ee="",ue=n;for(;;){if(n>=r){ee+=e.substring(ue,n),F=2;break}const ce=e.charCodeAt(n);if(ce===34){ee+=e.substring(ue,n),n++;break}if(ce===92){if(ee+=e.substring(ue,n),n++,n>=r){F=2;break}switch(e.charCodeAt(n++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const ne=p(4);ne>=0?ee+=String.fromCharCode(ne):F=4;break;default:F=5}ue=n;continue}if(ce>=0&&ce<=31)if(c(ce)){ee+=e.substring(ue,n),F=2;break}else F=6;n++}return ee}function Y(){if(a="",F=0,v=n,n>=r)return v=r,w=17;let ee=e.charCodeAt(n);if(T(ee)){do n++,a+=String.fromCharCode(ee),ee=e.charCodeAt(n);while(T(ee));return w=15}if(c(ee))return n++,a+=String.fromCharCode(ee),ee===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),w=14;switch(ee){case 123:return n++,w=1;case 125:return n++,w=2;case 91:return n++,w=3;case 93:return n++,w=4;case 58:return n++,w=6;case 44:return n++,w=5;case 34:return n++,a=V(),w=10;case 47:const ue=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!c(e.charCodeAt(n));)n++;return a=e.substring(ue,n),w=12}if(e.charCodeAt(n+1)===42){n+=2;const ce=r-1;let G=!1;for(;n<ce;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,F=1),a=e.substring(ue,n),w=13}return a+=String.fromCharCode(ee),n++,w=16;case 45:if(a+=String.fromCharCode(ee),n++,n===r||!g(e.charCodeAt(n)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),w=11;default:for(;n<r&&ie(ee);)n++,ee=e.charCodeAt(n);if(v!==n){switch(a=e.substring(v,n),a){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return a+=String.fromCharCode(ee),n++,w=16}}function ie(ee){if(T(ee)||c(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ee;do ee=Y();while(ee>=12&&ee<=15);return ee}return{setPosition:C,getPosition:()=>n,scan:i?oe:Y,getToken:()=>w,getTokenValue:()=>a,getTokenOffset:()=>v,getTokenLength:()=>n-v,getTokenError:()=>F}}t.createScanner=D;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var m;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(m||(m={}));function P(e,i){const n=[],r=new Object;let a;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function F(p,C,N,V){v.value=p,v.offset=C,v.length=N,v.type=V,v.colonOffset=void 0,a=v}try{f(e,{onObjectBegin:(p,C)=>{if(i<=p)throw r;a=void 0,w=i>p,n.push("")},onObjectProperty:(p,C,N)=>{if(i<C||(F(p,C,N,"property"),n[n.length-1]=p,i<=C+N))throw r},onObjectEnd:(p,C)=>{if(i<=p)throw r;a=void 0,n.pop()},onArrayBegin:(p,C)=>{if(i<=p)throw r;a=void 0,n.push(0)},onArrayEnd:(p,C)=>{if(i<=p)throw r;a=void 0,n.pop()},onLiteralValue:(p,C,N)=>{if(i<C||(F(p,C,N,s(p)),i<=C+N))throw r},onSeparator:(p,C,N)=>{if(i<=C)throw r;if(p===":"&&a&&a.type==="property")a.colonOffset=C,w=!1,a=void 0;else if(p===","){const V=n[n.length-1];typeof V=="number"?n[n.length-1]=V+1:(w=!0,n[n.length-1]=""),a=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:a,isAtPropertyKey:w,matches:p=>{let C=0;for(let N=0;C<p.length&&N<n.length;N++)if(p[C]===n[N]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}t.getLocation=P;function d(e,i=[],n=I.DEFAULT){let r=null,a=[];const v=[];function w(p){Array.isArray(a)?a.push(p):r!==null&&(a[r]=p)}return f(e,{onObjectBegin:()=>{const p={};w(p),v.push(a),a=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{a=v.pop()},onArrayBegin:()=>{const p=[];w(p),v.push(a),a=p,r=null},onArrayEnd:()=>{a=v.pop()},onLiteralValue:w,onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},n),a[0]}t.parse=d;function R(e,i=[],n=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function v(p){return r.children.push(p),p}f(e,{onObjectBegin:p=>{r=v({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,C,N)=>{r=v({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:C,length:N,parent:r})},onObjectEnd:(p,C)=>{r.length=p+C-r.offset,r=r.parent,a(p+C)},onArrayBegin:(p,C)=>{r=v({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,C)=>{r.length=p+C-r.offset,r=r.parent,a(p+C)},onLiteralValue:(p,C,N)=>{v({type:s(p),offset:C,length:N,parent:r,value:p}),a(C+N)},onSeparator:(p,C,N)=>{r.type==="property"&&(p===":"?r.colonOffset=C:p===","&&a(C))},onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},n);const F=r.children[0];return F&&delete F.parent,F}t.parseTree=R;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const v of n.children)if(Array.isArray(v.children)&&v.children[0].value===r){n=v.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function l(e){if(!e.parent||!e.parent.children)return[];const i=l(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=l;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function E(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=E;function h(e,i,n=!1){if(E(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const v=h(r[a],i,n);if(v)return v}return e}}t.findNodeAtOffset=h;function f(e,i,n=I.DEFAULT){const r=D(e,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function v(B){return B?J=>B(J,r.getTokenOffset(),r.getTokenLength()):()=>!0}const w=a(i.onObjectBegin),F=v(i.onObjectProperty),p=a(i.onObjectEnd),C=a(i.onArrayBegin),N=a(i.onArrayEnd),V=v(i.onLiteralValue),Y=v(i.onSeparator),ie=a(i.onComment),oe=v(i.onError),ee=n&&n.disallowComments,ue=n&&n.allowTrailingComma;function ce(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ee||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:ee?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,J=[],q=[]){if(oe(B),J.length+q.length>0){let k=r.getToken();for(;k!==17;){if(J.indexOf(k)!==-1){ce();break}else if(q.indexOf(k)!==-1)break;k=ce()}}}function ne(B){const J=r.getTokenValue();return B?V(J):F(J),ce(),!0}function z(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch(J){G(2)}V(B);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return ce(),!0}function L(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(Y(":"),ce(),K()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function M(){w(),ce();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ce(),r.getToken()===2&&ue)break}else B&&G(6,[],[]);L()||G(4,[],[2,5]),B=!0}return p(),r.getToken()!==2?G(7,[2],[]):ce(),!0}function U(){C(),ce();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ce(),r.getToken()===4&&ue)break}else B&&G(6,[],[]);K()||G(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?G(8,[4],[]):ce(),!0}function K(){switch(r.getToken()){case 3:return U();case 1:return M();case 10:return ne(!0);default:return z()}}return ce(),r.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):K()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=f;function o(e,i){let n=D(e),r=[],a,v=0,w;do switch(w=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:v!==w&&r.push(e.substring(v,w)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),v=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(y){const I=[];typeof y=="number"&&I.push("code/timeOrigin",y);function D(c){I.push(c,Date.now())}function T(){const c=[];for(let g=0;g<I.length;g+=2)c.push({name:I[g],startTime:I[g+1]});return c}return{mark:D,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(y+D.startTime)});return I}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function O(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=t()),y.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=O(b))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var O=t();for(var b in O)(typeof exports=="object"?exports:$)[b]=O[b]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function O(b){if(t[b])return t[b].exports;var y=t[b]={i:b,l:!1,exports:{}};return $[b].call(y.exports,y,y.exports,O),y.l=!0,y.exports}return O.m=$,O.c=t,O.d=function(b,y,I){O.o(b,y)||Object.defineProperty(b,y,{enumerable:!0,get:I})},O.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},O.t=function(b,y){if(1&y&&(b=O(b)),8&y||4&y&&typeof b=="object"&&b&&b.__esModule)return b;var I=Object.create(null);if(O.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:b}),2&y&&typeof b!="string")for(var D in b)O.d(I,D,function(T){return b[T]}.bind(null,D));return I},O.n=function(b){var y=b&&b.__esModule?function(){return b.default}:function(){return b};return O.d(y,"a",y),y},O.o=function(b,y){return Object.prototype.hasOwnProperty.call(b,y)},O.p="",O(O.s=0)}([function($,t,O){(function(b){var y;t=$.exports=q,y=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],c=t.src=[],g=0,m=g++;c[m]="0|[1-9]\\d*";var P=g++;c[P]="[0-9]+";var d=g++;c[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var R=g++;c[R]="("+c[m]+")\\.("+c[m]+")\\.("+c[m]+")";var u=g++;c[u]="("+c[P]+")\\.("+c[P]+")\\.("+c[P]+")";var l=g++;c[l]="(?:"+c[m]+"|"+c[d]+")";var S=g++;c[S]="(?:"+c[P]+"|"+c[d]+")";var E=g++;c[E]="(?:-("+c[l]+"(?:\\."+c[l]+")*))";var h=g++;c[h]="(?:-?("+c[S]+"(?:\\."+c[S]+")*))";var f=g++;c[f]="[0-9A-Za-z-]+";var o=g++;c[o]="(?:\\+("+c[f]+"(?:\\."+c[f]+")*))";var s=g++,e="v?"+c[R]+c[E]+"?"+c[o]+"?";c[s]="^"+e+"$";var i="[v=\\s]*"+c[u]+c[h]+"?"+c[o]+"?",n=g++;c[n]="^"+i+"$";var r=g++;c[r]="((?:<|>)?=?)";var a=g++;c[a]=c[P]+"|x|X|\\*";var v=g++;c[v]=c[m]+"|x|X|\\*";var w=g++;c[w]="[v=\\s]*("+c[v]+")(?:\\.("+c[v]+")(?:\\.("+c[v]+")(?:"+c[E]+")?"+c[o]+"?)?)?";var F=g++;c[F]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[h]+")?"+c[o]+"?)?)?";var p=g++;c[p]="^"+c[r]+"\\s*"+c[w]+"$";var C=g++;c[C]="^"+c[r]+"\\s*"+c[F]+"$";var N=g++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=g++;c[V]="(?:~>?)";var Y=g++;c[Y]="(\\s*)"+c[V]+"\\s+",T[Y]=new RegExp(c[Y],"g");var ie=g++;c[ie]="^"+c[V]+c[w]+"$";var oe=g++;c[oe]="^"+c[V]+c[F]+"$";var ee=g++;c[ee]="(?:\\^)";var ue=g++;c[ue]="(\\s*)"+c[ee]+"\\s+",T[ue]=new RegExp(c[ue],"g");var ce=g++;c[ce]="^"+c[ee]+c[w]+"$";var G=g++;c[G]="^"+c[ee]+c[F]+"$";var ne=g++;c[ne]="^"+c[r]+"\\s*("+i+")$|^$";var z=g++;c[z]="^"+c[r]+"\\s*("+e+")$|^$";var L=g++;c[L]="(\\s*)"+c[r]+"\\s*("+i+"|"+c[w]+")",T[L]=new RegExp(c[L],"g");var M=g++;c[M]="^\\s*("+c[w]+")\\s+-\\s+("+c[w]+")\\s*$";var U=g++;c[U]="^\\s*("+c[F]+")\\s+-\\s+("+c[F]+")\\s*$";var K=g++;c[K]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)y(B,c[B]),T[B]||(T[B]=new RegExp(c[B]));function J(x,_){if(x instanceof q)return x;if(typeof x!="string"||x.length>I||!(_?T[n]:T[s]).test(x))return null;try{return new q(x,_)}catch(H){return null}}function q(x,_){if(x instanceof q){if(x.loose===_)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof q))return new q(x,_);y("SemVer",x,_),this.loose=_;var H=x.trim().match(_?T[n]:T[s]);if(!H)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var he=+ae;if(he>=0&&he<D)return he}return ae}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=J,t.valid=function(x,_){var H=J(x,_);return H?H.version:null},t.clean=function(x,_){var H=J(x.trim().replace(/^[=v]+/,""),_);return H?H.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(x){return y("SemVer.compare",this.version,this.loose,x),x instanceof q||(x=new q(x,this.loose)),this.compareMain(x)||this.comparePre(x)},q.prototype.compareMain=function(x){return x instanceof q||(x=new q(x,this.loose)),A(this.major,x.major)||A(this.minor,x.minor)||A(this.patch,x.patch)},q.prototype.comparePre=function(x){if(x instanceof q||(x=new q(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var _=0;do{var H=this.prerelease[_],ae=x.prerelease[_];if(y("prerelease compare",_,H,ae),H===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(H===void 0)return-1;if(H!==ae)return A(H,ae)}while(++_)},q.prototype.inc=function(x,_){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,_,H,ae){typeof H=="string"&&(ae=H,H=void 0);try{return new q(x,H).inc(_,ae).version}catch(he){return null}},t.diff=function(x,_){if(Q(x,_))return null;var H=J(x),ae=J(_);if(H.prerelease.length||ae.prerelease.length){for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==ae[he])return"pre"+he;return"prerelease"}for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==ae[he])return he},t.compareIdentifiers=A;var k=/^[0-9]+$/;function A(x,_){var H=k.test(x),ae=k.test(_);return H&&ae&&(x=+x,_=+_),H&&!ae?-1:ae&&!H?1:x<_?-1:x>_?1:0}function j(x,_,H){return new q(x,H).compare(new q(_,H))}function W(x,_,H){return j(x,_,H)>0}function X(x,_,H){return j(x,_,H)<0}function Q(x,_,H){return j(x,_,H)===0}function se(x,_,H){return j(x,_,H)!==0}function re(x,_,H){return j(x,_,H)>=0}function me(x,_,H){return j(x,_,H)<=0}function Ee(x,_,H,ae){var he;switch(_){case"===":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x===H;break;case"!==":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x!==H;break;case"":case"=":case"==":he=Q(x,H,ae);break;case"!=":he=se(x,H,ae);break;case">":he=W(x,H,ae);break;case">=":he=re(x,H,ae);break;case"<":he=X(x,H,ae);break;case"<=":he=me(x,H,ae);break;default:throw new TypeError("Invalid operator: "+_)}return he}function fe(x,_){if(x instanceof fe){if(x.loose===_)return x;x=x.value}if(!(this instanceof fe))return new fe(x,_);y("comparator",x,_),this.loose=_,this.parse(x),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}t.rcompareIdentifiers=function(x,_){return A(_,x)},t.major=function(x,_){return new q(x,_).major},t.minor=function(x,_){return new q(x,_).minor},t.patch=function(x,_){return new q(x,_).patch},t.compare=j,t.compareLoose=function(x,_){return j(x,_,!0)},t.rcompare=function(x,_,H){return j(_,x,H)},t.sort=function(x,_){return x.sort(function(H,ae){return t.compare(H,ae,_)})},t.rsort=function(x,_){return x.sort(function(H,ae){return t.rcompare(H,ae,_)})},t.gt=W,t.lt=X,t.eq=Q,t.neq=se,t.gte=re,t.lte=me,t.cmp=Ee,t.Comparator=fe;var Ie={};function pe(x,_){if(x instanceof pe)return x.loose===_?x:new pe(x.raw,_);if(x instanceof fe)return new pe(x.value,_);if(!(this instanceof pe))return new pe(x,_);if(this.loose=_,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ye(x){return!x||x.toLowerCase()==="x"||x==="*"}function Ae(x,_,H,ae,he,Te,we,Oe,Pe,Ce,Ne,Re,Le){return((_=ye(H)?"":ye(ae)?">="+H+".0.0":ye(he)?">="+H+"."+ae+".0":">="+_)+" "+(Oe=ye(Pe)?"":ye(Ce)?"<"+(+Pe+1)+".0.0":ye(Ne)?"<"+Pe+"."+(+Ce+1)+".0":Re?"<="+Pe+"."+Ce+"."+Ne+"-"+Re:"<="+Oe)).trim()}function Me(x,_){for(var H=0;H<x.length;H++)if(!x[H].test(_))return!1;if(_.prerelease.length){for(H=0;H<x.length;H++)if(y(x[H].semver),x[H].semver!==Ie&&x[H].semver.prerelease.length>0){var ae=x[H].semver;if(ae.major===_.major&&ae.minor===_.minor&&ae.patch===_.patch)return!0}return!1}return!0}function Ue(x,_,H){try{_=new pe(_,H)}catch(ae){return!1}return _.test(x)}function ze(x,_,H,ae){var he,Te,we,Oe,Pe;switch(x=new q(x,ae),_=new pe(_,ae),H){case">":he=W,Te=me,we=X,Oe=">",Pe=">=";break;case"<":he=X,Te=re,we=W,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,_,ae))return!1;for(var Ce=0;Ce<_.set.length;++Ce){var Ne=_.set[Ce],Re=null,Le=null;if(Ne.forEach(function(Fe){Fe.semver===Ie&&(Fe=new fe(">=0.0.0")),Re=Re||Fe,Le=Le||Fe,he(Fe.semver,Re.semver,ae)?Re=Fe:we(Fe.semver,Le.semver,ae)&&(Le=Fe)}),Re.operator===Oe||Re.operator===Pe||(!Le.operator||Le.operator===Oe)&&Te(x,Le.semver)||Le.operator===Pe&&we(x,Le.semver))return!1}return!0}fe.prototype.parse=function(x){var _=this.loose?T[ne]:T[z],H=x.match(_);if(!H)throw new TypeError("Invalid comparator: "+x);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new q(H[2],this.loose):this.semver=Ie},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(x){return y("Comparator.test",x,this.loose),this.semver===Ie||(typeof x=="string"&&(x=new q(x,this.loose)),Ee(x,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(x,_){if(!(x instanceof fe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new pe(x.value,_),Ue(this.value,H,_);if(x.operator==="")return H=new pe(this.value,_),Ue(x.semver,H,_);var ae=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Te=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=Ee(this.semver,"<",x.semver,_)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Pe=Ee(this.semver,">",x.semver,_)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ae||he||Te&&we||Oe||Pe},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(x){var _=this.loose;x=x.trim(),y("range",x,_);var H=_?T[U]:T[M];x=x.replace(H,Ae),y("hyphen replace",x),x=x.replace(T[L],"$1$2$3"),y("comparator trim",x,T[L]),x=(x=(x=x.replace(T[Y],"$1~")).replace(T[ue],"$1^")).split(/\s+/).join(" ");var ae=_?T[ne]:T[z],he=x.split(" ").map(function(Te){return function(we,Oe){return y("comp",we),we=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(Re,Le){y("caret",Re,Le);var Fe=Le?T[G]:T[ce];return Re.replace(Fe,function(ke,ge,ve,Se,be){var De;return y("caret",Re,ke,ge,ve,Se,be),ye(ge)?De="":ye(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":ye(Se)?De=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(y("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+be+" <"+(+ge+1)+".0.0"):(y("no pr"),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),y("caret return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),y("caret",we),we=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(Re,Le){var Fe=Le?T[oe]:T[ie];return Re.replace(Fe,function(ke,ge,ve,Se,be){var De;return y("tilde",Re,ke,ge,ve,Se,be),ye(ge)?De="":ye(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":ye(Se)?De=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(y("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0"):De=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",y("tilde return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),y("tildes",we),we=function(Pe,Ce){return y("replaceXRanges",Pe,Ce),Pe.split(/\s+/).map(function(Ne){return function(Re,Le){Re=Re.trim();var Fe=Le?T[C]:T[p];return Re.replace(Fe,function(ke,ge,ve,Se,be,De){y("xRange",Re,ke,ge,ve,Se,be,De);var je=ye(ve),We=je||ye(Se),Ve=We||ye(be);return ge==="="&&Ve&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ve?(We&&(Se=0),Ve&&(be=0),ge===">"?(ge=">=",We?(ve=+ve+1,Se=0,be=0):Ve&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",We?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+be):We?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ve&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),y("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(we,Oe),y("xrange",we),we=function(Pe,Ce){return y("replaceStars",Pe,Ce),Pe.trim().replace(T[K],"")}(we,Oe),y("stars",we),we}(Te,_)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Te){return!!Te.match(ae)})),he=he.map(function(Te){return new fe(Te,_)})},pe.prototype.intersects=function(x,_){if(!(x instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ae){return x.set.some(function(he){return he.every(function(Te){return ae.intersects(Te,_)})})})})},t.toComparators=function(x,_){return new pe(x,_).set.map(function(H){return H.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new q(x,this.loose));for(var _=0;_<this.set.length;_++)if(Me(this.set[_],x))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(x,_,H){var ae=null,he=null;try{var Te=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Te.test(we)&&(ae&&he.compare(we)!==-1||(he=new q(ae=we,H)))}),ae},t.minSatisfying=function(x,_,H){var ae=null,he=null;try{var Te=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Te.test(we)&&(ae&&he.compare(we)!==1||(he=new q(ae=we,H)))}),ae},t.validRange=function(x,_){try{return new pe(x,_).range||"*"}catch(H){return null}},t.ltr=function(x,_,H){return ze(x,_,"<",H)},t.gtr=function(x,_,H){return ze(x,_,">",H)},t.outside=ze,t.prerelease=function(x,_){var H=J(x,_);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(x,_,H){return x=new pe(x,H),_=new pe(_,H),x.intersects(_)},t.coerce=function(x){if(x instanceof q)return x;if(typeof x!="string")return null;var _=x.match(T[N]);return _==null?null:J((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,O(1))},function($,t){var O,b,y=$.exports={};function I(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(S){if(O===setTimeout)return setTimeout(S,0);if((O===I||!O)&&setTimeout)return O=setTimeout,setTimeout(S,0);try{return O(S,0)}catch(E){try{return O.call(null,S,0)}catch(h){return O.call(this,S,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:I}catch(S){O=I}try{b=typeof clearTimeout=="function"?clearTimeout:D}catch(S){b=D}})();var c,g=[],m=!1,P=-1;function d(){m&&c&&(m=!1,c.length?g=c.concat(g):P=-1,g.length&&R())}function R(){if(!m){var S=T(d);m=!0;for(var E=g.length;E;){for(c=g,g=[];++P<E;)c&&c[P].run();P=-1,E=g.length}c=null,m=!1,function(h){if(b===clearTimeout)return clearTimeout(h);if((b===D||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(h);try{b(h)}catch(f){try{return b.call(null,h)}catch(o){return b.call(this,h)}}}(S)}}function u(S,E){this.fun=S,this.array=E}function l(){}y.nextTick=function(S){var E=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)E[h-1]=arguments[h];g.push(new u(S,E)),g.length!==1||m||T(R)},u.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=l,y.addListener=l,y.once=l,y.off=l,y.removeListener=l,y.removeAllListeners=l,y.emit=l,y.prependListener=l,y.prependOnceListener=l,y.listeners=function(S){return[]},y.binding=function(S){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(S){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Z[37],te([0,1,9,2]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function y(f){const o=f;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=y;function I(f){const o=f;return o?y(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=I;function D(f,o){return new T(f,o)}t.newWriteableStream=D;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,O.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(f,o){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return o(s)}t.consumeReadable=c;function g(f,o,s){const e=[];let i;for(;(i=f.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=g;function m(f,o){return new Promise((s,e)=>{const i=[];P(f,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=m;function P(f,o){f.on("error",s=>o.onError(s)),f.on("end",()=>o.onEnd()),f.on("data",s=>o.onData(s))}t.listenStream=P;function d(f,o){return new Promise((s,e)=>{const i=new b.DisposableStore,n=[],r=w=>{if(n.push(w),n.length>o)return i.dispose(),f.pause(),s({stream:f,buffer:n,ended:!1})},a=w=>e(w),v=()=>s({stream:f,buffer:n,ended:!0});i.add((0,b.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,b.toDisposable)(()=>f.removeListener("end",v))),f.on("end",v),i.add((0,b.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=d;function R(f,o){const s=D(o);return s.end(f),s}t.toStream=R;function u(){const f=D(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=u;function l(f){let o=!1;return{read:()=>o?null:(o=!0,f)}}t.toReadable=l;function S(f,o,s){const e=D(s);return P(f,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=S;function E(f,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([f,i]):f)}}}t.prefixedReadable=E;function h(f,o,s){let e=!1;const i=D(s);return P(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=h}),define(Z[17],te([0,1,37]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined";let y,I;class D{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return b?new D(Buffer.allocUnsafe(r)):new D(new Uint8Array(r))}static wrap(r){return b&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new D(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&b?new D(Buffer.from(r)):(y||(y=new TextEncoder),new D(y.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let F=0,p=r.length;F<p;F++)a+=r[F].byteLength}const v=D.alloc(a);let w=0;for(let F=0,p=r.length;F<p;F++){const C=r[F];v.set(C,w),w+=C.byteLength}return v}toString(){return b?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(r,a){return new D(this.buffer.subarray(r,a))}set(r,a){r instanceof D?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return g(this.buffer,r)}writeUInt32BE(r,a){m(this.buffer,r,a)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,a){d(this.buffer,r,a)}readUInt8(r){return R(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=D;function T(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=T;function c(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=c;function g(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=g;function m(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=m;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=P;function d(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=d;function R(n,r){return n[r]}t.readUInt8=R;function u(n,r,a){n[a]=r}t.writeUInt8=u;function l(n){return O.consumeReadable(n,r=>D.concat(r))}t.readableToBuffer=l;function S(n){return O.toReadable(n)}t.bufferToReadable=S;function E(n){return O.consumeStream(n,r=>D.concat(r))}t.streamToBuffer=E;async function h(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await E(n.stream)])}t.bufferedStreamToBuffer=h;function f(n){return O.toStream(n,r=>D.concat(r))}t.bufferToStream=f;function o(n){return O.transform(n,{data:r=>typeof r=="string"?D.fromString(r):D.wrap(r)},r=>D.concat(r))}t.streamToBufferReadableStream=o;function s(n){return O.newWriteableStream(r=>D.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return O.prefixedReadable(n,r,a=>D.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return O.prefixedStream(n,r,a=>D.concat(a))}t.prefixedBufferStream=i}),define(Z[18],te([0,1,10]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function b(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const S=Array.isArray(l)?[]:{};return Object.keys(l).forEach(E=>{l[E]&&typeof l[E]=="object"?S[E]=b(l[E]):S[E]=l[E]}),S}t.deepClone=b;function y(l){if(!l||typeof l!="object")return l;const S=[l];for(;S.length>0;){const E=S.shift();Object.freeze(E);for(const h in E)if(I.call(E,h)){const f=E[h];typeof f=="object"&&!Object.isFrozen(f)&&S.push(f)}}return l}t.deepFreeze=y;const I=Object.prototype.hasOwnProperty;function D(l,S){return T(l,S,new Set)}t.cloneAndChange=D;function T(l,S,E){if((0,O.isUndefinedOrNull)(l))return l;const h=S(l);if(typeof h!="undefined")return h;if((0,O.isArray)(l)){const f=[];for(const o of l)f.push(T(o,S,E));return f}if((0,O.isObject)(l)){if(E.has(l))throw new Error("Cannot clone recursive data-structure");E.add(l);const f={};for(let o in l)I.call(l,o)&&(f[o]=T(l[o],S,E));return E.delete(l),f}return l}function c(l,S,E=!0){return(0,O.isObject)(l)?((0,O.isObject)(S)&&Object.keys(S).forEach(h=>{h in l?E&&((0,O.isObject)(l[h])&&(0,O.isObject)(S[h])?c(l[h],S[h],E):l[h]=S[h]):l[h]=S[h]}),l):S}t.mixin=c;function g(l,S){if(l===S)return!0;if(l==null||S===null||S===void 0||typeof l!=typeof S||typeof l!="object"||Array.isArray(l)!==Array.isArray(S))return!1;let E,h;if(Array.isArray(l)){if(l.length!==S.length)return!1;for(E=0;E<l.length;E++)if(!g(l[E],S[E]))return!1}else{const f=[];for(h in l)f.push(h);f.sort();const o=[];for(h in S)o.push(h);if(o.sort(),!g(f,o))return!1;for(E=0;E<f.length;E++)if(!g(l[f[E]],S[f[E]]))return!1}return!0}t.equals=g;function m(l){const S=new Set;return JSON.stringify(l,(E,h)=>{if((0,O.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}t.safeStringify=m;function P(l,S,E){const h=S(l);return typeof h=="undefined"?E:h}t.getOrDefault=P;function d(l,S){const E=Object.create(null);return!l||!S||Object.keys(S).forEach(f=>{const o=l[f],s=S[f];g(o,s)||(E[f]=s)}),E}t.distinct=d;function R(l,S){const E=S.toLowerCase(),h=Object.keys(l).find(f=>f.toLowerCase()===E);return h?l[h]:l[S]}t.getCaseInsensitive=R;function u(l,S){const E=Object.create(null);for(const h of Object.keys(l))S(h,l[h])&&(E[h]=l[h]);return E}t.filter=u}),define(Z[60],te([0,1,7]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function b(g){const m=g;return m&&typeof m.type=="string"&&typeof m.severity=="string"}t.isRemoteConsoleLog=b;function y(g){const m=[];let P;try{const d=JSON.parse(g.arguments),R=d[d.length-1];R&&R.__$stack&&(d.pop(),P=R.__$stack),m.push(...d)}catch(d){m.push("Unable to log remote console arguments",g.arguments)}return{args:m,stack:P}}t.parse=y;function I(g){if(typeof g!="string")return I(y(g).stack);const m=g;if(m){const P=D(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=I;function D(g){if(!g)return g;const m=g.indexOf(`
`);return m===-1?g:g.substring(0,m)}function T(g,m){const{args:P,stack:d}=y(g),R=typeof P[0]=="string"&&P.length===1;let u=D(d);u&&(u=`(${u.trim()})`);let l=[];if(typeof P[0]=="string"?u&&R?l=[`%c[${m}] %c${P[0]} %c${u}`,c("blue"),c(""),c("grey")]:l=[`%c[${m}] %c${P[0]}`,c("blue"),c(""),...P.slice(1)]:l=[`%c[${m}]%`,c("blue"),...P],u&&!R&&l.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,l)}t.log=T;function c(g){return`color: ${g}`}}),define(Z[61],te([0,1,17,22,7]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function I(m){return JSON.stringify(m,c)}t.stringify=I;function D(m){let P=JSON.parse(m);return P=g(P),P}t.parse=D;var T;(function(m){m[m.Uri=1]="Uri",m[m.Regexp=2]="Regexp",m[m.ScmResource=3]="ScmResource",m[m.ScmResourceGroup=4]="ScmResourceGroup",m[m.ScmProvider=5]="ScmProvider",m[m.CommentController=6]="CommentController",m[m.CommentThread=7]="CommentThread",m[m.CommentThreadReply=8]="CommentThreadReply",m[m.CommentNode=9]="CommentNode",m[m.CommentThreadNode=10]="CommentThreadNode",m[m.TimelineActionContext=11]="TimelineActionContext",m[m.NotebookCellActionContext=12]="NotebookCellActionContext",m[m.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function c(m,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,b.regExpFlags)(P)}:P}function g(m,P=0){if(!m||P>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return y.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof O.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let d=0;d<m.length;++d)m[d]=g(m[d],P+1);else for(const d in m)Object.hasOwnProperty.call(m,d)&&(m[d]=g(m[d],P+1))}return m}t.revive=g}),define(Z[62],te([0,1,3,38,46,4,22]),function($,t,O,b,y,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const c="**",g="/",m="[/\\\\]",P="[^/\\\\]",d=/\//g;function R(L){switch(L){case 0:return"";case 1:return`${P}*?`;default:return`(?:${m}|${P}+${m}|${m}${P}+)*?`}}function u(L,M){if(!L)return[];const U=[];let K=!1,B=!1,J="";for(const q of L){switch(q){case M:if(!K&&!B){U.push(J),J="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":B=!0;break;case"]":B=!1;break}J+=q}return J&&U.push(J),U}t.splitGlobAware=u;function l(L){if(!L)return"";let M="";const U=u(L,g);if(U.every(K=>K===c))M=".*";else{let K=!1;U.forEach((B,J)=>{if(B===c){K||(M+=R(2),K=!0);return}let q=!1,k="",A=!1,j="";for(const W of B){if(W!=="}"&&q){k+=W;continue}if(A&&(W!=="]"||!j)){let X;W==="-"?X=W:(W==="^"||W==="!")&&!j?X="^":W===g?X="":X=D.escapeRegExpCharacters(W),j+=X;continue}switch(W){case"{":q=!0;continue;case"[":A=!0;continue;case"}":M+=`(?:${u(k,",").map(se=>l(se)).join("|")})`,q=!1,k="";break;case"]":M+="["+j+"]",A=!1,j="";break;case"?":M+=P;continue;case"*":M+=R(1);continue;default:M+=D.escapeRegExpCharacters(W)}}J<U.length-1&&(U[J+1]!==c||J+2<U.length)&&(M+=m),K=!1})}return M}const S=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new y.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(L,M){if(!L)return n;let U;typeof L!="string"?U=L.pattern:U=L,U=U.trim();const K=`${U}_${!!M.trimForExclusions}`;let B=e.get(K);if(B)return a(B,L);let J;if(S.test(U)){const q=U.substr(4);B=function(k,A){return typeof k=="string"&&k.endsWith(q)?U:null}}else(J=E.exec(v(U,M)))?B=w(J[1],U):(M.trimForExclusions?f:h).test(U)?B=F(U,M):(J=o.exec(v(U,M)))?B=p(J[1].substr(1),U,!0):(J=s.exec(v(U,M)))?B=p(J[1],U,!1):B=C(U);return e.set(K,B),a(B,L)}function a(L,M){return typeof M=="string"?L:function(U,K){return b.isEqualOrParent(U,M.base)?L(I.relative(M.base,U),K):null}}function v(L,M){return M.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function w(L,M){const U=`/${L}`,K=`\\${L}`,B=function(q,k){return typeof q!="string"?null:k?k===L?M:null:q===L||q.endsWith(U)||q.endsWith(K)?M:null},J=[L];return B.basenames=J,B.patterns=[M],B.allBasenames=J,B}function F(L,M){const U=z(L.slice(1,-1).split(",").map(k=>r(k,M)).filter(k=>k!==n),L),K=U.length;if(!K)return n;if(K===1)return U[0];const B=function(k,A){for(let j=0,W=U.length;j<W;j++)if(U[j](k,A))return L;return null},J=U.find(k=>!!k.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((k,A)=>A.allPaths?k.concat(A.allPaths):k,[]);return q.length&&(B.allPaths=q),B}function p(L,M,U){const K=I.sep===I.posix.sep,B=K?L:L.replace(d,I.sep),J=I.sep+B,q=I.posix.sep+L,k=U?function(A,j){return typeof A=="string"&&(A===B||A.endsWith(J)||!K&&(A===L||A.endsWith(q)))?M:null}:function(A,j){return typeof A=="string"&&(A===B||!K&&A===L)?M:null};return k.allPaths=[(U?"*/":"./")+L],k}function C(L){try{const M=new RegExp(`^${l(L)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?L:null}}catch(M){return n}}function N(L,M,U){return!L||typeof M!="string"?!1:V(L)(M,void 0,U)}t.match=N;function V(L,M={}){if(!L)return i;if(typeof L=="string"||ee(L)){const U=r(L,M);if(U===n)return i;const K=function(B,J){return!!U(B,J)};return U.allBasenames&&(K.allBasenames=U.allBasenames),U.allPaths&&(K.allPaths=U.allPaths),K}return G(L,M)}t.parse=V;function Y(L){if(!L)return;let M;return U=>(M||(M=(L()||Promise.resolve([])).then(K=>K?oe(K):{})),M.then(K=>!!K[U]))}t.hasSiblingPromiseFn=Y;function ie(L){if(!L)return;let M;return U=>{if(!M){const K=L();M=K?oe(K):{}}return!!M[U]}}t.hasSiblingFn=ie;function oe(L){const M={};for(const U of L)M[U]=!0;return M}function ee(L){const M=L;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=ee;function ue(L){return L.allBasenames||[]}t.getBasenameTerms=ue;function ce(L){return L.allPaths||[]}t.getPathTerms=ce;function G(L,M){const U=z(Object.getOwnPropertyNames(L).map(k=>ne(k,L[k],M)).filter(k=>k!==n)),K=U.length;if(!K)return n;if(!U.some(k=>!!k.requiresSiblings)){if(K===1)return U[0];const k=function(W,X){for(let Q=0,se=U.length;Q<se;Q++){const re=U[Q](W,X);if(re)return re}return null},A=U.find(W=>!!W.allBasenames);A&&(k.allBasenames=A.allBasenames);const j=U.reduce((W,X)=>X.allPaths?W.concat(X.allPaths):W,[]);return j.length&&(k.allPaths=j),k}const B=function(k,A,j){let W;for(let X=0,Q=U.length;X<Q;X++){const se=U[X];se.requiresSiblings&&j&&(A||(A=I.basename(k)),W||(W=A.substr(0,A.length-I.extname(k).length)));const re=se(k,A,W,j);if(re)return re}return null},J=U.find(k=>!!k.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((k,A)=>A.allPaths?k.concat(A.allPaths):k,[]);return q.length&&(B.allPaths=q),B}function ne(L,M,U){if(M===!1)return n;const K=r(L,U);if(K===n)return n;if(typeof M=="boolean")return K;if(M){const B=M.when;if(typeof B=="string"){const J=(q,k,A,j)=>{if(!j||!K(q,k))return null;const W=B.replace("$(basename)",A),X=j(W);return(0,O.isThenable)(X)?X.then(Q=>Q?L:null):X?L:null};return J.requiresSiblings=!0,J}}return K}function z(L,M){const U=L.filter(k=>!!k.basenames);if(U.length<2)return L;const K=U.reduce((k,A)=>{const j=A.basenames;return j?k.concat(j):k},[]);let B;if(M){B=[];for(let k=0,A=K.length;k<A;k++)B.push(M)}else B=U.reduce((k,A)=>{const j=A.patterns;return j?k.concat(j):k},[]);const J=function(k,A){if(typeof k!="string")return null;if(!A){let W;for(W=k.length;W>0;W--){const X=k.charCodeAt(W-1);if(X===47||X===92)break}A=k.substr(W)}const j=K.indexOf(A);return j!==-1?B[j]:null};J.basenames=K,J.patterns=B,J.allBasenames=K;const q=L.filter(k=>!k.basenames);return q.push(J),q}}),define(Z[63],te([0,1,38,8,4,11,19,22,7]),function($,t,O,b,y,I,D,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(r,a,v){if(typeof r=="string"&&(r=c.URI.file(r)),v){const F=v.getWorkspaceFolder(r);if(F){const p=v.getWorkspace().folders.length>1;let C;if((0,D.isEqual)(F.uri,r)?C="":C=(0,D.relativePath)(F.uri,r),p){const N=F.name?F.name:(0,D.basename)(F.uri);C=C?N+" \u2022 "+C:N}return C}}if(r.scheme!==b.Schemas.file&&r.scheme!==b.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,O.hasDriveLetter)(r.fsPath))return(0,y.normalize)(P(r.fsPath));let w=(0,y.normalize)(r.fsPath);return!I.isWindows&&a?.userHome&&(w=R(w,a.userHome.fsPath)),w}t.getPathLabel=g;function m(r){if(!r)return;typeof r=="string"&&(r=c.URI.file(r));const a=(0,D.basename)(r)||(r.scheme===b.Schemas.file?r.fsPath:r.path);return I.isWindows&&(0,O.isRootOrDriveLetter)(a)?P(a):a}t.getBaseLabel=m;function P(r){return(0,O.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=P;let d=Object.create(null);function R(r,a){if(I.isWindows||!r||!a)return r;let v=d.original===a?d.normalized:void 0;return v||(v=`${(0,T.rtrim)(a,y.posix.sep)}${y.posix.sep}`,d={original:a,normalized:v}),(I.isLinux?r.startsWith(v):(0,T.startsWithIgnoreCase)(r,v))&&(r=`~/${r.substr(v.length)}`),r}t.tildify=R;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const l="\u2026",S="\\\\",E="~";function h(r,a=y.sep){const v=new Array(r.length);let w=!1;for(let F=0;F<r.length;F++){let p=r[F];if(p===""){v[F]=`.${a}`;continue}if(!p){v[F]=p;continue}w=!0;let C="";p.indexOf(S)===0?(C=p.substr(0,p.indexOf(S)+S.length),p=p.substr(p.indexOf(S)+S.length)):p.indexOf(a)===0?(C=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(E)===0&&(C=p.substr(0,p.indexOf(E)+E.length),p=p.substr(p.indexOf(E)+E.length));const N=p.split(a);for(let V=1;w&&V<=N.length;V++)for(let Y=N.length-V;w&&Y>=0;Y--){w=!1;let ie=N.slice(Y,Y+V).join(a);for(let oe=0;!w&&oe<r.length;oe++)if(oe!==F&&r[oe]&&r[oe].indexOf(ie)>-1){const ee=Y+V===N.length,ue=Y>0&&r[oe].indexOf(a)>-1?a+ie:ie,ce=r[oe].endsWith(ue);w=!ee||ce}if(!w){let oe="";(N[0].endsWith(":")||C!=="")&&(Y===1&&(Y=0,V++,ie=N[0]+a+ie),Y>0&&(oe=N[0]+a),oe=C+oe),Y>0&&(oe=oe+l+a),oe=oe+ie,Y+V<N.length&&(oe=oe+a+l),v[F]=oe}}w&&(v[F]=p)}return v}t.shorten=h;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(r,a=Object.create(null)){const v=[];let w=!1,F="";for(const p of r)if(p==="$"||w&&p==="{")F&&v.push({value:F,type:f.TEXT}),F="",w=!0;else if(p==="}"&&w){const C=a[F];if(typeof C=="string")C.length&&v.push({value:C,type:f.VARIABLE});else if(C){const N=v[v.length-1];(!N||N.type!==f.SEPARATOR)&&v.push({value:C.label,type:f.SEPARATOR})}F="",w=!1}else F+=p;return F&&!w&&v.push({value:F,type:f.TEXT}),v.filter((p,C)=>{if(p.type===f.SEPARATOR){const N=v[C-1],V=v[C+1];return[N,V].every(Y=>Y&&(Y.type===f.VARIABLE||Y.type===f.TEXT)&&Y.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function s(r,a){return I.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):r.replace(/&&|&/g,v=>v==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return I.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):I.isWindows?r.replace(/&&|&/g,v=>v==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?y.posix:y.win32,v=a.basename(r),w=a.dirname(r);return v.length?{name:v,parentPath:w}:{name:w,parentPath:""}}t.splitName=n}),define(Z[47],te([0,1,126]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class b{constructor(I="utf8"){this.stringDecoder=new O.StringDecoder(I),this.remaining=null}write(I){const D=[],T=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(T.length<1)return D;let c=0,g,m=c;for(;m<T.length;)if(g=T.charCodeAt(m),g===13||g===10){if(D.push(T.substring(c,m)),m++,m<T.length){const P=g;g=T.charCodeAt(m),(P===13&&g===10||P===10&&g===13)&&m++}c=m}else m++;return this.remaining=c<T.length?T.substr(c):null,D}end(){return this.remaining}}t.LineDecoder=b}),define(Z[64],te([0,1,48,4,22,12]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(m){const P=(0,b.dirname)(m);if(m===P)return m;const d=((0,b.basename)(m)||m).toLowerCase();try{const u=(0,I.readdirSync)(P).filter(l=>l.toLowerCase()===d);if(u.length===1){const l=D(P);if(l)return(0,b.join)(l,u[0])}else if(u.length>1){const l=u.indexOf(d);if(l>=0){const S=D(P);if(S)return(0,b.join)(S,u[l])}}}catch(R){}return null}t.realcaseSync=D;async function T(m){try{return await I.Promises.realpath(m)}catch(P){const d=g(m);return await I.Promises.access(d,O.constants.R_OK),d}}t.realpath=T;function c(m){try{return O.realpathSync(m)}catch(P){const d=g(m);return O.accessSync(d,O.constants.R_OK),d}}t.realpathSync=c;function g(m){return(0,y.rtrim)((0,b.normalize)(m),b.sep)}}),define(Z[65],te([0,1,34,4,12]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class P{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function R({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:o});if(!e)return null;const i=b.join(e,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const w of await y.Promises.readdir(i)){let F=-1;if(s){const C=w.indexOf("-");if(C<0)continue;const N=w.substring(0,C);if(!I.test(N)||w.substring(C+1)!=="preview")continue;F=parseInt(N,10)}else{if(!I.test(w))continue;F=parseInt(w,10)}if(F<=n)continue;const p=b.join(i,w,"pwsh.exe");!await y.SymlinkSupport.existsFile(p)||(r=p,n=F)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",v=s?" Preview":"";return new P(r,`PowerShell${v}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await y.Promises.readdir(s))if(e.test(n)){const r=b.join(s,n,"pwsh.exe");return new P(r,i)}return null}function l(){const o=b.join(O.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function S(){const o=b.join(process.env.windir,g===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*E(){let o=await R();o&&(yield o),o=await R({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=l(),o&&(yield o),o=await R({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await R({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=S(),o&&(yield o)}async function*h(){for await(const o of E())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=h;async function f(){for await(const o of h())return o;return null}t.getFirstAvailablePowerShellInstallation=f});var de=this&&this.__decorate||function($,t,O,b){var y=arguments.length,I=y<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,O):b,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate($,t,O,b);else for(var T=$.length-1;T>=0;T--)(D=$[T])&&(I=(y<3?D(I):y>3?D(t,O,I):D(t,O))||I);return y>3&&I&&Object.defineProperty(t,O,I),I};define(Z[39],te([0,1,20,3,17,25,45,9,13,2,61,22,10]),function($,t,O,b,y,I,D,T,c,g,m,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var R;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(R=t.RequestType||(t.RequestType={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function S(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(E||(E={}));class h{constructor(L){this.buffer=L,this.pos=0}read(L){const M=this.buffer.slice(this.pos,this.pos+L);return this.pos+=M.byteLength,M}}class f{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function s(z){const L=y.VSBuffer.alloc(4);return L.writeUInt32BE(z,0),L}function e(z){return z.read(4).readUInt32BE(0)}function i(z){const L=y.VSBuffer.alloc(1);return L.writeUInt8(z,0),L}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(z,L){if(typeof L=="undefined")z.write(n.Undefined);else if(typeof L=="string"){const M=y.VSBuffer.fromString(L);z.write(n.String),z.write(s(M.byteLength)),z.write(M)}else if(r&&Buffer.isBuffer(L)){const M=y.VSBuffer.wrap(L);z.write(n.Buffer),z.write(s(M.byteLength)),z.write(M)}else if(L instanceof y.VSBuffer)z.write(n.VSBuffer),z.write(s(L.byteLength)),z.write(L);else if(Array.isArray(L)){z.write(n.Array),z.write(s(L.length));for(const M of L)a(z,M)}else{const M=y.VSBuffer.fromString(JSON.stringify(L));z.write(n.Object),z.write(s(M.byteLength)),z.write(M)}}function v(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(e(z)).toString();case o.Buffer:return z.read(e(z)).buffer;case o.VSBuffer:return z.read(e(z));case o.Array:{const M=e(z),U=[];for(let K=0;K<M;K++)U.push(v(z));return U}case o.Object:return JSON.parse(z.read(e(z)).toString())}}class w{constructor(L,M,U=null,K=1e3){this.protocol=L,this.ctx=M,this.logger=U,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(L,M){this.channels.set(L,M),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const M=this.send([L.type]);this.logger&&this.logger.logOutgoing(M,0,1,S(L.type));return}case 201:case 202:case 204:case 203:{const M=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(M,L.id,1,S(L.type),L.data);return}}}send(L,M=void 0){const U=new f;return a(U,L),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(M){return 0}}onRawMessage(L){const M=new h(L),U=v(M),K=v(M),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(L){const M=this.channels.get(L.channelName);if(!M){this.collectPendingRequest(L);return}const U=new I.CancellationTokenSource;let K;try{K=M.call(this.ctx,L.name,L.arg,U.token)}catch(q){K=Promise.reject(q)}const B=L.id;K.then(q=>{this.sendResponse({id:B,data:q,type:201}),this.activeRequests.delete(L.id)},q=>{q instanceof Error?this.sendResponse({id:B,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:B,data:q,type:203}),this.activeRequests.delete(L.id)});const J=(0,g.toDisposable)(()=>U.cancel());this.activeRequests.set(L.id,J)}onEventListen(L){const M=this.channels.get(L.channelName);if(!M){this.collectPendingRequest(L);return}const U=L.id,B=M.listen(this.ctx,L.name,L.arg)(J=>this.sendResponse({id:U,data:J,type:204}));this.activeRequests.set(L.id,B)}disposeActiveRequest(L){const M=this.activeRequests.get(L.id);M&&(M.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let M=this.pendingRequests.get(L.channelName);M||(M=[],this.pendingRequests.set(L.channelName,M));const U=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:L,timeoutTimer:U})}flushPendingRequests(L){const M=this.pendingRequests.get(L);if(M){for(const U of M)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}t.ChannelServer=w;var F;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(L,M=null){this.protocol=L,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=M}getChannel(L){const M=this;return{call(U,K,B){return M.isDisposed?Promise.reject(T.canceled()):M.requestPromise(L,U,K,B)},listen(U,K){return M.isDisposed?Promise.reject(T.canceled()):M.requestEvent(L,U,K)}}}requestPromise(L,M,U,K=I.CancellationToken.None){const B=this.lastRequestId++,q={id:B,type:100,channelName:L,name:M,arg:U};if(K.isCancellationRequested)return Promise.reject(T.canceled());let k;return new Promise((j,W)=>{if(K.isCancellationRequested)return W(T.canceled());const X=()=>{const me=Ee=>{switch(Ee.type){case 201:this.handlers.delete(B),j(Ee.data);break;case 202:this.handlers.delete(B);const fe=new Error(Ee.data.message);fe.stack=Ee.data.stack,fe.name=Ee.data.name,W(fe);break;case 203:this.handlers.delete(B),W(Ee.data);break}};this.handlers.set(B,me),this.sendRequest(q)};let Q=null;this.state===E.Idle?X():(Q=(0,b.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,X()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:B,type:101}),W(T.canceled())},re=K.onCancellationRequested(se);k=(0,g.combinedDisposable)((0,g.toDisposable)(se),re),this.activeRequests.add(k)}).finally(()=>{this.activeRequests.delete(k)})}requestEvent(L,M,U){const K=this.lastRequestId++,J={id:K,type:102,channelName:L,name:M,arg:U};let q=null;const k=new c.Emitter({onFirstListenerAdd:()=>{q=(0,b.createCancelablePromise)(j=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(k),this.sendRequest(J)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(k),this.sendRequest({id:K,type:103}))}}),A=j=>k.fire(j.data);return this.handlers.set(K,A),k.event}sendRequest(L){switch(L.type){case 100:case 102:{const M=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(M,L.id,0,`${u(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const M=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(M,L.id,0,u(L.type));return}}}send(L,M=void 0){const U=new f;return a(U,L),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(M){return 0}}onBuffer(L){const M=new h(L),U=v(M),K=v(M),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,S(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],0,S(B),K),this.onResponse({type:U[0],id:U[1],data:K})}}onResponse(L){if(L.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(L.id);M&&M(L)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}de([D.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class C{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:M,onDidClientDisconnect:U})=>{c.Event.once(M.onMessage)(B=>{const J=new h(B),q=v(J),k=new w(M,q),A=new p(M);this.channels.forEach((W,X)=>k.registerChannel(X,W));const j={channelServer:k,channelClient:A,ctx:q};this._connections.add(j),this._onDidAddConnection.fire(j),U(()=>{k.dispose(),A.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const L=[];return this._connections.forEach(M=>L.push(M)),L}getChannel(L,M){const U=this;return{call(K,B,J){let q;if((0,d.isFunction)(M)){let A=(0,O.getRandomElement)(U.connections.filter(M));q=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(U.onDidAddConnection,M))}else q=M.routeCall(U,K,B);const k=q.then(A=>A.channelClient.getChannel(L));return V(k).call(K,B,J)},listen(K,B){if((0,d.isFunction)(M))return U.getMulticastEvent(L,M,K,B);const J=M.routeEvent(U,K,B).then(q=>q.channelClient.getChannel(L));return V(J).listen(K,B)}}}getMulticastEvent(L,M,U,K){const B=this;let J=new g.DisposableStore;const q=new c.Emitter({onFirstListenerAdd:()=>{J=new g.DisposableStore;const k=new c.EventMultiplexer,A=new Map,j=X=>{const se=X.channelClient.getChannel(L).listen(U,K),re=k.add(se);A.set(X,re)},W=X=>{const Q=A.get(X);!Q||(Q.dispose(),A.delete(X))};B.connections.filter(M).forEach(j),c.Event.filter(B.onDidAddConnection,M)(j,void 0,J),B.onDidRemoveConnection(W,void 0,J),k.event(q.fire,q,J),J.add(k)},onLastListenerRemove:()=>{J.dispose()}});return q.event}registerChannel(L,M){this.channels.set(L,M),this._connections.forEach(U=>{U.channelServer.registerChannel(L,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class N{constructor(L,M,U=null){const K=new f;a(K,M),L.send(K.buffer),this.channelClient=new p(L,U),this.channelServer=new w(L,M,U)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,M){this.channelServer.registerChannel(L,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function V(z){return{call(L,M,U){return z.then(K=>K.call(L,M,U))},listen(L,M){const U=new c.Relay;return z.then(K=>U.input=K.listen(L,M)),U.event}}}t.getDelayedChannel=V;function Y(z){let L=!1;return{call(M,U,K){return L?z.call(M,U,K):(0,b.timeout)(0).then(()=>L=!0).then(()=>z.call(M,U,K))},listen(M,U){if(L)return z.listen(M,U);const K=new c.Relay;return(0,b.timeout)(0).then(()=>L=!0).then(()=>K.input=z.listen(M,U)),K.event}}}t.getNextTickChannel=Y;class ie{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const M of L.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await c.Event.toPromise(L.onDidAddConnection),await this.route(L)}}t.StaticRouter=ie;var oe;(function(z){function L(B,J){const q=B,k=J&&J.disableMarshalling,A=new Map;for(const j in q)U(j)&&A.set(j,c.Event.buffer(q[j],!0));return new class{listen(j,W,X){const Q=A.get(W);if(Q)return Q;if(K(W)){const se=q[W];if(typeof se=="function")return se.call(q,X)}throw new Error(`Event not found: ${W}`)}call(j,W,X){const Q=q[W];if(typeof Q=="function"){if(!k&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,m.revive)(X[se]);return Q.apply(q,X)}throw new Error(`Method not found: ${W}`)}}}z.fromService=L;function M(B,J){const q=J&&J.disableMarshalling;return new Proxy({},{get(k,A){if(typeof A=="string")return J?.properties?.has(A)?J.properties.get(A):K(A)?function(j){return B.listen(A,j)}:U(A)?B.listen(A):async function(...j){let W;J&&!(0,d.isUndefinedOrNull)(J.context)?W=[J.context,...j]:W=j;const X=await B.call(A,W);return q?X:(0,m.revive)(X)};throw new Error(`Property not found: ${String(A)}`)}})}z.toService=M;function U(B){return B[0]==="o"&&B[1]==="n"&&P.isUpperAsciiLetter(B.charCodeAt(2))}function K(B){return/^onScoped/.test(B)&&P.isUpperAsciiLetter(B.charCodeAt(8))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let L=z.toString();if(L!=="[object Object]")return L}return z}function ce(z){return Array.isArray(z)?z.map(ue):ue(z)}function G(z,L,M,U,K,B,J){J=ce(J);const q=ee[K],k=q[U%q.length];let A=[`%c[${z}]%c[${String(L).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(B)?(A=A.concat(J),A.push(")")):A.push(J),console.log.apply(console,A)}t.logWithColors=G;class ne{constructor(L,M){this._outgoingPrefix=L,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,M,U,K,B){this._totalOutgoing+=L,G(this._outgoingPrefix,this._totalOutgoing,L,M,U,K,B)}logIncoming(L,M,U,K,B){this._totalIncoming+=L,G(this._incomingPrefix,this._totalIncoming,L,M,U,K,B)}}t.IPCLogger=ne}),define(Z[66],te([0,1,3,13,2,10]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var D;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=t.StorageHint||(t.StorageHint={}));function T(P){const d=P;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=T;var c;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(c||(c={}));class g extends y.Disposable{constructor(d,R=Object.create(null)){super();this.database=d,this.options=R,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((R,u)=>this.accept(u,R)),d.deleted?.forEach(R=>this.accept(R,void 0))}accept(d,R){if(this.state===c.Closed)return;let u=!1;(0,I.isUndefinedOrNull)(R)?u=this.cache.delete(d):this.cache.get(d)!==R&&(this.cache.set(d,R),u=!0),u&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,R){const u=this.cache.get(d);return(0,I.isUndefinedOrNull)(u)?R:u}getBoolean(d,R){const u=this.get(d);return(0,I.isUndefinedOrNull)(u)?R:u==="true"}getNumber(d,R){const u=this.get(d);return(0,I.isUndefinedOrNull)(u)?R:parseInt(u,10)}async set(d,R){if(this.state===c.Closed)return;if((0,I.isUndefinedOrNull)(R))return this.delete(d);const u=String(R);if(this.cache.get(d)!==u)return this.cache.set(d,u),this.pendingInserts.set(d,u),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async delete(d){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((R,u)=>this.items.set(u,R)),d.delete&&d.delete.forEach(R=>this.items.delete(R))}async close(){}}t.InMemoryStorageDatabase=m}),define(Z[67],te([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[68],te([0,1,67]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const b=60,y=b*60,I=y*24,D=I*7,T=I*30,c=I*365;function g(P,d){typeof P!="number"&&(P=P.getTime());const R=Math.round((new Date().getTime()-P)/1e3);if(R<-30)return(0,O.localize)(0,null,g(new Date().getTime()+R*1e3,!1));if(R<30)return(0,O.localize)(1,null);let u;return R<b?(u=R,d?u===1?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):u===1?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u)):R<y?(u=Math.floor(R/b),d?u===1?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):u===1?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):R<I?(u=Math.floor(R/y),d?u===1?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):u===1?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u)):R<D?(u=Math.floor(R/I),d?u===1?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):u===1?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):R<T?(u=Math.floor(R/D),d?u===1?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):u===1?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u)):R<c?(u=Math.floor(R/T),d?u===1?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):u===1?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):(u=Math.floor(R/c),d?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u))}t.fromNow=g;function m(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=m}),define(Z[69],te([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[30],te([0,1,20,10,69]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function I(g,m){return m&&(g.stack||g.stacktrace)?y.localize(0,null,T(g),D(g.stack)||D(g.stacktrace)):T(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function T(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?y.localize(1,null,g.message):g.message||y.localize(2,null)}function c(g=null,m=!1){if(!g)return y.localize(3,null);if(Array.isArray(g)){const P=O.coalesce(g),d=c(P[0],m);return P.length>1?y.localize(4,null,d,P.length):d}if(b.isString(g))return g;if(g.detail){const P=g.detail;if(P.error)return I(P.error,m);if(P.exception)return I(P.exception,m)}return g.stack?I(g,m):g.message?g.message:y.localize(5,null)}t.toErrorMessage=c}),define(Z[70],te([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Z[49],te([0,1,35,38,8,18,4,11,28,10,47,12,70]),function($,t,O,b,y,I,D,T,c,g,m,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function R(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,s){if(T.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=O.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",r=>{n({success:!1,error:r})}),i.once("exit",(r,a)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?R(e.status):1})}else if(T.isLinux||T.isMacintosh)try{const e=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{O.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,r,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function l(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=l;class S{constructor(s,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=n;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(c.env).forEach(a=>{r[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{r[a]=this.options.env[a]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(D.sep);return e!==-1&&(s=s.substring(e+1)),S.WellKnowCommands[s]?s:"other"}start(s){return T.isWindows&&(this.options&&this.options.cwd&&b.isUNC(this.options.cwd)||!this.options&&b.isUNC(c.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(e=>{let i,n;const r=new Promise((a,v)=>{i=a,n=v});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=O.exec(a,this.options,(v,w,F)=>{this.childProcess=null;const p=v;p&&p.killed?n({killed:this.terminateRequested,stdout:w.toString(),stderr:F.toString()}):this.handleExec(i,s,v,w,F)})}else{let a=null;const v=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,i,s,n);const F={terminated:this.terminateRequested};g.isNumber(w)&&(F.cmdCode=w),i(F)};if(this.shell&&T.isWindows){const w=I.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let F=!1,p=!1;const C=[];let N=this.ensureQuotes(this.cmd);C.push(N.value),F=N.quoted,this.args&&this.args.forEach(Y=>{N=this.ensureQuotes(Y),C.push(N.value),p=p&&N.quoted});const V=["/s","/c"];F?p?V.push('"'+C.join(" ")+'"'):C.length>1?V.push('"'+C[0]+'" '+C.slice(1).join(" ")):V.push('"'+C[0]+'"'):V.push(C.join(" ")),a=O.spawn(l(),V,w)}else this.cmd&&(a=O.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(g.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",w=>{this.childProcess=null,n({terminated:this.terminateRequested,error:w})}),a.pid&&(this.childProcess.on("close",v),this.handleSpawn(a,i,s,n,!0)))}return r})}handleClose(s,e,i,n){}ensureQuotes(s){return S.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,u(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!T.isWindows)return s(!1);const e=O.spawn(l(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class E extends S{constructor(s,e,i,n){super(s,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,n,r){[n,r].forEach((a,v)=>{const w=new m.LineDecoder;w.write(a).forEach(C=>{e({line:C,source:v===0?0:1})});const p=w.end();p&&e({line:p,source:v===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,n,r){const a=new m.LineDecoder,v=new m.LineDecoder;s.stdout.on("data",w=>{a.write(w).forEach(p=>i({line:p,source:0}))}),s.stderr.on("data",w=>{v.write(w).forEach(p=>i({line:p,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=v}handleClose(s,e,i,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=E;function h(o){let s=[],e=!1;const i=function(n){if(e){s.push(n);return}(!o.send(n,a=>{if(a&&console.error(a),e=!1,s.length>0){const v=s.slice(0);s=[],v.forEach(w=>i(w))}})||T.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=h;var f;(function(o){async function s(e,i,n){if(D.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),D.dirname(e)!=="."||(n===void 0&&g.isString(c.env.PATH)&&(n=c.env.PATH.split(D.delimiter)),n===void 0||n.length===0))return D.join(i,e);async function a(v){if(await P.Promises.exists(v)){let w;try{w=await P.Promises.stat(v)}catch(F){F.message.startsWith("EACCES")&&(w=await P.Promises.lstat(v))}return w?!w.isDirectory():!1}return!1}for(let v of n){let w;if(D.isAbsolute(v)?w=D.join(v,e):w=D.join(i,v,e),await a(w))return w;let F=w+".com";if(await a(F)||(F=w+".exe",await a(F)))return F}return D.join(i,e)}o.findExecutable=s})(f=t.win32||(t.win32={}))}),define(Z[71],te([0,1,34,11,65,49]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function D(R,u){return R===1?b.isWindows?P():I.getWindowsShell(u):g(R,u)}t.getSystemShell=D;function T(R,u){return R===1?b.isWindows?d(u):I.getWindowsShell(u):g(R,u)}t.getSystemShellSync=T;let c=null;function g(R,u){if(b.isLinux&&R===2||b.isMacintosh&&R===3)return"/bin/bash";if(!c){let l;if(b.isWindows)l="/bin/bash";else{if(l=u.SHELL,!l)try{l=(0,O.userInfo)().shell}catch(S){}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}c=l}return c}let m=null;async function P(){return m||(m=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),m}function d(R){if(m)return m;const u=b.isWindows&&parseFloat((0,O.release)())>=10,l=R.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${R.windir}\\${l?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?S:I.getWindowsShell(R)}}),define(Z[50],te([0,1,35,3,17,25,60,9,13,2,18,11,49,39]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends R.ChannelServer{constructor(E){super({send:h=>{try{process.send&&process.send(h.buffer.toString("base64"))}catch(f){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",h=>y.VSBuffer.wrap(Buffer.from(h,"base64")))},E);process.once("disconnect",()=>this.dispose())}}t.Server=u;class l{constructor(E,h){this.modulePath=E,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new b.Delayer(f),this.child=null,this._client=null}getChannel(E){const h=this;return{call(f,o,s){return h.requestPromise(E,f,o,s)},listen(f,o){return h.requestEvent(E,f,o)}}}requestPromise(E,h,f,o=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),e=(0,b.createCancelablePromise)(r=>s.call(h,f,r)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,g.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(E,h,f){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const s=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(E).listen(h,f)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),P.isMacintosh&&h.env&&delete h.env.DYLD_LIBRARY_PATH,this.child=(0,O.fork)(this.modulePath,E,h);const f=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.options.serverName}`);return}f.fire(y.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,d.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=f.event,n={send:e,onMessage:i};this._client=new R.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,v)=>{process.removeListener("exit",r),this.activeRequests.forEach(w=>(0,g.dispose)(w)),this.activeRequests.clear(),a!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+v),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:v})})}return this._client}getCachedChannel(E){let h=this.channels.get(E);return h||(h=this.client.getChannel(E),this.channels.set(E,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=l}),define(Z[72],te([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[73],te([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[74],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[75],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[76],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[77],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[78],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[79],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[80],te([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[81],te([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[82],te([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[83],te([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[84],te([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[85],te([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[86],te([0,1,68,45,8,4,28,19,7]),function($,t,O,b,y,I,D,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(l,S,E){this._args=l,this.paths=S,this.productService=E}get appRoot(){return(0,I.dirname)(y.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(c.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?c.URI.file((0,I.join)(l,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,I.resolve)(l):(0,I.normalize)((0,I.join)(y.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,I.resolve)(l):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,I.resolve)(l);const S=D.env.VSCODE_EXTENSIONS;if(S)return S;const E=D.env.VSCODE_PORTABLE;return E?(0,I.join)(E,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(S=>/^[^:/?#]+?:\/\//.test(S)?c.URI.parse(S):c.URI.file((0,I.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,I.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([b.memoize],g.prototype,"appRoot",null),de([b.memoize],g.prototype,"userHome",null),de([b.memoize],g.prototype,"userDataPath",null),de([b.memoize],g.prototype,"appSettingsHome",null),de([b.memoize],g.prototype,"tmpDir",null),de([b.memoize],g.prototype,"userRoamingDataHome",null),de([b.memoize],g.prototype,"settingsResource",null),de([b.memoize],g.prototype,"userDataSyncHome",null),de([b.memoize],g.prototype,"userDataSyncLogResource",null),de([b.memoize],g.prototype,"sync",null),de([b.memoize],g.prototype,"machineSettingsResource",null),de([b.memoize],g.prototype,"globalStorageHome",null),de([b.memoize],g.prototype,"workspaceStorageHome",null),de([b.memoize],g.prototype,"keybindingsResource",null),de([b.memoize],g.prototype,"keyboardLayoutResource",null),de([b.memoize],g.prototype,"argvResource",null),de([b.memoize],g.prototype,"snippetsHome",null),de([b.memoize],g.prototype,"isExtensionDevelopment",null),de([b.memoize],g.prototype,"untitledWorkspacesHome",null),de([b.memoize],g.prototype,"installSourcePath",null),de([b.memoize],g.prototype,"builtinExtensionsPath",null),de([b.memoize],g.prototype,"extensionsPath",null),de([b.memoize],g.prototype,"extensionDevelopmentLocationURI",null),de([b.memoize],g.prototype,"extensionDevelopmentKind",null),de([b.memoize],g.prototype,"extensionTestsLocationURI",null),de([b.memoize],g.prototype,"debugExtensionHost",null),de([b.memoize],g.prototype,"serviceMachineIdResource",null),de([b.memoize],g.prototype,"telemetryLogResource",null),de([b.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function m(u,l){return R(u["inspect-extensions"],u["inspect-brk-extensions"],5870,l,u.debugId)}t.parseExtensionHostPort=m;function P(u,l){return R(u["inspect-search"],u["inspect-brk-search"],5876,l)}t.parseSearchPort=P;function d(u,l){return R(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l)}t.parsePtyHostPort=d;function R(u,l,S,E,h){const o=Number(l||u)||(E?null:S),s=o?Boolean(!!l):!1;return{port:o,break:s,debugId:h}}}),function(){"use strict";function $(t,O,b,y){function I(T){const c=D(T),g=[c];return t.isAbsolute(c)||g.unshift(y),t.resolve(...g)}function D(T){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,b);const m=T["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(P,"AppData","Roaming")}break;case"darwin":g=t.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,b)}return{getUserDataPath:I}}if(typeof define=="function")define(Z[87],te([0,88,34,8,19,28]),function(t,O,b,y,I,D){const T=I.dirname(y.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(I.joinPath(T,"package.json").fsPath);return $(O,b,c.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),O=require("path"),b=require("os");module.exports=$(O,b,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[89],te([0,1,34,86,87]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class I extends b.AbstractNativeEnvironmentService{constructor(T,c){super(T,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,y.getUserDataPath)(T)},c)}}t.NativeEnvironmentService=I}),define(Z[90],te([0,1,18]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const b=/^%([\w\d.-]+)%$/i;function y(I,D){const T=c=>{if(typeof c!="string")return;const g=b.exec(c);if(!g)return;const m=D[g[1]]??c;return typeof m=="string"?m:typeof m.message=="string"?m.message:c};return(0,O.cloneAndChange)(I,T)}t.localizeManifest=y}),define(Z[51],te([0,1,80]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function I(d){return d=d.trim(),d==="*"||b.test(d)}t.isValidVersionStr=I;function D(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let R=d.match(b);return R?{hasCaret:R[1]==="^",hasGreaterEquals:R[1]===">=",majorBase:R[2]==="x"?0:parseInt(R[2],10),majorMustEqual:R[2]!=="x",minorBase:R[4]==="x"?0:parseInt(R[4],10),minorMustEqual:R[4]!=="x",patchBase:R[6]==="x"?0:parseInt(R[6],10),patchMustEqual:R[6]!=="x",preRelease:R[8]||null}:null}t.parseVersion=D;function T(d){if(!d)return null;let R=d.majorBase,u=d.majorMustEqual,l=d.minorBase,S=d.minorMustEqual,E=d.patchBase,h=d.patchMustEqual;d.hasCaret&&(R===0||(S=!1),h=!1);let f=0;if(d.preRelease){const o=y.exec(d.preRelease);if(o){const[,s,e,i]=o;f=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:R,majorMustEqual:u,minorBase:l,minorMustEqual:S,patchBase:E,patchMustEqual:h,isMinimum:d.hasGreaterEquals,notBefore:f}}t.normalizeVersion=T;function c(d,R,u){let l;typeof d=="string"?l=T(D(d)):l=d;let S;R instanceof Date?S=R.getTime():typeof R=="string"&&(S=new Date(R).getTime());let E;if(typeof u=="string"?E=T(D(u)):E=u,!l||!E)return!1;let h=l.majorBase,f=l.minorBase,o=l.patchBase,s=E.majorBase,e=E.minorBase,i=E.patchBase,n=E.notBefore,r=E.majorMustEqual,a=E.minorMustEqual,v=E.patchMustEqual;return E.isMinimum?h>s?!0:h<s?!1:f>e?!0:f<e||S&&S<n?!1:o>=i:(h===1&&s===0&&(!r||!a||!v)&&(s=1,e=0,i=0,r=!0,a=!1,v=!1),h<s?!1:h>s?!r:f<e?!1:f>e?!a:o<i?!1:o>i?!v:!(S&&S<n))}t.isValidVersion=c;function g(d,R,u,l){return u.isBuiltin||typeof u.main=="undefined"?!0:P(d,R,u.engines.vscode,l)}t.isValidExtensionVersion=g;function m(d,R,u){return d==="*"||P(R,u,d)}t.isEngineValid=m;function P(d,R,u,l=[]){let S=T(D(u));if(!S)return l.push(O.localize(0,null,u)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return l.push(O.localize(1,null,u)),!1}else if(!S.majorMustEqual)return l.push(O.localize(2,null,u)),!1;return c(d,R,S)?!0:(l.push(O.localize(3,null,d,u)),!1)}}),define(Z[91],te([0,1,2,8,39,50]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends O.Disposable{constructor(c,g,m,P){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new I.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(Z[92],te([0,1,2,8,39,50]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends O.Disposable{constructor(c,g,m,P,d={}){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=P,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new I.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(Z[93],te([0,1,35,62,8,47]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class D{constructor(c,g,m,P,d){this.watchedFolder=c,this.eventCallback=m,this.logCallback=P,this.verboseLogging=d,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(R=>(0,b.parse)(R)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,O.spawn)(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const g=new I.LineDecoder;this.handle.stdout.on("data",m=>{const P=[];for(const d of g.write(m)){const R=d.split("|");if(R.length===2){const u=Number(R[0]),l=R[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(S=>S(l))){this.verboseLogging&&this.log(l);continue}P.push({type:D.changeTypeMap[u],path:l})}else this.log(R[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",m=>this.onError(m)),this.handle.stderr.on("data",m=>this.onError(m)),this.handle.on("exit",(m,P)=>this.onExit(m,P))}onError(c){this.error("process error: "+c.toString())}onExit(c,g){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${g})`),this.restartCounter<=D.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=D,D.MAX_RESTARTS=5,D.changeTypeMap=[0,1,2]}),define(Z[94],te([0,1,4,22,93]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class I{constructor(T,c,g,m){this.onDidFilesChange=c,this.onLogMessage=g,this.verboseLogging=m,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=I}),define(Z[52],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class O{constructor(y,I=[],D=!1){this.ctor=y,this.staticArguments=I,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=O}),define(Z[95],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class O{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}t.Node=O;class b{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let D of this._nodes.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const T=this.lookupOrInsertNode(I),c=this.lookupOrInsertNode(D);T.outgoing.set(this._hashFn(D),c),c.incoming.set(this._hashFn(I),T)}removeNode(I){const D=this._hashFn(I);this._nodes.delete(D);for(let T of this._nodes.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(I){const D=this._hashFn(I);let T=this._nodes.get(D);return T||(T=new O(I),this._nodes.set(D,T)),T}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[D,T]of this._nodes)I.push(`${D}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,D]of this._nodes){const T=new Set([I]),c=this._findCycle(D,T);if(c)return c}}_findCycle(I,D){for(let[T,c]of I.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const g=this._findCycle(c,D);if(g)return g;D.delete(T)}}}t.Graph=b}),define(Z[53],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Z[21],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,O.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,O.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[23],te([0,1,8,75,15]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var I;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(I=t.TargetPlatform||(t.TargetPlatform={}));function D(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=D;function T(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function c(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=c;function g(h,f){return f==="web"&&!h.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function m(h,f,o){return g(f,o)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===o?!0:P(o).includes(h)}t.isTargetPlatformCompatible=m;function P(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=P;function d(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=d;var R;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(R=t.SortBy||(t.SortBy={}));var u;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var l;(function(h){h.Install="install",h.Uninstall="uninstall"})(l=t.StatisticType||(t.StatisticType={}));var S;(function(h){h[h.None=0]="None",h[h.Install=1]="Install",h[h.Update=2]="Update"})(S=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class E extends Error{constructor(f,o){super(f);this.code=o,this.name=o}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,b.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,b.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],te([0,1,22,15]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function y(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}t.getWorkspaceSupportTypeMessage=y;function I(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}t.isIExtensionIdentifier=I,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D=t.ExtensionType||(t.ExtensionType={}));class T{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,d){if(typeof P=="undefined"||P===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof P=="string"||typeof d=="string"){let R=typeof P=="string"?P:P.value,u=typeof d=="string"?d:d.value;return O.equalsIgnoreCase(R,u)}return P._lower===d._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}t.ExtensionIdentifier=T;function c(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],te([0,1,22,40]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function y(u,l){return u.uuid&&l.uuid?u.uuid===l.uuid:u.id===l.id?!0:(0,O.compareIgnoreCase)(u.id,l.id)===0}t.areSameExtensions=y;class I{constructor(l,S){this.version=S,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof I?y(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=I;function D(u,l){return`${u}.${l}`}t.getExtensionId=D;function T(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function c(u,l){return T(D(u,l))}t.getGalleryExtensionId=c;function g(u,l){const S=[],E=h=>{for(const f of S)if(f.some(o=>y(l(o),l(h))))return f;return null};for(const h of u){const f=E(h);f?f.push(h):S.push([h])}return S}t.groupByExtension=g;function m(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=m;function P(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=P,t.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function d(u){const l=new Set;for(const S of u)S.malicious&&l.add(S.id.id);return l}t.getMaliciousExtensionsSet=d;function R(u,l){const S=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const h=E.shift();if(h&&S.every(f=>!y(f.identifier,{id:h}))){const f=u.filter(o=>y(o.identifier,{id:h}));f.length===1&&(S.push(f[0]),E.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}t.getExtensionDependencies=R});var le=this&&this.__param||function($,t){return function(O,b){t(O,b,$)}};define(Z[96],te([0,1,25,9,63,8,41,7,76,23,24,40]),function($,t,O,b,y,I,D,T,c,g,m,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=h=>(0,c.localize)(0,null,h),R=(0,c.localize)(1,null,"ms-dotnettools.csharp");function u(h,f){return f?`${h.publisher}.${h.name}@${h.version}`:`${h.publisher}.${h.name}`}const l=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(h){const f=l.exec(h);return f&&f[1]?[(0,m.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,m.adoptToGalleryExtensionId)(h),void 0]}t.getIdAndVersion=S;let E=class{constructor(f,o){this.extensionManagementService=f,this.extensionGalleryService=o}get location(){}async listExtensions(f,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=P.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(v=>v.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,c.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,f)))}async installExtensions(f,o,s,e,i=console){const n=[],r=[];f.length&&i.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),v=(p,C)=>{const N=a.find(V=>(0,m.areSameExtensions)(V.identifier,{id:p}));if(N){if(!C&&!e)return i.log((0,c.localize)(5,null,p,N.manifest.version,p)),!1;if(C&&N.manifest.version===C)return i.log((0,c.localize)(6,null,`${p}@${C}`)),!1}return!0},w=[],F=[];for(const p of f)if(p instanceof T.URI)w.push(p);else{const[C,N]=S(p);v(C,N)&&F.push({id:C,version:N,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const p of o){const[C,N]=S(p);v(C,N)&&F.push({id:C,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(w.length&&await Promise.all(w.map(async p=>{try{const C=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:s},e,i);C&&r.push(C)}catch(C){i.error(C.message||C.stack||C),n.push(p.toString())}})),F.length){const p=await this.getGalleryExtensions(F);await Promise.all(F.map(async C=>{const N=p.get(C.id.toLowerCase());if(N)try{const V=await this.installFromGallery(C,N,a,e,i);V&&r.push(V)}catch(V){i.error(V.message||V.stack||V),n.push(C.id)}else i.error(`${d(C.version?`${C.id}@${C.version}`:C.id)}
${R}`),n.push(C.id)}))}if(n.length)throw new Error((0,c.localize)(7,null,n.join(", ")))}async installVSIX(f,o,s,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(f,o),e.log((0,c.localize)(8,null,(0,y.getBaseLabel)(f))),i}catch(r){if((0,b.isPromiseCanceledError)(r))return e.log((0,c.localize)(9,null,(0,y.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const o=new Map,s=await this.extensionGalleryService.getExtensions(f,O.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:f,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const v=i.find(w=>(0,m.areSameExtensions)(w.identifier,e.identifier));if(v){if(e.version===v.manifest.version)return r.log((0,c.localize)(10,null,o?`${f}@${o}`:f)),null;r.log((0,c.localize)(11,null,f,e.version))}try{return s.isBuiltin?r.log(o?(0,c.localize)(12,null,f,o):(0,c.localize)(13,null,f)):r.log(o?(0,c.localize)(14,null,f,o):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,c.localize)(16,null,f,e.version)),a}catch(w){if((0,b.isPromiseCanceledError)(w))return r.log((0,c.localize)(17,null,f)),null;throw w}}validateExtensionKind(f,o){return!0}async validateVSIX(f,o,s){const e={id:(0,m.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,m.areSameExtensions)(e,r.identifier)&&(0,D.gt)(r.manifest.version,f.version));return n&&!o?(s.log((0,c.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,o,s=console){const e=async n=>{if(n instanceof T.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of f){const r=await e(n),v=(await this.extensionManagementService.getInstalled()).filter(w=>(0,m.areSameExtensions)(w.identifier,{id:r}));if(!v.length)throw new Error(`${this.notInstalled(r)}
${R}`);if(v.some(w=>w.type===0)){s.log((0,c.localize)(19,null,r));return}if(!o&&v.some(w=>w.isBuiltin)){s.log((0,c.localize)(20,null,r));return}s.log((0,c.localize)(21,null,r));for(const w of v)await this.extensionManagementService.uninstall(w),i.push(w);this.location?s.log((0,c.localize)(22,null,r,this.location)):s.log((0,c.localize)(23,null,r))}}async locateExtension(f,o=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===I.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};E=de([le(0,g.IExtensionManagementService),le(1,g.IExtensionGalleryService)],E),t.ExtensionManagementCLIService=E}),define(Z[97],te([0,1,2,4,12,40]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends O.Disposable{constructor(c,g){super();this.environmentService=c,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(g.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(c){c.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){y.Promises.rm(this.extensionsManifestCache,y.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=D}),define(Z[98],te([0,1,35,88,25,30,9,11,31,71,127]),function($,t,O,b,y,I,D,T,c,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function P(u,l,S){return l["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):T.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(S)&&!l["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(S)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=new Promise(async E=>{const h=new y.CancellationTokenSource,f=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),h.dispose(!0),E({})},1e4);try{const o=await R(u,h.token);E(o)}catch(o){(0,D.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),E({})}finally{clearTimeout(f),h.dispose()}})),d)}t.resolveShellEnv=P;let d;async function R(u,l){const S=new Promise(async(E,h)=>{const f=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",f);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",i);const n=await(0,g.getSystemShell)(T.OS,i);if(u.trace("getUnixShellEnvironment#shell",n),l.isCancellationRequested)return h(D.canceled);const r=b.basename(n);let a,v;/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,v=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,v=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),a);const w=(0,O.spawn)(n,[...v,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});l.onCancellationRequested(()=>(w.kill(),h(D.canceled))),w.on("error",C=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,I.toErrorMessage)(C)),E({})});const F=[];w.stdout.on("data",C=>F.push(C));const p=[];w.stderr.on("data",C=>p.push(C)),w.on("close",(C,N)=>{const V=Buffer.concat(F).toString("utf8");u.trace("getUnixShellEnvironment#raw",V);const Y=Buffer.concat(p).toString("utf8");if(Y.trim()&&u.trace("getUnixShellEnvironment#stderr",Y),C||N)return h(new Error(`Failed to get environment (code ${C}, signal ${N})`));const ie=e.exec(V),oe=ie?ie[1]:"{}";try{const ee=JSON.parse(oe);f?ee.ELECTRON_RUN_AS_NODE=f:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ee),E(ee)}catch(ee){u.error("getUnixShellEnvironment#errorCaught",(0,I.toErrorMessage)(ee)),h(ee)}})});try{return await S}catch(E){return u.error("getUnixShellEnvironment#error",(0,I.toErrorMessage)(E)),{}}}}),define(Z[54],te([0,1,11,7,16]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function I(c){return c.map(g=>({type:g.type,resource:b.URI.file(g.path)}))}t.toFileChanges=I;function D(c){const g=new T;for(const m of c)g.processEvent(m);return g.normalize()}t.normalizeFileChanges=D;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const m=this.mapPathToChange.get(g.path);if(m){const P=m.type,d=g.type;P===1&&d===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(m),1)):P===2&&d===1?m.type=0:P===1&&d===0||(m.type=d)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],m=[];return this.normalized.filter(P=>P.type!==2?(g.push(P),!1):!0).sort((P,d)=>P.path.length-d.path.length).filter(P=>m.some(d=>(0,y.isParent)(P.path,d,!O.isLinux))?!1:(m.push(P.path),!0)).concat(g)}}}),define(Z[99],te([0,1,3,2,4,64,12,128,54]),function($,t,O,b,y,I,D,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends b.Disposable{constructor(P,d,R,u){super();this.path=P,this.onDidFilesChange=d,this.onLogMessage=R,this.verboseLogging=u,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:d}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let R=this.path;if(d)try{R=await(0,I.realpath)(R)}catch(u){if(this.onError(u),d.dangling)return}P.isDirectory()?this._register((0,T.watchFolder)(R,(u,l)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,y.join)(this.path,(0,y.basename)(l))})},u=>this.onError(u))):this._register((0,T.watchFile)(R,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const R=(0,c.normalizeFileChanges)(d);if(this.verboseLogging)for(const u of R)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);R.length>0&&this.onDidFilesChange(R)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(Z[55],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class O{constructor(...y){this._entries=new Map;for(let[I,D]of y)this.set(I,D)}set(y,I){const D=this._entries.get(y);return this._entries.set(y,I),D}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}t.ServiceCollection=O}),define(Z[100],te([0,1,3,9,52,95,15,55]),function($,t,O,b,y,I,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class g extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class m{constructor(u=new T.ServiceCollection,l=!1,S){this._activeInstantiations=new Set,this._services=u,this._strict=l,this._parent=S,this._services.set(D.IInstantiationService,this)}createChild(u){return new m(u,this._strict,this)}invokeFunction(u,...l){let S=d.traceInvocation(u),E=!1;try{return u({get:(f,o)=>{if(E)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,S);if(!s&&o!==D.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...l)}finally{E=!0,S.stop()}}createInstance(u,...l){let S,E;return u instanceof y.SyncDescriptor?(S=d.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(l),S)):(S=d.traceCreation(u),E=this._createInstance(u,l,S)),S.stop(),E}_createInstance(u,l=[],S){let E=D._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),h=[];for(const o of E){let s=this._getOrCreateServiceInstance(o.id,S);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);h.push(s)}let f=E.length>0?E[0].index:l.length;if(l.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${l.length} static arguments`);let o=f-l.length;o>0?l=l.concat(new Array(o)):l=l.slice(0,f)}return new u(...[...l,...h])}_setServiceInstance(u,l){if(this._services.get(u)instanceof y.SyncDescriptor)this._services.set(u,l);else if(this._parent)this._parent._setServiceInstance(u,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let l=this._services.get(u);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):l}_getOrCreateServiceInstance(u,l){let S=this._getServiceInstanceOrDescriptor(u);return S instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,S,l.branch(u,!0)):(l.branch(u,!1),S)}_safeCreateAndCacheServiceInstance(u,l,S){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,l,S)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,l,S){const E=new I.Graph(o=>o.id.toString());let h=0;const f=[{id:u,desc:l,_trace:S}];for(;f.length;){const o=f.pop();if(E.lookupOrInsertNode(o),h++>1e3)throw new g(E);for(let s of D._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof y.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};E.insertEdge(o,i),f.push(i)}}}for(;;){const o=E.roots();if(o.length===0){if(!E.isEmpty())throw new g(E);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof y.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,l,S=[],E,h){if(this._services.get(u)instanceof y.SyncDescriptor)return this._createServiceInstance(l,S,E,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,l,S,E,h);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(u,l=[],S,E){if(S){const h=new O.IdleValue(()=>this._createInstance(u,l,E));return new Proxy(Object.create(null),{get(f,o){if(o in f)return f[o];let s=h.value,e=s[o];return typeof e!="function"||(e=e.bind(s),f[o]=e),e},set(f,o,s){return h.value[o]=s,!0}})}else return this._createInstance(u,l,E)}}t.InstantiationService=m;var P;(function(R){R[R.Creation=0]="Creation",R[R.Invocation=1]="Invocation",R[R.Branch=2]="Branch"})(P||(P={}));class d{constructor(u,l){this.type=u,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return c?new d(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(u){return c?new d(0,u.name):d._None}branch(u,l){let S=new d(2,u.toString());return this._dep.push([u,l,S]),S}stop(){let u=Date.now()-this._start;d._totals+=u;let l=!1;function S(h,f){let o=[],s=new Array(h+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){l=!0,o.push(`${s}CREATES -> ${e}`);let r=S(h+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(u>2||l)&&console.log(E.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Z[56],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,O.createDecorator)("localizationsService");function b(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const I of y.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}t.isValidLocalization=b}),define(Z[14],te([0,1,30,13,2,11,15]),function($,t,O,b,y,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,D.createDecorator)("logService"),t.ILoggerService=(0,D.createDecorator)("loggerService");function T(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class g extends y.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class m extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=m;class P extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...i):console.warn(`[main ${T()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=P;class d extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=d;class R extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,O.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=R;class u extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class l extends y.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=l;class S extends y.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=S;class E{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=E;function h(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=h;function f(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=f;function o(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(Z[101],te([0,1,3,9,2,11,19,41,7,31,12,21,23,24,16,14]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends y.Disposable{constructor(f,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=c.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,o){await this.cleanUpPromise;const s=this.getName(f),e=(0,D.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){}async rename(f,o,s){try{await m.Promises.rename(f.fsPath,o.fsPath)}catch(e){if(I.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${o} with 'EPERM' error. Trying again...`),this.rename(f,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const o=[],s=[];for(const n of f.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,R.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>T.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await O.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new R.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(f){const o=S.exec(f);return o&&o[1]&&o[2]?new R.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};E=de([le(0,P.INativeEnvironmentService),le(1,u.IFileService),le(2,d.IExtensionGalleryService),le(3,l.ILogService)],E),t.ExtensionsDownloader=E}),define(Z[102],te([0,1,35,3,30,13,2,8,4,12,21,14]),function($,t,O,b,y,I,D,T,c,g,m,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends D.Disposable{constructor(u,l){super();this.environmentService=u,this.logService=l,this.processesLimiter=new b.Limiter(5)}async postUninstall(u){const l=this.parseScript(u,"uninstall");return l&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(l.script,"uninstall",l.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${S}`)))),g.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(u,l){const S=`vscode:${l}`;if(u.location.scheme===T.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[S]=="string"){const E=u.manifest.scripts[S].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${S} should be a node script`),null):{script:(0,c.join)(u.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(u,l,S,E,h){return new Promise((f,o)=>{const s=this.start(u,l,S,h);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):f(void 0)};s.on("error",n=>{i((0,y.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${l} process exited with code ${n}`:void 0)}),E&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,l,S,E){const h={silent:!0,execArgv:void 0},f=(0,O.fork)(u,[`--type=extension-post-${l}`,...S],h);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const o=I.Event.fromNodeEventEmitter(f.stdout,"data"),s=I.Event.fromNodeEventEmitter(f.stderr,"data");o(n=>this.logService.info(E.identifier.id,E.manifest.version,`post-${l}`,n)),s(n=>this.logService.error(E.identifier.id,E.manifest.version,`post-${l}`,n));const e=I.Event.any(I.Event.map(o,n=>({data:`%c${n}`,format:[""]})),I.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(E.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};d=de([le(0,m.IEnvironmentService),le(1,P.ILogService)],d),t.ExtensionsLifecycle=d}),define(Z[103],te([0,1,13,2,19,7,21,24,16,14]),function($,t,O,b,y,I,D,T,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let m=class extends b.Disposable{constructor(d,R,u,l){super();this.extensionsManagementService=d,this.logService=l,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(h=>{this.installedExtensions=h.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(h=>this.onInstallExtension(h))),this._register(d.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(d.onDidUninstallExtension(h=>this.onDidUninstallExtension(h)));const S=I.URI.file(u.extensionsPath),E=new y.ExtUri(h=>!R.hasCapability(h,1024));this._register(R.watch(S)),this._register(O.Event.filter(R.onDidChangeFilesRaw,h=>h.changes.some(f=>this.doesChangeAffects(f,S,E)))(()=>this.onDidChange()))}doesChangeAffects(d,R,u){return u.isEqual(u.dirname(d.resource),R)?u.isEqual(d.resource,u.joinPath(R,".obsolete"))?!0:!(d.type!==1&&d.type!==2||u.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const R of d)this.removeInstallingExtension(R.identifier),R.local&&this.addInstalledExtension(R.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(R=>!(0,T.areSameExtensions)(R,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(R=>!(0,T.areSameExtensions)(R,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),R=d.filter(l=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,T.areSameExtensions)(S,l.identifier))?!1:l.installedTimestamp&&l.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",l.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",l.identifier.id),!1)),u=this.installedExtensions.filter(l=>this.installingExtensions.some(S=>(0,T.areSameExtensions)(S,l))?!1:d.every(S=>!(0,T.areSameExtensions)(S.identifier,l))?(this.logService.info("Detected extension removed from another source",l.id),!0):!1);this.installedExtensions=d.map(l=>l.identifier),(R.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:R,removed:u})}}};m=de([le(1,c.IFileService),le(2,D.INativeEnvironmentService),le(3,g.ILogService)],m),t.ExtensionsWatcher=m}),define(Z[104],te([0,1,129,20,3,2,8,4,12,21,23,24,56,14]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends I.Disposable{constructor(E,h,f){super();this.extensionManagementService=E,this.logService=f,this.cache=this._register(new l(h,f)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const E=await this.cache.getLanguagePacks(),h=["en",...Object.keys(E)];return(0,b.distinct)(h)}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const h=await this.cache.getLanguagePacks();Object.keys(h).some(f=>h[f]&&h[f].extensions.some(o=>(0,P.areSameExtensions)(o.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(h);return!(0,b.equals)(Object.keys(E),Object.keys(f))}};u=de([le(0,m.IExtensionManagementService),le(1,g.INativeEnvironmentService),le(2,R.ILogService)],u),t.LocalizationsService=u;let l=class extends I.Disposable{constructor(E,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new y.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(h=>{Object.keys(h).forEach(f=>delete h[f]),this.createLanguagePacksFromExtensions(h,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...h){for(const f of h)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,f);Object.keys(E).forEach(f=>this.updateHash(E[f]))}createLanguagePacksFromExtension(E,h){const f=h.identifier,o=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const s of o)if(h.location.scheme===D.Schemas.file&&(0,d.isValidLocalization)(s)){let e=E[s.languageId];e||(e={hash:"",extensions:[],translations:{}},E[s.languageId]=e);let i=e.extensions.filter(n=>(0,P.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=h.manifest.version:e.extensions.push({extensionIdentifier:f,version:h.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,T.join)(h.location.fsPath,n.path)}}updateHash(E){if(E){const h=(0,O.createHash)("md5");for(const f of E.extensions)h.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);E.hash=h.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(o){return{}}}).then(f=>(h=E(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>h,f=>this.logService.error(f))})}};l=de([le(0,g.INativeEnvironmentService),le(1,R.ILogService)],l)}),define(Z[105],te([0,1,16,14]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function y(c,g,m,P){try{const d=await new Promise((R,u)=>{$(["spdlog"],R,u)});return d.setFlushOn(b.LogLevel.Trace),d.createAsyncRotatingLogger(c,g,m,P)}catch(d){console.error(d)}return null}function I(c,g,m,P){const d=$.__$__nodeRequire("spdlog");return d.setFlushOn(b.LogLevel.Trace),d.createRotatingLogger(c,g,m,P)}t.createRotatingLogger=I;function D(c,g,m){switch(g){case b.LogLevel.Trace:c.trace(m);break;case b.LogLevel.Debug:c.debug(m);break;case b.LogLevel.Info:c.info(m);break;case b.LogLevel.Warning:c.warn(m);break;case b.LogLevel.Error:c.error(m);break;case b.LogLevel.Critical:c.critical(m);break;default:throw new Error("Invalid log level")}}class T extends b.AbstractMessageLogger{constructor(g,m,P,d){super();this.name=g,this.filepath=m,this.rotating=P,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(R=>{this._logger&&this._logger.setLevel(R)}))}_createSpdLogLogger(){const g=this.rotating?6:1,m=30/g*O.ByteSize.MB;return y(this.name,this.filepath,m,g).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:d,message:R}of this.buffer)D(this._logger,d,R);this.buffer=[]}})}log(g,m){this._logger?D(this._logger,g,m):this.getLevel()<=g&&this.buffer.push({level:g,message:m})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Z[57],te([0,1,17,9,82,16,32]),function($,t,O,b,y,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(P,d,R,u,l,S){let E;try{await c(P,d,R,u,l,S)}catch(h){E=h}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E!="undefined"&&R.error(E),R.end()}}t.readFileIntoStream=T;async function c(P,d,R,u,l,S){g(S);const E=await P.open(d,{create:!1});try{g(S);let h=0,f=0,o=l&&typeof l.length=="number"?l.length:void 0,s=O.VSBuffer.alloc(Math.min(l.bufferSize,typeof o=="number"?o:l.bufferSize)),e=l&&typeof l.position=="number"?l.position:0,i=0;do f=await P.read(E,e,s.buffer,i,s.byteLength-i),e+=f,i+=f,h+=f,typeof o=="number"&&(o-=f),i===s.byteLength&&(await R.write(u(s)),s=O.VSBuffer.alloc(Math.min(l.bufferSize,typeof o=="number"?o:l.bufferSize)),i=0);while(f>0&&(typeof o!="number"||o>0)&&g(S)&&m(h,l));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),R.write(u(s.slice(0,n)))}}catch(h){throw(0,I.ensureFileSystemProviderError)(h)}finally{await P.close(E)}}function g(P){if(P.isCancellationRequested)throw(0,b.canceled)();return!0}function m(P,d){if(d?.limits){if(typeof d.limits.memory=="number"&&P>d.limits.memory)throw(0,I.createFileSystemProviderError)((0,y.localize)(0,null,D.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&P>d.limits.size)throw(0,I.createFileSystemProviderError)((0,y.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[106],te([0,1,20,3,17,25,13,130,2,46,8,131,19,37,81,16,57,14]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l,S,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let h=class xe extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new b.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new l.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new b.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new l.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new c.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await b.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,d.isAbsolutePath)(o))throw new l.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s)||(0,l.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,l.toFileSystemProviderErrorCode)(e)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,l.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,v=await e.stat(o);let w;return this.toFileStat(e,o,v,void 0,!!a,(F,p)=>{if(!w&&(w=g.TernarySearchTree.forUris(()=>!i),w.set(o,!0),n))for(const C of n)w.set(C,!0);return w.get(F.resource)||w.findSuperstr(F.resource.with({query:null,fragment:null}))?!0:F.isDirectory&&r?p===1:!1})}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),v={resource:s,name:a.basename(s),isFile:(e.type&l.FileType.File)!=0,isDirectory:(e.type&l.FileType.Directory)!=0,isSymbolicLink:(e.type&l.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&l.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,l.etag)({mtime:e.mtime,size:e.size})};if(v.isDirectory&&r(v,i)){try{const w=await o.readdir(s),F=await b.Promises.settled(w.map(async([p,C])=>{try{const N=a.joinPath(s,p),V=n?await o.stat(N):{type:C};return await this.toFileStat(o,N,V,w.length,n,r)}catch(N){return this.logService.trace(N),null}}));v.children=(0,O.coalesce)(F)}catch(w){this.logService.trace(w),v.children=[]}return v}return v}async resolveAll(o){return b.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new l.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,l.hasReadWriteCapability)(i)&&!(s instanceof y.VSBuffer))if((0,R.isReadableStream)(s)){const v=await(0,R.peekStream)(s,3);v.ended?a=y.VSBuffer.concat(v.buffer):a=v}else a=(0,R.peekReadable)(s,v=>y.VSBuffer.concat(v),3);else a=s;!(0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasReadWriteCapability)(i)&&a instanceof y.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof y.VSBuffer?(0,y.bufferToReadable)(a):a)}catch(r){throw new l.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&l.FileType.Directory)!=0)throw new l.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==l.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,l.etag)({mtime:e.mtime,size:n.size}))throw new l.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,y.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new I.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==l.ETAG_DISABLED&&await n,!((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasFileReadStreamCapability)(o))||(0,l.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,l.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,R.consumeStream)(r);const v=(0,u.localize)(8,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(a).toString());throw a instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(v,a.stat,e):new l.FileOperationError(v,(0,l.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,R.transform)(n,{data:r=>r instanceof y.VSBuffer?r:y.VSBuffer.wrap(r),error:r=>new l.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},r=>y.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,y.newWriteableBufferStream)();return(0,S.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new l.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,R.newWriteableStream)(n=>y.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(y.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new l.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==l.ETAG_DISABLED&&s.etag===e.etag)throw new l.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new l.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:v}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!v&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,l.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const w=await this.resolve(s);w.isDirectory?await this.doCopyFolder(o,w,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:w,isPathCaseSensitive:F}=this.getExtUri(o);if(F||(a=w.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&w.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const v=await this.exists(i);if(v&&!a){if(!r)throw new l.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:w}=this.getExtUri(o);if(w.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:v,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&l.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,l.toFileSystemProviderErrorCode)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,l.toFileSystemProviderErrorCode)(r)!==l.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new l.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new l.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new l.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,c.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,c.dispose)(r):n=()=>(0,c.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,c.toDisposable)(()=>{n.count--,n.count===0&&((0,c.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,R.isReadableStream)(i)||(0,R.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,R.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(r,a)=>{(0,R.listenStream)(n,{onData:async v=>{n.pause();try{await this.doWriteBuffer(o,s,v,v.byteLength,i,0)}catch(w){return a(w)}i+=v.byteLength,setTimeout(()=>n.resume())},onError:v=>a(v),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof y.VSBuffer?n=i:(0,R.isReadableStream)(i)?n=await(0,y.streamToBuffer)(i):(0,R.isReadableBufferedStream)(i)?n=await(0,y.bufferedStreamToBuffer)(i):n=(0,y.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=y.VSBuffer.alloc(this.BUFFER_SIZE);let v=0,w=0,F=0;do F=await o.read(n,v,a.buffer,w,a.byteLength-w),await this.doWriteBuffer(e,r,a,F,v,w),v+=F,w+=F,w===a.byteLength&&(w=0);while(F>0)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,y.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,y.streamToBuffer)(this.readFileBuffered(o,s,I.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new l.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};h.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},h=de([le(0,E.ILogService)],h),t.FileService=h}),define(Z[107],te([0,1,20,3,17,13,38,2,4,11,19,37,12,83,16,57,99,91,92,54,94,14,32]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l,S,E,h,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends T.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:v}=await d.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,v),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await d.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),v=[];return await Promise.all(a.map(async w=>{try{let F;w.isSymbolicLink()?F=(await this.stat((0,m.joinPath)(r,w.name))).type:F=this.toType(w),v.push([w.name,F])}catch(F){this.logService.trace(F)}})),v}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let v;return a?.dangling?v=u.FileType.Unknown:r.isFile()?v=u.FileType.File:r.isDirectory()?v=u.FileType.Directory:v=u.FileType.Unknown,a&&(v|=u.FileType.SymbolicLink),v}async readFile(r){try{const a=this.toFilePath(r);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,v){const w=(0,P.newWriteableStream)(F=>y.VSBuffer.concat(F.map(p=>y.VSBuffer.wrap(p))).buffer);return(0,l.readFileIntoStream)(this,r,w,F=>F.buffer,{...a,bufferSize:this.BUFFER_SIZE},v),w}async writeFile(r,a,v){let w;try{const F=this.toFilePath(r);if(!v.create||!v.overwrite){if(await d.Promises.exists(F)){if(!v.overwrite)throw(0,u.createFileSystemProviderError)((0,R.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!v.create)throw(0,u.createFileSystemProviderError)((0,R.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:v.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(r,F)}finally{typeof w=="number"&&await this.close(w)}}async open(r,a){try{const v=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await d.SymlinkSupport.stat(v);p.mode&128||await d.Promises.chmod(v,p.mode|128)}catch(p){this.logService.trace(p)}let w;if((0,u.isFileOpenForWriteOptions)(a)){if(g.isWindows)try{await d.Promises.truncate(v,0),w="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}w||(w="w")}else w="r";const F=await d.Promises.open(v,w);return this.mapHandleToPos.set(F,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(F,r),F}catch(v){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,v):this.toFileSystemProviderError(v)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await d.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,v,w,F){const p=this.normalizePos(r,a);let C=null;try{const N=await d.Promises.read(r,v,w,F,p);return typeof N=="number"?C=N:C=N.bytesRead,C}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(r,p,C)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,v){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof a=="number"||(typeof v=="number"?this.mapHandleToPos.set(r,w+v):this.mapHandleToPos.delete(r)))}async write(r,a,v,w,F){return(0,b.retry)(()=>this.doWrite(r,a,v,w,F),100,3)}async doWrite(r,a,v,w,F){const p=this.normalizePos(r,a);let C=null;try{const N=await d.Promises.write(r,v,w,F,p);return typeof N=="number"?C=N:C=N.bytesWritten,C}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),N)}finally{this.updatePos(r,p,C)}}async mkdir(r){try{await d.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const v=this.toFilePath(r);await this.doDelete(v,a)}catch(v){throw this.toFileSystemProviderError(v)}}async doDelete(r,a){a.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}async rename(r,a,v){const w=this.toFilePath(r),F=this.toFilePath(a);if(w!==F)try{await this.validateTargetDeleted(r,a,"move",v.overwrite),await d.Promises.move(w,F)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,R.localize)(2,null,(0,c.basename)(w),(0,c.basename)((0,c.dirname)(F)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(r,a,v){const w=this.toFilePath(r),F=this.toFilePath(a);if(w!==F)try{await this.validateTargetDeleted(r,a,"copy",v.overwrite),await d.Promises.copy(w,F,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,R.localize)(3,null,(0,c.basename)(w),(0,c.basename)((0,c.dirname)(F)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(r,a,v,w){const F=this.toFilePath(r),p=this.toFilePath(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,D.isEqual)(F,p,!0)),C&&v==="copy")throw(0,u.createFileSystemProviderError)((0,R.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!C&&await d.Promises.exists(p)){if(!w)throw(0,u.createFileSystemProviderError)((0,R.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a.excludes):this.watchNonRecursive(r)}watchRecursive(r,a){const v={path:this.toFilePath(r),excludes:a},w=(0,O.insert)(this.recursiveFoldersToWatch,v);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof E.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;this.options?.watcher?.usePolling?(r=h.FileWatcher,a=this.options?.watcher):e.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?g.isWindows?r=o.FileWatcher:r=h.FileWatcher:r=E.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,v=>this._onDidChangeFile.fire((0,f.toFileChanges)(v)),v=>{v.type==="error"&&this._onDidWatchErrorOccur.fire(v.message),this.logService[v.type](v.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new S.FileWatcher(this.toFilePath(r),w=>this._onDidChangeFile.fire((0,f.toFileChanges)(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===s.LogLevel.Trace),v=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,T.combinedDisposable)(a,v)}toFilePath(r){return(0,c.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let v=this.toFileSystemProviderError(a);if(r&&v.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await d.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(v=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return v}dispose(){super.dispose(),(0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,T.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Z[42],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,O.createDecorator)("productService")}),define(Z[26],te([0,1,58,10]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class y{constructor(){this.data=new Map}add(D,T){O.ok(b.isString(D)),O.ok(b.isObject(T)),O.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,T)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}t.Registry=new y}),define(Z[108],te([0,1,13,26]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function y(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class I{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,g){this.schemasById[y(c)]=g,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new I;b.Registry.add(t.Extensions.JSONContribution,D)}),define(Z[33],te([0,1,20,13,10,73,108,26]),function($,t,O,b,y,I,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var c;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(c=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var g;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=T.Registry.as(D.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,o=!0){this.registerConfigurations([f],o)}registerConfigurations(f,o=!0){const s=this.doRegisterConfigurations(f,o);m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(f){const o=this.doDeregisterConfigurations(f);m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:f,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(f,!1)),m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,O.distinct)(s))}registerDefaultConfigurations(f){const o=[],s=[];for(const e of f)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:I.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(R(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(f){const o=[];for(const s of f)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const o of f)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,o){const s=[];return f.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(f){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of f){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(f,o=!0,s,e=3){e=y.isUndefinedOrNull(f.scope)?e:f.scope;let i=[],n=f.properties;if(n)for(let a in n){if(o&&S(a)){delete n[a];continue}const v=n[a];if(this.updatePropertyDefaultValue(a,v),t.OVERRIDE_PROPERTY_PATTERN.test(a)?v.scope=void 0:(v.scope=y.isUndefinedOrNull(v.scope)?e:v.scope,v.restricted=y.isUndefinedOrNull(v.restricted)?!!s?.restrictedConfigurations?.includes(a):v.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=f.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(f)}updateSchema(f,o){switch(t.allSettings.properties[f]=o,o.scope){case 1:t.applicationSettings.properties[f]=o;break;case 2:t.machineSettings.properties[f]=o;break;case 6:t.machineOverridableSettings.properties[f]=o;break;case 3:t.windowSettings.properties[f]=o;break;case 4:t.resourceSettings.properties[f]=o;break;case 5:t.resourceSettings.properties[f]=o,this.resourceLanguageSettingsSchema.properties[f]=o;break}}removeFromSchema(f,o){switch(delete t.allSettings.properties[f],o.scope){case 1:delete t.applicationSettings.properties[f];break;case 2:delete t.machineSettings.properties[f];break;case 6:delete t.machineOverridableSettings.properties[f];break;case 3:delete t.windowSettings.properties[f];break;case 4:case 5:delete t.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const o=`[${f}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,o){let s=this.defaultValues[f];y.isUndefined(s)&&(s=o.default),y.isUndefined(s)&&(s=u(o.type)),o.default=s}}const d="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(d);function R(h){return h.substring(1,h.length-1)}t.overrideIdentifierFromKey=R;function u(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const l=new P;T.Registry.add(t.Extensions.Configuration,l);function S(h){return h.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(h)?I.localize(5,null,h):l.getConfigurationProperties()[h]!==void 0?I.localize(6,null,h):null:I.localize(4,null)}t.validateProperty=S;function E(){const h=[],f=l.getConfigurationProperties();for(const o of Object.keys(f))h.push([o,f[o].scope]);return h.push(["launch",4]),h.push(["task",4]),h}t.getScopes=E}),define(Z[27],te([0,1,18,10,7,33,15,26]),function($,t,O,b,y,I,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof y.URI)}t.isConfigurationOverrides=c;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function m(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=m;function P(i,n){const r=n?i?n.keys.filter(N=>i.keys.indexOf(N)===-1):[...n.keys]:[],a=i?n?i.keys.filter(N=>n.keys.indexOf(N)===-1):[...i.keys]:[],v=[];if(n&&i){for(const N of i.keys)if(n.keys.indexOf(N)!==-1){const V=E(i.contents,N),Y=E(n.contents,N);O.equals(V,Y)||v.push(N)}}const w=[],F=N=>{const V={};for(const Y of N)for(const ie of Y.identifiers)V[s(ie)]=Y;return V},p=n?F(n.overrides):{},C=i?F(i.overrides):{};if(Object.keys(p).length)for(const N of r){const V=p[N];V&&w.push([(0,I.overrideIdentifierFromKey)(N),V.keys])}if(Object.keys(C).length)for(const N of a){const V=C[N];V&&w.push([(0,I.overrideIdentifierFromKey)(N),V.keys])}if(Object.keys(p).length&&Object.keys(C).length)for(const N of v){const V=C[N],Y=p[N];if(V&&Y){const ie=P({contents:V.contents,keys:V.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});w.push([(0,I.overrideIdentifierFromKey)(N),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:a,updated:v,overrides:w}}t.compare=P;function d(i,n){const r=[];for(const a of Object.keys(i))if(I.OVERRIDE_PROPERTY_PATTERN.test(a)){const v={};for(const w in i[a])v[w]=i[a][w];r.push({identifiers:[(0,I.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(v),contents:R(v,n)})}return r}t.toOverrides=d;function R(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=R;function u(i,n,r,a){const v=n.split("."),w=v.pop();let F=i;for(let p=0;p<v.length;p++){let C=v[p],N=F[C];switch(typeof N){case"undefined":N=F[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${v.slice(0,p+1).join(".")} is ${JSON.stringify(N)}`);return}F=N}if(typeof F=="object"&&F!==null)try{F[w]=r}catch(p){a(`Ignoring ${n} as ${v.join(".")} is ${JSON.stringify(F)}`)}else a(`Ignoring ${n} as ${v.join(".")} is ${JSON.stringify(F)}`)}t.addToValueTree=u;function l(i,n){const r=n.split(".");S(i,r)}t.removeFromValueTree=l;function S(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(S(a,n),Object.keys(a).length===0&&delete i[r])}}function E(i,n,r){function a(F,p){let C=F;for(const N of p){if(typeof C!="object"||C===null)return;C=C[N]}return C}const v=n.split("."),w=a(i,v);return typeof w=="undefined"?r:w}t.getConfigurationValue=E;function h(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?b.isObject(i[a])&&b.isObject(n[a])?h(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=h;function f(){const i=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function o(){const i=Object.create(null),n=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,v=>console.error(`Conflict in default settings: ${v}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),v=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Z[109],te([0,1,20,13,59,2,46,18,10,7,27,33,26]),function($,t,O,b,y,I,D,T,c,g,m,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class R{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,m.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,m.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=T.deepClone(a),this.mergeContents(a,v)):a=v),n[r]=a}return new R(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const v of a.overrides){const[w]=n.filter(F=>O.equals(F.identifiers,v.identifiers));w?this.mergeContents(w.contents,v.contents):n.push(T.deepClone(v))}for(const v of a.keys)r.indexOf(v)===-1&&r.push(v)}return new R(i,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&c.isObject(e[n])&&c.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,m.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,m.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=R;class u extends R{constructor(){const e=(0,m.getDefaultValues)(),i=(0,m.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))P.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,P.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,m.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class l{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new R}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!c.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:v}=this.doParseRaw(e,i);this._configurationModel=new R(n,r,a),this._restrictedConfigurations=v||[]}doParseContent(e){let i={},n=null,r=[],a=[],v=[];function w(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}let F={onObjectBegin:()=>{let p={};w(p),a.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let p=[];w(p),a.push(r),r=p,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(p,C,N)=>{v.push({error:p,offset:C,length:N})}};if(e)try{y.visit(e,F),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const n=d.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,m.toValuesTree)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`)),v=Object.keys(e),w=(0,m.toOverrides)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},v=[];for(let w in e)if(P.OVERRIDE_PROPERTY_PATTERN.test(w)&&n){const F=this.filter(e[w],i,!1,r);a[w]=F.raw,v.push(...F.restricted)}else{const F=i[w],p=F?typeof F.scope!="undefined"?F.scope:3:void 0;F?.restricted&&v.push(w),(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&(r.skipRestricted&&F?.restricted||(a[w]=e[w]))}return{raw:a,restricted:v}}}t.ConfigurationModelParser=l;class S extends I.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new R}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=S;class E{constructor(e,i,n=new R,r=new R,a=new D.ResourceMap,v=new R,w=new D.ResourceMap,F=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=v,this._memoryConfigurationByResource=w,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new R,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,V=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(e):v.getValue(e),ie=r.getValue(e),oe=O.distinct(O.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(e,ee)!==void 0);return{defaultValue:w,userValue:F,userLocalValue:p,userRemoteValue:C,workspaceValue:N,workspaceFolderValue:V,memoryValue:Y,value:ie,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:V!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:v.getValue(e),override:i.overrideIdentifier?v.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>P.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,P.overrideIdentifierFromKey)(r),v=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=e.getKeysForOverrideIdentifier(a),F=[...w.filter(p=>v.indexOf(p)===-1),...v.filter(p=>w.indexOf(p)===-1),...v.filter(p=>!T.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,F]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,m.compare)(this.localUserConfiguration,e),v=[...i,...n,...r];return v.length&&this.updateLocalUserConfiguration(e),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,m.compare)(this.remoteUserConfiguration,e);let v=[...i,...n,...r];return v.length&&this.updateRemoteUserConfiguration(e),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,m.compare)(this.workspaceConfiguration,e);let v=[...i,...n,...r];return v.length&&this.updateWorkspaceConfiguration(e),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:v,overrides:w}=(0,m.compare)(n,i);let F=[...r,...a,...v];return(F.length||!n)&&this.updateFolderConfiguration(e,i),{keys:F,overrides:w}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:v}=(0,m.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((v,w)=>(v.set(g.URI.revive(w[0]),this.parseConfigurationModel(w[1])),v),new D.ResourceMap);return new E(i,n,new R,r,a,new R,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new R(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=E;function h(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,D.getOrSet)(i,a,new Set);v.forEach(F=>w.add(F))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=h;class f{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(w=>a.add(w)),e.overrides.forEach(([,w])=>w.forEach(F=>a.add(F))),this.affectedKeys=[...a.values()];const v=new R;this.affectedKeys.forEach(w=>v.setValue(w,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,m.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=f;class o extends f{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Z[110],te([0,1,3,13,2,19,27,109,33,26]),function($,t,O,b,y,I,D,T,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class m extends y.Disposable{constructor(d,R){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,R)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,R){const u=typeof d=="string"?d:void 0,l=(0,D.isConfigurationOverrides)(d)?d:(0,D.isConfigurationOverrides)(R)?R:{};return this.configuration.getValue(u,l,void 0)}updateValue(d,R,u,l){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const R=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(u,R,1)}onDidDefaultConfigurationChange(d){const R=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,d);this.trigger(u,R,6)}trigger(d,R,u){const l=new T.ConfigurationChangeEvent(d,{data:R},this.configuration);l.source=u,l.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(l)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=m}),define(Z[43],te([0,1,17,84,33,15,26]),function($,t,O,b,y,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,I.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function c(u){return u.res.statusCode===204}async function g(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return c(u)?null:(await(0,O.streamToBuffer)(u.stream)).toString()}t.asText=g;async function m(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(c(u))return null;const S=(await(0,O.streamToBuffer)(u.stream)).toString();try{return JSON.parse(S)}catch(E){throw E.message+=`:
`+S,E}}t.asJson=m;function P(u){R(u)}t.updateProxyConfigurationsScope=P;let d;function R(u){const l=D.Registry.as(y.Extensions.Configuration),S=d;d={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},l.updateConfigurations({add:[d],remove:S?[S]:[]})}R(2)}),define(Z[111],te([0,1,25,8,16,43]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let D=class{constructor(c,g){this.requestService=c,this.fileService=g}async download(c,g,m=O.CancellationToken.None){if(c.scheme===b.Schemas.file||c.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(c,g);return}const P={type:"GET",url:c.toString()},d=await this.requestService.request(P,m);if(d.res.statusCode===200)await this.fileService.writeFile(g,d.stream);else{const R=await(0,I.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${R}`)}}};D=de([le(0,I.IRequestService),le(1,y.IFileService)],D),t.DownloadService=D}),define(Z[112],te([0,1,113,10]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function y(D,T){return D.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:D.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function I(D,T,c={}){const g=(0,O.parse)(D),m=c.proxyUrl||y(g,T);if(!m)return null;const P=(0,O.parse)(m);if(!/^https?:$/.test(P.protocol||""))return null;const d={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,b.isBoolean)(c.strictSSL)?c.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((R,u)=>{$(["http-proxy-agent"],R,u)}))(d):new(await new Promise((R,u)=>{$(["https-proxy-agent"],R,u)}))(d)}t.getProxyAgent=I}),define(Z[114],te([0,1,17,31]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function y(I,D,T){let c=T&&T.get("storage.serviceMachineId",0)||null;if(c)return c;try{const m=(await D.readFile(I.serviceMachineIdResource)).value.toString();c=(0,b.isUUID)(m)?m:null}catch(g){c=null}if(!c){c=(0,b.generateUuid)();try{await D.writeFile(I.serviceMachineIdResource,O.VSBuffer.fromString(c))}catch(g){}}return T&&T.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=y}),define(Z[115],te([0,1,3,13,2,10,66,15]),function($,t,O,b,y,I,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var g;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var m;(function(l){l[l.GLOBAL=0]="GLOBAL",l[l.WORKSPACE=1]="WORKSPACE"})(m=t.StorageScope||(t.StorageScope={}));var P;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(P=t.StorageTarget||(t.StorageTarget={}));class d extends y.Disposable{constructor(S={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,E){E===c?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:E,target:this.getKeyTargets(S)[E]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,E,h){return this.getStorage(E)?.get(S,h)}getBoolean(S,E,h){return this.getStorage(E)?.getBoolean(S,h)}getNumber(S,E,h){return this.getStorage(E)?.getNumber(S,h)}store(S,E,h,f){if((0,I.isUndefinedOrNull)(E)){this.remove(S,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,h,f),this.getStorage(h)?.set(S,E)})}remove(S,E){this.withPausedEmitters(()=>{this.updateKeyTarget(S,E,void 0),this.getStorage(E)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,E){const h=[],f=this.getKeyTargets(S);for(const o of Object.keys(f))f[o]===E&&h.push(o);return h}updateKeyTarget(S,E,h){const f=this.getKeyTargets(E);typeof h=="number"?f[S]!==h&&(f[S]=h,this.getStorage(E)?.set(c,JSON.stringify(f))):typeof f[S]=="number"&&(delete f[S],this.getStorage(E)?.set(c,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const E=this.get(c,S);if(E)try{return JSON.parse(E)}catch(h){}return Object.create(null)}isNew(S){return this.getBoolean(t.IS_NEW_KEY,S)===!0}async flush(S=g.NONE){this._onWillSaveState.fire({reason:S}),await O.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const S=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return u(S,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class R extends d{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}t.InMemoryStorageService=R;async function u(l,S,E,h){const f=a=>{try{return JSON.parse(a)}catch(v){return a}},o=new Map,s=new Map;l.forEach((a,v)=>{o.set(v,a),s.set(v,f(a))});const e=new Map,i=new Map;S.forEach((a,v)=>{e.set(v,a),i.set(v,f(a))}),console.group(`Storage: Global (path: ${E})`);let n=[];o.forEach((a,v)=>{n.push({key:v,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${h})`);let r=[];e.forEach((a,v)=>{r.push({key:v,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Z[116],te([0,1,11,28,7,31]),function($,t,O,b,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function D(g){if(O.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function T(g,m,P,d,R,u,l,S,E,h){const f=Object.create(null);f["common.machineId"]=l,f.sessionID=(0,I.generateUuid)()+Date.now(),f.commitHash=R,f.version=u,f["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,O.PlatformToString)(O.platform),f["common.nodePlatform"]=b.platform,f["common.nodeArch"]=d,f["common.product"]=h||"desktop";const o=c(S||[]);o&&(f["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),O.isLinuxSnap&&(f["common.snap"]="true");const i=D(P);i&&(f["common.platformDetail"]=i);try{const n=await g.readFile(y.URI.file(E));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=T;function c(g){const m=b.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return g.some(d=>P===d)}t.verifyMicrosoftInternalDomain=c}),define(Z[29],te([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,O.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(I){I[I.NONE=0]="NONE",I[I.LOG=1]="LOG",I[I.USER=2]="USER"})(b=t.TelemetryLevel||(t.TelemetryLevel={}));var y;(function(I){I.OFF="off",I.ERROR="error",I.ON="on"})(y=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[117],te([0,1,20,3,25,9,13,2,11,7,74,23,24,14,32,29]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let S=class extends T.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,P.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new P.ExtensionManagementError(m.localize(1,null,s.identifier.id,u.default.nameLong,(0,P.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,I.getErrorMessage)(n)),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,y.CancellationToken.None);if(i===null){const n=new P.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new P.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(m.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!g.URI.isUri(e)){let w=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);g.URI.isUri(e)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let v=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:C}of F)if(v=v||!!C.extensionDependencies?.some(N=>(0,d.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const N=this.createInstallExtensionTask(C,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(N.identifier,C.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:p}),this.logService.info("Installing extension:",N.identifier.id),n.push({task:N,manifest:C})}}catch(F){if(g.URI.isUri(a.source))(0,O.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,F.message),(0,O.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(F),F}const w=n.reduce((F,{task:p,manifest:C})=>(F.set(p.identifier.id.toLowerCase(),{task:p,manifest:C}),F),new Map);for(;w.size;){let F;const p=[...w.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(N=>w.has(N.toLowerCase())));p.length?F=w.size===1?p:p.filter(({task:C})=>!(C===a&&!v)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:C})=>C.identifier.id)),F=[...w.values()]),await this.joinAllSettled(F.map(async({task:C})=>{const N=new Date().getTime();try{const V=await C.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(V,C.source,i,y.CancellationToken.None))),!g.URI.isUri(C.source)&&(h(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,void 0),c.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch(Y){}r.push({local:V,identifier:C.identifier,operation:C.operation,source:C.source})}catch(V){throw g.URI.isUri(C.source)||h(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,V),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(V),V}finally{w.delete(C.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:F})=>(0,d.areSameExtensions)(F,a.identifier))[0].local}catch(w){if(n.forEach(({task:F})=>F.cancel()),r.length)try{const F=await Promise.allSettled(r.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<F.length;p++){const C=F[p],{identifier:N}=r[p];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,I.getErrorMessage)(C.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(F),r.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,I.getErrorMessage)(w)),this._onDidInstallExtensions.fire(n.map(({task:F})=>({identifier:F.identifier,operation:1,source:F.source}))),w instanceof Error&&(w.name=w&&w.code?w.code:t.ERROR_UNKNOWN),w}finally{for(const{task:w,manifest:F}of n)if(!g.URI.isUri(w.source)){const p=new d.ExtensionIdentifierWithVersion(w.identifier,F.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw E(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(w=>w.identifier)],a=[],v=async(w,F)=>{const p=F.extensionDependencies||[],C=[...p];if(F.extensionPack){const N=i?n.find(V=>(0,d.areSameExtensions)(V.identifier,w)):void 0;for(const V of F.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(Y=>(0,d.areSameExtensions)({id:Y},{id:V}))||C.every(Y=>!(0,d.areSameExtensions)({id:Y},{id:V}))&&C.push(V)}if(C.length){const N=[...r,...a.map(Y=>Y.gallery.identifier)],V=C.filter(Y=>N.every(ie=>!(0,d.areSameExtensions)(ie,{id:Y})));if(V.length){const Y=await this.galleryService.query({names:V,pageSize:C.length},y.CancellationToken.None);for(const ie of Y.firstPage){if(N.find(ce=>(0,d.areSameExtensions)(ce,ie.identifier)))continue;if(!p.some(ce=>(0,d.areSameExtensions)({id:ce},ie.identifier))&&!await this.canInstall(ie)){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}const ee=await this.checkAndGetCompatibleVersion(ie,!0),ue=await this.galleryService.getManifest(ee,y.CancellationToken.None);if(ue===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${ee.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:ee,manifest:ue}),await v(ee.identifier,ue)}}}};return await v(s,e),n=await this.getInstalled(),a.filter(w=>!n.some(F=>(0,d.areSameExtensions)(F.identifier,w.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new P.ExtensionManagementError(m.localize(4,null,s.identifier.id),P.INSTALL_ERROR_MALICIOUS);const i=await this.getTargetPlatform();let n=null;if(await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),!n)throw new P.ExtensionManagementError(m.localize(5,null,s.identifier.id,u.default.version),P.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(w,F)=>{const p=this.createUninstallExtensionTask(w,F);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),p},r=(w,F)=>{F?this.logService.error("Failed to uninstall extension:",w.identifier.id,F.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),h(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(w),void 0,F),this._onDidUninstallExtension.fire({identifier:w.identifier,error:F?.code})},a=[],v=[];try{a.push(n(s,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const F=this.getAllPackExtensionsToUninstall(s,w);for(const p of F)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(n(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(F=>F.extension),w,s),await this.joinAllSettled(a.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(F.extension,e,y.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch(p){}r(F.extension)}catch(p){const C=p instanceof P.ExtensionManagementError?p:new P.ExtensionManagementError((0,I.getErrorMessage)(p),t.ERROR_UNKNOWN);throw r(F.extension,C),C}finally{v.push(F)}}))}catch(w){const F=w instanceof P.ExtensionManagementError?w:new P.ExtensionManagementError((0,I.getErrorMessage)(w),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(C){}v.includes(p)||r(p.extension,F)}throw F}finally{for(const w of a)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(v=>!s.some(w=>(0,d.areSameExtensions)(w.identifier,v.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?m.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?m.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(v=>!v.isBuiltin&&n.some(w=>(0,d.areSameExtensions)({id:w},v.identifier))),a=[];for(const v of r)a.push(...this.getAllPackExtensionsToUninstall(v,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,d.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},y.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};S=de([le(0,P.IExtensionGalleryService),le(1,l.ITelemetryService),le(2,R.ILogService)],S),t.AbstractExtensionManagementService=S;function E(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=E;function h(o,s,e,i,n){const r=n?n instanceof P.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=h;class f{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=f}),define(Z[36],te([0,1,3,18,10,27,29]),function($,t,O,b,y,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryConfiguration=t.getTelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(E,h){return Promise.resolve(void 0)}publicLog2(E,h){return this.publicLog(E,h)}publicLogError(E,h){return Promise.resolve(void 0)}publicLogError2(E,h){return this.publicLogError(E,h)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(h,f,o){}async publicLogError(h,f,o){}}t.NullEndpointTelemetryService=T;function c(...E){return{log:(h,f)=>E.forEach(o=>o.log(h,f)),flush:()=>O.Promises.settled(E.map(h=>h.flush()))}}t.combinedAppender=c,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(E,h){return h.onDidChangeConfiguration(f=>{f.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(f.source),configurationKeys:l(f.sourceConfig)})})}t.configurationTelemetry=g;function m(E,h){return h.disableTelemetry||!E.enableTelemetry?0:h.isBuilt?2:1}t.getTelemetryLevel=m;function P(E){const h=E.getValue(D.TELEMETRY_SETTING_ID),f=E.getValue(D.TELEMETRY_OLD_SETTING_ID);return f!==void 0&&f===!1?"off":h??"on"}t.getTelemetryConfiguration=P;function d(E){const h=Object.create(null),f=Object.create(null),o=Object.create(null);u(E,o);for(let s in o){s=s.length>150?s.substr(s.length-149):s;const e=o[s];typeof e=="number"?f[s]=e:typeof e=="boolean"?f[s]=e?1:0:typeof e=="string"?h[s]=e.substring(0,1023):typeof e!="undefined"&&e!==null&&(h[s]=e)}return{properties:h,measurements:f}}t.validateTelemetryData=d;function R(E){if(!E)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{E.indexOf(`${o}+`)===0&&(h=o)}),h}t.cleanRemoteAuthority=R;function u(E,h,f=0,o){if(!!E)for(let s of Object.getOwnPropertyNames(E)){const e=E[s],i=o?o+s:s;Array.isArray(e)?h[i]=(0,b.safeStringify)(e):e instanceof Date?h[i]=e.toISOString():(0,y.isObject)(e)?f<2?u(e,h,f+1,i+"."):h[i]=(0,b.safeStringify)(e):h[i]=e}}function l(E){if(!E)return[];const h=[];return S(h,"",E),h}function S(E,h,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(o=>S(E,h?`${h}.${o}`:o,f[o])):E.push(h)}}),define(Z[118],te([0,1,20,25,9,18,11,28,7,27,21,23,24,51,16,14,42,43,114,115,29,36]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l,S,E,h,f,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=D.isWeb?"web":(0,P.getTargetPlatform)(D.platform,T.arch);var i;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...k){return String(k.reduce((A,j)=>A|j,0))}var r;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},F={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class p{constructor(A=F){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,j=this.state.pageSize){return new p({...this.state,pageNumber:A,pageSize:j})}withFilter(A,...j){const W=[...this.state.criteria,...j.length?j.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new p({...this.state,criteria:W})}withSortBy(A){return new p({...this.state,sortBy:A})}withSortOrder(A){return new p({...this.state,sortOrder:A})}withFlags(...A){return new p({...this.state,flags:A.reduce((j,W)=>j|W,0)})}withAssetTypes(...A){return new p({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:j,pageSize:W,sortBy:X,sortOrder:Q,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:A,pageNumber:j,pageSize:W,sortBy:X,sortOrder:Q}],assetTypes:re,flags:se}}get searchText(){const A=this.state.criteria.filter(j=>j.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function C(k,A){const j=(k||[]).filter(W=>W.statisticName===A)[0];return j?j.value:0}function N(k){const A="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(W=>W.assetType.indexOf(A)===0).reduce((W,X)=>{const Q=oe(k,X.assetType);return Q&&W.push([X.assetType.substring(A.length),Q]),W},[])}function V(k){if(k.properties){const A=k.properties.filter(X=>X.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=A.filter(X=>j.test(X.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(k,a.Repository)}function Y(k){return{uri:`${k.fallbackAssetUri}/${a.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${a.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function ie(k){const A=oe(k,a.Icon);if(A)return A;const j=P.DefaultIconPath;return{uri:j,fallbackUri:j}}function oe(k,A){return k.files.filter(W=>W.assetType===A)[0]?{uri:`${k.assetUri}/${A}`,fallbackUri:`${k.fallbackAssetUri}/${A}`}:null}function ee(k,A){const j=k.properties?k.properties.filter(X=>X.key===A):[],W=j.length>0&&j[0].value;return W?W.split(",").map(X=>(0,d.adoptToGalleryExtensionId)(X)):[]}function ue(k){const A=k.properties?k.properties.filter(j=>j.key===v.Engine):[];return A.length>0&&A[0].value||""}function ce(k){const A=k.properties?k.properties.filter(W=>W.key===v.LocalizedLanguages):[],j=A.length>0&&A[0].value||"";return j?j.split(","):[]}function G(k){return k.indexOf("preview")!==-1}function ne(k){return k.targetPlatform?(0,P.toTargetPlatform)(k.targetPlatform):"undefined"}function z(k){const A=(0,O.distinct)(k.versions.map(ne)),j=!!k.tags?.includes(P.WEB_EXTENSION_TAG),W=A.indexOf("web");return j?W===-1&&A.push("web"):W!==-1&&A.splice(W,1),A}function L(k,A){const j=(0,P.getFallbackTargetPlarforms)(A);for(let W=0;W<k.length;W++){const X=k[W];if(X.version===k[W-1]?.version){let Q=W;const se=ne(X);if(se===A)for(;Q>0&&k[Q-1].version===X.version;)Q--;else if(j.includes(se))for(;Q>0&&k[Q-1].version===X.version&&ne(k[Q-1])!==A;)Q--;Q!==W&&(k.splice(W,1),k.splice(Q,0,X))}}return k}t.sortExtensionVersions=L;function M(k,A,j,W,X){const Q=z(k);let se=k.versions[0];return se=k.versions.find(re=>re.version===se.version&&(0,P.isTargetPlatformCompatible)(ne(re),Q,X))||se,U(k,se,Q,A,j,W)}function U(k,A,j,W,X,Q){const se={manifest:oe(A,a.Manifest),readme:oe(A,a.Details),changelog:oe(A,a.Changelog),license:oe(A,a.License),repository:V(A),download:Y(A),icon:ie(A),coreTranslations:N(A)};return{identifier:{id:(0,d.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:A.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:C(k.statistics,"install"),rating:C(k.statistics,"averagerating"),ratingCount:C(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:j,assets:se,properties:{dependencies:ee(A,v.Dependency),extensionPack:ee(A,v.ExtensionPack),engine:ue(A),localizedLanguages:ce(A),targetPlatform:ne(A)},preview:G(k.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+W,querySource:Q}}}let K=class{constructor(A,j,W,X,Q,se,re,me){this.requestService=j,this.logService=W,this.environmentService=X,this.telemetryService=Q,this.fileService=se,this.productService=re,this.configurationService=me;const Ee=re.extensionsGallery;this.extensionsGalleryUrl=Ee&&Ee.serviceUrl,this.extensionsControlUrl=Ee&&Ee.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,j){const W=[];let X=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(X,e,b.CancellationToken.None);for(let se=0;se<Q.length;se++){const re=Q[se];if(!re.versions.length)continue;const me=(0,d.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),Ee=A.find(fe=>(0,d.areSameExtensions)(fe,{id:me}))?.version;if(Ee){const fe=re.versions.find(Ie=>Ie.version===Ee);fe&&W.push(U(re,fe,z(re),se,X))}else W.push(M(re,se,X,void 0,e))}return W}async getCompatibleExtension(A,j){const W=(0,P.isIExtensionIdentifier)(A)?null:A;if(W){if((0,P.isNotWebExtensionInWebTargetPlatform)(W.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(W,j))return W}const{id:X,uuid:Q}=W?W.identifier:A;let se=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,j,b.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const Ee=z(me);if((0,P.isNotWebExtensionInWebTargetPlatform)(Ee,j))return null;for(let fe of me.versions){if(!ue(fe)){const Ie=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:v.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(fe,Ee,j))return U(me,fe,Ee,0,se)}return null}async isExtensionCompatible(A,j){if(!(0,P.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,j))return!1;let W=A.properties.engine;if(!W){const X=await this.getManifest(A,b.CancellationToken.None);if(!X)throw new Error("Manifest was not found");W=X.engines.vscode}return(0,R.isEngineValid)(W,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,j,W){if(!(0,P.isTargetPlatformCompatible)(ne(A),j,W))return!1;const X=await this.getEngine(A);return(0,R.isEngineValid)(X,this.productService.version,this.productService.date)}async query(A,j){const W=b.CancellationToken.isCancellationToken(A)?{}:A,X=b.CancellationToken.isCancellationToken(A)?A:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=W.text||"";const se=(0,I.getOrDefault)(W,pe=>pe.pageSize,50);let re=new p().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ye,Ae)=>(re=re.withFilter(r.Category,Ae||ye),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ye,Ae)=>(re=re.withFilter(r.Tag,Ae||ye),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),re=re.withFilter(r.SearchText,Q)),re=re.withSortBy(0)):W.ids?re=re.withFilter(r.ExtensionId,...W.ids):W.names?re=re.withFilter(r.ExtensionName,...W.names):re=re.withSortBy(4),typeof W.sortBy=="number"&&(re=re.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(re=re.withSortOrder(W.sortOrder));const{galleryExtensions:me,total:Ee}=await this.queryGallery(re,e,X),fe=me.map((pe,ye)=>M(pe,ye,re,W.source,e)),Ie=async(pe,ye)=>{if(ye.isCancellationRequested)throw(0,y.canceled)();const Ae=re.withPage(pe+1),{galleryExtensions:Me}=await this.queryGallery(Ae,e,ye);return Me.map((Ue,ze)=>M(Ue,ze,Ae,W.source,e))};return{firstPage:fe,total:Ee,pageSize:re.pageSize,getPage:Ie}}async queryGallery(A,j,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},re=new Date().getTime();let me,Ee,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},W),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Ie=await(0,E.asJson)(me);if(Ie){const pe=Ie.results[0],ye=pe.extensions;ye.forEach(Me=>L(Me.versions,j));const Ae=pe.resultMetadata&&pe.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Ae&&Ae.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:fe}}return{galleryExtensions:[],total:fe}}catch(Ie){throw Ee=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-re,success:!!me&&(0,E.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:Ee?(0,y.isPromiseCanceledError)(Ee)?"canceled":(0,y.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,j,W,X){if(!this.isEnabled())return;const Q=D.isWeb?this.api(`/itemName/${A}.${j}/version/${W}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${j}/${W}/stats?statType=${X}`),se=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},b.CancellationToken.None)}catch(Ee){}}async download(A,j,W){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,d.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=W===1?"install":W===2?"update":"",me=re?{uri:`${A.assets.download.uri}${c.URI.parse(A.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${A.assets.download.fallbackUri}${c.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:A.assets.download,Ee=await this.getAsset(me);await this.fileService.writeFile(j,Ee.stream),se(new Date().getTime()-Q)}async getReadme(A,j){if(A.assets.readme){const W=await this.getAsset(A.assets.readme,{},j);return await(0,E.asText)(W)||""}return""}async getManifest(A,j){if(A.assets.manifest){const W=await this.getAsset(A.assets.manifest,{},j),X=await(0,E.asText)(W);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,j){const W=oe(A,a.Manifest);if(!W)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(W,{headers:X});return await(0,E.asJson)(Q)}async getCoreTranslation(A,j){const W=A.assets.coreTranslations.filter(X=>X[0]===j.toUpperCase())[0];if(W){const X=await this.getAsset(W[1]),Q=await(0,E.asText)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(A,j){if(A.assets.changelog){const W=await this.getAsset(A.assets.changelog,{},j);return await(0,E.asText)(W)||""}return""}async getAllCompatibleVersions(A,j){let W=new p().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?W=W.withFilter(r.ExtensionId,A.identifier.uuid):W=W.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryGallery(W,j,b.CancellationToken.None);if(!X.length)return[];const Q=z(X[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(Q,j))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Q,j)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(A,j={},W=b.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},se={...X,...j.headers||{}};j={...j,...Q,headers:se};const re=A.uri,me=A.fallbackUri,Ee={...j,url:re};try{const fe=await this.requestService.request(Ee,W);if(fe.res.statusCode===200)return fe;const Ie=await(0,E.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Ie}`)}catch(fe){if((0,y.isPromiseCanceledError)(fe))throw fe;const Ie=(0,y.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Ie});const pe={...j,url:me};return this.requestService.request(pe,W)}}async getEngine(A){let j=ue(A);if(!j){const W=await this.getManifestFromRawExtensionVersion(A,b.CancellationToken.None);if(!W)throw new Error("Manifest was not found");j=W.engines.vscode}return j}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,E.asJson)(A),W=new Map;if(j)for(const X of j.malicious){const Q=W.get(X)||{id:{id:X},malicious:!0,slow:!1};Q.malicious=!0,W.set(X,Q)}return[...W.values()]}};K=de([le(1,E.IRequestService),le(2,l.ILogService),le(3,m.IEnvironmentService),le(4,o.ITelemetryService),le(5,u.IFileService),le(6,S.IProductService),le(7,g.IConfigurationService)],K);let B=class extends K{constructor(A,j,W,X,Q,se,re,me){super(A,j,W,X,Q,se,re,me)}};B=de([le(0,f.IStorageService),le(1,E.IRequestService),le(2,l.ILogService),le(3,m.IEnvironmentService),le(4,o.ITelemetryService),le(5,u.IFileService),le(6,S.IProductService),le(7,g.IConfigurationService)],B),t.ExtensionGalleryService=B;let J=class extends K{constructor(A,j,W,X,Q,se,re){super(void 0,A,j,W,X,Q,se,re)}};J=de([le(0,E.IRequestService),le(1,l.ILogService),le(2,m.IEnvironmentService),le(3,o.ITelemetryService),le(4,u.IFileService),le(5,S.IProductService),le(6,g.IConfigurationService)],J),t.ExtensionGalleryServiceWithNoStorageService=J;async function q(k,A,j,W,X,Q){const se={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},re=await(0,h.getServiceMachineId)(j,X,Q);return(0,s.getTelemetryLevel)(A,j)>=2&&(0,s.getTelemetryConfiguration)(W)==="on"&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=q}),define(Z[119],te([0,1,2,18,22,85,27,33,32,26,29,36]),function($,t,O,b,y,I,D,T,c,g,m,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(u,l){this._configurationService=l,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,y.escapeRegExpCharacters)(S),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const E=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})})}setExperimentProperty(u,l){this._experimentProperties[u]=l}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=(0,P.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=u!=="off",this._userOptIn=u==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let l=u.sessionID,S=u["common.instanceId"],E=u["common.machineId"],h=u["common.firstSessionDate"],f=u["common.msftInternal"];return{sessionId:l,instanceId:S,machineId:E,firstSessionDate:h,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(u,l,S){return this.isOptedIn?this._commonProperties.then(E=>{l=(0,b.mixin)(l,E),l=(0,b.mixin)(l,this._experimentProperties),l=(0,b.cloneAndChange)(l,h=>{if(typeof h=="string")return this._cleanupInfo(h,S)}),this._appender.log(u,l)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(u,l,S){return this.publicLog(u,l,S)}publicLogError(u,l){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(u,l,!0)}publicLogError2(u,l){return this.publicLogError(u,l)}_anonymizeFilePaths(u){let l=u;const S=[];for(let o of this._cleanupPatterns)for(;;){const s=o.exec(u);if(!s)break;S.push([s.index,o.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(l="";;){const o=h.exec(u);if(!o)break;!E.test(o[0])&&S.every(([s,e])=>o.index<s||o.index>=e)&&(l+=u.substring(f,o.index)+"<REDACTED: user-file-path>",f=h.lastIndex)}return f<u.length&&(l+=u.substr(f)),l}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const l=u.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(l)?"<REDACTED: secret>":S.test(l)?"<REDACTED: email>":u}_cleanupInfo(u,l){let S=u;l&&(S=this._anonymizeFilePaths(S));for(let E of this._cleanupPatterns)S=S.replace(E,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=de([le(1,D.IConfigurationService)],d),t.TelemetryService=d,g.Registry.as(T.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(0,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,I.localize)(1,null),(0,I.localize)(2,null),(0,I.localize)(3,null)],markdownDescription:c.default.privacyStatementUrl?(0,I.localize)(5,null,c.default.nameLong,c.default.privacyStatementUrl):(0,I.localize)(4,null,c.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(T.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(6,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,I.localize)(8,null,c.default.nameLong,c.default.privacyStatementUrl):(0,I.localize)(7,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(9,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[120],te([0,1,9,18,36]),function($,t,O,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function I(T){const c=await new Promise((m,P)=>{$(["applicationinsights"],m,P)});let g;return c.defaultClient?(g=new c.TelemetryClient(T),g.channel.setUseDiskRetryCaching(!0)):(c.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=c.defaultClient),T.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class D{constructor(c,g,m){this._eventPrefix=c,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof m=="function"?this._aiClient=m():this._aiClient=m,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient)),this._asyncAIClient.then(g=>{c(g)},g=>{(0,O.onUnexpectedError)(g),console.error(g)})}}log(c,g){!this._aiClient||(g=(0,b.mixin)(g,this._defaultData),g=(0,y.validateTelemetryData)(g),this._withAIClient(m=>m.trackEvent({name:this._eventPrefix+"/"+c,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=D}),define(Z[121],te([0,1,4,12]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function y(I,D){const T=Object.create(null),c=(m,P)=>{const d=JSON.parse(m);T[P]=d};if(D){const m=[],P=await b.Promises.readdir(D);for(const R of P)try{(await b.Promises.stat((0,O.join)(D,R))).isDirectory()&&m.push(R)}catch{}const d=[];for(const R of m)(await b.Promises.readdir((0,O.join)(D,R))).filter(l=>l==="telemetry.json").length===1&&d.push(R);for(const R of d){const u=(await b.Promises.readFile((0,O.join)(D,R,"telemetry.json"))).toString();c(u,R)}}let g=(await b.Promises.readFile((0,O.join)(I,"telemetry-core.json"))).toString();return c(g,"vscode-core"),g=(await b.Promises.readFile((0,O.join)(I,"telemetry-extensions.json"))).toString(),c(g,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=y}),define(Z[44],te([0,1,48,3,4,10,12,72,132,133]),function($,t,O,b,y,I,D,T,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class m extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=m;function P(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function d(s){if(s instanceof m)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new m(e,s)}function R(s,e,i,n,r,a){const v=y.dirname(e),w=y.join(n,v);if(!w.startsWith(n))return Promise.reject(new Error(T.localize(0,null,e)));const F=y.join(n,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(D.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((C,N)=>{if(!a.isCancellationRequested)try{p=(0,O.createWriteStream)(F,{mode:i}),p.once("close",()=>C()),p.once("error",N),s.once("error",N),s.pipe(p)}catch(V){N(V)}}))}function u(s,e,i,n){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((v,w)=>{const F=new b.Sequencer,p=C=>{C.isCancellationRequested||(a++,s.readEntry())};s.once("error",w),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?v():w(new m("Incomplete",new Error(T.localize(1,null,a,s.entryCount))))},w)),s.readEntry(),s.on("entry",C=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){p(n);return}const N=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const ie=y.join(e,N);r=(0,b.createCancelablePromise)(oe=>D.Promises.mkdir(ie,{recursive:!0}).then(()=>p(oe)).then(void 0,w));return}const V=S(s,C),Y=P(C);r=(0,b.createCancelablePromise)(ie=>F.queue(()=>V.then(oe=>R(oe,N,Y,e,i,ie).then(()=>p(ie)))).then(null,w))})})}function l(s,e=!1){return new Promise((i,n)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(d(r)):i((0,I.assertIsDefined)(a))})})}function S(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(d(r)):i((0,I.assertIsDefined)(a))})})}function E(s,e){return new Promise((i,n)=>{const r=new g.ZipFile;e.forEach(v=>{v.contents?r.addBuffer(typeof v.contents=="string"?Buffer.from(v.contents,"utf8"):v.contents,v.path):v.localPath&&r.addFile(v.localPath,v.path)}),r.end();const a=(0,O.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=E;function h(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=l(s,!0);return i.overwrite&&(a=a.then(v=>D.Promises.rm(e).then(()=>v))),a.then(v=>u(v,e,{sourcePathRegex:r},n))}t.extract=h;function f(s,e){return l(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&S(i,a).then(v=>n(v),v=>r(v))}),i.once("close",()=>r(new Error(T.localize(2,null,e))))}))}function o(s,e){return f(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",v=>a.push(v)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(Z[122],te([0,1,44,78]),function($,t,O,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function y(I){return(0,O.buffer)(I,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(T){throw new Error((0,b.localize)(0,null))}})}t.getManifest=y}),define(Z[123],te([0,1,20,3,9,2,8,4,11,19,41,7,31,12,44,79,21,23,24,90,16,14,42]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l,S,E,h,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",v="renaming";let w=class extends I.Disposable{constructor(p,C,N,V,Y){super();this.beforeRemovingExtension=p,this.fileService=C,this.logService=N,this.environmentService=V,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=V.builtinExtensionsPath,this.extensionsPath=V.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const C=[];(p===null||p===0)&&C.push(this.scanSystemExtensions().then(null,N=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(N).message,i)))),(p===null||p===1)&&C.push(this.scanUserExtensions(!0).then(null,N=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(N).message,n))));try{const N=await Promise.all(C);return(0,O.flatten)(N)}catch(N){throw this.joinErrors(N)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[C,N]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return N=N.filter(V=>!C[new h.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).key()]),p&&(N=(0,h.groupByExtension)(N,Y=>Y.identifier).map(Y=>Y.sort((ie,oe)=>m.rcompare(ie.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",N.length),N}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,C,N,V){const Y=p.key(),ie=T.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),oe=T.join(this.extensionsPath,Y);try{await R.Promises.rm(oe)}catch(ue){try{await R.Promises.rm(oe)}catch(ce){}throw new E.ExtensionManagementError((0,l.localize)(0,null,oe,p.id),a)}await this.extractAtLocation(p,C,ie,V);let ee=await this.scanExtension(P.URI.file(ie),1);if(!ee)throw new Error((0,l.localize)(1,null,ie));await this.storeMetadata(ee,{...N,installedTimestamp:Date.now()});try{await this.rename(p,ie,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(ue){try{await R.Promises.rm(ie)}catch(ce){}if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,y.getErrorMessage)(ue)}. Deleted from extracted location`,ie),ue}try{ee=await this.scanExtension(P.URI.file(oe),1)}catch(ue){}if(ee)return ee;throw new Error((0,l.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,C){return this.setMetadata(p,C),await this.storeMetadata(p,{...C,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const N=T.join(p.location.fsPath,"package.json"),V=await R.Promises.readFile(N,"utf8"),{manifest:Y}=await this.parseManifest(V);return Y.__metadata=C,await R.Promises.writeFile(N,JSON.stringify(Y,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const C=p.map(N=>new h.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version));await this.withUninstalledExtensions(N=>{C.forEach(V=>N[V.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(V=>delete V[p.key()]);const N=(await this.scanExtensions(1)).find(V=>new h.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).equals(p))||null;return N?(await this.storeMetadata(N,{installedTimestamp:Date.now()}),this.scanExtension(N.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await R.Promises.readFile(this.uninstalledPath,"utf8")}catch(V){if(V.code!=="ENOENT")throw V}let N={};if(C)try{N=JSON.parse(C)}catch(V){}return p&&(p(N),Object.keys(N).length?await R.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await R.Promises.rm(this.uninstalledPath)),N})}async removeExtension(p,C){this.logService.trace(`Deleting ${C} extension from disk`,p.identifier.id,p.location.fsPath),await R.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new h.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,C,N,V){this.logService.trace(`Started extracting the extension from ${C} to ${N}`);try{await R.Promises.rm(N)}catch(Y){throw new E.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,u.extract)(C,N,{sourcePath:"extension",overwrite:!0},V),this.logService.info(`Extracted extension to ${N}:`,p.id)}catch(Y){try{await R.Promises.rm(N)}catch(ie){}throw new E.ExtensionManagementError(Y.message,Y instanceof u.ExtractError&&Y.type?Y.type:r)}}async rename(p,C,N,V){try{await R.Promises.rename(C,N)}catch(Y){if(c.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<V)return this.logService.info(`Failed renaming ${C} to ${N} with 'EPERM' error. Trying again...`,p.id),this.rename(p,C,N,V);throw new E.ExtensionManagementError(Y.message||(0,l.localize)(3,null,C,N),Y.code||v)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const C=this.scanDevSystemExtensions(),[N,V]=await Promise.all([p,C]);return[...N,...V]}async scanExtensionsInDir(p,C){const N=new b.Limiter(10),V=await this.fileService.resolve(P.URI.file(p));return V.children?(await Promise.all(V.children.filter(ie=>ie.isDirectory).map(ie=>N.queue(async()=>C===1&&(0,g.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,C))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(p,C){try{const N=await this.fileService.resolve(p);if(N.children){const{manifest:V,metadata:Y}=await this.readManifest(p.fsPath),ie=N.children.find(({name:ce})=>/^readme(\.txt|\.md|)$/i.test(ce))?.resource,oe=N.children.find(({name:ce})=>/^changelog(\.txt|\.md|)$/i.test(ce))?.resource,ee={id:(0,h.getGalleryExtensionId)(V.publisher,V.name)},ue={type:C,identifier:ee,manifest:V,location:p,readmeUrl:ie,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return Y&&(this.setMetadata(ue,Y),ue.installedTimestamp=Y.installedTimestamp),ue}}catch(N){C!==0&&this.logService.trace(N)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(N=>p.some(V=>(0,h.areSameExtensions)(N.identifier,{id:V})))}else return[]}setMetadata(p,C){p.publisherDisplayName=C.publisherDisplayName||null,p.publisherId=C.publisherId||null,p.identifier.uuid=C.id,p.isMachineScoped=!!C.isMachineScoped,p.isBuiltin=p.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),N=new Set;for(const ie of C)p[new h.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||N.add(ie.identifier.id.toLowerCase());const V=(0,h.groupByExtension)(C,ie=>ie.identifier);await b.Promises.settled(V.map(async ie=>{const oe=ie.sort((ee,ue)=>m.rcompare(ee.manifest.version,ue.manifest.version))[0];N.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const Y=C.filter(ie=>p[new h.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await b.Promises.settled(Y.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),C=[],N=(0,h.groupByExtension)(p,V=>V.identifier);C.push(...(0,O.flatten)(N.map(V=>V.sort((Y,ie)=>m.rcompare(Y.manifest.version,ie.manifest.version)).slice(1)))),await b.Promises.settled(C.map(V=>this.removeExtension(V,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const C=Array.isArray(p)?p:[p];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((N,V)=>new Error(`${N.message}${N.message?",":""}${V instanceof Error?V.message:V}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const C=[R.Promises.readFile(T.join(p,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),R.Promises.readFile(T.join(p,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:N,metadata:V},Y]=await Promise.all(C);return{manifest:(0,f.localizeManifest)(N,Y),metadata:V}}parseManifest(p){return new Promise((C,N)=>{try{const V=JSON.parse(p),Y=V.__metadata||null;C({manifest:V,metadata:Y})}catch(V){N(new Error((0,l.localize)(4,null)))}})}};w=de([le(1,o.IFileService),le(2,s.ILogService),le(3,S.INativeEnvironmentService),le(4,e.IProductService)],w),t.ExtensionsScanner=w}),define(Z[124],te([0,1,30,9,8,4,11,28,19,41,7,31,12,44,77,53,21,117,23,24,101,102,122,97,123,103,51,16,15,14,32,29]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l,S,E,h,f,o,s,e,i,n,r,a,v,w,F,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const N="unsetUninstalled",V="downloading";let Y=class extends E.AbstractExtensionManagementService{constructor(G,ne,z,L,M,U,K){super(G,ne,z);this.environmentService=L,this.downloadService=M,this.fileService=K;const B=this._register(U.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(n.ExtensionsScanner,q=>B.postUninstall(q))),this.manifestCache=this._register(new i.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(U.createInstance(o.ExtensionsDownloader));const J=this._register(new r.ExtensionsWatcher(this,K,L,z));this._register(J.onDidChangeExtensionsByAnotherSource(({added:q,removed:k})=>{q.length&&this._onDidInstallExtensions.fire(q.map(A=>({identifier:A.identifier,operation:0,local:A}))),k.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const G=await this.isAlpineLinux(),ne=(0,h.getTargetPlatform)(G?"alpine":D.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let G;try{G=(await this.fileService.readFile(m.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{G=(await this.fileService.readFile(m.URI.file("/usr/lib/os-release"))).value.toString()}catch(z){this.logService.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(z))}}return!!G&&(G.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const ne=await this.collectFiles(G),z=await(0,R.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)()).fsPath,ne);return m.URI.file(z)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const ne=await this.downloadVsix(G),z=I.resolve(ne.fsPath);return(0,e.getManifest)(z)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async install(G,ne={}){this.logService.trace("ExtensionManagementService#install",G.toString());const z=await this.downloadVsix(G),L=await(0,e.getManifest)(I.resolve(z.fsPath));if(L.engines&&L.engines.vscode&&!(0,a.isEngineValid)(L.engines.vscode,p.default.version,p.default.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(L.publisher,L.name),p.default.version));return this.installExtension(L,z,ne)}async updateMetadata(G,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),G}async updateExtensionScope(G,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===y.Schemas.file)return G;const ne=(0,c.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)());return await this.downloadService.download(G,ne),ne}createInstallExtensionTask(G,ne,z){return m.URI.isUri(ne)?new ee(G,ne,z,this.galleryService,this.extensionsScanner,this.logService):new oe(ne,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,ne){return new ue(G,ne,this.extensionsScanner)}async collectFiles(G){const ne=async L=>{let M=await d.Promises.readdir(L);M=M.map(B=>I.join(L,B));const U=await Promise.all(M.map(B=>d.Promises.stat(B)));let K=Promise.resolve([]);return U.forEach((B,J)=>{const q=M[J];B.isFile()&&(K=K.then(k=>[...k,q])),B.isDirectory()&&(K=K.then(k=>ne(q).then(A=>[...k,...A])))}),K};return(await ne(G.location.fsPath)).map(L=>({path:`extension/${I.relative(G.location.fsPath,L)}`,localPath:L}))}};Y=de([le(0,h.IExtensionGalleryService),le(1,C.ITelemetryService),le(2,F.ILogService),le(3,S.INativeEnvironmentService),le(4,l.IDownloadService),le(5,w.IInstantiationService),le(6,v.IFileService)],Y),t.ExtensionManagementService=Y;class ie extends E.AbstractExtensionTask{constructor(G,ne,z,L){super();this.identifier=G,this.source=ne,this.extensionsScanner=z,this.logService=L,this._operation=1}get operation(){return this._operation}async installExtension(G,ne){try{const z=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(z)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,G.metadata):z}catch(z){throw D.isMacintosh?new h.ExtensionManagementError(u.localize(1,null),N):new h.ExtensionManagementError(u.localize(2,null),N)}return this.extract(G,ne)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const z=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),z}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:ne,metadata:z},L){let M=await this.extensionsScanner.extractUserExtension(ne,G,z,L);return this.logService.info("Extracting completed.",ne.id),M}}class oe extends ie{constructor(G,ne,z,L,M){super(G.identifier,G,L,M);this.gallery=G,this.options=ne,this.extensionsDownloader=z}async doRun(G){const z=(await this.extensionsScanner.scanExtensions(null)).find(U=>(0,f.areSameExtensions)(U.identifier,this.gallery.identifier));z&&(this._operation=2);const L=await this.downloadInstallableExtension(this.gallery,this._operation);L.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,L.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;const M=await this.installExtension(L,G);z&&g.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z);try{await this.extensionsDownloader.delete(m.URI.file(L.zipPath))}catch(U){}return M}async downloadInstallableExtension(G,ne){const z={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let L;try{this.logService.trace("Started downloading extension:",G.identifier.id),L=(await this.extensionsDownloader.downloadExtension(G,ne)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,L)}catch(M){throw new h.ExtensionManagementError((0,E.joinErrors)(M).message,V)}try{const M=await(0,e.getManifest)(L);return{zipPath:L,identifierWithVersion:new f.ExtensionIdentifierWithVersion(G.identifier,M.version),metadata:z}}catch(M){throw new h.ExtensionManagementError((0,E.joinErrors)(M).message,E.INSTALL_ERROR_VALIDATING)}}}class ee extends ie{constructor(G,ne,z,L,M,U){super({id:(0,f.getGalleryExtensionId)(G.publisher,G.name)},ne,M,U);this.manifest=G,this.location=ne,this.options=z,this.galleryService=L}async doRun(G){const ne=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),L=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,f.areSameExtensions)(this.identifier,U.identifier)),M=await this.getMetadata(this.identifier.id,G);if(M.isMachineScoped=this.options.isMachineScoped||L?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||L?.isBuiltin,L)if(this._operation=2,ne.equals(new f.ExtensionIdentifierWithVersion(L.identifier,L.manifest.version)))try{await this.extensionsScanner.removeExtension(L,"existing")}catch(U){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(L.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(L);else{const U=await this.unsetUninstalledAndGetLocal(ne);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(K){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:M},G)}async getMetadata(G,ne){try{const z=(await this.galleryService.query({names:[G],pageSize:1},ne)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ue extends E.AbstractExtensionTask{constructor(G,ne,z){super();this.extension=G,this.options=ne,this.extensionsScanner=z}async doRun(G){const ne=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const L=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...z.filter(M=>L.equals(new f.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else ne.push(...z.filter(L=>(0,f.areSameExtensions)(L.identifier,this.extension.identifier)));if(!ne.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const L of ne)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(L)}catch(M){throw new Error(u.localize(6,null,(0,O.toErrorMessage)(M)))}}}}),define(Z[125],te([0,1,113,17,9,2,10,27,21,98,14,112,134]),function($,t,O,b,y,I,D,T,c,g,m,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let R=class extends I.Disposable{constructor(l,S,E){super();this.environmentService=S,this.logService=E,this.configure(l.getValue()),this._register(l.onDidChangeConfiguration(()=>this.configure(l.getValue()),this))}configure(l){this.proxyUrl=l.http&&l.http.proxy,this.strictSSL=!!(l.http&&l.http.proxyStrictSSL),this.authorization=l.http&&l.http.proxyAuthorization}async request(l,S){this.logService.trace("RequestService#request",l.url);const{proxyUrl:E,strictSSL:h}=this,f={...process.env,...await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=l.agent?l.agent:await(0,P.getProxyAgent)(l.url||"",f,{proxyUrl:E,strictSSL:h});return l.agent=o,l.strictSSL=h,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this._request(l,S)}async getNodeRequest(l){return((0,O.parse)(l.url).protocol==="https:"?await new Promise((h,f)=>{$(["https"],h,f)}):await new Promise((h,f)=>{$(["http"],h,f)})).request}_request(l,S){return new Promise(async(E,h)=>{let f;const o=(0,O.parse)(l.url),s=l.getRawRequest?l.getRawRequest(l):await this.getNodeRequest(l),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,D.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(e.auth=l.user+":"+l.password),f=s(e,i=>{const n=(0,D.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...l,url:i.headers.location,followRedirects:n-1},S).then(E,h);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,d.createGunzip)())),E({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}}),f.on("error",h),l.timeout&&f.setTimeout(l.timeout),l.data&&typeof l.data=="string"&&f.write(l.data),f.end(),S.onCancellationRequested(()=>{f.abort(),h((0,y.canceled)())})})}async resolveProxy(l){}};R=de([le(0,T.IConfigurationService),le(1,c.INativeEnvironmentService),le(2,m.ILogService)],R),t.RequestService=R}),define(Z[135],te([0,1,48,136,34,3,17,30,9,2,8,4,28,7,12,27,110,53,111,21,89,118,23,96,124,16,106,107,52,100,55,56,104,14,105,32,42,43,125,116,29,119,36,120,121]),function($,t,O,b,y,I,D,T,c,g,m,P,d,R,u,l,S,E,h,f,o,s,e,i,n,r,a,v,w,F,p,C,N,V,Y,ie,oe,ee,ue,ce,G,ne,z,L,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class U extends g.Disposable{constructor(J){super();this.argv=J,(0,b.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[J,q]=await this.initServices();return J.invokeFunction(async k=>{const A=k.get(V.ILogService),j=k.get(r.IFileService),W=k.get(f.INativeEnvironmentService),X=k.get(e.IExtensionManagementCLIService);return A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(W,X,j),(0,I.raceTimeout)((0,z.combinedAppender)(...q).flush(),1e3)})}async initServices(){const J=new p.ServiceCollection,q={_serviceBrand:void 0,...ie.default};J.set(oe.IProductService,q);const k=new o.NativeEnvironmentService(this.argv,q);J.set(f.INativeEnvironmentService,k),await Promise.all([k.appSettingsHome.fsPath,k.extensionsPath].map(me=>me?u.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,V.getLogLevel)(k),j=[];j.push(new Y.SpdLogLogger("cli",(0,P.join)(k.logsPath,"cli.log"),!0,A)),A===V.LogLevel.Trace&&j.push(new V.ConsoleLogger(A));const W=this._register(new V.MultiplexLogService(j));J.set(V.ILogService,W);const X=this._register(new a.FileService(W));J.set(r.IFileService,X);const Q=this._register(new v.DiskFileSystemProvider(W));X.registerProvider(m.Schemas.file,Q);const se=this._register(new S.ConfigurationService(k.settingsResource,X));J.set(l.IConfigurationService,se),await se.initialize(),J.set(ee.IRequestService,new w.SyncDescriptor(ue.RequestService)),J.set(E.IDownloadService,new w.SyncDescriptor(h.DownloadService)),J.set(e.IExtensionManagementService,new w.SyncDescriptor(n.ExtensionManagementService)),J.set(e.IExtensionGalleryService,new w.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),J.set(e.IExtensionManagementCLIService,new w.SyncDescriptor(i.ExtensionManagementCLIService)),J.set(C.ILocalizationsService,new w.SyncDescriptor(N.LocalizationsService));const re=[];if((0,z.getTelemetryLevel)(q,k)>=2){q.aiConfig&&q.aiConfig.asimovKey&&re.push(new L.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:me,extensionsPath:Ee,installSourcePath:fe}=k,Ie={appender:(0,z.combinedAppender)(...re),sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const ye=await u.Promises.readFile((0,P.join)(k.userDataPath,"storage.json"));pe=JSON.parse(ye.toString())[G.machineIdKey]}catch(ye){ye.code!=="ENOENT"&&W.error(ye)}return(0,ce.resolveCommonProperties)(X,(0,y.release)(),(0,y.hostname)(),process.arch,q.commit,q.version,pe,q.msftInternalDomains,fe)})(),piiPaths:[me,Ee]};J.set(G.ITelemetryService,new w.SyncDescriptor(ne.TelemetryService,[Ie]))}else J.set(G.ITelemetryService,z.NullTelemetryService);return[new F.InstantiationService(J),re]}registerErrorHandler(J){(0,c.setUnexpectedErrorHandler)(q=>{const k=(0,T.toErrorMessage)(q,!0);!k||J.error(`[uncaught exception in CLI]: ${k}`)}),process.on("uncaughtException",q=>(0,c.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,c.onUnexpectedError)(q))}async doRun(J,q,k){if(this.argv["install-source"])return this.setInstallSource(J,k,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(J.appRoot,J.extensionsPath))}asExtensionIdOrVSIX(J){return J.map(q=>/\.vsix$/i.test(q)?R.URI.file((0,P.isAbsolute)(q)?q:(0,P.join)((0,d.cwd)(),q)):q)}async setInstallSource(J,q,k){await q.writeFile(R.URI.file(J.installSourcePath),D.VSBuffer.fromString(k.slice(0,30)))}}async function K(B){const J=new U(B);try{await J.run()}finally{J.dispose()}}t.main=K})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1b9403cd461c9c975bcb9e48d84ba9e4ea86559e/core/vs/code/node/cliProcessMain.js.map
