/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(J){for(var e=[],g=0,L=J.length;g<L;g++)e[g]=fe[J[g]];return e};define(fe[57],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(fe[58],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(n){const I=[];for(let c in n)g.call(n,c)&&I.push(n[c]);return I}e.values=L;function k(n,I){for(let c in n)if(g.call(n,c)&&I({key:c,value:n[c]},function(){delete n[c]})===!1)return}e.forEach=k;function C(n,I){const c=Object.create(null);for(const f of n){const d=I(f);let p=c[d];p||(p=c[d]=[]),p.push(f)}return c}e.groupBy=C;function A(n){const I=Object.create(null);return n&&n.forEach((c,f)=>{I[f]=c}),I}e.fromMap=A;function S(n,I){const c=[],f=[];for(let d of n)I.has(d)||c.push(d);for(let d of I)n.has(d)||f.push(d);return{removed:c,added:f}}e.diffSets=S;function y(n,I){const c=[],f=[];for(let[d,p]of n)I.has(d)||c.push(p);for(let[d,p]of I)n.has(d)||f.push(p);return{removed:c,added:f}}e.diffMaps=y;class T{constructor(){this.map=new Map}add(I,c){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(c)}delete(I,c){const f=this.map.get(I);!f||(f.delete(c),f.size===0&&this.map.delete(I))}forEach(I,c){const f=this.map.get(I);!f||f.forEach(c)}}e.SetMap=T}),define(fe[59],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(A){return(S,y,T)=>{let n=null,I=null;if(typeof T.value=="function"?(n="value",I=T.value):typeof T.get=="function"&&(n="get",I=T.get),!I)throw new Error("not supported");T[n]=A(I,y)}}e.createDecorator=g;function L(A,S,y){let T=null,n=null;if(typeof y.value=="function"?(T="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",n=y.get),!n)throw new Error("not supported");const I=`$memoize$${S}`;y[T]=function(...c){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,c)}),this[I]}}e.memoize=L;function k(A,S,y){return g((T,n)=>{const I=`$debounce$${n}`,c=`$debounce$result$${n}`;return function(...f){this[c]||(this[c]=y?y():void 0),clearTimeout(this[I]),S&&(this[c]=S(this[c],...f),f=[this[c]]),this[I]=setTimeout(()=>{T.apply(this,f),this[c]=y?y():void 0},A)}})}e.debounce=k;function C(A,S,y){return g((T,n)=>{const I=`$throttle$timer$${n}`,c=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...p){if(this[c]||(this[c]=y?y():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[c]=S(this[c],...p)),this[d])return;const D=this[f]+A;D<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[c]]),this[c]=y?y():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),T.apply(this,[this[c]]),this[c]=y?y():void 0},D-Date.now()))}})}e.throttle=C}),define(fe[17],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(u=>{u(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=L;function k(m){y(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function C(m){y(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=C;function A(m){if(m instanceof Error){let{name:t,message:u}=m;const r=m.stacktrace||m.stack;return{$isError:!0,name:t,message:u,stack:r}}return m}e.transformErrorForSerialization=A;const S="Canceled";function y(m){return m instanceof Error&&m.name===S&&m.message===S}e.isPromiseCanceledError=y;class T extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=T;function n(){const m=new Error(S);return m.name=m.message,m}e.canceled=n;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function c(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=c;function f(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function d(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function p(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=p;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class R extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=R;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function a(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function o(m,t=Object.create(null)){const u=new Error(m);return t.actions&&(u.actions=t.actions),u}e.createErrorWithActions=o}),define(fe[16],me([0,1,17]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L($,Y=0){return $[$.length-(1+Y)]}e.tail=L;function k($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=k;function C($,Y,Q=(de,_e)=>de===_e){if($===Y)return!0;if(!$||!Y||$.length!==Y.length)return!1;for(let de=0,_e=$.length;de<_e;de++)if(!Q($[de],Y[de]))return!1;return!0}e.equals=C;function A($,Y,Q){let de=0,_e=$.length-1;for(;de<=_e;){const Ce=(de+_e)/2|0,Te=Q($[Ce],Y);if(Te<0)de=Ce+1;else if(Te>0)_e=Ce-1;else return Ce}return-(de+1)}e.binarySearch=A;function S($,Y){let Q=0,de=$.length;if(de===0)return 0;for(;Q<de;){const _e=Math.floor((Q+de)/2);Y($[_e])?de=_e:Q=_e+1}return Q}e.findFirstInSorted=S;function y($,Y,Q){if($=$|0,$>=Y.length)throw new TypeError("invalid index");let de=Y[Math.floor(Y.length*Math.random())],_e=[],Ce=[],Te=[];for(let $e of Y){const Be=Q($e,de);Be<0?_e.push($e):Be>0?Ce.push($e):Te.push($e)}return $<_e.length?y($,_e,Q):$<_e.length+Te.length?Te[0]:y($-(_e.length+Te.length),Ce,Q)}e.quickSelect=y;function T($,Y){const Q=[];let de;for(const _e of $.slice(0).sort(Y))!de||Y(de[0],_e)!==0?(de=[_e],Q.push(de)):de.push(_e);return Q}e.groupBy=T;function n($,Y,Q){const de=[];function _e($e,Be,He){if(Be===0&&He.length===0)return;const j=de[de.length-1];j&&j.start+j.deleteCount===$e?(j.deleteCount+=Be,j.toInsert.push(...He)):de.push({start:$e,deleteCount:Be,toInsert:He})}let Ce=0,Te=0;for(;;){if(Ce===$.length){_e(Ce,0,Y.slice(Te));break}if(Te===Y.length){_e(Ce,$.length-Ce,[]);break}const $e=$[Ce],Be=Y[Te],He=Q($e,Be);He===0?(Ce+=1,Te+=1):He<0?(_e(Ce,1,[]),Ce+=1):He>0&&(_e(Ce,0,[Be]),Te+=1)}return de}e.sortedDiff=n;function I($,Y,Q){const de=n($,Y,Q),_e=[],Ce=[];for(const Te of de)_e.push(...$.slice(Te.start,Te.start+Te.deleteCount)),Ce.push(...Te.toInsert);return{removed:_e,added:Ce}}e.delta=I;function c($,Y,Q){if(Q===0)return[];const de=$.slice(0,Q).sort(Y);return d($,Y,de,Q,$.length),de}e.top=c;function f($,Y,Q,de,_e){return Q===0?Promise.resolve([]):new Promise((Ce,Te)=>{(async()=>{const $e=$.length,Be=$.slice(0,Q).sort(Y);for(let He=Q,j=Math.min(Q+de,$e);He<$e;He=j,j=Math.min(j+de,$e)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();d($,Y,Be,He,j)}return Be})().then(Ce,Te)})}e.topAsync=f;function d($,Y,Q,de,_e){for(const Ce=Q.length;de<_e;de++){const Te=$[de];if(Y(Te,Q[Ce-1])<0){Q.pop();const $e=S(Q,Be=>Y(Te,Be)<0);Q.splice($e,0,Te)}}}function p($){return $.filter(Y=>!!Y)}e.coalesce=p;function D($){let Y=0;for(let Q=0;Q<$.length;Q++)$[Q]&&($[Y]=$[Q],Y+=1);$.length=Y}e.coalesceInPlace=D;function R($,Y,Q){$.splice(Q,0,$.splice(Y,1)[0])}e.move=R;function E($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=E;function a($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=a;function o($,Y){if(!Y)return $.filter((de,_e)=>$.indexOf(de)===_e);const Q=Object.create(null);return $.filter(de=>{const _e=Y(de);return Q[_e]?!1:(Q[_e]=!0,!0)})}e.distinct=o;function m($){const Y=new Set;return $.filter(Q=>Y.has(Q)?!1:(Y.add(Q),!0))}e.distinctES6=m;function t($){const Y=Object.create(null);return Q=>{const de=$(Q);return Y[de]?!1:(Y[de]=!0,!0)}}e.uniqueFilter=t;function u($,Y){for(let Q=$.length-1;Q>=0;Q--){const de=$[Q];if(Y(de))return Q}return-1}e.lastIndex=u;function r($,Y){return $.length>0?$[0]:Y}e.firstOrDefault=r;function i($,Y,Q=(de,_e)=>de===_e){let de=0;for(let _e=0,Ce=Math.min($.length,Y.length);_e<Ce&&Q($[_e],Y[_e]);_e++)de++;return de}e.commonPrefixLength=i;function s($){return[].concat(...$)}e.flatten=s;function l($,Y){let Q=typeof Y=="number"?$:0;typeof Y=="number"?Q=$:(Q=0,Y=$);const de=[];if(Q<=Y)for(let _e=Q;_e<Y;_e++)de.push(_e);else for(let _e=Q;_e>Y;_e--)de.push(_e);return de}e.range=l;function h($,Y,Q){return $.reduce((de,_e)=>(de[Y(_e)]=Q?Q(_e):_e,de),Object.create(null))}e.index=h;function w($,Y){return $.push(Y),()=>_($,Y)}e.insert=w;function _($,Y){const Q=$.indexOf(Y);if(Q>-1)return $.splice(Q,1),Y}e.remove=_;function v($,Y,Q){const de=$.slice(0,Y),_e=$.slice(Y);return de.concat(Q,_e)}e.arrayInsert=v;function P($,Y){let Q;if(typeof Y=="number"){let de=Y;Q=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else Q=Math.random;for(let de=$.length-1;de>0;de-=1){const _e=Math.floor(Q()*(de+1)),Ce=$[de];$[de]=$[_e],$[_e]=Ce}}e.shuffle=P;function b($,Y){const Q=$.indexOf(Y);Q>-1&&($.splice(Q,1),$.unshift(Y))}e.pushToStart=b;function F($,Y){const Q=$.indexOf(Y);Q>-1&&($.splice(Q,1),$.push(Y))}e.pushToEnd=F;function M($,Y){return Array.isArray($)?$.map(Y):Y($)}e.mapArrayOrNot=M;function q($){return Array.isArray($)?$:[$]}e.asArray=q;function G($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=G;function U($,Y){for(const Q of $){const de=Y(Q);if(de!==void 0)return de}}e.mapFind=U;function z($,Y,Q){const de=N($,Y),_e=$.length,Ce=Q.length;$.length=_e+Ce;for(let Te=_e-1;Te>=de;Te--)$[Te+Ce]=$[Te];for(let Te=0;Te<Ce;Te++)$[Te+de]=Q[Te]}e.insertInto=z;function O($,Y,Q,de){const _e=N($,Y),Ce=$.splice(_e,Q);return z($,_e,de),Ce}e.splice=O;function N($,Y){return Y<0?Math.max(Y+$.length,0):Math.min(Y,$.length)}function x($,Y){let Q=Number.MAX_SAFE_INTEGER,de=0;return $.forEach((_e,Ce)=>{const Te=Y(_e);Te<Q&&(Q=Te,de=Ce)}),de}e.minIndex=x;function B($,Y){let Q=Number.MIN_SAFE_INTEGER,de=0;return $.forEach((_e,Ce)=>{const Te=Y(_e);Te>Q&&(Q=Te,de=Ce)}),de}e.maxIndex=B;class H{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let Q=this.firstIdx;for(;Q<this.items.length&&Y(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(Y){let Q=this.lastIdx;for(;Q>=0&&Y(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}}e.ArrayQueue=H}),define(fe[75],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const k=this;let C=!1,A;return function(){return C||(C=!0,A=L.apply(k,arguments)),A}}e.once=g}),define(fe[76],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[94],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function k(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}L.is=k;const C=Object.freeze([]);function A(){return C}L.empty=A;function*S(m){yield m}L.single=S;function y(m){return m||C}L.from=y;function T(m){return!m||m[Symbol.iterator]().next().done===!0}L.isEmpty=T;function n(m){return m[Symbol.iterator]().next().value}L.first=n;function I(m,t){for(const u of m)if(t(u))return!0;return!1}L.some=I;function c(m,t){for(const u of m)if(t(u))return u}L.find=c;function*f(m,t){for(const u of m)t(u)&&(yield u)}L.filter=f;function*d(m,t){let u=0;for(const r of m)yield t(r,u++)}L.map=d;function*p(...m){for(const t of m)for(const u of t)yield u}L.concat=p;function*D(m){for(const t of m)for(const u of t)yield u}L.concatNested=D;function R(m,t,u){let r=u;for(const i of m)r=t(r,i);return r}L.reduce=R;function*E(m,t,u=m.length){for(t<0&&(t+=m.length),u<0?u+=m.length:u>m.length&&(u=m.length);t<u;t++)yield m[t]}L.slice=E;function a(m,t=Number.POSITIVE_INFINITY){const u=[];if(t===0)return[u,m];const r=m[Symbol.iterator]();for(let i=0;i<t;i++){const s=r.next();if(s.done)return[u,L.empty()];u.push(s.value)}return[u,{[Symbol.iterator](){return r}}]}L.consume=a;function o(m,t,u=(r,i)=>r===i){const r=m[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const s=r.next(),l=i.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!u(s.value,l.value))return!1}}L.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(fe[60],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function A(t,u=!1){let r=0,i=t.length,s="",l=0,h=16,w=0;function _(G){let U=0,z=0;for(;U<G;){const O=t.charCodeAt(r);if(O>=48&&O<=57)z=z*16+O-48;else if(O>=65&&O<=70)z=z*16+O-65+10;else if(O>=97&&O<=102)z=z*16+O-97+10;else break;r++,U++}return U<G&&(z=-1),z}function v(G){r=G,s="",l=0,h=16,w=0}function P(){const G=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return w=3,t.substring(G,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;U=r}else w=3;return t.substring(G,U)}function b(){let G="",U=r;for(;;){if(r>=i){G+=t.substring(U,r),w=2;break}const z=t.charCodeAt(r);if(z===34){G+=t.substring(U,r),r++;break}if(z===92){if(G+=t.substring(U,r),r++,r>=i){w=2;break}switch(t.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const N=_(4);N>=0?G+=String.fromCharCode(N):w=4;break;default:w=5}U=r;continue}if(z>=0&&z<=31)if(y(z)){G+=t.substring(U,r),w=2;break}else w=6;r++}return G}function F(){if(s="",w=0,l=r,r>=i)return l=i,h=17;let G=t.charCodeAt(r);if(S(G)){do r++,s+=String.fromCharCode(G),G=t.charCodeAt(r);while(S(G));return h=15}if(y(G))return r++,s+=String.fromCharCode(G),G===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),h=14;switch(G){case 123:return r++,h=1;case 125:return r++,h=2;case 91:return r++,h=3;case 93:return r++,h=4;case 58:return r++,h=6;case 44:return r++,h=5;case 34:return r++,s=b(),h=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!y(t.charCodeAt(r));)r++;return s=t.substring(U,r),h=12}if(t.charCodeAt(r+1)===42){r+=2;const z=i-1;let O=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,O=!0;break}r++}return O||(r++,w=1),s=t.substring(U,r),h=13}return s+=String.fromCharCode(G),r++,h=16;case 45:if(s+=String.fromCharCode(G),r++,r===i||!T(t.charCodeAt(r)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),h=11;default:for(;r<i&&M(G);)r++,G=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(G),r++,h=16}}function M(G){if(S(G)||y(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let G;do G=F();while(G>=12&&G<=15);return G}return{setPosition:v,getPosition:()=>r,scan:u?q:F,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>w}}e.createScanner=A;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,u){const r=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function w(_,v,P,b){l.value=_,l.offset=v,l.length=P,l.type=b,l.colonOffset=void 0,s=l}try{a(t,{onObjectBegin:(_,v)=>{if(u<=_)throw i;s=void 0,h=u>_,r.push("")},onObjectProperty:(_,v,P)=>{if(u<v||(w(_,v,P,"property"),r[r.length-1]=_,u<=v+P))throw i},onObjectEnd:(_,v)=>{if(u<=_)throw i;s=void 0,r.pop()},onArrayBegin:(_,v)=>{if(u<=_)throw i;s=void 0,r.push(0)},onArrayEnd:(_,v)=>{if(u<=_)throw i;s=void 0,r.pop()},onLiteralValue:(_,v,P)=>{if(u<v||(w(_,v,P,m(_)),u<=v+P))throw i},onSeparator:(_,v,P)=>{if(u<=v)throw i;if(_===":"&&s&&s.type==="property")s.colonOffset=v,h=!1,s=void 0;else if(_===","){const b=r[r.length-1];typeof b=="number"?r[r.length-1]=b+1:(h=!0,r[r.length-1]=""),s=void 0}}})}catch(_){if(_!==i)throw _}return{path:r,previousNode:s,isAtPropertyKey:h,matches:_=>{let v=0;for(let P=0;v<_.length&&P<r.length;P++)if(_[v]===r[P]||_[v]==="*")v++;else if(_[v]!=="**")return!1;return v===_.length}}}e.getLocation=I;function c(t,u=[],r=C.DEFAULT){let i=null,s=[];const l=[];function h(_){Array.isArray(s)?s.push(_):i!==null&&(s[i]=_)}return a(t,{onObjectBegin:()=>{const _={};h(_),l.push(s),s=_,i=null},onObjectProperty:_=>{i=_},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const _=[];h(_),l.push(s),s=_,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:h,onError:(_,v,P)=>{u.push({error:_,offset:v,length:P})}},r),s[0]}e.parse=c;function f(t,u=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(_){i.type==="property"&&(i.length=_-i.offset,i=i.parent)}function l(_){return i.children.push(_),_}a(t,{onObjectBegin:_=>{i=l({type:"object",offset:_,length:-1,parent:i,children:[]})},onObjectProperty:(_,v,P)=>{i=l({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:_,offset:v,length:P,parent:i})},onObjectEnd:(_,v)=>{i.length=_+v-i.offset,i=i.parent,s(_+v)},onArrayBegin:(_,v)=>{i=l({type:"array",offset:_,length:-1,parent:i,children:[]})},onArrayEnd:(_,v)=>{i.length=_+v-i.offset,i=i.parent,s(_+v)},onLiteralValue:(_,v,P)=>{l({type:m(_),offset:v,length:P,parent:i,value:_}),s(v+P)},onSeparator:(_,v,P)=>{i.type==="property"&&(_===":"?i.colonOffset=v:_===","&&s(v))},onError:(_,v,P)=>{u.push({error:_,offset:v,length:P})}},r);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=f;function d(t,u){if(!t)return;let r=t;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=d;function p(t){if(!t.parent||!t.parent.children)return[];const u=p(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.getNodePath=p;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const u=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(u[r.children[0].value]=D(i))}return u;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function R(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.contains=R;function E(t,u,r=!1){if(R(t,u,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=u;s++){const l=E(i[s],u,r);if(l)return l}return t}}e.findNodeAtOffset=E;function a(t,u,r=C.DEFAULT){const i=A(t,!1);function s(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(Q){return Q?de=>Q(de,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(u.onObjectBegin),w=l(u.onObjectProperty),_=s(u.onObjectEnd),v=s(u.onArrayBegin),P=s(u.onArrayEnd),b=l(u.onLiteralValue),F=l(u.onSeparator),M=s(u.onComment),q=l(u.onError),G=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:G||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(Q){case 12:case 13:G?O(10):M();break;case 16:O(1);break;case 15:case 14:break;default:return Q}}}function O(Q,de=[],_e=[]){if(q(Q),de.length+_e.length>0){let Ce=i.getToken();for(;Ce!==17;){if(de.indexOf(Ce)!==-1){z();break}else if(_e.indexOf(Ce)!==-1)break;Ce=z()}}}function N(Q){const de=i.getTokenValue();return Q?b(de):w(de),z(),!0}function x(){switch(i.getToken()){case 11:let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(O(2),Q=0)}catch(de){O(2)}b(Q);break;case 7:b(null);break;case 8:b(!0);break;case 9:b(!1);break;default:return!1}return z(),!0}function B(){return i.getToken()!==10?(O(3,[],[2,5]),!1):(N(!1),i.getToken()===6?(F(":"),z(),Y()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function H(){h(),z();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||O(4,[],[]),F(","),z(),i.getToken()===2&&U)break}else Q&&O(6,[],[]);B()||O(4,[],[2,5]),Q=!0}return _(),i.getToken()!==2?O(7,[2],[]):z(),!0}function $(){v(),z();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||O(4,[],[]),F(","),z(),i.getToken()===4&&U)break}else Q&&O(6,[],[]);Y()||O(4,[],[4,5]),Q=!0}return P(),i.getToken()!==4?O(8,[4],[]):z(),!0}function Y(){switch(i.getToken()){case 3:return $();case 1:return H();case 10:return N(!0);default:return x()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(O(4,[],[]),!1):Y()?(i.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=a;function o(t,u){let r=A(t),i=[],s,l=0,h;do switch(h=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==h&&i.push(t.substring(l,h)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),l=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=o;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(fe[137],me([0,1,60]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,T,n){let I,c,f,d,p;if(T){for(d=T.offset,p=d+T.length,f=d;f>0&&!S(y,f-1);)f--;let l=p;for(;l<y.length&&!S(y,l);)l++;c=y.substring(f,l),I=C(c,n)}else c=y,I=0,f=0,d=0,p=y.length;const D=A(n,y);let R=!1,E=0,a;n.insertSpaces?a=k(" ",n.tabSize||4):a="	";const o=(0,g.createScanner)(c,!1);let m=!1;function t(){return D+k(a,I+E)}function u(){let l=o.scan();for(R=!1;l===15||l===14;)R=R||l===14,l=o.scan();return m=l===16||o.getTokenError()!==0,l}const r=[];function i(l,h,w){!m&&h<p&&w>d&&y.substring(h,w)!==l&&r.push({offset:h,length:w-h,content:l})}let s=u();if(s!==17){const l=o.getTokenOffset()+f,h=k(a,I);i(h,f,l)}for(;s!==17;){let l=o.getTokenOffset()+o.getTokenLength()+f,h=u(),w="";for(;!R&&(h===12||h===13);){const v=o.getTokenOffset()+f;i(" ",l,v),l=o.getTokenOffset()+o.getTokenLength()+f,w=h===12?t():"",h=u()}if(h===2)s!==1&&(E--,w=t());else if(h===4)s!==3&&(E--,w=t());else{switch(s){case 3:case 1:E++,w=t();break;case 5:case 12:w=t();break;case 13:R?w=t():w=" ";break;case 6:w=" ";break;case 10:if(h===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?w=" ":h!==5&&h!==17&&(m=!0);break;case 16:m=!0;break}R&&(h===12||h===13)&&(w=t())}const _=o.getTokenOffset()+f;i(w,l,_),s=h}return r}e.format=L;function k(y,T){let n="";for(let I=0;I<T;I++)n+=y;return n}function C(y,T){let n=0,I=0;const c=T.tabSize||4;for(;n<y.length;){const f=y.charAt(n);if(f===" ")I++;else if(f==="	")I+=c;else break;n++}return Math.floor(I/c)}function A(y,T){for(let n=0;n<T.length;n++){const I=T.charAt(n);if(I==="\r")return n+1<T.length&&T.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=A;function S(y,T){return`\r
`.indexOf(y.charAt(T))!==-1}e.isEOL=S}),define(fe[138],me([0,1,60,137]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(T,n,I){return C(T,n,void 0,I)}e.removeProperty=k;function C(T,n,I,c,f){const d=n.slice(),p=[],D=(0,g.parseTree)(T,p);let R,E;for(;d.length>0&&(E=d.pop(),R=(0,g.findNodeAtLocation)(D,d),R===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(R)if(R.type==="object"&&typeof E=="string"&&Array.isArray(R.children)){const a=(0,g.findNodeAtLocation)(R,[E]);if(a!==void 0)if(I===void 0){if(!a.parent)throw new Error("Malformed AST");const o=R.children.indexOf(a.parent);let m,t=a.parent.offset+a.parent.length;if(o>0){const u=R.children[o-1];m=u.offset+u.length}else m=R.offset+1,R.children.length>1&&(t=R.children[1].offset);return A(T,{offset:m,length:t-m,content:""},c)}else return A(T,{offset:a.offset,length:a.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const o=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,m=f?f(R.children.map(u=>u.children[0].value)):R.children.length;let t;if(m>0){const u=R.children[m-1];t={offset:u.offset+u.length,length:0,content:","+o}}else R.children.length===0?t={offset:R.offset+1,length:0,content:o}:t={offset:R.offset+1,length:0,content:o+","};return A(T,t,c)}}else if(R.type==="array"&&typeof E=="number"&&Array.isArray(R.children))if(I!==void 0){const a=`${JSON.stringify(I)}`;let o;if(R.children.length===0||E===0)o={offset:R.offset+1,length:0,content:R.children.length===0?a:a+","};else{const m=E===-1||E>R.children.length?R.children.length:E,t=R.children[m-1];o={offset:t.offset+t.length,length:0,content:","+a}}return A(T,o,c)}else{const a=E,o=R.children[a];let m;if(R.children.length===1)m={offset:R.offset+1,length:R.length-2,content:""};else if(R.children.length-1===a){const t=R.children[a-1],u=t.offset+t.length,r=R.offset+R.length;m={offset:u,length:r-2-u,content:""}}else m={offset:o.offset,length:R.children[a+1].offset-o.offset,content:""};return A(T,m,c)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${R.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(T,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},c)}}e.setProperty=C;function A(T,n,I){let c=S(T,n),f=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;f>0&&!(0,L.isEOL)(c,f-1);)f--;for(;d<c.length&&!(0,L.isEOL)(c,d);)d++}const p=(0,L.format)(c,{offset:f,length:d-f},I);for(let R=p.length-1;R>=0;R--){const E=p[R];c=S(c,E),f=Math.min(f,E.offset),d=Math.max(d,E.offset+E.length),d+=E.content.length-E.length}const D=T.length-(c.length-d)-f;return[{offset:f,length:D,content:c.substring(f,d)}]}e.withFormatting=A;function S(T,n){return T.substring(0,n.offset)+n.content+T.substring(n.offset+n.length)}e.applyEdit=S;function y(T,n){let I=n.slice(0).sort((f,d)=>{const p=f.offset-d.offset;return p===0?f.length-d.length:p}),c=T.length;for(let f=I.length-1;f>=0;f--){let d=I[f];if(d.offset+d.length<=c)T=S(T,d);else throw new Error("Overlapping edit");c=d.offset}return T}e.applyEdits=y}),define(fe[139],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,75,94]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let C=null;function A(r){C=r}if(e.setDisposableTracker=A,k){const r="__is_disposable_tracked__";A(new class{trackDisposable(i){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(s)},3e3)}setParent(i,s){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function S(r){return C?.trackDisposable(r),r}function y(r){C?.markAsDisposed(r)}function T(r,i){C?.setParent(r,i)}function n(r,i){if(!!C)for(const s of r)C.setParent(s,i)}function I(r){return C?.markAsSingleton(r),r}e.markAsSingleton=I;class c extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=c;function f(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=f;function d(r){if(L.Iterable.is(r)){let i=[];for(const s of r)if(s)try{s.dispose()}catch(l){i.push(l)}if(i.length===1)throw i[0];if(i.length>1)throw new c(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function p(...r){const i=D(()=>d(r));return n(r,i),i}e.combinedDisposable=p;function D(r){const i=S({dispose:(0,g.once)(()=>{y(i),r()})});return i}e.toDisposable=D;class R{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=R,R.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new R,S(this),T(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=a;class o{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class m{constructor(){this.references=new Map}acquire(i,...s){let l=this.references.get(i);l||(l={counter:0,object:this.createReferencedObject(i,...s)},this.references.set(i,l));const{object:h}=l,w=(0,g.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(i,l.object),this.references.delete(i))});return l.counter++,{object:h,dispose:w}}}e.ReferenceCollection=m;class t{constructor(i){this.referenceCollection=i}async acquire(i,...s){const l=this.referenceCollection.acquire(i,...s);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=t;class u{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=u}),define(fe[95],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const A=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=A}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,A){const S=new g(C);if(this._first===g.Undefined)this._first=S,this._last=S;else if(A){const T=this._last;this._last=S,S.prev=T,T.next=S}else{const T=this._first;this._first=S,S.next=T,T.prev=S}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(S))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const A=C.prev;A.next=C.next,C.next.prev=A}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ae,ye){for(var Ie=0;Ie<ye.length;Ie++){var ne=ye[Ie];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Ae,ne.key,ne)}}function e(Ae,ye,Ie){return ye&&J(Ae.prototype,ye),Ie&&J(Ae,Ie),Ae}function g(Ae,ye){if(!!Ae){if(typeof Ae=="string")return L(Ae,ye);var Ie=Object.prototype.toString.call(Ae).slice(8,-1);if(Ie==="Object"&&Ae.constructor&&(Ie=Ae.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Ae);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return L(Ae,ye)}}function L(Ae,ye){(ye==null||ye>Ae.length)&&(ye=Ae.length);for(var Ie=0,ne=new Array(ye);Ie<ye;Ie++)ne[Ie]=Ae[Ie];return ne}function k(Ae,ye){var Ie=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(Ie)return(Ie=Ie.call(Ae)).next.bind(Ie);if(Array.isArray(Ae)||(Ie=g(Ae))||ye&&Ae&&typeof Ae.length=="number"){Ie&&(Ae=Ie);var ne=0;return function(){return ne>=Ae.length?{done:!0}:{done:!1,value:Ae[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function S(Ae){C.exports.defaults=Ae}C.exports={defaults:A(),getDefaults:A,changeDefaults:S};var y=/[&<>"']/,T=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return c[ye]};function d(Ae,ye){if(ye){if(y.test(Ae))return Ae.replace(T,f)}else if(n.test(Ae))return Ae.replace(I,f);return Ae}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Ae){return Ae.replace(p,function(ye,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var R=/(^|[^\[])\^/g;function E(Ae,ye){Ae=Ae.source||Ae,ye=ye||"";var Ie={replace:function(ue,Ee){return Ee=Ee.source||Ee,Ee=Ee.replace(R,"$1"),Ae=Ae.replace(ue,Ee),Ie},getRegex:function(){return new RegExp(Ae,ye)}};return Ie}var a=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Ae,ye,Ie){if(Ae){var ne;try{ne=decodeURIComponent(D(Ie)).replace(a,"").toLowerCase()}catch(ue){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}ye&&!o.test(Ie)&&(Ie=s(ye,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch(ue){return null}return Ie}var t={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Ae,ye){t[" "+Ae]||(u.test(Ae)?t[" "+Ae]=Ae+"/":t[" "+Ae]=_(Ae,"/",!0)),Ae=t[" "+Ae];var Ie=Ae.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ie?ye:Ae.replace(r,"$1")+ye:ye.charAt(0)==="/"?Ie?ye:Ae.replace(i,"$1")+ye:Ae+ye}var l={exec:function(){}};function h(Ae){for(var ye=1,Ie,ne;ye<arguments.length;ye++){Ie=arguments[ye];for(ne in Ie)Object.prototype.hasOwnProperty.call(Ie,ne)&&(Ae[ne]=Ie[ne])}return Ae}function w(Ae,ye){var Ie=Ae.replace(/\|/g,function(Ee,we,Fe){for(var Ke=!1,Ve=we;--Ve>=0&&Fe[Ve]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ne=Ie.split(/ \|/),ue=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>ye)ne.splice(ye);else for(;ne.length<ye;)ne.push("");for(;ue<ne.length;ue++)ne[ue]=ne[ue].trim().replace(/\\\|/g,"|");return ne}function _(Ae,ye,Ie){var ne=Ae.length;if(ne===0)return"";for(var ue=0;ue<ne;){var Ee=Ae.charAt(ne-ue-1);if(Ee===ye&&!Ie)ue++;else if(Ee!==ye&&Ie)ue++;else break}return Ae.substr(0,ne-ue)}function v(Ae,ye){if(Ae.indexOf(ye[1])===-1)return-1;for(var Ie=Ae.length,ne=0,ue=0;ue<Ie;ue++)if(Ae[ue]==="\\")ue++;else if(Ae[ue]===ye[0])ne++;else if(Ae[ue]===ye[1]&&(ne--,ne<0))return ue;return-1}function P(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(Ae,ye){if(ye<1)return"";for(var Ie="";ye>1;)ye&1&&(Ie+=Ae),ye>>=1,Ae+=Ae;return Ie+Ae}var F={escape:d,unescape:D,edit:E,cleanUrl:m,resolveUrl:s,noopTest:l,merge:h,splitCells:w,rtrim:_,findClosingBracket:v,checkSanitizeDeprecation:P,repeatString:b},M=C.exports.defaults,q=F.rtrim,G=F.splitCells,U=F.escape,z=F.findClosingBracket;function O(Ae,ye,Ie,ne){var ue=ye.href,Ee=ye.title?U(ye.title):null,we=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){ne.state.inLink=!0;var Fe={type:"link",raw:Ie,href:ue,title:Ee,text:we,tokens:ne.inlineTokens(we,[])};return ne.state.inLink=!1,Fe}else return{type:"image",raw:Ie,href:ue,title:Ee,text:U(we)}}function N(Ae,ye){var Ie=Ae.match(/^(\s+)(?:```)/);if(Ie===null)return ye;var ne=Ie[1];return ye.split(`
`).map(function(ue){var Ee=ue.match(/^\s+/);if(Ee===null)return ue;var we=Ee[0];return we.length>=ne.length?ue.slice(ne.length):ue}).join(`
`)}var x=function(){function Ae(Ie){this.options=Ie||M}var ye=Ae.prototype;return ye.space=function(ne){var ue=this.rules.block.newline.exec(ne);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(ne){var ue=this.rules.block.code.exec(ne);if(ue){var Ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Ee:q(Ee,`
`)}}},ye.fences=function(ne){var ue=this.rules.block.fences.exec(ne);if(ue){var Ee=ue[0],we=N(Ee,ue[3]||"");return{type:"code",raw:Ee,lang:ue[2]?ue[2].trim():ue[2],text:we}}},ye.heading=function(ne){var ue=this.rules.block.heading.exec(ne);if(ue){var Ee=ue[2].trim();if(/#$/.test(Ee)){var we=q(Ee,"#");(this.options.pedantic||!we||/ $/.test(we))&&(Ee=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:Ee,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ye.hr=function(ne){var ue=this.rules.block.hr.exec(ne);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ne){var ue=this.rules.block.blockquote.exec(ne);if(ue){var Ee=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Ee,[]),text:Ee}}},ye.list=function(ne){var ue=this.rules.block.list.exec(ne);if(ue){var Ee,we,Fe,Ke,Ve,Je,rt,Ue,pe,be,ie=ue[1].trim(),K=ie.length>1,Se={type:"list",raw:"",ordered:K,start:K?+ie.slice(0,-1):"",loose:!1,items:[]};ie=K?"\\d{1,9}\\"+ie.slice(-1):"\\"+ie,this.options.pedantic&&(ie=K?ie:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ie+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(ue=Le.exec(ne)));){pe=ue[2].split(`
`),this.options.pedantic?(Ke=2,be=pe[0].trimLeft()):(Ke=ue[2].search(/[^ ]/),Ke=ue[1].length+(Ke>4?1:Ke),be=pe[0].slice(Ke-ue[1].length)),Je=!1,Ee=ue[0],!pe[0]&&/^ *$/.test(pe[1])&&(Ee=ue[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var nt=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ve=1;Ve<pe.length;Ve++){if(Ue=pe[Ve],this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),nt.test(Ue)){Ee=ue[1]+pe.slice(0,Ve).join(`
`)+`
`;break}if(!Je){Ue.trim()||(Je=!0),Ue.search(/[^ ]/)>=Ke?be+=`
`+Ue.slice(Ke):be+=`
`+Ue;continue}if(Ue.search(/[^ ]/)>=Ke||!Ue.trim()){be+=`
`+Ue.slice(Ke);continue}else{Ee=ue[1]+pe.slice(0,Ve).join(`
`)+`
`;break}}Se.loose||(rt?Se.loose=!0:/\n *\n *$/.test(Ee)&&(rt=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(be),we&&(Fe=we[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:Ee,task:!!we,checked:Fe,loose:!1,text:be}),Se.raw+=Ee,ne=ne.slice(Ee.length)}Se.items[Se.items.length-1].raw=Ee.trimRight(),Se.items[Se.items.length-1].text=be.trimRight(),Se.raw=Se.raw.trimRight();var Qe=Se.items.length;for(Ve=0;Ve<Qe;Ve++)this.lexer.state.top=!1,Se.items[Ve].tokens=this.lexer.blockTokens(Se.items[Ve].text,[]),Se.items[Ve].tokens.some(function(gt){return gt.type==="space"})&&(Se.loose=!0,Se.items[Ve].loose=!0);return Se}},ye.html=function(ne){var ue=this.rules.block.html.exec(ne);if(ue){var Ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(Ee.type="paragraph",Ee.text=this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]),Ee.tokens=[],this.lexer.inline(Ee.text,Ee.tokens)),Ee}},ye.def=function(ne){var ue=this.rules.block.def.exec(ne);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Ee,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ne){var ue=this.rules.block.table.exec(ne);if(ue){var Ee={type:"table",header:G(ue[1]).map(function(rt){return{text:rt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(Ee.header.length===Ee.align.length){Ee.raw=ue[0];var we=Ee.align.length,Fe,Ke,Ve,Je;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(Ee.align[Fe])?Ee.align[Fe]="right":/^ *:-+: *$/.test(Ee.align[Fe])?Ee.align[Fe]="center":/^ *:-+ *$/.test(Ee.align[Fe])?Ee.align[Fe]="left":Ee.align[Fe]=null;for(we=Ee.rows.length,Fe=0;Fe<we;Fe++)Ee.rows[Fe]=G(Ee.rows[Fe],Ee.header.length).map(function(rt){return{text:rt}});for(we=Ee.header.length,Ke=0;Ke<we;Ke++)Ee.header[Ke].tokens=[],this.lexer.inlineTokens(Ee.header[Ke].text,Ee.header[Ke].tokens);for(we=Ee.rows.length,Ke=0;Ke<we;Ke++)for(Je=Ee.rows[Ke],Ve=0;Ve<Je.length;Ve++)Je[Ve].tokens=[],this.lexer.inlineTokens(Je[Ve].text,Je[Ve].tokens);return Ee}}},ye.lheading=function(ne){var ue=this.rules.block.lheading.exec(ne);if(ue){var Ee={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},ye.paragraph=function(ne){var ue=this.rules.block.paragraph.exec(ne);if(ue){var Ee={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},ye.text=function(ne){var ue=this.rules.block.text.exec(ne);if(ue){var Ee={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},ye.escape=function(ne){var ue=this.rules.inline.escape.exec(ne);if(ue)return{type:"escape",raw:ue[0],text:U(ue[1])}},ye.tag=function(ne){var ue=this.rules.inline.tag.exec(ne);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]):ue[0]}},ye.link=function(ne){var ue=this.rules.inline.link.exec(ne);if(ue){var Ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(Ee)){if(!/>$/.test(Ee))return;var we=q(Ee.slice(0,-1),"\\");if((Ee.length-we.length)%2==0)return}else{var Fe=z(ue[2],"()");if(Fe>-1){var Ke=ue[0].indexOf("!")===0?5:4,Ve=Ke+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,Ve).trim(),ue[3]=""}}var Je=ue[2],rt="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Je);Ue&&(Je=Ue[1],rt=Ue[3])}else rt=ue[3]?ue[3].slice(1,-1):"";return Je=Je.trim(),/^</.test(Je)&&(this.options.pedantic&&!/>$/.test(Ee)?Je=Je.slice(1):Je=Je.slice(1,-1)),O(ue,{href:Je&&Je.replace(this.rules.inline._escapes,"$1"),title:rt&&rt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ne,ue){var Ee;if((Ee=this.rules.inline.reflink.exec(ne))||(Ee=this.rules.inline.nolink.exec(ne))){var we=(Ee[2]||Ee[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=Ee[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(Ee,we,Ee[0],this.lexer)}},ye.emStrong=function(ne,ue,Ee){Ee===void 0&&(Ee="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&Ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(Ee===""||this.rules.inline.punctuation.exec(Ee))){var Ke=we[0].length-1,Ve,Je,rt=Ke,Ue=0,pe=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ue=ue.slice(-1*ne.length+Ke);(we=pe.exec(ue))!=null;)if(Ve=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ve){if(Je=Ve.length,we[3]||we[4]){rt+=Je;continue}else if((we[5]||we[6])&&Ke%3&&!((Ke+Je)%3)){Ue+=Je;continue}if(rt-=Je,!(rt>0)){if(Je=Math.min(Je,Je+rt+Ue),Math.min(Ke,Je)%2){var be=ne.slice(1,Ke+we.index+Je);return{type:"em",raw:ne.slice(0,Ke+we.index+Je+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var ie=ne.slice(2,Ke+we.index+Je-1);return{type:"strong",raw:ne.slice(0,Ke+we.index+Je+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},ye.codespan=function(ne){var ue=this.rules.inline.code.exec(ne);if(ue){var Ee=ue[2].replace(/\n/g," "),we=/[^ ]/.test(Ee),Fe=/^ /.test(Ee)&&/ $/.test(Ee);return we&&Fe&&(Ee=Ee.substring(1,Ee.length-1)),Ee=U(Ee,!0),{type:"codespan",raw:ue[0],text:Ee}}},ye.br=function(ne){var ue=this.rules.inline.br.exec(ne);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ne){var ue=this.rules.inline.del.exec(ne);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ye.autolink=function(ne,ue){var Ee=this.rules.inline.autolink.exec(ne);if(Ee){var we,Fe;return Ee[2]==="@"?(we=U(this.options.mangle?ue(Ee[1]):Ee[1]),Fe="mailto:"+we):(we=U(Ee[1]),Fe=we),{type:"link",raw:Ee[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.url=function(ne,ue){var Ee;if(Ee=this.rules.inline.url.exec(ne)){var we,Fe;if(Ee[2]==="@")we=U(this.options.mangle?ue(Ee[0]):Ee[0]),Fe="mailto:"+we;else{var Ke;do Ke=Ee[0],Ee[0]=this.rules.inline._backpedal.exec(Ee[0])[0];while(Ke!==Ee[0]);we=U(Ee[0]),Ee[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:Ee[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.inlineText=function(ne,ue){var Ee=this.rules.inline.text.exec(ne);if(Ee){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):U(Ee[0]):Ee[0]:we=U(this.options.smartypants?ue(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:we}}},Ae}(),B=F.noopTest,H=F.edit,$=F.merge,Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=H(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=H(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=H(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=H(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=H(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=H(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=$({},Y),Y.gfm=$({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=H(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=$({},Y.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:H(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=H(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=H(Y._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=H(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=H(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=H(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=H(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=H(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=H(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=H(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=H(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=$({},Q),Q.pedantic=$({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=$({},Q.normal,{escape:H(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=H(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=$({},Q.gfm,{br:H(Q.br).replace("{2,}","*").getRegex(),text:H(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:Y,inline:Q},_e=x,Ce=C.exports.defaults,Te=de.block,$e=de.inline,Be=F.repeatString;function He(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Ae){var ye="",Ie,ne,ue=Ae.length;for(Ie=0;Ie<ue;Ie++)ne=Ae.charCodeAt(Ie),Math.random()>.5&&(ne="x"+ne.toString(16)),ye+="&#"+ne+";";return ye}var ee=function(){function Ae(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||Ce,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Te.normal,inline:$e.normal};this.options.pedantic?(ne.block=Te.pedantic,ne.inline=$e.pedantic):this.options.gfm&&(ne.block=Te.gfm,this.options.breaks?ne.inline=$e.breaks:ne.inline=$e.gfm),this.tokenizer.rules=ne}Ae.lex=function(ne,ue){var Ee=new Ae(ue);return Ee.lex(ne)},Ae.lexInline=function(ne,ue){var Ee=new Ae(ue);return Ee.inlineTokens(ne)};var ye=Ae.prototype;return ye.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ne,ue){var Ee=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ke,Ve;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(rt){return(we=rt.call({lexer:Ee},ne,ue))?(ne=ne.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(Ke=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var rt=Infinity,Ue=ne.slice(1),pe=void 0;Ee.options.extensions.startBlock.forEach(function(be){pe=be.call({lexer:this},Ue),typeof pe=="number"&&pe>=0&&(rt=Math.min(rt,pe))}),rt<Infinity&&rt>=0&&(Ke=ne.substring(0,rt+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ke))){Fe=ue[ue.length-1],Ve&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),Ve=Ke.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(ne){var Je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Je);break}else throw new Error(Je)}}return this.state.top=!0,ue},ye.inline=function(ne,ue){this.inlineQueue.push({src:ne,tokens:ue})},ye.inlineTokens=function(ne,ue){var Ee=this;ue===void 0&&(ue=[]);var we,Fe,Ke,Ve=ne,Je,rt,Ue;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(Je=this.tokenizer.rules.inline.reflinkSearch.exec(Ve))!=null;)pe.includes(Je[0].slice(Je[0].lastIndexOf("[")+1,-1))&&(Ve=Ve.slice(0,Je.index)+"["+Be("a",Je[0].length-2)+"]"+Ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Je=this.tokenizer.rules.inline.blockSkip.exec(Ve))!=null;)Ve=Ve.slice(0,Je.index)+"["+Be("a",Je[0].length-2)+"]"+Ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Je=this.tokenizer.rules.inline.escapedEmSt.exec(Ve))!=null;)Ve=Ve.slice(0,Je.index)+"++"+Ve.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(rt||(Ue=""),rt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(we=ie.call({lexer:Ee},ne,ue))?(ne=ne.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(ne,Ve,Ue)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(ne,j)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,j))){ne=ne.substring(we.raw.length),ue.push(we);continue}if(Ke=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=Infinity,K=ne.slice(1),Se=void 0;Ee.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},K),typeof Se=="number"&&Se>=0&&(ie=Math.min(ie,Se))}),ie<Infinity&&ie>=0&&(Ke=ne.substring(0,ie+1))}(),we=this.tokenizer.inlineText(Ke,He)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(Ue=we.raw.slice(-1)),rt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(ne){var be="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ue},e(Ae,null,[{key:"rules",get:function(){return{block:Te,inline:$e}}}]),Ae}(),se=C.exports.defaults,le=F.cleanUrl,Z=F.escape,ae=function(){function Ae(Ie){this.options=Ie||se}var ye=Ae.prototype;return ye.code=function(ne,ue,Ee){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(Ee=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(Ee?ne:Z(ne,!0))+`</code></pre>
`:"<pre><code>"+(Ee?ne:Z(ne,!0))+`</code></pre>
`},ye.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},ye.html=function(ne){return ne},ye.heading=function(ne,ue,Ee,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(Ee)+'">'+ne+"</h"+ue+`>
`:"<h"+ue+">"+ne+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ne,ue,Ee){var we=ue?"ol":"ul",Fe=ue&&Ee!==1?' start="'+Ee+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},ye.listitem=function(ne){return"<li>"+ne+`</li>
`},ye.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ne){return"<p>"+ne+`</p>
`},ye.table=function(ne,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},ye.tablecell=function(ne,ue){var Ee=ue.header?"th":"td",we=ue.align?"<"+Ee+' align="'+ue.align+'">':"<"+Ee+">";return we+ne+"</"+Ee+`>
`},ye.strong=function(ne){return"<strong>"+ne+"</strong>"},ye.em=function(ne){return"<em>"+ne+"</em>"},ye.codespan=function(ne){return"<code>"+ne+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ne){return"<del>"+ne+"</del>"},ye.link=function(ne,ue,Ee){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Ee;var we='<a href="'+Z(ne)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+Ee+"</a>",we},ye.image=function(ne,ue,Ee){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Ee;var we='<img src="'+ne+'" alt="'+Ee+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},ye.text=function(ne){return ne},Ae}(),ve=function(){function Ae(){}var ye=Ae.prototype;return ye.strong=function(ne){return ne},ye.em=function(ne){return ne},ye.codespan=function(ne){return ne},ye.del=function(ne){return ne},ye.html=function(ne){return ne},ye.text=function(ne){return ne},ye.link=function(ne,ue,Ee){return""+Ee},ye.image=function(ne,ue,Ee){return""+Ee},ye.br=function(){return""},Ae}(),Me=function(){function Ae(){this.seen={}}var ye=Ae.prototype;return ye.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ne,ue){var Ee=ne,we=0;if(this.seen.hasOwnProperty(Ee)){we=this.seen[ne];do we++,Ee=ne+"-"+we;while(this.seen.hasOwnProperty(Ee))}return ue||(this.seen[ne]=we,this.seen[Ee]=0),Ee},ye.slug=function(ne,ue){ue===void 0&&(ue={});var Ee=this.serialize(ne);return this.getNextSafeSlug(Ee,ue.dryrun)},Ae}(),qe=ae,Ye=ve,Ze=Me,ke=C.exports.defaults,at=F.unescape,X=function(){function Ae(Ie){this.options=Ie||ke,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ye,this.slugger=new Ze}Ae.parse=function(ne,ue){var Ee=new Ae(ue);return Ee.parse(ne)},Ae.parseInline=function(ne,ue){var Ee=new Ae(ue);return Ee.parseInline(ne)};var ye=Ae.prototype;return ye.parse=function(ne,ue){ue===void 0&&(ue=!0);var Ee="",we,Fe,Ke,Ve,Je,rt,Ue,pe,be,ie,K,Se,Le,nt,Qe,gt,bt,ht,pt,ut=ne.length;for(we=0;we<ut;we++){if(ie=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(pt=this.options.extensions.renderers[ie.type].call({parser:this},ie),pt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){Ee+=pt||"";continue}switch(ie.type){case"space":continue;case"hr":{Ee+=this.renderer.hr();continue}case"heading":{Ee+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,at(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{Ee+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(pe="",Ue="",Ve=ie.header.length,Fe=0;Fe<Ve;Fe++)Ue+=this.renderer.tablecell(this.parseInline(ie.header[Fe].tokens),{header:!0,align:ie.align[Fe]});for(pe+=this.renderer.tablerow(Ue),be="",Ve=ie.rows.length,Fe=0;Fe<Ve;Fe++){for(rt=ie.rows[Fe],Ue="",Je=rt.length,Ke=0;Ke<Je;Ke++)Ue+=this.renderer.tablecell(this.parseInline(rt[Ke].tokens),{header:!1,align:ie.align[Ke]});be+=this.renderer.tablerow(Ue)}Ee+=this.renderer.table(pe,be);continue}case"blockquote":{be=this.parse(ie.tokens),Ee+=this.renderer.blockquote(be);continue}case"list":{for(K=ie.ordered,Se=ie.start,Le=ie.loose,Ve=ie.items.length,be="",Fe=0;Fe<Ve;Fe++)Qe=ie.items[Fe],gt=Qe.checked,bt=Qe.task,nt="",Qe.task&&(ht=this.renderer.checkbox(gt),Le?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=ht+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=ht+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:ht}):nt+=ht),nt+=this.parse(Qe.tokens,Le),be+=this.renderer.listitem(nt,bt,gt);Ee+=this.renderer.list(be,K,Se);continue}case"html":{Ee+=this.renderer.html(ie.text);continue}case"paragraph":{Ee+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(be=ie.tokens?this.parseInline(ie.tokens):ie.text;we+1<ut&&ne[we+1].type==="text";)ie=ne[++we],be+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);Ee+=ue?this.renderer.paragraph(be):be;continue}default:{var yt='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(yt);return}else throw new Error(yt)}}}return Ee},ye.parseInline=function(ne,ue){ue=ue||this.renderer;var Ee="",we,Fe,Ke,Ve=ne.length;for(we=0;we<Ve;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ke=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){Ee+=Ke||"";continue}switch(Fe.type){case"escape":{Ee+=ue.text(Fe.text);break}case"html":{Ee+=ue.html(Fe.text);break}case"link":{Ee+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{Ee+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{Ee+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{Ee+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{Ee+=ue.codespan(Fe.text);break}case"br":{Ee+=ue.br();break}case"del":{Ee+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{Ee+=ue.text(Fe.text);break}default:{var Je='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return Ee},Ae}(),te=ee,ge=X,je=x,tt=ae,lt=ve,ft=Me,wt=F.merge,Ct=F.checkSanitizeDeprecation,ce=F.escape,Pe=C.exports.getDefaults,xe=C.exports.changeDefaults,Xe=C.exports.defaults;function ze(Ae,ye,Ie){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof ye=="function"&&(Ie=ye,ye=null),ye=wt({},ze.defaults,ye||{}),Ct(ye),Ie){var ne=ye.highlight,ue;try{ue=te.lex(Ae,ye)}catch(Ke){return Ie(Ke)}var Ee=function(Ve){var Je;if(!Ve)try{ye.walkTokens&&ze.walkTokens(ue,ye.walkTokens),Je=ge.parse(ue,ye)}catch(rt){Ve=rt}return ye.highlight=ne,Ve?Ie(Ve):Ie(null,Je)};if(!ne||ne.length<3||(delete ye.highlight,!ue.length))return Ee();var we=0;ze.walkTokens(ue,function(Ke){Ke.type==="code"&&(we++,setTimeout(function(){ne(Ke.text,Ke.lang,function(Ve,Je){if(Ve)return Ee(Ve);Je!=null&&Je!==Ke.text&&(Ke.text=Je,Ke.escaped=!0),we--,we===0&&Ee()})},0))}),we===0&&Ee();return}try{var Fe=te.lex(Ae,ye);return ye.walkTokens&&ze.walkTokens(Fe,ye.walkTokens),ge.parse(Fe,ye)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ce(Ke.message+"",!0)+"</pre>";throw Ke}}ze.options=ze.setOptions=function(Ae){return wt(ze.defaults,Ae),xe(ze.defaults),ze},ze.getDefaults=Pe,ze.defaults=Xe,ze.use=function(){for(var Ae=this,ye=arguments.length,Ie=new Array(ye),ne=0;ne<ye;ne++)Ie[ne]=arguments[ne];var ue=wt.apply(void 0,[{}].concat(Ie)),Ee=ze.defaults.extensions||{renderers:{},childTokens:{}},we;Ie.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(Ve){if(!Ve.name)throw new Error("extension name required");if(Ve.renderer){var Je=Ee.renderers?Ee.renderers[Ve.name]:null;Je?Ee.renderers[Ve.name]=function(){for(var rt=arguments.length,Ue=new Array(rt),pe=0;pe<rt;pe++)Ue[pe]=arguments[pe];var be=Ve.renderer.apply(this,Ue);return be===!1&&(be=Je.apply(this,Ue)),be}:Ee.renderers[Ve.name]=Ve.renderer}if(Ve.tokenizer){if(!Ve.level||Ve.level!=="block"&&Ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Ee[Ve.level]?Ee[Ve.level].unshift(Ve.tokenizer):Ee[Ve.level]=[Ve.tokenizer],Ve.start&&(Ve.level==="block"?Ee.startBlock?Ee.startBlock.push(Ve.start):Ee.startBlock=[Ve.start]:Ve.level==="inline"&&(Ee.startInline?Ee.startInline.push(Ve.start):Ee.startInline=[Ve.start]))}Ve.childTokens&&(Ee.childTokens[Ve.name]=Ve.childTokens)})),Fe.renderer&&function(){var Ve=ze.defaults.renderer||new tt,Je=function(pe){var be=Ve[pe];Ve[pe]=function(){for(var ie=arguments.length,K=new Array(ie),Se=0;Se<ie;Se++)K[Se]=arguments[Se];var Le=Fe.renderer[pe].apply(Ve,K);return Le===!1&&(Le=be.apply(Ve,K)),Le}};for(var rt in Fe.renderer)Je(rt);ue.renderer=Ve}(),Fe.tokenizer&&function(){var Ve=ze.defaults.tokenizer||new je,Je=function(pe){var be=Ve[pe];Ve[pe]=function(){for(var ie=arguments.length,K=new Array(ie),Se=0;Se<ie;Se++)K[Se]=arguments[Se];var Le=Fe.tokenizer[pe].apply(Ve,K);return Le===!1&&(Le=be.apply(Ve,K)),Le}};for(var rt in Fe.tokenizer)Je(rt);ue.tokenizer=Ve}(),Fe.walkTokens){var Ke=ze.defaults.walkTokens;ue.walkTokens=function(Ve){Fe.walkTokens.call(Ae,Ve),Ke&&Ke(Ve)}}we&&(ue.extensions=Ee),ze.setOptions(ue)})},ze.walkTokens=function(Ae,ye){for(var Ie=function(){var we=ue.value;switch(ye(we),we.type){case"table":{for(var Fe=k(we.header),Ke;!(Ke=Fe()).done;){var Ve=Ke.value;ze.walkTokens(Ve.tokens,ye)}for(var Je=k(we.rows),rt;!(rt=Je()).done;)for(var Ue=rt.value,pe=k(Ue),be;!(be=pe()).done;){var ie=be.value;ze.walkTokens(ie.tokens,ye)}break}case"list":{ze.walkTokens(we.items,ye);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[we.type]?ze.defaults.extensions.childTokens[we.type].forEach(function(K){ze.walkTokens(we[K],ye)}):we.tokens&&ze.walkTokens(we.tokens,ye)}},ne=k(Ae),ue;!(ue=ne()).done;)Ie()},ze.parseInline=function(Ae,ye){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");ye=wt({},ze.defaults,ye||{}),Ct(ye);try{var Ie=te.lexInline(Ae,ye);return ye.walkTokens&&ze.walkTokens(Ie,ye.walkTokens),ge.parseInline(Ie,ye)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ce(ne.message+"",!0)+"</pre>";throw ne}},ze.Parser=ge,ze.parser=ge.parse,ze.Renderer=tt,ze.TextRenderer=lt,ze.Lexer=te,ze.lexer=te.lex,ze.Tokenizer=je,ze.Slugger=ft,ze.parse=ze;var ot=ze;return ot}),define(fe[77],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(A,S,y){return Math.min(Math.max(A,S),y)}e.clamp=g;function L(A,S){return(S+A%S)%S}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class C{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function J(k){const C=[];typeof k=="number"&&C.push("code/timeOrigin",k);function A(y){C.push(y,Date.now())}function S(){const y=[];for(let T=0;T<C.length;T+=2)y.push({name:C[T],startTime:C[T+1]});return y}return{mark:A,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))C.push({name:A.name,startTime:Math.round(k+A.startTime)});return C}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[11],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,k=!1,C=!1,A=!1,S=!1,y=!1,T=!1,n,I=g,c,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const p=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=p&&d?.sandboxed,typeof navigator=="object"&&!p)f=navigator.userAgent,L=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=f.indexOf("Linux")>=0,y=!0,n=navigator.language,I=n;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",C=d.platform==="linux",A=C&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,n=g,I=g;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),s=i.availableLanguages["*"];n=i.locale,I=s||g,c=i._translationsConfigFile}catch(i){}S=!0}else console.error("Unable to resolve platform.");var D;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function R(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let E=0;k?E=1:L?E=3:C&&(E=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=C,e.isLinuxSnap=A,e.isNative=S,e.isWeb=y,e.isIOS=T,e.platform=E,e.userAgent=f,e.language=I;var a;(function(r){function i(){return e.language}r.value=i;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=s;function l(){return e.language==="en"}r.isDefault=l})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let w=0,_=s.length;w<_;w++){const v=s[w];if(v.id===h.data.vscodeSetImmediateId){s.splice(w,1),v.callback();return}}});let l=0;return h=>{const w=++l;s.push({id:w,callback:h}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const i=Promise.resolve();return s=>i.then(s)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||T?2:L?1:3;let m=!0,t=!1;function u(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,m=new Uint16Array(r.buffer)[0]===(2<<8)+1}return m}e.isLittleEndian=u}),define(fe[38],me([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[8],me([0,1,38]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,C=90,A=122,S=46,y=47,T=92,n=58,I=63;class c extends Error{constructor(o,m,t){let u;typeof m=="string"&&m.indexOf("not ")===0?(u="must not be",m=m.replace(/^not /,"")):u="must be";const r=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${r} ${u} of type ${m}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,o){if(typeof a!="string")throw new c(o,"string",a)}function d(a){return a===y||a===T}function p(a){return a===y}function D(a){return a>=L&&a<=C||a>=k&&a<=A}function R(a,o,m,t){let u="",r=0,i=-1,s=0,l=0;for(let h=0;h<=a.length;++h){if(h<a.length)l=a.charCodeAt(h);else{if(t(l))break;l=y}if(t(l)){if(!(i===h-1||s===1))if(s===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==S||u.charCodeAt(u.length-2)!==S){if(u.length>2){const w=u.lastIndexOf(m);w===-1?(u="",r=0):(u=u.slice(0,w),r=u.length-1-u.lastIndexOf(m)),i=h,s=0;continue}else if(u.length!==0){u="",r=0,i=h,s=0;continue}}o&&(u+=u.length>0?`${m}..`:"..",r=2)}else u.length>0?u+=`${m}${a.slice(i+1,h)}`:u=a.slice(i+1,h),r=h-i-1;i=h,s=0}else l===S&&s!==-1?++s:s=-1}return u}function E(a,o){if(o===null||typeof o!="object")throw new c("pathObject","Object",o);const m=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return m?m===o.root?`${m}${t}`:`${m}${a}${t}`:t}e.win32={resolve(...a){let o="",m="",t=!1;for(let u=a.length-1;u>=-1;u--){let r;if(u>=0){if(r=a[u],f(r,"path"),r.length===0)continue}else o.length===0?r=g.cwd():(r=g.env[`=${o}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===T)&&(r=`${o}\\`));const i=r.length;let s=0,l="",h=!1;const w=r.charCodeAt(0);if(i===1)d(w)&&(s=1,h=!0);else if(d(w))if(h=!0,d(r.charCodeAt(1))){let _=2,v=_;for(;_<i&&!d(r.charCodeAt(_));)_++;if(_<i&&_!==v){const P=r.slice(v,_);for(v=_;_<i&&d(r.charCodeAt(_));)_++;if(_<i&&_!==v){for(v=_;_<i&&!d(r.charCodeAt(_));)_++;(_===i||_!==v)&&(l=`\\\\${P}\\${r.slice(v,_)}`,s=_)}}}else s=1;else D(w)&&r.charCodeAt(1)===n&&(l=r.slice(0,2),s=2,i>2&&d(r.charCodeAt(2))&&(h=!0,s=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(m=`${r.slice(s)}\\${m}`,t=h,h&&o.length>0)break}return m=R(m,!t,"\\",d),t?`${o}\\${m}`:`${o}${m}`||"."},normalize(a){f(a,"path");const o=a.length;if(o===0)return".";let m=0,t,u=!1;const r=a.charCodeAt(0);if(o===1)return p(r)?"\\":a;if(d(r))if(u=!0,d(a.charCodeAt(1))){let s=2,l=s;for(;s<o&&!d(a.charCodeAt(s));)s++;if(s<o&&s!==l){const h=a.slice(l,s);for(l=s;s<o&&d(a.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!d(a.charCodeAt(s));)s++;if(s===o)return`\\\\${h}\\${a.slice(l)}\\`;s!==l&&(t=`\\\\${h}\\${a.slice(l,s)}`,m=s)}}}else m=1;else D(r)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),m=2,o>2&&d(a.charCodeAt(2))&&(u=!0,m=3));let i=m<o?R(a.slice(m),!u,"\\",d):"";return i.length===0&&!u&&(i="."),i.length>0&&d(a.charCodeAt(o-1))&&(i+="\\"),t===void 0?u?`\\${i}`:i:u?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){f(a,"path");const o=a.length;if(o===0)return!1;const m=a.charCodeAt(0);return d(m)||o>2&&D(m)&&a.charCodeAt(1)===n&&d(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let o,m;for(let r=0;r<a.length;++r){const i=a[r];f(i,"path"),i.length>0&&(o===void 0?o=m=i:o+=`\\${i}`)}if(o===void 0)return".";let t=!0,u=0;if(typeof m=="string"&&d(m.charCodeAt(0))){++u;const r=m.length;r>1&&d(m.charCodeAt(1))&&(++u,r>2&&(d(m.charCodeAt(2))?++u:t=!1))}if(t){for(;u<o.length&&d(o.charCodeAt(u));)u++;u>=2&&(o=`\\${o.slice(u)}`)}return e.win32.normalize(o)},relative(a,o){if(f(a,"from"),f(o,"to"),a===o)return"";const m=e.win32.resolve(a),t=e.win32.resolve(o);if(m===t||(a=m.toLowerCase(),o=t.toLowerCase(),a===o))return"";let u=0;for(;u<a.length&&a.charCodeAt(u)===T;)u++;let r=a.length;for(;r-1>u&&a.charCodeAt(r-1)===T;)r--;const i=r-u;let s=0;for(;s<o.length&&o.charCodeAt(s)===T;)s++;let l=o.length;for(;l-1>s&&o.charCodeAt(l-1)===T;)l--;const h=l-s,w=i<h?i:h;let _=-1,v=0;for(;v<w;v++){const b=a.charCodeAt(u+v);if(b!==o.charCodeAt(s+v))break;b===T&&(_=v)}if(v!==w){if(_===-1)return t}else{if(h>w){if(o.charCodeAt(s+v)===T)return t.slice(s+v+1);if(v===2)return t.slice(s+v)}i>w&&(a.charCodeAt(u+v)===T?_=v:v===2&&(_=3)),_===-1&&(_=0)}let P="";for(v=u+_+1;v<=r;++v)(v===r||a.charCodeAt(v)===T)&&(P+=P.length===0?"..":"\\..");return s+=_,P.length>0?`${P}${t.slice(s,l)}`:(t.charCodeAt(s)===T&&++s,t.slice(s,l))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const o=e.win32.resolve(a);if(o.length<=2)return a;if(o.charCodeAt(0)===T){if(o.charCodeAt(1)===T){const m=o.charCodeAt(2);if(m!==I&&m!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===T)return`\\\\?\\${o}`;return a},dirname(a){f(a,"path");const o=a.length;if(o===0)return".";let m=-1,t=0;const u=a.charCodeAt(0);if(o===1)return d(u)?a:".";if(d(u)){if(m=t=1,d(a.charCodeAt(1))){let s=2,l=s;for(;s<o&&!d(a.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&d(a.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!d(a.charCodeAt(s));)s++;if(s===o)return a;s!==l&&(m=t=s+1)}}}}else D(u)&&a.charCodeAt(1)===n&&(m=o>2&&d(a.charCodeAt(2))?3:2,t=m);let r=-1,i=!0;for(let s=o-1;s>=t;--s)if(d(a.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(m===-1)return".";r=m}return a.slice(0,r)},basename(a,o){o!==void 0&&f(o,"ext"),f(a,"path");let m=0,t=-1,u=!0,r;if(a.length>=2&&D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(m=2),o!==void 0&&o.length>0&&o.length<=a.length){if(o===a)return"";let i=o.length-1,s=-1;for(r=a.length-1;r>=m;--r){const l=a.charCodeAt(r);if(d(l)){if(!u){m=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(l===o.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=s))}return m===t?t=s:t===-1&&(t=a.length),a.slice(m,t)}for(r=a.length-1;r>=m;--r)if(d(a.charCodeAt(r))){if(!u){m=r+1;break}}else t===-1&&(u=!1,t=r+1);return t===-1?"":a.slice(m,t)},extname(a){f(a,"path");let o=0,m=-1,t=0,u=-1,r=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&D(a.charCodeAt(0))&&(o=t=2);for(let s=a.length-1;s>=o;--s){const l=a.charCodeAt(s);if(d(l)){if(!r){t=s+1;break}continue}u===-1&&(r=!1,u=s+1),l===S?m===-1?m=s:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||u===-1||i===0||i===1&&m===u-1&&m===t+1?"":a.slice(m,u)},format:E.bind(null,"\\"),parse(a){f(a,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return o;const m=a.length;let t=0,u=a.charCodeAt(0);if(m===1)return d(u)?(o.root=o.dir=a,o):(o.base=o.name=a,o);if(d(u)){if(t=1,d(a.charCodeAt(1))){let _=2,v=_;for(;_<m&&!d(a.charCodeAt(_));)_++;if(_<m&&_!==v){for(v=_;_<m&&d(a.charCodeAt(_));)_++;if(_<m&&_!==v){for(v=_;_<m&&!d(a.charCodeAt(_));)_++;_===m?t=_:_!==v&&(t=_+1)}}}}else if(D(u)&&a.charCodeAt(1)===n){if(m<=2)return o.root=o.dir=a,o;if(t=2,d(a.charCodeAt(2))){if(m===3)return o.root=o.dir=a,o;t=3}}t>0&&(o.root=a.slice(0,t));let r=-1,i=t,s=-1,l=!0,h=a.length-1,w=0;for(;h>=t;--h){if(u=a.charCodeAt(h),d(u)){if(!l){i=h+1;break}continue}s===-1&&(l=!1,s=h+1),u===S?r===-1?r=h:w!==1&&(w=1):r!==-1&&(w=-1)}return s!==-1&&(r===-1||w===0||w===1&&r===s-1&&r===i+1?o.base=o.name=a.slice(i,s):(o.name=a.slice(i,r),o.base=a.slice(i,s),o.ext=a.slice(r,s))),i>0&&i!==t?o.dir=a.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let o="",m=!1;for(let t=a.length-1;t>=-1&&!m;t--){const u=t>=0?a[t]:g.cwd();f(u,"path"),u.length!==0&&(o=`${u}/${o}`,m=u.charCodeAt(0)===y)}return o=R(o,!m,"/",p),m?`/${o}`:o.length>0?o:"."},normalize(a){if(f(a,"path"),a.length===0)return".";const o=a.charCodeAt(0)===y,m=a.charCodeAt(a.length-1)===y;return a=R(a,!o,"/",p),a.length===0?o?"/":m?"./":".":(m&&(a+="/"),o?`/${a}`:a)},isAbsolute(a){return f(a,"path"),a.length>0&&a.charCodeAt(0)===y},join(...a){if(a.length===0)return".";let o;for(let m=0;m<a.length;++m){const t=a[m];f(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(a,o){if(f(a,"from"),f(o,"to"),a===o||(a=e.posix.resolve(a),o=e.posix.resolve(o),a===o))return"";const m=1,t=a.length,u=t-m,r=1,i=o.length-r,s=u<i?u:i;let l=-1,h=0;for(;h<s;h++){const _=a.charCodeAt(m+h);if(_!==o.charCodeAt(r+h))break;_===y&&(l=h)}if(h===s)if(i>s){if(o.charCodeAt(r+h)===y)return o.slice(r+h+1);if(h===0)return o.slice(r+h)}else u>s&&(a.charCodeAt(m+h)===y?l=h:h===0&&(l=0));let w="";for(h=m+l+1;h<=t;++h)(h===t||a.charCodeAt(h)===y)&&(w+=w.length===0?"..":"/..");return`${w}${o.slice(r+l)}`},toNamespacedPath(a){return a},dirname(a){if(f(a,"path"),a.length===0)return".";const o=a.charCodeAt(0)===y;let m=-1,t=!0;for(let u=a.length-1;u>=1;--u)if(a.charCodeAt(u)===y){if(!t){m=u;break}}else t=!1;return m===-1?o?"/":".":o&&m===1?"//":a.slice(0,m)},basename(a,o){o!==void 0&&f(o,"ext"),f(a,"path");let m=0,t=-1,u=!0,r;if(o!==void 0&&o.length>0&&o.length<=a.length){if(o===a)return"";let i=o.length-1,s=-1;for(r=a.length-1;r>=0;--r){const l=a.charCodeAt(r);if(l===y){if(!u){m=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(l===o.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=s))}return m===t?t=s:t===-1&&(t=a.length),a.slice(m,t)}for(r=a.length-1;r>=0;--r)if(a.charCodeAt(r)===y){if(!u){m=r+1;break}}else t===-1&&(u=!1,t=r+1);return t===-1?"":a.slice(m,t)},extname(a){f(a,"path");let o=-1,m=0,t=-1,u=!0,r=0;for(let i=a.length-1;i>=0;--i){const s=a.charCodeAt(i);if(s===y){if(!u){m=i+1;break}continue}t===-1&&(u=!1,t=i+1),s===S?o===-1?o=i:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===m+1?"":a.slice(o,t)},format:E.bind(null,"/"),parse(a){f(a,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return o;const m=a.charCodeAt(0)===y;let t;m?(o.root="/",t=1):t=0;let u=-1,r=0,i=-1,s=!0,l=a.length-1,h=0;for(;l>=t;--l){const w=a.charCodeAt(l);if(w===y){if(!s){r=l+1;break}continue}i===-1&&(s=!1,i=l+1),w===S?u===-1?u=l:h!==1&&(h=1):u!==-1&&(h=-1)}if(i!==-1){const w=r===0&&m?1:r;u===-1||h===0||h===1&&u===i-1&&u===r+1?o.base=o.name=a.slice(w,i):(o.name=a.slice(w,u),o.base=a.slice(w,i),o.ext=a.slice(u,i))}return r>0?o.dir=a.slice(0,r-1):m&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[140],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(C,...A){const S=A.reduce((n,I)=>(n[I]=!0,n),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!S[n]).forEach(n=>{for(let I=0;I<y.length;I++)if(n.search(y[I])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=k}),define(fe[141],me([0,1]),function(J,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(S,y,T){this.level=S,this.key=y,this.value=T,this.forward=[]}}const k=void 0;class C{constructor(S,y=2**16){this.comparator=S,this[g]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new L(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,k,k)}has(S){return Boolean(C._search(this,S,this.comparator))}get(S){return C._search(this,S,this.comparator)?.value}set(S,y){return C._insert(this,S,y,this.comparator)&&(this._size+=1),this}delete(S){const y=C._delete(this,S,this.comparator);return y&&(this._size-=1),y}forEach(S,y){let T=this._header.forward[0];for(;T;)S.call(y,T.value,T.key,this),T=T.forward[0]}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",y=this._header.forward[0];for(;y;)S+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return S}static _search(S,y,T){let n=S._header;for(let I=S._level-1;I>=0;I--)for(;n.forward[I]&&T(n.forward[I].key,y)<0;)n=n.forward[I];if(n=n.forward[0],n&&T(n.key,y)===0)return n}static _insert(S,y,T,n){let I=[],c=S._header;for(let f=S._level-1;f>=0;f--){for(;c.forward[f]&&n(c.forward[f].key,y)<0;)c=c.forward[f];I[f]=c}if(c=c.forward[0],c&&n(c.key,y)===0)return c.value=T,!1;{let f=C._randomLevel(S);if(f>S._level){for(let d=S._level;d<f;d++)I[d]=S._header;S._level=f}c=new L(f,y,T);for(let d=0;d<f;d++)c.forward[d]=I[d].forward[d],I[d].forward[d]=c;return!0}}static _randomLevel(S,y=.5){let T=1;for(;Math.random()<y&&T<S._maxLevel;)T+=1;return T}static _delete(S,y,T){let n=[],I=S._header;for(let c=S._level-1;c>=0;c--){for(;I.forward[c]&&T(I.forward[c].key,y)<0;)I=I.forward[c];n[c]=I}if(I=I.forward[0],!I||T(I.key,y)!==0)return!1;for(let c=0;c<S._level&&n[c].forward[c]===I;c++)n[c].forward[c]=I.forward[c];for(;S._level>0&&S._header.forward[S._level-1]===k;)S._level-=1;return!0}}e.SkipList=C}),define(fe[46],me([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(fe[3],me([0,1,17,75,6,95,46]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(o){o.None=()=>k.Disposable.None;function m(U){return(z,O=null,N)=>{let x=!1,B;return B=U(H=>{if(!x)return B?B.dispose():x=!0,z.call(O,H)},null,N),x&&B.dispose(),B}}o.once=m;function t(U,z){return h((O,N=null,x)=>U(B=>O.call(N,z(B)),null,x))}o.map=t;function u(U,z){return h((O,N=null,x)=>U(B=>{z(B),O.call(N,B)},null,x))}o.forEach=u;function r(U,z){return h((O,N=null,x)=>U(B=>z(B)&&O.call(N,B),null,x))}o.filter=r;function i(U){return U}o.signal=i;function s(...U){return(z,O=null,N)=>(0,k.combinedDisposable)(...U.map(x=>x(B=>z.call(O,B),null,N)))}o.any=s;function l(U,z,O){let N=O;return t(U,x=>(N=z(N,x),N))}o.reduce=l;function h(U){let z;const O=new c({onFirstListenerAdd(){z=U(O.fire,O)},onLastListenerRemove(){z.dispose()}});return O.event}function w(U,z,O=100,N=!1,x){let B,H,$,Y=0;const Q=new c({leakWarningThreshold:x,onFirstListenerAdd(){B=U(de=>{Y++,H=z(H,de),N&&!$&&(Q.fire(H),H=void 0),clearTimeout($),$=setTimeout(()=>{const _e=H;H=void 0,$=void 0,(!N||Y>1)&&Q.fire(_e),Y=0},O)})},onLastListenerRemove(){B.dispose()}});return Q.event}o.debounce=w;function _(U,z=(O,N)=>O===N){let O=!0,N;return r(U,x=>{const B=O||!z(x,N);return O=!1,N=x,B})}o.latch=_;function v(U,z){return[o.filter(U,z),o.filter(U,O=>!z(O))]}o.split=v;function P(U,z=!1,O=[]){let N=O.slice(),x=U($=>{N?N.push($):H.fire($)});const B=()=>{N&&N.forEach($=>H.fire($)),N=null},H=new c({onFirstListenerAdd(){x||(x=U($=>H.fire($)))},onFirstListenerDidAdd(){N&&(z?setTimeout(B):B())},onLastListenerRemove(){x&&x.dispose(),x=null}});return H.event}o.buffer=P;class b{constructor(z){this.event=z}map(z){return new b(t(this.event,z))}forEach(z){return new b(u(this.event,z))}filter(z){return new b(r(this.event,z))}reduce(z,O){return new b(l(this.event,z,O))}latch(){return new b(_(this.event))}debounce(z,O=100,N=!1,x){return new b(w(this.event,z,O,N,x))}on(z,O,N){return this.event(z,O,N)}once(z,O,N){return m(this.event)(z,O,N)}}function F(U){return new b(U)}o.chain=F;function M(U,z,O=N=>N){const N=(...$)=>H.fire(O(...$)),x=()=>U.on(z,N),B=()=>U.removeListener(z,N),H=new c({onFirstListenerAdd:x,onLastListenerRemove:B});return H.event}o.fromNodeEventEmitter=M;function q(U,z,O=N=>N){const N=(...$)=>H.fire(O(...$)),x=()=>U.addEventListener(z,N),B=()=>U.removeEventListener(z,N),H=new c({onFirstListenerAdd:x,onLastListenerRemove:B});return H.event}o.fromDOMEventEmitter=q;function G(U){return new Promise(z=>m(U)(z))}o.toPromise=G})(S=e.Event||(e.Event={}));class y{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${y._idPool++}`}start(m){this._stopWatch=new A.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let T=-1;function n(o){const m=T;return T=o,{dispose(){T=m}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(m,t=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let t=T;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||m<t)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(u)||0;if(this._stacks.set(u,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let i,s=0;for(const[l,h]of this._stacks)(!i||s<h)&&(i=l,s=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class c{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=T>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(m,t,u)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(t?[m,t]:m);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,t);const s=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof k.DisposableStore?u.add(l):Array.isArray(u)&&u.push(l),l}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,u]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,u):t[0].call(t[1],u)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class f extends c{async fireAsync(m,t,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,m]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],l={...i,waitUntil:h=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");u&&(h=u(h,typeof r=="function"?r:r[0])),s.push(h)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(h){(0,g.onUnexpectedError)(h);continue}Object.freeze(s),await Promise.allSettled(s).then(h=>{for(const w of h)w.status==="rejected"&&(0,g.onUnexpectedError)(w.reason)})}}}}e.AsyncEmitter=f;class d extends c{constructor(m){super(m);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=d;class p extends d{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=p;class D extends c{constructor(m){super(m);this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=D;class R{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const t={event:m,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const u=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(t=>this.emitter.fire(t))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=R;class E{constructor(){this.buffers=[]}wrapEvent(m){return(t,u,r)=>m(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>t.call(u,i)):t.call(u,i)},void 0,r)}bufferEvents(m){const t=[];this.buffers.push(t);const u=m();return this.buffers.pop(),t.forEach(r=>r()),u}}e.EventBufferer=E;class a{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(fe[21],me([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(S,y){const T=setTimeout(S.bind(y),0);return{dispose(){clearTimeout(T)}}});var k;(function(S){function y(T){return T===S.None||T===S.Cancelled||T instanceof C?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}S.isCancellationToken=y,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(fe[47],me([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const c=this._icons.get(I.id);c?I.description?c.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function C(n,I){return new S(n,I)}e.registerCodicon=C;function A(n){return n?n.replace(/\$\((.*?)\)/g,(I,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=A;class S{constructor(I,c,f){this.id=I,this.definition=c,this.description=f,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function y(n,I){const c=["codicon","codicon-"+n];return I&&c.push("codicon-modifier-"+I),c}e.getClassNamesArray=y;var T;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function c(p){if(p instanceof S)return["codicon","codicon-"+p.id];const D=I.exec(p.id);if(!D)return c(S.error);let[,R,E]=D;const a=["codicon","codicon-"+R];return E&&a.push("codicon-modifier-"+E.substr(1)),a}n.asClassNameArray=c;function f(p){return c(p).join(" ")}n.asClassName=f;function d(p){return"."+c(p).join(".")}n.asCSSSelector=d})(T=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(fe[96],me([0,1,17,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(a){const o=a;return o?[o.on,o.pause,o.resume,o.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=k;function C(a){const o=a;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(a,o){return new S(a,o)}e.newWriteableStream=A;class S{constructor(o,m){this.reducer=o,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(m=>m(o))}emitError(o){this.listeners.error.length===0?(0,g.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(m=>m(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,m){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(o,m){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const u=t.indexOf(m);u>=0&&t.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,o){const m=[];let t;for(;(t=a.read())!==null;)m.push(t);return o(m)}e.consumeReadable=y;function T(a,o,m){const t=[];let u;for(;(u=a.read())!==null&&t.length<m;)t.push(u);return u===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return a.read()}}}e.peekReadable=T;function n(a,o){return new Promise((m,t)=>{const u=[];I(a,{onData:r=>{o&&u.push(r)},onError:r=>{o?t(r):m(void 0)},onEnd:()=>{m(o?o(u):void 0)}})})}e.consumeStream=n;function I(a,o){a.on("error",m=>o.onError(m)),a.on("end",()=>o.onEnd()),a.on("data",m=>o.onData(m))}e.listenStream=I;function c(a,o){return new Promise((m,t)=>{const u=new L.DisposableStore,r=[],i=h=>{if(r.push(h),r.length>o)return u.dispose(),a.pause(),m({stream:a,buffer:r,ended:!1})},s=h=>t(h),l=()=>m({stream:a,buffer:r,ended:!0});u.add((0,L.toDisposable)(()=>a.removeListener("error",s))),a.on("error",s),u.add((0,L.toDisposable)(()=>a.removeListener("end",l))),a.on("end",l),u.add((0,L.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=c;function f(a,o){const m=A(o);return m.end(a),m}e.toStream=f;function d(){const a=A(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=d;function p(a){let o=!1;return{read:()=>o?null:(o=!0,a)}}e.toReadable=p;function D(a,o,m){const t=A(m);return I(a,{onData:u=>t.write(o.data(u)),onError:u=>t.error(o.error?o.error(u):u),onEnd:()=>t.end()}),t}e.transform=D;function R(a,o,m){let t=!1;return{read:()=>{const u=o.read();return t?u:(t=!0,u!==null?m([a,u]):a)}}}e.prefixedReadable=R;function E(a,o,m){let t=!1;const u=A(m);return I(o,{onData:r=>t?u.write(r):(t=!0,u.write(m([a,r]))),onError:r=>u.error(r),onEnd:()=>{t||(t=!0,u.write(a)),u.end()}}),u}e.prefixedStream=E}),define(fe[22],me([0,1,96]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,C;class A{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new A(Buffer.allocUnsafe(i)):new A(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new A(i)}static fromString(i,s){return!(s?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(i)):(k||(k=new TextEncoder),new A(k.encode(i)))}static concat(i,s){if(typeof s=="undefined"){s=0;for(let w=0,_=i.length;w<_;w++)s+=i[w].byteLength}const l=A.alloc(s);let h=0;for(let w=0,_=i.length;w<_;w++){const v=i[w];l.set(v,h),h+=v.byteLength}return l}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,s){return new A(this.buffer.subarray(i,s))}set(i,s){i instanceof A?this.buffer.set(i.buffer,s):this.buffer.set(i,s)}readUInt32BE(i){return T(this.buffer,i)}writeUInt32BE(i,s){n(this.buffer,i,s)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,s){c(this.buffer,i,s)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,s){d(this.buffer,i,s)}}e.VSBuffer=A;function S(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=S;function y(r,i,s){r[s+0]=i&255,i=i>>>8,r[s+1]=i&255}e.writeUInt16LE=y;function T(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=T;function n(r,i,s){r[s+3]=i,i=i>>>8,r[s+2]=i,i=i>>>8,r[s+1]=i,i=i>>>8,r[s]=i}e.writeUInt32BE=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=I;function c(r,i,s){r[s+0]=i&255,i=i>>>8,r[s+1]=i&255,i=i>>>8,r[s+2]=i&255,i=i>>>8,r[s+3]=i&255}e.writeUInt32LE=c;function f(r,i){return r[i]}e.readUInt8=f;function d(r,i,s){r[s]=i}e.writeUInt8=d;function p(r){return g.consumeReadable(r,i=>A.concat(i))}e.readableToBuffer=p;function D(r){return g.toReadable(r)}e.bufferToReadable=D;function R(r){return g.consumeStream(r,i=>A.concat(i))}e.streamToBuffer=R;async function E(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await R(r.stream)])}e.bufferedStreamToBuffer=E;function a(r){return g.toStream(r,i=>A.concat(i))}e.bufferToStream=a;function o(r){return g.transform(r,{data:i=>typeof i=="string"?A.fromString(i):A.wrap(i)},i=>A.concat(i))}e.streamToBufferReadableStream=o;function m(r){return g.newWriteableStream(i=>A.concat(i),r)}e.newWriteableBufferStream=m;function t(r,i){return g.prefixedReadable(r,i,s=>A.concat(s))}e.prefixedBufferReadable=t;function u(r,i){return g.prefixedStream(r,i,s=>A.concat(s))}e.prefixedBufferStream=u}),define(fe[9],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function k(ce,...Pe){return Pe.length===0?ce:ce.replace(L,function(xe,Xe){const ze=parseInt(Xe,10);return isNaN(ze)||ze<0||ze>=Pe.length?xe:Pe[ze]})}e.format=k;const C=/{([^}]+)}/g;function A(ce,Pe){return ce.replace(C,(xe,Xe)=>Pe[Xe]??xe)}e.format2=A;function S(ce){return ce.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.escape=S;function y(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function T(ce,Pe){let xe=0;const Xe=Pe.charCodeAt(0);for(let ze=ce.length-1;ze>=0;ze--)ce.charCodeAt(ze)===Xe&&xe++;return xe}e.count=T;function n(ce,Pe,xe="\u2026"){return ce.length<=Pe?ce:`${ce.substr(0,Pe)}${xe}`}e.truncate=n;function I(ce,Pe=" "){const xe=c(ce,Pe);return f(xe,Pe)}e.trim=I;function c(ce,Pe){if(!ce||!Pe)return ce;const xe=Pe.length;if(xe===0||ce.length===0)return ce;let Xe=0;for(;ce.indexOf(Pe,Xe)===Xe;)Xe=Xe+xe;return ce.substring(Xe)}e.ltrim=c;function f(ce,Pe){if(!ce||!Pe)return ce;const xe=Pe.length,Xe=ce.length;if(xe===0||Xe===0)return ce;let ze=Xe,ot=-1;for(;ot=ce.lastIndexOf(Pe,ze-1),!(ot===-1||ot+xe!==ze);){if(ot===0)return"";ze=ot}return ce.substring(0,ze)}e.rtrim=f;function d(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function p(ce){return ce.replace(/\*/g,"")}e.stripWildcards=p;function D(ce,Pe,xe={}){if(!ce)throw new Error("Cannot create regex from empty string");Pe||(ce=y(ce)),xe.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Xe="";return xe.global&&(Xe+="g"),xe.matchCase||(Xe+="i"),xe.multiline&&(Xe+="m"),xe.unicode&&(Xe+="u"),new RegExp(ce,Xe)}e.createRegExp=D;function R(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=R;function E(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function a(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=a;function o(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=o;function m(ce){for(let Pe=0,xe=ce.length;Pe<xe;Pe++){const Xe=ce.charCodeAt(Pe);if(Xe!==32&&Xe!==9)return Pe}return-1}e.firstNonWhitespaceIndex=m;function t(ce,Pe=0,xe=ce.length){for(let Xe=Pe;Xe<xe;Xe++){const ze=ce.charCodeAt(Xe);if(ze!==32&&ze!==9)return ce.substring(Pe,Xe)}return ce.substring(Pe,xe)}e.getLeadingWhitespace=t;function u(ce,Pe=ce.length-1){for(let xe=Pe;xe>=0;xe--){const Xe=ce.charCodeAt(xe);if(Xe!==32&&Xe!==9)return xe}return-1}e.lastNonWhitespaceIndex=u;function r(ce,Pe){return ce<Pe?-1:ce>Pe?1:0}e.compare=r;function i(ce,Pe,xe=0,Xe=ce.length,ze=0,ot=Pe.length){for(;xe<Xe&&ze<ot;xe++,ze++){let Ie=ce.charCodeAt(xe),ne=Pe.charCodeAt(ze);if(Ie<ne)return-1;if(Ie>ne)return 1}const Ae=Xe-xe,ye=ot-ze;return Ae<ye?-1:Ae>ye?1:0}e.compareSubstring=i;function s(ce,Pe){return l(ce,Pe,0,ce.length,0,Pe.length)}e.compareIgnoreCase=s;function l(ce,Pe,xe=0,Xe=ce.length,ze=0,ot=Pe.length){for(;xe<Xe&&ze<ot;xe++,ze++){let Ie=ce.charCodeAt(xe),ne=Pe.charCodeAt(ze);if(Ie===ne)continue;const ue=Ie-ne;if(!(ue===32&&w(ne))&&!(ue===-32&&w(Ie)))return h(Ie)&&h(ne)?ue:i(ce.toLowerCase(),Pe.toLowerCase(),xe,Xe,ze,ot)}const Ae=Xe-xe,ye=ot-ze;return Ae<ye?-1:Ae>ye?1:0}e.compareSubstringIgnoreCase=l;function h(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=h;function w(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=w;function _(ce){return h(ce)||w(ce)}function v(ce,Pe){return ce.length===Pe.length&&P(ce,Pe)}e.equalsIgnoreCase=v;function P(ce,Pe,xe=ce.length){for(let Xe=0;Xe<xe;Xe++){const ze=ce.charCodeAt(Xe),ot=Pe.charCodeAt(Xe);if(ze!==ot){if(_(ze)&&_(ot)){const Ae=Math.abs(ze-ot);if(Ae!==0&&Ae!==32)return!1}else if(String.fromCharCode(ze).toLowerCase()!==String.fromCharCode(ot).toLowerCase())return!1}}return!0}function b(ce,Pe){const xe=Pe.length;return Pe.length>ce.length?!1:P(ce,Pe,xe)}e.startsWithIgnoreCase=b;function F(ce,Pe){let xe,Xe=Math.min(ce.length,Pe.length);for(xe=0;xe<Xe;xe++)if(ce.charCodeAt(xe)!==Pe.charCodeAt(xe))return xe;return Xe}e.commonPrefixLength=F;function M(ce,Pe){let xe,Xe=Math.min(ce.length,Pe.length);const ze=ce.length-1,ot=Pe.length-1;for(xe=0;xe<Xe;xe++)if(ce.charCodeAt(ze-xe)!==Pe.charCodeAt(ot-xe))return xe;return Xe}e.commonSuffixLength=M;function q(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=q;function G(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=G;function U(ce,Pe){return(ce-55296<<10)+(Pe-56320)+65536}e.computeCodePoint=U;function z(ce,Pe,xe){const Xe=ce.charCodeAt(xe);if(q(Xe)&&xe+1<Pe){const ze=ce.charCodeAt(xe+1);if(G(ze))return U(Xe,ze)}return Xe}e.getNextCodePoint=z;function O(ce,Pe){const xe=ce.charCodeAt(Pe-1);if(G(xe)&&Pe>1){const Xe=ce.charCodeAt(Pe-2);if(q(Xe))return U(Xe,xe)}return xe}function N(ce,Pe){const xe=ge.getInstance(),Xe=Pe,ze=ce.length,ot=z(ce,ze,Pe);Pe+=ot>=65536?2:1;let Ae=xe.getGraphemeBreakType(ot);for(;Pe<ze;){const ye=z(ce,ze,Pe),Ie=xe.getGraphemeBreakType(ye);if(X(Ae,Ie))break;Pe+=ye>=65536?2:1,Ae=Ie}return Pe-Xe}e.nextCharLength=N;function x(ce,Pe){const xe=ge.getInstance(),Xe=Pe,ze=O(ce,Pe);Pe-=ze>=65536?2:1;let ot=xe.getGraphemeBreakType(ze);for(;Pe>0;){const Ae=O(ce,Pe),ye=xe.getGraphemeBreakType(Ae);if(X(ye,ot))break;Pe-=Ae>=65536?2:1,ot=ye}return Xe-Pe}e.prevCharLength=x;function B(ce,Pe){const xe=ge.getInstance(),Xe=ce.length,ze=Pe,ot=z(ce,Xe,Pe),Ae=xe.getGraphemeBreakType(ot);Pe+=ot>=65536?2:1;let ye=Ae;for(;Pe<Xe;){const ne=z(ce,Xe,Pe),ue=xe.getGraphemeBreakType(ne);if(X(ye,ue))break;Pe+=ne>=65536?2:1,ye=ue}const Ie=Pe;for(Pe=ze,ye=Ae;Pe>0;){const ne=O(ce,Pe),ue=xe.getGraphemeBreakType(ne);if(X(ue,ye))break;Pe-=ne>=65536?2:1,ye=ue}return[Pe,Ie]}function H(ce,Pe){return Pe>0&&G(ce.charCodeAt(Pe))?B(ce,Pe-1):B(ce,Pe)}e.getCharContainingOffset=H;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(ce){return $.test(ce)}e.containsRTL=Y;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function de(ce){return Q.test(ce)}e.containsEmoji=de;const _e=/^[\t\n\r\x20-\x7E]*$/;function Ce(ce){return _e.test(ce)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Te(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=Te;function $e(ce){for(let Pe=0,xe=ce.length;Pe<xe;Pe++)if(Be(ce.charCodeAt(Pe)))return!0;return!1}e.containsFullWidthCharacter=$e;function Be(ce){return ce=+ce,ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=Be;function He(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=He;function j(ce,Pe){if(ce.length<Pe)return ce;const xe=/\b/g;let Xe=0;for(;xe.test(ce)&&!(ce.length-xe.lastIndex<Pe);)Xe=xe.lastIndex,xe.lastIndex+=1;return ce.substring(Xe).replace(/^\s/,"")}e.lcut=j;const ee=/\x1B\x5B[12]?K/g,se=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function Z(ce){return ce&&(ce=ce.replace(ee,""),ce=ce.replace(se,""),ce=ce.replace(le,"")),ce}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ae;function ve(ce){return ae(ce)?ce.substr(1):ce}e.stripUTF8BOM=ve;function Me(ce,Pe){if(!ce||!Pe||ce.length<Pe.length)return!1;const xe=Pe.length,Xe=ce.toLowerCase();let ze=0,ot=-1;for(;ze<xe;){const Ae=Xe.indexOf(Pe[ze],ot+1);if(Ae<0)return!1;ot=Ae,ze++}return!0}e.fuzzyContains=Me;function qe(ce,Pe=!1){return ce?(Pe&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=qe;function Ye(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Ye;function Ze(ce,Pe=1){if(Pe===0)return"";let xe=-1;do xe=ce.indexOf(`
`,xe+1),Pe--;while(Pe>0&&xe>=0);return xe===-1?ce:(ce[xe-1]==="\r"&&xe--,ce.substr(0,xe))}e.getNLines=Ze;function ke(ce){const Pe=90-65+1;return ce=ce%(2*Pe),ce<Pe?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Pe)}e.singleLetterHash=ke;function at(ce){return ge.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=at;function X(ce,Pe){return ce===0?Pe!==5&&Pe!==7:ce===2&&Pe===3?!1:ce===4||ce===2||ce===3||Pe===4||Pe===2||Pe===3?!0:!(ce===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(ce===11||ce===9)&&(Pe===9||Pe===10)||(ce===12||ce===10)&&Pe===10||Pe===5||Pe===13||Pe===7||ce===1||ce===13&&Pe===14||ce===6&&Pe===6)}e.breakBetweenGraphemeBreakType=X;var te;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ge{constructor(){this._data=je()}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const xe=this._data,Xe=xe.length/3;let ze=1;for(;ze<=Xe;)if(Pe<xe[3*ze])ze=2*ze;else if(Pe>xe[3*ze+1])ze=2*ze+1;else return xe[3*ze+2];return 0}}ge._INSTANCE=null;function je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(ce,Pe){if(ce===0)return 0;const xe=lt(ce,Pe);if(xe!==void 0)return xe;const Xe=O(Pe,ce);return ce-=ft(Xe),ce}e.getLeftDeleteOffset=tt;function lt(ce,Pe){let xe=O(Pe,ce);for(ce-=ft(xe);wt(xe)||xe===65039||xe===8419;){if(ce===0)return;xe=O(Pe,ce),ce-=ft(xe)}if(!!He(xe)){if(ce>=0){const Xe=O(Pe,ce);Xe===8205&&(ce-=ft(Xe))}return ce}}function ft(ce){return ce>=65536?2:1}function wt(ce){return 127995<=ce&&ce<=127999}var Ct;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(Ct||(Ct={}))}),define(fe[48],me([0,1,9]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(R){return k(R,0)}e.hash=L;function k(R,E){switch(typeof R){case"object":return R===null?C(349,E):Array.isArray(R)?y(R,E):T(R,E);case"string":return S(R,E);case"boolean":return A(R,E);case"number":return C(R,E);case"undefined":return C(937,E);default:return C(617,E)}}e.doHash=k;function C(R,E){return(E<<5)-E+R|0}function A(R,E){return C(R?433:863,E)}function S(R,E){E=C(149417,E);for(let a=0,o=R.length;a<o;a++)E=C(R.charCodeAt(a),E);return E}e.stringHash=S;function y(R,E){return E=C(104579,E),R.reduce((a,o)=>k(o,a),E)}function T(R,E){return E=C(181387,E),Object.keys(R).sort().reduce((a,o)=>(a=S(o,a),k(R[o],a)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=n;var I;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(R,E,a=32){const o=a-E,m=~((1<<o)-1);return(R<<E|(m&R)>>>o)>>>0}function f(R,E=0,a=R.byteLength,o=0){for(let m=0;m<a;m++)R[E+m]=o}function d(R,E,a="0"){for(;R.length<E;)R=a+R;return R}function p(R,E=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(a=>a.toString(16).padStart(2,"0")).join(""):d((R>>>0).toString(16),E/4)}e.toHexString=p;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const o=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,u,r;for(t!==0?(u=t,r=-1,t=0):(u=E.charCodeAt(0),r=0);;){let i=u;if(g.isHighSurrogate(u))if(r+1<a){const s=E.charCodeAt(r+1);g.isLowSurrogate(s)?(r++,i=g.computeCodePoint(u,s)):i=65533}else{t=u;break}else g.isLowSurrogate(u)&&(i=65533);if(m=this._push(o,m,i),r++,r<a)u=E.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=t}_push(E,a,o){return o<128?E[a++]=o:o<2048?(E[a++]=192|(o&1984)>>>6,E[a++]=128|(o&63)>>>0):o<65536?(E[a++]=224|(o&61440)>>>12,E[a++]=128|(o&4032)>>>6,E[a++]=128|(o&63)>>>0):(E[a++]=240|(o&1835008)>>>18,E[a++]=128|(o&258048)>>>12,E[a++]=128|(o&4032)>>>6,E[a++]=128|(o&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=D._bigBlock32,a=this._buffDV;for(let h=0;h<64;h+=4)E.setUint32(h,a.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)E.setUint32(h,c(E.getUint32(h-12,!1)^E.getUint32(h-32,!1)^E.getUint32(h-56,!1)^E.getUint32(h-64,!1),1),!1);let o=this._h0,m=this._h1,t=this._h2,u=this._h3,r=this._h4,i,s,l;for(let h=0;h<80;h++)h<20?(i=m&t|~m&u,s=1518500249):h<40?(i=m^t^u,s=1859775393):h<60?(i=m&t|m&u|t&u,s=2400959708):(i=m^t^u,s=3395469782),l=c(o,5)+i+r+s+E.getUint32(h*4,!1)&4294967295,r=u,u=t,t=c(m,30),m=o,o=l;this._h0=this._h0+o&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[49],me([0,1,9]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const C="error",A="warning",S="warn",y="info",T="ignore";function n(c){return c?g.equalsIgnoreCase(C,c)?k.Error:g.equalsIgnoreCase(A,c)||g.equalsIgnoreCase(S,c)?k.Warning:g.equalsIgnoreCase(y,c)?k.Info:k.Ignore:k.Ignore}k.fromValue=n;function I(c){switch(c){case k.Error:return C;case k.Warning:return A;case k.Info:return y;default:return T}}k.toString=I}(L||(L={})),e.default=L}),define(fe[12],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(w){return Array.isArray(w)}e.isArray=g;function L(w){return typeof w=="string"}e.isString=L;function k(w){return Array.isArray(w)&&w.every(_=>L(_))}e.isStringArray=k;function C(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=C;function A(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=A;function S(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=S;function y(w){return w===!0||w===!1}e.isBoolean=y;function T(w){return typeof w=="undefined"}e.isUndefined=T;function n(w){return!I(w)}e.isDefined=n;function I(w){return T(w)||w===null}e.isUndefinedOrNull=I;function c(w,_){if(!w)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=c;function f(w){if(I(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=f;function d(...w){const _=[];for(let v=0;v<w.length;v++){const P=w[v];if(I(P))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);_.push(P)}return _}e.assertAllDefined=d;const p=Object.prototype.hasOwnProperty;function D(w){if(!C(w))return!1;for(let _ in w)if(p.call(w,_))return!1;return!0}e.isEmptyObject=D;function R(w){return typeof w=="function"}e.isFunction=R;function E(...w){return w.length>0&&w.every(R)}e.areFunctions=E;function a(w,_){const v=Math.min(w.length,_.length);for(let P=0;P<v;P++)o(w[P],_[P])}e.validateConstraints=a;function o(w,_){if(L(_)){if(typeof w!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(R(_)){try{if(w instanceof _)return}catch{}if(!I(w)&&w.constructor===_||_.length===1&&_.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function m(w){let _=[],v=Object.getPrototypeOf(w);for(;Object.prototype!==v;)_=_.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return _}e.getAllPropertyNames=m;function t(w){const _=[];for(const v of m(w))typeof w[v]=="function"&&_.push(v);return _}e.getAllMethodNames=t;function u(w,_){const v=b=>function(){const F=Array.prototype.slice.call(arguments,0);return _(b,F)};let P={};for(const b of w)P[b]=v(b);return P}e.createProxyObject=u;function r(w){return w===null?void 0:w}e.withNullAsUndefined=r;function i(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=i;function s(w){return class{constructor(){return new Proxy({},{get(_,v){if(_[v])return _[v];throw new Error(`Not Implemented: ${w}->${String(v)}`)}})}}}e.NotImplementedProxy=s;function l(w,_="Unreachable"){throw new Error(_)}e.assertNever=l;function h(w){return!!w&&typeof w.then=="function"&&typeof w.catch=="function"}e.isPromise=h}),define(fe[29],me([0,1,8,11,9,12]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function S(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=S;function y(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function T(r,i=g.posix.sep){if(!r)return"";const s=r.length,l=r.charCodeAt(0);if(A(l)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let w=3;const _=w;for(;w<s&&!A(r.charCodeAt(w));w++);if(_!==w&&!A(r.charCodeAt(w+1))){for(w+=1;w<s;w++)if(A(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(R(l)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(A(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=T;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let s=2;const l=s;for(;s<r.length&&(i=r.charCodeAt(s),i!==92);s++);return!(l===s||(i=r.charCodeAt(s+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,i=L.isWindows){const s=i?I:c;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function p(r,i,s){const l=r===i;return!s||l?l:!r||!i?!1:(0,k.equalsIgnoreCase)(r,i)}e.isEqual=p;function D(r,i,s,l=g.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let w=i.length;return i.charAt(i.length-1)===l&&w--,r.charAt(w)===l}return i.charAt(i.length-1)!==l&&(i+=l),r.indexOf(i)===0}e.isEqualOrParent=D;function R(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=R;function E(r,i){return L.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(i,r)),r=(0,g.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,k.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=E;function a(r){const i=(0,g.normalize)(r);return L.isWindows?r.length>3?!1:o(i)&&(r.length===2||i.charCodeAt(2)===92):i===g.posix.sep}e.isRootOrDriveLetter=a;function o(r){return L.isWindows?R(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function m(r){return o(r)?r[0]:void 0}e.getDriveLetter=m;function t(r,i,s){return i.length>r.length?-1:r===i?0:(s&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function u(r){const i=r.split(":");let s,l,h;if(i.forEach(w=>{const _=Number(w);(0,C.isNumber)(_)?l===void 0?l=_:h===void 0&&(h=_):s=s?[s,w].join(":"):w}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(fe[25],me([0,1,12]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const D=Array.isArray(p)?[]:{};return Object.keys(p).forEach(R=>{p[R]&&typeof p[R]=="object"?D[R]=L(p[R]):D[R]=p[R]}),D}e.deepClone=L;function k(p){if(!p||typeof p!="object")return p;const D=[p];for(;D.length>0;){const R=D.shift();Object.freeze(R);for(const E in R)if(C.call(R,E)){const a=R[E];typeof a=="object"&&!Object.isFrozen(a)&&D.push(a)}}return p}e.deepFreeze=k;const C=Object.prototype.hasOwnProperty;function A(p,D){return S(p,D,new Set)}e.cloneAndChange=A;function S(p,D,R){if((0,g.isUndefinedOrNull)(p))return p;const E=D(p);if(typeof E!="undefined")return E;if((0,g.isArray)(p)){const a=[];for(const o of p)a.push(S(o,D,R));return a}if((0,g.isObject)(p)){if(R.has(p))throw new Error("Cannot clone recursive data-structure");R.add(p);const a={};for(let o in p)C.call(p,o)&&(a[o]=S(p[o],D,R));return R.delete(p),a}return p}function y(p,D,R=!0){return(0,g.isObject)(p)?((0,g.isObject)(D)&&Object.keys(D).forEach(E=>{E in p?R&&((0,g.isObject)(p[E])&&(0,g.isObject)(D[E])?y(p[E],D[E],R):p[E]=D[E]):p[E]=D[E]}),p):D}e.mixin=y;function T(p,D){if(p===D)return!0;if(p==null||D===null||D===void 0||typeof p!=typeof D||typeof p!="object"||Array.isArray(p)!==Array.isArray(D))return!1;let R,E;if(Array.isArray(p)){if(p.length!==D.length)return!1;for(R=0;R<p.length;R++)if(!T(p[R],D[R]))return!1}else{const a=[];for(E in p)a.push(E);a.sort();const o=[];for(E in D)o.push(E);if(o.sort(),!T(a,o))return!1;for(R=0;R<a.length;R++)if(!T(p[a[R]],D[a[R]]))return!1}return!0}e.equals=T;function n(p){const D=new Set;return JSON.stringify(p,(R,E)=>{if((0,g.isObject)(E)||Array.isArray(E)){if(D.has(E))return"[Circular]";D.add(E)}return E})}e.safeStringify=n;function I(p,D,R){const E=D(p);return typeof E=="undefined"?R:E}e.getOrDefault=I;function c(p,D){const R=Object.create(null);return!p||!D||Object.keys(D).forEach(a=>{const o=p[a],m=D[a];T(o,m)||(R[a]=m)}),R}e.distinct=c;function f(p,D){const R=D.toLowerCase(),E=Object.keys(p).find(a=>a.toLowerCase()===R);return E?p[E]:p[D]}e.getCaseInsensitive=f;function d(p,D){const R=Object.create(null);for(const E of Object.keys(p))D(E,p[E])&&(R[E]=p[E]);return R}e.filter=d}),define(fe[97],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function k(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=k}),define(fe[2],me([0,1,8,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,C=/^\//,A=/^\/\//;function S(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,i){return!r&&!i?"file":r}function T(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,s,l,h,w,_=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,_),this.authority=s||n,this.path=T(this.scheme,l||n),this.query=h||n,this.fragment=w||n,S(this,_))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:l,path:h,query:w,fragment:_}=i;return s===void 0?s=this.scheme:s===null&&(s=n),l===void 0?l=this.authority:l===null&&(l=n),h===void 0?h=this.path:h===null&&(h=n),w===void 0?w=this.query:w===null&&(w=n),_===void 0?_=this.fragment:_===null&&(_=n),s===this.scheme&&l===this.authority&&h===this.path&&w===this.query&&_===this.fragment?this:new p(s,l,h,w,_)}static parse(i,s=!1){const l=c.exec(i);return l?new p(l[2]||n,u(l[4]||n),u(l[5]||n),u(l[7]||n),u(l[9]||n),s):new p(n,n,n,n,n)}static file(i){let s=n;if(L.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const l=i.indexOf(I,2);l===-1?(s=i.substring(2),i=I):(s=i.substring(2,l),i=i.substring(l)||I)}return new p("file",s,i,n,n)}static from(i){const s=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return S(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&i.scheme==="file"?l=f.file(g.win32.join(a(i,!0),...s)).path:l=g.posix.join(i.path,...s),i.with({path:l})}toString(i=!1){return o(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const s=new p(i);return s._formatted=i.external,s._fsPath=i._sep===d?i.fsPath:null,s}}else return i}}e.URI=f;const d=L.isWindows?1:void 0;class p extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=d),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(r,i){let s,l=-1;for(let h=0;h<r.length;h++){const w=r.charCodeAt(h);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47)l!==-1&&(s+=encodeURIComponent(r.substring(l,h)),l=-1),s!==void 0&&(s+=r.charAt(h));else{s===void 0&&(s=r.substr(0,h));const _=D[w];_!==void 0?(l!==-1&&(s+=encodeURIComponent(r.substring(l,h)),l=-1),s+=_):l===-1&&(l=h)}}return l!==-1&&(s+=encodeURIComponent(r.substring(l))),s!==void 0?s:r}function E(r){let i;for(let s=0;s<r.length;s++){const l=r.charCodeAt(s);l===35||l===63?(i===void 0&&(i=r.substr(0,s)),i+=D[l]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function a(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,L.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=a;function o(r,i){const s=i?E:R;let l="",{scheme:h,authority:w,path:_,query:v,fragment:P}=r;if(h&&(l+=h,l+=":"),(w||h==="file")&&(l+=I,l+=I),w){let b=w.indexOf("@");if(b!==-1){const F=w.substr(0,b);w=w.substr(b+1),b=F.indexOf(":"),b===-1?l+=s(F,!1):(l+=s(F.substr(0,b),!1),l+=":",l+=s(F.substr(b+1),!1)),l+="@"}w=w.toLowerCase(),b=w.indexOf(":"),b===-1?l+=s(w,!1):(l+=s(w.substr(0,b),!1),l+=w.substr(b))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const b=_.charCodeAt(1);b>=65&&b<=90&&(_=`/${String.fromCharCode(b+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const b=_.charCodeAt(0);b>=65&&b<=90&&(_=`${String.fromCharCode(b+32)}:${_.substr(2)}`)}l+=s(_,!0)}return v&&(l+="?",l+=s(v,!1)),P&&(l+="#",l+=i?P:R(P,!1)),l}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(t)?r.replace(t,i=>m(i)):r}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[24],me([0,1,16,9,2]),function(J,e,g,L,k){"use strict";var C,A,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(u,r,i){let s=u.get(r);return s===void 0&&(s=i,u.set(r,s)),s}e.getOrSet=y;function T(u){const r=[];return u.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${u.size}) {${r.join(", ")}}`}e.mapToString=T;function n(u){const r=[];return u.forEach(i=>{r.push(i)}),`Set(${u.size}) {${r.join(", ")}}`}e.setToString=n;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=I;class c{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=c;class f{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var d;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(d||(d={}));class p{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class D{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class R{constructor(r){this._iter=r}static forUris(r=()=>!1){return new R(new p(r))}static forPaths(){return new R(new f)}static forStrings(){return new R(new I)}static forConfigKeys(){return new R(new c)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let l;for(this._root||(this._root=new D,this._root.segment=s.value()),l=this._root;;){const w=s.cmp(l.segment);if(w>0)l.left||(l.left=new D,l.left.segment=s.value()),l=l.left;else if(w<0)l.right||(l.right=new D,l.right.segment=s.value()),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new D,l.mid.segment=s.value()),l=l.mid;else break}const h=l.value;return l.value=i,l.key=r,h}fill(r,i){const s=i.slice(0);(0,g.shuffle)(s);for(let l of s)this.set(l,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const l=i.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),l=[];let h=this._root;for(;h;){const w=s.cmp(h.segment);if(w>0)l.push([1,h]),h=h.left;else if(w<0)l.push([-1,h]),h=h.right;else if(s.hasNext())s.next(),l.push([0,h]),h=h.mid;else{for(i?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;l.length>0&&h.isEmpty();){let[_,v]=l.pop();switch(_){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}h=v}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,l;for(;s;){const h=i.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(i.hasNext())i.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const l=i.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=R;class E{constructor(r,i){this[C]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,l]of this.map)r(l,k.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=u=>u.toString();var a;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class o{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let l=this._map.get(r);if(l)l.value=i,s!==0&&this.touch(l,s);else{switch(l={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let l=this._head;for(;l;){if(i?r.bind(i)(l.value,l.key,this):r(l.value,l.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,i=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return l}values(){const r=this,i=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return l}entries(){const r=this,i=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(s.previous=l,l.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,l=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=l,l.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=o;class m extends o{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class t{constructor(r){S.set(this,void 0),it(this,S,r,"f")}get size(){return Oe(this,S,"f").size}forEach(r,i){Oe(this,S,"f").forEach(r,i)}get(r){return Oe(this,S,"f").get(r)}has(r){return Oe(this,S,"f").has(r)}entries(){return Oe(this,S,"f").entries()}keys(){return Oe(this,S,"f").keys()}values(){return Oe(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Oe(this,S,"f").entries()}}e.ReadonlyMapView=t}),define(fe[98],me([0,1,24,9]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Z){return function(ae,ve){for(let Me=0,qe=Z.length;Me<qe;Me++){const Ye=Z[Me](ae,ve);if(Ye)return Ye}return null}}e.or=k,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,ae,ve){if(!ve||ve.length<ae.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(ve,ae):Me=ve.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(Z,ae){const ve=ae.toLowerCase().indexOf(Z.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Z.length}]}e.matchesContiguousSubString=A;function S(Z,ae){return y(Z.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=S;function y(Z,ae,ve,Me){if(ve===Z.length)return[];if(Me===ae.length)return null;if(Z[ve]===ae[Me]){let qe=null;return(qe=y(Z,ae,ve+1,Me+1))?R({start:Me,end:Me+1},qe):null}return y(Z,ae,ve,Me+1)}function T(Z){return 97<=Z&&Z<=122}function n(Z){return 65<=Z&&Z<=90}e.isUpper=n;function I(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>f.add(Z.charCodeAt(0)));function d(Z){return c(Z)||f.has(Z)}function p(Z,ae){return Z===ae||d(Z)&&d(ae)}function D(Z){return T(Z)||n(Z)||I(Z)}function R(Z,ae){return ae.length===0?ae=[Z]:Z.end===ae[0].start?ae[0].start=Z.start:ae.unshift(Z),ae}function E(Z,ae){for(let ve=ae;ve<Z.length;ve++){const Me=Z.charCodeAt(ve);if(n(Me)||I(Me)||ve>0&&!D(Z.charCodeAt(ve-1)))return ve}return Z.length}function a(Z,ae,ve,Me){if(ve===Z.length)return[];if(Me===ae.length)return null;if(Z[ve]!==ae[Me].toLowerCase())return null;{let qe=null,Ye=Me+1;for(qe=a(Z,ae,ve+1,Me+1);!qe&&(Ye=E(ae,Ye))<ae.length;)qe=a(Z,ae,ve+1,Ye),Ye++;return qe===null?null:R({start:Me,end:Me+1},qe)}}function o(Z){let ae=0,ve=0,Me=0,qe=0,Ye=0;for(let te=0;te<Z.length;te++)Ye=Z.charCodeAt(te),n(Ye)&&ae++,T(Ye)&&ve++,D(Ye)&&Me++,I(Ye)&&qe++;const Ze=ae/Z.length,ke=ve/Z.length,at=Me/Z.length,X=qe/Z.length;return{upperPercent:Ze,lowerPercent:ke,alphaPercent:at,numericPercent:X}}function m(Z){const{upperPercent:ae,lowerPercent:ve}=Z;return ve===0&&ae>.6}function t(Z){const{upperPercent:ae,lowerPercent:ve,alphaPercent:Me,numericPercent:qe}=Z;return ve>.2&&ae<.8&&Me>.6&&qe<.2}function u(Z){let ae=0,ve=0,Me=0,qe=0;for(let Ye=0;Ye<Z.length;Ye++)Me=Z.charCodeAt(Ye),n(Me)&&ae++,T(Me)&&ve++,c(Me)&&qe++;return(ae===0||ve===0)&&qe===0?Z.length<=30:ae<=5}function r(Z,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!u(Z)||ae.length>60)return null;const ve=o(ae);if(!t(ve)){if(!m(ve))return null;ae=ae.toLowerCase()}let Me=null,qe=0;for(Z=Z.toLowerCase();qe<ae.length&&(Me=a(Z,ae,0,qe))===null;)qe=E(ae,qe+1);return Me}e.matchesCamelCase=r;function i(Z,ae,ve=!1){if(!ae||ae.length===0)return null;let Me=null,qe=0;for(Z=Z.toLowerCase(),ae=ae.toLowerCase();qe<ae.length&&(Me=s(Z,ae,0,qe,ve))===null;)qe=l(ae,qe+1);return Me}e.matchesWords=i;function s(Z,ae,ve,Me,qe){if(ve===Z.length)return[];if(Me===ae.length)return null;if(p(Z.charCodeAt(ve),ae.charCodeAt(Me))){let Ye=null,Ze=Me+1;if(Ye=s(Z,ae,ve+1,Me+1,qe),!qe)for(;!Ye&&(Ze=l(ae,Ze))<ae.length;)Ye=s(Z,ae,ve+1,Ze,qe),Ze++;return Ye===null?null:R({start:Me,end:Me+1},Ye)}else return null}function l(Z,ae){for(let ve=ae;ve<Z.length;ve++)if(d(Z.charCodeAt(ve))||ve>0&&d(Z.charCodeAt(ve-1)))return ve;return Z.length}const h=k(e.matchesPrefix,r,A),w=k(e.matchesPrefix,r,S),_=new g.LRUCache(1e4);function v(Z,ae,ve=!1){if(typeof Z!="string"||typeof ae!="string")return null;let Me=_.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),_.set(Z,Me));const qe=Me.exec(ae);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:ve?w(Z,ae):h(Z,ae)}e.matchesFuzzy=v;function P(Z,ae){const ve=$e(Z,Z.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=P;function b(Z,ae,ve,Me,qe,Ye){const Ze=Math.min(13,Z.length);for(;ve<Ze;ve++){const ke=$e(Z,ae,ve,Me,qe,Ye,!1);if(ke)return ke}return[0,Ye]}e.anyScore=b;function F(Z){if(typeof Z=="undefined")return[];const ae=[],ve=Z[1];for(let Me=Z.length-1;Me>1;Me--){const qe=Z[Me]+ve,Ye=ae[ae.length-1];Ye&&Ye.end===qe?Ye.end=qe+1:ae.push({start:qe,end:qe+1})}return ae}e.createMatches=F;const M=128;function q(){const Z=[],ae=[];for(let ve=0;ve<=M;ve++)ae[ve]=0;for(let ve=0;ve<=M;ve++)Z.push(ae.slice(0));return Z}function G(Z){const ae=[];for(let ve=0;ve<=Z;ve++)ae[ve]=0;return ae}const U=G(2*M),z=G(2*M),O=q(),N=q(),x=q(),B=!1;function H(Z,ae,ve,Me,qe){function Ye(ke,at,X=" "){for(;ke.length<at;)ke=X+ke;return ke}let Ze=` |   |${Me.split("").map(ke=>Ye(ke,3)).join("|")}
`;for(let ke=0;ke<=ve;ke++)ke===0?Ze+=" |":Ze+=`${ae[ke-1]}|`,Ze+=Z[ke].slice(0,qe+1).map(at=>Ye(at.toString(),3)).join("|")+`
`;return Ze}function $(Z,ae,ve,Me){Z=Z.substr(ae),ve=ve.substr(Me),console.log(H(N,Z,Z.length,ve,ve.length)),console.log(H(x,Z,Z.length,ve,ve.length)),console.log(H(O,Z,Z.length,ve,ve.length))}function Y(Z,ae){if(ae<0||ae>=Z.length)return!1;const ve=Z.codePointAt(ae);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function Q(Z,ae){if(ae<0||ae>=Z.length)return!1;switch(Z.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function de(Z,ae,ve){return ae[Z]!==ve[Z]}function _e(Z,ae,ve,Me,qe,Ye,Ze=!1){for(;ae<ve&&qe<Ye;)Z[ae]===Me[qe]&&(Ze&&(U[ae]=qe),ae+=1),qe+=1;return ae===ve}e.isPatternInWord=_e;var Ce;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Te;(function(Z){Z.Default=[-100,0];function ae(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Z.isDefault=ae})(Te=e.FuzzyScore||(e.FuzzyScore={}));function $e(Z,ae,ve,Me,qe,Ye,Ze){const ke=Z.length>M?M:Z.length,at=Me.length>M?M:Me.length;if(ve>=ke||Ye>=at||ke-ve>at-Ye||!_e(ae,ve,ke,qe,Ye,at,!0))return;Be(ke,at,ve,Ye,ae,qe);let X=1,te=1,ge=ve,je=Ye;const tt=[!1];for(X=1,ge=ve;ge<ke;X++,ge++){const ce=U[ge],Pe=z[ge],xe=ge+1<ke?z[ge+1]:at;for(te=ce-Ye+1,je=ce;je<xe;te++,je++){let Xe=Number.MIN_SAFE_INTEGER,ze=!1;je<=Pe&&(Xe=He(Z,ae,ge,ve,Me,qe,je,at,Ye,O[X-1][te-1]===0,tt));let ot=0;Xe!==Number.MAX_SAFE_INTEGER&&(ze=!0,ot=Xe+N[X-1][te-1]);const Ae=je>ce,ye=Ae?N[X][te-1]+(O[X][te-1]>0?-5:0):0,Ie=je>ce+1&&O[X][te-1]>0,ne=Ie?N[X][te-2]+(O[X][te-2]>0?-5:0):0;if(Ie&&(!Ae||ne>=ye)&&(!ze||ne>=ot))N[X][te]=ne,x[X][te]=3,O[X][te]=0;else if(Ae&&(!ze||ye>=ot))N[X][te]=ye,x[X][te]=2,O[X][te]=0;else if(ze)N[X][te]=ot,x[X][te]=1,O[X][te]=O[X-1][te-1]+1;else throw new Error("not possible")}}if(B&&$(Z,ve,Me,Ye),!tt[0]&&!Ze)return;X--,te--;const lt=[N[X][te],Ye];let ft=0,wt=0;for(;X>=1;){let ce=te;do{const Pe=x[X][ce];if(Pe===3)ce=ce-2;else if(Pe===2)ce=ce-1;else break}while(ce>=1);ft>1&&ae[ve+X-1]===qe[Ye+te-1]&&!de(ce+Ye-1,Me,qe)&&ft+1>O[X][ce]&&(ce=te),ce===te?ft++:ft=1,wt||(wt=ce),X--,te=ce-1,lt.push(te)}at===ke&&(lt[0]+=2);const Ct=wt-ke;return lt[0]-=Ct,lt}e.fuzzyScore=$e;function Be(Z,ae,ve,Me,qe,Ye){let Ze=Z-1,ke=ae-1;for(;Ze>=ve&&ke>=Me;)qe[Ze]===Ye[ke]&&(z[Ze]=ke,Ze--),ke--}function He(Z,ae,ve,Me,qe,Ye,Ze,ke,at,X,te){if(ae[ve]!==Ye[Ze])return Number.MIN_SAFE_INTEGER;let ge=1,je=!1;return Ze===ve-Me?ge=Z[ve]===qe[Ze]?7:5:de(Ze,qe,Ye)&&(Ze===0||!de(Ze-1,qe,Ye))?(ge=Z[ve]===qe[Ze]?7:5,je=!0):Y(Ye,Ze)&&(Ze===0||!Y(Ye,Ze-1))?ge=5:(Y(Ye,Ze-1)||Q(Ye,Ze-1))&&(ge=5,je=!0),ge>1&&ve===Me&&(te[0]=!0),je||(je=de(Ze,qe,Ye)||Y(Ye,Ze-1)||Q(Ye,Ze-1)),ve===Me?Ze>at&&(ge-=je?3:5):X?ge+=je?2:0:ge+=je?0:1,Ze+1===ke&&(ge-=je?3:5),ge}function j(Z,ae,ve,Me,qe,Ye,Ze){return se(Z,ae,ve,Me,qe,Ye,!0,Ze)}e.fuzzyScoreGracefulAggressive=j;function ee(Z,ae,ve,Me,qe,Ye,Ze){return se(Z,ae,ve,Me,qe,Ye,!1,Ze)}e.fuzzyScoreGraceful=ee;function se(Z,ae,ve,Me,qe,Ye,Ze,ke){let at=$e(Z,ae,ve,Me,qe,Ye,ke);if(at&&!Ze)return at;if(Z.length>=3){const X=Math.min(7,Z.length-1);for(let te=ve+1;te<X;te++){const ge=le(Z,te);if(ge){const je=$e(ge,ge.toLowerCase(),ve,Me,qe,Ye,ke);je&&(je[0]-=3,(!at||je[0]>at[0])&&(at=je))}}}return at}function le(Z,ae){if(ae+1>=Z.length)return;const ve=Z[ae],Me=Z[ae+1];if(ve!==Me)return Z.slice(0,ae)+Me+ve+Z.slice(ae+2)}}),define(fe[142],me([0,1,47,98,9]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function S(p){return p.replace(A,(D,R)=>R?D:`\\${D}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function T(p){return p.replace(y,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=T;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function I(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(n,(D,R,E,a)=>E?D:R||a||"")}e.stripIcons=I;function c(p){const D=p.indexOf(e.iconStartMarker);return D===-1?{text:p}:f(p,D)}e.parseLabelWithIcons=c;function f(p,D){const R=[];let E="";function a(l){if(l){E+=l;for(const h of l)R.push(t)}}let o=-1,m="",t=0,u,r,i=D;const s=p.length;for(a(p.substr(0,D));i<s;)u=p[i],r=p[i+1],u===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(o=i,a(m),m=e.iconStartMarker,i++):u===")"&&o!==-1?(t+=i-o+1,o=-1,m=""):o!==-1?/^[a-z0-9\-]$/i.test(u)?m+=u:(a(m),o=-1,m=""):a(u),i++;return a(m),{text:E,iconOffsets:R}}function d(p,D,R=!1){const{text:E,iconOffsets:a}=D;if(!a||a.length===0)return(0,L.matchesFuzzy)(p,E,R);const o=(0,k.ltrim)(E," "),m=E.length-o.length,t=(0,L.matchesFuzzy)(p,o,R);if(t)for(const u of t){const r=a[u.start+m]+m;u.start+=r,u.end+=r}return t}e.matchesFuzzyIconAware=d}),define(fe[99],me([0,1,17,142]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(f="",d=!1){if(this.value=f,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(f,d=0){return this.value+=T(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(p,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,d){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=C;function A(c){return S(c)?!c.value:Array.isArray(c)?c.every(A):!0}e.isEmptyMarkdownString=A;function S(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function y(c,f){return c===f?!0:!c||!f?!1:c.value===f.value&&c.isTrusted===f.isTrusted&&c.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=y;function T(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(c){const f=[],d=c.split("|").map(D=>D.trim());c=d[0];const p=d[1];if(p){const D=/height=(\d+)/.exec(p),R=/width=(\d+)/.exec(p),E=D?D[1]:"",a=R?R[1]:"",o=isFinite(parseInt(a)),m=isFinite(parseInt(E));o&&f.push(`width="${a}"`),m&&f.push(`height="${E}"`)}return{href:c,dimensions:f}}e.parseHrefAndDimensions=I}),define(fe[61],me([0,1,22,9,2]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,y)}e.stringify=C;function A(n){let I=JSON.parse(n);return I=T(I),I}e.parse=A;var S;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(S=e.MarshalledId||(e.MarshalledId={}));function y(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function T(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let c=0;c<n.length;++c)n[c]=T(n[c],I+1);else for(const c in n)Object.hasOwnProperty.call(n,c)&&(n[c]=T(n[c],I+1))}return n}e.revive=T}),define(fe[10],me([0,1,11,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,T,n){this._hosts[y]=T,this._ports[y]=n}setConnectionToken(y,T){this._connectionTokens[y]=T}rewrite(y){if(this._delegate)return this._delegate(y);const T=y.authority;let n=this._hosts[T];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[T],c=this._connectionTokens[T];let f=`path=${encodeURIComponent(y.path)}`;return typeof c=="string"&&(f+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new C;class A{asBrowserUri(y,T){const n=this.toUri(y,T);return n.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===k.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,T){const n=this.toUri(y,T);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,T){return L.URI.isUri(y)?y:L.URI.parse(T.toUrl(y))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(fe[78],me([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function k(T){return y(T,"NFC",L)}e.normalizeNFC=k;const C=new g.LRUCache(1e4);function A(T){return y(T,"NFD",C)}e.normalizeNFD=A;const S=/[^\u0000-\u0080]/;function y(T,n,I){if(!T)return T;const c=I.get(T);if(c)return c;let f;return S.test(T)?f=T.normalize(n):f=T,I.set(T,f),f}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(n){return A(n).replace(T,"")}}()}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,S.uriToFsPath)(f,!0)}e.originalFSPath=y;class T{constructor(d){this._ignorePathCasing=d}compare(d,p,D=!1){return d===p?0:(0,A.compare)(this.getComparisonKey(d,D),this.getComparisonKey(p,D))}isEqual(d,p,D=!1){return d===p?!0:!d||!p?!1:this.getComparisonKey(d,D)===this.getComparisonKey(p,D)}getComparisonKey(d,p=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,p,D=!1){if(d.scheme===p.scheme){if(d.scheme===L.Schemas.file)return g.isEqualOrParent(y(d),y(p),this._ignorePathCasing(d))&&d.query===p.query&&(D||d.fragment===p.fragment);if((0,e.isEqualAuthority)(d.authority,p.authority))return g.isEqualOrParent(d.path,p.path,this._ignorePathCasing(d),"/")&&d.query===p.query&&(D||d.fragment===p.fragment)}return!1}joinPath(d,...p){return S.URI.joinPath(d,...p)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let p;return d.scheme===L.Schemas.file?p=S.URI.file(k.dirname(y(d))).path:(p=k.posix.dirname(d.path),d.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),p="/")),d.with({path:p})}normalizePath(d){if(!d.path.length)return d;let p;return d.scheme===L.Schemas.file?p=S.URI.file(k.normalize(y(d))).path:p=k.posix.normalize(d.path),d.with({path:p})}relativePath(d,p){if(d.scheme!==p.scheme||!(0,e.isEqualAuthority)(d.authority,p.authority))return;if(d.scheme===L.Schemas.file){const E=k.relative(y(d),y(p));return C.isWindows?g.toSlashes(E):E}let D=d.path||"/",R=p.path||"/";if(this._ignorePathCasing(d)){let E=0;for(const a=Math.min(D.length,R.length);E<a&&!(D.charCodeAt(E)!==R.charCodeAt(E)&&D.charAt(E).toLowerCase()!==R.charAt(E).toLowerCase());E++);D=R.substr(0,E)+D.substr(E)}return k.posix.relative(D,R)}resolvePath(d,p){if(d.scheme===L.Schemas.file){const D=S.URI.file(k.resolve(y(d),p));return d.with({authority:D.authority,path:D.path})}return p=g.toPosixPath(p),d.with({path:k.posix.resolve(d.path,p)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,p){return d===p||(0,A.equalsIgnoreCase)(d,p)}hasTrailingPathSeparator(d,p=k.sep){if(d.scheme===L.Schemas.file){const D=y(d);return D.length>g.getRoot(D).length&&D[D.length-1]===p}else{const D=d.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,p=k.sep){return(0,e.hasTrailingPathSeparator)(d,p)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,p=k.sep){let D=!1;if(d.scheme===L.Schemas.file){const R=y(d);D=R!==void 0&&R.length===g.getRoot(R).length&&R[R.length-1]===p}else{p="/";const R=d.path;D=R.length===1&&R.charCodeAt(R.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(d,p)?d.with({path:d.path+"/"}):d}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,d){const p=[];for(let D=0;D<f.length;D++){const R=d(f[D]);f.some((E,a)=>a===D?!1:(0,e.isEqualOrParent)(R,d(E)))||p.push(f[D])}return p}e.distinctParents=n;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(p){const D=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[o,m]=a.split(":");o&&m&&D.set(o,m)});const E=p.path.substring(0,p.path.indexOf(";"));return E&&D.set(f.META_DATA_MIME,E),D}f.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function c(f,d,p){if(d){let D=f.path;return D&&D[0]!==k.posix.sep&&(D=k.posix.sep+D),f.with({scheme:p,authority:d,path:D})}return f.with({scheme:p})}e.toLocalResource=c}),define(fe[18],me([0,1,21,17,3,6,23]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(O){return!!O&&typeof O.then=="function"}e.isThenable=S;function y(O){const N=new g.CancellationTokenSource,x=O(N.token),B=new Promise((H,$)=>{const Y=N.token.onCancellationRequested(()=>{Y.dispose(),N.dispose(),$((0,L.canceled)())});Promise.resolve(x).then(Q=>{Y.dispose(),N.dispose(),H(Q)},Q=>{Y.dispose(),N.dispose(),$(Q)})});return new class{cancel(){N.cancel()}then(H,$){return B.then(H,$)}catch(H){return this.then(void 0,H)}finally(H){return B.finally(H)}}}e.createCancelablePromise=y;function T(O,N,x){return Promise.race([O,new Promise(B=>N.onCancellationRequested(()=>B(x)))])}e.raceCancellation=T;async function n(O){let N=-1;const x=O.map((H,$)=>H.then(Y=>(N=$,Y))),B=await Promise.race(x);return O.forEach((H,$)=>{$!==N&&H.cancel()}),B}e.raceCancellablePromises=n;function I(O,N,x){let B;const H=setTimeout(()=>{B?.(void 0),x?.()},N);return Promise.race([O.finally(()=>clearTimeout(H)),new Promise($=>B=$)])}e.raceTimeout=I;function c(O){return new Promise((N,x)=>{const B=O();S(B)?B.then(N,x):N(B)})}e.asPromise=c;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(x,x).then(B)})}return new Promise((x,B)=>{this.queuedPromise.then(x,B)})}return this.activePromise=N(),new Promise((x,B)=>{this.activePromise.then(H=>{this.activePromise=null,x(H)},H=>{this.activePromise=null,B(H)})})}}e.Throttler=f;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class p{constructor(){this.promiseMap=new Map}queue(N,x){const H=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(N)===H&&this.promiseMap.delete(N)});return this.promiseMap.set(N,H),H}}e.SequencerByKey=p;class D{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,x=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,H)=>{this.doResolve=B,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class R{constructor(N){this.delayer=new D(N),this.throttler=new f}trigger(N,x){return this.delayer.trigger(()=>this.throttler.queue(N),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=R;class E{constructor(){this._isOpen=!1,this._promise=new Promise((N,x)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class a extends E{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function o(O,N){return N?new Promise((x,B)=>{const H=setTimeout(()=>{$.dispose(),x()},O),$=N.onCancellationRequested(()=>{clearTimeout(H),$.dispose(),B((0,L.canceled)())})}):y(x=>o(O,x))}e.timeout=o;function m(O,N=0){const x=setTimeout(O,N);return(0,C.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=m;function t(O){const N=[];let x=0;const B=O.length;function H(){return x<B?O[x++]():null}function $(Y){Y!=null&&N.push(Y);const Q=H();return Q?Q.then($):Promise.resolve(N)}return Promise.resolve(null).then($)}e.sequence=t;function u(O,N=B=>!!B,x=null){let B=0;const H=O.length,$=()=>{if(B>=H)return Promise.resolve(x);const Y=O[B++];return Promise.resolve(Y()).then(de=>N(de)?Promise.resolve(de):$())};return $()}e.first=u;function r(O,N=B=>!!B,x=null){if(O.length===0)return Promise.resolve(x);let B=O.length;const H=()=>{B=-1;for(const $ of O)$.cancel?.()};return new Promise(($,Y)=>{for(const Q of O)Q.then(de=>{--B>=0&&N(de)?(H(),$(de)):B===0&&$(x)}).catch(de=>{--B>=0&&(H(),Y(de))})})}e.firstParallel=r;class i{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((x,B)=>{this.outstandingPromises.push({factory:N,c:x,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const x=N.factory();x.then(N.c,N.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class s extends i{constructor(){super(1)}}e.Queue=s;class l{constructor(){this.queues=new Map}queueFor(N,x=A.extUri){const B=x.getComparisonKey(N);let H=this.queues.get(B);return H||(H=new s,k.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(B)}),this.queues.set(B,H)),H}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(N,x){this._token=-1,typeof N=="function"&&typeof x=="number"&&this.setIfNotSet(N,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},x)}setIfNotSet(N,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},x))}}e.TimeoutTimer=h;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,x){this.cancel(),this._token=setInterval(()=>{N()},x)}}e.IntervalTimer=w;class _{constructor(N,x){this.timeoutToken=-1,this.runner=N,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=_;class v{constructor(N,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=v;class P extends _{constructor(N,x){super(N,x);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=P;class b extends C.Disposable{constructor(N,x,B,H){super();this.maxWorkChunkSize=N,this.maxPendingWork=x,this.throttleDelay=B,this.handler=H,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new _(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=b,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const x=setTimeout(()=>N(O));let B=!1;return{dispose(){B||(B=!0,clearTimeout(x))}}}}else e.runWhenIdle=(O,N)=>{const x=requestIdleCallback(O,typeof N=="number"?{timeout:N}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(x))}}}}();class F{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function M(O,N,x){let B;for(let H=0;H<x;H++)try{return await O()}catch($){B=$,await o(N)}throw B}e.retry=M;class q{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,x,B){return this._pending={taskId:N,cancel:()=>B?.(),promise:x},x.then(()=>this.donePending(N),()=>this.donePending(N)),x}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let x,B;const H=new Promise(($,Y)=>{x=$,B=Y});this._next={run:N,promise:H,promiseResolve:x,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=q;class G{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,x)=>{this.completeCallback=N,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(x=>{this.completeCallback(N),this.resolved=!0,x()})}error(N){return new Promise(x=>{this.errorCallback(N),this.rejected=!0,x()})}cancel(){new Promise(N=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=U;var z;(function(O){async function N(x){let B;const H=await Promise.all(x.map($=>$.then(Y=>Y,Y=>{B||(B=Y)})));if(typeof B!="undefined")throw B;return H}O.settled=N})(z=e.Promises||(e.Promises={}))}),define(fe[100],me([0,1,18,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new g.IdleValue(()=>{const _=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:_,collatorIsNumeric:_.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(_,v,P=!1){const b=_||"",F=v||"",M=k.value.collator.compare(b,F);return k.value.collatorIsNumeric&&M===0&&b!==F?b<F?-1:1:M}e.compareFileNames=S;function y(_,v){const P=C.value.collator;return _=_||"",v=v||"",m(P,_,v)}e.compareFileNamesDefault=y;function T(_,v){const P=C.value.collator;return _=_||"",v=v||"",i(_,v)||m(P,_,v)}e.compareFileNamesUpper=T;function n(_,v){const P=C.value.collator;return _=_||"",v=v||"",r(_,v)||m(P,_,v)}e.compareFileNamesLower=n;function I(_,v){return _=_||"",v=v||"",_===v?0:_<v?-1:1}e.compareFileNamesUnicode=I;function c(_,v,P=!1){P||(_=_&&_.toLowerCase(),v=v&&v.toLowerCase());const[b,F]=a(_),[M,q]=a(v);return b!==M?b<M?-1:1:F===q?0:F<q?-1:1}e.noIntlCompareFileNames=c;function f(_,v){const[P,b]=a(_),[F,M]=a(v);let q=k.value.collator.compare(b,M);if(q===0){if(k.value.collatorIsNumeric&&b!==M)return b<M?-1:1;if(q=k.value.collator.compare(P,F),k.value.collatorIsNumeric&&q===0&&P!==F)return P<F?-1:1}return q}e.compareFileExtensions=f;function d(_,v){_=_||"",v=v||"";const P=o(_),b=o(v),F=C.value.collator,M=A.value.collator;return m(M,P,b)||m(F,_,v)}e.compareFileExtensionsDefault=d;function p(_,v){_=_||"",v=v||"";const P=o(_),b=o(v),F=C.value.collator,M=A.value.collator;return m(M,P,b)||i(_,v)||m(F,_,v)}e.compareFileExtensionsUpper=p;function D(_,v){_=_||"",v=v||"";const P=o(_),b=o(v),F=C.value.collator,M=A.value.collator;return m(M,P,b)||r(_,v)||m(F,_,v)}e.compareFileExtensionsLower=D;function R(_,v){_=_||"",v=v||"";const P=o(_).toLowerCase(),b=o(v).toLowerCase();return P!==b?P<b?-1:1:_!==v?_<v?-1:1:0}e.compareFileExtensionsUnicode=R;const E=/^(.*?)(\.([^.]*))?$/;function a(_,v=!1){const P=_?E.exec(_):[];let b=[P&&P[1]||"",P&&P[3]||""];return v&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function o(_){const v=_?E.exec(_):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function m(_,v,P){let b=_.compare(v,P);return b!==0?b:v.length!==P.length?v.length<P.length?-1:1:0}function t(_){const v=_.charAt(0);return v.toLocaleUpperCase()!==v}function u(_){const v=_.charAt(0);return v.toLocaleLowerCase()!==v}function r(_,v){return t(_)&&u(v)?-1:u(_)&&t(v)?1:0}function i(_,v){return u(_)&&t(v)?-1:t(_)&&u(v)?1:0}function s(_,v,P=!1){return P||(_=_&&_.toLowerCase(),v=v&&v.toLowerCase()),_===v?0:_<v?-1:1}function l(_,v,P=!1){const b=_.split(L.sep),F=v.split(L.sep),M=b.length-1,q=F.length-1;let G,U;for(let z=0;;z++){if(G=M===z,U=q===z,G&&U)return S(b[z],F[z],P);if(G)return-1;if(U)return 1;const O=s(b[z],F[z],P);if(O!==0)return O}}e.comparePaths=l;function h(_,v,P){const b=_.toLowerCase(),F=v.toLowerCase(),M=w(_,v,P);if(M)return M;const q=b.endsWith(P),G=F.endsWith(P);if(q!==G)return q?-1:1;const U=S(b,F);return U!==0?U:b.localeCompare(F)}e.compareAnything=h;function w(_,v,P){const b=_.toLowerCase(),F=v.toLowerCase(),M=b.startsWith(P),q=F.startsWith(P);if(M!==q)return M?-1:1;if(M&&q){if(b.length<F.length)return-1;if(b.length>F.length)return 1}return 0}e.compareByPrefix=w}),define(fe[101],me([0,1,100,98,48,8,11,9]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,T=[y,[]];function n(O,N,x,B){if(!O||!N)return T;const H=O.length,$=N.length;if(H<$)return T;const Y=O.toLowerCase();return I(N,x,$,O,Y,H,B)}e.scoreFuzzy=n;function I(O,N,x,B,H,$,Y){const Q=[],de=[];for(let $e=0;$e<x;$e++){const Be=$e*$,He=Be-$,j=$e>0,ee=O[$e],se=N[$e];for(let le=0;le<$;le++){const Z=le>0,ae=Be+le,ve=ae-1,Me=He+le-1,qe=Z?Q[ve]:0,Ye=j&&Z?Q[Me]:0,Ze=j&&Z?de[Me]:0;let ke;!Ye&&j?ke=0:ke=c(ee,se,B,H,le,Ze),ke&&Ye+ke>=qe&&(Y||j||H.startsWith(N,le))?(de[ae]=Ze+1,Q[ae]=Ye+ke):(de[ae]=y,Q[ae]=qe)}}const _e=[];let Ce=x-1,Te=$-1;for(;Ce>=0&&Te>=0;){const $e=Ce*$+Te;de[$e]===y||(_e.push(Te),Ce--),Te--}return[Q[x*$-1],_e.reverse()]}function c(O,N,x,B,H,$){let Y=0;if(!f(N,B[H]))return Y;if(Y+=1,$>0&&(Y+=$*5),O===x[H]&&(Y+=1),H===0)Y+=8;else{const Q=d(x.charCodeAt(H-1));Q?Y+=Q:(0,L.isUpper)(x.charCodeAt(H))&&(Y+=2)}return Y}function f(O,N){return O===N?!0:O==="/"||O==="\\"?N==="/"||N==="\\":!1}function d(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function D(O,N,x=0,B=0){const H=N;return H.values&&H.values.length>1?R(O,H.values,x,B):E(O,N,x,B)}e.scoreFuzzy2=D;function R(O,N,x,B){let H=0;const $=[];for(const Y of N){const[Q,de]=E(O,Y,x,B);if(typeof Q!="number")return p;H+=Q,$.push(...de)}return[H,w($)]}function E(O,N,x,B){const H=(0,L.fuzzyScore)(N.original,N.originalLowercase,x,O,O.toLowerCase(),B,!0);return H?[H[0],(0,L.createMatches)(H)]:p}const a=Object.freeze({score:0}),o=1<<18,m=1<<17,t=1<<16;function u(O,N,x,B){const H=B.values?B.values:[B];return(0,k.hash)({[B.normalized]:{values:H.map(Y=>({value:Y.normalized,expectContiguousMatch:Y.expectContiguousMatch})),label:O,description:N,allowNonContiguousMatches:x}})}function r(O,N,x,B,H){if(!O||!N.normalized)return a;const $=B.getItemLabel(O);if(!$)return a;const Y=B.getItemDescription(O),Q=u($,Y,x,N),de=H[Q];if(de)return de;const _e=i($,Y,B.getItemPath(O),N,x);return H[Q]=_e,_e}e.scoreItemFuzzy=r;function i(O,N,x,B,H){const $=!x||!B.containsPathSeparator;return x&&(A.isLinux?B.pathNormalized===x:(0,S.equalsIgnoreCase)(B.pathNormalized,x))?{score:o,labelMatch:[{start:0,end:O.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:B.values&&B.values.length>1?s(O,N,x,B.values,$,H):l(O,N,x,B,$,H)}function s(O,N,x,B,H,$){let Y=0;const Q=[],de=[];for(const _e of B){const{score:Ce,labelMatch:Te,descriptionMatch:$e}=l(O,N,x,_e,H,$);if(Ce===y)return a;Y+=Ce,Te&&Q.push(...Te),$e&&de.push(...$e)}return{score:Y,labelMatch:w(Q),descriptionMatch:w(de)}}function l(O,N,x,B,H,$){if(H||!N){const[Y,Q]=n(O,B.normalized,B.normalizedLowercase,$&&!B.expectContiguousMatch);if(Y){const de=(0,L.matchesPrefix)(B.normalized,O);let _e;return de?(_e=m,_e+=Math.round(B.normalized.length/O.length*100)):_e=t,{score:_e+Y,labelMatch:de||h(Q)}}}if(N){let Y=N;x&&(Y=`${N}${C.sep}`);const Q=Y.length,de=`${Y}${O}`,[_e,Ce]=n(de,B.normalized,B.normalizedLowercase,$&&!B.expectContiguousMatch);if(_e){const Te=h(Ce),$e=[],Be=[];return Te.forEach(He=>{He.start<Q&&He.end>Q?($e.push({start:0,end:He.end-Q}),Be.push({start:He.start,end:Q})):He.start>=Q?$e.push({start:He.start-Q,end:He.end-Q}):Be.push(He)}),{score:_e,labelMatch:$e,descriptionMatch:Be}}}return a}function h(O){const N=[];if(!O)return N;let x;for(const B of O)x&&x.end===B?x.end+=1:(x={start:B,end:B+1},N.push(x));return N}function w(O){const N=O.sort((H,$)=>H.start-$.start),x=[];let B;for(const H of N)!B||!_(B,H)?(B=H,x.push(H)):(B.start=Math.min(B.start,H.start),B.end=Math.max(B.end,H.end));return x}function _(O,N){return!(O.end<N.start||N.end<O.start)}function v(O,N,x,B,H,$){const Y=r(O,x,B,H,$),Q=r(N,x,B,H,$),de=Y.score,_e=Q.score;if((de===o||_e===o)&&de!==_e)return de===o?-1:1;if(de>t||_e>t){if(de!==_e)return de>_e?-1:1;if(de<m&&_e<m){const ee=b(Y.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=H.getItemLabel(O)||"",j=H.getItemLabel(N)||"";if(He.length!==j.length)return He.length-j.length}if(de!==_e)return de>_e?-1:1;const Ce=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0,Te=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(Ce&&!Te)return-1;if(Te&&!Ce)return 1;const $e=P(O,Y,H),Be=P(N,Q,H);return $e&&Be&&$e!==Be?Be>$e?-1:1:F(O,N,x,H)}e.compareItemsByFuzzyScore=v;function P(O,N,x){let B=-1,H=-1;if(N.descriptionMatch&&N.descriptionMatch.length?B=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(B=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(H=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const $=x.getItemDescription(O);$&&(H+=$.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(H=N.descriptionMatch[N.descriptionMatch.length-1].end);return H-B}function b(O,N){if(!O&&!N||(!O||!O.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!O||!O.length)return 1;const x=O[0].start,H=O[O.length-1].end-x,$=N[0].start,Q=N[N.length-1].end-$;return H===Q?0:Q<H?1:-1}function F(O,N,x,B){const H=B.getItemLabel(O)||"",$=B.getItemLabel(N)||"",Y=B.getItemDescription(O),Q=B.getItemDescription(N),de=H.length+(Y?Y.length:0),_e=$.length+(Q?Q.length:0);if(de!==_e)return de-_e;const Ce=B.getItemPath(O),Te=B.getItemPath(N);return Ce&&Te&&Ce.length!==Te.length?Ce.length-Te.length:H!==$?(0,g.compareAnything)(H,$,x.normalized):Y&&Q&&Y!==Q?(0,g.compareAnything)(Y,Q,x.normalized):Ce&&Te&&Ce!==Te?(0,g.compareAnything)(Ce,Te,x.normalized):0}function M(O){return O.startsWith('"')&&O.endsWith('"')}const q=" ";function G(O){typeof O!="string"&&(O="");const N=O.toLowerCase(),{pathNormalized:x,normalized:B,normalizedLowercase:H}=U(O),$=x.indexOf(C.sep)>=0,Y=M(O);let Q;const de=O.split(q);if(de.length>1)for(const _e of de){const Ce=M(_e),{pathNormalized:Te,normalized:$e,normalizedLowercase:Be}=U(_e);$e&&(Q||(Q=[]),Q.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Te,normalized:$e,normalizedLowercase:Be,expectContiguousMatch:Ce}))}return{original:O,originalLowercase:N,pathNormalized:x,normalized:B,normalizedLowercase:H,values:Q,containsPathSeparator:$,expectContiguousMatch:Y}}e.prepareQuery=G;function U(O){let N;A.isWindows?N=O.replace(/\//g,C.sep):N=O.replace(/\\/g,C.sep);const x=(0,S.stripWildcards)(N).replace(/\s|"/g,"");return{pathNormalized:N,normalized:x,normalizedLowercase:x.toLowerCase()}}function z(O){return Array.isArray(O)?G(O.map(N=>N.original).join(q)):G(O.original)}e.pieceToQuery=z}),define(fe[30],me([0,1,18,29,24,8,9]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const y="**",T="/",n="[/\\\\]",I="[^/\\\\]",c=/\//g;function f(B){switch(B){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function d(B,H){if(!B)return[];const $=[];let Y=!1,Q=!1,de="";for(const _e of B){switch(_e){case H:if(!Y&&!Q){$.push(de),de="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=_e}return de&&$.push(de),$}e.splitGlobAware=d;function p(B){if(!B)return"";let H="";const $=d(B,T);if($.every(Y=>Y===y))H=".*";else{let Y=!1;$.forEach((Q,de)=>{if(Q===y){Y||(H+=f(2),Y=!0);return}let _e=!1,Ce="",Te=!1,$e="";for(const Be of Q){if(Be!=="}"&&_e){Ce+=Be;continue}if(Te&&(Be!=="]"||!$e)){let He;Be==="-"?He=Be:(Be==="^"||Be==="!")&&!$e?He="^":Be===T?He="":He=A.escapeRegExpCharacters(Be),$e+=He;continue}switch(Be){case"{":_e=!0;continue;case"[":Te=!0;continue;case"}":H+=`(?:${d(Ce,",").map(ee=>p(ee)).join("|")})`,_e=!1,Ce="";break;case"]":H+="["+$e+"]",Te=!1,$e="";break;case"?":H+=I;continue;case"*":H+=f(1);continue;default:H+=A.escapeRegExpCharacters(Be)}}de<$.length-1&&($[de+1]!==y||de+2<$.length)&&(H+=n),Y=!1})}return H}const D=/^\*\*\/\*\.[\w\.-]+$/,R=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),u=function(){return!1},r=function(){return null};function i(B,H){if(!B)return r;let $;typeof B!="string"?$=B.pattern:$=B,$=$.trim();const Y=`${$}_${!!H.trimForExclusions}`;let Q=t.get(Y);if(Q)return s(Q,B);let de;if(D.test($)){const _e=$.substr(4);Q=function(Ce,Te){return typeof Ce=="string"&&Ce.endsWith(_e)?$:null}}else(de=R.exec(l($,H)))?Q=h(de[1],$):(H.trimForExclusions?a:E).test($)?Q=w($,H):(de=o.exec(l($,H)))?Q=_(de[1].substr(1),$,!0):(de=m.exec(l($,H)))?Q=_(de[1],$,!1):Q=v($);return t.set(Y,Q),s(Q,B)}function s(B,H){return typeof H=="string"?B:function($,Y){return L.isEqualOrParent($,H.base)?B(C.relative(H.base,$),Y):null}}function l(B,H){return H.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function h(B,H){const $=`/${B}`,Y=`\\${B}`,Q=function(_e,Ce){return typeof _e!="string"?null:Ce?Ce===B?H:null:_e===B||_e.endsWith($)||_e.endsWith(Y)?H:null},de=[B];return Q.basenames=de,Q.patterns=[H],Q.allBasenames=de,Q}function w(B,H){const $=x(B.slice(1,-1).split(",").map(Ce=>i(Ce,H)).filter(Ce=>Ce!==r),B),Y=$.length;if(!Y)return r;if(Y===1)return $[0];const Q=function(Ce,Te){for(let $e=0,Be=$.length;$e<Be;$e++)if($[$e](Ce,Te))return B;return null},de=$.find(Ce=>!!Ce.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=$.reduce((Ce,Te)=>Te.allPaths?Ce.concat(Te.allPaths):Ce,[]);return _e.length&&(Q.allPaths=_e),Q}function _(B,H,$){const Y=C.sep===C.posix.sep,Q=Y?B:B.replace(c,C.sep),de=C.sep+Q,_e=C.posix.sep+B,Ce=$?function(Te,$e){return typeof Te=="string"&&(Te===Q||Te.endsWith(de)||!Y&&(Te===B||Te.endsWith(_e)))?H:null}:function(Te,$e){return typeof Te=="string"&&(Te===Q||!Y&&Te===B)?H:null};return Ce.allPaths=[($?"*/":"./")+B],Ce}function v(B){try{const H=new RegExp(`^${p(B)}$`);return function($){return H.lastIndex=0,typeof $=="string"&&H.test($)?B:null}}catch(H){return r}}function P(B,H,$){return!B||typeof H!="string"?!1:b(B)(H,void 0,$)}e.match=P;function b(B,H={}){if(!B)return u;if(typeof B=="string"||G(B)){const $=i(B,H);if($===r)return u;const Y=function(Q,de){return!!$(Q,de)};return $.allBasenames&&(Y.allBasenames=$.allBasenames),$.allPaths&&(Y.allPaths=$.allPaths),Y}return O(B,H)}e.parse=b;function F(B){if(!B)return;let H;return $=>(H||(H=(B()||Promise.resolve([])).then(Y=>Y?q(Y):{})),H.then(Y=>!!Y[$]))}e.hasSiblingPromiseFn=F;function M(B){if(!B)return;let H;return $=>{if(!H){const Y=B();H=Y?q(Y):{}}return!!H[$]}}e.hasSiblingFn=M;function q(B){const H={};for(const $ of B)H[$]=!0;return H}function G(B){const H=B;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=G;function U(B){return B.allBasenames||[]}e.getBasenameTerms=U;function z(B){return B.allPaths||[]}e.getPathTerms=z;function O(B,H){const $=x(Object.getOwnPropertyNames(B).map(Ce=>N(Ce,B[Ce],H)).filter(Ce=>Ce!==r)),Y=$.length;if(!Y)return r;if(!$.some(Ce=>!!Ce.requiresSiblings)){if(Y===1)return $[0];const Ce=function(Be,He){for(let j=0,ee=$.length;j<ee;j++){const se=$[j](Be,He);if(se)return se}return null},Te=$.find(Be=>!!Be.allBasenames);Te&&(Ce.allBasenames=Te.allBasenames);const $e=$.reduce((Be,He)=>He.allPaths?Be.concat(He.allPaths):Be,[]);return $e.length&&(Ce.allPaths=$e),Ce}const Q=function(Ce,Te,$e){let Be;for(let He=0,j=$.length;He<j;He++){const ee=$[He];ee.requiresSiblings&&$e&&(Te||(Te=C.basename(Ce)),Be||(Be=Te.substr(0,Te.length-C.extname(Ce).length)));const se=ee(Ce,Te,Be,$e);if(se)return se}return null},de=$.find(Ce=>!!Ce.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=$.reduce((Ce,Te)=>Te.allPaths?Ce.concat(Te.allPaths):Ce,[]);return _e.length&&(Q.allPaths=_e),Q}function N(B,H,$){if(H===!1)return r;const Y=i(B,$);if(Y===r)return r;if(typeof H=="boolean")return Y;if(H){const Q=H.when;if(typeof Q=="string"){const de=(_e,Ce,Te,$e)=>{if(!$e||!Y(_e,Ce))return null;const Be=Q.replace("$(basename)",Te),He=$e(Be);return(0,g.isThenable)(He)?He.then(j=>j?B:null):He?B:null};return de.requiresSiblings=!0,de}}return Y}function x(B,H){const $=B.filter(Ce=>!!Ce.basenames);if($.length<2)return B;const Y=$.reduce((Ce,Te)=>{const $e=Te.basenames;return $e?Ce.concat($e):Ce},[]);let Q;if(H){Q=[];for(let Ce=0,Te=Y.length;Ce<Te;Ce++)Q.push(H)}else Q=$.reduce((Ce,Te)=>{const $e=Te.patterns;return $e?Ce.concat($e):Ce},[]);const de=function(Ce,Te){if(typeof Ce!="string")return null;if(!Te){let Be;for(Be=Ce.length;Be>0;Be--){const He=Ce.charCodeAt(Be-1);if(He===47||He===92)break}Te=Ce.substr(Be)}const $e=Y.indexOf(Te);return $e!==-1?Q[$e]:null};de.basenames=Y,de.patterns=Q,de.allBasenames=Y;const _e=B.filter(Ce=>!Ce.basenames);return _e.push(de),_e}}),define(fe[79],me([0,1,29,10,8,11,23,9,2]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,s,l){if(typeof i=="string"&&(i=y.URI.file(i)),l){const w=l.getWorkspaceFolder(i);if(w){const _=l.getWorkspace().folders.length>1;let v;if((0,A.isEqual)(w.uri,i)?v="":v=(0,A.relativePath)(w.uri,i),_){const P=w.name?w.name:(0,A.basename)(w.uri);v=v?P+" \u2022 "+v:P}return v}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(i.fsPath))return(0,k.normalize)(I(i.fsPath));let h=(0,k.normalize)(i.fsPath);return!C.isWindows&&s?.userHome&&(h=f(h,s.userHome.fsPath)),h}e.getPathLabel=T;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const s=(0,A.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(s)?I(s):s}e.getBaseLabel=n;function I(i){return(0,g.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let c=Object.create(null);function f(i,s){if(C.isWindows||!i||!s)return i;let l=c.original===s?c.normalized:void 0;return l||(l=`${(0,S.rtrim)(s,k.posix.sep)}${k.posix.sep}`,c={original:s,normalized:l}),(C.isLinux?i.startsWith(l):(0,S.startsWithIgnoreCase)(i,l))&&(i=`~/${i.substr(l.length)}`),i}e.tildify=f;function d(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=d;const p="\u2026",D="\\\\",R="~";function E(i,s=k.sep){const l=new Array(i.length);let h=!1;for(let w=0;w<i.length;w++){let _=i[w];if(_===""){l[w]=`.${s}`;continue}if(!_){l[w]=_;continue}h=!0;let v="";_.indexOf(D)===0?(v=_.substr(0,_.indexOf(D)+D.length),_=_.substr(_.indexOf(D)+D.length)):_.indexOf(s)===0?(v=_.substr(0,_.indexOf(s)+s.length),_=_.substr(_.indexOf(s)+s.length)):_.indexOf(R)===0&&(v=_.substr(0,_.indexOf(R)+R.length),_=_.substr(_.indexOf(R)+R.length));const P=_.split(s);for(let b=1;h&&b<=P.length;b++)for(let F=P.length-b;h&&F>=0;F--){h=!1;let M=P.slice(F,F+b).join(s);for(let q=0;!h&&q<i.length;q++)if(q!==w&&i[q]&&i[q].indexOf(M)>-1){const G=F+b===P.length,U=F>0&&i[q].indexOf(s)>-1?s+M:M,z=i[q].endsWith(U);h=!G||z}if(!h){let q="";(P[0].endsWith(":")||v!=="")&&(F===1&&(F=0,b++,M=P[0]+s+M),F>0&&(q=P[0]+s),q=v+q),F>0&&(q=q+p+s),q=q+M,F+b<P.length&&(q=q+s+p),l[w]=q}}h&&(l[w]=_)}return l}e.shorten=E;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function o(i,s=Object.create(null)){const l=[];let h=!1,w="";for(const _ of i)if(_==="$"||h&&_==="{")w&&l.push({value:w,type:a.TEXT}),w="",h=!0;else if(_==="}"&&h){const v=s[w];if(typeof v=="string")v.length&&l.push({value:v,type:a.VARIABLE});else if(v){const P=l[l.length-1];(!P||P.type!==a.SEPARATOR)&&l.push({value:v.label,type:a.SEPARATOR})}w="",h=!1}else w+=_;return w&&!h&&l.push({value:w,type:a.TEXT}),l.filter((_,v)=>{if(_.type===a.SEPARATOR){const P=l[v-1],b=l[v+1];return[P,b].every(F=>F&&(F.type===a.VARIABLE||F.type===a.TEXT)&&F.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=o;function m(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const s=i.indexOf("/")!==-1?k.posix:k.win32,l=s.basename(i),h=s.dirname(i);return l.length?{name:l,parentPath:h}:{name:h,parentPath:""}}e.splitName=r}),define(fe[102],me([0,1,30,10,8,23,9]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var S;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(S=e.Mimes||(e.Mimes={}));let y=[],T=[],n=[];function I(i,s=!1){const l=c(i);y.push(l),l.userConfigured?n.push(l):T.push(l),s&&!l.userConfigured&&y.forEach(h=>{h.mime===l.mime||h.userConfigured||(l.extension&&h.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&h.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&h.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&h.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function c(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,g.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(k.posix.sep)>=0:!1}}function f(i){i?(y=y.filter(s=>!s.userConfigured),n=[]):(y=[],T=[],n=[])}e.clearTextMimes=f;function d(i,s){let l;if(i)switch(i.scheme){case L.Schemas.file:l=i.fsPath;break;case L.Schemas.data:l=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:l=i.path}if(!l)return[S.unknown];l=l.toLowerCase();const h=(0,k.basename)(l),w=p(l,h,n);if(w)return[w,S.text];const _=p(l,h,T);if(_)return[_,S.text];if(s){const v=D(s);if(v)return[v,S.text]}return[S.unknown]}e.guessMimeTypes=d;function p(i,s,l){let h=null,w=null,_=null;for(let v=l.length-1;v>=0;v--){const P=l[v];if(s===P.filenameLowercase){h=P;break}if(P.filepattern&&(!w||P.filepattern.length>w.filepattern.length)){const b=P.filepatternOnPath?i:s;P.filepatternLowercase?.(b)&&(w=P)}P.extension&&(!_||P.extension.length>_.extension.length)&&s.endsWith(P.extensionLowercase)&&(_=P)}return h?h.mime:w?w.mime:_?_.mime:null}function D(i){if((0,A.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let s=y.length-1;s>=0;s--){const l=y[s];if(!l.firstline)continue;const h=i.match(l.firstline);if(h&&h.length>0)return l.mime}return null}function R(i){return i?typeof i=="string"?i===S.binary||i===S.text||i===S.unknown:i.length===1&&R(i[0]):!0}e.isUnspecific=R;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(i){const s=(0,k.extname)(i),l=E[s.toLowerCase()];return l!==void 0?l:m(i)}e.getMediaOrTextMime=o;function m(i){const s=(0,k.extname)(i);return a[s.toLowerCase()]}e.getMediaMime=m;function t(i){for(const s in a)if(a[s]===i)return s}e.getExtensionForMimeType=t;const u=/^(.+)\/(.+?)(;.+)?$/;function r(i,s){const l=u.exec(i);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:s?void 0:i}e.normalizeMimeType=r}),define(fe[103],me([0,1,2]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:L(g.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:L(g.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:g.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,I,c){if(!n||c>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const d=C(n[f],I,c+1);d!==null&&(n[f]=d)}}return null}function A(n,I){const c=C(n,I,0);return c===null?n:c}e.transformOutgoingURIs=A;function S(n,I,c,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return c?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const p=S(n[d],I,c,f+1);p!==null&&(n[d]=p)}}return null}function y(n,I){const c=S(n,I,!1,0);return c===null?n:c}e.transformIncomingURIs=y;function T(n,I){const c=S(n,I,!0,0);return c===null?n:c}e.transformAndReviveIncomingURIs=T}),define(fe[32],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return g.test(y)}e.isUUID=L;const k=new Uint8Array(16),C=[];for(let y=0;y<256;y++)C.push(y.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(y){for(let T=0;T<y.length;T++)y[T]=Math.floor(Math.random()*256);return y};function S(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,T="";return T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T}e.generateUuid=S}),define(fe[143],me([0,1,104]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const A=[],S=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(S.length<1)return A;let y=0,T,n=y;for(;n<S.length;)if(T=S.charCodeAt(n),T===13||T===10){if(A.push(S.substring(y,n)),n++,n<S.length){const I=T;T=S.charCodeAt(n),(I===13&&T===10||I===10&&T===13)&&n++}y=n}else n++;return this.remaining=y<S.length?S.substr(y):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(fe[28],me([0,1,50,80,291,18,29,78,8,11,23,2,32]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function d(U,z=f.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===f.UNLINK?D(U):p(U)}async function p(U){try{const z=(0,y.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(U,z)}catch(O){return D(U)}D(z).catch(O=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function D(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function R(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(U,{recursive:!0})}e.rimrafSync=R;async function E(U,z){return m(await(z?a(U):(0,k.promisify)(g.readdir)(U)))}async function a(U){try{return await(0,k.promisify)(g.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const z=[],O=await E(U);for(const N of O){let x=!1,B=!1,H=!1;try{const $=await e.Promises.lstat((0,y.join)(U,N));x=$.isFile(),B=$.isDirectory(),H=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}z.push({name:N,isFile:()=>x,isDirectory:()=>B,isSymbolicLink:()=>H})}return z}function o(U){return m(g.readdirSync(U))}e.readdirSync=o;function m(U){return U.map(z=>typeof z=="string"?T.isMacintosh?(0,S.normalizeNFC)(z):z:(z.name=T.isMacintosh?(0,S.normalizeNFC)(z.name):z.name,z))}async function t(U){const z=await E(U),O=[];for(const N of z)await r.existsDirectory((0,y.join)(U,N))&&O.push(N);return O}function u(U,z=1e3){return new Promise(O=>{let N=!1;const x=setInterval(()=>{N||(N=!0,g.access(U,B=>{N=!1,B&&(clearInterval(x),O(void 0))}))},z)})}e.whenDeleted=u;var r;(function(U){async function z(x){let B;try{if(B=await e.Promises.lstat(x),!B.isSymbolicLink())return{stat:B}}catch(H){}try{return{stat:await e.Promises.stat(x),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(T.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw $}throw H}}U.stat=z;async function O(x){try{const{stat:B,symbolicLink:H}=await U.stat(x);return B.isFile()&&H?.dangling!==!0}catch(B){}return!1}U.existsFile=O;async function N(x){try{const{stat:B,symbolicLink:H}=await U.stat(x);return B.isDirectory()&&H?.dangling!==!0}catch(B){}return!1}U.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function s(U,z,O){return i.queueFor(I.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const N=_(O);return new Promise((x,B)=>h(U,z,N,H=>H?B(H):x()))})}let l=!0;function h(U,z,O,N){if(!l)return g.writeFile(U,z,{mode:O.mode,flag:O.flag},N);g.open(U,O.flag,O.mode,(x,B)=>{if(x)return N(x);g.writeFile(B,z,H=>{if(H)return g.close(B,()=>N(H));g.fdatasync(B,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),l=!1),g.close(B,Y=>N(Y))))})})}function w(U,z,O){const N=_(O);if(!l)return g.writeFileSync(U,z,{mode:N.mode,flag:N.flag});const x=g.openSync(U,N.flag,N.mode);try{g.writeFileSync(x,z);try{g.fdatasyncSync(x)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),l=!1}}finally{g.closeSync(x)}}e.writeFileSync=w;function _(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function v(U,z){if(U===z)return;async function O(N){try{const x=await e.Promises.lstat(N);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(N,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(U,z),await O(z)}catch(N){if(U.toLowerCase()!==z.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await P(U,z,{preserveSymlinks:!1}),await d(U,f.MOVE),await O(z);else throw N}}async function P(U,z,O){return F(U,z,{root:{source:U,target:z},options:O,handledSourcePaths:new Set})}const b=511;async function F(U,z,O){if(O.handledSourcePaths.has(U))return;O.handledSourcePaths.add(U);const{stat:N,symbolicLink:x}=await r.stat(U);if(x){if(O.options.preserveSymlinks)try{return await G(U,z,O)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(x.dangling)return}return N.isDirectory()?M(U,z,N.mode&b,O):q(U,z,N.mode&b)}async function M(U,z,O,N){await e.Promises.mkdir(z,{recursive:!0,mode:O});const x=await E(U);for(const B of x)await F((0,y.join)(U,B),(0,y.join)(z,B),N)}async function q(U,z,O){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,O)}async function G(U,z,O){let N=await e.Promises.readlink(U);(0,A.isEqualOrParent)(N,O.root.source,!T.isLinux)&&(N=(0,y.join)(O.root.target,N.substr(O.root.source.length+1))),await e.Promises.symlink(N,z)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return d}get move(){return v}get copy(){return P}}}),define(fe[105],me([0,1,50,8,9,28]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const I=(0,L.dirname)(n);if(n===I)return n;const c=((0,L.basename)(n)||n).toLowerCase();try{const d=(0,C.readdirSync)(I).filter(p=>p.toLowerCase()===c);if(d.length===1){const p=A(I);if(p)return(0,L.join)(p,d[0])}else if(d.length>1){const p=d.indexOf(c);if(p>=0){const D=A(I);if(D)return(0,L.join)(D,d[p])}}}catch(f){}return null}e.realcaseSync=A;async function S(n){try{return await C.Promises.realpath(n)}catch(I){const c=T(n);return await C.Promises.access(c,g.constants.R_OK),c}}e.realpath=S;function y(n){try{return g.realpathSync(n)}catch(I){const c=T(n);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=y;function T(n){return(0,k.rtrim)((0,L.normalize)(n),L.sep)}});var Ge=this&&this.__decorate||function(J,e,g,L){var k=arguments.length,C=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,g,L);else for(var S=J.length-1;S>=0;S--)(A=J[S])&&(C=(k<3?A(C):k>3?A(e,g,C):A(e,g))||C);return k>3&&C&&Object.defineProperty(e,g,C),C};define(fe[106],me([0,1,16,18,22,21,59,17,3,6,61,9,12]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function d(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function D(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(R||(R={}));class E{constructor(B){this.buffer=B,this.pos=0}read(B){const H=this.buffer.slice(this.pos,this.pos+B);return this.pos+=H.byteLength,H}}class a{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(o||(o={}));function m(x){const B=k.VSBuffer.alloc(4);return B.writeUInt32BE(x,0),B}function t(x){return x.read(4).readUInt32BE(0)}function u(x){const B=k.VSBuffer.alloc(1);return B.writeUInt8(x,0),B}const r={Undefined:u(o.Undefined),String:u(o.String),Buffer:u(o.Buffer),VSBuffer:u(o.VSBuffer),Array:u(o.Array),Object:u(o.Object)},i=typeof Buffer!="undefined";function s(x,B){if(typeof B=="undefined")x.write(r.Undefined);else if(typeof B=="string"){const H=k.VSBuffer.fromString(B);x.write(r.String),x.write(m(H.byteLength)),x.write(H)}else if(i&&Buffer.isBuffer(B)){const H=k.VSBuffer.wrap(B);x.write(r.Buffer),x.write(m(H.byteLength)),x.write(H)}else if(B instanceof k.VSBuffer)x.write(r.VSBuffer),x.write(m(B.byteLength)),x.write(B);else if(Array.isArray(B)){x.write(r.Array),x.write(m(B.length));for(const H of B)s(x,H)}else{const H=k.VSBuffer.fromString(JSON.stringify(B));x.write(r.Object),x.write(m(H.byteLength)),x.write(H)}}function l(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(t(x)).toString();case o.Buffer:return x.read(t(x)).buffer;case o.VSBuffer:return x.read(t(x));case o.Array:{const H=t(x),$=[];for(let Y=0;Y<H;Y++)$.push(l(x));return $}case o.Object:return JSON.parse(x.read(t(x)).toString())}}class h{constructor(B,H,$=null,Y=1e3){this.protocol=B,this.ctx=H,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(B,H){this.channels.set(B,H),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const H=this.send([B.type]);this.logger&&this.logger.logOutgoing(H,0,1,D(B.type));return}case 201:case 202:case 204:case 203:{const H=this.send([B.type,B.id],B.data);this.logger&&this.logger.logOutgoing(H,B.id,1,D(B.type),B.data);return}}}send(B,H=void 0){const $=new a;return s($,B),s($,H),this.sendBuffer($.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch(H){return 0}}onRawMessage(B){const H=new E(B),$=l(H),Y=l(H),Q=$[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${d(Q)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:Q,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${d(Q)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:Q,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:$[1]})}}onPromise(B){const H=this.channels.get(B.channelName);if(!H){this.collectPendingRequest(B);return}const $=new C.CancellationTokenSource;let Y;try{Y=H.call(this.ctx,B.name,B.arg,$.token)}catch(_e){Y=Promise.reject(_e)}const Q=B.id;Y.then(_e=>{this.sendResponse({id:Q,data:_e,type:201}),this.activeRequests.delete(B.id)},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Q,data:_e,type:203}),this.activeRequests.delete(B.id)});const de=(0,T.toDisposable)(()=>$.cancel());this.activeRequests.set(B.id,de)}onEventListen(B){const H=this.channels.get(B.channelName);if(!H){this.collectPendingRequest(B);return}const $=B.id,Q=H.listen(this.ctx,B.name,B.arg)(de=>this.sendResponse({id:$,data:de,type:204}));this.activeRequests.set(B.id,Q)}disposeActiveRequest(B){const H=this.activeRequests.get(B.id);H&&(H.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let H=this.pendingRequests.get(B.channelName);H||(H=[],this.pendingRequests.set(B.channelName,H));const $=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:B,timeoutTimer:$})}flushPendingRequests(B){const H=this.pendingRequests.get(B);if(H){for(const $ of H)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class _{constructor(B,H=null){this.protocol=B,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=H}getChannel(B){const H=this;return{call($,Y,Q){return H.isDisposed?Promise.reject(S.canceled()):H.requestPromise(B,$,Y,Q)},listen($,Y){return H.isDisposed?Promise.reject(S.canceled()):H.requestEvent(B,$,Y)}}}requestPromise(B,H,$,Y=C.CancellationToken.None){const Q=this.lastRequestId++,_e={id:Q,type:100,channelName:B,name:H,arg:$};if(Y.isCancellationRequested)return Promise.reject(S.canceled());let Ce;return new Promise(($e,Be)=>{if(Y.isCancellationRequested)return Be(S.canceled());const He=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),$e(Z.data);break;case 202:this.handlers.delete(Q);const ae=new Error(Z.data.message);ae.stack=Z.data.stack,ae.name=Z.data.name,Be(ae);break;case 203:this.handlers.delete(Q),Be(Z.data);break}};this.handlers.set(Q,le),this.sendRequest(_e)};let j=null;this.state===R.Idle?He():(j=(0,L.createCancelablePromise)(le=>this.whenInitialized()),j.then(()=>{j=null,He()}));const ee=()=>{j?(j.cancel(),j=null):this.sendRequest({id:Q,type:101}),Be(S.canceled())},se=Y.onCancellationRequested(ee);Ce=(0,T.combinedDisposable)((0,T.toDisposable)(ee),se),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(B,H,$){const Y=this.lastRequestId++,de={id:Y,type:102,channelName:B,name:H,arg:$};let _e=null;const Ce=new y.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)($e=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Ce),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Ce),this.sendRequest({id:Y,type:103}))}}),Te=$e=>Ce.fire($e.data);return this.handlers.set(Y,Te),Ce.event}sendRequest(B){switch(B.type){case 100:case 102:{const H=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger&&this.logger.logOutgoing(H,B.id,0,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const H=this.send([B.type,B.id]);this.logger&&this.logger.logOutgoing(H,B.id,0,d(B.type));return}}}send(B,H=void 0){const $=new a;return s($,B),s($,H),this.sendBuffer($.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch(H){return 0}}onBuffer(B){const H=new E(B),$=l(H),Y=l(H),Q=$[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(B.byteLength,0,0,D(Q)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(B.byteLength,$[1],0,D(Q),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(B){if(B.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(B.id);H&&H(B)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}Ge([A.memoize],_.prototype,"onDidInitializePromise",null),e.ChannelClient=_;class v{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:H,onDidClientDisconnect:$})=>{y.Event.once(H.onMessage)(Q=>{const de=new E(Q),_e=l(de),Ce=new h(H,_e),Te=new _(H);this.channels.forEach((Be,He)=>Ce.registerChannel(He,Be));const $e={channelServer:Ce,channelClient:Te,ctx:_e};this._connections.add($e),this._onDidAddConnection.fire($e),$(()=>{Ce.dispose(),Te.dispose(),this._connections.delete($e),this._onDidRemoveConnection.fire($e)})})})}get connections(){const B=[];return this._connections.forEach(H=>B.push(H)),B}getChannel(B,H){const $=this;return{call(Y,Q,de){let _e;if((0,c.isFunction)(H)){let Te=(0,g.getRandomElement)($.connections.filter(H));_e=Te?Promise.resolve(Te):y.Event.toPromise(y.Event.filter($.onDidAddConnection,H))}else _e=H.routeCall($,Y,Q);const Ce=_e.then(Te=>Te.channelClient.getChannel(B));return b(Ce).call(Y,Q,de)},listen(Y,Q){if((0,c.isFunction)(H))return $.getMulticastEvent(B,H,Y,Q);const de=H.routeEvent($,Y,Q).then(_e=>_e.channelClient.getChannel(B));return b(de).listen(Y,Q)}}}getMulticastEvent(B,H,$,Y){const Q=this;let de=new T.DisposableStore;const _e=new y.Emitter({onFirstListenerAdd:()=>{de=new T.DisposableStore;const Ce=new y.EventMultiplexer,Te=new Map,$e=He=>{const ee=He.channelClient.getChannel(B).listen($,Y),se=Ce.add(ee);Te.set(He,se)},Be=He=>{const j=Te.get(He);!j||(j.dispose(),Te.delete(He))};Q.connections.filter(H).forEach($e),y.Event.filter(Q.onDidAddConnection,H)($e,void 0,de),Q.onDidRemoveConnection(Be,void 0,de),Ce.event(_e.fire,_e,de),de.add(Ce)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(B,H){this.channels.set(B,H),this._connections.forEach($=>{$.channelServer.registerChannel(B,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class P{constructor(B,H,$=null){const Y=new a;s(Y,H),B.send(Y.buffer),this.channelClient=new _(B,$),this.channelServer=new h(B,H,$)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,H){this.channelServer.registerChannel(B,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function b(x){return{call(B,H,$){return x.then(Y=>Y.call(B,H,$))},listen(B,H){const $=new y.Relay;return x.then(Y=>$.input=Y.listen(B,H)),$.event}}}e.getDelayedChannel=b;function F(x){let B=!1;return{call(H,$,Y){return B?x.call(H,$,Y):(0,L.timeout)(0).then(()=>B=!0).then(()=>x.call(H,$,Y))},listen(H,$){if(B)return x.listen(H,$);const Y=new y.Relay;return(0,L.timeout)(0).then(()=>B=!0).then(()=>Y.input=x.listen(H,$)),Y.event}}}e.getNextTickChannel=F;class M{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const H of B.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await y.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=M;var q;(function(x){function B(Q,de){const _e=Q,Ce=de&&de.disableMarshalling,Te=new Map;for(const $e in _e)$($e)&&Te.set($e,y.Event.buffer(_e[$e],!0));return new class{listen($e,Be,He){const j=Te.get(Be);if(j)return j;if(Y(Be)){const ee=_e[Be];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${Be}`)}call($e,Be,He){const j=_e[Be];if(typeof j=="function"){if(!Ce&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,n.revive)(He[ee]);return j.apply(_e,He)}throw new Error(`Method not found: ${Be}`)}}}x.fromService=B;function H(Q,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(Ce,Te){if(typeof Te=="string")return de?.properties?.has(Te)?de.properties.get(Te):Y(Te)?function($e){return Q.listen(Te,$e)}:$(Te)?Q.listen(Te):async function(...$e){let Be;de&&!(0,c.isUndefinedOrNull)(de.context)?Be=[de.context,...$e]:Be=$e;const He=await Q.call(Te,Be);return _e?He:(0,n.revive)(He)};throw new Error(`Property not found: ${String(Te)}`)}})}x.toService=H;function $(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function Y(Q){return/^onScoped/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(8))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let B=x.toString();if(B!=="[object Object]")return B}return x}function z(x){return Array.isArray(x)?x.map(U):U(x)}function O(x,B,H,$,Y,Q,de){de=z(de);const _e=G[Y],Ce=_e[$%_e.length];let Te=[`%c[${x}]%c[${String(B).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String($).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(Q)?(Te=Te.concat(de),Te.push(")")):Te.push(de),console.log.apply(console,Te)}e.logWithColors=O;class N{constructor(B,H){this._outgoingPrefix=B,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,H,$,Y,Q){this._totalOutgoing+=B,O(this._outgoingPrefix,this._totalOutgoing,B,H,$,Y,Q)}logIncoming(B,H,$,Y,Q){this._totalIncoming+=B,O(this._incomingPrefix,this._totalIncoming,B,H,$,Y,Q)}}e.IPCLogger=N}),define(fe[107],me([0,1,22,3,6,11,38,106]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function n(){return T||(T=g.VSBuffer.alloc(0)),T}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,s){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const _=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=i),_}if(this._chunks[0].byteLength>i){const _=this._chunks[0].slice(0,i);return s&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),_}let l=g.VSBuffer.alloc(i),h=0,w=0;for(;i>0;){const _=this._chunks[w];if(_.byteLength>i){const v=_.slice(0,i);l.set(v,h),h+=i,s&&(this._chunks[w]=_.slice(i),this._totalLength-=i),i-=i}else l.set(_,h),h+=_.byteLength,s?(this._chunks.shift(),this._totalLength-=_.byteLength):w++,i-=_.byteLength}return l}}e.ChunkStream=I;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(i,s,l,h){this.type=i,this.id=s,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends k.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const l=this._state.messageType,h=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(l,h,w,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=g.VSBuffer.alloc(13);s.writeUInt8(i.type,0),s.writeUInt32BE(i.id,1),s.writeUInt32BE(i.ack,5),s.writeUInt32BE(i.data.byteLength,9),this._writeSoon(s,i.data)}_bufferAdd(i,s){const l=this._totalLength===0;return this._data.push(i,s),this._totalLength+=i.byteLength+s.byteLength,l}_bufferTake(){const i=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,s){this._bufferAdd(i,s)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class R extends k.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new d(1,0,0,i))}}e.Protocol=R;class E extends S.IPCClient{constructor(i,s,l=null){super(i,s,l);this.protocol=i}static fromSocket(i,s){return new E(new R(i),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class o{constructor(i){this.data=i,this.next=null}}class m{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],s=0,l=this._first;for(;l;)i[s++]=l.data,l=l.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const s=new o(i);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let s=0;s<t._HISTORY_LENGTH;s++)this.lastRuns[s]=i-1e3*s;setInterval(()=>{for(let s=t._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),s=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<t._HISTORY_LENGTH;h++)i-this.lastRuns[h]<=s&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class u{constructor(i,s=null,l=t.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new m,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new d(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const s=new d(4,0,0,n());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,s){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let s=0,l=i.length;s<l;s++)this._socketWriter.write(i[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new d(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const s=this._outgoingUnackMsg.toArray();for(let l=0,h=s.length;l<h;l++)this._socketWriter.write(s[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new d(1,s,this._incomingAckId,i);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(i){const s=new d(2,0,0,i);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),s=Date.now()-i.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new d(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=u}),define(fe[108],me([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(S){let y=(0,g.toUint8)(S);this._defaultValue=y,this._asciiMap=L._createAsciiMap(y),this._map=new Map}static _createAsciiMap(S){let y=new Uint8Array(256);for(let T=0;T<256;T++)y[T]=S;return y}set(S,y){let T=(0,g.toUint8)(y);S>=0&&S<256?this._asciiMap[S]=T:this._map.set(S,T)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class C{constructor(){this._actual=new L(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=C}),define(fe[144],me([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(S){super(0);for(let y=0,T=S.length;y<T;y++)this.set(S.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function C(A){let S={};return y=>(S.hasOwnProperty(y)||(S[y]=A(y)),S[y])}e.getMapForWordSeparators=C(A=>new k(A))}),define(fe[51],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,C){this.lineNumber=k,this.column=C}with(k=this.lineNumber,C=this.column){return k===this.lineNumber&&C===this.column?this:new g(k,C)}delta(k=0,C=0){return this.with(this.lineNumber+k,this.column+C)}equals(k){return g.equals(this,k)}static equals(k,C){return!k&&!C?!0:!!k&&!!C&&k.lineNumber===C.lineNumber&&k.column===C.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<C.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<=C.column}static compare(k,C){let A=k.lineNumber|0,S=C.lineNumber|0;if(A===S){let y=k.column|0,T=C.column|0;return y-T}return A-S}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(fe[42],me([0,1,51]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,A,S,y){C>S||C===S&&A>y?(this.startLineNumber=S,this.startColumn=y,this.endLineNumber=C,this.endColumn=A):(this.startLineNumber=C,this.startColumn=A,this.endLineNumber=S,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,A){return!(A.lineNumber<C.startLineNumber||A.lineNumber>C.endLineNumber||A.lineNumber===C.startLineNumber&&A.column<C.startColumn||A.lineNumber===C.endLineNumber&&A.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,A){return!(A.startLineNumber<C.startLineNumber||A.endLineNumber<C.startLineNumber||A.startLineNumber>C.endLineNumber||A.endLineNumber>C.endLineNumber||A.startLineNumber===C.startLineNumber&&A.startColumn<C.startColumn||A.endLineNumber===C.endLineNumber&&A.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,A){return!(A.startLineNumber<C.startLineNumber||A.endLineNumber<C.startLineNumber||A.startLineNumber>C.endLineNumber||A.endLineNumber>C.endLineNumber||A.startLineNumber===C.startLineNumber&&A.startColumn<=C.startColumn||A.endLineNumber===C.endLineNumber&&A.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,A){let S,y,T,n;return A.startLineNumber<C.startLineNumber?(S=A.startLineNumber,y=A.startColumn):A.startLineNumber===C.startLineNumber?(S=A.startLineNumber,y=Math.min(A.startColumn,C.startColumn)):(S=C.startLineNumber,y=C.startColumn),A.endLineNumber>C.endLineNumber?(T=A.endLineNumber,n=A.endColumn):A.endLineNumber===C.endLineNumber?(T=A.endLineNumber,n=Math.max(A.endColumn,C.endColumn)):(T=C.endLineNumber,n=C.endColumn),new L(S,y,T,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,A){let S=C.startLineNumber,y=C.startColumn,T=C.endLineNumber,n=C.endColumn,I=A.startLineNumber,c=A.startColumn,f=A.endLineNumber,d=A.endColumn;return S<I?(S=I,y=c):S===I&&(y=Math.max(y,c)),T>f?(T=f,n=d):T===f&&(n=Math.min(n,d)),S>T||S===T&&y>n?null:new L(S,y,T,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,A){return!!C&&!!A&&C.startLineNumber===A.startLineNumber&&C.startColumn===A.startColumn&&C.endLineNumber===A.endLineNumber&&C.endColumn===A.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,A){return new L(this.startLineNumber,this.startColumn,C,A)}setStartPosition(C,A){return new L(C,A,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,A=C){return new L(C.lineNumber,C.column,A.lineNumber,A.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,A){return!(C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn||A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn)}static areIntersecting(C,A){return!(C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn||A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,A){if(C&&A){const T=C.startLineNumber|0,n=A.startLineNumber|0;if(T===n){const I=C.startColumn|0,c=A.startColumn|0;if(I===c){const f=C.endLineNumber|0,d=A.endLineNumber|0;if(f===d){const p=C.endColumn|0,D=A.endColumn|0;return p-D}return f-d}return I-c}return T-n}return(C?1:0)-(A?1:0)}static compareRangesUsingEnds(C,A){return C.endLineNumber===A.endLineNumber?C.endColumn===A.endColumn?C.startLineNumber===A.startLineNumber?C.startColumn-A.startColumn:C.startLineNumber-A.startLineNumber:C.endColumn-A.endColumn:C.endLineNumber-A.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,51,42]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(S,y,T,n){super(S,y,T,n);this.selectionStartLineNumber=S,this.selectionStartColumn=y,this.positionLineNumber=T,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return C.selectionsEqual(this,S)}static selectionsEqual(S,y){return S.selectionStartLineNumber===y.selectionStartLineNumber&&S.selectionStartColumn===y.selectionStartColumn&&S.positionLineNumber===y.positionLineNumber&&S.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,y){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,S,y):new C(S,y,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,y){return this.getDirection()===0?new C(S,y,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,S,y)}static fromPositions(S,y=S){return new C(S.lineNumber,S.column,y.lineNumber,y.column)}static liftSelection(S){return new C(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,y){if(S&&!y||!S&&y)return!1;if(!S&&!y)return!0;if(S.length!==y.length)return!1;for(let T=0,n=S.length;T<n;T++)if(!this.selectionsEqual(S[T],y[T]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,y,T,n,I){return I===0?new C(S,y,T,n):new C(T,n,S,y)}}e.Selection=C}),define(fe[109],me([0,1,25]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),this.indentSize=D.tabSize|0,this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class T{constructor(D,R){this._findMatchBrand=void 0,this.range=D,this.matches=R}}e.FindMatch=T;var n;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(I=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class f{constructor(D,R,E,a,o,m){this.identifier=D,this.range=R,this.text=E,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=o,this._isTracked=m}}e.ValidAnnotatedEditOperation=f;class d{constructor(D,R,E){this.reverseEdits=D,this.changes=R,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=d}),define(fe[146],me([0,1,9,144,51,42,109]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class y{constructor(a,o,m,t){this.searchString=a,this.isRegex=o,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=T(this.searchString):a=this.searchString.indexOf(`
`)>=0;let o=null;try{o=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let m=!this.isRegex&&!a;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new n(o,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=y;function T(E){if(!E||E.length===0)return!1;for(let a=0,o=E.length;a<o;a++)if(E.charCodeAt(a)===92){if(a++,a>=o)break;const t=E.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=T;class n{constructor(a,o,m){this.regex=a,this.wordSeparators=o,this.simpleSearch=m}}e.SearchData=n;function I(E,a,o){if(!o)return new A.FindMatch(E,null);let m=[];for(let t=0,u=a.length;t<u;t++)m[t]=a[t];return new A.FindMatch(E,m)}e.createFindMatch=I;class c{constructor(a){let o=[],m=0;for(let t=0,u=a.length;t<u;t++)a.charCodeAt(t)===10&&(o[m++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(a){const o=this._lineFeedsOffsets;let m=0,t=o.length-1;if(t===-1||a<=o[0])return 0;for(;m<t;){const u=m+((t-m)/2>>0);o[u]>=a?t=u-1:o[u+1]>=a?(m=u,t=u):m=u+1}return m+1}}class f{static findMatches(a,o,m,t,u){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,m,new R(r.wordSeparators,r.regex),t,u):this._doFindMatchesLineByLine(a,m,r,t,u):[]}static _getMultilineMatchRange(a,o,m,t,u,r){let i,s=0;t?(s=t.findLineFeedCountBeforeOffset(u),i=o+u+s):i=o+u;let l;if(t){let v=t.findLineFeedCountBeforeOffset(u+r.length)-s;l=i+r.length+v}else l=i+r.length;const h=a.getPositionAt(i),w=a.getPositionAt(l);return new C.Range(h.lineNumber,h.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(a,o,m,t,u){const r=a.getOffsetAt(o.getStartPosition()),i=a.getValueInRange(o,1),s=a.getEOL()===`\r
`?new c(i):null,l=[];let h=0,w;for(m.reset(0);w=m.next(i);)if(l[h++]=I(this._getMultilineMatchRange(a,r,i,s,w.index,w[0]),w,t),h>=u)return l;return l}static _doFindMatchesLineByLine(a,o,m,t,u){const r=[];let i=0;if(o.startLineNumber===o.endLineNumber){const l=a.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return i=this._findMatchesInLine(m,l,o.startLineNumber,o.startColumn-1,i,r,t,u),r}const s=a.getLineContent(o.startLineNumber).substring(o.startColumn-1);i=this._findMatchesInLine(m,s,o.startLineNumber,o.startColumn-1,i,r,t,u);for(let l=o.startLineNumber+1;l<o.endLineNumber&&i<u;l++)i=this._findMatchesInLine(m,a.getLineContent(l),l,0,i,r,t,u);if(i<u){const l=a.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);i=this._findMatchesInLine(m,l,o.endLineNumber,0,i,r,t,u)}return r}static _findMatchesInLine(a,o,m,t,u,r,i,s){const l=a.wordSeparators;if(!i&&a.simpleSearch){const _=a.simpleSearch,v=_.length,P=o.length;let b=-v;for(;(b=o.indexOf(_,b+v))!==-1;)if((!l||D(l,o,P,b,v))&&(r[u++]=new A.FindMatch(new C.Range(m,b+1+t,m,b+1+v+t),null),u>=s))return u;return u}const h=new R(a.wordSeparators,a.regex);let w;h.reset(0);do if(w=h.next(o),w&&(r[u++]=I(new C.Range(m,w.index+1+t,m,w.index+1+w[0].length+t),w,i),u>=s))return u;while(w);return u}static findNextMatch(a,o,m,t){const u=o.parseSearchRequest();if(!u)return null;const r=new R(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindNextMatchMultiline(a,m,r,t):this._doFindNextMatchLineByLine(a,m,r,t)}static _doFindNextMatchMultiline(a,o,m,t){const u=new k.Position(o.lineNumber,1),r=a.getOffsetAt(u),i=a.getLineCount(),s=a.getValueInRange(new C.Range(u.lineNumber,u.column,i,a.getLineMaxColumn(i)),1),l=a.getEOL()===`\r
`?new c(s):null;m.reset(o.column-1);let h=m.next(s);return h?I(this._getMultilineMatchRange(a,r,s,l,h.index,h[0]),h,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(a,new k.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(a,o,m,t){const u=a.getLineCount(),r=o.lineNumber,i=a.getLineContent(r),s=this._findFirstMatchInLine(m,i,r,o.column,t);if(s)return s;for(let l=1;l<=u;l++){const h=(r+l-1)%u,w=a.getLineContent(h+1),_=this._findFirstMatchInLine(m,w,h+1,1,t);if(_)return _}return null}static _findFirstMatchInLine(a,o,m,t,u){a.reset(t-1);const r=a.next(o);return r?I(new C.Range(m,r.index+1,m,r.index+1+r[0].length),r,u):null}static findPreviousMatch(a,o,m,t){const u=o.parseSearchRequest();if(!u)return null;const r=new R(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindPreviousMatchMultiline(a,m,r,t):this._doFindPreviousMatchLineByLine(a,m,r,t)}static _doFindPreviousMatchMultiline(a,o,m,t){const u=this._doFindMatchesMultiline(a,new C.Range(1,1,o.lineNumber,o.column),m,t,10*S);if(u.length>0)return u[u.length-1];const r=a.getLineCount();return o.lineNumber!==r||o.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new k.Position(r,a.getLineMaxColumn(r)),m,t):null}static _doFindPreviousMatchLineByLine(a,o,m,t){const u=a.getLineCount(),r=o.lineNumber,i=a.getLineContent(r).substring(0,o.column-1),s=this._findLastMatchInLine(m,i,r,t);if(s)return s;for(let l=1;l<=u;l++){const h=(u+r-l-1)%u,w=a.getLineContent(h+1),_=this._findLastMatchInLine(m,w,h+1,t);if(_)return _}return null}static _findLastMatchInLine(a,o,m,t){let u=null,r;for(a.reset(0);r=a.next(o);)u=I(new C.Range(m,r.index+1,m,r.index+1+r[0].length),r,t);return u}}e.TextModelSearch=f;function d(E,a,o,m,t){if(m===0)return!0;const u=a.charCodeAt(m-1);if(E.get(u)!==0||u===13||u===10)return!0;if(t>0){const r=a.charCodeAt(m);if(E.get(r)!==0)return!0}return!1}function p(E,a,o,m,t){if(m+t===o)return!0;const u=a.charCodeAt(m+t);if(E.get(u)!==0||u===13||u===10)return!0;if(t>0){const r=a.charCodeAt(m+t-1);if(E.get(r)!==0)return!0}return!1}function D(E,a,o,m,t){return d(E,a,o,m,t)&&p(E,a,o,m,t)}e.isValidMatch=D;class R{constructor(a,o){this._wordSeparators=a,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const o=a.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(m=this._searchRegex.exec(a),!m))return null;const t=m.index,u=m[0].length;if(t===this._prevMatchStartIndex&&u===this._prevMatchLength){if(u===0){g.getNextCodePoint(a,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=u,!this._wordSeparators||D(this._wordSeparators,a,o,t,u))return m}while(m);return null}}e.Searcher=R}),define(fe[110],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(S=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)S.indexOf(T)>=0||(y+="\\"+T);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=g();function L(S){let y=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)y=S;else{let T="g";S.ignoreCase&&(T+="i"),S.multiline&&(T+="m"),S.unicode&&(T+="u"),y=new RegExp(S.source,T)}return y.lastIndex=0,y}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function C(S,y,T,n,I=k){if(T.length>I.maxLen){let D=S-I.maxLen/2;return D<0?D=0:n+=D,T=T.substring(D,S+I.maxLen/2),C(S,y,T,n,I)}const c=Date.now(),f=S-1-n;let d=-1,p=null;for(let D=1;!(Date.now()-c>=I.timeBudget);D++){const R=f-I.windowSize*D;y.lastIndex=Math.max(0,R);const E=A(y,T,f,d);if(!E&&p||(p=E,R<=0))break;d=R}if(p){let D={word:p[0],startColumn:n+1+p.index,endColumn:n+1+p.index+p[0].length};return y.lastIndex=0,D}return null}e.getWordAtText=C;function A(S,y,T,n){let I;for(;I=S.exec(y);){const c=I.index||0;if(c<=T&&S.lastIndex>=T)return I;if(n>0&&c>n)return null}return null}}),define(fe[147],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(S){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let y=0,T=S.notIn.length;y<T;y++)switch(S.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of S)C(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),C(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),C(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),C(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&C(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function C(A,S,y){A.has(S)?A.get(S).push(y):A.set(S,[y])}}),define(fe[81],me([0,1,30,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(C,A,S,y){if(Array.isArray(C)){let T=0;for(const n of C){const I=k(n,A,S,y);if(I===10)return I;I>T&&(T=I)}return T}else{if(typeof C=="string")return y?C==="*"?5:C===S?10:0:0;if(C){const{language:T,pattern:n,scheme:I,hasAccessToAllModels:c}=C;if(!y&&!c)return 0;let f=0;if(I)if(I===A.scheme)f=10;else if(I==="*")f=5;else return 0;if(T)if(T===S)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(n){let d;if(typeof n=="string"?d=n:d={...n,base:(0,L.normalize)(n.base)},d===A.fsPath||(0,g.match)(d,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=k}),define(fe[148],me([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(d,p,D){const R=new Uint8Array(d*p);for(let E=0,a=d*p;E<a;E++)R[E]=D;this._data=R,this.rows=d,this.cols=p}get(d,p){return this._data[d*this.cols+p]}set(d,p,D){this._data[d*this.cols+p]=D}}e.Uint8Matrix=k;class C{constructor(d){let p=0,D=0;for(let E=0,a=d.length;E<a;E++){let[o,m,t]=d[E];m>p&&(p=m),o>D&&(D=o),t>D&&(D=t)}p++,D++;let R=new k(D,p,0);for(let E=0,a=d.length;E<a;E++){let[o,m,t]=d[E];R.set(o,m,t)}this._states=R,this._maxCharCode=p}nextState(d,p){return p<0||p>=this._maxCharCode?0:this._states.get(d,p)}}e.StateMachine=C;let A=null;function S(){return A===null&&(A=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let T=null;function n(){if(T===null){T=new g.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<f.length;p++)T.set(f.charCodeAt(p),1);const d=".,;";for(let p=0;p<d.length;p++)T.set(d.charCodeAt(p),2)}return T}class I{static _createLink(d,p,D,R,E){let a=E-1;do{const o=p.charCodeAt(a);if(d.get(o)!==2)break;a--}while(a>R);if(R>0){const o=p.charCodeAt(R-1),m=p.charCodeAt(a);(o===40&&m===41||o===91&&m===93||o===123&&m===125)&&a--}return{range:{startLineNumber:D,startColumn:R+1,endLineNumber:D,endColumn:a+2},url:p.substring(R,a+1)}}static computeLinks(d,p=S()){const D=n();let R=[];for(let E=1,a=d.getLineCount();E<=a;E++){const o=d.getLineContent(E),m=o.length;let t=0,u=0,r=0,i=1,s=!1,l=!1,h=!1,w=!1;for(;t<m;){let _=!1;const v=o.charCodeAt(t);if(i===13){let P;switch(v){case 40:s=!0,P=0;break;case 41:P=s?0:1;break;case 91:h=!0,l=!0,P=0;break;case 93:h=!1,P=l?0:1;break;case 123:w=!0,P=0;break;case 125:P=w?0:1;break;case 39:P=r===34||r===96?0:1;break;case 34:P=r===39||r===96?0:1;break;case 96:P=r===39||r===34?0:1;break;case 42:P=r===42?1:0;break;case 124:P=r===124?1:0;break;case 32:P=h?0:1;break;default:P=D.get(v)}P===1&&(R.push(I._createLink(D,o,E,u,t)),_=!0)}else if(i===12){let P;v===91?(l=!0,P=0):P=D.get(v),P===1?_=!0:i=13}else i=p.nextState(i,v),i===0&&(_=!0);_&&(i=1,s=!1,l=!1,w=!1,u=t+1,r=v),t++}i===13&&R.push(I._createLink(D,o,E,u,m))}return R}}e.LinkComputer=I;function c(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=c}),define(fe[149],me([0,1,3,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,S){return this._map.set(A,S),this.fire([A]),(0,L.toDisposable)(()=>{this._map.get(A)===S&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,S){let y=null,T=!1;return this._promises.set(A,S.then(n=>{this._promises.delete(A),!(T||!n)&&(y=this.register(A,n))})),(0,L.toDisposable)(()=>{T=!0,y&&y.dispose()})}getPromise(A){const S=this.get(A);if(S)return Promise.resolve(S);const y=this._promises.get(A);return y?y.then(T=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(fe[111],me([0,1,22,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function C(I){for(let c=0,f=I.length;c<f;c+=4){const d=I[c+0],p=I[c+1],D=I[c+2],R=I[c+3];I[c+0]=R,I[c+1]=D,I[c+2]=p,I[c+3]=d}}function A(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(c),g.VSBuffer.wrap(c)}function S(I){const c=I.buffer;if(L.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const f=new Uint8Array(c.byteLength);return f.set(c),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(I){const c=new Uint32Array(T(I));let f=0;if(c[f++]=I.id,I.type==="full")c[f++]=1,c[f++]=I.data.length,c.set(I.data,f),f+=I.data.length;else{c[f++]=2,c[f++]=I.deltas.length;for(const d of I.deltas)c[f++]=d.start,c[f++]=d.deleteCount,d.data?(c[f++]=d.data.length,c.set(d.data,f),f+=d.data.length):c[f++]=0}return A(c)}e.encodeSemanticTokensDto=y;function T(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(c+=f.data.length)}return c}function n(I){const c=S(I);let f=0;const d=c[f++];if(c[f++]===1){const E=c[f++],a=c.subarray(f,f+E);return f+=E,{id:d,type:"full",data:a}}const D=c[f++];let R=[];for(let E=0;E<D;E++){const a=c[f++],o=c[f++],m=c[f++];let t;m>0&&(t=c.subarray(f,f+m),f+=m),R[E]={start:a,deleteCount:o,data:t}}return{id:d,type:"delta",deltas:R}}e.decodeSemanticTokensDto=n}),define(fe[112],me([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(A,S){this._prefixSumIndexOfResultBrand=void 0,this.index=A,this.remainder=S}}e.PrefixSumIndexOfResult=L;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,S){A=(0,g.toUint32)(A);const y=this.values,T=this.prefixSum,n=S.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,A),0),this.values.set(y.subarray(A),A+n),this.values.set(S,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,S){return A=(0,g.toUint32)(A),S=(0,g.toUint32)(S),this.values[A]===S?!1:(this.values[A]=S,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,S){A=(0,g.toUint32)(A),S=(0,g.toUint32)(S);const y=this.values,T=this.prefixSum;if(A>=y.length)return!1;let n=y.length-A;return S>=n&&(S=n),S===0?!1:(this.values=new Uint32Array(y.length-S),this.values.set(y.subarray(0,A),0),this.values.set(y.subarray(A+S),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=(0,g.toUint32)(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),A>=this.values.length&&(A=this.values.length-1);for(let y=S;y<=A;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let S=0,y=this.values.length-1,T=0,n=0,I=0;for(;S<=y;)if(T=S+(y-S)/2|0,n=this.prefixSum[T],I=n-this.values[T],A<I)y=T-1;else if(A>=n)S=T+1;else break;return new L(T,A-I)}}e.PrefixSumComputer=k}),define(fe[150],me([0,1,9,51,112]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(S,y,T,n){this._uri=S,this._lines=y,this._eol=T,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const y=S.changes;for(const T of y)this._acceptDeleteRange(T.range),this._acceptInsertText(new L.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,y=this._lines.length,T=new Uint32Array(y);for(let n=0;n<y;n++)T[n]=this._lines[n].length+S;this._lineStarts=new k.PrefixSumComputer(T)}}_setLineText(S,y){this._lines[S]=y,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,y){if(y.length===0)return;let T=(0,g.splitLines)(y);if(T.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+T[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}T[T.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+T[0]);let n=new Uint32Array(T.length-1);for(let I=1;I<T.length;I++)this._lines.splice(S.lineNumber+I-1,0,T[I]),n[I-1]=T[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,n)}}e.MirrorTextModel=C}),define(fe[151],me([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,C=k*24,A=C*7,S=C*30,y=C*365;function T(I,c){typeof I!="number"&&(I=I.getTime());const f=Math.round((new Date().getTime()-I)/1e3);if(f<-30)return(0,g.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,g.localize)(1,null);let d;return f<L?(d=f,c?d===1?(0,g.localize)(2,null,d):(0,g.localize)(3,null,d):d===1?(0,g.localize)(4,null,d):(0,g.localize)(5,null,d)):f<k?(d=Math.floor(f/L),c?d===1?(0,g.localize)(6,null,d):(0,g.localize)(7,null,d):d===1?(0,g.localize)(8,null,d):(0,g.localize)(9,null,d)):f<C?(d=Math.floor(f/k),c?d===1?(0,g.localize)(10,null,d):(0,g.localize)(11,null,d):d===1?(0,g.localize)(12,null,d):(0,g.localize)(13,null,d)):f<A?(d=Math.floor(f/C),c?d===1?(0,g.localize)(14,null,d):(0,g.localize)(15,null,d):d===1?(0,g.localize)(16,null,d):(0,g.localize)(17,null,d)):f<S?(d=Math.floor(f/A),c?d===1?(0,g.localize)(18,null,d):(0,g.localize)(19,null,d):d===1?(0,g.localize)(20,null,d):(0,g.localize)(21,null,d)):f<y?(d=Math.floor(f/S),c?d===1?(0,g.localize)(22,null,d):(0,g.localize)(23,null,d):d===1?(0,g.localize)(24,null,d):(0,g.localize)(25,null,d)):(d=Math.floor(f/y),c?d===1?(0,g.localize)(26,null,d):(0,g.localize)(27,null,d):d===1?(0,g.localize)(28,null,d):(0,g.localize)(29,null,d))}e.fromNow=T;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(fe[153],me([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(fe[62],me([0,1,16,12,153]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(T,n){return n&&(T.stack||T.stacktrace)?k.localize(0,null,S(T),A(T.stack)||A(T.stacktrace)):S(T)}function A(T){return Array.isArray(T)?T.join(`
`):T}function S(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?k.localize(1,null,T.message):T.message||k.localize(2,null)}function y(T=null,n=!1){if(!T)return k.localize(3,null);if(Array.isArray(T)){const I=g.coalesce(T),c=y(I[0],n);return I.length>1?k.localize(4,null,c,I.length):c}if(L.isString(T))return T;if(T.detail){const I=T.detail;if(I.error)return C(I.error,n);if(I.exception)return C(I.exception,n)}return T.stack?C(T,n):T.message?T.message:k.localize(5,null)}e.toErrorMessage=y}),define(fe[154],me([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(fe[113],me([0,1,39,29,10,25,8,11,38,12,143,28,154]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,m){if(S.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};m&&(t.cwd=m);const u=g.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{u.once("error",i=>{r({success:!1,error:i})}),u.once("exit",(i,s)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(S.isLinux||S.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(u=>{g.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,i,s)=>{u(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function p(o=y.env){return o.comspec||"cmd.exe"}e.getWindowsShell=p;class D{constructor(m,t,u,r){if(t!==void 0&&u!==void 0&&r!==void 0)this.cmd=m,this.args=t,this.shell=u,this.options=r;else{const i=m;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(y.env).forEach(s=>{i[s]=y.env[s]}),Object.keys(this.options.env).forEach(s=>{i[s]=this.options.env[s]}),this.options.env=i}}getSanitizedCommand(){let m=this.cmd.toLowerCase();const t=m.lastIndexOf(A.sep);return t!==-1&&(m=m.substring(t+1)),D.WellKnowCommands[m]?m:"other"}start(m){return S.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(c.localize(0,null))):this.useExec().then(t=>{let u,r;const i=new Promise((s,l)=>{u=s,r=l});if(t){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=g.exec(s,this.options,(l,h,w)=>{this.childProcess=null;const _=l;_&&_.killed?r({killed:this.terminateRequested,stdout:h.toString(),stderr:w.toString()}):this.handleExec(u,m,l,h,w)})}else{let s=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,u,m,r);const w={terminated:this.terminateRequested};T.isNumber(h)&&(w.cmdCode=h),u(w)};if(this.shell&&S.isWindows){const h=C.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let w=!1,_=!1;const v=[];let P=this.ensureQuotes(this.cmd);v.push(P.value),w=P.quoted,this.args&&this.args.forEach(F=>{P=this.ensureQuotes(F),v.push(P.value),_=_&&P.quoted});const b=["/s","/c"];w?_?b.push('"'+v.join(" ")+'"'):v.length>1?b.push('"'+v[0]+'" '+v.slice(1).join(" ")):b.push('"'+v[0]+'"'):b.push(v.join(" ")),s=g.spawn(p(),b,h)}else this.cmd&&(s=g.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(T.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",h=>{this.childProcess=null,r({terminated:this.terminateRequested,error:h})}),s.pid&&(this.childProcess.on("close",l),this.handleSpawn(s,u,m,r,!0)))}return i})}handleClose(m,t,u,r){}ensureQuotes(m){return D.regexp.test(m)?{value:'"'+m+'"',quoted:!0}:{value:m,quoted:m.length>0&&m[0]==='"'&&m[m.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(m=>m.pid,m=>-1):new Promise(m=>{this.pidResolve=m})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(m=>(this.terminateRequested=!0,d(m,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),m=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(m=>{if(!this.shell||!S.isWindows)return m(!1);const t=g.spawn(p(),["/s","/c"]);t.on("error",u=>m(!0)),t.on("exit",u=>m(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class R extends D{constructor(m,t,u,r){super(m,t,u,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(m,t,u,r,i){[r,i].forEach((s,l)=>{const h=new n.LineDecoder;h.write(s).forEach(v=>{t({line:v,source:l===0?0:1})});const _=h.end();_&&t({line:_,source:l===0?0:1})}),m({terminated:this.terminateRequested,error:u})}handleSpawn(m,t,u,r,i){const s=new n.LineDecoder,l=new n.LineDecoder;m.stdout.on("data",h=>{s.write(h).forEach(_=>u({line:_,source:0}))}),m.stderr.on("data",h=>{l.write(h).forEach(_=>u({line:_,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=l}handleClose(m,t,u,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&u({line:i,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&u({line:s,source:1})}}e.LineProcess=R;function E(o){let m=[],t=!1;const u=function(r){if(t){m.push(r);return}(!o.send(r,s=>{if(s&&console.error(s),t=!1,m.length>0){const l=m.slice(0);m=[],l.forEach(h=>u(h))}})||S.isWindows)&&(t=!0)};return{send:u}}e.createQueuedSender=E;var a;(function(o){async function m(t,u,r){if(A.isAbsolute(t))return t;if(u===void 0&&(u=y.cwd()),A.dirname(t)!=="."||(r===void 0&&T.isString(y.env.PATH)&&(r=y.env.PATH.split(A.delimiter)),r===void 0||r.length===0))return A.join(u,t);async function s(l){if(await I.Promises.exists(l)){let h;try{h=await I.Promises.stat(l)}catch(w){w.message.startsWith("EACCES")&&(h=await I.Promises.lstat(l))}return h?!h.isDirectory():!1}return!1}for(let l of r){let h;if(A.isAbsolute(l)?h=A.join(l,t):h=A.join(u,l,t),await s(h))return h;let w=h+".com";if(await s(w)||(w=h+".exe",await s(w)))return w}return A.join(u,t)}o.findExecutable=m})(a=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(fe[114],me([0,1,155,11,110]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=A;class S{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ge){this._values[te]=ge}}e.ValidatedEditorOptions=S;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class T{constructor(te,ge,je,tt){this.id=te,this.name=ge,this.defaultValue=je,this.schema=tt}compute(te,ge,je){return je}}class n{constructor(te,ge=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(te){return this.defaultValue}}class I{constructor(te,ge,je,tt){this.id=te,this.name=ge,this.defaultValue=je,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ge,je){return je}}function c(X,te){return typeof X=="undefined"?te:X==="false"?!1:Boolean(X)}e.boolean=c;class f extends I{constructor(te,ge,je,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=je),super(te,ge,je,tt)}validate(te){return c(te,this.defaultValue)}}function d(X,te,ge,je){if(typeof X=="undefined")return te;let tt=parseInt(X,10);return isNaN(tt)?te:(tt=Math.max(ge,tt),tt=Math.min(je,tt),tt|0)}e.clampedInt=d;class p extends I{constructor(te,ge,je,tt,lt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=je,ft.minimum=tt,ft.maximum=lt),super(te,ge,je,ft),this.minimum=tt,this.maximum=lt}static clampedInt(te,ge,je,tt){return d(te,ge,je,tt)}validate(te){return p.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class D extends I{constructor(te,ge,je,tt,lt){typeof lt!="undefined"&&(lt.type="number",lt.default=je),super(te,ge,je,lt),this.validationFn=tt}static clamp(te,ge,je){return te<ge?ge:te>je?je:te}static float(te,ge){if(typeof te=="number")return te;if(typeof te=="undefined")return ge;const je=parseFloat(te);return isNaN(je)?ge:je}validate(te){return this.validationFn(D.float(te,this.defaultValue))}}class R extends I{static string(te,ge){return typeof te!="string"?ge:te}constructor(te,ge,je,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=je),super(te,ge,je,tt)}validate(te){return R.string(te,this.defaultValue)}}function E(X,te,ge){return typeof X!="string"||ge.indexOf(X)===-1?te:X}e.stringSet=E;class a extends I{constructor(te,ge,je,tt,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=tt,lt.default=je),super(te,ge,je,lt),this._allowedValues=tt}validate(te){return E(te,this.defaultValue,this._allowedValues)}}class o extends T{constructor(te,ge,je,tt,lt,ft,wt=void 0){typeof wt!="undefined"&&(wt.type="string",wt.enum=lt,wt.default=tt),super(te,ge,je,wt),this._allowedValues=lt,this._convert=ft}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function m(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ge,je){return je===0?te.accessibilitySupport:je}}class u extends T{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:g.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{insertSpace:c(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(X){switch(X){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function h(X){switch(X){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class w extends n{constructor(){super(127,[65,32])}compute(te,ge,je){const tt=["monaco-editor"];return ge.get(32)&&tt.push(ge.get(32)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),ge.get(65)==="default"?tt.push("mouse-default"):ge.get(65)==="copy"&&tt.push("mouse-copy"),ge.get(100)&&tt.push("showUnused"),ge.get(125)&&tt.push("showDeprecated"),tt.join(" ")}}class _ extends f{constructor(){super(31,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(te,ge,je){return je&&te.emptySelectionClipboard}}class v extends T{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:g.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{cursorMoveOnType:c(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":E(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":E(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ge.loop,this.defaultValue.loop)}}}class P extends T{constructor(){super(43,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?P.OFF:te==="true"?P.ON:te:Boolean(te)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class b extends n{constructor(){super(42)}compute(te,ge,je){return te.fontInfo}}class F extends I{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(te){let ge=D.float(te,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(ge,6,100)}compute(te,ge,je){return te.fontInfo.fontSize}}class M extends T{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.MINIMUM_VALUE,maximum:M.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(p.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,M.MINIMUM_VALUE,M.MAXIMUM_VALUE))}}M.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],M.MINIMUM_VALUE=1,M.MAXIMUM_VALUE=1e3;class q extends T{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:je,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:je,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:je,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:je,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:je,description:g.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{multiple:E(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??E(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??E(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??E(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??E(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??E(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:R.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:R.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:R.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:R.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:R.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends T{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:g.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{enabled:c(ge.enabled,this.defaultValue.enabled),delay:p.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:c(ge.sticky,this.defaultValue.sticky)}}}var U;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,ge,je){return z.computeLayout(ge,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ge=te.height/te.lineHeight,je=te.scrollBeyondLastLine?ge-1:0,tt=(te.viewLineCount+je)/(te.pixelRatio*te.height),lt=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:je,desiredRatio:tt,minimapLineCount:lt}}static _computeMinimapLayout(te,ge){const je=te.outerWidth,tt=te.outerHeight,lt=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const ft=ge.stableMinimapLayoutInput,wt=ft&&te.outerHeight===ft.outerHeight&&te.lineHeight===ft.lineHeight&&te.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&te.pixelRatio===ft.pixelRatio&&te.scrollBeyondLastLine===ft.scrollBeyondLastLine&&te.minimap.enabled===ft.minimap.enabled&&te.minimap.side===ft.minimap.side&&te.minimap.size===ft.minimap.size&&te.minimap.showSlider===ft.minimap.showSlider&&te.minimap.renderCharacters===ft.minimap.renderCharacters&&te.minimap.maxColumn===ft.minimap.maxColumn&&te.minimap.scale===ft.minimap.scale&&te.verticalScrollbarWidth===ft.verticalScrollbarWidth&&te.isViewportWrapping===ft.isViewportWrapping,Ct=te.lineHeight,ce=te.typicalHalfwidthCharacterWidth,Pe=te.scrollBeyondLastLine,xe=te.minimap.renderCharacters;let Xe=lt>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const ze=te.minimap.maxColumn,ot=te.minimap.size,Ae=te.minimap.side,ye=te.verticalScrollbarWidth,Ie=te.viewLineCount,ne=te.remainingWidth,ue=te.isViewportWrapping,Ee=xe?2:3;let we=Math.floor(lt*tt);const Fe=we/lt;let Ke=!1,Ve=!1,Je=Ee*Xe,rt=Xe/lt,Ue=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:nt,extraLinesBeyondLastLine:Qe,desiredRatio:gt,minimapLineCount:bt}=z.computeContainedMinimapLineCount({viewLineCount:Ie,scrollBeyondLastLine:Pe,height:tt,lineHeight:Ct,pixelRatio:lt});if(Ie/bt>1)Ke=!0,Ve=!0,Xe=1,Je=1,rt=Xe/lt;else{let pt=!1,ut=Xe+1;if(ot==="fit"){const yt=Math.ceil((Ie+Qe)*Je);ue&&wt&&ne<=ge.stableFitRemainingWidth?(pt=!0,ut=ge.stableFitMaxMinimapScale):pt=yt>we}if(ot==="fill"||pt){Ke=!0;const yt=Xe;Je=Math.min(Ct*lt,Math.max(1,Math.floor(1/gt))),ue&&wt&&ne<=ge.stableFitRemainingWidth&&(ut=ge.stableFitMaxMinimapScale),Xe=Math.min(ut,Math.max(1,Math.floor(Je/Ee))),Xe>yt&&(Ue=Math.min(2,Xe/yt)),rt=Xe/lt/Ue,we=Math.ceil(Math.max(nt,Ie+Qe)*Je),ue?(ge.stableMinimapLayoutInput=te,ge.stableFitRemainingWidth=ne,ge.stableFitMaxMinimapScale=Xe):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const pe=Math.floor(ze*rt),be=Math.min(pe,Math.max(0,Math.floor((ne-ye-2)*rt/(ce+rt)))+e.MINIMAP_GUTTER_WIDTH);let ie=Math.floor(lt*be);const K=ie/lt;ie=Math.floor(ie*Ue);const Se=xe?1:2,Le=Ae==="left"?0:je-be-ye;return{renderMinimap:Se,minimapLeft:Le,minimapWidth:be,minimapHeightIsEditorHeight:Ke,minimapIsSampling:Ve,minimapScale:Xe,minimapLineHeight:Je,minimapCanvasInnerWidth:ie,minimapCanvasInnerHeight:we,minimapCanvasOuterWidth:K,minimapCanvasOuterHeight:Fe}}static computeLayout(te,ge){const je=ge.outerWidth|0,tt=ge.outerHeight|0,lt=ge.lineHeight|0,ft=ge.lineNumbersDigitCount|0,wt=ge.typicalHalfwidthCharacterWidth,Ct=ge.maxDigitWidth,ce=ge.pixelRatio,Pe=ge.viewLineCount,xe=te.get(122),Xe=xe==="inherit"?te.get(121):xe,ze=Xe==="inherit"?te.get(117):Xe,ot=te.get(120),Ae=te.get(2),ye=ge.isDominatedByLongLines,Ie=te.get(48),ne=te.get(59).renderType!==0,ue=te.get(60),Ee=te.get(94),we=te.get(64),Fe=te.get(92),Ke=Fe.verticalScrollbarSize,Ve=Fe.verticalHasArrows,Je=Fe.arrowSize,rt=Fe.horizontalScrollbarSize,Ue=te.get(57),pe=te.get(36);let be;if(typeof Ue=="string"&&/^\d+(\.\d+)?ch$/.test(Ue)){const $t=parseFloat(Ue.substr(0,Ue.length-2));be=p.clampedInt($t*wt,0,0,1e3)}else be=p.clampedInt(Ue,0,0,1e3);pe&&(be+=16);let ie=0;if(ne){const $t=Math.max(ft,ue);ie=Math.round($t*Ct)}let K=0;Ie&&(K=lt);let Se=0,Le=Se+K,nt=Le+ie,Qe=nt+be;const gt=je-K-ie-be;let bt=!1,ht=!1,pt=-1;Ae!==2&&(Xe==="inherit"&&ye?(bt=!0,ht=!0):ze==="on"||ze==="bounded"?ht=!0:ze==="wordWrapColumn"&&(pt=ot));const ut=z._computeMinimapLayout({outerWidth:je,outerHeight:tt,lineHeight:lt,typicalHalfwidthCharacterWidth:wt,pixelRatio:ce,scrollBeyondLastLine:Ee,minimap:we,verticalScrollbarWidth:Ke,viewLineCount:Pe,remainingWidth:gt,isViewportWrapping:ht},ge.memory||new y);ut.renderMinimap!==0&&ut.minimapLeft===0&&(Se+=ut.minimapWidth,Le+=ut.minimapWidth,nt+=ut.minimapWidth,Qe+=ut.minimapWidth);const yt=gt-ut.minimapWidth,Dt=Math.max(1,Math.floor((yt-Ke-2)/wt)),xt=Ve?Je:0;return ht&&(pt=Math.max(1,Dt),ze==="bounded"&&(pt=Math.min(pt,ot))),{width:je,height:tt,glyphMarginLeft:Se,glyphMarginWidth:K,lineNumbersLeft:Le,lineNumbersWidth:ie,decorationsLeft:nt,decorationsWidth:be,contentLeft:Qe,contentWidth:yt,minimap:ut,viewportColumn:Dt,isWordWrapMinified:bt,isViewportWrapping:ht,wrappingColumn:pt,verticalScrollbarWidth:Ke,horizontalScrollbarHeight:rt,overviewRuler:{top:xt,width:Ke,height:tt-2*xt,right:0}}}}e.EditorLayoutInfoComputer=z;class O extends T{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:g.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class N extends T{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:g.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{enabled:c(ge.enabled,this.defaultValue.enabled),fontSize:p.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:R.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class x extends D{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>D.clamp(te,0,150),{markdownDescription:g.localize(46,null)})}compute(te,ge,je){return te.fontInfo.lineHeight}}class B extends T{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:te.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:g.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{enabled:c(ge.enabled,this.defaultValue.enabled),size:E(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(ge.side,this.defaultValue.side,["right","left"]),showSlider:E(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ge.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(ge.scale,1,1,3),maxColumn:p.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class $ extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{top:p.clampedInt(ge.top,0,0,1e3),bottom:p.clampedInt(ge.bottom,0,0,1e3)}}}class Y extends T{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:g.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{enabled:c(ge.enabled,this.defaultValue.enabled),cycle:c(ge.cycle,this.defaultValue.cycle)}}}class Q extends n{constructor(){super(128)}compute(te,ge,je){return te.pixelRatio}}class de extends T{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:g.localize(61,null)},comments:{type:"boolean",default:te.comments,description:g.localize(62,null)},other:{type:"boolean",default:te.other,description:g.localize(63,null)}}}],default:te,description:g.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ge=te,je={other:c(ge.other,this.defaultValue.other),comments:c(ge.comments,this.defaultValue.comments),strings:c(ge.strings,this.defaultValue.strings)};return je.other&&je.comments&&je.strings?!0:!je.other&&!je.comments&&!je.strings?!1:je}return this.defaultValue}}var _e;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(te){let ge=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ge=4,je=te):te==="interval"?ge=3:te==="relative"?ge=2:te==="on"?ge=1:ge=0),{renderType:ge,renderFn:je}}}function Te(X){const te=X.get(87);return te==="editable"?X.get(80):te!=="on"}e.filterValidationDecorations=Te;class $e extends T{constructor(){const te=[],ge={type:"number",description:g.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:te,description:g.localize(72,null)})}validate(te){if(Array.isArray(te)){let ge=[];for(let je of te)if(typeof je=="number")ge.push({column:p.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const tt=je;ge.push({column:p.clampedInt(tt.column,0,0,1e4),color:tt.color})}return ge.sort((je,tt)=>je.column-tt.column),ge}return this.defaultValue}}function Be(X,te){if(typeof X!="string")return te;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends T{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:g.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te,je=p.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=p.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Be(ge.vertical,this.defaultValue.vertical),horizontal:Be(ge.horizontal,this.defaultValue.horizontal),useShadows:c(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:p.clampedInt(ge.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:p.clampedInt(ge.verticalSliderSize,tt,0,1e3),scrollByPage:c(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class j extends T{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:g.localize(84,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{enabled:c(ge.enabled,this.defaultValue.enabled),mode:E(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends T{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:g.localize(85,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class se extends T{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(86,null),g.localize(87,null)],default:te.insertMode,description:g.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:g.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:g.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:g.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:g.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:g.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:g.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:g.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:g.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ge=te;return{insertMode:E(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(ge.showIcons,this.defaultValue.showIcons),showStatusBar:c(ge.showStatusBar,this.defaultValue.showStatusBar),preview:c(ge.preview,this.defaultValue.preview),previewMode:E(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ge.showMethods,this.defaultValue.showMethods),showFunctions:c(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:c(ge.showFields,this.defaultValue.showFields),showVariables:c(ge.showVariables,this.defaultValue.showVariables),showClasses:c(ge.showClasses,this.defaultValue.showClasses),showStructs:c(ge.showStructs,this.defaultValue.showStructs),showInterfaces:c(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ge.showModules,this.defaultValue.showModules),showProperties:c(ge.showProperties,this.defaultValue.showProperties),showEvents:c(ge.showEvents,this.defaultValue.showEvents),showOperators:c(ge.showOperators,this.defaultValue.showOperators),showUnits:c(ge.showUnits,this.defaultValue.showUnits),showValues:c(ge.showValues,this.defaultValue.showValues),showConstants:c(ge.showConstants,this.defaultValue.showConstants),showEnums:c(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ge.showKeywords,this.defaultValue.showKeywords),showWords:c(ge.showWords,this.defaultValue.showWords),showColors:c(ge.showColors,this.defaultValue.showColors),showFiles:c(ge.showFiles,this.defaultValue.showFiles),showReferences:c(ge.showReferences,this.defaultValue.showReferences),showFolders:c(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ge.showSnippets,this.defaultValue.showSnippets),showUsers:c(ge.showUsers,this.defaultValue.showUsers),showIssues:c(ge.showIssues,this.defaultValue.showIssues)}}}class le extends T{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(128,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Z extends n{constructor(){super(129,[80])}compute(te,ge,je){return ge.get(80)?!0:te.tabFocusMode}}var ae;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function ve(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Me extends n{constructor(){super(131,[130])}compute(te,ge,je){const tt=ge.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const qe="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Ye:L.isLinux?Ze:qe,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ke(X){return e.editorOptionsRegistry[X.id]=X,X}var at;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.codeLens=13]="codeLens",X[X.codeLensFontFamily=14]="codeLensFontFamily",X[X.codeLensFontSize=15]="codeLensFontSize",X[X.colorDecorators=16]="colorDecorators",X[X.columnSelection=17]="columnSelection",X[X.comments=18]="comments",X[X.contextmenu=19]="contextmenu",X[X.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",X[X.cursorBlinking=21]="cursorBlinking",X[X.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",X[X.cursorStyle=23]="cursorStyle",X[X.cursorSurroundingLines=24]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",X[X.cursorWidth=26]="cursorWidth",X[X.disableLayerHinting=27]="disableLayerHinting",X[X.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",X[X.domReadOnly=29]="domReadOnly",X[X.dragAndDrop=30]="dragAndDrop",X[X.emptySelectionClipboard=31]="emptySelectionClipboard",X[X.extraEditorClassName=32]="extraEditorClassName",X[X.fastScrollSensitivity=33]="fastScrollSensitivity",X[X.find=34]="find",X[X.fixedOverflowWidgets=35]="fixedOverflowWidgets",X[X.folding=36]="folding",X[X.foldingStrategy=37]="foldingStrategy",X[X.foldingHighlight=38]="foldingHighlight",X[X.foldingImportsByDefault=39]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=41]="fontFamily",X[X.fontInfo=42]="fontInfo",X[X.fontLigatures=43]="fontLigatures",X[X.fontSize=44]="fontSize",X[X.fontWeight=45]="fontWeight",X[X.formatOnPaste=46]="formatOnPaste",X[X.formatOnType=47]="formatOnType",X[X.glyphMargin=48]="glyphMargin",X[X.gotoLocation=49]="gotoLocation",X[X.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",X[X.hover=52]="hover",X[X.inDiffEditor=53]="inDiffEditor",X[X.inlineSuggest=54]="inlineSuggest",X[X.letterSpacing=55]="letterSpacing",X[X.lightbulb=56]="lightbulb",X[X.lineDecorationsWidth=57]="lineDecorationsWidth",X[X.lineHeight=58]="lineHeight",X[X.lineNumbers=59]="lineNumbers",X[X.lineNumbersMinChars=60]="lineNumbersMinChars",X[X.linkedEditing=61]="linkedEditing",X[X.links=62]="links",X[X.matchBrackets=63]="matchBrackets",X[X.minimap=64]="minimap",X[X.mouseStyle=65]="mouseStyle",X[X.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=67]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",X[X.multiCursorModifier=69]="multiCursorModifier",X[X.multiCursorPaste=70]="multiCursorPaste",X[X.occurrencesHighlight=71]="occurrencesHighlight",X[X.overviewRulerBorder=72]="overviewRulerBorder",X[X.overviewRulerLanes=73]="overviewRulerLanes",X[X.padding=74]="padding",X[X.parameterHints=75]="parameterHints",X[X.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",X[X.quickSuggestions=78]="quickSuggestions",X[X.quickSuggestionsDelay=79]="quickSuggestionsDelay",X[X.readOnly=80]="readOnly",X[X.renameOnType=81]="renameOnType",X[X.renderControlCharacters=82]="renderControlCharacters",X[X.renderIndentGuides=83]="renderIndentGuides",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unusualLineTerminators=113]="unusualLineTerminators",X[X.useShadowDOM=114]="useShadowDOM",X[X.useTabStops=115]="useTabStops",X[X.wordSeparators=116]="wordSeparators",X[X.wordWrap=117]="wordWrap",X[X.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=120]="wordWrapColumn",X[X.wordWrapOverride1=121]="wordWrapOverride1",X[X.wordWrapOverride2=122]="wordWrapOverride2",X[X.wrappingIndent=123]="wrappingIndent",X[X.wrappingStrategy=124]="wrappingStrategy",X[X.showDeprecated=125]="showDeprecated",X[X.inlayHints=126]="inlayHints",X[X.editorClassName=127]="editorClassName",X[X.pixelRatio=128]="pixelRatio",X[X.tabFocusMode=129]="tabFocusMode",X[X.layoutInfo=130]="layoutInfo",X[X.wrappingInfo=131]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(129,null)})),acceptSuggestionOnEnter:ke(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(130,null),""],markdownDescription:g.localize(131,null)})),accessibilitySupport:ke(new t),accessibilityPageSize:ke(new p(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(132,null)})),ariaLabel:ke(new R(4,"ariaLabel",g.localize(133,null))),autoClosingBrackets:ke(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(134,null),g.localize(135,null),""],description:g.localize(136,null)})),autoClosingDelete:ke(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(137,null),""],description:g.localize(138,null)})),autoClosingOvertype:ke(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(139,null),""],description:g.localize(140,null)})),autoClosingQuotes:ke(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(141,null),g.localize(142,null),""],description:g.localize(143,null)})),autoIndent:ke(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[g.localize(144,null),g.localize(145,null),g.localize(146,null),g.localize(147,null),g.localize(148,null)],description:g.localize(149,null)})),automaticLayout:ke(new f(10,"automaticLayout",!1)),autoSurround:ke(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(150,null),g.localize(151,null),g.localize(152,null),""],description:g.localize(153,null)})),bracketPairColorization:ke(new ee),stickyTabStops:ke(new f(104,"stickyTabStops",!1,{description:g.localize(154,null)})),codeLens:ke(new f(13,"codeLens",!0,{description:g.localize(155,null)})),codeLensFontFamily:ke(new R(14,"codeLensFontFamily","",{description:g.localize(156,null)})),codeLensFontSize:ke(new p(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(157,null)})),colorDecorators:ke(new f(16,"colorDecorators",!0,{description:g.localize(158,null)})),columnSelection:ke(new f(17,"columnSelection",!1,{description:g.localize(159,null)})),comments:ke(new u),contextmenu:ke(new f(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new f(20,"copyWithSyntaxHighlighting",!0,{description:g.localize(160,null)})),cursorBlinking:ke(new o(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:g.localize(161,null)})),cursorSmoothCaretAnimation:ke(new f(22,"cursorSmoothCaretAnimation",!1,{description:g.localize(162,null)})),cursorStyle:ke(new o(23,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:g.localize(163,null)})),cursorSurroundingLines:ke(new p(24,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(164,null)})),cursorSurroundingLinesStyle:ke(new a(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(165,null),g.localize(166,null)],description:g.localize(167,null)})),cursorWidth:ke(new p(26,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(168,null)})),disableLayerHinting:ke(new f(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new f(28,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new f(29,"domReadOnly",!1)),dragAndDrop:ke(new f(30,"dragAndDrop",!0,{description:g.localize(169,null)})),emptySelectionClipboard:ke(new _),extraEditorClassName:ke(new R(32,"extraEditorClassName","")),fastScrollSensitivity:ke(new D(33,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(170,null)})),find:ke(new v),fixedOverflowWidgets:ke(new f(35,"fixedOverflowWidgets",!1)),folding:ke(new f(36,"folding",!0,{description:g.localize(171,null)})),foldingStrategy:ke(new a(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(172,null),g.localize(173,null)],description:g.localize(174,null)})),foldingHighlight:ke(new f(38,"foldingHighlight",!0,{description:g.localize(175,null)})),foldingImportsByDefault:ke(new f(39,"foldingImportsByDefault",!1,{description:g.localize(176,null)})),unfoldOnClickAfterEndOfLine:ke(new f(40,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(177,null)})),fontFamily:ke(new R(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(178,null)})),fontInfo:ke(new b),fontLigatures2:ke(new P),fontSize:ke(new F),fontWeight:ke(new M),formatOnPaste:ke(new f(46,"formatOnPaste",!1,{description:g.localize(179,null)})),formatOnType:ke(new f(47,"formatOnType",!1,{description:g.localize(180,null)})),glyphMargin:ke(new f(48,"glyphMargin",!0,{description:g.localize(181,null)})),gotoLocation:ke(new q),hideCursorInOverviewRuler:ke(new f(50,"hideCursorInOverviewRuler",!1,{description:g.localize(182,null)})),highlightActiveIndentGuide:ke(new f(51,"highlightActiveIndentGuide",!0,{description:g.localize(183,null)})),hover:ke(new G),inDiffEditor:ke(new f(53,"inDiffEditor",!1)),letterSpacing:ke(new D(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>D.clamp(X,-5,20),{description:g.localize(184,null)})),lightbulb:ke(new O),lineDecorationsWidth:ke(new I(57,"lineDecorationsWidth",10)),lineHeight:ke(new x),lineNumbers:ke(new Ce),lineNumbersMinChars:ke(new p(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new f(61,"linkedEditing",!1,{description:g.localize(185,null)})),links:ke(new f(62,"links",!0,{description:g.localize(186,null)})),matchBrackets:ke(new a(63,"matchBrackets","always",["always","near","never"],{description:g.localize(187,null)})),minimap:ke(new B),mouseStyle:ke(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new D(66,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(188,null)})),mouseWheelZoom:ke(new f(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(189,null)})),multiCursorMergeOverlapping:ke(new f(68,"multiCursorMergeOverlapping",!0,{description:g.localize(190,null)})),multiCursorModifier:ke(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[g.localize(191,null),g.localize(192,null)],markdownDescription:g.localize(193,null)})),multiCursorPaste:ke(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(194,null),g.localize(195,null)],markdownDescription:g.localize(196,null)})),occurrencesHighlight:ke(new f(71,"occurrencesHighlight",!0,{description:g.localize(197,null)})),overviewRulerBorder:ke(new f(72,"overviewRulerBorder",!0,{description:g.localize(198,null)})),overviewRulerLanes:ke(new p(73,"overviewRulerLanes",3,0,3)),padding:ke(new $),parameterHints:ke(new Y),peekWidgetDefaultFocus:ke(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(199,null),g.localize(200,null)],description:g.localize(201,null)})),definitionLinkOpensInPeek:ke(new f(77,"definitionLinkOpensInPeek",!1,{description:g.localize(202,null)})),quickSuggestions:ke(new de),quickSuggestionsDelay:ke(new p(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(203,null)})),readOnly:ke(new f(80,"readOnly",!1)),renameOnType:ke(new f(81,"renameOnType",!1,{description:g.localize(204,null),markdownDeprecationMessage:g.localize(205,null)})),renderControlCharacters:ke(new f(82,"renderControlCharacters",!1,{description:g.localize(206,null)})),renderIndentGuides:ke(new f(83,"renderIndentGuides",!0,{description:g.localize(207,null)})),renderFinalNewline:ke(new f(84,"renderFinalNewline",!0,{description:g.localize(208,null)})),renderLineHighlight:ke(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(209,null)],description:g.localize(210,null)})),renderLineHighlightOnlyWhenFocus:ke(new f(86,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(211,null)})),renderValidationDecorations:ke(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(212,null),g.localize(213,null),g.localize(214,null),""],description:g.localize(215,null)})),revealHorizontalRightPadding:ke(new p(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new f(90,"roundedSelection",!0,{description:g.localize(216,null)})),rulers:ke(new $e),scrollbar:ke(new He),scrollBeyondLastColumn:ke(new p(93,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(217,null)})),scrollBeyondLastLine:ke(new f(94,"scrollBeyondLastLine",!0,{description:g.localize(218,null)})),scrollPredominantAxis:ke(new f(95,"scrollPredominantAxis",!0,{description:g.localize(219,null)})),selectionClipboard:ke(new f(96,"selectionClipboard",!0,{description:g.localize(220,null),included:L.isLinux})),selectionHighlight:ke(new f(97,"selectionHighlight",!0,{description:g.localize(221,null)})),selectOnLineNumbers:ke(new f(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(222,null),g.localize(223,null)],description:g.localize(224,null)})),showUnused:ke(new f(100,"showUnused",!0,{description:g.localize(225,null)})),showDeprecated:ke(new f(125,"showDeprecated",!0,{description:g.localize(226,null)})),inlayHints:ke(new N),snippetSuggestions:ke(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(227,null),g.localize(228,null),g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),smartSelect:ke(new le),smoothScrolling:ke(new f(103,"smoothScrolling",!1,{description:g.localize(232,null)})),stopRenderingLineAfter:ke(new p(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new se),inlineSuggest:ke(new j),suggestFontSize:ke(new p(107,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(233,null)})),suggestLineHeight:ke(new p(108,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(234,null)})),suggestOnTriggerCharacters:ke(new f(109,"suggestOnTriggerCharacters",!0,{description:g.localize(235,null)})),suggestSelection:ke(new a(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),tabCompletion:ke(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null)],description:g.localize(243,null)})),tabIndex:ke(new p(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),useShadowDOM:ke(new f(114,"useShadowDOM",!0)),useTabStops:ke(new f(115,"useTabStops",!0,{description:g.localize(248,null)})),wordSeparators:ke(new R(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(249,null)})),wordWrap:ke(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),wordWrapBreakAfterCharacters:ke(new R(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new R(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new p(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(255,null)})),wordWrapOverride1:ke(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[g.localize(256,null),g.localize(257,null),g.localize(258,null),g.localize(259,null)],description:g.localize(260,null)})),wrappingStrategy:ke(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),editorClassName:ke(new w),pixelRatio:ke(new Q),tabFocusMode:ke(new Z),layoutInfo:ke(new z),wrappingInfo:ke(new Me)}}),define(fe[156],me([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(fe[173],me([19,20]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(fe[174],me([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[175],me([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[176],me([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[177],me([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[178],me([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[179],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[180],me([0,1,158]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=C;function A(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=c.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function S(c){if(!c)return null;let f=c.majorBase,d=c.majorMustEqual,p=c.minorBase,D=c.minorMustEqual,R=c.patchBase,E=c.patchMustEqual;c.hasCaret&&(f===0||(D=!1),E=!1);let a=0;if(c.preRelease){const o=k.exec(c.preRelease);if(o){const[,m,t,u]=o;a=Date.UTC(Number(m),Number(t)-1,Number(u))}}return{majorBase:f,majorMustEqual:d,minorBase:p,minorMustEqual:D,patchBase:R,patchMustEqual:E,isMinimum:c.hasGreaterEquals,notBefore:a}}e.normalizeVersion=S;function y(c,f,d){let p;typeof c=="string"?p=S(A(c)):p=c;let D;f instanceof Date?D=f.getTime():typeof f=="string"&&(D=new Date(f).getTime());let R;if(typeof d=="string"?R=S(A(d)):R=d,!p||!R)return!1;let E=p.majorBase,a=p.minorBase,o=p.patchBase,m=R.majorBase,t=R.minorBase,u=R.patchBase,r=R.notBefore,i=R.majorMustEqual,s=R.minorMustEqual,l=R.patchMustEqual;return R.isMinimum?E>m?!0:E<m?!1:a>t?!0:a<t||D&&D<r?!1:o>=u:(E===1&&m===0&&(!i||!s||!l)&&(m=1,t=0,u=0,i=!0,s=!1,l=!1),E<m?!1:E>m?!i:a<t?!1:a>t?!s:o<u?!1:o>u?!l:!(D&&D<r))}e.isValidVersion=y;function T(c,f,d,p){return d.isBuiltin||typeof d.main=="undefined"?!0:I(c,f,d.engines.vscode,p)}e.isValidExtensionVersion=T;function n(c,f,d){return c==="*"||I(f,d,c)}e.isEngineValid=n;function I(c,f,d,p=[]){let D=S(A(d));if(!D)return p.push(g.localize(0,null,d)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return p.push(g.localize(1,null,d)),!1}else if(!D.majorMustEqual)return p.push(g.localize(2,null,d)),!1;return y(c,f,D)?!0:(p.push(g.localize(3,null,c,d)),!1)}}),define(fe[115],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,C=[],A=!1){this.ctor=k,this.staticArguments=C,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=g}),define(fe[82],me([0,1,115]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(A,S,y){S instanceof g.SyncDescriptor||(S=new g.SyncDescriptor(S,[],y)),L.push([A,S])}e.registerSingleton=k;function C(){return L}e.getSingletonServiceDescriptors=C}),define(fe[181],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let A of this._nodes.values())A.outgoing.size===0&&C.push(A);return C}insertEdge(C,A){const S=this.lookupOrInsertNode(C),y=this.lookupOrInsertNode(A);S.outgoing.set(this._hashFn(A),y),y.incoming.set(this._hashFn(C),S)}removeNode(C){const A=this._hashFn(C);this._nodes.delete(A);for(let S of this._nodes.values())S.outgoing.delete(A),S.incoming.delete(A)}lookupOrInsertNode(C){const A=this._hashFn(C);let S=this._nodes.get(A);return S||(S=new g(C),this._nodes.set(A,S)),S}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[A,S]of this._nodes)C.push(`${A}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,A]of this._nodes){const S=new Set([C]),y=this._findCycle(A,S);if(y)return y}}_findCycle(C,A){for(let[S,y]of C.outgoing){if(A.has(S))return[...A,S].join(" -> ");A.add(S);const T=this._findCycle(y,A);if(T)return T;A.delete(S)}}}e.Graph=L}),define(fe[4],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function y(T){return T[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=y})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(S,y,T,n){y[g.DI_TARGET]===y?y[g.DI_DEPENDENCIES].push({id:S,index:T,optional:n}):(y[g.DI_DEPENDENCIES]=[{id:S,index:T,optional:n}],y[g.DI_TARGET]=y)}function k(S){if(g.serviceIds.has(S))return g.serviceIds.get(S);const y=function(T,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,T,I,!1)};return y.toString=()=>S,g.serviceIds.set(S,y),y}e.createDecorator=k;function C(S){return S}e.refineServiceDecorator=C;function A(S){return function(y,T,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(S,y,n,!0)}}e.optional=A}),define(fe[182],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[183],me([0,1,3,48,6,24,77,81,182]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(T):!!p.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(D,R){let E={selector:D,provider:R,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(E){let a=this._entries.indexOf(E);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const R=[];for(let E of this._entries)E._score>0&&R.push(E.provider);return R}ordered(D){const R=[];return this._orderedForEach(D,E=>R.push(E.provider)),R}orderedGroups(D){const R=[];let E,a;return this._orderedForEach(D,o=>{E&&a===o._score?E.push(o.provider):(a=o._score,E=[o.provider],R.push(E))}),R}_orderedForEach(D,R){if(!!D){this._updateScores(D);for(const E of this._entries)E._score>0&&R(E)}}_updateScores(D){let R={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let E of this._entries)if(E._score=(0,S.score)(E.selector,D.uri,D.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(D)),T(E.selector)&&E._score>0){for(let a of this._entries)a._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(D,R){return D._score<R._score?1:D._score>R._score?-1:D._time<R._time?1:D._time>R._time?-1:0}}e.LanguageFeatureRegistry=n;const I=new WeakMap;let c=0;function f(p){let D=I.get(p);return D===void 0&&(D=++c,I.set(p,D)),D}class d{constructor(D,R,E=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=R,this.max=E,this._cache=new C.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((R,E)=>(0,L.doHash)(f(E),R),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const R=this._key(D),E=this._cache.get(R);return this._clamp(E?.value)}update(D,R){const E=this._key(D);let a=this._cache.get(E);return a||(a=new A.MovingAverage,this._cache.set(E,a)),a.update(R),this.get(D)}}e.LanguageFeatureRequestDelays=d}),define(fe[83],me([0,1,2,42,183,149,47]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class y{constructor(P,b){this.language=P,this.id=b}}e.LanguageIdentifier=y;var T;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var n;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let b=this.getForeground(P),F="mtk"+b,M=this.getFontStyle(P);return M&1&&(F+=" mtki"),M&2&&(F+=" mtkb"),M&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(P,b){const F=this.getForeground(P),M=this.getFontStyle(P);let q=`color: ${b[F]};`;return M&1&&(q+="font-style: italic;"),M&2&&(q+="font-weight: bold;"),M&4&&(q+="text-decoration: underline;"),q}}e.TokenMetadata=f;var d;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(P){const b=v[P];let F=b&&A.iconRegistry.get(b);return F||(console.info("No codicon found for CompletionItemKind "+P),F=A.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(P,b){let F=v[P];return typeof F=="undefined"&&!b&&(F=9),F}}();var p;(function(v){v[v.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var R;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(v){return v&&g.URI.isUri(v.uri)&&L.Range.isIRange(v.range)&&(L.Range.isIRange(v.originSelectionRange)||L.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=t;var u;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var r;(function(v){v[v.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(v){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const b=new Map;b.set(0,"file"),b.set(1,"module"),b.set(2,"namespace"),b.set(3,"package"),b.set(4,"class"),b.set(5,"method"),b.set(6,"property"),b.set(7,"field"),b.set(8,"constructor"),b.set(9,"enum"),b.set(10,"interface"),b.set(11,"function"),b.set(12,"variable"),b.set(13,"constant"),b.set(14,"string"),b.set(15,"number"),b.set(16,"boolean"),b.set(17,"array"),b.set(18,"object"),b.set(19,"key"),b.set(20,"null"),b.set(21,"enum-member"),b.set(22,"struct"),b.set(23,"event"),b.set(24,"operator"),b.set(25,"type-parameter");function F(G){return P.get(G)}v.fromString=F;function M(G){return b.get(G)}v.toString=M;function q(G,U){const z=b.get(G);let O=z&&A.iconRegistry.get("symbol-"+z);return O||(console.info("No codicon found for SymbolKind "+G),O=A.Codicon.symbolProperty),`${U?"inline":"block"} ${O.classNames}`}v.toCssClassName=q})(i=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(P){this.value=P}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var l;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var w;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var _;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",g.isMacintosh),A.set("isLinux",g.isLinux),A.set("isWindows",g.isWindows),A.set("isWeb",g.isWeb),A.set("isMacNative",g.isMacintosh&&!g.isWeb),A.set("isEdge",C.indexOf("Edg/")>=0),A.set("isFirefox",C.indexOf("Firefox")>=0),A.set("isChrome",C.indexOf("Chrome")>=0),A.set("isSafari",C.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True",P[P.Defined=2]="Defined",P[P.Not=3]="Not",P[P.Equals=4]="Equals",P[P.NotEquals=5]="NotEquals",P[P.And=6]="And",P[P.Regex=7]="Regex",P[P.NotRegex=8]="NotRegex",P[P.Or=9]="Or",P[P.In=10]="In",P[P.NotIn=11]="NotIn",P[P.Greater=12]="Greater",P[P.GreaterEquals=13]="GreaterEquals",P[P.Smaller=14]="Smaller",P[P.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return I.INSTANCE}static true(){return c.INSTANCE}static has(b){return f.create(b)}static equals(b,F){return d.create(b,F)}static notEquals(b,F){return R.create(b,F)}static regex(b,F){return u.create(b,F)}static in(b,F){return p.create(b,F)}static not(b){return E.create(b)}static and(...b){return i.create(b,null)}static or(...b){return s.create(b,null,!0)}static greater(b,F){return a.create(b,F)}static less(b,F){return m.create(b,F)}static deserialize(b,F=!1){if(!!b)return this._deserializeOrExpression(b,F)}static _deserializeOrExpression(b,F){let M=b.split("||");return s.create(M.map(q=>this._deserializeAndExpression(q,F)),null,!0)}static _deserializeAndExpression(b,F){let M=b.split("&&");return i.create(M.map(q=>this._deserializeOne(q,F)),null)}static _deserializeOne(b,F){if(b=b.trim(),b.indexOf("!=")>=0){let M=b.split("!=");return R.create(M[0].trim(),this._deserializeValue(M[1],F))}if(b.indexOf("==")>=0){let M=b.split("==");return d.create(M[0].trim(),this._deserializeValue(M[1],F))}if(b.indexOf("=~")>=0){let M=b.split("=~");return u.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(b.indexOf(" in ")>=0){let M=b.split(" in ");return p.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const M=b.split(">=");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const M=b.split(">");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const M=b.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const M=b.split("<");return m.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(b)?E.create(b.substr(1).trim()):f.create(b)}static _deserializeValue(b,F){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let M=/^'([^']*)'$/.exec(b);return M?M[1].trim():b}static _deserializeRegexValue(b,F){if((0,L.isFalsyOrWhitespace)(b)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=b.indexOf("/"),q=b.lastIndexOf("/");if(M===q||M<0){if(F)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let G=b.slice(M+1,q),U=b[q+1]==="i"?"i":"";try{return new RegExp(G,U)}catch(z){if(F)throw new Error(`bad regexp-value '${b}', parse error: ${z}`);return console.warn(`bad regexp-value '${b}', parse error: ${z}`),null}}}e.ContextKeyExpr=T;function n(P,b){return P.cmp(b)}class I{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class c{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class f{constructor(b,F){this.key=b,this.negated=F,this.type=2}static create(b,F=null){const M=A.get(b);return typeof M=="boolean"?M?c.INSTANCE:I.INSTANCE:new f(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:h(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class d{constructor(b,F,M){this.key=b,this.value=F,this.negated=M,this.type=4}static create(b,F,M=null){if(typeof F=="boolean")return F?f.create(b,M):E.create(b,M);const q=A.get(b);return typeof q=="boolean"?F===(q?"true":"false")?c.INSTANCE:I.INSTANCE:new d(b,F,M)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class p{constructor(b,F){this.key=b,this.valueKey=F,this.type=10,this.negated=null}static create(b,F){return new p(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const F=b.getValue(this.valueKey),M=b.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?S.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=p;class D{constructor(b){this._actual=b,this.type=11}static create(b){return new D(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new D(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class R{constructor(b,F,M){this.key=b,this.value=F,this.negated=M,this.type=5}static create(b,F,M=null){if(typeof F=="boolean")return F?E.create(b,M):f.create(b,M);const q=A.get(b);return typeof q=="boolean"?F===(q?"true":"false")?I.INSTANCE:c.INSTANCE:new R(b,F,M)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class E{constructor(b,F){this.key=b,this.negated=F,this.type=3}static create(b,F=null){const M=A.get(b);return typeof M=="boolean"?M?I.INSTANCE:c.INSTANCE:new E(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:h(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class a{constructor(b,F,M){this.key=b,this.value=F,this.negated=M,this.type=12}static create(b,F,M=null){return new a(b,F,M)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class o{constructor(b,F,M){this.key=b,this.value=F,this.negated=M,this.type=13}static create(b,F,M=null){return new o(b,F,M)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class m{constructor(b,F,M){this.key=b,this.value=F,this.negated=M,this.type=14}static create(b,F,M=null){return new m(b,F,M)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=m;class t{constructor(b,F,M){this.key=b,this.value=F,this.negated=M,this.type=15}static create(b,F,M=null){return new t(b,F,M)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class u{constructor(b,F){this.key=b,this.regexp=F,this.type=7,this.negated=null}static create(b,F){return new u(b,F)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const F=this.regexp?this.regexp.source:"",M=b.regexp?b.regexp.source:"";return F<M?-1:F>M?1:0}equals(b){if(b.type===this.type){const F=this.regexp?this.regexp.source:"",M=b.regexp?b.regexp.source:"";return this.key===b.key&&F===M}return!1}evaluate(b){let F=b.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=u;class r{constructor(b){this._actual=b,this.type=8}static create(b){return new r(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new r(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(b,F){this.expr=b,this.negated=F,this.type=6}static create(b,F){return i._normalizeArr(b,F)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const q=n(this.expr[F],b.expr[F]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}evaluate(b){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(b))return!1;return!0}static _normalizeArr(b,F){const M=[];let q=!1;for(const G of b)if(!!G){if(G.type===1){q=!0;continue}if(G.type===0)return I.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&q)return c.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const U=M.pop(),z=M.length===0,O=s.create(G.expr.map(N=>i.create([N,U],null)),null,z);O&&(M.push(O),M.sort(n))}return M.length===1?M[0]:new i(M,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let F of this.expr)b.push(...F.keys());return b}map(b){return new i(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.negated){const b=[];for(let F of this.expr)b.push(F.negate());this.negated=s.create(b,this,!0)}return this.negated}}class s{constructor(b,F){this.expr=b,this.negated=F,this.type=9}static create(b,F,M){return s._normalizeArr(b,F,M)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const q=n(this.expr[F],b.expr[F]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}evaluate(b){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(b))return!0;return!1}static _normalizeArr(b,F,M){let q=[],G=!1;if(b){for(let U=0,z=b.length;U<z;U++){const O=b[U];if(!!O){if(O.type===0){G=!0;continue}if(O.type===1)return c.INSTANCE;if(O.type===9){q=q.concat(O.expr);continue}q.push(O)}}if(q.length===0&&G)return I.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let U=1;U<q.length;U++)q[U-1].equals(q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0];if(M){for(let U=0;U<q.length;U++)for(let z=U+1;z<q.length;z++)_(q[U],q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0]}return new s(q,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let F of this.expr)b.push(...F.keys());return b}map(b){return new s(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.negated){let b=[];for(let F of this.expr)b.push(F.negate());for(;b.length>1;){const F=b.shift(),M=b.shift(),q=[];for(const U of v(F))for(const z of v(M))q.push(i.create([U,z],null));const G=b.length===0;b.unshift(s.create(q,null,G))}this.negated=b[0]}return this.negated}}class l extends f{constructor(b,F,M){super(b,null);this._defaultValue=F,typeof M=="object"?l._info.push({...M,key:b}):M!==!0&&l._info.push({key:b,description:M,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return d.create(this.key,b)}notEqualsTo(b){return R.create(this.key,b)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(P,b){return P<b?-1:P>b?1:0}function w(P,b,F,M){return P<F?-1:P>F?1:b<M?-1:b>M?1:0}function _(P,b){if(b.type===6&&P.type!==9&&P.type!==6){for(const q of b.expr)if(P.equals(q))return!0}const F=P.negate(),M=v(F).concat(v(b));M.sort(n);for(let q=0;q<M.length;q++){const U=M[q].negate();for(let z=q+1;z<M.length;z++){const O=M[z];if(U.equals(O))return!0}}return!1}e.implies=_;function v(P){return P.type===9?P.expr:[P]}}),define(fe[184],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[185],me([0,1,10,157,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function A(E){switch(E){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function S(E){switch(E){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=S;function y(E,a){switch(E){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function T(E,a){return a==="web"&&!E.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function n(E,a,o){return T(a,o)?!1:E==="undefined"||E==="universal"?!0:E==="unknown"?!1:E===o?!0:I(o).includes(E)}e.isTargetPlatformCompatible=n;function I(E){switch(E){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function c(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=c;var f;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=10]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(f=e.SortBy||(e.SortBy={}));var d;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var p;(function(E){E.Install="install",E.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var D;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(a,o){super(a);this.code=o,this.name=o}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(fe[26],me([0,1,9,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=k;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class S{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,c){if(typeof I=="undefined"||I===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof I=="string"||typeof c=="string"){let f=typeof I=="string"?I:I.value,d=typeof c=="string"?c:c.value;return g.equalsIgnoreCase(f,d)}return I._lower===c._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=S;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function T(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[186],me([0,1,9,26]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,p){return d.uuid&&p.uuid?d.uuid===p.uuid:d.id===p.id?!0:(0,g.compareIgnoreCase)(d.id,p.id)===0}e.areSameExtensions=k;class C{constructor(p,D){this.version=D,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?k(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function A(d,p){return`${d}.${p}`}e.getExtensionId=A;function S(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function y(d,p){return S(A(d,p))}e.getGalleryExtensionId=y;function T(d,p){const D=[],R=E=>{for(const a of D)if(a.some(o=>k(p(o),p(E))))return a;return null};for(const E of d){const a=R(E);a?a.push(E):D.push([E])}return D}e.groupByExtension=T;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(d){const p=new Set;for(const D of d)D.malicious&&p.add(D.id.id);return p}e.getMaliciousExtensionsSet=c;function f(d,p){const D=[],R=p.manifest.extensionDependencies?.slice(0)??[];for(;R.length;){const E=R.shift();if(E&&D.every(a=>!k(a.identifier,{id:E}))){const a=d.filter(o=>k(o.identifier,{id:E}));a.length===1&&(D.push(a[0]),R.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=f}),define(fe[187],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,39,10,8,11,140,28,113,159,187]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=T.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends c{openTerminal(o,m){return this.spawnTerminal(g,o,y.getWindowsShell(),m)}spawnTerminal(o,m,t,u){const r=m.windowsExec||f.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=k.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return o.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((l,h)=>{const w=D(process),_=o.spawn(t,s,{cwd:u,env:w});_.on("error",h),_.on("exit",()=>l())})}runInTerminal(o,m,t,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((s,l)=>{const h=`"${m} - ${I}"`,w=`""${t.join('" "')}" & pause"`,_=["/c","start",h,"/wait",i,"/c",w],v=Object.assign({},D(process),u);Object.keys(v).filter(F=>v[F]===null).forEach(F=>delete v[F]);const P={cwd:m,env:v,windowsVerbatimArguments:!0};g.spawn(f.CMD,_,P).on("error",F=>{l(R(F))}),s(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class d extends c{openTerminal(o,m){return this.spawnTerminal(g,o,m)}runInTerminal(o,m,t,u,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",_=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,J).fsPath,"-t",o||I,"-w",m];for(let b of t)_.push("-a"),_.push(b);if(u){const b=Object.assign({},D(process),u);for(let F in b){const M=b[F];M===null?(_.push("-u"),_.push(F)):(_.push("-e"),_.push(`${F}=${M}`))}}let v="";const P=g.spawn(d.OSASCRIPT,_);P.on("error",b=>{l(R(b))}),P.stderr.on("data",b=>{v+=b.toString()}),P.on("exit",b=>{if(b===0)s(void 0);else if(v){const F=v.split(`
`,1);l(new Error(F[0]))}else l(new Error(T.localize(1,null,h,b)))})}else l(new Error(T.localize(2,null,i)))})}spawnTerminal(o,m,t){const u=m.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",u];t&&s.push(t);const l=D(process),h=o.spawn("/usr/bin/open",s,{cwd:t,env:l});h.on("error",i),h.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class p extends c{openTerminal(o,m){return this.spawnTerminal(g,o,m)}runInTerminal(o,m,t,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{let h=[];i.then(w=>{w.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const _=`${E(t)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;h.push(`''${_}''`);const v=Object.assign({},D(process),u);Object.keys(v).filter(M=>v[M]===null).forEach(M=>delete v[M]);const P={cwd:m,env:v};let b="";const F=g.spawn(w,h,P);F.on("error",M=>{l(R(M))}),F.stderr.on("data",M=>{b+=M.toString()}),F.on("exit",M=>{if(M===0)s(void 0);else if(b){const q=b.split(`
`,1);l(new Error(q[0]))}else l(new Error(T.localize(4,null,w,M)))})})})}static async getDefaultTerminalLinuxReady(){return p._DEFAULT_TERMINAL_LINUX_READY||(p._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{C.isLinux?await S.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,m,t){const u=m.linuxExec?Promise.resolve(m.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(s=>{const l=D(process),h=o.spawn(s,[],{cwd:t,env:l});h.on("error",i),h.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=T.localize(3,null);function D(a){const o={...a.env};return(0,A.sanitizeProcessEnvironment)(o),o}function R(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(T.localize(5,null,a.path)):a}function E(a){let o="";for(let m of a)m.indexOf(" ")>=0?o+='"'+m+'"':o+=m,o+=" ";return o}}),define(fe[43],me([0,1,24,8,9,12,2,160,4]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(U){return U.create===!0}e.isFileOpenForWriteOptions=T;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var c;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=f;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function p(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function D(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=D;var R;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(R=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(z,O){super(z);this.code=O}}e.FileSystemProviderError=E;function a(U,z){const O=new E(U.toString(),z);return m(O,z),O}e.createFileSystemProviderError=a;function o(U){return U||a((0,S.localize)(0,null),R.Unknown)}e.ensureFileSystemProviderError=o;function m(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=m;function t(U){if(!U)return R.Unknown;if(U instanceof E)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return R.Unknown;switch(z[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileExceedsMemoryLimit:return R.FileExceedsMemoryLimit;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}e.toFileSystemProviderErrorCode=t;function u(U){if(U instanceof w)return U.fileOperationResult;switch(t(U)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 10;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileExceedsMemoryLimit:return 9;case R.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,O,N){this.resource=z,this.operation=O,this.target=N}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var s;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,O){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of z)switch(N.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>O)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>O)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>O)),this.deleted.set(N.resource,N);break}}contains(z,...O){return this.doContains(z,{includeChildren:!1},...O)}affects(z,...O){return this.doContains(z,{includeChildren:!0},...O)}doContains(z,O,...N){if(!z)return!1;const x=N.length>0;return!!((!x||N.includes(1))&&(this.added?.get(z)||O.includeChildren&&this.added?.findSuperstr(z))||(!x||N.includes(0))&&(this.updated?.get(z)||O.includeChildren&&this.updated?.findSuperstr(z))||(!x||N.includes(2))&&(this.deleted?.findSubstr(z)||O.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function h(U,z,O){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),O?(0,k.startsWithIgnoreCase)(U,z):U.indexOf(z)===0)}e.isParent=h;class w extends Error{constructor(z,O,N){super(z);this.fileOperationResult=O,this.options=N}}e.FileOperationError=w;class _ extends w{constructor(z,O,N){super(z,2,N);this.stat=O}}e.NotModifiedSinceFileOperationError=_;var v;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=b;async function F(U,z){if(!z.canHandleResource(A.URI.from({scheme:U.scheme})))return new Promise(O=>{const N=z.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===U.scheme&&x.added&&(N.dispose(),O())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<M.KB?(0,S.localize)(1,null,z.toFixed(0)):z<M.MB?(0,S.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,S.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,S.localize)(4,null,(z/M.GB).toFixed(2)):(0,S.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var q;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function G(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G}),define(fe[84],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[C,A]of k)this.set(C,A)}set(k,C){const A=this._entries.get(k);return this._entries.set(k,C),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(fe[189],me([0,1,18,17,115,181,4,84]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class T extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new S.ServiceCollection,p=!1,D){this._activeInstantiations=new Set,this._services=d,this._strict=p,this._parent=D,this._services.set(A.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...p){let D=c.traceInvocation(d),R=!1;try{return d({get:(a,o)=>{if(R)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(a,D);if(!m&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return m}},...p)}finally{R=!0,D.stop()}}createInstance(d,...p){let D,R;return d instanceof k.SyncDescriptor?(D=c.traceCreation(d.ctor),R=this._createInstance(d.ctor,d.staticArguments.concat(p),D)):(D=c.traceCreation(d),R=this._createInstance(d,p,D)),D.stop(),R}_createInstance(d,p=[],D){let R=A._util.getServiceDependencies(d).sort((o,m)=>o.index-m.index),E=[];for(const o of R){let m=this._getOrCreateServiceInstance(o.id,D);if(!m&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);E.push(m)}let a=R.length>0?R[0].index:p.length;if(p.length!==a){console.warn(`[createInstance] First service dependency of ${d.name} at position ${a+1} conflicts with ${p.length} static arguments`);let o=a-p.length;o>0?p=p.concat(new Array(o)):p=p.slice(0,a)}return new d(...[...p,...E])}_setServiceInstance(d,p){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,p);else if(this._parent)this._parent._setServiceInstance(d,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let p=this._services.get(d);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):p}_getOrCreateServiceInstance(d,p){let D=this._getServiceInstanceOrDescriptor(d);return D instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,D,p.branch(d,!0)):(p.branch(d,!1),D)}_safeCreateAndCacheServiceInstance(d,p,D){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,p,D)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,p,D){const R=new C.Graph(o=>o.id.toString());let E=0;const a=[{id:d,desc:p,_trace:D}];for(;a.length;){const o=a.pop();if(R.lookupOrInsertNode(o),E++>1e3)throw new T(R);for(let m of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${d} depends on ${m.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const u={id:m.id,desc:t,_trace:o._trace.branch(m.id,!0)};R.insertEdge(o,u),a.push(u)}}}for(;;){const o=R.roots();if(o.length===0){if(!R.isEmpty())throw new T(R);break}for(const{data:m}of o){if(this._getServiceInstanceOrDescriptor(m.id)instanceof k.SyncDescriptor){const u=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,u)}R.removeNode(m)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,p,D=[],R,E){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(p,D,R,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,p,D,R,E);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(d,p=[],D,R){if(D){const E=new g.IdleValue(()=>this._createInstance(d,p,R));return new Proxy(Object.create(null),{get(a,o){if(o in a)return a[o];let m=E.value,t=m[o];return typeof t!="function"||(t=t.bind(m),a[o]=t),t},set(a,o,m){return E.value[o]=m,!0}})}else return this._createInstance(d,p,R)}}e.InstantiationService=n;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class c{constructor(d,p){this.type=d,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return y?new c(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(d){return y?new c(0,d.name):c._None}branch(d,p){let D=new c(2,d.toString());return this._dep.push([d,p,D]),D}stop(){let d=Date.now()-this._start;c._totals+=d;let p=!1;function D(E,a){let o=[],m=new Array(E+1).join("	");for(const[t,u,r]of a._dep)if(u&&r){p=!0,o.push(`${m}CREATES -> ${t}`);let i=D(E+1,r);i&&o.push(i)}else o.push(`${m}uses -> ${t}`);return o.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(d>2||p)&&console.log(R.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(fe[13],me([0,1,62,3,6,11,4]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function S(){return new Date().toISOString()}var y;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class T extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class n extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...u){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...u]))}debug(t,...u){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...u]))}info(t,...u){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...u]))}warn(t,...u){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...u]))}error(t,...u){if(this.checkLogLevel(y.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([t,...u]))}critical(t,...u){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...u]))}flush(){}format(t){let u="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(s){}u+=(r>0?" ":"")+i}return u}}e.AbstractMessageLogger=n;class I extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...u){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...u):console.log(`[main ${S()}]`,t,...u))}debug(t,...u){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...u):console.log(`[main ${S()}]`,t,...u))}info(t,...u){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...u):console.log(`[main ${S()}]`,t,...u))}warn(t,...u){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...u):console.warn(`[main ${S()}]`,t,...u))}error(t,...u){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...u):console.error(`[main ${S()}]`,t,...u))}critical(t,...u){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...u):console.error(`[main ${S()}]`,t,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class c extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...u){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...u)}debug(t,...u){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...u)}info(t,...u){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...u)}warn(t,...u){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...u)}error(t,...u){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...u)}critical(t,...u){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...u)}dispose(){}flush(){}}e.ConsoleLogger=c;class f extends T{constructor(t,u=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(u)}trace(t,...u){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...u])}debug(t,...u){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...u])}info(t,...u){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...u])}warn(t,...u){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...u])}error(t,...u){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...u])}critical(t,...u){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...u])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class d extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const u of this.logServices)u.setLevel(t);super.setLevel(t)}trace(t,...u){for(const r of this.logServices)r.trace(t,...u)}debug(t,...u){for(const r of this.logServices)r.debug(t,...u)}info(t,...u){for(const r of this.logServices)r.info(t,...u)}warn(t,...u){for(const r of this.logServices)r.warn(t,...u)}error(t,...u){for(const r of this.logServices)r.error(t,...u)}critical(t,...u){for(const r of this.logServices)r.critical(t,...u)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...u){this.logger.trace(t,...u)}debug(t,...u){this.logger.debug(t,...u)}info(t,...u){this.logger.info(t,...u)}warn(t,...u){this.logger.warn(t,...u)}error(t,...u){this.logger.error(t,...u)}critical(t,...u){this.logger.critical(t,...u)}flush(){this.logger.flush()}}e.LogService=p;class D extends k.Disposable{constructor(t,u){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(u(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,u){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,u?.always?y.Trace:this.logLevel,u),this.loggers.set(t.toString(),r),u?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class R{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...u){}debug(t,...u){}info(t,...u){}warn(t,...u){}error(t,...u){}critical(t,...u){}dispose(){}flush(){}}e.NullLogService=R;function E(m){if(m.verbose)return y.Trace;if(typeof m.logLevel=="string"){const t=a(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function a(m){switch(m){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function o(m){switch(m){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=o}),define(fe[116],me([0,1,43,13]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(y,T,n,I){try{const c=await new Promise((f,d)=>{J(["spdlog"],f,d)});return c.setFlushOn(L.LogLevel.Trace),c.createAsyncRotatingLogger(y,T,n,I)}catch(c){console.error(c)}return null}function C(y,T,n,I){const c=J.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(y,T,n,I)}e.createRotatingLogger=C;function A(y,T,n){switch(T){case L.LogLevel.Trace:y.trace(n);break;case L.LogLevel.Debug:y.debug(n);break;case L.LogLevel.Info:y.info(n);break;case L.LogLevel.Warning:y.warn(n);break;case L.LogLevel.Error:y.error(n);break;case L.LogLevel.Critical:y.critical(n);break;default:throw new Error("Invalid log level")}}class S extends L.AbstractMessageLogger{constructor(T,n,I,c){super();this.name=T,this.filepath=n,this.rotating=I,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const T=this.rotating?6:1,n=30/T*g.ByteSize.MB;return k(this.name,this.filepath,n,T).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:c,message:f}of this.buffer)A(this._logger,c,f);this.buffer=[]}})}log(T,n){this._logger?A(this._logger,T,n):this.getLevel()<=T&&this.buffer.push({level:T,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(fe[117],me([0,1,49,161,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var A;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(d,p){return p-d}y.compare=T;const n=Object.create(null);n[y.Error]=(0,L.localize)(0,null),n[y.Warning]=(0,L.localize)(1,null),n[y.Info]=(0,L.localize)(2,null);function I(d){return n[d]||""}y.toString=I;function c(d){switch(d){case g.default.Error:return y.Error;case g.default.Warning:return y.Warning;case g.default.Info:return y.Info;case g.default.Ignore:return y.Hint}}y.fromSeverity=c;function f(d){switch(d){case y.Error:return g.default.Error;case y.Warning:return g.default.Warning;case y.Info:return g.default.Info;case y.Hint:return g.default.Ignore}}y.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(y){const T="";function n(c){return I(c,!0)}y.makeKey=n;function I(c,f){let d=[T];return c.source?d.push(c.source.replace("\xA6","\\\xA6")):d.push(T),c.code?typeof c.code=="string"?d.push(c.code.replace("\xA6","\\\xA6")):d.push(c.code.value.replace("\xA6","\\\xA6")):d.push(T),c.severity!==void 0&&c.severity!==null?d.push(A.toString(c.severity)):d.push(T),c.message&&f?d.push(c.message.replace("\xA6","\\\xA6")):d.push(T),c.startLineNumber!==void 0&&c.startLineNumber!==null?d.push(c.startLineNumber.toString()):d.push(T),c.startColumn!==void 0&&c.startColumn!==null?d.push(c.startColumn.toString()):d.push(T),c.endLineNumber!==void 0&&c.endLineNumber!==null?d.push(c.endLineNumber.toString()):d.push(T),c.endColumn!==void 0&&c.endColumn!==null?d.push(c.endColumn.toString()):d.push(T),d.push(T),d.join("\xA6")}y.makeKeyOptionalMessage=I})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(fe[190],me([0,1,3,49,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,k.createDecorator)("notificationService");var C;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new y,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=S;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(fe[191],me([0,1,6,9,2,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function A(S,y){return k.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,y):(0,L.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=A}),define(fe[192],me([0,1,10,11,38,23]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const S=L.globals.vscode.context.configuration();if(S)A=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const S=(0,C.dirname)(g.FileAccess.asFileUri("",J));A=J.__$__nodeRequire((0,C.joinPath)(S,"product.json").fsPath);const y=J.__$__nodeRequire((0,C.joinPath)(S,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:y.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var We=this&&this.__param||function(J,e){return function(g,L){e(g,L,J)}};define(fe[118],me([0,1,18,21,6,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var A;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(I,c){super();this.deferred=new g.DeferredPromise,c.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=Ge([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,f=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:f.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,57,12]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,S){g.ok(L.isString(A)),g.ok(L.isObject(S)),g.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,S)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(fe[119],me([0,1,3,34]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,T){this.schemasById[k(y)]=T,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new C;L.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[85],me([0,1,16,3,12,156,119,34]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=S.Registry.as(A.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(a,o=!0){this.registerConfigurations([a],o)}registerConfigurations(a,o=!0){const m=this.doRegisterConfigurations(a,o);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(a){const o=this.doDeregisterConfigurations(a);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:a,remove:o}){const m=[];m.push(...this.doDeregisterConfigurations(o)),m.push(...this.doRegisterConfigurations(a,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(m))}registerDefaultConfigurations(a){const o=[],m=[];for(const t of a)for(const u in t)if(o.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]={...this.defaultValues[u]||{},...t[u]};const r={type:"object",default:this.defaultValues[u],description:C.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};m.push(f(u)),this.configurationProperties[u]=r,this.defaultLanguageConfigurationOverridesNode.properties[u]=r}else{this.defaultValues[u]=t[u];const r=this.configurationProperties[u];r&&(this.updatePropertyDefaultValue(u,r),this.updateSchema(u,r))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(a){const o=[];for(const m of a)for(const t in m)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const o of a)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,o){const m=[];return a.forEach(t=>{m.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),m}doDeregisterConfigurations(a){const o=[],m=t=>{if(t.properties)for(const u in t.properties)o.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,t.properties[u]);t.allOf&&t.allOf.forEach(u=>m(u))};for(const t of a){m(t);const u=this.configurationContributors.indexOf(t);u!==-1&&this.configurationContributors.splice(u,1)}return o}validateAndRegisterProperties(a,o=!0,m,t=3){t=k.isUndefinedOrNull(a.scope)?t:a.scope;let u=[],r=a.properties;if(r)for(let s in r){if(o&&D(s)){delete r[s];continue}const l=r[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=k.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=k.isUndefinedOrNull(l.restricted)?!!m?.restrictedConfigurations?.includes(s):l.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),u.push(s)}let i=a.allOf;if(i)for(let s of i)u.push(...this.validateAndRegisterProperties(s,o,m,t));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(a){const o=m=>{let t=m.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let u=m.allOf;u&&u.forEach(o)};o(a)}updateSchema(a,o){switch(e.allSettings.properties[a]=o,o.scope){case 1:e.applicationSettings.properties[a]=o;break;case 2:e.machineSettings.properties[a]=o;break;case 6:e.machineOverridableSettings.properties[a]=o;break;case 3:e.windowSettings.properties[a]=o;break;case 4:e.resourceSettings.properties[a]=o;break;case 5:e.resourceSettings.properties[a]=o,this.resourceLanguageSettingsSchema.properties[a]=o;break}}removeFromSchema(a,o){switch(delete e.allSettings.properties[a],o.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const o=`[${a}]`,m={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,m),e.allSettings.properties[o]=m,e.applicationSettings.properties[o]=m,e.machineSettings.properties[o]=m,e.machineOverridableSettings.properties[o]=m,e.windowSettings.properties[o]=m,e.resourceSettings.properties[o]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,o){let m=this.defaultValues[a];k.isUndefined(m)&&(m=o.default),k.isUndefined(m)&&(m=d(o.type)),o.default=m}}const c="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(c);function f(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=f;function d(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const p=new I;S.Registry.add(e.Extensions.Configuration,p);function D(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?C.localize(5,null,E):p.getConfigurationProperties()[E]!==void 0?C.localize(6,null,E):null:C.localize(4,null)}e.validateProperty=D;function R(){const E=[],a=p.getConfigurationProperties();for(const o of Object.keys(a))E.push([o,a[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=R}),define(fe[120],me([0,1,25,12,2,85,4,34]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function y(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationOverrides=y;var T;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(u,r){const i=r?u?r.keys.filter(P=>u.keys.indexOf(P)===-1):[...r.keys]:[],s=u?r?u.keys.filter(P=>r.keys.indexOf(P)===-1):[...u.keys]:[],l=[];if(r&&u){for(const P of u.keys)if(r.keys.indexOf(P)!==-1){const b=R(u.contents,P),F=R(r.contents,P);g.equals(b,F)||l.push(P)}}const h=[],w=P=>{const b={};for(const F of P)for(const M of F.identifiers)b[m(M)]=F;return b},_=r?w(r.overrides):{},v=u?w(u.overrides):{};if(Object.keys(_).length)for(const P of i){const b=_[P];b&&h.push([(0,C.overrideIdentifierFromKey)(P),b.keys])}if(Object.keys(v).length)for(const P of s){const b=v[P];b&&h.push([(0,C.overrideIdentifierFromKey)(P),b.keys])}if(Object.keys(_).length&&Object.keys(v).length)for(const P of l){const b=v[P],F=_[P];if(b&&F){const M=I({contents:b.contents,keys:b.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});h.push([(0,C.overrideIdentifierFromKey)(P),[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:s,updated:l,overrides:h}}e.compare=I;function c(u,r){const i=[];for(const s of Object.keys(u))if(C.OVERRIDE_PROPERTY_PATTERN.test(s)){const l={};for(const h in u[s])l[h]=u[s][h];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(l),contents:f(l,r)})}return i}e.toOverrides=c;function f(u,r){const i=Object.create(null);for(let s in u)d(i,s,u[s],r);return i}e.toValuesTree=f;function d(u,r,i,s){const l=r.split("."),h=l.pop();let w=u;for(let _=0;_<l.length;_++){let v=l[_],P=w[v];switch(typeof P){case"undefined":P=w[v]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${l.slice(0,_+1).join(".")} is ${JSON.stringify(P)}`);return}w=P}if(typeof w=="object"&&w!==null)try{w[h]=i}catch(_){s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(w)}`)}else s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=d;function p(u,r){const i=r.split(".");D(u,i)}e.removeFromValueTree=p;function D(u,r){const i=r.shift();if(r.length===0){delete u[i];return}if(Object.keys(u).indexOf(i)!==-1){const s=u[i];typeof s=="object"&&!Array.isArray(s)&&(D(s,r),Object.keys(s).length===0&&delete u[i])}}function R(u,r,i){function s(w,_){let v=w;for(const P of _){if(typeof v!="object"||v===null)return;v=v[P]}return v}const l=r.split("."),h=s(u,l);return typeof h=="undefined"?i:h}e.getConfigurationValue=R;function E(u,r,i){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in u?L.isObject(u[s])&&L.isObject(r[s])?E(u[s],r[s],i):i&&(u[s]=r[s]):u[s]=r[s])})}e.merge=E;function a(){const u=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(u)}e.getConfigurationKeys=a;function o(){const u=Object.create(null),r=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in r){let s=r[i].default;d(u,i,s,l=>console.error(`Conflict in default settings: ${l}`))}return u}e.getDefaultValues=o;function m(u){return`[${u}]`}e.keyFromOverrideIdentifier=m;function t(u,r,i){const s=u.inspect(r),l=u.inspect(i);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:s.defaultValue}e.getMigratedSettingValue=t}),define(fe[193],me([0,1,16,3,60,6,24,25,12,2,120,85,34]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},u=[],r=[]){this._contents=t,this._keys=u,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,u){const r=this.getContentsForOverrideIdentifer(u);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const u of this.overrides)if(u.identifiers.indexOf(t)!==-1)return u.keys;return[]}override(t){const u=this.getContentsForOverrideIdentifer(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;let r={};for(const i of g.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[i],l=u[i];l&&(typeof s=="object"&&typeof l=="object"?(s=S.deepClone(s),this.mergeContents(s,l)):s=l),r[i]=s}return new f(r,this.keys,this.overrides)}merge(...t){const u=S.deepClone(this.contents),r=S.deepClone(this.overrides),i=[...this.keys];for(const s of t){this.mergeContents(u,s.contents);for(const l of s.overrides){const[h]=r.filter(w=>g.equals(w.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):r.push(S.deepClone(l))}for(const l of s.keys)i.indexOf(l)===-1&&i.push(l)}return new f(u,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,u){for(const r of Object.keys(u)){if(r in t&&y.isObject(t[r])&&y.isObject(u[r])){this.mergeContents(t[r],u[r]);continue}t[r]=S.deepClone(u[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const u of this.overrides)if(u.identifiers.indexOf(t)!==-1)return u.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,u){this.addKey(t),(0,n.addToValueTree)(this.contents,t,u,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let u=this.keys.length;for(let r=0;r<u;r++)t.indexOf(this.keys[r])===0&&(u=r);this.keys.splice(u,1,t)}removeKey(t){let u=this.keys.indexOf(t);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=f;class d extends f{constructor(){const t=(0,n.getDefaultValues)(),u=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,u,r)}}e.DefaultConfigurationModel=d;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,u){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,u)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,u){this._raw=t;const{contents:r,keys:i,overrides:s,restricted:l}=this.doParseRaw(t,u);this._configurationModel=new f(r,i,s),this._restrictedConfigurations=l||[]}doParseContent(t){let u={},r=null,i=[],s=[],l=[];function h(_){Array.isArray(i)?i.push(_):r!==null&&(i[r]=_)}let w={onObjectBegin:()=>{let _={};h(_),s.push(i),i=_,r=null},onObjectProperty:_=>{r=_},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{let _=[];h(_),s.push(i),i=_,r=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:h,onError:(_,v,P)=>{l.push({error:_,offset:v,length:P})}};if(t)try{k.visit(t,w),u=i[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return u}doParseRaw(t,u){const r=c.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,u);t=i.raw;const s=(0,n.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),l=Object.keys(t),h=(0,n.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:s,keys:l,overrides:h,restricted:i.restricted}}filter(t,u,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const s={},l=[];for(let h in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(h)&&r){const w=this.filter(t[h],u,!1,i);s[h]=w.raw,l.push(...w.restricted)}else{const w=u[h],_=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&l.push(h),(_===void 0||i.scopes===void 0||i.scopes.includes(_))&&(i.skipRestricted&&w?.restricted||(s[h]=t[h]))}return{raw:s,restricted:l}}}e.ConfigurationModelParser=p;class D extends C.Disposable{constructor(t,u,r,i){super();this.userSettingsResource=t,this.scopes=u,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class R{constructor(t,u,r=new f,i=new f,s=new A.ResourceMap,l=new f,h=new A.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=u,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=s,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,u,r){return this.getConsolidateConfigurationModel(u,r).getValue(t)}updateValue(t,u,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new f,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,u===void 0?i.removeValue(t):i.setValue(t,u),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,u,r){const i=this.getConsolidateConfigurationModel(u,r),s=this.getFolderConfigurationModelForResource(u.resource,r),l=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,h=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),_=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=r?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,b=s?u.overrideIdentifier?s.freeze().override(u.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,F=u.overrideIdentifier?l.override(u.overrideIdentifier).getValue(t):l.getValue(t),M=i.getValue(t),q=g.distinct(g.flatten(i.overrides.map(G=>G.identifiers))).filter(G=>i.getOverrideValue(t,G)!==void 0);return{defaultValue:h,userValue:w,userLocalValue:_,userRemoteValue:v,workspaceValue:P,workspaceFolderValue:b,memoryValue:F,value:M,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspaceFolder:b!==void 0?{value:s?.freeze().getValue(t),override:u.overrideIdentifier?s?.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(t),override:u.overrideIdentifier?l.getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(t){const u=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,u){this._folderConfigurations.set(t,u),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const r=u.filter(i=>I.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const s=(0,I.overrideIdentifierFromKey)(i),l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=t.getKeysForOverrideIdentifier(s),w=[...h.filter(_=>l.indexOf(_)===-1),...l.filter(_=>h.indexOf(_)===-1),...l.filter(_=>!S.equals(this._defaultConfiguration.override(s).getValue(_),t.override(s).getValue(_)))];return[s,w]});return this.updateDefaultConfiguration(t),{keys:u,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:r,removed:i,overrides:s}=(0,n.compare)(this.localUserConfiguration,t),l=[...u,...r,...i];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:r,removed:i,overrides:s}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...u,...r,...i];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:r,removed:i,overrides:s}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...u,...r,...i];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(t,u){const r=this.folderConfigurations.get(t),{added:i,updated:s,removed:l,overrides:h}=(0,n.compare)(r,u);let w=[...i,...s,...l];return(w.length||!r)&&this.updateFolderConfiguration(t,u),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(t){const u=this.folderConfigurations.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:s,overrides:l}=(0,n.compare)(u,void 0);return{keys:[...r,...i,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,u){let r=this.getConsolidatedConfigurationModelForResource(t,u);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},u){let r=this.getWorkspaceConsolidatedConfiguration();if(u&&t){const i=u.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const s=this._memoryConfigurationByResource.get(t);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let u=this._foldersConsolidatedConfigurations.get(t);if(!u){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(u=r.merge(i),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(t,u)):u=r}return u}getFolderConfigurationModelForResource(t,u){if(u&&t){const r=u.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,u)=>{const{contents:r,overrides:i,keys:s}=this._folderConfigurations.get(u);return t.push([u,{contents:r,overrides:i,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>t.add(u)),this.userConfiguration.freeze().keys.forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i))),[...u.values()]}static parse(t){const u=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((l,h)=>(l.set(T.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new A.ResourceMap);return new R(u,r,new f,i,s,new f,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=R;function E(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,u=new Map;for(const i of m)i.keys.forEach(s=>t.add(s)),i.overrides.forEach(([s,l])=>{const h=(0,A.getOrSet)(u,s,new Set);l.forEach(w=>h.add(w))});const r=[];return u.forEach((i,s)=>r.push([s,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=E;class a{constructor(t,u,r,i){this.change=t,this.previous=u,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(h=>s.add(h)),t.overrides.forEach(([,h])=>h.forEach(w=>s.add(w))),this.affectedKeys=[...s.values()];const l=new f;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(u){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,u,this.currentWorkspace);return!S.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,u){let r=(0,n.toValuesTree)({[u]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=a;class o extends a{constructor(t,u,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,u);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=o}),define(fe[121],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,S=L.Unknown,y){super(A);this._message=A,this._code=S,this._detail=y,this.isHandled=S===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(fe[86],me([0,1,10]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(T){return T.scheme===g.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=L;function k(T){if(!T)return;const n=T.indexOf("+");return n<0?T:T.substr(0,n)}e.getRemoteName=k;function C(T){return T.scheme!==g.Schemas.file&&T.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function A(T){if(T.folders.length)return T.folders.every(n=>C(n.uri))?T.folders[0].uri:void 0;if(T.configuration&&C(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=A;function S(T){return A(T)?.scheme}e.getVirtualWorkspaceScheme=S;function y(T){return A(T)!==void 0}e.isVirtualWorkspace=y}),define(fe[194],me([0,1,3,11,4,13]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var A;(function(f){f.Http="http",f.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=n;function I(f,d){return d?d!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=I;let c=class{constructor(d){this.logService=d,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,p){return this._tunnelProvider=d,d?(this._canElevate=p.elevation,this._canMakePublic=p.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const p=[],D=Array.from(this._tunnels.values());for(let R of D){const E=Array.from(R.values());for(let a of E){const o=await a.value;o&&p.push(o)}}d(p)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:p}of d.values())await p.then(D=>D?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,p,D,R,E=!1,a=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${D} on local port ${R}.`),!d)return;p||(p="localhost");const m=this.retainOrCreateTunnel(d,p,D,R,E,a,o);return m?m.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const p=this._tunnels.get(d.tunnelRemoteHost);if(p){const D=p.get(d.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,D))}}}}async tryDisposeTunnel(d,p,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${p}.`);const R=D.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(p),R}}async closeTunnel(d,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${p} `);const D=this._tunnels.get(d);if(D&&D.has(p)){const R=D.get(p);R.refcount=0,await this.tryDisposeTunnel(d,p,R)}}addTunnelToMap(d,p,D){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(p,{refcount:1,value:D})}async removeEmptyTunnelFromMap(d,p){const D=this._tunnels.get(d);D&&(await D.get(p)||D.delete(p),D.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,p){let D=[d];T(d)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):n(d)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const R=D.map(E=>this._tunnels.get(E));for(const E of R){const a=E?.get(p);if(a)return a}}canTunnel(d){return!!y(d)}createWithProvider(d,p,D,R,E,a,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${D} on local port ${R}.`);const t={elevationRequired:E?I(R===void 0?D:R):!1},u={remoteAddress:{host:p,port:D},localAddressPort:R,public:a,protocol:o},r=d.forwardPort(u,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(p,D,r),r}};c=Ge([We(0,C.ILogService)],c),e.AbstractTunnelService=c}),define(fe[195],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,C)=>J(["vsda"],k,C))}async sign(k){try{const C=await this.vsda(),A=new C.signer;if(A)return A.sign(k)}catch(C){}return k}}e.SignService=g}),define(fe[196],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,C,A=5){let S;return S=C(y=>{const T=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(k);if(n){n.data.push(T);return}const I=setTimeout(()=>this.flushBuffer(k),A);n={data:[T],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),S.dispose()}},this._terminalBufferMap.set(k,n)}),S}stopBuffering(k){const C=this._terminalBufferMap.get(k);C&&C.dispose()}flushBuffer(k){const C=this._terminalBufferMap.get(k);C&&(this._terminalBufferMap.delete(k),this._callback(k,C.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[197],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[64],me([0,1,47,3,6,4,34,197]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var y;(function(D){function R(E){return E&&typeof E=="object"&&typeof E.id=="string"}D.isThemeColor=R})(y=e.ThemeColor||(e.ThemeColor={}));function T(D){return{id:D}}e.themeColorFromId=T;var n;(function(D){function R(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color=="undefined"||y.isThemeColor(u.color))}D.isThemeIcon=R;const E=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function a(u){const r=E.exec(u);if(!r)return;let[,i]=r;return{id:i}}D.fromString=a;function o(u,r){let i=u.id;const s=i.lastIndexOf("~");return s!==-1&&(i=i.substring(0,s)),r&&(i=`${i}~${r}`),{id:i}}D.modify=o;function m(u,r){return u.id===r.id&&u.color?.id===r.color?.id}D.isEqual=m;function t(u,r){return{id:u.id,color:r?T(r):void 0}}D.asThemeIcon=t,D.asClassNameArray=g.CSSIcon.asClassNameArray,D.asClassName=g.CSSIcon.asClassName,D.asCSSSelector=g.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(D){switch(D){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(R){return this.themingParticipants.push(R),this.onThemingParticipantAddedEmitter.fire(R),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(R);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new c;A.Registry.add(e.Extensions.ThemingContribution,f);function d(D){return f.onColorThemeChange(D)}e.registerThemingParticipant=d;class p extends k.Disposable{constructor(R){super();this.themeService=R,this.theme=R.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(R){this.theme=R,this.updateStyles()}updateStyles(){}getColor(R,E){let a=this.theme.getColor(R);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}e.Themable=p}),define(fe[198],me([0,1,18,47,3,162,119,34,64]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(R,E,a,o){const m=this.iconsById[R];if(m){if(a&&!m.description){m.description=a,this.iconSchema.properties[R].markdownDescription=`${a} $(${R})`;const r=this.iconReferenceSchema.enum.indexOf(R);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return m}let t={id:R,description:a,defaults:E,deprecationMessage:o};this.iconsById[R]=t;let u={$ref:"#/definitions/icons"};return o&&(u.deprecationMessage=o),a&&(u.markdownDescription=`${a}: $(${R})`),this.iconSchema.properties[R]=u,this.iconReferenceSchema.enum.push(R),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:R}}deregisterIcon(R){delete this.iconsById[R],delete this.iconSchema.properties[R];const E=this.iconReferenceSchema.enum.indexOf(R);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(R=>this.iconsById[R])}getIcon(R){return this.iconsById[R]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(R,E){const a=this.iconFontsById[R];if(a)return a;let o={id:R,definition:E};return this.iconFontsById[R]=o,this._onDidChange.fire(),o}deregisterIconFont(R){delete this.iconFontsById[R]}getIconFonts(){return Object.keys(this.iconFontsById).map(R=>this.iconFontsById[R])}getIconFont(R){return this.iconFontsById[R]}toString(){const R=(m,t)=>m.id.localeCompare(t.id),E=m=>{for(;y.ThemeIcon.isThemeIcon(m.defaults);)m=this.iconsById[m.defaults.id];return`codicon codicon-${m?m.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(m=>this.iconsById[m]);for(const m of o.filter(t=>!!t.description).sort(R))a.push(`|<i class="${E(m)}"></i>|${m.id}|${y.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const m of o.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(R))a.push(`|<i class="${E(m)}"></i>|${m.id}|`);return a.join(`
`)}}const n=new T;S.Registry.add(e.Extensions.IconContribution,n);function I(D,R,E,a){return n.registerIcon(D,R,E,a)}e.registerIcon=I;function c(){return n}e.getIconRegistry=c;function f(){for(const D of L.iconRegistry.all)n.registerIcon(D.id,D.definition,D.description);L.iconRegistry.onDidRegister(D=>n.registerIcon(D.id,D.definition,D.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let d=S.Registry.as(A.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,n.getIconSchema());const p=new g.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=y.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var A;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function S(c){const f=c;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=S;function y(c){const f=c;return!!(f&&typeof f=="object"&&k.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class T{constructor(f,d,p,D){this._id=f,this._configuration=p,this._ignorePathCasing=D,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class n{constructor(f,d){this.raw=d,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,L.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(c){return new n({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(fe[199],me([0,1,29,60,138,79,10,8,11,23,2,163,4,86,44]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(U){return(typeof U=="string"?(0,S.extname)(U):(0,T.extname)(U))===p}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function R(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=R;function E(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=E;function a(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=a;function o(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function m(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=m;function t(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function u(U){const z=U;if(z?.uri)return{id:z.id,uri:n.URI.revive(z.uri)};const O=U;if(O?.configPath)return{id:O.id,configPath:n.URI.revive(O.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=u;function r(U,z){return T.extUriBiasedIgnorePathCase.isEqualOrParent(U,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(U){return s(U)||l(U)}e.isStoredWorkspaceFolder=i;function s(U){const z=U;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=s;function l(U){const z=U;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=l;function h(U,z,O,N,x=!y.isWindows,B){if(U.scheme!==N.scheme)return{name:O,uri:U.toString(!0)};let H=z?void 0:B.relativePath(N,U);if(H!==void 0)H.length===0?H=".":y.isWindows&&U.scheme===A.Schemas.file&&!x&&(H=H.replace(/\//g,"\\"));else if(U.scheme===A.Schemas.file)H=U.fsPath,y.isWindows&&(H=(0,C.normalizeDriveLetter)(H),x&&(H=(0,g.toSlashes)(H)));else{if(!B.isEqualAuthority(U.authority,N.authority))return{name:O,uri:U.toString(!0)};H=U.path}return{name:O,path:H}}e.getStoredWorkspaceFolder=h;function w(U,z,O){let N=[],x=new Set;const B=O.dirname(z);for(let H of U){let $;if(s(H))H.path&&($=O.resolvePath(B,H.path));else if(l(H))try{$=n.URI.parse(H.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(Y){console.warn(Y)}if($){let Y=O.getComparisonKey($);if(!x.has(Y)){x.add(Y);const Q=H.name||O.basenameOrAuthority($);N.push(new d.WorkspaceFolder({uri:$,name:Q,index:N.length},H))}}}return N}e.toWorkspaceFolders=w;function _(U,z,O,N,x){let B=v(z,U);const H=x.dirname(z),$=x.dirname(N),Y=[],Q=P(B.folders);for(const Te of B.folders){const $e=s(Te)?x.resolvePath(H,Te.path):n.URI.parse(Te.uri);let Be;O?Be=!1:Be=!s(Te)||(0,S.isAbsolute)(Te.path),Y.push(h($e,Be,Te.name,$,Q,x))}const de={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},_e=k.setProperty(U,["folders"],Y,de);let Ce=k.applyEdits(U,_e);return B.remoteAuthority===(0,f.getRemoteAuthority)(N)&&(Ce=k.applyEdits(Ce,k.removeProperty(Ce,["remoteAuthority"],de))),Ce}e.rewriteWorkspaceFileForNewLocation=_;function v(U,z){let O=L.parse(z);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(N=>i(N));else throw new Error(`${U} looks like an invalid workspace file.`);return O}function P(U){return y.isWindows?U.some(z=>s(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=P;function b(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function F(U){return typeof U.folderUri=="string"}function M(U){return typeof U.fileUri=="string"}function q(U,z){const O={workspaces:[],files:[]};if(U){const N=function(B,H){for(let $=0;$<B.length;$++)try{H(B[$],$)}catch(Y){z.warn(`Error restoring recent entry ${JSON.stringify(B[$])}: ${Y.toString()}. Skip entry.`)}},x=U;if(Array.isArray(x.entries))N(x.entries,B=>{const H=B.label,$=B.remoteAuthority;b(B)?O.workspaces.push({label:H,remoteAuthority:$,workspace:{id:B.workspace.id,configPath:n.URI.parse(B.workspace.configPath)}}):F(B)?O.workspaces.push({label:H,remoteAuthority:$,folderUri:n.URI.parse(B.folderUri)}):M(B)&&O.files.push({label:H,remoteAuthority:$,fileUri:n.URI.parse(B.fileUri)})});else{const B=U;Array.isArray(B.workspaces3)&&N(B.workspaces3,(H,$)=>{const Y=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[$]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?O.workspaces.push({label:Y,workspace:{id:H.id,configPath:n.URI.parse(H.configURIPath)}}):typeof H=="string"&&O.workspaces.push({label:Y,folderUri:n.URI.parse(H)})}),Array.isArray(B.files2)&&N(B.files2,(H,$)=>{const Y=Array.isArray(B.fileLabels)&&B.fileLabels[$]||void 0;typeof H=="string"&&O.files.push({label:Y,fileUri:n.URI.parse(H)})})}}return O}e.restoreRecentlyOpened=q;function G(U){const z={entries:[]};for(const O of U.workspaces)E(O)?z.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):z.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of U.files)z.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return z}e.toStoreData=G}),define(fe[87],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const C=this._idPool++;return this._data.set(C,k),this.logDebugInfo(),C}get(k,C){return this._data.has(k)?this._data.get(k)[C]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[52],me([0,1,10,23,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(S=>{const y=this._providerInfo.get(S.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(S,y){y===null?this._providerInfo.delete(S):this._providerInfo.set(S,y)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(fe[27],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[200],me([0,1,18]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(A,S,y){this._deferredPromises=new Map,this._id=A,this._shared=S,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of T.values())n.complete()}catch(n){for(const I of T.values())I.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,S){let y=this._value[A];return typeof y=="undefined"&&(y=S),y}update(A,S){this._value[A]=S;let y=this._deferredPromises.get(A);if(y!==void 0)return y.p;const T=new g.DeferredPromise;return this._deferredPromises.set(A,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(A,S){super(A.identifier.value,!0,S);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(fe[201],me([0,1,3,2,13]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(S,y){this._logService=S,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(S,y,T){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S)).acceptModelChanged(y.value,T)}$acceptDirtyStateChanged(S,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S)).acceptDirty(y)}$acceptModelSaved(S){const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(S,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",S.path,y);const T=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S));T.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};C=Ge([We(0,k.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(fe[14],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[202],me([0,1,26,3]),function(J,e,g,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(S,y){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(S.identifier),it(this,k,y,"f"),Oe(this,k,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(S){return Oe(this,k,"f").get(this._id,S)}store(S,y){return Oe(this,k,"f").store(this._id,S,y)}delete(S){return Oe(this,k,"f").delete(this._id,S)}}e.ExtensionSecrets=C,k=new WeakMap}),define(fe[122],me([0,1,4,3]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[65],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,k=(E,a)=>{const o={controllerId:a};return L.set(E,o),o};e.createPrivateApiFor=k;const C=E=>L.get(E);e.getPrivateApiFor=C;const A=(E,a,o,m)=>{let t=o;return{enumerable:!0,configurable:!1,get(){return t},set(u){if(!m(t,u)){const r=t;t=u,E.listener?.({op:3,key:a,value:u,previous:r})}}}},S=(E,a)=>E===a,y={range:(E,a)=>E===a?!0:!E||!a?!1:E.isEqual(a),label:S,description:S,busy:S,error:S,canResolveChildren:S,tags:(E,a)=>!(E.length!==a.length||E.some(o=>!a.find(m=>o.id===m.id)))},T=Object.keys(y),n=(E,a)=>({range:A(E,"range",void 0,y.range),label:A(E,"label",a,y.label),description:A(E,"description",void 0,y.description),canResolveChildren:A(E,"canResolveChildren",!1,y.canResolveChildren),busy:A(E,"busy",!1,y.busy),error:A(E,"error",void 0,y.error),tags:A(E,"tags",[],y.tags)}),I=(E,a)=>{const o=new Map;for(const m of T)y[m](E[m],a[m])||o.set(m,a[m]);return o};e.diffTestItems=I;class c extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=c;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(a,o,m){super(`TestItem with ID "${a}" is from controller "${o}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=d;const p=E=>{const a=(0,e.getPrivateApiFor)(E);let o=new Map;return{get size(){return o.size},forEach(m,t){for(const u of o.values())m.call(t,u,this)},replace(m){const t=new Map,u=new Set(o.keys()),r={op:4,ops:[]};for(const i of m){if(!(i instanceof D))throw new f(i.id);const s=(0,e.getPrivateApiFor)(i).controllerId;if(s!==a.controllerId)throw new d(i.id,s,a.controllerId);if(t.has(i.id))throw new c(i.id);t.set(i.id,i),u.delete(i.id),r.ops.push({op:0,item:i})}for(const i of u.keys())r.ops.push({op:1,id:i});a.listener?.(r),o=t},add(m){if(!(m instanceof D))throw new f(m.id);o.set(m.id,m),a.listener?.({op:0,item:m})},delete(m){o.delete(m)&&a.listener?.({op:1,id:m})},get(m){return o.get(m)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class D{constructor(a,o,m,t){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const u=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof R?void 0:u.parent}},children:{value:p(this),enumerable:!0,writable:!1},...n(u,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class R extends D{constructor(a,o){super(a,a,o,void 0)}}e.TestItemRootImpl=R}),define(fe[53],me([0,1,4,3,14]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(S){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}S.fromApiTunnel=y;function T(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}S.fromServiceTunnel=T})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let A=class{constructor(y){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,T){return{dispose:()=>{}}}async $providePortAttributes(y,T,n,I,c){return[]}async $forwardPort(y,T){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ge([We(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[7],me([0,1,16,17,99,24,102,12,2,32,43,121]),function(J,e,g,L,k,C,A,S,y,T,n,I){"use strict";var c,f,d,p,D,R,E,a,o,m,t,u,r,i,s,l,h,w,_,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(V){function W(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(W,V),Object.setPrototypeOf(W.prototype,V.prototype),W}let b=D=class{constructor(W){c.set(this,void 0),it(this,c,W,"f")}static from(...W){let oe=W;return new D(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),it(this,c,void 0,"f"))}};c=new WeakMap,b=D=Ge([P],b),e.Disposable=b;let F=R=class{constructor(W,oe){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=W,this._character=oe}static Min(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let De=1;De<W.length;De++){const et=W[De];et.isBefore(oe)&&(oe=et)}return oe}static Max(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let De=1;De<W.length;De++){const et=W[De];et.isAfter(oe)&&(oe=et)}return oe}static isPosition(W){if(!W)return!1;if(W instanceof R)return!0;let{line:oe,character:De}=W;return typeof oe=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,oe=0){if(W===null||oe===null)throw(0,L.illegalArgument)();let De;return typeof W=="undefined"?De=0:typeof W=="number"?De=W:(De=typeof W.lineDelta=="number"?W.lineDelta:0,oe=typeof W.characterDelta=="number"?W.characterDelta:0),De===0&&oe===0?this:new R(this.line+De,this.character+oe)}with(W,oe=this.character){if(W===null||oe===null)throw(0,L.illegalArgument)();let De;return typeof W=="undefined"?De=this.line:typeof W=="number"?De=W:(De=typeof W.line=="number"?W.line:this.line,oe=typeof W.character=="number"?W.character:this.character),De===this.line&&oe===this.character?this:new R(De,oe)}toJSON(){return{line:this.line,character:this.character}}};F=R=Ge([P],F),e.Position=F;let M=E=class{constructor(W,oe,De,et){let st,dt;if(typeof W=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof et=="number"?(st=new F(W,oe),dt=new F(De,et)):W instanceof F&&oe instanceof F&&(st=W,dt=oe),!st||!dt)throw new Error("Invalid arguments");st.isBefore(dt)?(this._start=st,this._end=dt):(this._start=dt,this._end=st)}static isRange(W){return W instanceof E?!0:W?F.isPosition(W.start)&&F.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof E?this.contains(W._start)&&this.contains(W._end):W instanceof F?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const oe=F.Max(W.start,this._start),De=F.Min(W.end,this._end);if(!oe.isAfter(De))return new E(oe,De)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const oe=F.Min(W.start,this._start),De=F.Max(W.end,this.end);return new E(oe,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,oe=this.end){if(W===null||oe===null)throw(0,L.illegalArgument)();let De;return W?F.isPosition(W)?De=W:(De=W.start||this.start,oe=W.end||this.end):De=this.start,De.isEqual(this._start)&&oe.isEqual(this.end)?this:new E(De,oe)}toJSON(){return[this.start,this.end]}};M=E=Ge([P],M),e.Range=M;let q=a=class extends M{constructor(W,oe,De,et){let st,dt;if(typeof W=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof et=="number"?(st=new F(W,oe),dt=new F(De,et)):W instanceof F&&oe instanceof F&&(st=W,dt=oe),!st||!dt)throw new Error("Invalid arguments");super(st,dt);this._anchor=st,this._active=dt}static isSelection(W){return W instanceof a?!0:W?M.isRange(W)&&F.isPosition(W.anchor)&&F.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=a=Ge([P],q),e.Selection=q;class G{constructor(W,oe,De){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(oe),this.connectionToken=De}}e.ResolvedAuthority=G;class U extends Error{constructor(W,oe=I.RemoteAuthorityResolverErrorCode.Unknown,De){super(W);this._message=W,this._code=oe,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(W,oe){return new U(W,I.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(W){return new U(W,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var z;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var O;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let N=o=class{constructor(W,oe){this._range=W,this._newText=oe}static isTextEdit(W){return W instanceof o?!0:W?M.isRange(W)&&typeof W.newText=="string":!1}static replace(W,oe){return new o(W,oe)}static insert(W,oe){return o.replace(new M(W,W),oe)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const oe=new o(new M(new F(0,0),new F(0,0)),"");return oe.newEol=W,oe}get range(){return this._range}set range(W){if(W&&!M.isRange(W))throw(0,L.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};N=o=Ge([P],N),e.TextEdit=N;var x;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let B=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,oe,De,et){this._edits.push({_type:1,from:W,to:oe,options:De,metadata:et})}createFile(W,oe,De){this._edits.push({_type:1,from:void 0,to:W,options:oe,metadata:De})}deleteFile(W,oe,De){this._edits.push({_type:1,from:W,to:void 0,options:oe,metadata:De})}replaceNotebookMetadata(W,oe,De){this._edits.push({_type:3,metadata:De,uri:W,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(W,oe,De,et,st){let dt,mt,kt=[],At;if(Vt.isNotebookRange(oe)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(et)?(dt=oe.start,mt=oe.end,kt=De,At=et):typeof oe=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(et)&&(dt=oe,mt=De,kt=et,At=st),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||kt.length>0)&&this._edits.push({_type:5,uri:W,index:dt,count:mt-dt,cells:kt,metadata:At})}replaceNotebookCellMetadata(W,oe,De,et){this._edits.push({_type:3,metadata:et,uri:W,edit:{editType:8,index:oe,metadata:De}})}replace(W,oe,De,et){this._edits.push({_type:2,uri:W,edit:new N(oe,De),metadata:et})}insert(W,oe,De,et){this.replace(W,new M(oe,oe),De,et)}delete(W,oe,De){this.replace(W,oe,"",De)}has(W){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===W.toString())}set(W,oe){if(oe)for(const De of oe)De&&this._edits.push({_type:2,uri:W,edit:De});else{for(let De=0;De<this._edits.length;De++){const et=this._edits[De];et._type===2&&et.uri.toString()===W.toString()&&(this._edits[De]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(W){const oe=[];for(let De of this._edits)De._type===2&&De.uri.toString()===W.toString()&&oe.push(De.edit);return oe}entries(){const W=new C.ResourceMap;for(let oe of this._edits)if(oe._type===2){let De=W.get(oe.uri);De||(De=[oe.uri,[]],W.set(oe.uri,De)),De[1].push(oe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};B=Ge([P],B),e.WorkspaceEdit=B;let H=m=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof m?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=m._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,oe=this._tabstop++){if(typeof W=="function"){const De=new m;De._tabstop=this._tabstop,W(De),this._tabstop=De._tabstop,W=De.value}else W=m._escape(W);return this.value+="${",this.value+=oe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,oe=this._tabstop++){const De=W.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(W,oe){if(typeof oe=="function"){const De=new m;De._tabstop=this._tabstop,oe(De),this._tabstop=De._tabstop,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};H=m=Ge([P],H),e.SnippetString=H;var $;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var Y;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Y=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=t=class{constructor(W,oe){if(this.uri=W,oe)if(oe instanceof M)this.range=oe;else if(oe instanceof F)this.range=new M(oe,oe);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof t?!0:W?M.isRange(W.range)&&y.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=t=Ge([P],Q),e.Location=Q;let de=class{constructor(W,oe){this.location=W,this.message=oe}static is(W){return W?typeof W.message=="string"&&W.location&&M.isRange(W.location.range)&&y.URI.isUri(W.location.uri):!1}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.location.range.isEqual(oe.location.range)&&W.location.uri.toString()===oe.location.uri.toString()}};de=Ge([P],de),e.DiagnosticRelatedInformation=de;let _e=class{constructor(W,oe,De=Y.Error){if(!M.isRange(W))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=W,this.message=oe,this.severity=De}toJSON(){return{severity:Y[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.severity===oe.severity&&W.code===oe.code&&W.severity===oe.severity&&W.source===oe.source&&W.range.isEqual(oe.range)&&(0,g.equals)(W.tags,oe.tags)&&(0,g.equals)(W.relatedInformation,oe.relatedInformation,de.isEqual)}};_e=Ge([P],_e),e.Diagnostic=_e;let Ce=class{constructor(W,oe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=oe}};Ce=Ge([P],Ce),e.Hover=Ce;var Te;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor(W,oe=Te.Text){this.range=W,this.kind=oe}toJSON(){return{range:this.range,kind:Te[this.kind]}}};$e=Ge([P],$e),e.DocumentHighlight=$e;var Be;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Be=e.SymbolKind||(e.SymbolKind={}));var He;(function(V){V[V.Deprecated=1]="Deprecated"})(He=e.SymbolTag||(e.SymbolTag={}));let j=u=class{constructor(W,oe,De,et,st){this.name=W,this.kind=oe,this.containerName=st,typeof De=="string"&&(this.containerName=De),et instanceof Q?this.location=et:De instanceof M&&(this.location=new Q(et,De)),u.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Be[this.kind],location:this.location,containerName:this.containerName}}};j=u=Ge([P],j),e.SymbolInformation=j;let ee=r=class{constructor(W,oe,De,et,st){this.name=W,this.detail=oe,this.kind=De,this.range=et,this.selectionRange=st,this.children=[],r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(r.validate)}};ee=r=Ge([P],ee),e.DocumentSymbol=ee;var se;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(W,oe){this.title=W,this.kind=oe}};le=Ge([P],le),e.CodeAction=le;let Z=i=class{constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};Z.sep=".",Z=i=Ge([P],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let ae=class{constructor(W,oe){if(this.range=W,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ge([P],ae),e.SelectionRange=ae;class ve{constructor(W,oe,De,et,st,dt){this.kind=W,this.name=oe,this.detail=De,this.uri=et,this.range=st,this.selectionRange=dt}}e.CallHierarchyItem=ve;class Me{constructor(W,oe){this.fromRanges=oe,this.from=W}}e.CallHierarchyIncomingCall=Me;class qe{constructor(W,oe){this.fromRanges=oe,this.to=W}}e.CallHierarchyOutgoingCall=qe;var Ye;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,oe){this.range=W,this.command=oe}get isResolved(){return!!this.command}};Ze=Ge([P],Ze),e.CodeLens=Ze;let ke=s=class{constructor(W,oe=!1){f.set(this,void 0),it(this,f,new k.MarkdownString(W,{supportThemeIcons:oe}),"f")}static isMarkdownString(W){return W instanceof s?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Oe(this,f,"f").value}set value(W){Oe(this,f,"f").value=W}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(W){Oe(this,f,"f").isTrusted=W}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(W){Oe(this,f,"f").supportThemeIcons=W}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(W){Oe(this,f,"f").supportHtml=W}appendText(W){return Oe(this,f,"f").appendText(W),this}appendMarkdown(W){return Oe(this,f,"f").appendMarkdown(W),this}appendCodeblock(W,oe){return Oe(this,f,"f").appendCodeblock(oe??"",W),this}};f=new WeakMap,ke=s=Ge([P],ke),e.MarkdownString=ke;let at=class{constructor(W,oe){this.label=W,this.documentation=oe}};at=Ge([P],at),e.ParameterInformation=at;let X=class{constructor(W,oe){this.label=W,this.documentation=oe,this.parameters=[]}};X=Ge([P],X),e.SignatureInformation=X;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=Ge([P],te),e.SignatureHelp=te;var ge;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(ge=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var je;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(je=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(W,oe,De){this.text=W,this.position=oe,this.kind=De}};tt=Ge([P],tt),e.InlayHint=tt;var lt;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(lt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ft;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(ft=e.CompletionItemKind||(e.CompletionItemKind={}));var wt;(function(V){V[V.Deprecated=1]="Deprecated"})(wt=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor(W,oe){this.label=W,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=Ge([P],Ct),e.CompletionItem=Ct;let ce=class{constructor(W=[],oe=!1){this.items=W,this.isIncomplete=oe}};ce=Ge([P],ce),e.CompletionList=ce;let Pe=class{constructor(W,oe,De){this.text=W,this.range=oe,this.command=De}};Pe=Ge([P],Pe),e.InlineSuggestion=Pe;let xe=class{constructor(W){this.items=W}};xe=Ge([P],xe),e.InlineSuggestions=xe;var Xe;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var ze;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ze=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ot;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(ot=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ie;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function W(oe){switch(oe){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(Ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor(W,oe){if(oe&&!y.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!M.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=oe}};Ee=Ge([P],Ee),e.DocumentLink=Ee;let we=class{constructor(W,oe,De,et){this.red=W,this.green=oe,this.blue=De,this.alpha=et}};we=Ge([P],we),e.Color=we;let Fe=class{constructor(W,oe){if(oe&&!(oe instanceof we))throw(0,L.illegalArgument)("color");if(!M.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=oe}};Fe=Ge([P],Fe),e.ColorInformation=Fe;let Ke=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};Ke=Ge([P],Ke),e.ColorPresentation=Ke;var Ve;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Ve=e.ColorFormat||(e.ColorFormat={}));var Je;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(W,oe,De){if(this.startIndex=W,this.length=oe,this.tooltip=De,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=rt;var Ue;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Ue=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(W){this.options=W,typeof W!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=pe;var be;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(be=e.TaskRevealKind||(e.TaskRevealKind={}));var ie;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(ie=e.TaskPanelKind||(e.TaskPanelKind={}));let K=l=class{constructor(W,oe){if(this.label=oe,typeof W!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};K.Clean=new l("clean","Clean"),K.Build=new l("build","Build"),K.Rebuild=new l("rebuild","Rebuild"),K.Test=new l("test","Test"),K=l=Ge([P],K),e.TaskGroup=K;function Se(V){let W="";for(let oe=0;oe<V.length;oe++)W+=V[oe].replace(/,/g,",,")+",";return W}let Le=class{constructor(W,oe,De){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=W,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=De):this._options=oe)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)W.push(oe);return Se(W)}};Le=Ge([P],Le),e.ProcessExecution=Le;let nt=class{constructor(W,oe,De){if(this._args=[],Array.isArray(oe)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W,this._args=oe,this._options=De}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)W.push(typeof oe=="string"?oe:oe.value);return Se(W)}};nt=Ge([P],nt),e.ShellExecution=nt;var Qe;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Qe=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class bt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=bt;let ht=h=class{constructor(W,oe,De,et,st,dt){this.__deprecated=!1,this._definition=this.definition=W;let mt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=De,this.execution=et,mt=st,this.__deprecated=!0):oe===gt.Global||oe===gt.Workspace?(this.target=oe,this._name=this.name=De,this._source=this.source=et,this.execution=st,mt=dt):(this.target=oe,this._name=this.name=De,this._source=this.source=et,this.execution=st,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof nt?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const oe=this._definition.type;(h.EmptyType===oe||h.ProcessType===oe||h.ShellType===oe||h.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=h=Ge([P],ht),e.Task=ht;var pt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(pt=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(W,oe=yt.None){this.collapsibleState=oe,y.URI.isUri(W)?this.resourceUri=W:this.label=W}};ut=Ge([P],ut),e.TreeItem=ut;var yt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(W,oe){this.id=W,this.color=oe}};Dt=Ge([P],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let xt=class{constructor(W){this.id=W}};xt=Ge([P],xt),e.ThemeColor=xt;var $t;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})($t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Pt=class{constructor(W,oe){if(typeof W!="string"&&(!W||!y.URI.isUri(W)&&!y.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=y.URI.file(W),this.base=W):y.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=oe}};Pt=Ge([P],Pt),e.RelativePattern=Pt;let Wt=class{constructor(W,oe,De,et){this.enabled=typeof W=="boolean"?W:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Wt=Ge([P],Wt),e.Breakpoint=Wt;let en=class extends Wt{constructor(W,oe,De,et,st){super(oe,De,et,st);if(W===null)throw(0,L.illegalArgument)("location");this.location=W}};en=Ge([P],en),e.SourceBreakpoint=en;let Et=class extends Wt{constructor(W,oe,De,et,st){super(oe,De,et,st);this.functionName=W}};Et=Ge([P],Et),e.FunctionBreakpoint=Et;let Qt=class extends Wt{constructor(W,oe,De,et,st,dt,mt){super(et,st,dt,mt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=oe,this.canPersist=De}};Qt=Ge([P],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(W,oe,De){this.command=W,this.args=oe||[],this.options=De}};jt=Ge([P],jt),e.DebugAdapterExecutable=jt;let tn=class{constructor(W,oe){this.port=W,this.host=oe}};tn=Ge([P],tn),e.DebugAdapterServer=tn;let nn=class{constructor(W){this.path=W}};nn=Ge([P],nn),e.DebugAdapterNamedPipeServer=nn;let Tt=class{constructor(W){this.implementation=W}};Tt=Ge([P],Tt),e.DebugAdapterInlineImplementation=Tt;let Xt=class{constructor(W,oe){this.range=W,this.expression=oe}};Xt=Ge([P],Xt),e.EvaluatableExpression=Xt;var bn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(W,oe){this.range=W,this.text=oe}};Ht=Ge([P],Ht),e.InlineValueText=Ht;let zt=class{constructor(W,oe,De=!0){this.range=W,this.variableName=oe,this.caseSensitiveLookup=De}};zt=Ge([P],zt),e.InlineValueVariableLookup=zt;let vt=class{constructor(W,oe){this.range=W,this.expression=oe}};vt=Ge([P],vt),e.InlineValueEvaluatableExpression=vt;let rn=class{constructor(W,oe){this.frameId=W,this.stoppedLocation=oe}};rn=Ge([P],rn),e.InlineValueContext=rn;var Ot;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=w=class extends Error{constructor(W,oe=n.FileSystemProviderErrorCode.Unknown,De){super(y.URI.isUri(W)?W.toString(!0):W);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(W){return new w(W,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(W){return new w(W,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(W){return new w(W,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(W){return new w(W,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Nt=w=Ge([P],Nt),e.FileSystemError=Nt;let Yt=class{constructor(W,oe,De){this.start=W,this.end=oe,this.kind=De}};Yt=Ge([P],Yt),e.FoldingRange=Yt;var En;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor(W,oe=[]){this.tokenTypes=W,this.tokenModifiers=oe}}e.SemanticTokensLegend=mn;function sn(V){return typeof V=="undefined"||(0,S.isStringArray)(V)}class on{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let oe=0,De=W.tokenTypes.length;oe<De;oe++)this._tokenTypeStrToInt.set(W.tokenTypes[oe],oe);for(let oe=0,De=W.tokenModifiers.length;oe<De;oe++)this._tokenModifierStrToInt.set(W.tokenModifiers[oe],oe)}}push(W,oe,De,et,st){if(typeof W=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof et=="number"&&(typeof st=="number"||typeof st=="undefined"))return typeof st=="undefined"&&(st=0),this._pushEncoded(W,oe,De,et,st);if(M.isRange(W)&&typeof oe=="string"&&sn(De))return this._push(W,oe,De);throw(0,L.illegalArgument)()}_push(W,oe,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const et=W.start.line,st=W.start.character,dt=W.end.character-W.start.character,mt=this._tokenTypeStrToInt.get(oe);let kt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);kt|=1<<Lt>>>0}this._pushEncoded(et,st,dt,mt,kt)}_pushEncoded(W,oe,De,et,st){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<kt;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=At,dn+=Lt):Ut+=At,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,At=Ut,Lt=dn}}let dt=W,mt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=et,this._data[this._dataLen++]=st,this._prevLine=W,this._prevChar=oe}static _sortAndDeltaEncode(W){let oe=[];const De=W.length/5|0;for(let mt=0;mt<De;mt++)oe[mt]=mt;oe.sort((mt,kt)=>{const At=W[5*mt],Lt=W[5*kt];if(At===Lt){const Mt=W[5*mt+1],Ut=W[5*kt+1];return Mt-Ut}return At-Lt});const et=new Uint32Array(W.length);let st=0,dt=0;for(let mt=0;mt<De;mt++){const kt=5*oe[mt],At=W[kt+0],Lt=W[kt+1],Mt=W[kt+2],Ut=W[kt+3],dn=W[kt+4],Bn=At-st,Gn=Bn===0?Lt-dt:Lt,hn=5*mt;et[hn+0]=Bn,et[hn+1]=Gn,et[hn+2]=Mt,et[hn+3]=Ut,et[hn+4]=dn,st=At,dt=Lt}return et}build(W){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),W):new qt(on._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=on;class qt{constructor(W,oe){this.resultId=oe,this.data=W}}e.SemanticTokens=qt;class an{constructor(W,oe,De){this.start=W,this.deleteCount=oe,this.data=De}}e.SemanticTokensEdit=an;class Sn{constructor(W,oe){this.resultId=oe,this.edits=W}}e.SemanticTokensEdits=Sn;var yn;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new Dt("arrow-left")},Jt=Ge([P],Jt),e.QuickInputButtons=Jt;var Dn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,oe,De){this.badge=W,this.tooltip=oe,this.color=De}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor(W){this.kind=W}};ln=Ge([P],ln),e.ColorTheme=ln;var cn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(cn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(W,oe){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");W<=oe?(this._start=W,this._end=oe):(this._start=oe,this._end=W)}static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let oe=this._start,De=this._end;return W.start!==void 0&&(oe=W.start),W.end!==void 0&&(De=W.end),oe===this._start&&De===this._end?this:new Vt(oe,De)}}e.NotebookRange=Vt;class Ft{constructor(W,oe,De,et,st,dt,mt){this.kind=W,this.value=oe,this.languageId=De,this.mime=et,this.outputs=st??[],this.metadata=dt,this.executionSummary=mt,Ft.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(oe=>Ft.isNotebookCellData(oe))}static isNotebookCellData(W){return!0}}e.NotebookCellData=Ft;class Ne{constructor(W){this.cells=W}}e.NotebookData=Ne;class Rt{constructor(W,oe){this.data=W,this.mime=oe;const De=(0,A.normalizeMimeType)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(W){return W instanceof Rt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const oe={name:W.name,message:W.message,stack:W.stack};return Rt.json(oe,"application/vnd.code.notebook.error")}static stdout(W){return Rt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Rt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,oe="application/octet-stream"){return new Rt(W,oe)}static text(W,oe=A.Mimes.text){const De=Oe(Rt,d,"f",p).encode(String(W));return new Rt(De,oe)}static json(W,oe="application/json"){const De=JSON.stringify(W,void 0,"	");return Rt.text(De,oe)}}e.NotebookCellOutputItem=Rt,d=Rt,p={value:new TextEncoder};class Kt{constructor(W,oe,De){this.items=Kt.ensureUniqueMimeTypes(W,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,T.generateUuid)(),this.metadata=oe??De)}static isNotebookCellOutput(W){return W instanceof Kt?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,S.isArray)(W.items)}static ensureUniqueMimeTypes(W,oe=!1){const De=new Set,et=new Set;for(let st=0;st<W.length;st++){const dt=W[st],mt=(0,A.normalizeMimeType)(dt.mime);if(!De.has(mt)){De.add(mt);continue}et.add(st),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return et.size===0?W:W.filter((st,dt)=>!et.has(dt))}}e.NotebookCellOutput=Kt;var _t;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(_t=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(W,oe){this.text=W,this.alignment=oe}}e.NotebookCellStatusBarItem=pn;var Pn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(W,oe=[]){this.uri=W,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=Tn;let un=class{constructor(W,oe){this.label=W,this.timestamp=oe}};un=Ge([P],un),e.TimelineItem=un;var An;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(W,oe){this.ranges=W,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class Fn{constructor(W,oe){this._port=W,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let re=class{constructor(W,oe,De){this.include=W,this.exclude=oe,this.profile=De}};re=Ge([P],re),e.TestRunRequest=re;let he=_=class{constructor(W){this.message=W}static diff(W,oe,De){const et=new _(W);return et.expectedOutput=oe,et.actualOutput=De,et}};he=_=Ge([P],he),e.TestMessage=he;let Re=class{constructor(W){this.id=W}};Re=Ge([P],Re),e.TestTag=Re;let ct=class{constructor(W,oe){this.covered=W,this.total=oe}};ct=Ge([P],ct),e.CoveredCount=ct;let St=v=class{constructor(W,oe,De,et){this.uri=W,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=et}static fromDetails(W,oe){const De=new ct(0,0),et=new ct(0,0),st=new ct(0,0);for(const mt of oe)if("branches"in mt){De.total+=1,De.covered+=mt.executionCount>0?1:0;for(const kt of mt.branches)et.total+=1,et.covered+=kt.executionCount>0?1:0}else st.total+=1,st.covered+=mt.executionCount>0?1:0;const dt=new v(W,De,et.total>0?et:void 0,st.total>0?st:void 0);return dt.detailedCoverage=oe,dt}};St=v=Ge([P],St),e.FileCoverage=St;let It=class{constructor(W,oe,De=[]){this.executionCount=W,this.location=oe,this.branches=De}};It=Ge([P],It),e.StatementCoverage=It;let Nn=class{constructor(W,oe){this.executionCount=W,this.location=oe}};Nn=Ge([P],Nn),e.BranchCoverage=Nn;let Un=class{constructor(W,oe){this.executionCount=W,this.location=oe}};Un=Ge([P],Un),e.FunctionCoverage=Un;var zn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(W,oe,De,et,st,dt){this.kind=W,this.name=oe,this.detail=De,this.uri=et,this.range=st,this.selectionRange=dt}}e.TypeHierarchyItem=qn}),define(fe[123],me([0,1,57,10,9,150,110,7,16]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function n(d,p){p?T.set(d,p):T.delete(d)}e.setWordDefinitionFor=n;function I(d){return T.get(d)}e.getWordDefinitionFor=I;class c extends C.MirrorTextModel{constructor(p,D,R,E,a,o,m,t){super(D,R,E,a);this._proxy=p,this._languageId=o,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,y.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===L.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(D){return D?p._getTextInRange(D):p.getText()},get eol(){return p._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(D){return p._lineAt(D)},offsetAt(D){return p._offsetAt(D)},positionAt(D){return p._positionAt(D)},validateRange(D){return p._validateRange(D)},validatePosition(D){return p._validatePosition(D)},getWordRangeAtPosition(D,R){return p._getWordRangeAtPosition(D,R)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,g.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,g.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const D=this._validateRange(p);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const R=this._eol,E=D.start.line,a=D.end.line,o=[];o.push(this._lines[E].substring(D.start.character));for(let m=E+1;m<a;m++)o.push(this._lines[m]);return o.push(this._lines[a].substring(0,D.end.character)),o.join(R)}_lineAt(p){let D;if(p instanceof S.Position?D=p.line:typeof p=="number"&&(D=p),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new f(D,this._lines[D],D===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(p),R=this._lines[D.index].length;return new S.Position(D.index,Math.min(D.remainder,R))}_validateRange(p){if(!(p instanceof S.Range))throw new Error("Invalid argument");const D=this._validatePosition(p.start),R=this._validatePosition(p.end);return D===p.start&&R===p.end?p:new S.Range(D.line,D.character,R.line,R.character)}_validatePosition(p){if(!(p instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:D,character:R}=p,E=!1;if(D<0)D=0,R=0,E=!0;else if(D>=this._lines.length)D=this._lines.length-1,R=this._lines[D].length,E=!0;else{const a=this._lines[D].length;R<0?(R=0,E=!0):R>a&&(R=a,E=!0)}return E?new S.Position(D,R):p}_getWordRangeAtPosition(p,D){const R=this._validatePosition(p);if(!D)D=I(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const E=(0,A.getWordAtText)(R.character+1,(0,A.ensureValidWordDefinition)(D),this._lines[R.line],0);if(E)return new S.Range(R.line,E.startColumn-1,R.line,E.endColumn-1)}}e.ExtHostDocumentData=c;class f{constructor(p,D,R){this._line=p,this._text=D,this._isLastLine=R}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(fe[203],me([0,1,7,3,112,6,81,24,2,32]),function(J,e,g,L,k,C,A,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(c,f,d,p){this._notebook=d,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(R=>{const E=this._cellUris.get(R.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=R=>{R===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(R=>D(R.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const c=[],f=[];for(const d of this._notebook.getCells())d.kind===g.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),c.push(d.document.getText().length+1),f.push(d.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(c){if(!c){let E="";for(const a of this._cells)E+=a.document.getText()+`
`;return E=E.slice(0,-1),E}if(c.isEmpty)return"";const f=this.locationAt(c.start),d=this.locationAt(c.end),p=this._cellUris.get(f.uri),D=this._cellUris.get(d.uri);if(p===void 0||D===void 0)return"";if(p===D)return this._cells[p].document.getText(new g.Range(f.range.start,d.range.end));const R=[this._cells[p].document.getText(new g.Range(f.range.start,new g.Position(this._cells[p].document.lineCount,0)))];for(let E=p+1;E<D;E++)R.push(this._cells[E].document.getText());return R.push(this._cells[D].document.getText(new g.Range(new g.Position(0,0),d.range.end))),R.join(`
`)}offsetAt(c){const f=this._cellLines.getIndexOf(c.line),d=this._cellLengths.getPrefixSum(f.index-1),p=this._cells[f.index].document.offsetAt(c.with(f.remainder));return d+p}positionAt(c){if(typeof c=="number"){const d=this._cellLengths.getIndexOf(c),p=this._cellLines.getPrefixSum(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(p)}const f=this._cellUris.get(c.uri);if(f!==void 0){const d=this._cellLines.getPrefixSum(f-1);return new g.Position(d+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const f=this._cellLines.getIndexOf(c.start.line);let d=f;c.isEmpty||(d=this._cellLines.getIndexOf(c.end.line));const p=new g.Position(f.remainder,c.start.character),D=new g.Position(d.remainder,c.end.character),R=new g.Range(p,D),E=this._cells[f.index];return new g.Location(E.document.uri,E.document.validateRange(R))}contains(c){return this._cellUris.has(c)}validateRange(c){const f=this.validatePosition(c.start),d=this.validatePosition(c.end);return c.with(f,d)}validatePosition(c){const f=this._cellLines.getIndexOf(c.line),d=new g.Position(f.remainder,c.character),p=this._cells[f.index].document.validatePosition(d),D=this._cellLines.getPrefixSum(f.index-1);return new g.Position(D+p.line,p.character)}}e.ExtHostNotebookConcatDocument=n}),define(fe[204],me([0,1,7,14,3]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(S){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let y=S==="light"?g.ColorThemeKind.Light:S==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ge([We(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(fe[66],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=L}),define(fe[205],me([0,1,22]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function k(S,y){if(y.serializeBuffersForPostMessage){const T=new L,n=(f,d)=>{if(d instanceof ArrayBuffer){const p=T.add(d);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(d)){const p=C(d);if(p){const D=T.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:p,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},I=JSON.stringify(S,n),c=T.buffers.map(f=>{const d=new Uint8Array(f);return g.VSBuffer.wrap(d)});return{message:I,buffers:c}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=k;function C(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(S,y){const T=y.map(c=>{const f=new ArrayBuffer(c.byteLength);return new Uint8Array(f).set(c.buffer),f}),n=y.length?(c,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const d=f,{index:p}=d,D=T[p];if(d.view)switch(d.view.type){case 1:return new Int8Array(D,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return f}:void 0;return{message:JSON.parse(S,n),arrayBuffers:T}}e.deserializeWebviewMessage=A}),define(fe[206],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function k(A){const S={items:new Map};return A.types.forEach((y,T)=>{S.items.set(y,{asString:async()=>A.items[T].asString})}),S}L.toITreeDataTransfer=k;async function C(A){const S={types:[],items:[]},y=Array.from(A.items.entries());for(const T of y)S.types.push(T[0]),S.items.push({asString:await T[1].asString()});return S}L.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[88],me([0,1,10,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(S,y){return S.scheme===g.Schemas.http||S.scheme===g.Schemas.https?S:(y&&y.authority&&y.isRemote&&S.scheme===g.Schemas.file&&(S=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:y.authority,path:S.path})),L.URI.from({scheme:g.Schemas.https,authority:`${S.scheme}+${C(S.authority)}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=k;function C(S){return S.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function A(S){return S.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=A}),define(fe[207],me([0,1,3,6,88]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(S,y,T){this._proxy=S,this._editors=y,this._initData=T,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,y,T,n,I){let c;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===S){c=a;break}if(!c)throw new Error("not a visible editor");const f=this,d=this._handlePool++,p=new g.Emitter,D=new g.Emitter,R=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,k.asWebviewUri)(a,f._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(d,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(d,a)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(a){return f._proxy.$postMessage(d,a)}},E=new class{constructor(){this.editor=S,this.line=y,this.height=T,this.webview=R,this.onDidDispose=D.event}dispose(){f._insets.has(d)&&(f._insets.delete(d),f._proxy.$disposeEditorInset(d),D.fire(),D.dispose(),p.dispose())}};return this._proxy.$createEditorInset(d,c.id,c.value.document.uri,y+1,T,n||{},I.identifier,I.extensionLocation),this._insets.set(d,{editor:S,inset:E,onDidReceiveMessage:p}),E}$onDidDispose(S){const y=this._insets.get(S);y&&y.inset.dispose()}$onDidReceiveMessage(S,y){const T=this._insets.get(S);T&&T.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=C}),define(fe[208],me([0,1,172,12,2,6,4,63,34,16,10]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new S.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new S.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new S.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new S.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new S.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new S.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new S.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new S.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new S.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new S.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new S.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new S.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new S.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new S.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new S.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new S.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new S.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new S.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new S.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new S.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new S.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new S.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(F,M,q){for(const G of q.visibleEditorPanes)if(G.group.id===M&&F.matches(G.input))return G.getViewState()}e.findViewStateForEditor=I;function c(F){if(o(F))return!1;const M=F;return k.URI.isUri(M?.resource)}e.isResourceEditorInput=c;function f(F){if(o(F))return!1;const M=F;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=f;function d(F){if(o(F)||f(F))return!1;const M=F;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function p(F){if(o(F))return!1;const M=F;return M?M.resource===void 0||M.resource.scheme===n.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var D;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var R;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(R=e.SaveReason||(e.SaveReason={}));var E;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends C.Disposable{}e.AbstractEditorInput=a;function o(F){return F instanceof a}e.isEditorInput=o;function m(F){const M=F;return k.URI.isUri(M?.preferredResource)}function t(F){const M=F;return o(M?.primary)&&o(M?.secondary)}e.isSideBySideEditorInput=t;function u(F){const M=F;return o(M?.modified)&&o(M?.original)}e.isDiffEditorInput=u;function r(F){return o(F?.editor)}e.isEditorInputWithOptions=r;function i(F){const M=F;return r(F)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function s(F){const M=F;return typeof M?.groupId=="number"&&o(M.editor)}e.isEditorIdentifier=s;var l;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(M,q){if(!M)return;if(q?.supportSideBySide){const{primary:U,secondary:z}=this.getSideEditors(M);if(U&&z){if(q?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(z,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===h.ANY)return this.getOriginalUri(U,{filterByScheme:q.filterByScheme})??this.getOriginalUri(z,{filterByScheme:q.filterByScheme});M=q.supportSideBySide===h.PRIMARY?U:z}}if(f(M)||d(M))return;const G=m(M)?M.preferredResource:M.resource;return!G||!q||!q.filterByScheme?G:this.filterUri(G,q.filterByScheme)}getSideEditors(M){return t(M)||d(M)?{primary:M.primary,secondary:M.secondary}:u(M)||f(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,q){if(!M)return;if(q?.supportSideBySide){const{primary:U,secondary:z}=this.getSideEditors(M);if(U&&z){if(q?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(z,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===h.ANY)return this.getCanonicalUri(U,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(z,{filterByScheme:q.filterByScheme});M=q.supportSideBySide===h.PRIMARY?U:z}}if(f(M)||d(M))return;const G=M.resource;return!G||!q||!q.filterByScheme?G:this.filterUri(G,q.filterByScheme)}filterUri(M,q){if(Array.isArray(q)){if(q.some(G=>M.scheme===G))return M}else if(q===M.scheme)return M}}e.EditorResourceAccessor=new w;var _;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class v{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const q=this.instantiationService=M.get(A.IInstantiationService);for(const[G,U]of this.editorSerializerConstructors)this.createEditorSerializer(G,U,q);this.editorSerializerConstructors.clear()}createEditorSerializer(M,q,G){const U=G.createInstance(q);this.editorSerializerInstances.set(M,U)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,q){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,q,this.instantiationService):this.editorSerializerConstructors.set(M,q),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new v);async function P(F,M){if(!F||!F.length)return[];const q=await Promise.all(F.map(async G=>{const U=k.URI.revive(G.fileUri);if(!U||(await M.activateProvider(U.scheme),!M.canHandleResource(U)))return;const z=typeof G.exists=="boolean"?G.exists:await M.exists(U);if(!z&&G.openOnlyIfExists)return;const O={selection:z?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let N;return z?N={resource:U,options:O}:N={resource:U,options:O,forceUntitled:!0},N}));return(0,T.coalesce)(q)}e.pathsToEditors=P;var b;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(b=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[209],me([0,1,3,63,173,4,6,24,34,16,58,25,47,198]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",c.Codicon.window,(0,k.localize)(0,null));var d;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(d=e.Extensions||(e.Extensions={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(p=e.ViewContainerLocation||(e.ViewContainerLocation={}));function D(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=D;function R(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=R;class E extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,h,w){const _=this.get(l.id);if(_)return _;const v=l;return v.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,S.getOrSet)(this.viewContainers,h,[]).push(v),w?.isDefault&&this.defaultViewContainers.push(v),this._onDidRegister.fire({viewContainer:v,viewContainerLocation:h}),v}deregisterViewContainer(l){for(const h of this.viewContainers.keys()){const w=this.viewContainers.get(h),_=w?.indexOf(l);if(_!==-1){w?.splice(_,1),w.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:h});return}}}get(l){return this.all.filter(h=>h.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(w=>w?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===l)}}y.Registry.add(d.ViewContainersRegistry,new E);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function o(s,l){const h=s.group??a.More,w=l.group??a.More;return h!==w?h.localeCompare(w):(s.order??5)-(l.order??5)}class m extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(l,h){this.registerViews2([{views:l,viewContainer:h}])}registerViews2(l){l.forEach(({views:h,viewContainer:w})=>this.addViews(h,w)),this._onViewsRegistered.fire(l)}deregisterViews(l,h){const w=this.removeViews(l,h);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:h})}moveViews(l,h){for(const w of this._views.keys())if(w!==h){const _=this.removeViews(l,w);_.length&&(this.addViews(_,h),this._onDidChangeContainer.fire({views:_,from:w,to:h}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const h of this._viewContainers){const w=(this._views.get(h)||[]).filter(_=>_.id===l)[0];if(w)return w}return null}getViewContainer(l){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(_=>_.id===l)[0])return h;return null}registerViewWelcomeContent(l,h){return this._viewWelcomeContents.add(l,h),this._onDidChangeViewWelcomeContent.fire(l),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(l,h),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,h){const w=new Map;for(const[_,v]of h)this._viewWelcomeContents.add(l,v),w.set(_,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(l,v),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),w}getViewWelcomeContent(l){const h=[];return this._viewWelcomeContents.forEach(l,w=>h.push(w)),h.sort(o)}addViews(l,h){let w=this._views.get(h);w||(w=[],this._views.set(h,w),this._viewContainers.push(h));for(const _ of l){if(this.getView(_.id)!==null)throw new Error((0,k.localize)(1,null,_.id));w.push(_)}}removeViews(l,h){const w=this._views.get(h);if(!w)return[];const _=[],v=[];for(const P of w)l.includes(P)?_.push(P):v.push(P);return _.length&&(v.length?this._views.set(h,v):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),_}}y.Registry.add(d.ViewsRegistry,new m),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,h){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,l),this._hasResolve=!!h,this.resolve=async w=>{if(h&&!this.resolved){const _=await h(w);_&&(this.tooltip=this.tooltip??_.tooltip,this.command=this.command??_.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[124],me([0,1,3,18,174]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,y,T,n){const I={command:S};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof n=="number"){const c=setTimeout(()=>{clearTimeout(c);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const d={type:"response",seq:0,request_seq:I.seq,success:!1,command:S,message:(0,k.localize)(0,null,n,S)};f(d)}},n)}return T&&this.pendingRequests.set(I.seq,T),I.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,y){return S.type!=="event"||y.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,L.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const y=S,T=this.pendingRequests.get(y.request_seq);T&&(this.pendingRequests.delete(y.request_seq),T(y));break}}}internalSend(S,y){y.type=S,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((y,T)=>S.set(T,y)),await(0,L.timeout)(500),S.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(fe[210],me([0,1,9,2,8,25,10]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function y(r,i,s){return r.replace(S,function(l,h){return i&&h.length>0&&h[0]!=="_"?l:s&&s.hasOwnProperty(h)?s[h]:l})}e.formatPII=y;function T(r){const i={};for(const s of Object.keys(r))s.startsWith("!")||(i[s]=r[s]);return i}e.filterExceptionsFromTelemetry=T;function n(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function I(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(i,"extensionhost")||(0,g.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function f(r,i,s){let l,h=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=w.exec(r);){let v=_.index+1,P=v+_[0].length;if(v<=i&&P>=s){l=_[0],h=v;break}}if(l){let v=/\w+/g,P=null;for(;(P=v.exec(l))&&!(P.index+1+h+P[0].length>=s););P&&(l=l.substring(0,v.lastIndex))}return l?{start:h,end:h+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(r){return!!(r&&r.match(d))}e.isUri=p;function D(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(p(r.path))return L.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function R(r){if(typeof r.path=="object"){const i=L.URI.revive(r.path);if(i)return i.scheme===A.Schemas.file?i.fsPath:i.toString()}return r.path}function E(r,i){const s=i?D:R,l=(0,C.deepClone)(r);return o(l,(h,w)=>{h&&w&&(w.path=s(w))}),l}e.convertToDAPaths=E;function a(r,i){const s=i?D:R,l=(0,C.deepClone)(r);return o(l,(h,w)=>{!h&&w&&(w.path=s(w))}),l}e.convertToVSCPaths=a;function o(r,i){switch(r.type){case"event":const s=r;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break;case"request":const l=r;switch(l.command){case"setBreakpoints":i(!0,l.arguments.source);break;case"breakpointLocations":i(!0,l.arguments.source);break;case"source":i(!0,l.arguments.source);break;case"gotoTargets":i(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>i(!1,w));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(w=>i(!1,w.source));break;case"loadedSources":h.body.sources.forEach(w=>i(!1,w));break;case"scopes":h.body.scopes.forEach(w=>i(!1,w.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(w=>i(!1,w.source));break;case"setBreakpoints":h.body.breakpoints.forEach(w=>i(!1,w.source));break;default:break}break}}function m(r){return r.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):t(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=m;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function u(r,i){const s=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const l=i.activeEditorPane;l&&await i.save({editor:l.input,groupId:l.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(fe[211],me([0,1,28,39,175,125,8,9,25,11,185,124]),function(J,e,g,L,k,C,A,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",o=>this.handleData(o))}sendMessage(E){if(this.outputStream){const a=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${c.TWO_CRLF}${a}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+a))}continue}}else{const a=this.rawData.indexOf(c.TWO_CRLF);if(a!==-1){const m=this.rawData.toString("utf8",0,a).split(c.HEADER_LINESEPARATOR);for(const t of m){const u=t.split(c.HEADER_FIELDSEPARATOR);u[0]==="Content-Length"&&(this.contentLength=Number(u[1]))}this.rawData=this.rawData.slice(a+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class f extends c{startSession(){return new Promise((E,a)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",m=>{o?this._onError.fire(m):a(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class d extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=d;class p extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=p;class D extends c{constructor(E,a,o){super();this.adapterExecutable=E,this.debugType=a,this.outputService=o}async startSession(){const E=this.adapterExecutable.command,a=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(E)if(A.isAbsolute(E)){if(!await g.Promises.exists(E))throw new Error(k.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let m=process.env;if(o.env&&Object.keys(o.env).length>0&&(m=y.mixin(y.deepClone(process.env),o.env)),E==="node")if(Array.isArray(a)&&a.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const i=L.fork(a[0],a.slice(1),r);if(!i.pid)throw new Error(k.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const u={env:m};o.cwd&&(u.cwd=o.cwd),this.serverProcess=L.spawn(E,a,u)}this.serverProcess.on("error",u=>{this._onError.fire(u)}),this.serverProcess.on("exit",(u,r)=>{this._onExit.fire(u)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stdin.on("error",u=>{this._onError.fire(u)});const t=this.outputService;if(t){const u=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(u(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((E,a)=>{const o=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,t,u){if(m)return a(m)});o.on("exit",E),o.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,a){if(!E)return;const o=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?o.runtime=A.join(a,E.runtime):o.runtime=E.runtime),E.runtimeArgs&&(o.runtimeArgs=E.runtimeArgs),E.program&&(A.isAbsolute(E.program)?o.program=E.program:o.program=A.join(a,E.program)),E.args&&(o.args=E.args);const m=E;return m.win&&(o.win=D.extract(m.win,a)),m.winx86&&(o.winx86=D.extract(m.winx86,a)),m.windows&&(o.windows=D.extract(m.windows,a)),m.osx&&(o.osx=D.extract(m.osx,a)),m.linux&&(o.linux=D.extract(m.linux,a)),o}static platformAdapterExecutable(E,a){let o=Object.create(null);a=a.toLowerCase();for(const s of E)if(s.contributes){const l=s.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&S.equalsIgnoreCase(h.type,a)).forEach(h=>{const w=D.extract(h,s.extensionLocation.fsPath);o=y.mixin(o,w,s.isBuiltin)})}let m;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=o.winx86||o.win||o.windows:T.isWindows?m=o.win||o.windows:T.isMacintosh?m=o.osx:T.isLinux&&(m=o.linux),m=m||o;let t=m.program||o.program;const u=m.args||o.args;let r=m.runtime||o.runtime;const i=m.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(u||[])};if(t)return{type:"executable",command:t,args:u||[]}}}e.ExecutableDebugAdapter=D}),define(fe[212],me([0,1,39,11,29,188]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(c,f){return new Promise((d,p)=>{let D="";const R=g.spawn(c,f);R.pid&&R.stdout.on("data",E=>{D+=E.toString()}),R.on("error",E=>{p(E)}),R.on("close",E=>{d(D)})})}let S;function y(c,f){if(!S)if(L.isWindows)S=new C.WindowsExternalTerminalService;else if(L.isMacintosh)S=new C.MacExternalTerminalService;else if(L.isLinux)S=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const d=f.getConfiguration("terminal");return S.runInTerminal(c.title,c.cwd,c.args,c.env||{},d.external||{})}e.runInExternalTerminal=y;function T(c){return c?L.isWindows?new Promise(async f=>{(await new Promise((p,D)=>{J(["windows-process-tree"],p,D)})).getProcessTree(c,p=>{f(p.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(c)]).then(f=>{const d=f.trim();return!(d.length===0||d.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=T;var n;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(n||(n={}));function I(c,f,d,p){c=c.trim().toLowerCase();let D;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?D=1:c.indexOf("cmd.exe")>=0?D=0:c.indexOf("bash")>=0?D=2:L.isWindows?D=0:D=2;let R,E=" ";switch(D){case 1:if(R=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),d){const o=(0,k.getDriveLetter)(d);o&&(E+=`${o}:; `),E+=`cd ${R(d)}; `}if(p)for(let o in p){const m=p[o];m===null?E+=`Remove-Item env:${o}; `:E+=`\${env:${o}}='${m}'; `}if(f.length>0){const o=R(f.shift());E+=o[0]==="'"?`& ${o} `:`${o} `;for(let m of f)E+=`${R(m)} `}break;case 0:if(R=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),d){const o=(0,k.getDriveLetter)(d);o&&(E+=`${o}: && `),E+=`cd ${R(d)} && `}if(p){E+='cmd /C "';for(let o in p){let m=p[o];m===null?E+=`set "${o}=" && `:(m=m.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${o}=${m}" && `)}}for(let o of f)E+=`${R(o)} `;p&&(E+='"');break;case 2:R=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const a=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(d&&(E+=`cd ${R(d)} ; `),p){E+="/usr/bin/env";for(let o in p){const m=p[o];m===null?E+=` -u ${a(o)}`:E+=` ${a(`${o}=${m}`)}`}E+=" "}for(let o of f)E+=`${R(o)} `;break}return E}e.prepareCommand=I}),define(fe[126],me([0,1,30,102,10,8,11,63]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var D;(function(v){v.scheme=k.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function b(U,z){return U.with({scheme:v.scheme,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==k.Schemas.file?U.scheme:""}`})}v.generate=b;function F(U){if(U.scheme!==v.scheme)return;const z=P.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}v.parse=F;function M(U){if(U.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const z=P.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}v.parseCellMetadataUri=M;function q(U,z,O){return U.with({scheme:O,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==k.Schemas.file?U.scheme:""}`})}v.generateCellUri=q;function G(U,z){if(U.scheme!==z)return;const O=P.exec(U.fragment);return O?{handle:Number(O[1]),notebook:U.with({scheme:U.fragment.substr(O[0].length)||k.Schemas.file,fragment:null})}:void 0}v.parseCellUri=G})(D=e.CellUri||(e.CellUri={}));const R=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(v){return R.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function a(v){return R.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function o(v){return R.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=o;function m(v,P){return A.isWindows&&(v=v.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),g.match(v,P)}function t(v,P,b){let F=0;for(let M=0;M<P.length;M++){if(m(P[M],v))return F;F++}for(let M=0;M<b.length;M++){if(m(b[M],v))return F;F++}return F}function u(v,P,b){return v.sort((F,M)=>t(F,P,b)-t(M,P,b))}e.sortMimeTypes=u;function r(v,P,b,F=(M,q)=>M===q){const M=[];function q(z,O,N){if(O===0&&N.length===0)return;const x=M[M.length-1];x&&x.start+x.deleteCount===z?(x.deleteCount+=O,x.toInsert.push(...N)):M.push({start:z,deleteCount:O,toInsert:N})}let G=0,U=0;for(;;){if(G===v.length){q(G,0,P.slice(U));break}if(U===P.length){q(G,v.length-G,[]);break}const z=v[G],O=P[U];if(F(z,O)){G+=1,U+=1;continue}b(O)?(q(G,1,[]),G+=1):(q(G,0,[O]),U+=1)}return M}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(v){const P=v;return!!((typeof P.include=="string"||g.isRelativePattern(P.include))&&(typeof P.exclude=="string"||g.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=s;function l(v,P,b){if(Array.isArray(v.viewType)&&v.viewType.indexOf(P)>=0||v.viewType===P)return!0;if(v.filenamePattern){let F=s(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,M=s(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(g.match(F,(0,C.basename)(b.fsPath).toLowerCase()))return!(M&&g.match(M,(0,C.basename)(b.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class h{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let b=0;b<this.textModel.cells.length;b++)P[b]=this.textModel.cells[b].getHashValue();return P}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(P){return`${_._prefix}${P}`}static parse(P){if(P.startsWith(_._prefix))return P.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(fe[213],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState",k[k.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[214],me([0,1,177,4,63]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[215],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(fe[127],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=A;var S;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(S=e.DetailType||(e.DetailType={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(c){}update(c){}remove(c,f){}complete(){}}e.IncrementalChangeCollector=T;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const f=this.createChangeCollector();for(const d of c)switch(d[0]){case 0:{const p=d[1];if(p.parent){if(this.items.has(p.parent)){const D=this.items.get(p.parent);D.children.add(p.item.extId);const R=this.createItem(p,D);this.items.set(p.item.extId,R),f.add(R)}}else{const D=this.createItem(p);this.roots.add(D),this.items.set(p.item.extId,D),f.add(D)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=d[1],D=this.items.get(p.extId);if(!D)break;p.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,p),f.update(D);break}case 2:{const p=this.items.get(d[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const D=[[d[1]]];for(;D.length;)for(const R of D.pop()){const E=this.items.get(R);E&&(D.push(E.children),this.items.delete(R),f.remove(E,E!==p),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d[1]);break;case 3:this.updatePendingRoots(d[1]);break;case 5:this._tags.set(d[1].id,d[1]);break;case 6:this._tags.delete(d[1]);break}f.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=n}),define(fe[89],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class k{constructor(A,S=A.length){if(this.path=A,this.viewEnd=S,A.length===0||S<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,S,y=A.parent){if(A.id===S)return new k([S]);let T=[A.id];for(let n=y;n&&n.id!==S;n=n.parent)T.push(n.id);return T.push(S),new k(T.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new k(A.split("\0"))}static join(A,S){return new k([...A.path,S])}static joinToString(A,S){return A.toString()+"\0"+S}static compare(A,S){return A===S?0:S.startsWith(A+"\0")?2:A.startsWith(S+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new k(this.path,A)}compare(A){if(typeof A=="string")return k.compare(this.toString(),A);for(let S=0;S<A.viewEnd&&S<this.viewEnd;S++)if(A.path[S]!==this.path[S])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=k}),define(fe[216],me([0,1,8,38,12,25,11,79,178]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(I,c,f){this._contributedVariables=new Map,this._context=I,this._labelService=c,f&&(this._envVariablesPromise=f.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(A.isWindows){const c=Object.create(null);return Object.keys(I).forEach(f=>{c[f.toLowerCase()]=I[f]}),c}return I}resolveWithEnvironment(I,c,f){return this.recursiveResolve(this.prepareEnv(I),c?c.uri:void 0,f)}async resolveAsync(I,c){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c)}async resolveAnyBase(I,c,f,d){const p=C.deepClone(c);return A.isWindows&&p.windows?Object.keys(p.windows).forEach(D=>p[D]=p.windows[D]):A.isMacintosh&&p.osx?Object.keys(p.osx).forEach(D=>p[D]=p.osx[D]):A.isLinux&&p.linux&&Object.keys(p.linux).forEach(D=>p[D]=p.linux[D]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,p,f,d)}async resolveAnyAsync(I,c,f){return this.resolveAnyBase(I,c,f)}async resolveAnyMap(I,c,f){const d=new Map;return{newConfig:await this.resolveAnyBase(I,c,f,d),resolvedVariables:d}}resolveWithInteractionReplace(I,c,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,f,d,p){if(k.isString(f))return this.resolveString(I,c,f,d,p);if(k.isArray(f))return f.map(D=>this.recursiveResolve(I,c,D,d,p));if(k.isObject(f)){let D=Object.create(null);return Object.keys(f).forEach(R=>{const E=this.resolveString(I,c,R,d,p);D[E]=this.recursiveResolve(I,c,f[R],d,p)}),D}return f}resolveString(I,c,f,d,p){return f.replace(T.VARIABLE_REGEXP,(R,E)=>{if(E.includes(T.VARIABLE_LHS))return R;let a=this.evaluateSingleVariable(I,R,E,c,d);return p&&p.set(E,a),a!==R&&k.isString(a)&&a.match(T.VARIABLE_REGEXP)&&(a=this.resolveString(I,c,a,d,p)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,f,d,p){let D;const R=f.split(":");R.length>1&&(f=R[0],D=R[1]);const E=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,y.localize)(0,null,c))},a=()=>{const m=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,c,g.basename(m)))},o=()=>{if(D){const m=this._context.getFolderUri(D);if(m)return m;throw new Error((0,y.localize)(2,null,c,D))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,c)):new Error((0,y.localize)(4,null,c))};switch(f){case"env":if(D){if(I){const m=I[A.isWindows?D.toLowerCase():D];if(k.isString(m))return m}return""}throw new Error((0,y.localize)(5,null,c));case"config":if(D){const m=this._context.getConfigurationValue(d,D);if(k.isUndefinedOrNull(m))throw new Error((0,y.localize)(6,null,c,D));if(k.isObject(m))throw new Error((0,y.localize)(7,null,c,D));return m}throw new Error((0,y.localize)(8,null,c));case"command":return this.resolveFromMap(c,D,p,"command");case"input":return this.resolveFromMap(c,D,p,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return d||D?(0,S.normalizeDriveLetter)(this.fsPath(o())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(o()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error((0,y.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,c));case"file":return E();case"fileWorkspaceFolder":return a();case"relativeFile":return d||D?g.relative(this.fsPath(o()),E()):E();case"relativeFileDirname":const u=g.dirname(E());if(d||D){const l=g.relative(this.fsPath(o()),u);return l.length===0?".":l}return u;case"fileDirname":return g.dirname(E());case"fileExtname":return g.extname(E());case"fileBasename":return g.basename(E());case"fileBasenameNoExtension":const r=g.basename(E());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||c;case"execInstallFolder":const s=this._context.getAppRoot();return s||c;case"pathSeparator":return g.sep;default:try{const l=D?`${f}:${D}`:f;return this.resolveFromMap(c,l,p,void 0)}catch(l){return c}}}}resolveFromMap(I,c,f,d){if(c&&f){const p=d===void 0?f[c]:f[d+":"+c];if(typeof p=="string")return p;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[128],me([0,1,4,208]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var C;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var S;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(p){const D=p;return(0,L.isEditorInput)(D?.editor)&&(0,L.isEditorInput)(D?.replacement)}e.isEditorReplacement=T;var n;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(p){p[p.GROUP_ACTIVE=0]="GROUP_ACTIVE",p[p.GROUP_INDEX=1]="GROUP_INDEX",p[p.GROUP_LOCKED=2]="GROUP_LOCKED",p[p.EDITOR_OPEN=3]="EDITOR_OPEN",p[p.EDITOR_CLOSE=4]="EDITOR_CLOSE",p[p.EDITOR_MOVE=5]="EDITOR_MOVE",p[p.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",p[p.EDITOR_LABEL=7]="EDITOR_LABEL",p[p.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",p[p.EDITOR_PIN=9]="EDITOR_PIN",p[p.EDITOR_STICKY=10]="EDITOR_STICKY",p[p.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function f(p){const D=p;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=f;function d(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(fe[217],me([0,1,4,128]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(C){const A=C;return typeof C=="number"||(0,L.isEditorGroup)(A)}e.isPreferredGroup=k}),define(fe[15],me([0,1,16,22,99,292,61,25,12,2,42,83,179,117,65,126,89,217,7]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(pe){function be(K){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:Qe}=K,gt=new E.Position(Se-1,Le-1),bt=new E.Position(nt-1,Qe-1);return new E.Selection(gt,bt)}pe.to=be;function ie(K){const{anchor:Se,active:Le}=K;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}pe.from=ie})(a=e.Selection||(e.Selection={}));var o;(function(pe){function be(K){if(!K)return;const{start:Se,end:Le}=K;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}pe.from=be;function ie(K){if(!K)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:nt,endColumn:Qe}=K;return new E.Range(Se-1,Le-1,nt-1,Qe-1)}pe.to=ie})(o=e.Range||(e.Range={}));var m;(function(pe){function be(ie){switch(ie){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}pe.to=be})(m=e.TokenType||(e.TokenType={}));var t;(function(pe){function be(K){return new E.Position(K.lineNumber-1,K.column-1)}pe.to=be;function ie(K){return{lineNumber:K.line+1,column:K.character+1}}pe.from=ie})(t=e.Position||(e.Position={}));var u;(function(pe){function be(Se,Le){return(0,g.coalesce)((0,g.asArray)(Se).map(nt=>ie(nt,Le)))}pe.from=be;function ie(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:K(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:wt.from(Se.pattern),exclusive:Se.exclusive}}function K(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(u=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(pe){function be(K){switch(K){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}pe.from=be;function ie(K){switch(K){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}pe.to=ie})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(pe){function be(K){let Se;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?Se=String(K.code):Se={value:String(K.code.value),target:K.code.target}),{...o.from(K.range),message:K.message,source:K.source,code:Se,severity:l.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(s.from),tags:Array.isArray(K.tags)?(0,g.coalesce)(K.tags.map(r.from)):void 0}}pe.from=be;function ie(K){const Se=new E.Diagnostic(o.to(K),K.message,l.to(K.severity));return Se.source=K.source,Se.code=(0,y.isString)(K.code)?K.code:K.code?.value,Se.relatedInformation=K.relatedInformation&&K.relatedInformation.map(s.to),Se.tags=K.tags&&(0,g.coalesce)(K.tags.map(r.to)),Se}pe.to=ie})(i=e.Diagnostic||(e.Diagnostic={}));var s;(function(pe){function be(K){return{...o.from(K.location.range),message:K.message,resource:K.location.uri}}pe.from=be;function ie(K){return new E.DiagnosticRelatedInformation(new E.Location(K.resource,o.to(K)),K.message)}pe.to=ie})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(pe){function be(K){switch(K){case E.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}pe.from=be;function ie(K){switch(K){case f.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}pe.to=ie})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(pe){function be(K){return typeof K=="number"&&K>=E.ViewColumn.One?K-1:K===E.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}pe.from=be;function ie(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ie})(h=e.ViewColumn||(e.ViewColumn={}));function w(pe){return typeof pe.range!="undefined"}function _(pe){return pe.length===0?!0:!!w(pe[0])}e.isDecorationOptionsArr=_;var v;(function(pe){function be(Qe){return Qe.map(pe.from)}pe.fromMany=be;function ie(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function K(Qe){let gt;if(ie(Qe)){const{language:ut,value:yt}=Qe;gt={value:"```"+ut+`
`+yt+"\n```\n"}}else E.MarkdownString.isMarkdownString(Qe)?gt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml}:typeof Qe=="string"?gt={value:Qe}:gt={value:""};const bt=Object.create(null);gt.uris=bt;const ht=ut=>{try{let yt=T.URI.parse(ut,!0);yt=yt.with({query:Se(yt.query,bt)}),bt[ut]=yt}catch(yt){}return""},pt=new C.Renderer;return pt.link=ht,pt.image=ut=>ht(k.parseHrefAndDimensions(ut).href),C(gt.value,{renderer:pt}),gt}pe.from=K;function Se(Qe,gt){if(!Qe)return Qe;let bt;try{bt=(0,A.parse)(Qe)}catch(pt){}if(!bt)return Qe;let ht=!1;return bt=(0,S.cloneAndChange)(bt,pt=>{if(T.URI.isUri(pt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[ut]=pt,ht=!0,ut}else return}),ht?JSON.stringify(bt):Qe}function Le(Qe){const gt=new E.MarkdownString(Qe.value,Qe.supportThemeIcons);return gt.isTrusted=Qe.isTrusted,gt.supportHtml=Qe.supportHtml,gt}pe.to=Le;function nt(Qe){if(!!Qe)return typeof Qe=="string"?Qe:pe.from(Qe)}pe.fromStrict=nt})(v=e.MarkdownString||(e.MarkdownString={}));function P(pe){return _(pe)?pe.map(be=>({range:o.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?v.fromMany(be.hoverMessage):be.hoverMessage?v.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):pe.map(be=>({range:o.from(be)}))}e.fromRangeOrRangeWithMessage=P;function b(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?T.URI.file(pe):pe}e.pathOrURIToURI=b;var F;(function(pe){function be(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?b(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}pe.from=be})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(pe){function be(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?b(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?F.from(ie.before):void 0,after:ie.after?F.from(ie.after):void 0}}pe.from=be})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(pe){function be(ie){if(typeof ie=="undefined")return ie;switch(ie){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=be})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(pe){function be(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?q.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?M.from(ie.light):void 0,dark:ie.dark?M.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?b(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?F.from(ie.before):void 0,after:ie.after?F.from(ie.after):void 0}}pe.from=be})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(pe){function be(K){return{text:K.newText,eol:K.newEol&&ge.from(K.newEol),range:o.from(K.range)}}pe.from=be;function ie(K){const Se=new E.TextEdit(o.to(K.range),K.text);return Se.newEol=typeof K.eol=="undefined"?void 0:ge.to(K.eol),Se}pe.to=ie})(U=e.TextEdit||(e.TextEdit={}));var z;(function(pe){function be(K,Se,Le){const nt={edits:[]};if(K instanceof E.WorkspaceEdit)for(let Qe of K._allEntries())if(Qe._type===1)nt.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const gt=Se?.getDocument(Qe.uri);nt.edits.push({_type:2,resource:Qe.uri,edit:U.from(Qe.edit),modelVersionId:gt?.version,metadata:Qe.metadata})}else Qe._type===3?nt.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version}):Qe._type===5&&nt.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Le?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ze.from)}});return nt}pe.from=be;function ie(K){const Se=new E.WorkspaceEdit;for(const Le of K.edits)Le.edit?Se.replace(T.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):Se.renameFile(T.URI.revive(Le.oldUri),T.URI.revive(Le.newUri),Le.options);return Se}pe.to=ie})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var O;(function(pe){const be=Object.create(null);be[E.SymbolKind.File]=0,be[E.SymbolKind.Module]=1,be[E.SymbolKind.Namespace]=2,be[E.SymbolKind.Package]=3,be[E.SymbolKind.Class]=4,be[E.SymbolKind.Method]=5,be[E.SymbolKind.Property]=6,be[E.SymbolKind.Field]=7,be[E.SymbolKind.Constructor]=8,be[E.SymbolKind.Enum]=9,be[E.SymbolKind.Interface]=10,be[E.SymbolKind.Function]=11,be[E.SymbolKind.Variable]=12,be[E.SymbolKind.Constant]=13,be[E.SymbolKind.String]=14,be[E.SymbolKind.Number]=15,be[E.SymbolKind.Boolean]=16,be[E.SymbolKind.Array]=17,be[E.SymbolKind.Object]=18,be[E.SymbolKind.Key]=19,be[E.SymbolKind.Null]=20,be[E.SymbolKind.EnumMember]=21,be[E.SymbolKind.Struct]=22,be[E.SymbolKind.Event]=23,be[E.SymbolKind.Operator]=24,be[E.SymbolKind.TypeParameter]=25;function ie(Se){return typeof be[Se]=="number"?be[Se]:6}pe.from=ie;function K(Se){for(const Le in be)if(be[Le]===Se)return Number(Le);return E.SymbolKind.Property}pe.to=K})(O=e.SymbolKind||(e.SymbolKind={}));var N;(function(pe){function be(K){switch(K){case E.SymbolTag.Deprecated:return 1}}pe.from=be;function ie(K){switch(K){case 1:return E.SymbolTag.Deprecated}}pe.to=ie})(N=e.SymbolTag||(e.SymbolTag={}));var x;(function(pe){function be(K){return{name:K.name,kind:O.from(K.kind),tags:K.tags&&K.tags.map(N.from),containerName:K.containerName,location:Q.from(K.location)}}pe.from=be;function ie(K){const Se=new E.SymbolInformation(K.name,O.to(K.kind),K.containerName,Q.to(K.location));return Se.tags=K.tags&&K.tags.map(N.to),Se}pe.to=ie})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(pe){function be(K){const Se={name:K.name||"!!MISSING: name!!",detail:K.detail,range:o.from(K.range),selectionRange:o.from(K.selectionRange),kind:O.from(K.kind),tags:K.tags?.map(N.from)??[]};return K.children&&(Se.children=K.children.map(be)),Se}pe.from=be;function ie(K){const Se=new E.DocumentSymbol(K.name,K.detail,O.to(K.kind),o.to(K.range),o.to(K.selectionRange));return(0,g.isNonEmptyArray)(K.tags)&&(Se.tags=K.tags.map(N.to)),K.children&&(Se.children=K.children.map(ie)),Se}pe.to=ie})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(pe){function be(K){const Se=new E.CallHierarchyItem(O.to(K.kind),K.name,K.detail||"",T.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}pe.to=be;function ie(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:K.name,detail:K.detail,kind:O.from(K.kind),uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(N.from)}}pe.from=ie})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var $;(function(pe){function be(ie){return new E.CallHierarchyIncomingCall(H.to(ie.from),ie.fromRanges.map(K=>o.to(K)))}pe.to=be})($=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(pe){function be(ie){return new E.CallHierarchyOutgoingCall(H.to(ie.to),ie.fromRanges.map(K=>o.to(K)))}pe.to=be})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(pe){function be(K){return{range:K.range&&o.from(K.range),uri:K.uri}}pe.from=be;function ie(K){return new E.Location(T.URI.revive(K.uri),o.to(K.range))}pe.to=ie})(Q=e.location||(e.location={}));var de;(function(pe){function be(K){const Se=K,Le=K;return{originSelectionRange:Se.originSelectionRange?o.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:o.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?o.from(Se.targetSelectionRange):void 0}}pe.from=be;function ie(K){return{targetUri:T.URI.revive(K.uri),targetRange:o.to(K.range),targetSelectionRange:K.targetSelectionRange?o.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?o.to(K.originSelectionRange):void 0}}pe.to=ie})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(pe){function be(K){return{range:o.from(K.range),contents:v.fromMany(K.contents)}}pe.from=be;function ie(K){return new E.Hover(K.contents.map(v.to),o.to(K.range))}pe.to=ie})(_e=e.Hover||(e.Hover={}));var Ce;(function(pe){function be(K){return{range:o.from(K.range),expression:K.expression}}pe.from=be;function ie(K){return new E.EvaluatableExpression(o.to(K.range),K.expression)}pe.to=ie})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Te;(function(pe){function be(K){if(K instanceof E.InlineValueText)return{type:"text",range:o.from(K.range),text:K.text};if(K instanceof E.InlineValueVariableLookup)return{type:"variable",range:o.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=be;function ie(K){switch(K.type){case"text":return{range:o.to(K.range),text:K.text};case"variable":return{range:o.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:o.to(K.range),expression:K.expression}}}pe.to=ie})(Te=e.InlineValue||(e.InlineValue={}));var $e;(function(pe){function be(K){return{frameId:K.frameId,stoppedLocation:o.from(K.stoppedLocation)}}pe.from=be;function ie(K){return new E.InlineValueContext(K.frameId,o.to(K.stoppedLocation))}pe.to=ie})($e=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(pe){function be(K){return{range:o.from(K.range),kind:K.kind}}pe.from=be;function ie(K){return new E.DocumentHighlight(o.to(K.range),K.kind)}pe.to=ie})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(pe){function be(ie){switch(ie){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}pe.to=be})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var j;(function(pe){function be(ie){return{triggerKind:He.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}pe.to=be})(j=e.CompletionContext||(e.CompletionContext={}));var ee;(function(pe){function be(K){switch(K){case E.CompletionItemTag.Deprecated:return 1}}pe.from=be;function ie(K){switch(K){case 1:return E.CompletionItemTag.Deprecated}}pe.to=ie})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var se;(function(pe){const be=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ie(Le){return be.get(Le)??9}pe.from=ie;const K=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Se(Le){return K.get(Le)??E.CompletionItemKind.Property}pe.to=Se})(se=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(pe){function be(ie,K){const Se=new E.CompletionItem(ie.label);return Se.insertText=ie.insertText,Se.kind=se.to(ie.kind),Se.tags=ie.tags?.map(ee.to),Se.detail=ie.detail,Se.documentation=k.isMarkdownString(ie.documentation)?v.to(ie.documentation):ie.documentation,Se.sortText=ie.sortText,Se.filterText=ie.filterText,Se.preselect=ie.preselect,Se.commitCharacters=ie.commitCharacters,n.Range.isIRange(ie.range)?Se.range=o.to(ie.range):typeof ie.range=="object"&&(Se.range={inserting:o.to(ie.range.insert),replacing:o.to(ie.range.replace)}),Se.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?Se.insertText=new E.SnippetString(ie.insertText):(Se.insertText=ie.insertText,Se.textEdit=Se.range instanceof E.Range?new E.TextEdit(Se.range,Se.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(Se.additionalTextEdits=ie.additionalTextEdits.map(Le=>U.to(Le))),Se.command=K&&ie.command?K.fromInternal(ie.command):void 0,Se}pe.to=be})(le=e.CompletionItem||(e.CompletionItem={}));var Z;(function(pe){function be(K){return{label:K.label,documentation:K.documentation?v.fromStrict(K.documentation):void 0}}pe.from=be;function ie(K){return{label:K.label,documentation:k.isMarkdownString(K.documentation)?v.to(K.documentation):K.documentation}}pe.to=ie})(Z=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(pe){function be(K){return{label:K.label,documentation:K.documentation?v.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}pe.from=be;function ie(K){return{label:K.label,documentation:k.isMarkdownString(K.documentation)?v.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}pe.to=ie})(ae=e.SignatureInformation||(e.SignatureInformation={}));var ve;(function(pe){function be(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.from):[]}}pe.from=be;function ie(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.to):[]}}pe.to=ie})(ve=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(pe){function be(K){return{text:K.text,position:t.from(K.position),kind:qe.from(K.kind??E.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}pe.from=be;function ie(K){const Se=new E.InlayHint(K.text,t.to(K.position),qe.to(K.kind));return Se.whitespaceAfter=K.whitespaceAfter,Se.whitespaceBefore=K.whitespaceBefore,Se}pe.to=ie})(Me=e.InlayHint||(e.InlayHint={}));var qe;(function(pe){function be(K){return K}pe.from=be;function ie(K){return K}pe.to=ie})(qe=e.InlayHintKind||(e.InlayHintKind={}));var Ye;(function(pe){function be(K){return{range:o.from(K.range),url:K.target,tooltip:K.tooltip}}pe.from=be;function ie(K){let Se;if(K.url)try{Se=typeof K.url=="string"?T.URI.parse(K.url,!0):T.URI.revive(K.url)}catch(Le){}return new E.DocumentLink(o.to(K.range),Se)}pe.to=ie})(Ye=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(pe){function be(K){const Se=new E.ColorPresentation(K.label);return K.textEdit&&(Se.textEdit=U.to(K.textEdit)),K.additionalTextEdits&&(Se.additionalTextEdits=K.additionalTextEdits.map(Le=>U.to(Le))),Se}pe.to=be;function ie(K){return{label:K.label,textEdit:K.textEdit?U.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Se=>U.from(Se)):void 0}}pe.from=ie})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var ke;(function(pe){function be(K){return new E.Color(K[0],K[1],K[2],K[3])}pe.to=be;function ie(K){return[K.red,K.green,K.blue,K.alpha]}pe.from=ie})(ke=e.Color||(e.Color={}));var at;(function(pe){function be(K){return{range:o.from(K.range)}}pe.from=be;function ie(K){return new E.SelectionRange(o.to(K.range))}pe.to=ie})(at=e.SelectionRange||(e.SelectionRange={}));var X;(function(pe){function be(ie){switch(ie){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}pe.to=be})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(pe){function be(K){switch(K){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=be;function ie(K){switch(K){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}pe.to=ie})(te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ge;(function(pe){function be(K){if(K===E.EndOfLine.CRLF)return 1;if(K===E.EndOfLine.LF)return 0}pe.from=be;function ie(K){if(K===1)return E.EndOfLine.CRLF;if(K===0)return E.EndOfLine.LF}pe.to=ie})(ge=e.EndOfLine||(e.EndOfLine={}));var je;(function(pe){function be(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=be})(je=e.ProgressLocation||(e.ProgressLocation={}));var tt;(function(pe){function be(ie){const K={start:ie.start+1,end:ie.end+1};return ie.kind&&(K.kind=lt.from(ie.kind)),K}pe.from=be})(tt=e.FoldingRange||(e.FoldingRange={}));var lt;(function(pe){function be(ie){if(ie)switch(ie){case E.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}pe.from=be})(lt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ft;(function(pe){function be(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?o.from(ie.selection):void 0,override:typeof ie.override=="boolean"?c.EditorResolution.DISABLED:void 0}}pe.from=be})(ft=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var wt;(function(pe){function be(K){return K instanceof E.RelativePattern||typeof K=="string"?K:ie(K)?new E.RelativePattern(K.base,K.pattern):K}pe.from=be;function ie(K){const Se=K;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(wt=e.GlobPattern||(e.GlobPattern={}));var Ct;(function(pe){function be(ie){if(ie){if(Array.isArray(ie))return ie.map(be);if(typeof ie=="string")return ie;{const K=ie;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:wt.from(K.pattern),exclusive:K.exclusive}}}else return}pe.from=be})(Ct=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(pe){function be(K){return{start:K.start,end:K.end}}pe.from=be;function ie(K){return new E.NotebookRange(K.start,K.end)}pe.to=ie})(ce=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(pe){function be(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}pe.to=be;function ie(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}pe.from=ie})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var xe;(function(pe){function be(K){switch(K){case E.NotebookCellKind.Markup:return p.CellKind.Markup;case E.NotebookCellKind.Code:default:return p.CellKind.Code}}pe.from=be;function ie(K){switch(K){case p.CellKind.Markup:return E.NotebookCellKind.Markup;case p.CellKind.Code:default:return E.NotebookCellKind.Code}}pe.to=ie})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Xe;(function(pe){function be(K){const Se={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)E.NotebookCellData.validate(Le),Se.cells.push(ze.from(Le));return Se}pe.from=be;function ie(K){const Se=new E.NotebookData(K.cells.map(ze.to));return(0,y.isEmptyObject)(K.metadata)||(Se.metadata=K.metadata),Se}pe.to=ie})(Xe=e.NotebookData||(e.NotebookData={}));var ze;(function(pe){function be(K){return{cellKind:xe.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Pe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ae.from):[]}}pe.from=be;function ie(K){return new E.NotebookCellData(xe.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ae.to):void 0,K.metadata,K.internalMetadata?Pe.to(K.internalMetadata):void 0)}pe.to=ie})(ze=e.NotebookCellData||(e.NotebookCellData={}));var ot;(function(pe){function be(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}pe.from=be;function ie(K){return new E.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}pe.to=ie})(ot=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(pe){function be(K){return{outputId:K.id,items:K.items.map(ot.from),metadata:K.metadata}}pe.from=be;function ie(K){const Se=K.items.map(ot.to);return new E.NotebookCellOutput(Se,K.outputId,K.metadata)}pe.to=ie})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(pe){function be(Le){if(Le!=null){if(Le instanceof E.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new E.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:wt.from(Le.include)||void 0,exclude:wt.from(Le.exclude)||void 0}}}pe.from=be;function ie(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}pe.to=ie;function K(Le){const nt=Le,Qe=wt.from(nt.include);if(!(Qe&&Qe instanceof E.RelativePattern||typeof Qe=="string"))return!1;const gt=wt.from(nt.exclude);return!!(gt&&gt instanceof E.RelativePattern||typeof gt=="string")}function Se(Le){const nt=Le;return nt&&typeof nt.base=="string"&&typeof nt.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ie;(function(pe){function be(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?F.from(ie.top):void 0}}pe.from=be})(Ie=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(pe){function be(ie,K,Se){const Le=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Se),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}pe.from=be})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(pe){function be(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}pe.from=be})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ee;(function(pe){function be(K){return{uri:K.uri,provides:K.provides}}pe.from=be;function ie(K){return new E.NotebookRendererScript(T.URI.revive(K.uri),K.provides)}pe.to=ie})(Ee=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(pe){function be(K){return{message:v.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}pe.from=be;function ie(K){const Se=new E.TestMessage(typeof K.message=="string"?K.message:v.to(K.message));return Se.actualOutput=K.actual,Se.expectedOutput=K.expected,Se.location=K.location?Q.to(K.location):void 0,Se}pe.to=ie})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(pe){let be;(function(ie){ie.Delimiter="\0"})(be||(be={})),pe.namespace=(ie,K)=>ie+"\0"+K,pe.denamespace=ie=>{const K=ie.indexOf("\0");return{ctrlId:ie.slice(0,K),tagId:ie.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ke;(function(pe){function be(Le){const nt=(0,d.getPrivateApiFor)(Le).controllerId;return{extId:D.TestId.fromExtHostTestItem(Le,nt).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Qe=>Fe.namespace(nt,Qe.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&v.fromStrict(Le.error)||null}}pe.from=be;function ie(Le){return{id:D.TestId.fromString(Le.extId).localId,label:Le.label,uri:T.URI.revive(Le.uri),tags:(Le.tags||[]).map(nt=>{const{tagId:Qe}=Fe.denamespace(nt);return new E.TestTag(Qe)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}pe.toPlain=ie;function K(Le){const nt=D.TestId.fromString(Le.extId),Qe=new d.TestItemImpl(nt.controllerId,nt.localId,Le.label,T.URI.revive(Le.uri));return Qe.range=o.to(Le.range||void 0),Qe.description=Le.description||void 0,Qe}function Se(Le){let nt;for(const Qe of Le.tests){const gt=K(Qe.item);(0,d.getPrivateApiFor)(gt).parent=nt,nt=gt}return nt}pe.toItemFromContext=Se})(Ke=e.TestItem||(e.TestItem={})),function(pe){function be(K){return{id:K.id}}pe.from=be;function ie(K){return new E.TestTag(K.id)}pe.to=ie}(Fe=e.TestTag||(e.TestTag={}));var Ve;(function(pe){const be=(K,Se)=>{const Le={...Ke.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(nt=>({state:nt.state,duration:nt.duration,messages:nt.messages.filter(Qe=>Qe.type===0).map(we.to)})),children:K.children.map(nt=>Se.get(nt)).filter(y.isDefined).map(nt=>be(nt,Se))};for(const nt of Le.children)nt.parent=Le;return Le};function ie(K){const Se=[],Le=new Map;for(const nt of K.items)Le.set(nt.item.extId,nt),K.request.targets.some(Qe=>Qe.controllerId===nt.controllerId&&Qe.testIds.includes(nt.item.extId))&&Se.push(nt);return{completedAt:K.completedAt,results:Se.map(nt=>be(nt,Le))}}pe.to=ie})(Ve=e.TestResults||(e.TestResults={}));var Je;(function(pe){function be(Le){return{covered:Le.covered,total:Le.covered}}function ie(Le){return"line"in Le?t.from(Le):o.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ie(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&ie(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:ie(Le.location)}}pe.fromDetailed=K;function Se(Le){return{uri:Le.uri,statement:be(Le.statementCoverage),branch:Le.branchCoverage&&be(Le.branchCoverage),function:Le.functionCoverage&&be(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}pe.fromFile=Se})(Je=e.TestCoverage||(e.TestCoverage={}));var rt;(function(pe){function be(ie){switch(ie){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}pe.to=be})(rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ue;(function(pe){function be(K){const Se=new E.TypeHierarchyItem(O.to(K.kind),K.name,K.detail||"",T.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}pe.to=be;function ie(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:O.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(N.from)}}pe.from=ie})(Ue=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[218],me([0,1,2,17,7,15,95]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(T,n,I,c={timeout:1500,errors:3}){this._logService=T,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(n,I,c)=>{const d={dispose:this._callbacks.push([n,I,T])};return Array.isArray(c)&&c.push(d),d}}async $participateInSave(T,n){const I=g.URI.revive(T);let c=!1;const f=setTimeout(()=>c=!0,this._thresholds.timeout),d=[];try{for(let p of[...this._callbacks]){if(c)break;const D=this._documents.getDocument(I),R=await this._deliverEventAsyncAndBlameBadListeners(p,{document:D,reason:C.TextDocumentSaveReason.to(n)});d.push(R)}}finally{clearTimeout(f)}return d}_deliverEventAsyncAndBlameBadListeners([T,n,I],c){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,T,n,c).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const p=this._badListeners.get(T);this._badListeners.set(T,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,n,I,c){const f=[],d=Date.now(),{document:p,reason:D}=c,{version:R}=p,E=Object.freeze({document:p,reason:D,waitUntil(a){if(Object.isFrozen(f))throw(0,L.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{n.apply(I,[E])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,o)=>{const m=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(m),a(t)}).catch(t=>{clearTimeout(m),o(t)})}).then(a=>{const o={edits:[]};for(const m of a)if(Array.isArray(m)&&m.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:u,range:r}of m)o.edits.push({_type:2,resource:p.uri,edit:{range:r&&C.Range.from(r),text:t,eol:u&&C.EndOfLine.from(u)}});if(o.edits.length!==0)return R===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(fe[54],me([0,1,15,2,3,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new k.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let T=-1;this._tabs=y.map((I,c)=>(I.isActive&&(T=c),Object.freeze({label:I.label,viewColumn:g.ViewColumn.to(I.viewColumn),resource:L.URI.revive(I.resource),viewId:I.editorId,isActive:I.isActive}))),this._tabs=this._tabs.sort((I,c)=>I.viewColumn-c.viewColumn);const n=this._activeTab;this._activeTab=T===-1?void 0:this._tabs[T],this._activeTab!==n&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=A}),define(fe[219],me([0,1,3,30,2,15,7]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(n,I,c,f,d){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),f&&(this._config+=2),d&&(this._config+=4);const p=(0,L.parse)(I),D=n(R=>{if(!c)for(let E of R.created){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let E of R.changed){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidChange.fire(a)}if(!d)for(let E of R.deleted){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,I,c){this._logService=I,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,I,c,f){return new S(this._onFileSystemEvent.event,n,I,c,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,I){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(c=>k.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(c=>k.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,I){return(c,f,d)=>{const p=function(R){c.call(f,R)};return p.extension=n,I.event(p,void 0,d)}}async $onWillRunFileOperation(n,I,c,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},c,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(d=>k.URI.revive(d.target))},c,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(d=>k.URI.revive(d.target))},c,f)}}async _fireWillEvent(n,I,c,f){const d=new Set,p=[];if(await n.fireAsync(I,f,async(R,E)=>{const a=Date.now(),o=await Promise.resolve(R);o instanceof A.WorkspaceEdit&&(p.push(o),d.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-a>c&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||p.length===0)return;const D={edits:[]};for(let R of p){let{edits:E}=C.WorkspaceEdit.from(R,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(E)}return{edit:D,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=y}),define(fe[220],me([0,1,10,25,2,15,7,126]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(c,f,d,p){this.start=c,this.deletedCount=f,this.deletedItems=d,this.items=p}static asApiEvents(c){return c.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(d=>d.apiCell)}))}}class T{constructor(c,f,d){this.notebook=c,this._extHostDocument=f,this._cellData=d,this.handle=d.handle,this.uri=k.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(c,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return c._mime},set mime(d){c._mime=d},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,f,d){const p=d.map(C.NotebookCellOutputItem.to),D=this._outputs.find(R=>R.id===c);D&&(f||(D.items.length=0),D.items.push(...p))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=T;class n{constructor(c,f,d,p,D,R){this._proxy=c,this._textDocumentsAndEditors=f,this._textDocuments=d,this._emitter=p,this.uri=D,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=R.viewType,this._metadata=Object.freeze(R.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,R.cells]],!0),this._versionId=R.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(f){return f=c._validateIndex(f),c._cells[f].apiCell},getCells(f){return(f?c._getCells(f):c._cells).map(p=>p.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,f){this._versionId=c.versionId,this._isDirty=f;for(const d of c.rawEvents)d.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===S.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let f=c.start|0,d=c.end|0;return f<0&&(f=0),d>this._cells.length&&(d=this._cells.length),c.with({start:f,end:d})}_getCells(c){c=this._validateRange(c);const f=[];for(let d=c.start;d<c.end;d++)f.push(this._cells[d]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,f){if(this._disposed)return;const d=[],p=[],D=[];c.reverse().forEach(R=>{const a=R[2].map(t=>{const u=new T(this,this._textDocumentsAndEditors,t);return f||p.push(T.asModelAddData(this.apiNotebook,t)),u}),o=new y(R[0],R[1],[],a),m=this._cells.splice(R[0],R[1],...a);for(const t of m)D.push(t.uri),o.deletedItems.push(t.apiCell);d.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:D}),f||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(d)}))}_moveCell(c,f){const d=this._cells.splice(c,1);this._cells.splice(f,0,...d);const p=[new y(c,1,d.map(D=>D.apiCell),[]),new y(f,0,[],d)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(p)}))}_setCellOutputs(c,f){const d=this._cells[c];d.setOutputs(f),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(c,f,d,p){const D=this._cells[c];D.setOutputItems(f,d,p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(c,f){const d=this._cells[c];d.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(d.uri,f)}_changeCellMime(c,f){const d=this._cells[c];d.apiCell.mime=f}_changeCellMetadata(c,f){const d=this._cells[c],p=d.apiCell.metadata;d.setMetadata(f);const D=d.apiCell.metadata;(0,L.equals)(p,D)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(c,f){const d=this._cells[c],p=d.internalMetadata;if(d.setInternalMetadata(f),p.runState!==f.runState){const D=f.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,state:D}))}}getCellFromApiCell(c){return this._cells.find(f=>f.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(f=>f.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(fe[129],me([0,1,7,15,17]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:T})}replaceCells(y,T,n){this._throwIfFinalized(),!(y===T&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:T-y,cells:n.map(L.NotebookCellData.from)})}}class A{constructor(y,T,n,I,c,f){this.id=y,this._proxy=T,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=I,this._viewColumn=f}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(T){if(!Array.isArray(T)||!T.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");y._selections=T,y._trySetSelections(T)},get visibleRanges(){return y._visibleRanges},revealRange(T,n){y._proxy.$tryRevealRange(y.id,L.NotebookRange.from(T),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(T){const n=new C(this.document.version);return T(n),y._applyEdit(n.finalize())},setDecorations(T,n){return y.setDecorations(T,n)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(L.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const T=[];let n=-1;for(let I=0;I<y.cellEdits.length;I++){if(n<0){T.push(y.cellEdits[I]),n++;continue}const f=T[n],d=y.cellEdits[I];if(f.editType===1&&d.editType===1&&f.index===d.index){f.cells.push(...y.cellEdits[I].cells),f.count+=y.cellEdits[I].count;continue}T.push(y.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,T)}setDecorations(y,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return T.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(T),y.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[221],me([0,1,15,118,166,21,59]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,c,f){const d=this._handles++,{title:p,location:D,cancellable:R}=c,E={label:(0,k.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(d,{location:g.ProgressLocation.from(D),title:p,source:E,cancellable:R},I),this._withProgress(d,f,!!R)}_withProgress(I,c,f){let d;f&&(d=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,d));const p=R=>{this._proxy.$progressEnd(R),this._mapHandleToCancellationSource.delete(R),d&&d.dispose()};let D;try{D=c(new T(this._proxy,I),f&&d?d.token:C.CancellationToken.None)}catch(R){throw p(I),R}return D.then(R=>p(I),R=>p(I)),D}$acceptProgressCanceled(I){const c=this._mapHandleToCancellationSource.get(I);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=S;function y(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class T extends L.Progress{constructor(I,c){super(f=>this.throttledReport(f));this._proxy=I,this._handle=c}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ge([(0,A.throttle)(100,(n,I)=>y(n,I),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(fe[130],me([0,1,57,17,76,15,7]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(c,f,d){const p=S._Keys.nextId();c.$registerTextEditorDecorationType(f.identifier,p,C.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:p,dispose(){c.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=S,S._Keys=new k.IdGenerator("TextEditorDecorationType");class y{constructor(c,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,f){this._throwIfFinalized();let d=null;if(c instanceof A.Position)d=new A.Range(c,c);else if(c instanceof A.Range)d=c;else throw new Error("Unrecognized location");this._pushEdit(d,f,!1)}insert(c,f){this._throwIfFinalized(),this._pushEdit(new A.Range(c,c),f,!0)}delete(c){this._throwIfFinalized();let f=null;if(c instanceof A.Range)f=c;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(c,f,d){const p=this._document.validateRange(c);this._collectedEdits.push({range:p,text:f,forceMoveMarkers:d})}setEndOfLine(c){if(this._throwIfFinalized(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=y;class T{constructor(c,f,d,p){this._proxy=c,this._id=f,this._accept(d),this._logService=p;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(R){D._setTabSize(R)},get insertSpaces(){return D._insertSpaces},set insertSpaces(R){D._setInsertSpaces(R)},get cursorStyle(){return D._cursorStyle},set cursorStyle(R){D._setCursorStyle(R)},get lineNumbers(){return D._lineNumbers},set lineNumbers(R){D._setLineNumbers(R)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const f=Math.floor(c);return f>0?f:null}if(typeof c=="string"){const f=parseInt(c,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(c){const f=this._validateTabSize(c);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const f=this._validateInsertSpaces(c);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const f={};let d=!1;if(typeof c.tabSize!="undefined"){const p=this._validateTabSize(c.tabSize);p==="auto"?(d=!0,f.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,d=!0,f.tabSize=p)}if(typeof c.insertSpaces!="undefined"){const p=this._validateInsertSpaces(c.insertSpaces);p==="auto"?(d=!0,f.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,d=!0,f.insertSpaces=p)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,d=!0,f.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,d=!0,f.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(c){c.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=T;class n{constructor(c,f,d,p,D,R,E,a){this.id=c,this._proxy=f,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new T(this._proxy,this.id,R,d),this._visibleRanges=E,this._viewColumn=a;const o=this;this.value=Object.freeze({get document(){return p.getValue()},set document(m){throw(0,L.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(m){if(!(m instanceof A.Selection))throw(0,L.illegalArgument)("selection");o._selections=[m],o._trySetSelection()},get selections(){return o._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof A.Selection)))throw(0,L.illegalArgument)("selections");o._selections=m,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(m){throw(0,L.readonly)("visibleRanges")},get options(){return o._options.value},set options(m){o._disposed||o._options.assign(m)},get viewColumn(){return o._viewColumn},set viewColumn(m){throw(0,L.readonly)("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new y(p.getValue(),t);return m(u),o._applyEdit(u)},insertSnippet(m,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=o._selections.map(i=>C.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:s}=C.Position.from(t);r=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof A.Range)r=[C.Range.from(t)];else{r=[];for(const i of t)if(i instanceof A.Range)r.push(C.Range.from(i));else{const{lineNumber:s,column:l}=C.Position.from(i);r.push({startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l})}}return f.$tryInsertSnippet(c,m.value,r,u)},setDecorations(m,t){const u=t.length===0;u&&!o._hasDecorationsForKey.has(m.key)||(u?o._hasDecorationsForKey.delete(m.key):o._hasDecorationsForKey.add(m.key),o._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return f.$trySetDecorations(c,m.key,C.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const l=t[i];r[4*i]=l.start.line+1,r[4*i+1]=l.start.character+1,r[4*i+2]=l.end.line+1,r[4*i+3]=l.end.character+1}return f.$trySetDecorationsFast(c,m.key,r)}}))},revealRange(m,t){o._runOnProxy(()=>f.$tryRevealRange(c,C.Range.from(m),t||A.TextEditorRevealType.Default))},show(m){f.$tryShowEditor(c,C.ViewColumn.from(m))},hide(){f.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const f=c.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const d=f.edits.map(D=>D.range);d.sort((D,R)=>D.end.line===R.end.line?D.end.character===R.end.character?D.start.line===R.start.line?D.start.character-R.start.character:D.start.line-R.start.line:D.end.character-R.end.character:D.end.line-R.end.line);for(let D=0,R=d.length-1;D<R;D++){const E=d[D].end;if(d[D+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=f.edits.map(D=>({range:C.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,p,{setEndOfLine:typeof f.setEndOfLine=="number"?C.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(fe[222],me([0,1,169,23,2,3,6,209,18,7,12,16,15,21,206]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,a){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let o;return Array.isArray(E.highlights)&&(o=E.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),o=o.length?o:void 0),{label:E.label,highlights:o}}}class D{constructor(a,o,m){this._proxy=a,this.commands=o,this.logService=m,this.treeViews=new Map;function t(u){return u&&u.$treeViewId&&u.$treeItemHandle}o.registerArgumentProcessor({processArgument:u=>t(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(r=>t(r)?this.convertArgument(r):r):u})}registerTreeDataProvider(a,o,m){const t=this.createTreeView(a,{treeDataProvider:o},m);return{dispose:()=>t.dispose()}}createTreeView(a,o,m){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=o.dragAndDropController!==void 0,u=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(a,o,m);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,s)=>r.reveal(i,s),dispose:async()=>{await u,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,o){const m=this.treeViews.get(a);return m?m.getChildren(o):Promise.reject(new Error((0,g.localize)(0,null,a)))}async $onDrop(a,o,m){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,a)));const u=d.TreeDataTransferConverter.toITreeDataTransfer(o);if(u.items.has(S.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await u.items.get(S.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(s=>t.getExtensionElement(s)).filter(s=>!!s);i.length>0?u.items.set(S.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):u.items.delete(S.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(u,m)}async $hasResolve(a){const o=this.treeViews.get(a);if(!o)throw new Error((0,g.localize)(2,null,a));return o.hasResolve}$resolve(a,o,m){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(3,null,a));return t.resolveTreeItem(o,m)}$setExpanded(a,o,m){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(4,null,a));t.setExpanded(o,m)}$setSelection(a,o){const m=this.treeViews.get(a);if(!m)throw new Error((0,g.localize)(5,null,a));m.setSelection(o)}$setVisible(a,o){const m=this.treeViews.get(a);if(!m)throw new Error((0,g.localize)(6,null,a));m.setVisible(o)}createExtHostTreeView(a,o,m){const t=new R(a,o,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(a,t),t}convertArgument(a){const o=this.treeViews.get(a.$treeViewId);return o?o.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=D;class R extends A.Disposable{constructor(a,o,m,t,u,r){super();if(this.viewId=a,this.proxy=m,this.commands=t,this.logService=u,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const l in r.contributes.views)for(const h of r.contributes.views[l])h.id===a&&(this._title=h.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let i,s;this._register(C.Event.debounce(this._onDidChangeData.event,(l,h)=>(l||(l={message:!1,elements:[]}),h.element!==!1&&(i||(i=new Promise(w=>s=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(h.element)?l.elements.push(...h.element):l.elements.push(h.element)),h.message&&(l.message=!0),l),200,!0)(({message:l,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=s;return i=null,this.refresh(h).then(()=>w())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}async getChildren(a){const o=a?this.getExtensionElement(a):void 0;if(a&&!o)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(a);return m||(m=await this.fetchChildrenNodes(o)),m?m.map(t=>t.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,o){o=o||{select:!0,focus:!1};const m=(0,n.isUndefinedOrNull)(o.select)?!0:o.select,t=(0,n.isUndefinedOrNull)(o.focus)?!1:o.focus,u=(0,n.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(s=>s.item)},{select:m,focus:t,expand:u})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:t,expand:u})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,o){const m=this.getExtensionElement(a);m&&(o?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,o){const m=this.getExtensionElement(o);if(!!m)return(0,y.asPromise)(()=>this.dndController?.onDrop(a,m))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,o){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(a);if(m){const t=this.nodes.get(m);if(t){const u=await this.dataProvider.resolveTreeItem(t.extensionItem,m,o)??t.extensionItem;return t.item.tooltip=this.getTooltip(u.tooltip),t.item.command=this.getCommand(t.disposableStore,u.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(o=>o?this.resolveUnknownParentChain(o).then(m=>this.resolveTreeNode(o,m[m.length-1]).then(t=>(m.push(t),m))):Promise.resolve([]))}resolveParent(a){const o=this.nodes.get(a);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,o){const m=this.nodes.get(a);return m?Promise.resolve(m):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,o,!0)).then(t=>this.getChildren(o?o.item.handle:void 0).then(()=>{const u=this.getExtensionElement(t);if(u){const r=this.nodes.get(u);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let o;if(typeof a=="string"){const m=this.getExtensionElement(a);o=m?this.nodes.get(m):void 0}else o=a;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const o=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(o.token.isCancellationRequested)return;const u=await Promise.all((0,I.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,m):null}));return o.token.isCancellationRequested?void 0:(0,I.coalesce)(u)}finally{o.dispose()}}refresh(a){if(a.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(a);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const o=new Set,m=a.map(u=>this.nodes.get(u));for(const u of m)if(u&&!o.has(u.item.handle)){let r=u;for(;r&&r.parent&&m.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&o.add(u.item.handle)}const t=[];return o.forEach(u=>{const r=this.elements.get(u);if(r){const i=this.nodes.get(r);i&&(!i.parent||!o.has(i.parent.item.handle))&&t.push(u)}}),t}refreshHandles(a){const o={};return Promise.all(a.map(m=>this.refreshNode(m).then(t=>{t&&(o[m]=t.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(a){const o=this.getExtensionElement(a);if(o){const m=this.nodes.get(o);if(m)return this.clearChildren(o),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>{if(t){const u=this.createTreeNode(o,t,m.parent);return this.updateNodeCache(o,u,m,m.parent),m.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,o,m){const t=this.createTreeNode(a,o,m);if(o.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,o.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,m),t}getTooltip(a){return T.MarkdownString.isMarkdownString(a)?c.MarkdownString.from(a):a}getCommand(a,o){return o?this.commands.toInternal(o,a):void 0}createTreeNode(a,o,m){const t=new A.DisposableStore,u=this.createHandle(a,o,m),r=this.getLightIconPath(o);return{item:{handle:u,parentHandle:m?m.item.handle:void 0,label:p(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(t,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,n.isUndefinedOrNull)(o.collapsibleState)?T.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:m,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof T.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:o,label:m,resourceUri:t},u,r){if(o)return`${R.ID_HANDLE_PREFIX}/${o}`;const i=p(m,this.extension),s=u?u.item.handle:R.LABEL_HANDLE_PREFIX;let l=i?i.label:t?(0,L.basename)(t):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const h=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,w=this.getChildrenNodes(u)||[];let _,v=0;do{if(_=`${s}/${v}:${l}`,r||!this.elements.has(_)||h===_)break;v++}while(v<=w.length);return _}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon))return typeof a.iconPath=="string"||k.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return k.URI.isUri(a)?a:k.URI.file(a)}addNodeToCache(a,o){this.elements.set(o.item.handle,a),this.nodes.set(a,o)}updateNodeCache(a,o,m,t){this.elements.delete(o.item.handle),this.nodes.delete(a),o.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(a,o);const u=this.getChildrenNodes(t)||[],r=u.filter(i=>i.item.handle===m.item.handle)[0];r&&u.splice(u.indexOf(r),1,o)}addNodeToParentCache(a,o){o?(o.children||(o.children=[]),o.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const o=this.nodes.get(a);if(o){if(o.children)for(const m of o.children){const t=this.elements.get(m.item.handle);t&&this.clear(t)}o.children=void 0}}else this.clearAll()}clear(a){const o=this.nodes.get(a);if(o){if(o.children)for(const m of o.children){const t=this.elements.get(m.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}R.LABEL_HANDLE_PREFIX="0",R.ID_HANDLE_PREFIX="1"}),define(fe[223],me([0,1,18,3,6,12,65,15,127,89]),function(J,e,g,L,k,C,A,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends k.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const f=this.diff[this.diff.length-1];if(f&&c[0]===1){if(f[0]===1&&f[1].extId===c[1].extId){(0,y.applyTestItemUpdate)(f[1],c[1]);return}if(f[0]===0&&f[1].item.extId===c[1].extId){(0,y.applyTestItemUpdate)(f[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,f){const d=this.tree.get(c);if(!!d){if((d.expandLevels===void 0||f>d.expandLevels)&&(d.expandLevels=f),d.expand===1){const p=this.resolveChildren(d);return p.isOpen()?this.expandChildren(d,f-1):p.wait().then(()=>this.expandChildren(d,f-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,f-1)):this.expandChildren(d,f-1)}}dispose(){for(const c of this.tree.values())(0,A.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,f){switch(f.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(c.fullId,f.id));break;case 0:this.upsertItem(f.item,c);break;case 4:for(const E of f.ops)this.onTestItemEvent(c,E);break;case 3:const{key:d,value:p,previous:D}=f,R=c.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(p,D,R);break;case"range":this.pushDiff([1,{extId:R,item:{range:S.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:R,item:{error:S.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:R,item:{[d]:p??null}}]);break}break;default:(0,C.assertNever)(f)}}upsertItem(c,f){if(!(c instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const d=T.TestId.fromExtHostTestItem(c,this.root.id,f?.actual),p=(0,A.getPrivateApiFor)(c);p.parent&&p.parent!==f?.actual&&p.parent.children.delete(c.id);let D=this.tree.get(d.toString());if(!D){D={fullId:d,actual:c,parent:f?d.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(c,f),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:S.TestItem.from(c)}]),this.connectItemAndChildren(c,D,f);return}if(D.actual===c){this.connectItem(c,D,f);return}const R=D.actual.children,E=D.actual,a=(0,A.diffTestItems)(E,c);(0,A.getPrivateApiFor)(E).listener=void 0,D.actual=c,D.expand=0;for(const[o,m]of a)this.onTestItemEvent(D,{op:3,key:o,value:m,previous:E[o]});this.connectItemAndChildren(c,D,f);for(const o of R)c.children.get(o.id)||this.removeItem(T.TestId.joinToString(d,o.id))}diffTagRefs(c,f,d){const p=new Set(f.map(D=>D.id));for(const D of c)p.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:d,item:{tags:c.map(D=>S.TestTag.namespace(this.controllerId,D.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const f=this.tags.get(c.id);f?f.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:S.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const f=this.tags.get(c);f&&!--f.refCount&&(this.tags.delete(c),this.pushDiff([6,S.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,f){(0,A.getPrivateApiFor)(c).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(c,f,d){this.setItemParent(c,d);const p=(0,A.getPrivateApiFor)(c);p.parent=d?.actual,p.listener=D=>this.onTestItemEvent(f,D),this.updateExpandability(f)}connectItemAndChildren(c,f,d){this.connectItem(c,f,d);for(const p of c.children)this.upsertItem(p,f)}updateExpandability(c){let f;this._resolveHandler?c.resolveBarrier?f=c.resolveBarrier.isOpen()?3:2:f=c.actual.canResolveChildren?1:0:f=0,f!==c.expand&&(c.expand=f,this.pushDiff([1,{extId:c.fullId.toString(),expand:f}]),f===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,f){if(f<0)return;const d=[];for(const p of c.actual.children){const D=this.expand(T.TestId.joinToString(c.fullId,p.id),f);(0,g.isThenable)(D)&&d.push(D)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const D=new g.Barrier;return D.open(),D}c.expand=2,this.pushExpandStateUpdate(c);const f=c.resolveBarrier=new g.Barrier,d=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=D.stack||D.message||String(D))};let p;try{p=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(D){d(D)}return(0,g.isThenable)(p)?p.catch(d).then(()=>{f.open(),this.updateExpandability(c)}):(f.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const f=this.tree.get(c);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const d=[f];for(;d.length;){const p=d.pop();if(!!p){(0,A.getPrivateApiFor)(p.actual).listener=void 0;for(const D of p.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(p.fullId.toString());for(const D of p.actual.children)d.push(this.tree.get(T.TestId.joinToString(p.fullId,D.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=n}),define(fe[224],me([0,1,4,184]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[225],me([0,1,26,3,8]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class A{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(c=>I.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const c=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(d=>f.add(g.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!f.has(g.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,R){this.addNode(D),this.addNode(R),this._arcs.has(D)?this._arcs.get(D).push(R):this._arcs.set(D,[R])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,R){const E=I.getArcs(D);for(let a=0;a<E.length;a++)if(!R.has(E[a]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let D of n){const R=g.ExtensionIdentifier.toKey(D.identifier);if(c.set(R,D),D.extensionDependencies)for(let E of D.extensionDependencies){const a=g.ExtensionIdentifier.toKey(E);I.addArc(R,a)}}let f=new Set;I.getNodes().filter(D=>I.getArcs(D).length===0).forEach(D=>f.add(D));let d=I.getNodes().filter(D=>!f.has(D)),p;do{p=!1;for(let D=0;D<d.length;D++){const R=d[D];I.hasOnlyGoodArcs(R,f)&&(d.splice(D,1),D--,f.add(R),p=!0)}}while(p);return d.map(D=>c.get(D))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=A;var S;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(S||(S={}));function y(T,n){const I=T.isBuiltin?0:T.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==c)return I-c;const f=k.posix.basename(T.extensionLocation.path),d=k.posix.basename(n.extensionLocation.path);return f<d?-1:f>d?1:0}}),define(fe[226],me([0,1,22]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function C(S){const y=g.VSBuffer.alloc(1);switch(S){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=C;function A(S,y){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=A}),define(fe[35],me([0,1,3,2,4,26,186]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var S;(function(a){a[a.None=0]="None",a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(S=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(o){this.dependency=o}}e.MissingExtensionDependency=y;var T;(function(a){a[a.LocalProcess=0]="LocalProcess",a[a.LocalWebWorker=1]="LocalWebWorker",a[a.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function n(a){switch(a){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=n;class I{constructor(o,m,t,u){this.codeLoadingTime=o,this.activateCallTime=m,this.activateResolvedTime=t,this.activationReason=u}}e.ActivationTimes=I;class c{constructor(o,m){this.description=o,this.value=m}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var f;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(f=e.ActivationKind||(e.ActivationKind={}));function d(a){a.enableProposedApi||p(a)}e.checkProposedApiEnabled=d;function p(a){throw new Error(`[${a.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.throwProposedApiError=p;function D(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation}}e.toExtension=D;function R(a,o){return{identifier:new C.ExtensionIdentifier(a.identifier.id),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!o,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid}}e.toExtensionDescription=R;class E{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(o){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(o){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(o,m){return Promise.resolve()}_onWillActivateExtension(o){}_onDidActivateExtension(o,m,t,u,r){}_onDidActivateExtensionError(o,m){}_onExtensionRuntimeError(o,m){}_onExtensionHostExit(o){}}e.NullExtensionService=E}),define(fe[227],me([0,1,26,35,13]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class A{constructor(d,p,D,R){this.startup=d,this.codeLoadingTime=p,this.activateCallTime=D,this.activateResolvedTime=R}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class S{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,p){return d===-1||p===-1?-1:p-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(d,p,D,R,E,a){this.activationFailed=d,this.activationFailedError=p,this.activationTimes=D,this.module=R,this.exports=E,this.subscriptions=a}}e.ActivatedExtension=y;class T extends y{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class n extends y{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends y{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let c=class{constructor(d,p,D,R,E){this._logService=E,this._registry=d,this._resolvedExtensionsSet=new Set,p.forEach(a=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,D.forEach(a=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(a),a)),this._host=R,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const p=g.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(p)}getActivatedExtension(d){const p=g.ExtensionIdentifier.toKey(d),D=this._activatedExtensions.get(p);if(!D)throw new Error("Extension `"+d.value+"` is not known or not activated");return D}activateByEvent(d,p){if(this._alreadyActivatedEvents[d])return C;const D=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(D.map(R=>({id:R.identifier,reason:{startup:p,extensionId:R.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,p){const D=this._registry.getExtensionDescription(d);if(!D)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:D.identifier,reason:p}])}_handleActivateRequest(d,p,D){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(d.id))){p[g.ExtensionIdentifier.toKey(d.id)]=d;return}const R=this._registry.getExtensionDescription(d.id);if(!R){const o=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,o,new L.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(d.id),new I(o));return}const E=typeof R.extensionDependencies=="undefined"?[]:R.extensionDependencies;let a=!0;for(let o=0,m=E.length;o<m;o++){const t=E[o];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const u=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){const l=R.displayName||R.identifier.value,h=this._registry.getExtensionDescription(t),w=h&&h.displayName||t,_=new Error(`Cannot activate the '${l}' extension because its dependency '${w}' failed to activate`);_.detail=u.activationFailedError,this._host.onExtensionActivationError(R.identifier,_,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(R.identifier),new I(_));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){a=!1,p[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){a=!1,p[g.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:d.reason};continue}const i=R.displayName||R.identifier.value,s=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(R.identifier,s,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(R.identifier),new I(s));return}a?p[g.ExtensionIdentifier.toKey(R.identifier)]=d:D.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(E=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(E.id))),d.length===0))return Promise.resolve(void 0);const p=Object.create(null),D=[];for(let E=0,a=d.length;E<a;E++)this._handleActivateRequest(d[E],p,D);for(let E=0,a=D.length;E<a;E++){const o=g.ExtensionIdentifier.toKey(D[E].id);p[o]&&delete p[o]}const R=Object.keys(p).map(E=>p[E]);return D.length===0?Promise.all(R.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(R).then(E=>this._activateExtensions(D))}_activateExtension(d,p){const D=g.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const R=this._activatingExtensions.get(D);if(R)return R;const E=this._host.actualActivateExtension(d,p).then(void 0,a=>{const o=new Error;return a&&a.name&&(o.name=a.name),a&&a.message?o.message=`Activating extension '${d.value}' failed: ${a.message}.`:o.message=`Activating extension '${d.value}' failed: ${a}.`,a&&a.stack&&(o.stack=a.stack),this._host.onExtensionActivationError(d,o,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(D,a),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,E),E}};c=Ge([We(4,k.ILogService)],c),e.ExtensionsActivator=c}),define(fe[228],me([0,1,13,35,27,10,116]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends g.LogService{constructor(T){if(T.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(L.ExtensionHostLogFileName,T.logFile.fsPath,!0,T.logLevel))}$setLevel(T){this.setLevel(T)}};S=Ge([We(0,k.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(fe[229],me([0,1,17]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,A)=>{this._actualOk=C,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,A){return this._ensureActual().then(C,A)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(fe[55],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(T,n){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=n,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function k(y){const T=new g(!0,y);return L[T.nid]=T,T}e.createMainContextProxyIdentifier=k;function C(y){const T=new g(!1,y);return L[T.nid]=T,T}e.createExtHostContextProxyIdentifier=C;function A(y){return L[y].sid}e.getStringIdentifierForProxy=A;class S{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=S}),define(fe[5],me([0,1,61,2,55]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var A;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(a){a.name="$ident";function o(t,u){return Object.defineProperty(t,a.name,{value:u,enumerable:!0}),t}a.mixin=o;function m(t){return t[a.name]}a.of=m})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(o){return o._id=f._n++,o}}e.IdObject=f,f._n=0;var d;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function R(a){if(a&&a.edits)for(const o of a.edits)typeof o.resource=="object"?o.resource=L.URI.revive(o.resource):(o.newUri=L.URI.revive(o.newUri),o.oldUri=L.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,g.revive)(o.metadata));return a}e.reviveWorkspaceEditDto=R;var E;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[90],me([0,1,5,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(S){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,y){return this._proxy.$getPassword(S,y)}store(S,y,T){return this._proxy.$setPassword(S,y,T)}delete(S,y){return this._proxy.$deletePassword(S,y)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(fe[67],me([0,1,4,13,5,14]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(y,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,T,n){const I=this.getUsageKey(y,T);this._reportedUsages.has(I)||(this._reportedUsages.add(I),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}getUsageKey(y,T){return`${y}-${T.identifier.value}`}};A=Ge([We(0,C.IExtHostRpcService),We(1,L.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(S,y,T){}})}),define(fe[230],me([0,1,3,5,7,26]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,T,n,I={}){const c=C.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(c)||[],d=[...n].sort().join(" ");let p=f.find(D=>D.scopes===d);if(p)return p.result;{const D=this._getSession(y,c,T,n,I);p={scopes:d,result:D},f.push(p),this._inFlightRequests.set(c,f);try{await D}finally{const R=f.findIndex(E=>E.scopes===d);R>-1&&(f.splice(R),this._inFlightRequests.set(c,f))}return D}}async _getSession(y,T,n,I,c={}){await this._proxy.$ensureProvider(n);const f=y.displayName||y.name;return this._proxy.$getSession(n,I,T,f,c)}async removeSession(y,T){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(T):this._proxy.$removeSession(y,T)}registerAuthenticationProvider(y,T,n,I){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:T,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===y)||this._providers.push({id:y,label:T});const c=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(y,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,T,I?.supportsMultipleAccounts??!1),new k.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(y);const f=this._providers.findIndex(d=>d.id===y);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this._onDidChangeSessions.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[231],me([0,1,5,14,15]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(S,y){this._extHostDocumentsAndEditors=y,this._proxy=S.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const y=k.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};C=Ge([We(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(fe[232],me([0,1,5]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const A=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(S){return A.$writeText(S)}})}}e.ExtHostClipboard=L}),define(fe[40],me([0,1,12,7,15,25,5,16,13,61,42,51,2,6,4,14,65,22,55]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(i,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadCommands),this._logService=s,this.converter=new o(this,l=>{const h=this._apiCommands.get(l);return h?.result===t.Void?h:void 0},s),this._argumentProcessors=[{processArgument(l){return(0,T.revive)(l)}},{processArgument(l){return(0,C.cloneAndChange)(l,function(h){if(n.Range.isIRange(h))return k.Range.to(h);if(I.Position.isIPosition(h))return k.Position.to(h);if(n.Range.isIRange(h.range)&&c.URI.isUri(h.uri))return k.location.to(h);if(h instanceof R.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const s=this.registerCommand(!1,i.id,async(...l)=>{const h=i.args.map((_,v)=>{if(!_.validate(l[v]))throw new Error(`Invalid argument '${_.name}' when running '${i.id}', received: ${l[v]}`);return _.convert(l[v])}),w=await this.executeCommand(i.internalId,...h);return i.result.convert(w,l,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new L.Disposable(()=>{s.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,s,l,h,w){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:l,thisArg:h,description:w}),i&&this._proxy.$registerCommand(s),new L.Disposable(()=>{this._commands.delete(s)&&i&&this._proxy.$unregisterCommand(s)})}executeCommand(i,...s){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,s,!0)}async _doExecuteCommand(i,s,l){if(this._commands.has(i))return this._executeContributedCommand(i,s);{let h=!1;const w=(0,C.cloneAndChange)(s,function(_){if(_ instanceof L.Position)return k.Position.from(_);if(_ instanceof L.Range)return k.Range.from(_);if(_ instanceof L.Location)return k.location.from(_);if(L.NotebookRange.isNotebookRange(_))return k.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return h=!0,R.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return h=!0,R.VSBuffer.wrap(_);if(!Array.isArray(_))return _});try{const _=await this._proxy.$executeCommand(i,h?new E.SerializableObjectWithBuffers(w):w,l);return(0,T.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(i,s,!1);throw _}}}async _executeContributedCommand(i,s){const l=this._commands.get(i);if(!l)throw new Error("Unknown command");let{callback:h,thisArg:w,description:_}=l;if(_)for(let v=0;v<_.args.length;v++)try{(0,g.validateConstraint)(s[v],_.args[v].constraint)}catch(P){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${_.args[v].name}' - ${_.args[v].description}`)}try{return await h.apply(w,s)}catch(v){if(i===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...s);P&&(i=P.command)}throw this._logService.error(v,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(s=s.map(l=>this._argumentProcessors.reduce((h,w)=>w.processArgument(h),l)),this._executeContributedCommand(i,s)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(s=>(i&&(s=s.filter(l=>l[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[s,l]of this._commands){let{description:h}=l;h&&(i[s]=h)}return Promise.resolve(i)}};a=Ge([We(0,p.IExtHostRpcService),We(1,y.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class o{constructor(i,s,l){this._commands=i,this._lookupApiCommand=s,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,s){if(!i)return;const l={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return l;const h=this._lookupApiCommand(i.command);if(h)l.id=h.internalId,l.arguments=h.args.map((w,_)=>w.convert(i.arguments&&i.arguments[_]));else if((0,S.isNonEmptyArray)(i.arguments)){const w=++this._cachIdPool;this._cache.set(w,i),s.add((0,f.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),l.$ident=w,l.id=this.delegatingCommandId,l.arguments=[w],this._logService.trace("CommandsConverter#CREATE",i.command,w)}return l}fromInternal(i){const s=A.ObjectIdentifier.of(i);return typeof s=="number"?this._cache.get(s):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const s=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class m{constructor(i,s,l,h){this.name=i,this.description=s,this.validate=l,this.convert=h}optional(){return new m(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,s){return new m(i??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=m,m.Uri=new m("uri","Uri of a text document",r=>c.URI.isUri(r),r=>r),m.Position=new m("position","A position in a text document",r=>L.Position.isPosition(r),k.Position.from),m.Range=new m("range","A range in a text document",r=>L.Range.isRange(r),k.Range.from),m.Selection=new m("selection","A selection in a text document",r=>L.Selection.isSelection(r),k.Selection.from),m.Number=new m("number","",r=>typeof r=="number",r=>r),m.String=new m("string","",r=>typeof r=="string",r=>r),m.CallHierarchyItem=new m("item","A call hierarchy item",r=>r instanceof L.CallHierarchyItem,k.CallHierarchyItem.from),m.TypeHierarchyItem=new m("item","A type hierarchy item",r=>r instanceof L.TypeHierarchyItem,k.TypeHierarchyItem.from),m.TestItem=new m("testItem","A VS Code TestItem",r=>r instanceof D.TestItemImpl,k.TestItem.from);class t{constructor(i,s){this.description=i,this.convert=s}}e.ApiCommandResult=t,t.Void=new t("no result",r=>r);class u{constructor(i,s,l,h,w){this.id=i,this.internalId=s,this.description=l,this.args=h,this.result=w}}e.ApiCommand=u}),define(fe[233],me([0,1,15,7,83,40,16,111]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,f)=>{if((0,A.isFalsyOrEmpty)(c))return;class d extends L.SymbolInformation{static to(D){const R=new d(D.name,g.SymbolKind.to(D.kind),D.containerName||"",new L.Location(f[0],g.Range.to(D.range)));return R.detail=D.detail,R.range=R.location.range,R.selectionRange=g.Range.to(D.selectionRange),R.children=D.children?D.children.map(d.to):[],R}}return c.map(d.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(f=>L.Position.isPosition(f)),c=>c.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(f=>{let d;for(const p of f.reverse())d=new L.SelectionRange(g.Range.to(p),d);return d}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const f=[];if(Array.isArray(c))for(let d of c)f.push(...d[1].map(g.WorkspaceSymbol.to));return f})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const f=(0,S.decodeSemanticTokensDto)(c);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const f=(0,S.decodeSemanticTokensDto)(c);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,f,d)=>{if(!c)return new L.CompletionList([]);const p=c.suggestions.map(D=>g.CompletionItem.to(D,d));return new L.CompletionList(p,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,f,d)=>n(p=>new L.CodeLens(g.Range.to(p.range),p.command&&d.fromInternal(p.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,f,d)=>n(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(p.command)}else{const D=new L.CodeAction(p.title,p.kind?new L.CodeActionKind(p.kind):void 0);return p.edit&&(D.edit=g.WorkspaceEdit.to(p.edit)),p.command&&(D.command=d.fromInternal(p.command)),D.isPreferred=p.isPreferred,D}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(f=>new L.ColorInformation(g.Range.to(f.range),g.Color.to(f.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(f=>g.NotebookExclusiveDocumentPattern.to(f))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class T{static register(f){y.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function n(c){return f=>{if(Array.isArray(f))return f.map(c)}}function I(c){if(!Array.isArray(c))return;const f=[];for(const d of c)k.isLocationLink(d)?f.push(g.DefinitionLink.to(d)):f.push(g.location.to(d));return f}}),define(fe[234],me([0,1,18,59,3,6,2,83,26,15,7,5]),function(J,e,g,L,k,C,A,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(f,d,p){const D=f.getProxy(I.MainContext.MainThreadComments);class R{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const l=s.getCommentThread(i.commentThreadHandle);return l||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const l=s.getCommentThread(i.thread.commentThreadHandle);return l?{thread:l,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const l=s.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let h=i.commentUniqueId,w=l.getCommentByUniqueId(h);return w||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const l=s.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let h=i.text,w=i.commentUniqueId,_=l.getCommentByUniqueId(w);return _?(_.body=h,_):i}return i}})}createCommentController(i,s,l){const h=R.handlePool++,w=new a(i,h,s,l);this._commentControllers.set(w.handle,w);const _=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return _.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),_),w.value}$createCommentThreadTemplate(i,s,l){const h=this._commentControllers.get(i);!h||h.$createCommentThreadTemplate(s,l)}async $updateCommentThreadTemplate(i,s,l){const h=this._commentControllers.get(i);!h||h.$updateCommentThreadTemplate(s,l)}$deleteCommentThread(i,s){const l=this._commentControllers.get(i);l&&l.$deleteCommentThread(s)}$provideCommentingRanges(i,s,l){const h=this._commentControllers.get(i);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=p.getDocument(A.URI.revive(s));return(0,g.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(w,l)).then(_=>_?_.map(v=>T.Range.from(v)):void 0)}$toggleReaction(i,s,l,h,w){const _=this._commentControllers.get(i);return!_||!_.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const v=_.getCommentThread(s);if(v){const P=v.getCommentByUniqueId(h.uniqueIdInThread);if(_!==void 0&&P&&_.reactionHandler)return _.reactionHandler(P,t(w))}return Promise.resolve(void 0)})}dispose(){}}R.handlePool=0;class E{constructor(i,s,l,h,w,_,v){this._commentControllerHandle=s,this._id=l,this._uri=h,this._range=w,this._comments=_,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),D.$createCommentThread(s,this.handle,this._id,this._uri,T.Range.from(this._range),v),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=_,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(s,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(b){P.range=b},get comments(){return P.comments},set comments(b){P.comments=b},get collapsibleState(){return P.collapsibleState},set collapsibleState(b){P.collapsibleState=b},get canReply(){return P.canReply},set canReply(b){P.canReply=b},get contextValue(){return P.contextValue},set contextValue(b){P.contextValue=b},get label(){return P.label},set label(b){P.label=b},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),s={};i("range")&&(s.range=T.Range.from(this._range)),i("label")&&(s.label=this.label),i("contextValue")&&(s.contextValue=this.contextValue),i("comments")&&(s.comments=this._comments.map(l=>o(this,l,this._commentsMap))),i("collapsibleState")&&(s.collapseState=u(this._collapseState)),i("canReply")&&(s.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(i){for(let s of this._commentsMap){let l=s[0],h=s[1];if(i===h)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,Ge([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,s,l,h){this._extension=i,this._handle=s,this._id=l,this._label=h,this._threads=new Map,D.$registerCommentController(this.handle,l,h);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(_){w.options=_},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(_){w.commentingRangeProvider=_},get reactionHandler(){return w.reactionHandler},set reactionHandler(_){w.reactionHandler=_},createCommentThread(_,v,P){return w.createCommentThread(_,v,P).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,s,l,h){if(typeof i=="string"){const w=new E(this.id,this.handle,i,s,l,h,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new E(this.id,this.handle,void 0,i,s,l,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,s){const l=new E(this.id,this.handle,void 0,A.URI.revive(i),T.Range.to(s),[],this._extension.identifier);return l.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(i,s){let l=this._threads.get(i);l&&(l.range=T.Range.to(s))}$deleteCommentThread(i){let s=this._threads.get(i);s&&s.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function o(r,i,s){let l=s.get(i);l||(l=++r.commentHandle,s.set(i,l));const h=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:h,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>m(w)):void 0}}function m(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function u(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}return new R}e.createExtHostComments=c}),define(fe[131],me([0,1,2,5,7,4,14,13,16,9,8]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(f,d){this._logService=d,this._provider=new Map,this._proxy=f.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,d){const p=wn._handlePool++;this._provider.set(p,{provider:f,extensionId:d}),this._proxy.$registerDecorationProvider(p,d.value);const D=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(R=>{if(!R){this._proxy.$onDidChange(p,null);return}let E=(0,y.asArray)(R);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(p,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,E.length);const a=E.map(t=>({uri:t,rank:(0,T.count)(t.path,"/")})),o=(0,y.groupBy)(a,(t,u)=>t.rank-u.rank||(0,T.compare)(t.uri.path,u.uri.path));let m=[];e:for(let t of o){let u;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(u!==i&&(u=i,m.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(p,m)});return new k.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(f,d,p){if(!this._provider.has(f))return Object.create(null);const D=Object.create(null),{provider:R,extensionId:E}=this._provider.get(f);return await Promise.all(d.map(async a=>{try{const{uri:o,id:m}=a,t=await Promise.resolve(R.provideFileDecoration(g.URI.revive(o),p));if(!t)return;try{k.FileDecoration.validate(t),D[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${E.value}': ${u}`)}}catch(o){this._logService.error(o)}})),D}};I._handlePool=0,I._maxEventSize=250,I=Ge([We(0,A.IExtHostRpcService),We(1,S.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[235],me([0,1,164,117,2,5,7,15,3,13,24,52,141]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";var f,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(a,o,m,t,u,r){this._name=a,this._owner=o,this._maxDiagnosticsPerFile=m,f.set(this,void 0),d.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,it(this,p,new c.SkipList((i,s)=>t.compare(i,s)),"f"),it(this,f,u,"f"),it(this,d,r,"f")}dispose(){this._isDisposed||(Oe(this,d,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,f,"f")&&Oe(this,f,"f").$clear(this._owner),Oe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,o){if(!a){this.clear();return}this._checkDisposed();let m=[];if(k.URI.isUri(a)){if(!o){this.delete(a);return}Oe(this,p,"f").set(a,o.slice()),m=[a]}else if(Array.isArray(a)){m=[];let u;a=[...a].sort(D._compareIndexedTuplesByUri);for(const r of a){const[i,s]=r;if((!u||i.toString()!==u.toString())&&(u&&Oe(this,p,"f").get(u).length===0&&Oe(this,p,"f").delete(u),u=i,m.push(i),Oe(this,p,"f").set(i,[])),s){const l=Oe(this,p,"f").get(i);l&&l.push(...s)}else{const l=Oe(this,p,"f").get(i);l&&(l.length=0)}}}if(Oe(this,d,"f").fire(m),!Oe(this,f,"f"))return;const t=[];for(let u of m){let r=[];const i=Oe(this,p,"f").get(u);if(i)if(i.length>this._maxDiagnosticsPerFile){r=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let h of i)if(h.severity===s[l]&&r.push(S.Diagnostic.from(h))===this._maxDiagnosticsPerFile)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=i.map(s=>S.Diagnostic.from(s));t.push([u,r])}Oe(this,f,"f").$changeMany(this._owner,t)}delete(a){this._checkDisposed(),Oe(this,d,"f").fire([a]),Oe(this,p,"f").delete(a),Oe(this,f,"f")&&Oe(this,f,"f").$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Oe(this,d,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,p,"f").clear(),Oe(this,f,"f")&&Oe(this,f,"f").$clear(this._owner)}forEach(a,o){this._checkDisposed();for(let m of Oe(this,p,"f").keys())a.apply(o,[m,this.get(m),this])}get(a){this._checkDisposed();const o=Oe(this,p,"f").get(a);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Oe(this,p,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,o){return a[0].toString()<o[0].toString()?-1:a[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=D,f=new WeakMap,d=new WeakMap,p=new WeakMap;let R=class Zt{constructor(a,o,m){this._logService=o,this._fileSystemInfoService=m,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=a.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(a){const o=new n.ResourceMap;for(const m of a)o.set(m,m);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(a,o){const{_collections:m,_proxy:t,_onDidChangeDiagnostics:u,_logService:r,_fileSystemInfoService:i}=this,s=new class{$changeMany(w,_){t.$changeMany(w,_),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,w,_.length===0?"CLEARING":_)}$clear(w){t.$clear(w),r.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,w)}dispose(){t.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+Zt._idPool++,l=o;else if(!m.has(o))l=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+Zt._idPool++;while(m.has(l))}return new class extends D{constructor(){super(o,l,Zt._maxDiagnosticsPerFile,i.extUri,s,u);m.set(l,this)}dispose(){super.dispose(),m.delete(l)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const o=new Map,m=[];for(const t of this._collections.values())t.forEach((u,r)=>{let i=o.get(u.toString());typeof i=="undefined"&&(i=m.length,o.set(u.toString(),i),m.push([u,[]])),m[i][1]=m[i][1].concat(...r)});return m}}_getDiagnostics(a){let o=[];for(let m of this._collections.values())m.has(a)&&(o=o.concat(m.get(a)));return o}$acceptMarkersChange(a){if(!this._mirrorCollection){const o="_generated_mirror",m=new D(o,o,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,m),this._mirrorCollection=m}for(const[o,m]of a)this._mirrorCollection.set(k.URI.revive(o),m.map(S.Diagnostic.to))}};R._idPool=0,R._maxDiagnosticsPerFile=1e3,R=Ge([We(1,T.ILogService),We(2,I.IExtHostFileSystemInfo)],R),e.ExtHostDiagnostics=R}),define(fe[236],me([0,1,2,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(S=>S?S.map(y=>g.URI.revive(y)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(S=>S?g.URI.revive(S):void 0)}}e.ExtHostDialogs=k}),define(fe[237],me([0,1,17,2,7,5,10,21,9]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(I,c,f){this._documentsAndEditors=c,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,c),this._proxy.$registerTextContentProvider(f,I);let d;return typeof c.onDidChange=="function"&&(d=c.onDidChange(p=>{if(p.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(f,p).then(D=>{if(!D&&typeof D!="string")return;const R=this._documentsAndEditors.getDocument(p);if(!R)return;const E=(0,y.splitLines)(D);if(!R.equalLines(E))return this._proxy.$onVirtualDocumentChange(p,D)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(I,c){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(L.URI.revive(c),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(fe[238],me([0,1,3,6,2,5,123,15,12,25,7]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(f,d){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const D of p)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const D of p)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const d=this._documentsAndEditors.getDocument(f);if(d)return d}getDocument(f){const d=this.getDocumentData(f);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return d.document}ensureDocumentData(f){const d=this._documentsAndEditors.getDocument(f);if(d)return Promise.resolve(d);let p=this._documentLoader.get(f.toString());return p||(p=this._proxy.$tryOpenDocument(f).then(D=>{this._documentLoader.delete(f.toString());const R=k.URI.revive(D);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(R))},D=>(this._documentLoader.delete(f.toString()),Promise.reject(D))),this._documentLoader.set(f.toString(),p)),p}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(d=>k.URI.revive(d))}$acceptModelModeChanged(f,d){const p=k.URI.revive(f),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(d),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(f){const d=k.URI.revive(f),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(f,d){const p=k.URI.revive(f),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");D._acceptIsDirty(d),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,d,p){const D=k.URI.revive(f),R=this._documentsAndEditors.getDocument(D);if(!R)throw new Error("unknown document");R._acceptIsDirty(p),R.onEvents(d);let E;d.isUndoing?E=n.TextDocumentChangeReason.Undo:d.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:R.document,contentChanges:d.changes.map(a=>({range:S.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:E}))}setWordDefinitionFor(f,d){(0,A.setWordDefinitionFor)(f,d)}}e.ExtHostDocuments=I}),define(fe[45],me([0,1,57,3,6,2,4,5,123,14,130,15,13,24,10,94,139]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class R{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(o,m){this._extHostRpc=o,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const m=[],t=[],u=[];if(o.removedDocuments)for(const r of o.removedDocuments){const i=C.URI.revive(r),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),m.push(s.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const i=C.URI.revive(r.uri);let s=this._documents.get(i);if(s&&i.scheme!==d.Schemas.vscodeNotebookCell&&i.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new R(new y.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,s),t.push(s.value)),s.ref()}if(o.removedEditors)for(const r of o.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&u.push(i)}if(o.addedEditors)for(const r of o.addedEditors){const i=C.URI.revive(r.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const s=this._documents.get(i).value,l=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>s.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(h=>I.Range.to(h)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,l)}o.newActiveEditor!==void 0&&(g.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,k.dispose)(m),(0,k.dispose)(u),o.removedDocuments&&this._onDidRemoveDocuments.fire(m),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return o?m:m?.value}allEditors(){return[...this._editors.values()]}};E=Ge([We(0,T.IExtHostRpcService),We(1,c.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[239],me([0,1,2,5,6,7,15,148,9,22]),function(J,e,g,L,k,C,A,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const d=this._schemes.indexOf(f);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),d=[];let p,D,R=14,E=14;for(const a of f){let o=p?(0,y.commonPrefixLength)(p,a):0;for(o===0?D=1:D=E;o<a.length;o++)o+1===a.length?(R=E,E=9):E+=1,d.push([D,a.toUpperCase().charCodeAt(o),E]),d.push([D,a.toLowerCase().charCodeAt(o),E]),D=E;p=a,E=R}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new S.StateMachine(d)}}provideDocumentLinks(f){this._initStateMachine();const d=[],p=S.LinkComputer.computeLinks({getLineContent(D){return f.lineAt(D-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const D of p){const R=A.DocumentLink.to(D);R.target&&d.push(R)}return d}}class I{constructor(f,d){this._extHostLanguageFeatures=d,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,d,p,D={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const R=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(R,p);let E=2;D.isCaseSensitive&&(E+=1024),D.isReadonly&&(E+=2048),typeof p.copy=="function"&&(E+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(R,d,E).catch(o=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${d}`),console.error(o)});const a=p.onDidChangeFile(o=>{const m=[];for(const t of o){let{uri:u,type:r}=t;if(u.scheme!==d)continue;let i;switch(r){case C.FileChangeType.Changed:i=0;break;case C.FileChangeType.Created:i=1;break;case C.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}m.push({resource:u,type:i})}this._proxy.$onFileSystemChange(R,m)});return(0,k.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(R),this._proxy.$unregisterProvider(R)})}static _asIStat(f){const{type:d,ctime:p,mtime:D,size:R,permissions:E}=f;return{type:d,ctime:p,mtime:D,size:R,permissions:E}}$stat(f,d){return Promise.resolve(this._getFsProvider(f).stat(g.URI.revive(d))).then(p=>I._asIStat(p))}$readdir(f,d){return Promise.resolve(this._getFsProvider(f).readDirectory(g.URI.revive(d)))}$readFile(f,d){return Promise.resolve(this._getFsProvider(f).readFile(g.URI.revive(d))).then(p=>T.VSBuffer.wrap(p))}$writeFile(f,d,p,D){return Promise.resolve(this._getFsProvider(f).writeFile(g.URI.revive(d),p.buffer,D))}$delete(f,d,p){return Promise.resolve(this._getFsProvider(f).delete(g.URI.revive(d),p))}$rename(f,d,p,D){return Promise.resolve(this._getFsProvider(f).rename(g.URI.revive(d),g.URI.revive(p),D))}$copy(f,d,p,D){const R=this._getFsProvider(f);if(!R.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(R.copy(g.URI.revive(d),g.URI.revive(p),D))}$mkdir(f,d){return Promise.resolve(this._getFsProvider(f).createDirectory(g.URI.revive(d)))}$watch(f,d,p,D){const R=this._getFsProvider(f).watch(g.URI.revive(p),D);this._watches.set(d,R)}$unwatch(f,d){const p=this._watches.get(d);p&&(p.dispose(),this._watches.delete(d))}$open(f,d,p){const D=this._getFsProvider(f);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(g.URI.revive(d),p))}$close(f,d){const p=this._getFsProvider(f);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(d))}$read(f,d,p,D){const R=this._getFsProvider(f);if(!R.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(D);return Promise.resolve(R.read(d,p,E.buffer,0,D)).then(a=>E.slice(0,a))}$write(f,d,p,D){const R=this._getFsProvider(f);if(!R.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(R.write(d,p,D.buffer,0,D.byteLength))}_getFsProvider(f){const d=this._fsProvider.get(f);if(!d){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return d}}e.ExtHostFileSystem=I}),define(fe[91],me([0,1,5,43,7,22,4,14,52]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Bt{constructor(I,c){const f=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return f.$stat(d).catch(Bt._handleError)},readDirectory(d){return f.$readdir(d).catch(Bt._handleError)},createDirectory(d){return f.$mkdir(d).catch(Bt._handleError)},async readFile(d){return f.$readFile(d).then(p=>p.buffer).catch(Bt._handleError)},writeFile(d,p){return f.$writeFile(d,C.VSBuffer.wrap(p)).catch(Bt._handleError)},delete(d,p){return f.$delete(d,{recursive:!1,useTrash:!1,...p}).catch(Bt._handleError)},rename(d,p,D){return f.$rename(d,p,{overwrite:!1,...D}).catch(Bt._handleError)},copy(d,p,D){return f.$copy(d,p,{overwrite:!1,...D}).catch(Bt._handleError)},isWritableFileSystem(d){const p=c.getCapabilities(d);if(typeof p=="number")return!(p&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};T=Ge([We(0,S.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[240],me([0,1,2,40]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(A,S,y,T){this._extHostNotebooks=S,this._textDocumentsAndEditors=y,this._commands=T;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(A,S,y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:S,lines:[""],modeId:y,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,S){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=k}),define(fe[241],me([0,1,6,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,A),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=k}),define(fe[242],me([0,1,2,25,15,7,5,9,42,16,12,145,6,111,76,87,46,17,3]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentSymbols(j,ee){const se=this._documents.getDocument(j),le=await this._provider.provideDocumentSymbols(se,ee);if(!(0,T.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(k.DocumentSymbol.from):a._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(j){j=j.slice(0).sort((le,Z)=>{let ae=le.location.range.start.compareTo(Z.location.range.start);return ae===0&&(ae=Z.location.range.end.compareTo(le.location.range.end)),ae});const ee=[],se=[];for(const le of j){const Z={name:le.name||"!!MISSING: name!!",kind:k.SymbolKind.from(le.kind),tags:le.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:k.Range.from(le.location.range),selectionRange:k.Range.from(le.location.range),children:[]};for(;;){if(se.length===0){se.push(Z),ee.push(Z);break}const ae=se[se.length-1];if(y.Range.containsRange(ae.range,Z.range)&&!y.Range.equalsRange(ae.range,Z.range)){ae.children&&ae.children.push(Z),se.push(Z);break}se.pop()}}return ee}}class o{constructor(j,ee,se){this._documents=j,this._commands=ee,this._provider=se,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,ee){const se=this._documents.getDocument(j),le=await this._provider.provideCodeLenses(se,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),ae=new c.DisposableStore;this._disposables.set(Z,ae);const ve={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Z,Me],range:k.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return ve}async resolveCodeLens(j,ee){const se=j.cacheId&&this._cache.get(...j.cacheId);if(!se)return;let le;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?le=se:le=await this._provider.resolveCodeLens(se,ee),le||(le=se),ee.isCancellationRequested)return;const Z=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!Z)return j.command=this._commands.toInternal(le.command??o._badCmd,Z),j}releaseCodeLenses(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function m(He){return Array.isArray(He)?He.map(k.DefinitionLink.from):He?[k.DefinitionLink.from(He)]:[]}class t{constructor(j,ee){this._documents=j,this._provider=ee}async provideDefinition(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideDefinition(le,Z,se);return m(ae)}}class u{constructor(j,ee){this._documents=j,this._provider=ee}async provideDeclaration(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideDeclaration(le,Z,se);return m(ae)}}class r{constructor(j,ee){this._documents=j,this._provider=ee}async provideImplementation(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideImplementation(le,Z,se);return m(ae)}}class i{constructor(j,ee){this._documents=j,this._provider=ee}async provideTypeDefinition(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideTypeDefinition(le,Z,se);return m(ae)}}class s{constructor(j,ee){this._documents=j,this._provider=ee}async provideHover(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideHover(le,Z,se);if(!(!ae||(0,T.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Z)),ae.range||(ae.range=new C.Range(Z,Z)),k.Hover.from(ae)}}class l{constructor(j,ee){this._documents=j,this._provider=ee}async provideEvaluatableExpression(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideEvaluatableExpression(le,Z,se);if(ae)return k.EvaluatableExpression.from(ae)}}class h{constructor(j,ee){this._documents=j,this._provider=ee}async provideInlineValues(j,ee,se,le){const Z=this._documents.getDocument(j),ae=await this._provider.provideInlineValues(Z,k.Range.to(ee),k.InlineValueContext.to(se),le);if(Array.isArray(ae))return ae.map(ve=>k.InlineValue.from(ve))}}class w{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentHighlights(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideDocumentHighlights(le,Z,se);if(Array.isArray(ae))return ae.map(k.DocumentHighlight.from)}}class _{constructor(j,ee){this._documents=j,this._provider=ee}async provideLinkedEditingRanges(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.provideLinkedEditingRanges(le,Z,se);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,T.coalesce)(ae.ranges.map(k.Range.from)),wordPattern:ae.wordPattern}}}class v{constructor(j,ee){this._documents=j,this._provider=ee}async provideReferences(j,ee,se,le){const Z=this._documents.getDocument(j),ae=k.Position.to(ee),ve=await this._provider.provideReferences(Z,ae,se,le);if(Array.isArray(ve))return ve.map(k.location.from)}}class P{constructor(j,ee,se,le,Z,ae,ve){this._documents=j,this._commands=ee,this._diagnostics=se,this._provider=le,this._logService=Z,this._extension=ae,this._apiDeprecation=ve,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(j,ee,se,le){const Z=this._documents.getDocument(j),ae=I.Selection.isISelection(ee)?k.Selection.to(ee):k.Range.to(ee),ve=[];for(const at of this._diagnostics.getDiagnostics(j))if(ae.intersection(at.range)&&ve.push(at)>P._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:se.only?new C.CodeActionKind(se.only):void 0,triggerKind:k.CodeActionTriggerKind.to(se.trigger)},qe=await this._provider.provideCodeActions(Z,ae,Me,le);if(!(0,T.isNonEmptyArray)(qe)||le.isCancellationRequested)return;const Ye=this._cache.add(qe),Ze=new c.DisposableStore;this._disposables.set(Ye,Ze);const ke=[];for(let at=0;at<qe.length;at++){const X=qe[at];!X||(P._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ke.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,Ze)})):(Me.only&&(X.kind?Me.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ke.push({cacheId:[Ye,at],title:X.title,command:X.command&&this._commands.toInternal(X.command,Ze),diagnostics:X.diagnostics&&X.diagnostics.map(k.Diagnostic.from),edit:X.edit&&k.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:X.disabled?.reason})))}return{cacheId:Ye,actions:ke}}async resolveCodeAction(j,ee){const[se,le]=j,Z=this._cache.get(se,le);if(!Z||P._isCommand(Z)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Z,ee)??Z;return ae?.edit?k.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}P._maxCodeActionsPerFile=1e3;class b{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentFormattingEdits(j,ee,se){const le=this._documents.getDocument(j),Z=await this._provider.provideDocumentFormattingEdits(le,ee,se);if(Array.isArray(Z))return Z.map(k.TextEdit.from)}}class F{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentRangeFormattingEdits(j,ee,se,le){const Z=this._documents.getDocument(j),ae=k.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Z,ae,se,le);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class M{constructor(j,ee){this._documents=j,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,ee,se,le,Z){const ae=this._documents.getDocument(j),ve=k.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(ae,ve,se,le,Z);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class q{constructor(j,ee){this._provider=j,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(j,ee){const se=A.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(j,ee);if((0,T.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const ae=A.IdObject.mixin(k.WorkspaceSymbol.from(Z));this._symbolCache.set(ae._id,Z),se.symbols.push(ae)}return se.symbols.length>0&&this._resultCache.set(se._id,[se.symbols[0]._id,se.symbols[se.symbols.length-1]._id]),se}async resolveWorkspaceSymbol(j,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const se=this._symbolCache.get(j._id);if(se){const le=await this._provider.resolveWorkspaceSymbol(se,ee);return le&&(0,L.mixin)(j,k.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(j){const ee=this._resultCache.get(j);if(ee){for(let[se,le]=ee;se<=le;se++)this._symbolCache.delete(se);this._resultCache.delete(j)}}}class G{constructor(j,ee,se){this._documents=j,this._provider=ee,this._logService=se}static supportsResolving(j){return typeof j.prepareRename=="function"}async provideRenameEdits(j,ee,se,le){const Z=this._documents.getDocument(j),ae=k.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Z,ae,se,le);return ve?k.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=G._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(j,ee,se){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(j),Z=k.Position.to(ee);try{const ae=await this._provider.prepareRename(le,Z,se);let ve,Me;if(C.Range.isRange(ae)?(ve=ae,Me=le.getText(ae)):(0,n.isObject)(ae)&&(ve=ae.range,Me=ae.placeholder),!ve||!Me)return;if(ve.start.line>Z.line||ve.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Me}}catch(ae){const ve=G._asMessage(ae);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class U{constructor(j,ee){this.resultId=j,this.tokens=ee}}class z{constructor(j,ee){this._documents=j,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(j,ee,se){const le=this._documents.getDocument(j),Z=ee!==0?this._previousResults.get(ee):null;let ae=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,se):await this._provider.provideDocumentSemanticTokens(le,se);return Z&&this._previousResults.delete(ee),ae?(ae=z._fixProvidedSemanticTokens(ae),this._send(z._convertToEdits(Z,ae),ae)):null}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return z._isSemanticTokens(j)?z._isCorrectSemanticTokens(j)?j:new C.SemanticTokens(new Uint32Array(j.data),j.resultId):z._isSemanticTokensEdits(j)?z._isCorrectSemanticTokensEdits(j)?j:new C.SemanticTokensEdits(j.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const ee of j.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,ee){if(!z._isSemanticTokens(ee)||!j||!j.tokens)return ee;const se=j.tokens,le=se.length,Z=ee.data,ae=Z.length;let ve=0;const Me=Math.min(le,ae);for(;ve<Me&&se[ve]===Z[ve];)ve++;if(ve===le&&ve===ae)return new C.SemanticTokensEdits([],ee.resultId);let qe=0;const Ye=Me-ve;for(;qe<Ye&&se[le-qe-1]===Z[ae-qe-1];)qe++;return new C.SemanticTokensEdits([{start:ve,deleteCount:le-ve-qe,data:Z.subarray(ve,ae-qe)}],ee.resultId)}_send(j,ee){if(z._isSemanticTokens(j)){const se=this._nextResultId++;return this._previousResults.set(se,new U(j.resultId,j.data)),(0,f.encodeSemanticTokensDto)({id:se,type:"full",data:j.data})}if(z._isSemanticTokensEdits(j)){const se=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(se,new U(ee.resultId,ee.data)):this._previousResults.set(se,new U(j.resultId)),(0,f.encodeSemanticTokensDto)({id:se,type:"delta",deltas:(j.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class O{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentRangeSemanticTokens(j,ee,se){const le=this._documents.getDocument(j),Z=await this._provider.provideDocumentRangeSemanticTokens(le,k.Range.to(ee),se);return Z?this._send(Z):null}_send(j){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=O;class N{constructor(j,ee,se,le,Z){this._documents=j,this._commands=ee,this._provider=se,this._apiDeprecation=le,this._extension=Z,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,ee,se,le){const Z=this._documents.getDocument(j),ae=k.Position.to(ee),ve=Z.getWordRangeAtPosition(ae)||new C.Range(ae,ae),Me=ve.with({end:ae}),qe=new D.StopWatch(!0),Ye=await this._provider.provideCompletionItems(Z,ae,le,k.CompletionContext.to(se));if(!Ye||le.isCancellationRequested)return;const Ze=Array.isArray(Ye)?new C.CompletionList(Ye):Ye,ke=N.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),at=new c.DisposableStore;this._disposables.set(ke,at);const X=[],te={x:ke,b:X,a:{replace:k.Range.from(ve),insert:k.Range.from(Me)},c:Ze.isIncomplete||void 0,d:qe.elapsed()};for(let ge=0;ge<Ze.items.length;ge++){const je=Ze.items[ge],tt=this._convertCompletionItem(je,[ke,ge],Me,ve);X.push(tt)}return te}async resolveCompletionItem(j,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const se=this._cache.get(...j);if(!se)return;const le=await this._provider.resolveCompletionItem(se,ee);if(!!le)return this._convertCompletionItem(le,j)}releaseCompletionItems(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,ee,se,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const ae={x:ee,a:j.label,b:j.kind!==void 0?k.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(k.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(j.command,Z)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=j.textEdit.newText):typeof j.insertText=="string"?ae.h=j.insertText:j.insertText instanceof C.SnippetString&&(ae.h=j.insertText.value,ae.i|=4);let ve;return j.textEdit?ve=j.textEdit.range:j.range&&(ve=j.range),C.Range.isRange(ve)?ae.j=k.Range.from(ve):ve&&(!se?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(ae.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),ae}}class x{constructor(j,ee,se){this._documents=j,this._provider=ee,this._commands=se,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,ee,se,le){const Z=this._documents.getDocument(j),ae=k.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Z,ae,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:k.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:se.triggerKind},le);if(!ve||le.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,qe=this._cache.add(Me.items);let Ye;return{pid:qe,items:Me.items.map((Ze,ke)=>{let at;return Ze.command&&(Ye||(Ye=new c.DisposableStore,this._disposables.set(qe,Ye)),at=this._commands.toInternal(Ze.command,Ye)),{text:Ze.text,range:Ze.range?k.Range.from(Ze.range):void 0,command:at,idx:ke}})}}disposeCompletions(j){this._cache.delete(j);const ee=this._disposables.get(j);ee&&ee.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,ee){const se=this._cache.get(j,ee);se&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:se})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let ee=B.map.get(j);return ee||(ee=new B,B.map.set(j,ee)),ee}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=B,B.map=new WeakMap;class H{constructor(j,ee){this._documents=j,this._provider=ee,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(j,ee,se,le){const Z=this._documents.getDocument(j),ae=k.Position.to(ee),ve=this.reviveContext(se),Me=await this._provider.provideSignatureHelp(Z,ae,le,ve);if(Me){const qe=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:qe}}}reviveContext(j){let ee;if(j.activeSignatureHelp){const se=k.SignatureHelp.to(j.activeSignatureHelp),le=this._cache.get(j.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=se.activeSignature,ee.activeParameter=se.activeParameter):ee=se}return{...j,activeSignatureHelp:ee}}releaseSignatureHelp(j){this._cache.delete(j)}}class ${constructor(j,ee){this._documents=j,this._provider=ee}async provideInlayHints(j,ee,se){const le=this._documents.getDocument(j),Z=await this._provider.provideInlayHints(le,k.Range.to(ee),se);return Z?{hints:Z.map(k.InlayHint.from)}:void 0}}class Y{constructor(j,ee){this._documents=j,this._provider=ee,this._cache=new p.Cache("DocumentLink")}async provideLinks(j,ee){const se=this._documents.getDocument(j),le=await this._provider.provideDocumentLinks(se,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(Y._validateLink).map(k.DocumentLink.from)};{const Z=this._cache.add(le),ae={links:[],id:Z};for(let ve=0;ve<le.length;ve++){if(!Y._validateLink(le[ve]))continue;const Me=k.DocumentLink.from(le[ve]);Me.cacheId=[Z,ve],ae.links.push(Me)}return ae}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const se=this._cache.get(...j);if(!se)return;const le=await this._provider.resolveDocumentLink(se,ee);if(!(!le||!Y._validateLink(le)))return k.DocumentLink.from(le)}releaseLinks(j){this._cache.delete(j)}}class Q{constructor(j,ee){this._documents=j,this._provider=ee}async provideColors(j,ee){const se=this._documents.getDocument(j),le=await this._provider.provideDocumentColors(se,ee);return Array.isArray(le)?le.map(ae=>({color:k.Color.from(ae.color),range:k.Range.from(ae.range)})):[]}async provideColorPresentations(j,ee,se){const le=this._documents.getDocument(j),Z=k.Range.to(ee.range),ae=k.Color.to(ee.color),ve=await this._provider.provideColorPresentations(ae,{document:le,range:Z},se);if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)}}class de{constructor(j,ee){this._documents=j,this._provider=ee}async provideFoldingRanges(j,ee,se){const le=this._documents.getDocument(j),Z=await this._provider.provideFoldingRanges(le,ee,se);if(!!Array.isArray(Z))return Z.map(k.FoldingRange.from)}}class _e{constructor(j,ee,se){this._documents=j,this._provider=ee,this._logService=se}async provideSelectionRanges(j,ee,se){const le=this._documents.getDocument(j),Z=ee.map(k.Position.to),ae=await this._provider.provideSelectionRanges(le,Z,se);if(!(0,T.isNonEmptyArray)(ae))return[];if(ae.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Z.length;Me++){const qe=[];ve.push(qe);let Ye=Z[Me],Ze=ae[Me];for(;;){if(!Ze.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(k.SelectionRange.from(Ze)),!Ze.parent)break;Ye=Ze.range,Ze=Ze.parent}}return ve}}class Ce{constructor(j,ee){this._documents=j,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.prepareCallHierarchy(le,Z,se);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideCallsTo(j,ee,se){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,se);if(!!Z)return Z.map(ae=>({from:this._cacheAndConvertItem(j,ae.from),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(j,ee,se){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,se);if(!!Z)return Z.map(ae=>({to:this._cacheAndConvertItem(j,ae.to),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,ee){const se=this._cache.get(j),le=k.CallHierarchyItem.from(ee,j,se.size.toString(36));return se.set(le._itemId,ee),le}_itemFromCache(j,ee){return this._cache.get(j)?.get(ee)}}class Te{constructor(j,ee){this._documents=j,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(j,ee,se){const le=this._documents.getDocument(j),Z=k.Position.to(ee),ae=await this._provider.prepareTypeHierarchy(le,Z,se);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideSupertypes(j,ee,se){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,se);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(j,ae))}async provideSubtypes(j,ee,se){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,se);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(j,ae))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,ee){const se=this._cache.get(j),le=k.TypeHierarchyItem.from(ee,j,se.size.toString(36));return se.set(le._itemId,ee),le}_itemFromCache(j,ee){return this._cache.get(j)?.get(ee)}}class $e{constructor(j,ee){this.adapter=j,this.extension=ee}}class Be{constructor(j,ee,se,le,Z,ae,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=j.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=se,this._commands=le,this._diagnostics=Z,this._logService=ae,this._apiDeprecation=ve}_transformDocumentSelector(j){return k.DocumentSelector.from(j,this._uriTransformer)}_createDisposable(j){return new C.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Be._handlePool++}_withAdapter(j,ee,se,le,Z=!1){const ae=this._adapter.get(j);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof ee){let ve;ae.extension&&(ve=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=se(ae.adapter,ae.extension),qe=ae.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ye=>{Z&&Ye instanceof R.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Ye))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,ee){const se=this._nextHandle();return this._adapter.set(se,new $e(j,ee)),se}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,ee,se,le){const Z=this._addNewAdapter(new a(this._documents,se),j),ae=le&&le.label||Be._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),ae),this._createDisposable(Z)}$provideDocumentSymbols(j,ee,se){return this._withAdapter(j,a,le=>le.provideDocumentSymbols(g.URI.revive(ee),se),void 0)}registerCodeLensProvider(j,ee,se){const le=this._nextHandle(),Z=typeof se.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new $e(new o(this._documents,this._commands.converter,se),j)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const ve=se.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));ae=C.Disposable.from(ae,ve)}return ae}$provideCodeLenses(j,ee,se){return this._withAdapter(j,o,le=>le.provideCodeLenses(g.URI.revive(ee),se),void 0)}$resolveCodeLens(j,ee,se){return this._withAdapter(j,o,le=>le.resolveCodeLens(ee,se),void 0)}$releaseCodeLenses(j,ee){this._withAdapter(j,o,se=>Promise.resolve(se.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(j,ee,se){const le=this._addNewAdapter(new t(this._documents,se),j);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(j,ee,se,le){return this._withAdapter(j,t,Z=>Z.provideDefinition(g.URI.revive(ee),se,le),[])}registerDeclarationProvider(j,ee,se){const le=this._addNewAdapter(new u(this._documents,se),j);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(j,ee,se,le){return this._withAdapter(j,u,Z=>Z.provideDeclaration(g.URI.revive(ee),se,le),[])}registerImplementationProvider(j,ee,se){const le=this._addNewAdapter(new r(this._documents,se),j);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(j,ee,se,le){return this._withAdapter(j,r,Z=>Z.provideImplementation(g.URI.revive(ee),se,le),[])}registerTypeDefinitionProvider(j,ee,se){const le=this._addNewAdapter(new i(this._documents,se),j);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(j,ee,se,le){return this._withAdapter(j,i,Z=>Z.provideTypeDefinition(g.URI.revive(ee),se,le),[])}registerHoverProvider(j,ee,se,le){const Z=this._addNewAdapter(new s(this._documents,se),j);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(j,ee,se,le){return this._withAdapter(j,s,Z=>Z.provideHover(g.URI.revive(ee),se,le),void 0)}registerEvaluatableExpressionProvider(j,ee,se,le){const Z=this._addNewAdapter(new l(this._documents,se),j);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(j,ee,se,le){return this._withAdapter(j,l,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),se,le),void 0)}registerInlineValuesProvider(j,ee,se,le){const Z=typeof se.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new h(this._documents,se),j);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(ee),Z);let ve=this._createDisposable(ae);if(Z!==void 0){const Me=se.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Z));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(j,ee,se,le,Z){return this._withAdapter(j,h,ae=>ae.provideInlineValues(g.URI.revive(ee),se,le,Z),void 0)}registerDocumentHighlightProvider(j,ee,se){const le=this._addNewAdapter(new w(this._documents,se),j);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(j,ee,se,le){return this._withAdapter(j,w,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),se,le),void 0)}registerLinkedEditingRangeProvider(j,ee,se){const le=this._addNewAdapter(new _(this._documents,se),j);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(j,ee,se,le){return this._withAdapter(j,_,async Z=>{const ae=await Z.provideLinkedEditingRanges(g.URI.revive(ee),se,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?Be._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(j,ee,se){const le=this._addNewAdapter(new v(this._documents,se),j);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(j,ee,se,le,Z){return this._withAdapter(j,v,ae=>ae.provideReferences(g.URI.revive(ee),se,le,Z),void 0)}registerCodeActionProvider(j,ee,se,le){const Z=new c.DisposableStore,ae=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,se,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Z)}))},Be._extLabel(j),Boolean(se.resolveCodeAction)),Z.add(this._createDisposable(ae)),Z}$provideCodeActions(j,ee,se,le,Z){return this._withAdapter(j,P,ae=>ae.provideCodeActions(g.URI.revive(ee),se,le,Z),void 0)}$resolveCodeAction(j,ee,se){return this._withAdapter(j,P,le=>le.resolveCodeAction(ee,se),void 0)}$releaseCodeActions(j,ee){this._withAdapter(j,P,se=>Promise.resolve(se.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(j,ee,se){const le=this._addNewAdapter(new b(this._documents,se),j);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),j.identifier,j.displayName||j.name),this._createDisposable(le)}$provideDocumentFormattingEdits(j,ee,se,le){return this._withAdapter(j,b,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),se,le),void 0)}registerDocumentRangeFormattingEditProvider(j,ee,se){const le=this._addNewAdapter(new F(this._documents,se),j);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),j.identifier,j.displayName||j.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(j,ee,se,le,Z){return this._withAdapter(j,F,ae=>ae.provideDocumentRangeFormattingEdits(g.URI.revive(ee),se,le,Z),void 0)}registerOnTypeFormattingEditProvider(j,ee,se,le){const Z=this._addNewAdapter(new M(this._documents,se),j);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,j.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(j,ee,se,le,Z,ae){return this._withAdapter(j,M,ve=>ve.provideOnTypeFormattingEdits(g.URI.revive(ee),se,le,Z,ae),void 0)}registerWorkspaceSymbolProvider(j,ee){const se=this._addNewAdapter(new q(ee,this._logService),j);return this._proxy.$registerNavigateTypeSupport(se),this._createDisposable(se)}$provideWorkspaceSymbols(j,ee,se){return this._withAdapter(j,q,le=>le.provideWorkspaceSymbols(ee,se),{symbols:[]})}$resolveWorkspaceSymbol(j,ee,se){return this._withAdapter(j,q,le=>le.resolveWorkspaceSymbol(ee,se),void 0)}$releaseWorkspaceSymbols(j,ee){this._withAdapter(j,q,se=>se.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(j,ee,se){const le=this._addNewAdapter(new G(this._documents,se,this._logService),j);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),G.supportsResolving(se)),this._createDisposable(le)}$provideRenameEdits(j,ee,se,le,Z){return this._withAdapter(j,G,ae=>ae.provideRenameEdits(g.URI.revive(ee),se,le,Z),void 0)}$resolveRenameLocation(j,ee,se,le){return this._withAdapter(j,G,Z=>Z.resolveRenameLocation(g.URI.revive(ee),se,le),void 0)}registerDocumentSemanticTokensProvider(j,ee,se,le){const Z=this._nextHandle(),ae=typeof se.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new $e(new z(this._documents,se),j)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,ae);let ve=this._createDisposable(Z);if(ae){const Me=se.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(ae));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(j,ee,se,le){return this._withAdapter(j,z,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),se,le),null,!0)}$releaseDocumentSemanticTokens(j,ee){this._withAdapter(j,z,se=>se.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(j,ee,se,le){const Z=this._addNewAdapter(new O(this._documents,se),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(j,ee,se,le){return this._withAdapter(j,O,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),se,le),null,!0)}registerCompletionItemProvider(j,ee,se,le){const Z=this._addNewAdapter(new N(this._documents,this._commands.converter,se,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,N.supportsResolving(se),`${j.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(j,ee,se,le,Z){return this._withAdapter(j,N,ae=>ae.provideCompletionItems(g.URI.revive(ee),se,le,Z),void 0)}$resolveCompletionItem(j,ee,se){return this._withAdapter(j,N,le=>le.resolveCompletionItem(ee,se),void 0)}$releaseCompletionItems(j,ee){this._withAdapter(j,N,se=>se.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(j,ee,se){const le=this._addNewAdapter(new x(this._documents,se,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(j,ee,se,le,Z){return this._withAdapter(j,x,ae=>ae.provideInlineCompletions(g.URI.revive(ee),se,le,Z),void 0)}$handleInlineCompletionDidShow(j,ee,se){this._withAdapter(j,x,async le=>{le.handleDidShowCompletionItem(ee,se)},void 0)}$freeInlineCompletionsList(j,ee){this._withAdapter(j,x,async se=>{se.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(j,ee,se,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new H(this._documents,se),j);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(ee),Z),this._createDisposable(ae)}$provideSignatureHelp(j,ee,se,le,Z){return this._withAdapter(j,H,ae=>ae.provideSignatureHelp(g.URI.revive(ee),se,le,Z),void 0)}$releaseSignatureHelp(j,ee){this._withAdapter(j,H,se=>se.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(j,ee,se){const le=typeof se.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new $(this._documents,se),j);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let ae=this._createDisposable(Z);if(le!==void 0){const ve=se.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=C.Disposable.from(ae,ve)}return ae}$provideInlayHints(j,ee,se,le){return this._withAdapter(j,$,Z=>Z.provideInlayHints(g.URI.revive(ee),se,le),void 0)}registerDocumentLinkProvider(j,ee,se){const le=this._addNewAdapter(new Y(this._documents,se),j);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof se.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(j,ee,se){return this._withAdapter(j,Y,le=>le.provideLinks(g.URI.revive(ee),se),void 0)}$resolveDocumentLink(j,ee,se){return this._withAdapter(j,Y,le=>le.resolveLink(ee,se),void 0)}$releaseDocumentLinks(j,ee){this._withAdapter(j,Y,se=>se.releaseLinks(ee),void 0)}registerColorProvider(j,ee,se){const le=this._addNewAdapter(new Q(this._documents,se),j);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(j,ee,se){return this._withAdapter(j,Q,le=>le.provideColors(g.URI.revive(ee),se),[])}$provideColorPresentations(j,ee,se,le){return this._withAdapter(j,Q,Z=>Z.provideColorPresentations(g.URI.revive(ee),se,le),void 0)}registerFoldingRangeProvider(j,ee,se){const le=this._nextHandle(),Z=typeof se.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new $e(new de(this._documents,se),j)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const ve=se.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ae=C.Disposable.from(ae,ve)}return ae}$provideFoldingRanges(j,ee,se,le){return this._withAdapter(j,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),se,le),void 0)}registerSelectionRangeProvider(j,ee,se){const le=this._addNewAdapter(new _e(this._documents,se,this._logService),j);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(j,ee,se,le){return this._withAdapter(j,_e,Z=>Z.provideSelectionRanges(g.URI.revive(ee),se,le),[])}registerCallHierarchyProvider(j,ee,se){const le=this._addNewAdapter(new Ce(this._documents,se),j);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(j,ee,se,le){return this._withAdapter(j,Ce,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),se,le)),void 0)}$provideCallHierarchyIncomingCalls(j,ee,se,le){return this._withAdapter(j,Ce,Z=>Z.provideCallsTo(ee,se,le),void 0)}$provideCallHierarchyOutgoingCalls(j,ee,se,le){return this._withAdapter(j,Ce,Z=>Z.provideCallsFrom(ee,se,le),void 0)}$releaseCallHierarchy(j,ee){this._withAdapter(j,Ce,se=>Promise.resolve(se.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(j,ee,se){const le=this._addNewAdapter(new Te(this._documents,se),j);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(j,ee,se,le){return this._withAdapter(j,Te,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),se,le)),void 0)}$provideTypeHierarchySupertypes(j,ee,se,le){return this._withAdapter(j,Te,Z=>Z.provideSupertypes(ee,se,le),void 0)}$provideTypeHierarchySubtypes(j,ee,se,le){return this._withAdapter(j,Te,Z=>Z.provideSubtypes(ee,se,le),void 0)}$releaseTypeHierarchy(j,ee){this._withAdapter(j,Te,se=>Promise.resolve(se.releaseSession(ee)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,S.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Be._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Be._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Be._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Be._serializeRegExp(j.beforeText),afterText:j.afterText?Be._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Be._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Be._serializeOnEnterRule)}setLanguageConfiguration(j,ee,se){let{wordPattern:le}=se;if(le&&(0,S.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),se.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),se.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const Z=this._nextHandle(),ae={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?Be._serializeRegExp(se.wordPattern):void 0,indentationRules:se.indentationRules?Be._serializeIndentationRule(se.indentationRules):void 0,onEnterRules:se.onEnterRules?Be._serializeOnEnterRules(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,ae),this._createDisposable(Z)}$setWordDefinitions(j){for(const ee of j)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(fe[243],me([0,1,5,15,7,49,18,6]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(n,I,c,f){this._documents=I,this._commands=c,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,I){await this._proxy.$changeLanguage(n,I);const c=this._documents.getDocumentData(n);if(!c)throw new Error(`document '${n.toString}' NOT found`);return c.document}async tokenAtPosition(n,I){const c=n.version,f=L.Position.from(I),d=await this._proxy.$tokensAtPosition(n.uri,f),p={type:k.StandardTokenType.Other,range:n.getWordRangeAtPosition(I)??new k.Range(I.line,I.character,I.line,I.character)};if(!d)return p;const D={range:L.Range.to(d.range),type:L.TokenType.to(d.type)};return!D.range.contains(I)||c!==n.version?p:D}createLanguageStatusItem(n,I,c){const f=this._handlePool++,d=this._proxy,p=this._ids,D=`${n.identifier.value}/${I}`;if(p.has(D))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);p.add(D);const R={selector:c,id:I,name:n.displayName??n.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,a=new S.DisposableStore;const o=()=>{E?.dispose(),E=(0,A.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(f,{id:D,name:R.name??n.displayName??n.name,source:n.displayName??n.name,selector:L.DocumentSelector.from(R.selector,this._uriTransformer),label:R.text,detail:R.detail??"",severity:R.severity===k.LanguageStatusSeverity.Error?C.default.Error:R.severity===k.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:R.command&&this._commands.toInternal(R.command,a),accessibilityInfo:R.accessibilityInformation})},0)},m={dispose(){a.dispose(),E?.dispose(),d.$removeLanguageStatus(f),p.delete(D)},get id(){return R.id},get name(){return R.name},set name(t){R.name=t,o()},get selector(){return R.selector},set selector(t){R.selector=t,o()},get text(){return R.text},set text(t){R.text=t,o()},get detail(){return R.detail},set detail(t){R.detail=t,o()},get severity(){return R.severity},set severity(t){R.severity=t,o()},get accessibilityInformation(){return R.accessibilityInformation},set accessibilityInformation(t){R.accessibilityInformation=t,o()},get command(){return R.command},set command(t){R.command=t,o()}};return o(),m}}e.ExtHostLanguages=y}),define(fe[244],me([0,1,5,13,35]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(S){return S&&S.title}let A=class{constructor(y,T){this._logService=T,this._proxy=y.getProxy(g.MainContext.MainThreadMessageService)}showMessage(y,T,n,I,c){const f={extension:y};let d;typeof I=="string"||C(I)?d=[I,...c]:(f.modal=I?.modal,f.useCustom=I?.useCustom,f.detail=I?.detail,d=c),f.useCustom&&(0,k.checkProposedApiEnabled)(y);const p=[];for(let D=0;D<d.length;D++){const R=d[D];if(typeof R=="string")p.push({title:R,handle:D,isCloseAffordance:!1});else if(typeof R=="object"){let{title:E,isCloseAffordance:a}=R;p.push({title:E,isCloseAffordance:!!a,handle:D})}else this._logService.warn("Invalid message item:",R)}return this._proxy.$showMessage(T,n,f,p).then(D=>{if(typeof D=="number")return d[D]})}};A=Ge([We(1,L.ILogService)],A),e.ExtHostMessageService=A}),define(fe[245],me([0,1,22,3,48,6,24,9,12,2,87,5,15,7,55,220,129]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class R{constructor(a,o,m,t,u){this._textDocumentsAndEditors=m,this._textDocuments=t,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,s=r.cell.handle,h=this._documents.get(i)?.getCell(s);if(h)return h.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const o=this._editors.get(a);if(!o)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(a){for(const[o,m]of this._editors)if(m.apiEditor===a)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,o){const m=this._documents.get(a);if(!m&&!o)throw new Error(`NO notebook document for '${a}'`);return m}_getProviderData(a){const o=this._notebookContentProviders.get(a);if(!o)throw new Error(`NO provider for '${a}'`);return o}registerNotebookContentProvider(a,o,m,t,u){if((0,S.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:a,provider:m});let r;return m.onDidChangeNotebookContentOptions&&(r=m.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(o,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},o,c.NotebookDocumentContentOptions.from(t),R._convertNotebookRegistrationData(a,u)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(a,o){if(!o)return;const m=o.filenamePattern.map(t=>c.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(o.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:o.displayName,filenamePattern:m,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,o,m){const t=R._notebookStatusBarItemProviderHandlePool++,u=typeof m.onDidChangeCellStatusBarItems=="function"?R._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,u,o);let r;return u!==void 0&&(r=m.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(u))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,u),r&&r.dispose()})}async createNotebookDocument(a){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&c.NotebookData.from(a.content)});return T.URI.revive(o)}async openNotebookDocument(a){const o=this._documents.get(a);if(o)return o.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(a),t=this._documents.get(T.URI.revive(m));return(0,y.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(a,o){T.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let m;typeof o=="object"?m={position:c.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(c.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:m={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,m),u=t&&this._editors.get(t)?.apiEditor;if(u)return u;throw t?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,o,m,t){const u=this._notebookStatusBarItemProviders.get(a),r=T.URI.revive(o),i=this._documents.get(r);if(!i||!u)return;const s=i.getCellFromIndex(m);if(!s)return;const l=await u.provideCellStatusBarItems(s.apiCell,t);if(!l)return;const h=new C.DisposableStore,w=this._statusBarCache.add([h]),v=(Array.isArray(l)?l:[l]).map(P=>c.NotebookStatusBarItem.from(P,this._commandsConverter,h));return{cacheId:w,items:v}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,o,m,t,u){if((0,S.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,m),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},o,c.NotebookDocumentContentOptions.from(t),R._convertNotebookRegistrationData(a,u)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,o,m){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const u=await t.deserializeNotebook(o.buffer,m);return new d.SerializableObjectWithBuffers(c.NotebookData.from(u))}async $notebookToData(a,o,m){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const u=await t.serializeNotebook(c.NotebookData.to(o.value),m);return g.VSBuffer.wrap(u)}async $openNotebook(a,o,m,t,u){const{provider:r}=this._getProviderData(a),i=await r.openNotebook(T.URI.revive(o),{backupId:m,untitledDocumentData:t?.buffer},u);return new d.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(a,o,m){const t=this.getNotebookDocument(T.URI.revive(o)),{provider:u}=this._getProviderData(a);return await u.saveNotebook(t.apiNotebook,m),!0}async $saveNotebookAs(a,o,m,t){const u=this.getNotebookDocument(T.URI.revive(o)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(T.URI.revive(m),u.apiNotebook,t),!0}async $backupNotebook(a,o,m){const t=this.getNotebookDocument(T.URI.revive(o)),u=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension),i=String((0,k.hash)([t.uri.toString(),this._backupIdPool++])),s=T.URI.joinPath(r,i),l=await u.provider.backupNotebook(t.apiNotebook,{destination:s},m);return t.updateBackup(l),l.id}_createExtHostEditor(a,o,m){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const t=new D.ExtHostNotebookEditor(o,this._notebookEditorsProxy,a,m.visibleRanges.map(c.NotebookRange.to),m.selections.map(c.NotebookRange.to),typeof m.viewColumn=="number"?c.ViewColumn.to(m.viewColumn):void 0);this._editors.set(o,t)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const m of a.value.removedDocuments){const t=T.URI.revive(m),u=this._documents.get(t);u&&(u.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const m=[];for(const t of a.value.addedDocuments){const u=T.URI.revive(t.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const r=this,i=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){r._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){r._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){r._onDidChangeCellMetadata.fire(s)},emitCellExecutionStateChange(s){r._onDidChangeCellExecutionState.fire(s)}},u,t);m.push(...t.cells.map(s=>p.ExtHostCell.asModelAddData(i.apiNotebook,s))),this._documents.get(u)?.dispose(),this._documents.set(u,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const m of a.value.addedEditors){if(this._editors.has(m.id))return;const t=T.URI.revive(m.documentUri),u=this._documents.get(t);u&&this._createExtHostEditor(u,m.id,m)}const o=[];if(a.value.removedEditors)for(const m of a.value.removedEditors){const t=this._editors.get(m);t&&(this._editors.delete(m),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),o.push(t))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const m=new Set;this._visibleNotebookEditors.forEach(t=>m.add(t.id));for(const t of this._editors.values()){const u=m.has(t.id);t._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=R,R._notebookStatusBarItemProviderHandlePool=0}),define(fe[246],me([0,1,3,76,13,5,14,15]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(I,c){const f=y._Keys.nextId();I.$registerNotebookEditorDecorationType(f,S.NotebookDecorationRenderOptions.from(c)),this.value={key:f,dispose(){I.$removeNotebookEditorDecorationType(f)}}}}y._Keys=new L.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(I,c,f){this._logService=I,this._extHostRpc=c,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new y(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,c);const f=this._notebooksAndEditors.getEditorById(I);c.visibleRanges&&f._acceptVisibleRanges(c.visibleRanges.ranges.map(S.NotebookRange.to)),c.selections&&f._acceptSelections(c.selections.selections.map(S.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const c in I)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(S.ViewColumn.to(I[c]))}};T=Ge([We(0,k.ILogService),We(1,A.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(fe[247],me([0,1,16,18,21,3,6,24,2,26,13,5,40,15,7,88,213,35,55]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,i,s,l,h){this._initData=i,this._extHostNotebook=s,this._commands=l,this._logService=h,this._activeExecutions=new S.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels);const w=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const v=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:v}}else if(_&&"notebookEditor"in _){const v=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(v===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:v}}return _})],c.ApiCommandResult.Void);this._commands.registerApiCommand(w)}createNotebookController(r,i,s,l,h,w){for(let H of this._kernelData.values())if(H.controller.id===i&&T.ExtensionIdentifier.equals(r.identifier,H.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const _=this._handlePool++,v=this;this._logService.trace(`NotebookController[${_}], CREATED by ${r.identifier.value}, ${i}`);const P=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let b=!1;const F=new A.DisposableStore,M=new C.Emitter,q=new C.Emitter,G={id:`${r.identifier.value}/${i}`,notebookType:s,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:w?w.map(f.NotebookRendererScript.from):[]};let U=h??P,z;this._proxy.$addKernel(_,G).catch(H=>{console.log(H),b=!0});let O=0;const N=()=>{if(b)return;const H=++O;Promise.resolve().then(()=>{H===O&&this._proxy.$updateKernel(_,G)})},x=new S.ResourceMap,B={get id(){return i},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return G.label},set label(H){G.label=H??r.displayName??r.name,N()},get detail(){return G.detail??""},set detail(H){G.detail=H,N()},get description(){return G.description??""},set description(H){G.description=H,N()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(H){G.supportedLanguages=H,N()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(H){G.supportsExecutionOrder=H,N()},get rendererScripts(){return G.preloads?G.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(H){U=H??P},get interruptHandler(){return z},set interruptHandler(H){z=H,G.supportsInterrupt=Boolean(H),N()},createNotebookCellExecution(H){if(b)throw new Error("notebook controller is DISPOSED");if(!x.has(H.notebook.uri))throw v._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map($=>$.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return v._createNotebookCellExecution(H)},dispose:()=>{b||(this._logService.trace(`NotebookController[${_}], DISPOSED`),b=!0,this._kernelData.delete(_),F.dispose(),M.dispose(),q.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(H,$){v._proxy.$updateNotebookPriority(_,H.uri,$)},onDidReceiveMessage:q.event,postMessage(H,$){return(0,R.checkProposedApiEnabled)(r),v._proxy.$postMessage(_,$&&v._extHostNotebook.getIdByEditor($),H)},asWebviewUri(H){return(0,R.checkProposedApiEnabled)(r),(0,p.asWebviewUri)(H,v._initData.remote)}};return this._kernelData.set(_,{extensionId:r.identifier,controller:B,onDidReceiveMessage:q,onDidChangeSelection:M,associatedNotebooks:x}),B}$acceptNotebookAssociation(r,i,s){const l=this._kernelData.get(r);if(l){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(i));s?l.associatedNotebooks.set(h.uri,!0):l.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,h.uri.toString(),s),l.onDidChangeSelection.fire({selected:s,notebook:h.apiNotebook})}}async $executeCells(r,i,s){const l=this._kernelData.get(r);if(!l)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)),w=[];for(let _ of s){const v=h.getCell(_);v&&w.push(v.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,h.uri.toString(),w.length),await l.controller.executeHandler.call(l.controller,w,h.apiNotebook,l.controller)}catch(_){this._logService.error(`NotebookController[${r}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(r,i,s){const l=this._kernelData.get(r);if(!l)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(i));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,h.apiNotebook);else for(let w of s){const _=h.getCell(w);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,s){const l=this._kernelData.get(r);if(!l)return;const h=this._extHostNotebook.getEditorById(i);l.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:s}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const l=new m(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,l);const h=l.onDidChangeState(()=>{l.state===o.Resolved&&(l.dispose(),h.dispose(),this._activeExecutions.delete(s.uri))});return l.asApiObject()}};a=Ge([We(4,n.ILogService)],a),e.ExtHostNotebookKernels=a;var o;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(o||(o={}));class m extends A.Disposable{constructor(r,i,s){super();this._document=r,this._cell=i,this._proxy=s,this._handle=m.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new t(10,l=>this.update(l)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new E.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?f.NotebookCellOutput.from(i):f.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,s){const l=this.cellIndexToHandle(i),h=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:D.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:s,outputs:h})}async updateOutputItems(r,i,s){return r=d.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:D.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(s){r._executionOrder=s,r.update([{editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(s){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:s})},end(s,l){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:D.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:l,lastRunSuccess:s}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(s){return r.verifyStateForOutput(),r.updateOutputs([],s,!1)},appendOutput(s,l){return r.verifyStateForOutput(),r.updateOutputs(s,l,!0)},replaceOutput(s,l){return r.verifyStateForOutput(),r.updateOutputs(s,l,!1)},appendOutputItems(s,l){return r.verifyStateForOutput(),r.updateOutputItems(s,l,!0)},replaceOutputItems(s,l){return r.verifyStateForOutput(),r.updateOutputItems(s,l,!1)}})}}m.HANDLE=0;class t{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(fe[248],me([0,1,3,5,129]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,T){const n=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:T})}createRendererMessaging(S,y){if(!S.contributes?.notebookRenderer?.some(c=>c.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const T=!!S.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(c,f,d)=>{const p=T?c:D=>{const R={};n.set(R,D.editor),c({editor:R,message:D.message})};return this.getOrCreateEmitterFor(y).event(p,f,d)},postMessage:(c,f)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(c)&&([c,f]=[f,c]);const d=T?f:n.get(f),p=d&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(p?.id,y,c)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new g.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=C}),define(fe[68],me([0,1,5,3,6,22,4,14]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends k.Disposable{constructor(d,p,D,R,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=E,this._id=E.$register(this.name,p,D,R),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?C.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(p=>this._proxy.$clear(p,d))}show(d,p){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof d=="boolean"?d:p)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class T extends y{constructor(d,p,D){super(d,!1,void 0,p,D)}append(d){super.append(d),this._id.then(p=>this._proxy.$append(p,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class n extends y{constructor(d,p,D){super(d,!0,p,void 0,D)}append(d){throw new Error("Not supported")}}class I{constructor(d,p){this.name=d,this._channel=p}append(d){this._channel.then(p=>p.append(d))}appendLine(d){this._channel.then(p=>p.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,p){this._channel.then(D=>D.show(d,p))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=I;let c=class{constructor(d){this._proxy=d.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d,p){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new T(d,p.identifier.value,this._proxy)}createOutputChannelFromLogFile(d,p){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!p)throw new Error("illegal argument `file`. must not be falsy");return new n(d,p,this._proxy)}};c=Ge([We(0,S.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(fe[249],me([0,1,18,21,3,6,5,2,7,17,16,49,64]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(d,p,D){const R=d.getProxy(A.MainContext.MainThreadQuickOpen);class E{constructor(l,h){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=h}showQuickPick(l,h,w,_=L.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(l),P=++this._instances,b=R.$show(P,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},_),F={},M=b.then(()=>F);return Promise.race([M,v]).then(q=>{if(q!==F)return v.then(G=>{const U=[];for(let z=0;z<G.length;z++){const O=G[z];let N,x,B,H,$;typeof O=="string"?N=O:(N=O.label,x=O.description,B=O.detail,H=O.picked,$=O.alwaysShow),U.push({label:N,description:x,handle:z,detail:B,picked:H,alwaysShow:$})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{w.onDidSelectItem(G[z])}),R.$setItems(P,U),b.then(z=>{if(typeof z=="number")return G[z];if(Array.isArray(z))return z.map(O=>G[O])})})}).then(void 0,q=>{if(!(0,T.isPromiseCanceledError)(q))return R.$setError(P,q),Promise.reject(q)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,h=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,R.$input(l,typeof this._validateInput=="function",h).then(void 0,w=>{if(!(0,T.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(l){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,h=L.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!w)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(v=>v.uri.toString()===w.uri.toString())}createQuickPick(l,h){const w=new r(l,h,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(l){const h=new i(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(l,h){const w=this._sessions.get(l);w&&w._fireDidChangeValue(h)}$onDidAccept(l){const h=this._sessions.get(l);h&&h._fireDidAccept()}$onDidChangeActive(l,h){const w=this._sessions.get(l);w instanceof r&&w._fireDidChangeActive(h)}$onDidChangeSelection(l,h){const w=this._sessions.get(l);w instanceof r&&w._fireDidChangeSelection(h)}$onDidTriggerButton(l,h){const w=this._sessions.get(l);w&&w._fireDidTriggerButton(h)}$onDidTriggerItemButton(l,h,w){const _=this._sessions.get(l);_ instanceof r&&_._fireDidTriggerItemButton(h,w)}$onDidHide(l){const h=this._sessions.get(l);h&&h._fireDidHide()}}class a{constructor(l,h){this._extensionId=l,this._onDidDispose=h,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((h,w)=>{const _=h===y.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(_,h)}),this.update({buttons:l.map((h,w)=>({...u(h),tooltip:h.tooltip,handle:h===y.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const h=this._handlesToButtons.get(l);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),R.$dispose(this._id))}update(l){if(!this._disposed){for(const h of Object.keys(l)){const w=l[h];this._pendingUpdate[h]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){R.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function o(s){if(s instanceof y.ThemeIcon)return{id:s.id};const l=t(s),h=m(s);return{dark:typeof l=="string"?S.URI.file(l):l,light:typeof h=="string"?S.URI.file(h):h}}function m(s){return typeof s=="object"&&"light"in s?s.light:s}function t(s){return typeof s=="object"&&"dark"in s?s.dark:s}function u(s){const l=o(s.iconPath);let h,w;return"id"in l?w=c.ThemeIcon.asClassName(l):h=l,{iconPath:h,iconClass:w}}class r extends a{constructor(l,h,w){super(l,w);this.enableProposedApi=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((h,w)=>{this._handlesToItems.set(w,h),this._itemsToHandles.set(h,w)}),this.update({items:l.map((h,w)=>({label:h.label,description:h.description,handle:w,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons&&this.enableProposedApi?h.buttons.map((_,v)=>({...u(_),tooltip:_.tooltip,handle:v})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(l){const h=(0,n.coalesce)(l.map(w=>this._handlesToItems.get(w)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(l){const h=(0,n.coalesce)(l.map(w=>this._handlesToItems.get(w)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(l,h){const w=this._handlesToItems.get(l);if(!w||!w.buttons||!w.buttons.length)return;const _=w.buttons[h];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:w})}}class i extends a{constructor(l,h){super(l,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?I.default.Error:I.default.Ignore})}}return new E(p,D)}e.createExtHostQuickOpen=f}),define(fe[250],me([0,1,2,3,59,6,18,5,16,100,13,26,35,64,15]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(l){if(l)return typeof l.iconPath=="string"?g.URI.file(l.iconPath):g.URI.isUri(l.iconPath)||f.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function D(l,h){if(!l.iconPath&&!h.iconPath)return 0;if(l.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof l.iconPath=="string"?l.iconPath:g.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,_=typeof h.iconPath=="string"?h.iconPath:g.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,T.comparePaths)(w,_)}function R(l,h){let w=0;if(l.strikeThrough!==h.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==h.faded)return l.faded?1:-1;if(l.tooltip!==h.tooltip)return(l.tooltip||"").localeCompare(h.tooltip||"");if(w=D(l,h),w!==0)return w;if(l.light&&h.light)w=D(l.light,h.light);else{if(l.light)return 1;if(h.light)return-1}if(w!==0)return w;if(l.dark&&h.dark)w=D(l.dark,h.dark);else{if(l.dark)return 1;if(h.dark)return-1}return w}function E(l,h){if(l.command!==h.command)return l.command<h.command?-1:1;if(l.title!==h.title)return l.title<h.title?-1:1;if(l.tooltip!==h.tooltip){if(l.tooltip!==void 0&&h.tooltip!==void 0)return l.tooltip<h.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(l.arguments===h.arguments)return 0;if(l.arguments)if(h.arguments){if(l.arguments.length!==h.arguments.length)return l.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<l.arguments.length;w++){const _=l.arguments[w],v=h.arguments[w];if(_!==v)return _<v?-1:1}return 0}function a(l,h){let w=(0,T.comparePaths)(l.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(l.command&&h.command)w=E(l.command,h.command);else{if(l.command)return 1;if(h.command)return-1}if(w!==0)return w;if(l.decorations&&h.decorations)w=R(l.decorations,h.decorations);else{if(l.decorations)return 1;if(h.decorations)return-1}return w}function o(l,h){for(let w=0;w<l.length;w++)if(l[w]!==h[w])return!1;return!0}function m(l,h){return l.command===h.command&&l.title===h.title&&l.tooltip===h.tooltip&&(l.arguments&&h.arguments?o(l.arguments,h.arguments):l.arguments===h.arguments)}function t(l,h){return(0,y.equals)(l,h,m)}class u{constructor(h,w,_){this._extension=h,this._proxy=w,this._sourceControlHandle=_,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(h){this._proxy.$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(h){if((0,c.checkProposedApiEnabled)(this._extension),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,h))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(h,w){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=u;class r{constructor(h,w,_,v,P){this._proxy=h,this._commands=w,this._sourceControlHandle=_,this._id=v,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const _=this._resourceStatesCommandsMap.get(h);return _?(0,A.asPromise)(()=>this._commands.executeCommand(_.command,..._.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(a),_=(0,y.sortedDiff)(this._resourceSnapshot,h,a).map(b=>{const F=b.toInsert.map(M=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,M);const G=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const de=new C.DisposableStore;U=this._commands.converter.toInternal(M.command,de),this._resourceStatesDisposablesMap.set(q,de)}else this._resourceStatesCommandsMap.set(q,M.command);const z=p(M.decorations),O=M.decorations&&p(M.decorations.light)||z,N=M.decorations&&p(M.decorations.dark)||z,x=[O,N],B=M.decorations&&M.decorations.tooltip||"",H=M.decorations&&!!M.decorations.strikeThrough,$=M.decorations&&!!M.decorations.faded,Y=M.contextValue||"";return{rawResource:[q,G,x,B,H,$,Y,U],handle:q}});return{start:b.start,deleteCount:b.deleteCount,toInsert:F}}),v=_.map(({start:b,deleteCount:F,toInsert:M})=>[b,F,M.map(q=>q.rawResource)]),P=_.reverse();for(const{start:b,deleteCount:F,toInsert:M}of P){const q=M.map(U=>U.handle),G=this._handlesSnapshot.splice(b,F,...q);for(const U of G)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=h,v}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(h,w,_,v,P,b){this._proxy=w,this._commands=_,this._id=v,this._label=P,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(h,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,v,P,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,this._proxy.$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,this._proxy.$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&t(this._statusBarCommands,h))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(_=>this._commands.converter.toInternal(_,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(h,w){const _=new r(this._proxy,this._commands,this.handle,h,w),v=L.Event.once(_.onDidDispose)(()=>this.createdResourceGroups.delete(_));return this.createdResourceGroups.set(_,v),this.eventuallyAddResourceGroups(),_}eventuallyAddResourceGroups(){const h=[],w=[];for(const[_,v]of this.createdResourceGroups){v.dispose();const P=_.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(_),this.eventuallyUpdateResourceStates()});L.Event.once(_.onDidDispose)(()=>{this.updatedResourceGroups.delete(_),P.dispose(),this._groups.delete(_.handle),this._proxy.$unregisterGroup(this.handle,_.handle)}),h.push([_.handle,_.id,_.label,_.features]);const b=_._takeResourceStateSnapshot();b.length>0&&w.push([_.handle,b]),this._groups.set(_.handle,_)}this._proxy.$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const _=w._takeResourceStateSnapshot();_.length!==0&&h.push([w.handle,_])}),h.length>0&&this._proxy.$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ge([(0,k.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ge([(0,k.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class xn{constructor(h,w,_){this._commands=w,this.logService=_,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=h.getProxy(S.MainContext.MainThreadSCM),this._telemetry=h.getProxy(S.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===3){const P=this._sourceControls.get(v.sourceControlHandle);if(!P)return v;const b=P.getResourceGroup(v.groupHandle);return b?b.getResourceState(v.handle):v}else if(v&&v.$mid===4){const P=this._sourceControls.get(v.sourceControlHandle);return P?P.getResourceGroup(v.groupHandle):v}else if(v&&v.$mid===5){const P=this._sourceControls.get(v.handle);return P||v}return v}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,w,_,v){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,_,v),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const P=xn._handlePool++,b=new i(h,this._proxy,this._commands,w,_,v);this._sourceControls.set(P,b);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier))||[];return F.push(b),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(h.identifier),F),b}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier)),_=w&&w[w.length-1];return _&&_.inputBox}$provideOriginalResource(h,w,_){const v=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,v.toString());const P=this._sourceControls.get(h);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(v,_)).then(b=>b||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const _=this._sourceControls.get(h);return _&&_.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,_,v){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,_);const P=this._sourceControls.get(h);if(!P)return Promise.resolve(void 0);const b=P.getResourceGroup(w);return b?b.$executeResourceCommand(_,v):Promise.resolve(void 0)}$validateInput(h,w,_){this.logService.trace("ExtHostSCM#$validateInput",h);const v=this._sourceControls.get(h);return!v||!v.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>v.inputBox.validateInput(w,_)).then(P=>{if(!P)return Promise.resolve(void 0);const b=d.MarkdownString.fromStrict(P.message);return b?Promise.resolve([b,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};s._handlePool=0,s=Ge([We(2,n.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[251],me([0,1,7,5,167,6,15,12]),function(J,e,g,L,k,C,A,S){"use strict";var y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class n{constructor(d,p,D,R,E=g.StatusBarAlignment.Left,a){y.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,it(this,y,d,"f"),it(this,T,p,"f"),this._entryId=n.ID_GEN++,this._extension=D,this._id=R,this._alignment=E,this._priority=this.validatePriority(a)}validatePriority(d){if(!!(0,S.isNumber)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!n.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Oe(this,T,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Oe(this,T,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let p;this._name?p=this._name:p=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=n.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const R=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,y,"f").$setEntry(this._entryId,d,p,this._text,R,this._command?.internal,D,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=n,y=new WeakMap,T=new WeakMap,n.ID_GEN=0,n.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const p={message:d};return this._messages.unshift(p),this._update(),new g.Disposable(()=>{const D=this._messages.indexOf(p);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(d,p){this._proxy=d.getProxy(L.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new I(this)}createStatusBarEntry(d,p,D,R){return new n(this._proxy,this._commands,d,p,D,R)}setStatusBarMessage(d,p){const D=this._statusMessage.setMessage(d);let R;return typeof p=="number"?R=setTimeout(()=>D.dispose(),p):typeof p!="undefined"&&p.then(()=>D.dispose(),()=>D.dispose()),new g.Disposable(()=>{D.dispose(),clearTimeout(R)})}}e.ExtHostStatusBar=c}),define(fe[92],me([0,1,5,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(S){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,y){this._proxy.$registerExtensionStorageKeysToSync(S,y)}getValue(S,y,T){return this._proxy.$getValue(S,y).then(n=>n||T)}setValue(S,y,T){return this._proxy.$setValue(S,y,T)}$acceptValue(S,y,T){this._onDidChangeStorage.fire({shared:S,key:y,value:T})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(fe[69],me([0,1,4,27,13,91,2]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let S=class{constructor(T,n,I){this._logService=n,this._extHostFileSystem=I,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(T){return A.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,n=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(T){if(this._value)return A.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return A.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};S=Ge([We(0,L.IExtHostInitDataService),We(1,k.ILogService),We(2,C.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(fe[33],me([0,1,3,5,4,2,14,6,7,168,17,215,21,32,196,64,12]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class R{constructor(s,l,h,w){this._proxy=s,this._id=l,this._creationOptions=h,this._name=w,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(v,P=!0){_._checkDisposed(),_._proxy.$sendText(_._id,v,P)},show(v){_._checkDisposed(),_._proxy.$show(_._id,v)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(s,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,D.withNullAsUndefined)(s.shellPath),shellArgs:(0,D.withNullAsUndefined)(s.shellArgs),cwd:(0,D.withNullAsUndefined)(s.cwd),env:(0,D.withNullAsUndefined)(s.env),icon:(0,D.withNullAsUndefined)(u(s.iconPath)),color:p.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,D.withNullAsUndefined)(s.message),strictEnv:(0,D.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,D.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,D.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,D.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(s.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(s,l,h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:p.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(s,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,l){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in s?{viewColumn:s.viewColumn,preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,l){return s===this._cols&&l===this._rows||s===0||l===0?!1:(this._cols=s,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=R;class E{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(s){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,l){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:l})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose&&this._pty.onDidClose((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(l=>this._onProcessOverrideDimensions.fire(l&&{cols:l.columns,rows:l.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(l=>this._onProcessTitleChanged.fire(l)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=E;let a=1,o=class extends S.Disposable{constructor(s,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[h,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,l){const h=new R(this._proxy,(0,f.generateUuid)(),s,s.name),w=new E(s.pty);return h.createExtensionTerminal(s.location,this._serializeParentTerminal(s,l).resolvedExtHostIdentifier,u(s.iconPath),r(s.color)).then(_=>{const v=this._setupExtHostProcessListeners(_,w);this._terminalProcessDisposables[_]=v}),this._terminals.push(h),h.value}_serializeParentTerminal(s,l){if(l=l||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const h=s.location.parentTerminal;if(h){const w=this._terminals.find(_=>_.value===h);w&&(l.resolvedExtHostIdentifier=w._id)}}else s.location&&typeof s.location!="object"?l.location=s.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(s,l){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const w=new E(l),_=this._setupExtHostProcessListeners(s,w);this._terminalProcessDisposables[s]=_}async $acceptActiveTerminalChanged(s){const l=this._activeTerminal;if(s===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(s);h&&(this._activeTerminal=h,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,l){const h=this._getTerminalById(s);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:l})}async $acceptTerminalDimensions(s,l,h){const w=this._getTerminalById(s);w&&w.setDimensions(l,h)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(s,l,h){this._terminalProcesses.get(s)?.resize(l,h)}async $acceptTerminalTitleChange(s,l){const h=this._getTerminalById(s);h&&(h.name=l)}async $acceptTerminalClosed(s,l){const h=this._getTerminalObjectIndexById(this._terminals,s);if(h!==null){const w=this._terminals.splice(h,1)[0];w.setExitCode(l),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(s,l,h,w){if(l){const P=this._getTerminalObjectIndexById(this._terminals,l);if(P!==null){this._terminals[P]._id=s,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const _={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:C.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},v=new R(this._proxy,s,_,h);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(s,l){const h=this._getTerminalById(s);h&&h._setProcessId(l)}async $startExtensionTerminal(s,l){const h=this._getTerminalById(s);if(!h)return{message:(0,T.localize)(0,null,s)};h.isOpen||await new Promise(_=>{const v=this.onDidOpenTerminal(async P=>{P===h.value&&(v.dispose(),_())})});const w=this._terminalProcesses.get(s);w?w.startSendingEvents(l):this._extensionTerminalAwaitingStart[s]={initialDimensions:l}}_setupExtHostProcessListeners(s,l){const h=new S.DisposableStore;h.add(l.onProcessReady(_=>this._proxy.$sendProcessReady(s,_.pid,_.cwd))),h.add(l.onProcessTitleChanged(_=>this._proxy.$sendProcessTitle(s,_))),this._bufferer.startBuffering(s,l.onProcessData),h.add(l.onProcessExit(_=>this._onProcessExit(s,_))),l.onProcessOverrideDimensions&&h.add(l.onProcessOverrideDimensions(_=>this._proxy.$sendOverrideDimensions(s,_))),this._terminalProcesses.set(s,l);const w=this._extensionTerminalAwaitingStart[s];return w&&l instanceof E&&(l.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),h}$acceptProcessAckDataEvent(s,l){this._terminalProcesses.get(s)?.acknowledgeDataEvent(l)}$acceptProcessInput(s,l){this._terminalProcesses.get(s)?.input(l)}$acceptTerminalInteraction(s){const l=this._getTerminalById(s);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(s,l,h){try{this._terminalProcesses.get(s)?.resize(l,h)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(s,l){this._terminalProcesses.get(s)?.shutdown(l)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(s,l))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(l=>this._proxy.$sendProcessCwd(s,l))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,l,h){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,h),this._proxy.$registerProfileProvider(l,s.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(s,l){const h=new c.CancellationTokenSource().token,w=await this._profileProviders.get(s)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,l);return}this.createTerminalFromOptions(w.options,l)}}async $provideLinks(s,l){const h=this._getTerminalById(s);if(!h)return[];this._terminalLinkCache.delete(s);const w=this._terminalLinkCancellationSource.get(s);w&&w.dispose(!0);const _=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,_);const v=[],P={terminal:h.value,line:l},b=[];for(const q of this._linkProviders)b.push(new Promise(async G=>{_.token.onCancellationRequested(()=>G({provider:q,links:[]}));const U=await q.provideTerminalLinks(P,_.token)||[];_.token.isCancellationRequested||G({provider:q,links:U})}));const F=await Promise.all(b);if(_.token.isCancellationRequested)return[];const M=new Map;for(const q of F)q&&q.links.length>0&&v.push(...q.links.map(G=>{const U={id:a++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return M.set(U.id,{provider:q.provider,link:G}),U}));return this._terminalLinkCache.set(s,M),v}$activateLink(s,l){const h=this._terminalLinkCache.get(s)?.get(l);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(s,l){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const h=this._terminalProcessDisposables[s];h&&(h.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,l)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,l){const h=this._getTerminalObjectIndexById(s,l);return h!==null?s[h]:null}_getTerminalObjectIndexById(s,l){let h=null;return s.some((w,_)=>w._id===l?(h=_,!0):!1),h}getEnvironmentVariableCollection(s){let l=this._environmentVariableCollections.get(s.identifier.value);return l||(l=new m,this._setEnvironmentVariableCollection(s.identifier.value,l)),l}_syncEnvironmentVariableCollection(s,l){const h=(0,I.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(s,l.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(s){s.forEach(l=>{const h=l[0],w=new m(l[1]);this._setEnvironmentVariableCollection(h,w)})}$acceptDefaultProfile(s,l){this._defaultProfile=s,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(s,l){this._environmentVariableCollections.set(s,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,l)})}};o=Ge([We(1,A.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class m{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,l){this._setIfDiffers(s,{value:l,type:y.EnvironmentVariableMutatorType.Replace})}append(s,l){this._setIfDiffers(s,{value:l,type:y.EnvironmentVariableMutatorType.Append})}prepend(s,l){this._setIfDiffers(s,{value:l,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,l){const h=this.map.get(s);(!h||h.value!==l.value||h.type!==l.type)&&(this.map.set(s,l),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,l){this.map.forEach((h,w)=>s.call(l,w,h,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let t=class extends o{constructor(s){super(!1,s)}createTerminal(s,l,h){throw new n.NotSupportedError}createTerminalFromOptions(s,l){throw new n.NotSupportedError}};t=Ge([We(0,A.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function u(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function r(i){return p.ThemeColor.isThemeColor(i)?i:void 0}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[252],me([0,1,16,22,21,3,75,48,6,25,12,32,5,14,65,15,7,223,127,89]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(b,F){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=b.getProxy(c.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new u(this.proxy),F.registerArgumentProcessor({processArgument:M=>M?.$mid===13?p.TestItem.toItemFromContext(M):M})}createTestController(b,F){if(this.controllers.has(b))throw new Error(`Attempt to insert a duplicate controller with ID "${b}"`);const M=new y.DisposableStore,q=M.add(new R.SingleUseTestCollection(b));q.root.label=F;const G=new Map,U=this.proxy,z={items:q.root.children,get label(){return F},set label(N){F=N,q.root.label=N,U.$updateControllerLabel(b,F)},get id(){return b},createRunProfile:(N,x,B,H,$)=>{let Y=(0,S.hash)(N);for(;G.has(Y);)Y++;const Q=new _(this.proxy,b,Y,N,x,B,H,$);return G.set(Y,Q),Q},createTestItem(N,x,B){return new d.TestItemImpl(b,N,x,B)},createTestRun:(N,x,B=!0)=>this.runTracker.createTestRun(b,q,N,x,B),set resolveHandler(N){q.resolveHandler=N},get resolveHandler(){return q.resolveHandler},dispose:()=>{M.dispose()}};z.createRunConfiguration=z.createRunProfile,U.$registerTestController(b,F),M.add((0,y.toDisposable)(()=>U.$unregisterTestController(b)));const O={controller:z,collection:q,profiles:G};return this.controllers.set(b,O),M.add((0,y.toDisposable)(()=>this.controllers.delete(b))),M.add(q.onDidGenerateDiff(N=>U.$publishDiff(b,N))),z}createTestObserver(){return this.observer.checkout()}async runTests(b,F=k.CancellationToken.None){const M=r(b);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.controllers.get(M.controllerId);if(!q)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:b.include?.map(G=>G.id)??[q.collection.root.id],profileGroup:v[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:b.exclude?.map(G=>G.id)},F)}$provideFileCoverage(b,F,M){return(0,g.mapFind)(this.runTracker.trackers,G=>G.id===b?G.getCoverage(F):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(b,F,M,q){return(0,g.mapFind)(this.runTracker.trackers,U=>U.id===b?U.getCoverage(F):void 0)?.resolveFileCoverage(M,q)??Promise.resolve([])}$configureRunProfile(b,F){this.controllers.get(b)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(b){this.results=Object.freeze(b.map(F=>(0,T.deepFreeze)(p.TestResults.to(F))).concat(this.results).sort((F,M)=>M.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(b,F){const M=this.controllers.get(a.TestId.fromString(b).controllerId)?.collection;M&&(await M.expand(b,F<0?Infinity:F),M.flushDiff())}$acceptDiff(b){this.observer.applyDiff(b)}async $runControllerTests(b,F){const M=this.controllers.get(b.controllerId);if(!M)return;const{collection:q,profiles:G}=M,U=G.get(b.profileId);if(!U)return;const z=b.testIds.map(B=>q.tree.get(B)).filter(n.isDefined),O=b.excludeExtIds.map(B=>M.collection.tree.get(B)).filter(n.isDefined).filter(B=>z.some(H=>H.fullId.compare(B.fullId)===2));if(!z.length)return;const N=new D.TestRunRequest(z.some(B=>B.actual instanceof d.TestItemRootImpl)?void 0:z.map(B=>B.actual),O.map(B=>B.actual),U),x=this.runTracker.prepareForMainThreadTestRun(N,i.fromInternal(b,M.collection),F);try{await U.runHandler(N,F)}finally{x.isRunning&&!F.isCancellationRequested&&await C.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(b){b===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(b)}};m=Ge([We(0,f.IExtHostRpcService)],m),e.ExtHostTesting=m;class t extends y.Disposable{constructor(b,F,M){super();this.dto=b,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(M)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:q}of this.tasks.values())q.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(b){return this.tasks.get(b)?.coverage}createRun(b){const F=this.dto.id,M=this.dto.controllerId,q=(0,I.generateUuid)(),G=new s(this.proxy,F,q),U=x=>(B,...H)=>{if(O){console.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(B)||(this.ensureTestIsKnown(B),x(B,...H))},z=(x,B)=>{const H=B instanceof Array?B.map(p.TestMessage.from):[p.TestMessage.from(B)];if(x.uri&&x.range){const $={range:p.Range.from(x.range),uri:x.uri};for(const Y of H)Y.location=Y.location||$}this.proxy.$appendTestMessagesInRun(F,q,a.TestId.fromExtHostTestItem(x,M).toString(),H)};let O=!1;const N={isPersisted:this.dto.isPersisted,token:this.cts.token,name:b,get coverageProvider(){return G.coverageProvider},set coverageProvider(x){G.coverageProvider=x},enqueued:U(x=>{this.proxy.$updateTestStateInRun(F,q,a.TestId.fromExtHostTestItem(x,M).toString(),1)}),skipped:U(x=>{this.proxy.$updateTestStateInRun(F,q,a.TestId.fromExtHostTestItem(x,M).toString(),5)}),started:U(x=>{this.proxy.$updateTestStateInRun(F,q,a.TestId.fromExtHostTestItem(x,M).toString(),2)}),errored:U((x,B,H)=>{z(x,B),this.proxy.$updateTestStateInRun(F,q,a.TestId.fromExtHostTestItem(x,M).toString(),6,H)}),failed:U((x,B,H)=>{z(x,B),this.proxy.$updateTestStateInRun(F,q,a.TestId.fromExtHostTestItem(x,M).toString(),4,H)}),passed:U((x,B)=>{this.proxy.$updateTestStateInRun(F,q,a.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,B)}),appendOutput:(x,B,H)=>{O||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(F,q,L.VSBuffer.fromString(x),B&&p.location.from(B),H&&a.TestId.fromExtHostTestItem(H,M).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(F,q),this.tasks.delete(q),this.isRunning||this.dispose())}};return this.tasks.set(q,{run:N,coverage:G}),this.proxy.$startedTestRunTask(F,{id:q,name:b,running:!0}),N}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(b){if(!(b instanceof d.TestItemImpl))throw new d.InvalidTestItemError(b.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(b,this.dto.controllerId).toString()))return;const F=[],M=this.dto.colllection.root;for(;;){const q=p.TestItem.from(b);if(F.unshift(q),this.sharedTestIds.has(q.extId)||(this.sharedTestIds.add(q.extId),b===M))break;b=b.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class u{constructor(b){this.proxy=b,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(b,F,M){return this.getTracker(b,F,M)}cancelRunById(b){for(const F of this.tracked.values())if(F.id===b){F.dispose();return}}cancelAllRuns(){for(const b of this.tracked.values())b.dispose()}createTestRun(b,F,M,q,G){const U=this.tracked.get(M);if(U)return U.createRun(q);const z=i.fromPublic(b,F,M,G),O=r(M);this.proxy.$startedExtensionTestRun({controllerId:b,profile:O&&{group:v[O.kind],id:O.profileId},exclude:M.exclude?.map(x=>x.id)??[],id:z.id,include:M.include?.map(x=>x.id)??[F.root.id],persist:G});const N=this.getTracker(M,z);return N.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),N.createRun(q)}getTracker(b,F,M){const q=new t(F,this.proxy,M);return this.tracked.set(b,q),q.onEnd(()=>this.tracked.delete(b)),q}}e.TestRunCoordinator=u;const r=P=>{if(!!P.profile){if(!(P.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(b,F,M,q,G,U){this.controllerId=b,this.id=F,this.isPersisted=G,this.colllection=U,this.includePrefix=M.map(z=>z+"\0"),this.excludePrefix=q.map(z=>z+"\0")}static fromPublic(b,F,M,q){return new i(b,(0,I.generateUuid)(),M.include?.map(G=>a.TestId.fromExtHostTestItem(G,b).toString())??[b],M.exclude?.map(G=>a.TestId.fromExtHostTestItem(G,b).toString())??[],q,F)}static fromInternal(b,F){return new i(b.controllerId,b.runId,b.testIds,b.excludeExtIds,!0,F)}isIncluded(b){const F=a.TestId.fromExtHostTestItem(b,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(F===M||F.startsWith(M))return!1;for(const M of this.includePrefix)if(F===M||F.startsWith(M))return!0;return!1}}e.TestRunDto=i;class s{constructor(b,F,M){this.proxy=b,this.runId=F,this.taskId=M}set coverageProvider(b){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!b||(this._coverageProvider=b,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(b){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(b))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(b,F){const M=await this.fileCoverage;let q=M?.[b];return!this._coverageProvider||!M||!q?[]:(q.detailedCoverage||(q=M[b]=await this._coverageProvider.resolveFileCoverage?.(q,F)??q),q.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class l extends E.IncrementalChangeCollector{constructor(b){super();this.emitter=b,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(b){this.added.add(b)}update(b){Object.assign(b.revived,p.TestItem.toPlain(b.item)),this.added.has(b)||this.updated.add(b)}remove(b){if(this.added.has(b)){this.added.delete(b);return}if(this.updated.delete(b),b.parent&&this.alreadyRemoved.has(b.parent)){this.alreadyRemoved.add(b.item.extId);return}this.removed.add(b)}getChangeEvent(){const{added:b,updated:F,removed:M}=this;return{get added(){return[...b].map(q=>q.revived)},get updated(){return[...F].map(q=>q.revived)},get removed(){return[...M].map(q=>q.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(b){return this.items.get(b)}getMirroredTestDataByReference(b){return this.items.get(b.id)}createItem(b,F){return{...b,revived:p.TestItem.toPlain(b.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=h;class w{constructor(b){this.proxy=b}checkout(){this.current||(this.current=this.createObserverData());const b=this.current;return b.observers++,{onDidChangeTest:b.tests.onDidChangeTests,get tests(){return[...b.tests.rootTests].map(F=>F.revived)},dispose:(0,A.once)(()=>{--b.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(b){return this.current?.tests.getMirroredTestDataByReference(b)}applyDiff(b){this.current?.tests.apply(b)}createObserverData(){const b=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:b}}}class _{constructor(b,F,M,q,G,U,z=!1,O=void 0){this.controllerId=F,this.profileId=M,this._label=q,this.kind=G,this.runHandler=U,this._isDefault=z,this._tag=O,o.set(this,void 0),it(this,o,b,"f");const N=v[G];if(typeof N!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Oe(this,o,"f").$publishTestRunProfile({profileId:M,controllerId:F,tag:O?p.TestTag.namespace(this.controllerId,O.id):null,label:q,group:N,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(b){b!==this._label&&(this._label=b,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:b}))}get isDefault(){return this._isDefault}set isDefault(b){b!==this._isDefault&&(this._isDefault=b,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:b}))}get tag(){return this._tag}set tag(b){b?.id!==this._tag?.id&&(this._tag=b,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:b?p.TestTag.namespace(this.controllerId,b.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(b){b!==this._configureHandler&&(this._configureHandler=b,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!b}))}dispose(){Oe(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=_,o=new WeakMap;const v={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(fe[253],me([0,1,3,16,5,130,15,7]),function(J,e,g,L,k,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(c=>c.value)}async showTextDocument(n,I,c){let f;typeof I=="number"?f={position:A.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?f={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(n.uri,f),p=d&&this._extHostDocumentsAndEditors.getEditor(d);if(p)return p.value;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new C.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const c=this._extHostDocumentsAndEditors.getEditor(n);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(A.Selection.to);c._acceptSelections(f)}if(I.visibleRanges){const f=L.coalesce(I.visibleRanges.map(A.Range.to));c._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const f=S.TextEditorSelectionChangeKind.fromValue(I.selections.source),d=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:d,kind:f})}if(I.visibleRanges){const f=L.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const I in n){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const f=A.ViewColumn.to(n[I]);c.value.viewColumn!==f&&(c._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(fe[254],me([0,1,2,4,5,6,7]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class S{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const f=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(y(f))?.get(c.handle)}return c}})}async $getTimeline(n,I,c,f,d){return this._providers.get(n)?.provideTimeline(g.URI.revive(I),c,f,d)}registerTimelineProvider(n,I,c,f){const d=new C.DisposableStore,p=this.convertTimelineItem(I.id,f,d).bind(this);let D;I.onDidChange&&(D=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:I.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:n,onDidChange:void 0,async provideTimeline(E,a,o,m){m?.resetCache&&(d.clear(),R.get(I.id)?.clear());const t=await I.provideTimeline(E,a,o);if(t==null)return;const u=p(E,m);return{...t,source:I.id,items:t.items.map(u)}},dispose(){for(const E of R.values())E.get(I.id)?.clear();D?.dispose(),d.dispose()}})}convertTimelineItem(n,I,c){return(f,d)=>{let p;if(d?.cacheResults){let D=this._itemsBySourceAndUriMap.get(n);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(n,D));const R=y(f);p=D.get(R),p===void 0&&(p=new Map,D.set(R,p))}return D=>{const{iconPath:R,...E}=D,a=`${n}|${D.id??D.timestamp}`;p?.set(a,D);let o,m,t;return D.iconPath&&(R instanceof A.ThemeIcon?t={id:R.id,color:R.color}:g.URI.isUri(R)?(o=R,m=R):{light:o,dark:m}=R),{...E,id:E.id??void 0,handle:a,source:n,command:D.command?I.toInternal(D.command,c):void 0,icon:o,iconDark:m,themeIcon:t,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=S;function y(T){return T?.toString()}}),define(fe[255],me([0,1,6,10,2,5]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(y){this._openers=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,n,I){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const c=I.schemes.find(f=>!A.supportedSchemes.has(f));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,n),this._proxy.$registerUriOpener(T,I.schemes,y,I.label),(0,g.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(y,T,n){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const c=k.URI.revive(T);return I.canOpenExternalUri(c,n)}async $openUri(y,T,n){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(k.URI.revive(T.resolvedUri),{sourceUri:k.URI.revive(T.sourceUri)},n)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[256],me([0,1,5,2,6,17,26]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(T,n){if(this.handles.has(A.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const I=S.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(T)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,T),(0,k.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(T)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(T,n){const I=this.handlers.get(T);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(n))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(T){return L.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=S,S.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[70],me([0,1,3,2,180,205,88,5]),function(J,e,g,L,k,C,A,S){"use strict";var y,T,n,I,c,f,d,p,D,R,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(h,w,_,v,P,b,F){y.set(this,void 0),T.set(this,void 0),n.set(this,void 0),I.set(this,void 0),c.set(this,void 0),f.set(this,void 0),d.set(this,""),p.set(this,void 0),D.set(this,!1),R.set(this,!1),E.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=Oe(this,a,"f").event,it(this,y,h,"f"),it(this,T,w,"f"),it(this,p,_,"f"),it(this,I,v,"f"),it(this,c,P,"f"),it(this,f,b,"f"),it(this,E,m(b),"f"),it(this,n,F,"f")}dispose(){it(this,D,!0,"f"),Oe(this,a,"f").fire(),Oe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return it(this,R,!0,"f"),(0,A.asWebviewUri)(h,Oe(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,d,"f")}set html(h){this.assertNotDisposed(),Oe(this,d,"f")!==h&&(it(this,d,h,"f"),!Oe(this,R,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(it(this,R,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,y,"f"),h))}get options(){return this.assertNotDisposed(),Oe(this,p,"f")}set options(h){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,y,"f"),r(Oe(this,f,"f"),Oe(this,c,"f"),h)),it(this,p,h,"f")}async postMessage(h){if(Oe(this,D,"f"))return!1;const w=(0,C.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,T,"f").$postMessage(Oe(this,y,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Oe(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,y=new WeakMap,T=new WeakMap,n=new WeakMap,I=new WeakMap,c=new WeakMap,f=new WeakMap,d=new WeakMap,p=new WeakMap,D=new WeakMap,R=new WeakMap,E=new WeakMap,a=new WeakMap;function m(l){try{const h=(0,k.normalizeVersion)((0,k.parseVersion)(l.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=m;class t{constructor(h,w,_,v,P){this.initData=w,this.workspace=_,this._logService=v,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=h.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(h,w,..._){const v=this.getWebview(h);if(v){const{message:P}=(0,C.deserializeWebviewMessage)(w,_);v._onMessageEmitter.fire(P)}}$onMissingCsp(h,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,w,_){const v=new o(h,this._webviewProxy,i(w),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(h,v),v._onDidDispose(()=>{this._webviews.delete(h)}),v}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=t;function u(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=u;function r(l,h,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||s(l,h)}}e.serializeWebviewOptions=r;function i(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(h=>L.URI.from(h))}}e.reviveOptions=i;function s(l,h){return[...(h?.getWorkspaceFolders()||[]).map(w=>w.uri),l.extensionLocation]}}),define(fe[257],me([0,1,21,48,6,10,23,2,15,70,87,5,7]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,u){this.document=t,this._storagePath=u,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,u){await this.getEdit(t).undo(),u||this.disposeBackup()}async redo(t,u){await this.getEdit(t).redo(),u||this.disposeBackup()}disposeEdits(t){for(const u of t)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const u=this._edits.get(t,0);if(!u)throw new Error("No edit found");return u}}class d{constructor(){this._documents=new Map}get(t,u){return this._documents.get(this.key(t,u))}add(t,u,r){const i=this.key(t,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${u.uri}`);const s=new f(u,r);return this._documents.set(i,s),s}delete(t,u){const r=this.key(t,u.uri);this._documents.delete(r)}key(t,u){return`${t}@@@${u}`}}var p;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(p||(p={}));class D{constructor(){this._providers=new Map}addTextProvider(t,u,r){return this.add(0,t,u,r)}addCustomProvider(t,u,r){return this.add(1,t,u,r)}get(t){return this._providers.get(t)}add(t,u,r,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:t,extension:r,provider:i}),new c.Disposable(()=>this._providers.delete(u))}}class R{constructor(t,u,r,i,s){this._extHostDocuments=u,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new D,this._documents=new d,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,u,r,i){const s=new k.DisposableStore;return E(r)?(s.add(this._editorProviders.addTextProvider(u,t,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(t),u,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(u,t,r)),this.supportEditing(r)&&s.add(r.onDidChangeCustomDocument(l=>{const h=this.getCustomDocumentEntry(u,l.document.uri);if(a(l)){const w=h.addEdit(l);this._proxy.$onDidEdit(l.document.uri,u,w,l.label)}else this._proxy.$onContentChange(l.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(t),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(s,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(t,u,r,i,s){const l=this._editorProviders.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${u}'`);const h=S.URI.revive(t),w=await l.provider.openCustomDocument(h,{backupId:r,untitledDocumentData:i?.buffer},s);let _;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(u,w,_),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(t,u){const r=this._editorProviders.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=S.URI.revive(t),{document:s}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,s),s.dispose()}async $resolveWebviewEditor(t,u,r,i,s,l){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);const w=y.ViewColumn.to(s),_=this._extHostWebview.createNewWebview(u,i.webviewOptions,h.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(u,r,i.title,w,i.panelOptions,_),P=S.URI.revive(t);switch(h.type){case 1:{const{document:b}=this.getCustomDocumentEntry(r,P);return h.provider.resolveCustomEditor(b,v,l)}case 0:{const b=this._extHostDocuments.getDocument(P);return h.provider.resolveCustomTextEditor(b,v,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,u,r){this.getCustomDocumentEntry(u,t).disposeEdits(r)}async $onMoveCustomEditor(t,u,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const l=S.URI.revive(u),h=this._extHostDocuments.getDocument(l);await i.provider.moveCustomTextEditor(h,s,g.CancellationToken.None)}async $undo(t,u,r,i){return this.getCustomDocumentEntry(u,t).undo(r,i)}async $redo(t,u,r,i){return this.getCustomDocumentEntry(u,t).redo(r,i)}async $revert(t,u,r){const i=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,u,r){const i=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,u,r,i){const s=this.getCustomDocumentEntry(u,t);return this.getCustomEditorProvider(u).saveCustomDocumentAs(s.document,S.URI.revive(r),i)}async $backup(t,u,r){const i=this.getCustomDocumentEntry(u,t),l=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(l),l.id}getCustomDocumentEntry(t,u){const r=this._documents.get(t,S.URI.revive(u));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=R;function E(m){return typeof m.resolveCustomTextEditor=="function"}function a(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function o(m){const t=m.scheme===C.Schemas.file||m.scheme===C.Schemas.untitled?m.fsPath:m.toString();return(0,L.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[258],me([0,1,3,6,2,32,15,70,5,7]),function(J,e,g,L,k,C,A,S,y,T){"use strict";var n,I,c,f,d,p,D,R,E,a,o,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends L.Disposable{constructor(l,h,w,_,v,P,b){super();n.set(this,void 0),I.set(this,void 0),c.set(this,void 0),f.set(this,void 0),d.set(this,void 0),p.set(this,void 0),D.set(this,void 0),R.set(this,void 0),E.set(this,!0),a.set(this,!0),o.set(this,!1),m.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,m,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,it(this,n,l,"f"),it(this,I,h,"f"),it(this,c,w,"f"),it(this,d,P,"f"),it(this,R,v,"f"),it(this,p,_,"f"),it(this,f,b,"f")}dispose(){Oe(this,o,"f")||(it(this,o,!0,"f"),Oe(this,m,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(l){this.assertNotDisposed(),Oe(this,p,"f")!==l&&(it(this,p,l,"f"),Oe(this,I,"f").$setTitle(Oe(this,n,"f"),l))}get iconPath(){return this.assertNotDisposed(),Oe(this,D,"f")}set iconPath(l){this.assertNotDisposed(),Oe(this,D,"f")!==l&&(it(this,D,l,"f"),Oe(this,I,"f").$setIconPath(Oe(this,n,"f"),k.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Oe(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,R,"f")=="number"&&Oe(this,R,"f")<0))return Oe(this,R,"f")}get active(){return this.assertNotDisposed(),Oe(this,a,"f")}get visible(){return this.assertNotDisposed(),Oe(this,E,"f")}_updateViewState(l){Oe(this,o,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(it(this,a,l.active,"f"),it(this,E,l.visible,"f"),it(this,R,l.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(l,h){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,n,"f"),{viewColumn:l?A.ViewColumn.from(l):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,c=new WeakMap,f=new WeakMap,d=new WeakMap,p=new WeakMap,D=new WeakMap,R=new WeakMap,E=new WeakMap,a=new WeakMap,o=new WeakMap,m=new WeakMap,t=new WeakMap;class r{constructor(l,h,w){this.webviews=h,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(l,h,w,_,v={}){const P=typeof _=="object"?_.viewColumn:_,b={viewColumn:A.ViewColumn.from(P),preserveFocus:typeof _=="object"&&!!_.preserveFocus},F=(0,S.shouldSerializeBuffersForPostMessage)(l),M=r.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(l),M,h,{title:w,panelOptions:i(v),webviewOptions:(0,S.serializeWebviewOptions)(l,this.workspace,v),serializeBuffersForPostMessage:F},b);const q=this.webviews.createNewWebview(M,v,l);return this.createNewWebviewPanel(M,h,w,P,v,q)}$onDidChangeWebviewPanelViewStates(l){const h=Object.keys(l);h.sort((w,_)=>{const v=l[w],P=l[_];return v.active?1:P.active?-1:+v.visible-+P.visible});for(const w of h){const _=this.getWebviewPanel(w);if(!_)continue;const v=l[w];_._updateViewState({active:v.active,visible:v.visible,viewColumn:A.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,h,w){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:w,extension:l}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(l,h,w,_){const v=this._serializers.get(h);if(!v)throw new Error(`No serializer found for '${h}'`);const{serializer:P,extension:b}=v,F=this.webviews.createNewWebview(l,w.webviewOptions,b),M=this.createNewWebviewPanel(l,h,w.title,_,w.panelOptions,F);await P.deserializeWebviewPanel(M,w.state)}createNewWebviewPanel(l,h,w,_,v,P){const b=new u(l,this._proxy,h,w,_,v,P);return this._webviewPanels.set(l,b),b}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=r;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[259],me([0,1,3,6,70,5,7]),function(J,e,g,L,k,C,A){"use strict";var S,y,T,n,I,c,f,d,p,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class R extends L.Disposable{constructor(o,m,t,u,r,i){super();S.set(this,void 0),y.set(this,void 0),T.set(this,void 0),n.set(this,void 0),I.set(this,!1),c.set(this,void 0),f.set(this,void 0),d.set(this,void 0),p.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Oe(this,p,"f").event,D.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,D,"f").event,it(this,T,t,"f"),it(this,f,u,"f"),it(this,S,o,"f"),it(this,y,m,"f"),it(this,n,r,"f"),it(this,c,i,"f")}dispose(){Oe(this,I,"f")||(it(this,I,!0,"f"),Oe(this,D,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(o){this.assertNotDisposed(),Oe(this,f,"f")!==o&&(it(this,f,o,"f"),Oe(this,y,"f").$setWebviewViewTitle(Oe(this,S,"f"),o))}get description(){return this.assertNotDisposed(),Oe(this,d,"f")}set description(o){this.assertNotDisposed(),Oe(this,d,"f")!==o&&(it(this,d,o,"f"),Oe(this,y,"f").$setWebviewViewDescription(Oe(this,S,"f"),o))}get visible(){return Oe(this,c,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,T,"f")}_setVisible(o){o===Oe(this,c,"f")||Oe(this,I,"f")||(it(this,c,o,"f"),Oe(this,p,"f").fire())}show(o){this.assertNotDisposed(),Oe(this,y,"f").$show(Oe(this,S,"f"),!!o)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,T=new WeakMap,n=new WeakMap,I=new WeakMap,c=new WeakMap,f=new WeakMap,d=new WeakMap,p=new WeakMap,D=new WeakMap;class E{constructor(o,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,m,t,u){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(o),m,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(o,m,t,u,r){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:l}=i,h=this._extHostWebview.createNewWebview(o,{},l),w=new R(o,this._proxy,m,t,h,!0);this._webviewViews.set(o,w),await s.resolveWebviewView(w,{state:u},r)}async $onDidChangeWebviewViewVisibility(o,m){this.getWebviewView(o)._setVisible(m)}async $disposeWebviewView(o){const m=this.getWebviewView(o);this._webviewViews.delete(o),m.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const m=this._webviewViews.get(o);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=E}),define(fe[132],me([0,1,3,5,2,10,9,4,14]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $n{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let f;if(typeof I=="string"){f=I;try{I=k.URI.parse(I)}catch(d){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,A.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,c)}async asExternalUri(I,c){if((0,A.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(I,c);return k.URI.from(f)}};T.InitialState={focused:!0},T=Ge([We(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(fe[260],me([0,1,8,80,32,40,6,5,2,14]),function(J,e,g,L,k,C,A,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends A.Disposable{constructor(c,f){super();const d=c.getProxy(S.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async p=>{const D=y.URI.file((0,g.join)((0,L.tmpdir)(),(0,k.generateUuid)()));return await d.$download(p,D),D})}};n=Ge([We(0,T.IExtHostRpcService),We(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(fe[261],me([0,1,2,8,152,28,68,27,14,6,13,116,43]),function(J,e,g,L,k,C,A,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(R,E,a){this.name=R,this.file=E,this.appender=a}static async create(R,E){const a=await(0,I.createRotatingLogger)(R,E,30*c.ByteSize.MB,1);return a.clearFormatters(),new f(R,E,a)}append(R){this.appender.critical(R)}flush(){this.appender.flush()}}class d extends A.AbstractExtHostOutputChannel{constructor(R,E,a,o){super(R,!1,g.URI.file(E.file),a,o);this._appender=E}append(R){super.append(R),this._appender.append(R),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(R,E){this._appender.flush(),super.show(R,E)}clear(){this._appender.flush(),super.clear()}}let p=class extends A.ExtHostOutputService{constructor(R,E,a){super(R);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=a.logsLocation}$setVisibleChannel(R){if(R){const E=this._channels.get(R);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(R,E){if(R=R.trim(),!R)throw new Error("illegal argument `name`. must not be falsy");const a=this._doCreateOutChannel(R,E);return a.then(o=>o._id.then(m=>this._channels.set(m,o))),new A.LazyOutputChannel(R,a)}async _doCreateOutChannel(R,E){try{const a=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(a)||await C.Promises.mkdir(a,{recursive:!0});const m=`${this._namePool++}-${R.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(a,`${m}.log`)),u=await f.create(m,t.fsPath);return new d(R,u,E.identifier.value,this._proxy)}catch(a){return this.logService.error(a),new A.ExtHostPushOutputChannel(R,E.identifier.value,this._proxy)}}};p=Ge([We(0,y.IExtHostRpcService),We(1,n.ILogService),We(2,S.IExtHostInitDataService)],p),e.ExtHostOutputService2=p}),define(fe[262],me([0,1,50,293,2,69,6,10,18]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(m){const t=await super._getWorkspaceStorageURI(m);if(t.scheme!==S.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const u=t.fsPath;let r=0;do{let i;r===0?i=u:i=/[/\\]$/.test(u)?`${u.substr(0,u.length-1)}-${r}`:`${u}-${r}`,await n(i);const s=L.join(i,"vscode.lock"),l=await d(this._logService,s,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),k.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function n(o){try{await g.promises.stat(o);return}catch{}try{await g.promises.mkdir(o,{recursive:!0})}catch{}}const I=1e3,c=10*60*1e3;class f extends A.Disposable{constructor(m,t){super();this.logService=m,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const u=await p(m,t);(!u||u.pid!==process.pid)&&(m.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(r){m.error(r),m.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(m){}}async setWillRelease(m){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${m} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+m};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function d(o,m,t){try{const r={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(m,JSON.stringify(r),{flag:"wx"})}catch(r){o.error(r)}const u=await p(o,m);return!u||u.pid!==process.pid?t?(o.info(`Lock '${m}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${m}': Could not acquire lock, checking if the file is stale.`),E(o,m)):(o.info(`Lock '${m}': Lock acquired.`),new f(o,m))}async function p(o,m){let t;try{t=await g.promises.readFile(m)}catch(u){return o.error(u),null}try{return JSON.parse(String(t))}catch(u){return o.error(u),null}}async function D(o,m){let t;try{t=await g.promises.stat(m)}catch(u){return o.error(u),0}return t.mtime.getTime()}function R(o){try{return process.kill(o,0),!0}catch(m){return!1}}async function E(o,m){const t=await p(o,m);if(!t)return o.info(`Lock '${m}': Could not read pid of lock holder.`),a(o,m);if(t.willReleaseAt){let l=t.willReleaseAt-Date.now();if(l<5e3){for(l>0?o.info(`Lock '${m}': The lockfile is scheduled to be released in ${l} ms.`):o.info(`Lock '${m}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,y.timeout)(Math.min(100,l)),await D(o,m)===0)return a(o,m);l=t.willReleaseAt-Date.now()}return a(o,m)}}if(!R(t.pid))return o.info(`Lock '${m}': The pid ${t.pid} appears to be gone.`),a(o,m);const u=await D(o,m),r=Date.now()-u;if(r<=c)return o.info(`Lock '${m}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;o.info(`Lock '${m}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const i=await D(o,m),s=Date.now()-i;return s<=c?(o.info(`Lock '${m}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null):(o.info(`Lock '${m}': The lock looks stale even after waiting for 2s.`),a(o,m))}async function a(o,m){o.info(`Lock '${m}': Deleting a stale lock.`);try{await g.promises.unlink(m)}catch(t){}return d(o,m,!0)}}),define(fe[263],me([0,1,32,14,33]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends k.BaseExtHostTerminalService{constructor(S){super(!0,S)}createTerminal(S,y,T){return this.createTerminalFromOptions({name:S,shellPath:y,shellArgs:T})}createTerminalFromOptions(S,y){const T=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),S,S.name);return this._terminals.push(T),T.create(S,this._serializeParentTerminal(S,y)),T.value}};C=Ge([We(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(fe[264],me([0,1,5,14,6,27,2,39,23,28,7,11,53,3,194,77,13]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class R{constructor(h,w,_){this.remoteAddress=h,this.localAddress=w,this._dispose=_,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(l){const h=l.trim().split(`
`),w=[];return h.forEach(v=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);P&&P.length>=3&&w.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),w.reduce((v,P)=>(v[P.socket]=P,v),{})}e.getSockets=E;function a(...l){const h=[].concat(...l.map(m));return[...new Map(h.filter(w=>w.st==="0A").map(w=>{const _=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:o(_[0]),port:parseInt(_[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=a;function o(l){let h="";if(l.length===8)for(let w=l.length-2;w>=0;w-=2)h+=parseInt(l.substr(w,2),16),w!==0&&(h+=".");else for(let w=l.length-4;w>=0;w-=4)h+=parseInt(l.substr(w,4),16).toString(16),w!==0&&(h+=":");return h}e.parseIpAddress=o;function m(l){const h=l.trim().split(`
`),w=h.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return h.map(v=>v.trim().split(/\s+/).reduce((P,b,F)=>(P[w[F]||F]=b,P),{}))}e.loadConnectionTable=m;function t(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function u(l){const h=l.trim().split(`
`),w=[];return h.forEach(_=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);v&&v.length>=4&&w.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),w}e.getRootProcesses=u;async function r(l,h,w){const _=w.reduce((P,b)=>(P[b.pid]=b,P),{}),v=[];return l.forEach(({socket:P,ip:b,port:F})=>{const M=h[P]?h[P].pid:void 0,q=M?_[M]?.cmd:void 0;M&&q&&!t(q)&&v.push({host:b,port:F,detail:q,pid:M})}),v}e.findPorts=r;function i(l,h,w){const _=new Map,v=u(h);for(const P of l){const b=w.get(P.port);if(b){_.set(P.port,b);continue}const F=v.find(M=>M.cmd.includes(`${P.port}`));if(F){let M=F,q;do q=v.find(G=>G.ppid===M.pid),q&&(M=q);while(q);_.set(P.port,{host:P.ip,port:P.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else _.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=i;let s=class extends k.Disposable{constructor(h,w,_){super();this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(g.MainContext.MainThreadTunnelService),I.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(w,h.displayName);if(_){const v=new R(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,w){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:h,provider:w}),this._proxy.$registerPortsAttributesProvider(h,_),new n.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(h,w,_,v,P){const b=[];for(const M of h){const q=this._portAttributesProviders.get(M);if(!q)return[];b.push(...await Promise.all(w.map(async G=>q.provider.providePortAttributes(G,_,v,P))))}const F=b.filter(M=>!!M);return F.length>0?F.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let w=new p.MovingAverage,_;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),P=(await this.findCandidatePorts()).filter(F=>(0,d.isLocalhost)(F.host)||(0,d.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${P.map(F=>F.port).join(", ")}`);const b=new Date().getTime()-v;w.update(b),(!_||JSON.stringify(_)!==JSON.stringify(P))&&(_=P,await this._proxy.$onFoundNewCandidates(_)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(h){return h?(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory&&(this._forwardPortProvider=h.tunnelFactory,this._proxy.$setTunnelProvider(h.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,w){if(this._extensionTunnels.has(h.host)){const _=this._extensionTunnels.get(h.host);_.has(h.port)&&(w&&_.get(h.port).disposeListener.dispose(),await _.get(h.port).tunnel.dispose(),_.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(h,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const v=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const P=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:v,disposeListener:P}),c.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(_){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const w=await Promise.all(h.map(v=>this._showCandidatePort(v.host,v.port,v.detail??""))),_=h.filter((v,P)=>w[P]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(v=>v.port).join(", ")} to ${_.map(v=>v.port).join(", ")}`),_}async findCandidatePorts(){let h="",w="";try{h=await T.Promises.readFile("/proc/net/tcp","utf8"),w=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(z){}const _=a(h,w),v=await new Promise(z=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,N,x)=>{z(N)})}),P=E(v),b=await T.Promises.readdir("/proc"),F=[];for(let z of b)try{const O=Number(z),N=y.joinPath(A.URI.file("/proc"),z);if((await T.Promises.stat(N.fsPath)).isDirectory()&&!isNaN(O)){const B=await T.Promises.readlink(y.joinPath(N,"cwd").fsPath),H=await T.Promises.readFile(y.joinPath(N,"cmdline").fsPath,"utf8");F.push({pid:O,cwd:B,cmd:H})}}catch(O){}const M=[],q=_.filter(z=>{const O=P[z.socket];return O||M.push(z),O}),G=r(q,P,F);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(O=>{(0,S.exec)("ps -F -A -l | grep root",(N,x,B)=>{O(x)})});this._foundRootPorts=i(M,z,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return G.then(z=>U?z.concat(U):z)}};s=Ge([We(0,L.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,D.ILogService)],s),e.ExtHostTunnelService=s}),define(fe[265],me([0,1,18,22,21,17,3,6,103,229,55]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(v,P){try{return JSON.stringify(v,P)}catch(b){return"null"}}const f="$$ref$$",d={[f]:-1};class p{constructor(P,b){this.jsonString=P,this.referencedBuffers=b}}function D(v,P=null,b=!1){const F=[];return{jsonString:(b?c:JSON.stringify)(v,(q,G)=>{if(typeof G=="undefined")return d;if(typeof G=="object"){if(G instanceof L.VSBuffer){const U=F.push(G)-1;return{[f]:U}}if(P)return P(q,G)}return G}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=D;function R(v,P,b){return JSON.parse(v,(F,M)=>{if(M){const q=M[f];if(typeof q=="number")return P[q];if(b&&M.$mid===1)return b.transformIncoming(M)}return M})}e.parseJsonAndRestoreBufferRefs=R;function E(v,P){return JSON.stringify(v,P)}function a(v){return v?(P,b)=>b&&b.$mid===1?v.transformOutgoing(b):b:null}var o;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends S.Disposable{constructor(P,b=null,F=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=b,this._uriTransformer=F,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let M=0,q=n.ProxyIdentifier.count;M<q;M++)this._locals[M]=null,this._proxies[M]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(M=>this._receiveOneMessage(M))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:b,sid:F}=P;return this._proxies[b]||(this._proxies[b]=this._createProxy(b,F)),this._proxies[b]}_createProxy(P,b){let F={get:(M,q)=>(typeof q=="string"&&!M[q]&&q.charCodeAt(0)===36&&(M[q]=(...G)=>this._remoteCall(P,q,G)),q===r?b:M[q])};return new Proxy(Object.create(null),F)}set(P,b){return this._locals[P.nid]=b,b}assertRegistered(P){for(let b=0,F=P.length;b<F;b++){const M=P[b];if(!this._locals[M.nid])throw new Error(`Missing actor ${M.sid} (isMain: ${M.isMain})`)}}_receiveOneMessage(P){if(this._isDisposed)return;const b=P.byteLength,F=s.read(P,0),M=F.readUInt8(),q=F.readUInt32();switch(M){case 1:case 2:{let{rpcId:G,method:U,args:z}=h.deserializeRequestJSONArgs(F);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(b,q,G,U,z,M===2);break}case 3:case 4:{let{rpcId:G,method:U,args:z}=h.deserializeRequestMixedArgs(F);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(b,q,G,U,z,M===4);break}case 5:{this._logger&&this._logger.logIncoming(b,q,0,"ack"),this._onDidReceiveAcknowledge(q);break}case 6:{this._receiveCancel(b,q);break}case 7:{this._receiveReply(b,q,void 0);break}case 9:{let G=h.deserializeReplyOKJSON(F);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReply(b,q,G);break}case 10:{const G=h.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(b,q,G);break}case 8:{let G=h.deserializeReplyOKVSBuffer(F);this._receiveReply(b,q,G);break}case 11:{let G=h.deserializeReplyErrError(F);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReplyErr(b,q,G);break}case 12:{this._receiveReplyErr(b,q,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,b,F,M,q,G){this._logger&&this._logger.logIncoming(P,b,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${M}(`,q);const U=String(b);let z,O;if(G){const x=new k.CancellationTokenSource;q.push(x.token),z=this._invokeHandler(F,M,q),O=()=>x.cancel()}else z=this._invokeHandler(F,M,q),O=t;this._cancelInvokedHandlers[U]=O;const N=h.serializeAcknowledged(b);this._logger&&this._logger.logOutgoing(N.byteLength,b,1,"ack"),this._protocol.send(N),z.then(x=>{delete this._cancelInvokedHandlers[U];const B=h.serializeReplyOK(b,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,b,1,"reply:",x),this._protocol.send(B)},x=>{delete this._cancelInvokedHandlers[U];const B=h.serializeReplyErr(b,x);this._logger&&this._logger.logOutgoing(B.byteLength,b,1,"replyErr:",x),this._protocol.send(B)})}_receiveCancel(P,b){this._logger&&this._logger.logIncoming(P,b,1,"receiveCancel");const F=String(b);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(P,b,F){this._logger&&this._logger.logIncoming(P,b,0,"receiveReply:",F);const M=String(b);if(!this._pendingRPCReplies.hasOwnProperty(M))return;const q=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M],q.resolveOk(F)}_receiveReplyErr(P,b,F){this._logger&&this._logger.logIncoming(P,b,0,"receiveReplyErr:",F);const M=String(b);if(!this._pendingRPCReplies.hasOwnProperty(M))return;const q=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M];let G;F&&(F.$isError?(G=new Error,G.name=F.name,G.message=F.message,G.stack=F.stack):G=F),q.resolveErr(G)}_invokeHandler(P,b,F){try{return Promise.resolve(this._doInvokeHandler(P,b,F))}catch(M){return Promise.reject(M)}}_doInvokeHandler(P,b,F){const M=this._locals[P];if(!M)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(P));let q=M[b];if(typeof q!="function")throw new Error("Unknown method "+b+" on actor "+(0,n.getStringIdentifierForProxy)(P));return q.apply(M,F)}_remoteCall(P,b,F){if(this._isDisposed)return Promise.reject(C.canceled());let M=null;if(F.length>0&&k.CancellationToken.isCancellationToken(F[F.length-1])&&(M=F.pop()),M&&M.isCancellationRequested)return Promise.reject(C.canceled());const q=h.serializeRequestArguments(F,this._uriReplacer),G=++this._lastMessageId,U=String(G),z=new T.LazyPromise;M&&M.onCancellationRequested(()=>{const N=h.serializeCancel(G);this._logger&&this._logger.logOutgoing(N.byteLength,G,0,"cancel"),this._protocol.send(h.serializeCancel(G))}),this._pendingRPCReplies[U]=z,this._onWillSendRequest(G);const O=h.serializeRequest(G,P,b,q,!!M);return this._logger&&this._logger.logOutgoing(O.byteLength,G,0,`request: ${(0,n.getStringIdentifierForProxy)(P)}.${b}(`,F),this._protocol.send(O),z}}e.RPCProtocol=i,I=u,i.UNRESPONSIVE_TIME=3*1e3;class s{constructor(P,b){this._buff=P,this._offset=b}static alloc(P,b,F){let M=new s(L.VSBuffer.alloc(F+1+4),0);return M.writeUInt8(P),M.writeUInt32(b),M}static read(P,b){return new s(P,b)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,b}static sizeMixedArray(P){let b=0;b+=1;for(let F=0,M=P.length;F<M;F++){const q=P[F];switch(b+=1,q.type){case 1:b+=this.sizeLongString(q.value);break;case 2:b+=this.sizeVSBuffer(q.value);break;case 3:b+=this.sizeUInt32,b+=this.sizeLongString(q.value);for(let G=0;G<q.buffers.length;++G)b+=this.sizeVSBuffer(q.buffers[G]);break;case 4:break}}return b}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let b=0,F=P.length;b<F;b++){const M=P[b];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let q=0;q<M.buffers.length;++q)this.writeBuffer(M.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let b=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:b[F]=this.readLongString();break;case 2:b[F]=this.readVSBuffer();break;case 3:const q=this.readUInt32(),G=this.readLongString(),U=[];for(let z=0;z<q;++z)U.push(this.readVSBuffer());b[F]=new n.SerializableObjectWithBuffers(R(G,U,null));break;case 4:b[F]=void 0;break}return b}}s.sizeUInt32=4;var l;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(l||(l={}));class h{static _useMixedArgSerialization(P){for(let b=0,F=P.length;b<F;b++)if(P[b]instanceof L.VSBuffer||P[b]instanceof n.SerializableObjectWithBuffers||typeof P[b]=="undefined")return!0;return!1}static serializeRequestArguments(P,b){if(this._useMixedArgSerialization(P)){const F=[];for(let M=0,q=P.length;M<q;M++){const G=P[M];if(G instanceof L.VSBuffer)F[M]={type:2,value:G};else if(typeof G=="undefined")F[M]={type:4};else if(G instanceof n.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:z}=D(G.value,b);F[M]={type:3,value:L.VSBuffer.fromString(U),buffers:z}}else F[M]={type:1,value:L.VSBuffer.fromString(E(G,b))}}return{type:1,args:F}}return{type:0,args:E(P,b)}}static serializeRequest(P,b,F,M,q){switch(M.type){case 0:return this._requestJSONArgs(P,b,F,M.args,q);case 1:return this._requestMixedArgs(P,b,F,M.args,q)}}static _requestJSONArgs(P,b,F,M,q){const G=L.VSBuffer.fromString(F),U=L.VSBuffer.fromString(M);let z=0;z+=s.sizeUInt8(),z+=s.sizeShortString(G),z+=s.sizeLongString(U);let O=s.alloc(q?2:1,P,z);return O.writeUInt8(b),O.writeShortString(G),O.writeLongString(U),O.buffer}static deserializeRequestJSONArgs(P){const b=P.readUInt8(),F=P.readShortString(),M=P.readLongString();return{rpcId:b,method:F,args:JSON.parse(M)}}static _requestMixedArgs(P,b,F,M,q){const G=L.VSBuffer.fromString(F);let U=0;U+=s.sizeUInt8(),U+=s.sizeShortString(G),U+=s.sizeMixedArray(M);let z=s.alloc(q?4:3,P,U);return z.writeUInt8(b),z.writeShortString(G),z.writeMixedArray(M),z.buffer}static deserializeRequestMixedArgs(P){const b=P.readUInt8(),F=P.readShortString(),M=P.readMixedArray(),q=new Array(M.length);for(let G=0,U=M.length;G<U;G++){const z=M[G];typeof z=="string"?q[G]=JSON.parse(z):q[G]=z}return{rpcId:b,method:F,args:q}}static serializeAcknowledged(P){return s.alloc(5,P,0).buffer}static serializeCancel(P){return s.alloc(6,P,0).buffer}static serializeReplyOK(P,b,F){if(typeof b=="undefined")return this._serializeReplyOKEmpty(P);if(b instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(P,b);if(b instanceof n.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:q}=D(b.value,F,!0);return this._serializeReplyOKJSONWithBuffers(P,M,q)}else return this._serializeReplyOKJSON(P,c(b,F))}static _serializeReplyOKEmpty(P){return s.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,b){let F=0;F+=s.sizeVSBuffer(b);let M=s.alloc(8,P,F);return M.writeVSBuffer(b),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,b){const F=L.VSBuffer.fromString(b);let M=0;M+=s.sizeLongString(F);let q=s.alloc(9,P,M);return q.writeLongString(F),q.buffer}static _serializeReplyOKJSONWithBuffers(P,b,F){const M=L.VSBuffer.fromString(b);let q=0;q+=s.sizeUInt32,q+=s.sizeLongString(M);for(const U of F)q+=s.sizeVSBuffer(U);let G=s.alloc(10,P,q);G.writeUInt32(F.length),G.writeLongString(M);for(const U of F)G.writeBuffer(U);return G.buffer}static deserializeReplyOKJSON(P){const b=P.readLongString();return JSON.parse(b)}static deserializeReplyOKJSONWithBuffers(P,b){const F=P.readUInt32(),M=P.readLongString(),q=[];for(let G=0;G<F;++G)q.push(P.readVSBuffer());return new n.SerializableObjectWithBuffers(R(M,q,b))}static serializeReplyErr(P,b){return b?this._serializeReplyErrEror(P,b):this._serializeReplyErrEmpty(P)}static _serializeReplyErrEror(P,b){const F=L.VSBuffer.fromString(c(C.transformErrorForSerialization(b),null));let M=0;M+=s.sizeLongString(F);let q=s.alloc(11,P,M);return q.writeLongString(F),q.buffer}static deserializeReplyErrError(P){const b=P.readLongString();return JSON.parse(b)}static _serializeReplyErrEmpty(P){return s.alloc(12,P,0).buffer}}var w;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var _;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(_||(_={}))}),define(fe[266],me([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[267],me([0,1,10,8,11,2,4,86,44,224,266]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let I=class Wn{constructor(f,d,p,D){this.localUserHome=f,this.remoteAgentService=d,this.environmentService=p,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const R=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=R?.userHome||f})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return g.Schemas.vscodeRemote;const p=(0,S.getVirtualWorkspaceScheme)(d.getWorkspace());if(p)return p;const D=d.getWorkspace().folders[0];if(D)return D.uri.scheme;const R=d.getWorkspace().configuration;return R?R.scheme:g.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?L.win32:L.posix)}async fileURI(f){let d="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const D=f.indexOf("/",2);D===-1?(d=f.substring(2),f="/"):(d=f.substring(2,D),f=f.substring(D)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:d,path:f,query:"",fragment:""})}};I=Ge([We(1,n.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,y.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[71],me([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(A,S){this.line=A,this.character=S}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,S){return new g(0,0)}with(A){return new g(0,0)}}e.Position=g;class L{constructor(A,S,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(A,S),this.end=new g(y,T)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.Range=L;var k;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,16,30,25,29,9,4,8,17,71,12]),function(J,e,g,L,k,C,A,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",f=" characters skipped \u27EB",d=(c.length+f.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var p;(function(N){N[N.file=0]="file",N[N.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(N){N[N.File=1]="File",N[N.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function R(N){return!!N.preview}e.resultIsMatch=R;function E(N){return!!N.resource}e.isFileMatch=E;function a(N){return!!N.message}e.isProgressMessage=a;var o;(function(N){N[N.Normal=0]="Normal",N[N.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=m;class t{constructor(x,B,H){this.ranges=B;const $=Array.isArray(B)?B:[B];if(H&&H.matchLines===1&&u($)){x=(0,A.getNLines)(x,H.matchLines);let Y="",Q=0,de=0;const _e=Math.floor(H.charsPerLine/5),Ce=[];for(const Te of $){const $e=Math.max(Te.startColumn-_e,0),Be=Te.startColumn+H.charsPerLine;if($e>de+_e+d){const He=c+($e-de)+f;Y+=He+x.slice($e,Be),Q+=$e-(de+He.length)}else Y+=x.slice(de,Be);Ce.push(new i(0,Te.startColumn-Q,Te.endColumn-Q)),de=Be}this.preview={text:Y,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const Y=Array.isArray(B)?B[0].startLineNumber:B.startLineNumber;this.preview={text:x,matches:(0,g.mapArrayOrNot)(B,Q=>new r(Q.startLineNumber-Y,Q.startColumn,Q.endLineNumber-Y,Q.endColumn))}}}}e.TextSearchMatch=t;function u(N){const x=N[0].startLineNumber;for(const B of N)if(B.startLineNumber!==x||B.endLineNumber!==x)return!1;return!0}class r{constructor(x,B,H,$){this.startLineNumber=x,this.startColumn=B,this.endLineNumber=H,this.endColumn=$}}e.SearchRange=r;class i extends r{constructor(x,B,H){super(x,B,x,H)}}e.OneLineRange=i;var s;(function(N){N.Default="default",N.FileNames="fileNames",N.Type="type",N.Modified="modified",N.CountDescending="countDescending",N.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function l(N,x=!0){const B=N&&N.files&&N.files.exclude,H=x&&N&&N.search&&N.search.exclude;if(!B&&!H)return;if(!B||!H)return B||H;let $=Object.create(null);return $=k.mixin($,k.deepClone(B)),$=k.mixin($,k.deepClone(H),!0),$}e.getExcludes=l;function h(N,x){return N.excludePattern&&L.match(N.excludePattern,x)?!1:N.includePattern||N.usingSearchPaths?N.includePattern&&L.match(N.includePattern,x)?!0:N.usingSearchPaths?!!N.folderQueries&&N.folderQueries.some(B=>{const H=B.folder.fsPath;if(C.isEqualOrParent(x,H)){const $=y.relative(H,x);return!B.includePattern||!!L.match(B.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var w;(function(N){N[N.unknownEncoding=1]="unknownEncoding",N[N.regexParseError=2]="regexParseError",N[N.globParseError=3]="globParseError",N[N.invalidLiteral=4]="invalidLiteral",N[N.rgProcessError=5]="rgProcessError",N[N.other=6]="other",N[N.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(x,B){super(x);this.code=B}}e.SearchError=_;function v(N){const x=N.message;if((0,T.isPromiseCanceledError)(N))return new _(x,w.canceled);try{const B=JSON.parse(x);return new _(B.message,B.code)}catch(B){return new _(x,w.other)}}e.deserializeSearchError=v;function P(N){const x={message:N.message,code:N.code};return new Error(JSON.stringify(x))}e.serializeSearchError=P;function b(N){return N.type==="error"?!0:N.type==="success"}e.isSerializedSearchComplete=b;function F(N){return N.type==="success"}e.isSerializedSearchSuccess=F;function M(N){return!!N.path}e.isSerializedFileMatch=M;function q(N,x){const B=N.searchPath?N.searchPath:N.relativePath;return(0,A.fuzzyContains)(B,x)}e.isFilePatternMatch=q;class G{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=G;function U(N,x){const B={...N||{},...x||{}};return Object.keys(B).filter(H=>{const $=B[H];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=U;class z{constructor(x,B){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...B.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=x.includePattern;B.includePattern&&(H?H={...H,...B.includePattern}:H=B.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}includedInQuerySync(x,B,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,B,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,B,H))}includedInQuery(x,B,H){const $=this._parsedExcludeExpression(x,B,H),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,B,H):!0;return(0,I.isPromise)($)?$.then(Q=>Q?!1:Y()):Y()}hasSiblingExcludeClauses(){return O(this._excludeExpression)}}e.QueryGlobTester=z;function O(N){for(const x in N)if(typeof N[x]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,16,18,21,3,24,10,77,23,9,12,2,170,4,13,190,44,52,27,14,7,31,5]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a,o,m,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(P,b,F){return new T.ExtUri(M=>h(M,F)).isEqual(P,b)}function i(P,b,F){return r(P.uri,b.uri,F)?0:(0,n.compare)(P.uri.toString(),b.uri.toString())}function s(P,b,F){return P.index!==b.index?P.index<b.index?-1:1:r(P.uri,b.uri,F)?(0,n.compare)(P.name,b.name):(0,n.compare)(P.uri.toString(),b.uri.toString())}function l(P,b,F,M){const q=P.slice(0).sort((U,z)=>F(U,z,M)),G=b.slice(0).sort((U,z)=>F(U,z,M));return(0,g.delta)(q,G,(U,z)=>F(U,z,M))}function h(P,b){const F=b.getCapabilities(P.scheme);return!(F&&F&1024)}class w extends R.Workspace{constructor(b,F,M,q,G,U){super(b,M.map(z=>new R.WorkspaceFolder(z)),q,U);this._name=F,this._isUntitled=G,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(U),M.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(b,F,M,q){if(!b)return{workspace:null,added:[],removed:[]};const{id:G,name:U,folders:z,configuration:O,isUntitled:N}=b,x=[],B=F;F?z.forEach((Q,de)=>{const _e=c.URI.revive(Q.uri),Ce=w._findFolder(M||F,_e,q);Ce?(Ce.name=Q.name,Ce.index=Q.index,x.push(Ce)):x.push({uri:_e,name:Q.name,index:de})}):x.push(...z.map(({uri:Q,name:de,index:_e})=>({uri:c.URI.revive(Q),name:de,index:_e}))),x.sort((Q,de)=>Q.index<de.index?-1:1);const H=new w(G,U,x,O?c.URI.revive(O):null,!!N,Q=>h(Q,q)),{added:$,removed:Y}=l(B?B.workspaceFolders:[],H.workspaceFolders,i,q);return{workspace:H,added:$,removed:Y}}static _findFolder(b,F,M){for(let q=0;q<b.folders.length;q++){const G=b.workspaceFolders[q];if(r(G.uri,F,M))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(b,F){return F&&this._structure.get(b)&&(b=(0,T.dirname)(b)),this._structure.findSubstr(b)}resolveWorkspaceFolder(b){return this._structure.get(b)}}let _=class{constructor(b,F,M,q){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=M,this._requestIdProvider=new y.Counter,this._barrier=new L.Barrier,this._proxy=b.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=b.getProxy(u.MainContext.MainThreadMessageService);const G=F.workspace;this._confirmedWorkspace=G?new w(G.id,G.name,[],G.configuration?c.URI.revive(G.configuration):null,!!G.isUntitled,U=>h(U,M)):void 0}$initializeWorkspace(b,F){this._trusted=F,this.$acceptWorkspaceData(b),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:S.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(b,F,M,...q){const G=[];if(Array.isArray(q)&&q.forEach(x=>{c.URI.isUri(x.uri)&&!G.some(B=>r(B.uri,x.uri,this._extHostFileSystemInfo))&&G.push({uri:x.uri,name:x.name||(0,T.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[F,M].some(x=>typeof x!="number"||x<0)||M===0&&G.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+M>U.length)return!1;const z=U.slice(0);z.splice(F,M,...G.map(x=>({uri:x.uri,name:x.name||(0,T.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<z.length;x++){const B=z[x];if(z.some((H,$)=>$!==x&&r(B.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((x,B)=>x.index=B);const{added:O,removed:N}=l(U,z,s,this._extHostFileSystemInfo);if(O.length===0&&N.length===0)return!1;if(this._proxy){const x=b.displayName||b.name;this._proxy.$updateWorkspaceFolders(x,F,M,G).then(void 0,B=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,f.localize)(0,null,x,B.toString()),{extension:b},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(b,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(b,F)}async getWorkspaceFolder2(b,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(b,F)}async resolveWorkspaceFolder(b){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(b)}getPath(){if(!this._actualWorkspace)return;const{folders:b}=this._actualWorkspace;if(b.length!==0)return b[0].uri.fsPath}getRelativePath(b,F){let M,q="";if(typeof b=="string"?(M=c.URI.file(b),q=b):typeof b!="undefined"&&(M=b,q=b.fsPath),!M)return q;const G=this.getWorkspaceFolder(M,!0);if(!G)return q;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let U=(0,T.relativePath)(G.uri,M);return F&&G.name&&(U=`${G.name}/${U}`),U}trySetWorkspaceFolders(b){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:b,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(b){const{workspace:F,added:M,removed:q}=w.toExtHostWorkspace(b,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:q}))}findFiles(b,F,M,q,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let U;if(F===null?U=!1:F&&(typeof F=="string"?U=F:U=F.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:O}=v(b);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(O),(0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(M),G).then(N=>Array.isArray(N)?N.map(x=>c.URI.revive(x)):[])}async findTextInFiles(b,F,M,q,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),z=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:O,folder:N}=v(F.include),x=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,B={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:O,excludePattern:x},H=!1;if(this._activeSearchCallbacks[U]=$=>{if(H)return;const Y=c.URI.revive($.resource);$.results.forEach(Q=>{(0,t.resultIsMatch)(Q)?M({uri:Y,preview:{text:Q.preview.text,matches:(0,g.mapArrayOrNot)(Q.preview.matches,de=>new m.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(Q.ranges,de=>new m.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):M({uri:Y,text:Q.text,lineNumber:Q.lineNumber})})},G.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(b,(0,I.withUndefinedAsNull)(N),B,U,G);return delete this._activeSearchCallbacks[U],$||{}}catch($){throw delete this._activeSearchCallbacks[U],$}}$handleTextSearchResult(b,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](b)}saveAll(b){return this._proxy.$saveAll(b)}resolveProxy(b){return this._proxy.$resolveProxy(b)}get trusted(){return this._trusted}requestWorkspaceTrust(b){return this._proxy.$requestWorkspaceTrust(b)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};_=Ge([We(0,o.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,E.IExtHostFileSystemInfo),We(3,p.ILogService)],_),e.ExtHostWorkspace=_,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function v(P){let b,F;return P&&(typeof P=="string"?b=P:(b=P.pattern,F=P.baseFolder||c.URI.file(P.base))),{includePattern:b,folder:F}}}),define(fe[37],me([0,1,25,3,36,5,7,193,85,12,18,4,14,13,2]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(u,r){if(r){const i=r.split(".");let s=u;for(let l=0;s&&l<i.length;l++)s=s[i[l]];return s}}function D(u){return u instanceof d.URI}function R(u){return u&&u.uri instanceof d.URI&&u.languageId&&typeof u.languageId=="string"}function E(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function a(u){return u&&u.uri instanceof d.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function o(u){if(D(u))return{resource:u};if(R(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(E(u))return{overrideIdentifier:u.languageId};if(a(u))return{resource:u.uri};if(u===null)return{resource:null}}let m=class{constructor(r,i,s){this._proxy=r.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,i))}};m=Ge([We(0,c.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,f.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(r,i,s,l){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=l,this._extHostWorkspace=i,this._configuration=S.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(r,i,s){const l=o(i)||{},h=this._toReadonlyValue(r?p(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,l,s?.identifier);function w(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const _={has(v){return typeof p(h,v)!="undefined"},get:(v,P)=>{this._validateConfigurationAccess(r?`${r}.${v}`:v,l,s?.identifier);let b=p(h,v);if(typeof b=="undefined")b=P;else{let F;const M=(q,G)=>{let U;const z=()=>{F=F||(0,g.deepClone)(h),U=U||p(F,G)};return(0,T.isObject)(q)?new Proxy(q,{get:(O,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return z(),()=>U;if(F)return U=U||p(F,G),U[N];const x=O[N];return typeof N=="string"?M(x,`${G}.${N}`):x},set:(O,N,x)=>(z(),U&&(U[N]=x),!0),deleteProperty:(O,N)=>(z(),U&&delete U[N],!0),defineProperty:(O,N,x)=>(z(),U&&Object.defineProperty(U,N,x),!0)}):q};b=M(b,v)}return b},update:(v,P,b,F)=>{v=r?`${r}.${v}`:v;const M=w(b);return P!==void 0?this._proxy.$updateConfigurationOption(M,v,P,l,F):this._proxy.$removeConfigurationOption(M,v,l,F)},inspect:v=>{v=r?`${r}.${v}`:v;const P=(0,g.deepClone)(this._configuration.inspect(v,l,this._extHostWorkspace.workspace));if(P)return{key:v,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof h=="object"&&(0,g.mixin)(_,h,!1),Object.freeze(_)}_toReadonlyValue(r){const i=s=>(0,T.isObject)(s)?new Proxy(s,{get:(l,h)=>i(l[h]),set:(l,h,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(l,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(l,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(r)}_validateConfigurationAccess(r,i,s){const l=y.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),h=s?`[${s.value}] `:"";if(l===4){typeof i?.resource=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const s=new S.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,h)=>s.affectsConfiguration(l,o(h))})}_toMap(r){return r.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[72],me([0,1,2,18,3,5,7,36,45,37,21,33,14,27,4,10,11,13,67,214,17]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a,o){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(G){function U(O){if(O!=null)return O}G.from=U;function z(O){if(O!=null)return O}G.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(G){function U(O){if(O!=null)return O}G.from=U;function z(O){if(O!=null)return O}G.to=z})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(G){function U(O){if(O!=null)return O}G.from=U;function z(O){if(O!=null)return O}G.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(G){function U(N){if(N){const x=N;return x&&!!x.process}else return!1}G.is=U;function z(N){if(N==null)return;const x={process:N.process,args:N.args};return N.options&&(x.options=r.from(N.options)),x}G.from=z;function O(N){if(N!=null)return new A.ProcessExecution(N.process,N.args,N.options)}G.to=O})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(G){function U(O){if(O!=null)return O}G.from=U;function z(O){if(O!=null)return O}G.to=z})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(G){function U(N){if(N){const x=N;return x&&(!!x.commandLine||!!x.command)}else return!1}G.is=U;function z(N){if(N==null)return;const x={};return N.commandLine!==void 0?x.commandLine=N.commandLine:(x.command=N.command,x.args=N.args),N.options&&(x.options=s.from(N.options)),x}G.from=z;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.ShellExecution(N.commandLine,N.options):new A.ShellExecution(N.command,N.args?N.args:[],N.options)}G.to=O})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(G){function U(N){if(N){let x=N;return x&&x.customExecution==="customExecution"}else return!1}G.is=U;function z(N){return{customExecution:"customExecution"}}G.from=z;function O(N,x){return x.get(N)}G.to=O})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(G){function U(z,O){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=a.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:N}}G.from=U})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var _;(function(G){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}G.from=U})(_=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(G){function U(N,x){if(N==null)return[];const B=[];for(let H of N){const $=z(H,x);$&&B.push($)}return B}G.fromMany=U;function z(N,x){if(N==null)return;let B;N.execution instanceof A.ProcessExecution?B=i.from(N.execution):N.execution instanceof A.ShellExecution?B=l.from(N.execution):N.execution&&N.execution instanceof A.CustomExecution&&(B=h.from(N.execution));const H=t.from(N.definition);let $;return N.scope?typeof N.scope=="number"?$=N.scope:$=N.scope.uri:$=A.TaskScope.Workspace,!H||!$?void 0:{_id:N._id,definition:H,name:N.name,source:{extensionId:x.identifier.value,label:N.source,scope:$},execution:B,isBackground:N.isBackground,group:_.from(N.group),presentationOptions:u.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}G.from=z;async function O(N,x,B){if(N==null)return;let H;i.is(N.execution)?H=i.to(N.execution):l.is(N.execution)?H=l.to(N.execution):h.is(N.execution)&&(H=h.to(N._id,B));const $=t.to(N.definition);let Y;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Y=N.source.scope:Y=await x.resolveWorkspaceFolder(g.URI.revive(N.source.scope)):Y=A.TaskScope.Workspace),!$||!Y)return;const Q=new A.Task($,Y,N.name,N.source.label,H,N.problemMatchers);return N.isBackground!==void 0&&(Q.isBackground=N.isBackground),N.group!==void 0&&(Q.group=A.TaskGroup.from(N.group._id),Q.group&&(Q.group=new A.TaskGroup(Q.group.id,Q.group.label),N.group.isDefault&&(Q.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Q.presentationOptions=u.to(N.presentationOptions)),N._id&&(Q._id=N._id),N.detail&&(Q.detail=N.detail),Q}G.to=O})(v=e.TaskDTO||(e.TaskDTO={}));var P;(function(G){function U(O){return O}G.from=U;function z(O){if(!!O)return Object.assign(Object.create(null),O)}G.to=z})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class b{constructor(U,z,O){this._id=z,this._task=O,m.set(this,void 0),it(this,m,U,"f")}get task(){return this._task}terminate(){Oe(this,m,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}m=new WeakMap;var F;(function(G){function U(z){return{id:z._id,task:void 0}}G.from=U})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let M=class{constructor(U,z,O,N,x,B,H,$){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=U.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=N,this._configurationService=x,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,O){if(!O)return new A.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:z,provider:O,extension:U}),this._proxy.$registerTaskProvider(N,z),new A.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(U,z){this._proxy.$registerTaskSystem(U,z)}fetchTasks(U){return this._proxy.$fetchTasks(P.from(U)).then(async z=>{const O=[];for(let N of z){const x=await v.to(N,this._workspaceProvider,this._providedCustomExecutions2);x&&O.push(x)}return O})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,z,O){const N=this._providedCustomExecutions2.get(U.id);if(N){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,N),this._terminalService.attachPtyToTerminal(z,await N.callback(O))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const z=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const O=this._handlers.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],x=(0,L.asPromise)(()=>O.provider.provideTasks(n.CancellationToken.None)).then(B=>this.provideTasksInternal(z,N,O,B));return new Promise(B=>{x.then(H=>{Promise.all(N).then(()=>{B(H)})})})}async $resolveTask(U,z){const O=this._handlers.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await v.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const x=await O.provider.resolveTask(N,n.CancellationToken.None);if(!x)return;this.checkDeprecation(x,O);const B=v.from(x,O.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(B.execution)&&await this.addCustomExecution(B,x,!0),await this.resolveTaskInternal(B)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,z,O){const N=await this._proxy.$createTaskId(U);!O&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,z.execution)}async getTaskExecution(U,z){if(typeof U=="string"){const x=this._taskExecutionPromises.get(U);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let O=this._taskExecutionPromises.get(U.id);if(O)return O;const N=new Promise(async(x,B)=>{const H=z||await v.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);H?x(new b(this,U.id,H)):B("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,N),N.then(x=>(this._taskExecutions.set(U.id,x),x),x=>Promise.reject(x))}checkDeprecation(U,z){U._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let O=this._notProvidedCustomExecutions.values(),N=O.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=O.next()}};M=Ge([We(0,c.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,S.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,R.ILogService),We(7,E.IExtHostApiDeprecationService)],M),e.ExtHostTaskBase=M;let q=class extends M{constructor(U,z,O,N,x,B,H,$){super(U,z,O,N,x,B,H,$);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=v.from(z,U);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.addCustomExecution(O,z,!1);else throw new o.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),z);return this._proxy.$executeTask(O).catch(x=>{throw new Error(x)}),N}provideTasksInternal(U,z,O,N){const x=[];if(N)for(let B of N){this.checkDeprecation(B,O),(!B.definition||!U[B.definition.type])&&this._logService.warn(`The task [${B.source}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`);const H=v.from(B,O.extension);H&&h.is(H.execution)?(x.push(H),z.push(this.addCustomExecution(H,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:O.extension}}async resolveTaskInternal(U){if(h.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,O){}};q=Ge([We(0,c.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,S.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,R.ILogService),We(7,E.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,d.createDecorator)("IExtHostTask")}),define(fe[268],me([0,1,16,58,30,79,24,10,8,23,9,12,2,146,176,120,44,128,267,31]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(w,_,v,P){this.configurationService=w,this.workspaceContextService=_,this.editorGroupsService=v,this.pathService=P}text(w,_,v={}){w=this.getContentPattern(w,v);const P=this.configurationService.getValue(),b=_&&_.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(_?.map(D.toWorkspaceFolder),v),type:2,contentPattern:w,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:P.search.usePCRE2||b||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(w,_){const v=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const P={...w,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(w,_)&&(P.isCaseSensitive=!0),this.isMultiline(w)&&(P.isMultiline=!0),P}file(w,_={}){return{...this.commonQuery(w,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(w,_){return w?(w=Array.isArray(w)?w.map(i):i(w),_?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],_={}){const v=this.handleIncludeExclude(_.includePattern,_.expandPatterns),P=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),b=w.length>1,F=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,_,P)):w.map(G=>this.getFolderQueryForRoot(G,_,P,b))).filter(G=>!!G),M={_reason:_._reason,folderQueries:F,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:P.pattern,includePattern:v.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const U=g.coalesce(g.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(N=>N.resource)))).filter(O=>(0,a.pathIncludedInQuery)(M,O.fsPath)),z=this.commonQueryFromFileList(U);return{...M,...z}}const q=_.extraFileResources&&_.extraFileResources.filter(G=>(0,a.pathIncludedInQuery)(M,G.fsPath));return M.extraFileResources=q&&q.length?q:void 0,M}commonQueryFromFileList(w){const _=[],v=new A.ResourceMap,P={};let b=!1;return w.forEach(F=>{if(F.scheme===S.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(F)){const q=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:y.dirname(F.fsPath)});let G=v.get(q);G||(b=!0,G={folder:q,includePattern:{}},_.push(G),v.set(q,G));const U=y.relative(q.fsPath,F.fsPath);(0,I.assertIsDefined)(G.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(b=!0,P[F.fsPath]=!0)}),{folderQueries:_,includePattern:P,usingSearchPaths:!0,excludePattern:b?void 0:{"**/*":!0}}}isCaseSensitive(w,_){if(_.isSmartCase){if(w.isRegExp){if(n.containsUppercaseCharacter(w.pattern,!0))return!0}else if(n.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,f.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const _=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),P=(Array.isArray(w)?w:u(w)).map(z=>{const O=this.pathService.resolvedUserHome;return O?(0,C.untildify)(z,O.scheme===S.Schemas.file?O.fsPath:O.path):z}),b=L.groupBy(P,z=>_(z)?"searchPaths":"exprSegments"),F=(b.exprSegments||[]).map(z=>n.rtrim(z,"/")).map(z=>n.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),M={},q=this.expandSearchPathPatterns(b.searchPaths||[]);q&&q.length&&(M.searchPaths=q);const G=g.flatten(F),U=t(...G);return U&&(M.pattern=U),M}getExcludesForFolder(w,_){return _.disregardExcludeSettings?void 0:(0,a.getExcludes)(w,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const _=g.flatten(w.map(P=>{let{pathPortion:b,globPortion:F}=m(P);F&&(F=s(F));const M=this.expandOneSearchPath(b);return g.flatten(M.map(q=>this.resolveOneSearchPathPattern(q,F)))})),v=new Map;return _.forEach(P=>{const b=P.searchPath.toString(),F=v.get(b);F?P.pattern&&(F.pattern=F.pattern||{},F.pattern[P.pattern]=!0):v.set(b,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==S.Schemas.file?[{searchPath:_[0].uri.with({path:w})}]:[{searchPath:c.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const P=y.posix.resolve(_.path,w);return[{searchPath:_.with({path:P})}]}const v=s(w);return[{searchPath:_,pattern:v}]}else{if(w==="./"||w===".\\")return[];{const _=w.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(b=>{const F=_.match(new RegExp(`^${n.escapeRegExpCharacters(b.name)}(?:/(.*)|$)`));return F?{match:F,folder:b}:null}).filter(I.isDefined);if(P.length)return P.map(b=>{const F=b.match[1];return{searchPath:b.folder.uri,pattern:F&&s(F)}});{const b=w.match(/\.[\/\\](.+)[\/\\]?/),F=b?b[1]:w,M=d.localize(0,null,F);throw new Error(M)}}}}resolveOneSearchPathPattern(w,_){const v=w.pattern&&_?`${w.pattern}/${_}`:w.pattern||_,P=[{searchPath:w.searchPath,pattern:v}];return v&&!v.endsWith("**")&&P.push({searchPath:w.searchPath,pattern:v+"/**"}),P}getFolderQueryForSearchPath(w,_,v){const P=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(w.searchPath),_,v,!1);return P?{...P,includePattern:w.pattern}:null}getFolderQueryForRoot(w,_,v,P){let b;const F=c.URI.isUri(w)?w:w.uri;if(v.searchPaths){const z=v.searchPaths.filter(O=>(0,T.isEqual)(O.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(b=z.pattern)}const M=this.configurationService.getValue({resource:F}),G={...this.getExcludesForFolder(M,_)||{},...b||{}},U=c.URI.isUri(w)?(0,T.basename)(w):w.name;return{folder:F,folderName:P?U:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!M.search.followSymlinks}}};o=Ge([We(0,p.IConfigurationService),We(1,D.IWorkspaceContextService),We(2,R.IEditorGroupsService),We(3,E.IPathService)],o),e.QueryBuilder=o;function m(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const _=w.index,v=h.substr(0,_).match(/[/|\\][^/\\]*$/);if(v){let P=h.substr(0,v.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((v.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((w,_)=>(w[_]=!0,w),Object.create(null)):void 0}function u(h){return k.splitGlobAware(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function r(h){return[`**/${h}/**`,`**/${h}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function s(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(h,w){h=g.distinct(h,P=>P.toString());const _=[],v=w.getWorkspace();return h&&h.forEach(P=>{let b;if(w.getWorkbenchState()===2)b=(0,T.relativePath)(v.folders[0].uri,P),b&&b!=="."&&(b="./"+b);else{const F=w.getWorkspaceFolder(P);if(F){const M=F.name;if(v.folders.filter(G=>G.name===M).length===1){const G=(0,T.relativePath)(F.uri,P);G===""?b=`./${F.name}`:b=`./${F.name}/${G}`}else b=P.fsPath}}b&&_.push(b)}),_}e.resolveResourcesForSearchIncludes=l}),define(fe[269],me([0,1,23,2,21,17,4,268,31,44]),function(J,e,g,L,k,C,A,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(p,D){const R=D.activationEvents;if(!R)return Promise.resolve(void 0);const E=[],a=[];for(const i of R)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||p.forceUsingSearch?a.push(s):E.push(s)}if(E.length===0&&a.length===0)return Promise.resolve(void 0);let o;const m=new Promise((i,s)=>{o=i}),t=i=>o({activationEvent:i}),u=Promise.all(E.map(i=>c(p,i,t))).then(()=>{}),r=f(p,D.identifier,a,t);return Promise.all([u,r]).then(()=>{o(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function c(p,D,R){for(const E of p.folders)if(await p.exists(g.joinPath(L.URI.revive(E),D))){R(`workspaceContains:${D}`);return}}async function f(p,D,R,E){if(R.length===0)return Promise.resolve(void 0);const a=new k.CancellationTokenSource,o=p.checkExists(p.folders,R,a.token),m=setTimeout(async()=>{a.cancel(),E(`workspaceContainsTimeout:${R.join(",")}`)},n);let t=!1;try{t=await o}catch(u){C.isPromiseCanceledError(u)||C.onUnexpectedError(u)}a.dispose(),clearTimeout(m),t&&E(`workspaceContains:${R.join(",")}`)}function d(p,D,R,E){const a=p.get(A.IInstantiationService),o=p.get(y.ISearchService),t=a.createInstance(S.QueryBuilder).file(D.map(u=>(0,T.toWorkspaceFolder)(L.URI.revive(u))),{_reason:"checkExists",includePattern:R,exists:!0});return o.fileSearch(t,E).then(u=>!!u.limitHit,u=>C.isPromiseCanceledError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=d});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},Oe=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(fe[41],me([0,1,165,8,73,23,18,6,24,2,13,5,37,227,92,36,35,225,17,26,22,200,7,121,4,27,69,14,84,53,33,3,269,90,202]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a,o,m,t,u,r,i,s,l,h,w,_,v,P,b,F){"use strict";var M,q,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Hn extends S.Disposable{constructor(x,B,H,$,Y,Q,de,_e,Ce,Te){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=H,this._initData=de,this._extHostWorkspace=$,this._extHostConfiguration=Y,this._logService=Q,this._extHostTunnelService=Ce,this._extHostTerminalService=Te,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new R.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new b.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=x.createChild(new h.ServiceCollection([d.IExtHostStorage,this._storage],[b.IExtHostSecretState,this._secretState]));const $e=new Set;this._initData.hostExtensions.forEach(Be=>$e.add(a.ExtensionIdentifier.toKey(Be))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,He,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,E.transformErrorForSerialization(He),j)},actualActivateExtension:async(Be,He)=>{if($e.has(a.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,He),new f.HostExtension;const j=this._registry.getExtensionDescription(Be);return this._activateExtension(j,He)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){E.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this._deactivate(Y))}catch(B){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,B){return this._activator.activateByEvent(x,B)}_activateById(x,B){return this._activator.activateById(x,B)}activateByIdWithErrors(x,B){return this._activateById(x,B).then(()=>{const H=this._activator.getActivatedExtension(x);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=y.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then($=>x.set(T.URI.file($).fsPath,H))});this._extensionPathIndex=Promise.all(B).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return B;const H=this._activator.getActivatedExtension(x);if(!H)return B;try{typeof H.module.deactivate=="function"&&(B=Promise.resolve(H.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,S.dispose)(H.subscriptions)}catch($){this._logService.error($)}return B}async _activateExtension(x,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,B).then(H=>{const $=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,B),this._logExtensionActivationTimes(x,B,"success",$),H},H=>{throw this._logExtensionActivationTimes(x,B,"failure"),H})}_logExtensionActivationTimes(x,B,H,$){const Y=z(x,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Y,...$||{},outcome:H})}_doActivateExtension(x,B){const H=z(x,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const $=this._getEntryPoint(x);if(!$)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const Y=new f.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,C.joinPath)(x.extensionLocation,$),Y),this._loadExtensionContext(x)]).then(Q=>(k.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Hn._callActivate(this._logService,x.identifier,Q[0],Q[1],Y))).then(Q=>(k.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Q))}_loadExtensionContext(x){const B=new m.ExtensionGlobalMemento(x,this._storage),H=new m.ExtensionMemento(x.identifier.value,!1,this._storage),$=new F.ExtensionSecrets(x,this._secretState),Y=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Q=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([B.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const de=this;let _e;return Object.freeze({globalState:B,workspaceState:H,secrets:$,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Ce){return L.join(x.extensionLocation.fsPath,Ce)},get storagePath(){return de._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return de._storagePath.globalValue(x).fsPath},get logPath(){return L.join(de._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return T.URI.joinPath(de._initData.logsLocation,x.identifier.value)},get storageUri(){return de._storagePath.workspaceValue(x)},get globalStorageUri(){return de._storagePath.globalValue(x)},get extensionMode(){return Y},get extension(){return _e===void 0&&(_e=new O(de,x.identifier,x,Q)),_e},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(x),de.extensionRuntime},get environmentVariableCollection(){return de._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,B,H,$,Y){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,B,H,$,Y).then(Q=>new f.ActivatedExtension(!1,null,Y.build(),H,Q,$.subscriptions))}static _callActivateOptional(x,B,H,$,Y){if(typeof H.activate=="function")try{Y.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${B.value}`);const Q=typeof global=="object"?global:self,de=H.activate.apply(Q,[$]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(de).then(_e=>(Y.activateResolveStop(),_e))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(H)}_activateOneStartupFinished(x,B){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:B}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const B of x.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(x,B)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,Y=>{this._logService.error(Y)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Y=>this._handleWorkspaceContainsEagerExtensions(Y.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(B),$=Promise.all([x,H]).then(()=>{});return Promise.race([$,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(x,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,B){if(this.isActivated(B.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:x.map(Q=>Q.uri),forceUsingSearch:H,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,de,_e)=>this._mainThreadWorkspaceProxy.$checkExists(Q,de,_e)},Y=await(0,P.checkActivateWorkspaceContainsExtension)($,B);if(!!Y)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Y.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:B}=this._initData.environment;if(!x||!B)throw new Error(g.localize(0,null));const H=await this._loadCommonJSModule(null,B,new f.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(g.localize(1,null,B.toString()));return new Promise(($,Y)=>{const Q=(Ce,Te)=>{Ce?Y(Ce):$(typeof Te=="number"&&Te>0?1:0)},de=(0,C.originalFSPath)(B),_e=H.run(de,Q);_e&&_e.then&&_e.then(()=>{$(0)}).catch(Ce=>{Y(Ce.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,B){return this._resolvers[x]=B,(0,S.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const B=x.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const H=x.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(x,B){const{authorityPrefix:H,resolver:$}=await this._activateAndGetResolver(x);if(!$)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),k.mark(`code/extHost/willResolveAuthority/${H}`);const Y=await $.resolve(x,{resolveAttempt:B});k.mark(`code/extHost/didResolveAuthorityOK/${H}`);const Q={authority:x,host:Y.host,port:Y.port,connectionToken:Y.connectionToken},de={extensionHostEnv:Y.extensionHostEnv,isTrusted:Y.isTrusted};return{type:"ok",value:{authority:Q,options:de,tunnelInformation:{environmentTunnels:Y.environmentTunnels}}}}catch(Y){if(k.mark(`code/extHost/didResolveAuthorityError/${H}`),Y instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Y._code,message:Y._message,detail:Y._detail}};throw Y}}async $getCanonicalURI(x,B){const{authorityPrefix:H,resolver:$}=await this._activateAndGetResolver(x);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const Y=T.URI.revive(B);if(typeof $.getCanonicalURI=="undefined")return Y;const Q=await(0,A.asPromise)(()=>$.getCanonicalURI(Y));return Q||Y}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,B){return B===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(x,!1))}async $activate(x,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,B),!0):!1}async $deltaExtensions(x,B){x.forEach($=>$.extensionLocation=T.URI.revive($.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(B.map(async $=>{const Y=this._registry.getExtensionDescription($);if(!Y)return;const Q=await this._hostUtils.realpath(Y.extensionLocation.fsPath);H.delete(T.URI.file(Q).fsPath)})),await Promise.all(x.map(async $=>{const Y=await this._hostUtils.realpath($.extensionLocation.fsPath);H.set(T.URI.file(Y).fsPath,$)})),this._registry.deltaExtensions(x,B),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let B=o.VSBuffer.alloc(x),H=Math.random()%256;for(let $=0;$<x;$++)B.writeUInt8(H,$);return B}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};U=Ge([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,l.IExtHostRpcService),We(3,p.IExtHostWorkspace),We(4,c.IExtHostConfiguration),We(5,n.ILogService),We(6,i.IExtHostInitDataService),We(7,s.IExtensionStoragePaths),We(8,w.IExtHostTunnelService),We(9,_.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function z(N,x){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class O{constructor(x,B,H,$){M.set(this,void 0),q.set(this,void 0),G.set(this,void 0),it(this,M,x,"f"),it(this,q,B,"f"),it(this,G,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=$}get isActive(){return Oe(this,M,"f").isActivated(Oe(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,M,"f").getExtensionExports(Oe(this,G,"f"))}activate(){return Oe(this,M,"f").activateByIdWithErrors(Oe(this,G,"f"),{startup:!1,extensionId:Oe(this,q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=O,M=new WeakMap,q=new WeakMap,G=new WeakMap}),define(fe[56],me([0,1,8,2,3,18,5,7,124,36,41,45,216,37,210,14,4,12,38,54]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let o=class{constructor(h,w,_,v,P,b){this._workspaceService=w,this._extensionService=_,this._editorsService=v,this._configurationService=P,this._editorTabs=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=h.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(M=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,w){const _=h;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let v=`debug:${encodeURIComponent(_.path||"")}`,P="?";return w&&(v+=`${P}session=${encodeURIComponent(w.id)}`,P="&"),v+=`${P}ref=${_.sourceReference}`,L.URI.parse(v)}else{if(_.path)return L.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const w=[];for(const _ of h.getAllExtensionDescriptions())if(_.contributes){const v=_.contributes.debuggers;if(v&&v.length>0)for(const P of v)(0,d.isDebuggerMainContribution)(P)&&w.push(P.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(w=>h.push(w)),h}addBreakpoints(h){this.startBreakpoints();const w=h.filter(P=>{const b=P.id;return this._breakpoints.has(b)?!1:(this._breakpoints.set(b,P),!0)});this.fireBreakpointChanges(w,[],[]);const _=[],v=new Map;for(const P of w)if(P instanceof S.SourceBreakpoint){let b=v.get(P.location.uri.toString());b||(b={type:"sourceMulti",uri:P.location.uri,lines:[]},v.set(P.location.uri.toString(),b),_.push(b)),b.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof S.FunctionBreakpoint&&_.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(h){this.startBreakpoints();const w=h.filter(b=>this._breakpoints.delete(b.id));this.fireBreakpointChanges([],w,[]);const _=w.filter(b=>b instanceof S.SourceBreakpoint).map(b=>b.id),v=w.filter(b=>b instanceof S.FunctionBreakpoint).map(b=>b.id),P=w.filter(b=>b instanceof S.DataBreakpoint).map(b=>b.id);return this._debugServiceProxy.$unregisterBreakpoints(_,v,P)}startDebugging(h,w,_){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,w,{parentSessionID:_.parentSession?_.parentSession.id:void 0,lifecycleManagedByParent:_.lifecycleManagedByParent,repl:_.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact,debugUI:_.debugUI,suppressSaveBeforeStart:_.suppressSaveBeforeStart})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,w,_){if(!w)return new S.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:v,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,_,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,v),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(h,w,_){if(!_)return new S.Disposable(()=>{});if(!this.definesDebugType(h,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:v,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,v),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(h,w){if(!w)return new S.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:_,factory:w}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==w)})}async $runInTerminal(h,w){return Promise.resolve(void 0)}async $substituteVariables(h,w){if(!this._variableResolver){const[P,b]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,b)}let _;const v=await this.getFolder(h);return v&&(_={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,w)}createDebugAdapter(h,w){if(h.type==="implementation")return new i(h.implementation)}createSignService(){}async $startDASession(h,w){const _=this,v=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const b=this.convertToDto(P),F=this.createDebugAdapter(b,v);if(!F)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const M=F;return this._debugAdapters.set(h,M),this.getDebugAdapterTrackers(v).then(q=>(q&&this._debugAdaptersTrackers.set(h,q),M.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const U=G,z={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(U.arguments.value);z.body={signature:O},M.sendResponse(z)}else throw new Error("no signer")}catch(O){z.success=!1,z.message=O.message,M.sendResponse(z)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(G),G=(0,d.convertToVSCPaths)(G,!0),_._debugServiceProxy.$acceptDAMessage(h,G)}),M.onError(G=>{q&&q.onError&&q.onError(G),this._debugServiceProxy.$acceptDAError(h,G.name,G.message,G.stack)}),M.onExit(G=>{q&&q.onExit&&q.onExit((0,R.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,R.withNullAsUndefined)(G),void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),M.startSession()))})}$sendDAMessage(h,w){w=(0,d.convertToDAPaths)(w,!1);const _=this._debugAdaptersTrackers.get(h);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(w);const v=this._debugAdapters.get(h);v&&v.sendMessage(w)}$stopDASession(h){const w=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),w&&w.onWillStopSession&&w.onWillStopSession();const _=this._debugAdapters.get(h);return this._debugAdapters.delete(h),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const w=[],_=[],v=[];if(h.added)for(const P of h.added){const b=P.id;if(b&&!this._breakpoints.has(b)){let F;if(P.type==="function")F=new S.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")F=new S.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const M=L.URI.revive(P.uri);F=new S.SourceBreakpoint(new S.Location(M,new S.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}F._id=b,this._breakpoints.set(b,F),w.push(F)}}if(h.removed)for(const P of h.removed){const b=this._breakpoints.get(P);b&&(this._breakpoints.delete(P),_.push(b))}if(h.changed){for(const P of h.changed)if(P.id){const b=this._breakpoints.get(P.id);if(b){if(b instanceof S.FunctionBreakpoint&&P.type==="function"){const F=b;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.functionName=P.functionName}else if(b instanceof S.SourceBreakpoint&&P.type==="source"){const F=b;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.location=new S.Location(L.URI.revive(P.uri),new S.Position(P.line,P.character))}v.push(b)}}}this.fireBreakpointChanges(w,_,v)}$provideDebugConfigurations(h,w,_){return(0,C.asPromise)(async()=>{const v=this.getConfigProviderByHandle(h);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(w);return v.provideDebugConfigurations(P,_)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(h,w,_,v){return(0,C.asPromise)(async()=>{const P=this.getConfigProviderByHandle(h);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const b=await this.getFolder(w);return P.resolveDebugConfiguration(b,_,v)})}$resolveDebugConfigurationWithSubstitutedVariables(h,w,_,v){return(0,C.asPromise)(async()=>{const P=this.getConfigProviderByHandle(h);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const b=await this.getFolder(w);return P.resolveDebugConfigurationWithSubstitutedVariables(b,_,v)})}async $provideDebugAdapter(h,w){const _=this.getAdapterDescriptorFactoryByHandle(h);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(w);return this.getAdapterDescriptor(_,v).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(h){const w=await this.getSession(h);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(h){const w=await this.getSession(h);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,w){const _=await this.getSession(h);_&&_._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(h,w){const v={session:await this.getSession(h),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(h){if(h instanceof S.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof S.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const w=this._adapterFactories.filter(_=>_.type===h);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(h){const w=this._adapterFactories.filter(_=>_.handle===h);if(w.length>0)return w[0].factory}getConfigProviderByHandle(h){const w=this._configProviders.filter(_=>_.handle===h);if(w.length>0)return w[0].provider}definesDebugType(h,w){if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0){for(const v of _)if(v.label&&v.type&&v.type===w)return!0}}return!1}getDebugAdapterTrackers(h){const _=h.configuration.type,v=this._trackerFactories.filter(P=>P.type===_||P.type==="*").map(P=>(0,C.asPromise)(()=>P.factory.createDebugAdapterTracker(h)).then(b=>b,b=>null));return Promise.race([Promise.all(v).then(P=>{const b=P.filter(F=>!!F);if(b.length>0)return new r(b)}),new Promise((P,b)=>{const F=setTimeout(()=>{clearTimeout(F),b(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(h,w){const _=w.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new S.DebugAdapterServer(_));if(h){const P=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>h.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,P))).then(b=>{if(b)return b})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,v))}daExecutableFromPackage(h,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,w,_){(h.length>0||w.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:w,changed:_}))}async getSession(h){if(h)if(typeof h=="string"){const w=this._debugSessions.get(h);if(w)return w}else{let w=this._debugSessions.get(h.id);if(!w){const _=await this.getFolder(h.folderUri),v=h.parent?this._debugSessions.get(h.parent):void 0;w=new m(this._debugServiceProxy,h.id,h.type,h.name,_,h.configuration,v),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(h){if(h){const w=L.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};o=Ge([We(0,p.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,a.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class m{constructor(h,w,_,v,P,b,F){this._debugServiceProxy=h,this._id=w,this._type=_,this._name=v,this._workspaceFolder=P,this._configuration=b,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,w)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=m;class t{constructor(h){this.value=Object.freeze({append(w){h.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class u extends c.AbstractVariableResolverService{constructor(h,w,_,v,P){function b(){if(w){const F=w.activeEditor();if(F)return F.document.uri;const M=v.tabs.filter(q=>q.isActive);if(M.length>0){const q=M[0].resource;return q&&(q.primary||q.secondary)?q.primary??q.secondary:M[0].resource}}}super({getFolderUri:F=>{const M=h.filter(q=>q.name===F);if(M&&M.length>0)return M[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(F,M)=>_.getConfiguration(void 0,F).get(M),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=b();if(F)return g.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const F=b();if(F){const M=P.getWorkspaceFolder(F);if(M)return g.normalize(M.uri.fsPath)}}},getSelectedText:()=>{if(w){const F=w.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(w){const F=w.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=u;class r{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(w=>w.onError?w.onError(h):void 0)}onExit(h,w){this.trackers.forEach(_=>_.onExit?_.onExit(h,w):void 0)}}class i extends y.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(h,w,_,v,P,b){super(h,w,_,v,P,b)}createVariableResolver(h,w,_){return new u(h,w,_,this._editorTabs)}};s=Ge([We(0,p.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,a.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(fe[270],me([0,1,73,2,5,37,35,26,14,27,4,41,38,13]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(a,o,m,t,u,r,i){this._apiFactory=a,this._extensionRegistry=o,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=u,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,o,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(D)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(R,o,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let o of a.nodeModuleName)this._factories.set(o,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(o=>a.alternativeModuleName(o))}};d=Ge([We(2,n.IInstantiationService),We(3,C.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,T.IExtHostInitDataService),We(6,f.ILogService)],d),e.RequireInterceptor=d;class p{constructor(a,o,m,t,u){this._apiFactory=a,this._extensionPaths=o,this._extensionRegistry=m,this._configProvider=t,this._logService=u,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,o){const m=this._extensionPaths.findSubstr(o.fsPath);if(m){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((u,r)=>t+=`	${r} -> ${u.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(a,o){this.nodeModuleName="keytar";const{environment:m}=o,t=a.getProxy(k.MainContext.MainThreadKeytar);if(m.appRoot){let u=m.appRoot.fsPath;c.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,r)=>t.$getPassword(u,r),setPassword:(u,r,i)=>t.$setPassword(u,r,i),deletePassword:(u,r)=>t.$deletePassword(u,r),findPassword:u=>t.$findPassword(u),findCredentials(u){return t.$findCredentials(u)}}}load(a,o){return this._impl}alternativeModuleName(a){const o=a.length;if(o<=7||!this.alternativeNames)return;const m=o-7;if((a.charAt(m)==="/"||a.charAt(m)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};D=Ge([We(0,y.IExtHostRpcService),We(1,T.IExtHostInitDataService)],D);let R=class{constructor(a,o,m){this._extensionPaths=a,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(k.MainContext.MainThreadTelemetry);const t=m.getProxy(k.MainContext.MainThreadWindow);this._impl=(u,r)=>{const i=L.URI.parse(u);return r?this.callOriginal(u,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,u,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,u,{}):this.callOriginal(u,r)}}load(a,o,m){const t=this._extensionPaths.findSubstr(o.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(a),this._impl}callOriginal(a,o){return this.sendNoForwardTelemetry(),this._original(a,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};R=Ge([We(2,y.IExtHostRpcService)],R)}),define(fe[271],me([0,1,171,11,7,211,36,41,45,37,33,14,56,195,18,212,54]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let R=class extends c.ExtHostDebugServiceBase{constructor(o,m,t,u,r,i,s){super(o,m,t,u,r,s);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(o,m){switch(o.type){case"server":return new C.SocketDebugAdapter(o);case"pipeServer":return new C.NamedPipeDebugAdapter(o);case"executable":return new C.ExecutableDebugAdapter(o,m.type)}return super.createDebugAdapter(o,m)}daExecutableFromPackage(o,m){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),o.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(o,m){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(b=>{this._integratedTerminalInstances.onTerminalClosed(b)}));const t=await this._configurationService.getConfigProvider(),u=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=o.title||g.localize(0,null),s=JSON.stringify({shell:u,shellArgs:r});let l=await this._integratedTerminalInstances.checkout(s,i),h,w=!1;if(l)h=o.cwd;else{const b={shellPath:u,shellArgs:r,cwd:o.cwd,name:i,iconPath:new k.ThemeIcon("debug")};w=!0,l=this._terminalService.createTerminalFromOptions(b,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,s)}l.show(!0);const _=await l.processId;w?await new Promise(b=>setTimeout(b,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?l.sendText("cls"):u.indexOf("bash")>=0?l.sendText("clear"):L.isWindows?l.sendText("cls"):l.sendText("clear"));const v=(0,p.prepareCommand)(u,o.args,h,o.env);l.sendText(v);const P=this.onDidTerminateDebugSession(b=>{b.id===m&&(this._integratedTerminalInstances.free(l),P.dispose())});return _}else if(o.kind==="external")return(0,p.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,m)}createVariableResolver(o,m,t){return new c.ExtHostVariableResolverService(o,m,t,this._editorTabs,this._workspaceService)}};R=Ge([We(0,I.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,S.IExtHostExtensionService),We(3,y.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,D.IExtHostEditorTabs)],R),e.ExtHostDebugService=R;class E{constructor(){this._terminalInstances=new Map}async checkout(o,m){const u=[...this._terminalInstances.entries()].map(([r,i])=>(0,d.createCancelablePromise)(async s=>{if(r.name!==m||i.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await r.processId))return null;const l=Date.now();return i.lastUsedAt+E.minUseDelay>l||s.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=l,r)}));return await(0,d.firstParallel)(u,r=>!!r)}insert(o,m){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:m})}free(o){const m=this._terminalInstances.get(o);m&&(m.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}E.minUseDelay=1e3}),define(fe[272],me([0,1,8,2,113,36,56,45,37,44,33,14,27,72,10,13,67,54,23,80]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends f.ExtHostTaskBase{constructor(t,u,r,i,s,l,h,w,_){super(t,u,r,i,s,l,h,w);this.workspaceService=r,this.editorTabs=_,u.remote.isRemote&&u.remote.authority?this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:u.remote.authority,platform:process.platform}):this.registerTaskSystem(d.Schemas.file,{scheme:d.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,u){const r=u;if(!u.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=f.TaskHandleDTO.from(r,this.workspaceService),s=await this._proxy.$getTaskExecution(i);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(s,u);return this._proxy.$executeTask(i).catch(()=>{}),l}else{const i=f.TaskDTO.from(u,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,u,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),u);return this._proxy.$executeTask(i).catch(()=>{}),s}}provideTasksInternal(t,u,r,i){const s=[];if(i)for(let l of i){this.checkDeprecation(l,r),(!l.definition||!t[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=f.TaskDTO.from(l,r.extension);h&&(s.push(h),f.CustomExecutionDTO.is(h.execution)&&u.push(this.addCustomExecution(h,l,!0)))}return{tasks:s,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const u=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(t,this._editorService,u,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let u=t&&t.length>0?t[0]:void 0;if(!u){const r=L.URI.file((0,a.homedir)());u=new T.WorkspaceFolder({uri:r,name:E.basename(r),index:0})}return{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,u){const r=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(r),l=await this._workspaceProvider.getWorkspaceFolders2()??[],h=await this.getVariableResolver(l),w=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(let _ of u.variables)i.variables[_]=await h.resolveAsync(w,_);if(u.process!==void 0){let _;if(u.process.path!==void 0){_=u.process.path.split(g.delimiter);for(let v=0;v<_.length;v++)_[v]=await h.resolveAsync(w,_[v])}i.process=await k.win32.findExecutable(await h.resolveAsync(w,u.process.name),u.process.cwd!==void 0?await h.resolveAsync(w,u.process.cwd):void 0,_)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,u,r){return k.win32.findExecutable(t,u,r)}};o=Ge([We(0,I.IExtHostRpcService),We(1,c.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,p.ILogService),We(7,D.IExtHostApiDeprecationService),We(8,R.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(fe[273],me([0,1,18,17,73,6,2,5,265,13,82,84,27,189,14,66,41,33]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(o,m,t,u){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(o,null,u),m=E._transform(m,this._rpcProtocol);const r=new I.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...m}),r.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),r.set(p.IURITransformerService,new p.URITransformerService(u)),r.set(D.IHostUtils,t);const i=new f.InstantiationService(r,!0),s=i.invokeFunction(_=>_.get(R.IExtHostTerminalService));this._disposables.add(s),this._logService=i.invokeFunction(_=>_.get(T.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=i.invokeFunction(_=>_.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(v,P)=>{let b="",F,M;for(const q of P)b+=`
	at ${q.toString()}`,M=q.getFileName(),!F&&M&&(F=_.findSubstr(M));return l.set(v,F),`${v.name||"Error"}: ${v.message||""}${b}`}});const h=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(_=>{const v=L.transformErrorForSerialization(_),P=l.get(_);P?h.$onExtensionRuntimeError(P.identifier,v):w.$onUnexpectedError(v)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,m){o.extensions.forEach(u=>u.extensionLocation=A.URI.revive(m.transformIncomingURIs(u.extensionLocation))),o.environment.appRoot=A.URI.revive(m.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(u=>A.URI.revive(m.transformIncomingURIs(u)))),o.environment.extensionTestsLocationURI=A.URI.revive(m.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=A.URI.revive(m.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=A.URI.revive(m.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=A.URI.revive(m.transformIncomingURIs(o.logsLocation)),o.logFile=A.URI.revive(m.transformIncomingURIs(o.logFile)),o.workspace=m.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=E}),define(fe[274],me([0,1,8,21,62,30,23,46,31]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(c,f,d){this.config=c,this.provider=f,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const f=this.config.folderQueries||[];return new Promise((d,p)=>{const D=R=>{this.resultCount++,c(R)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(R=>{const E=R.toString(),a=g.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,a)||this.matchFile(D,{base:R,basename:a})}),Promise.all(f.map(R=>this.searchInFolder(R,D))).then(R=>{d({limitHit:this.isLimitHit,stats:R[0]||void 0})},R=>{p(new Error((0,k.toErrorMessage)(R)))})})}async searchInFolder(c,f){const d=new L.CancellationTokenSource,p=this.getSearchOptionsForFolder(c),D=this.initDirectoryTree(),R=new y.QueryGlobTester(this.config,c),E=!R.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(d),a=S.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,d.token),m=a.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(u=>{const r=g.posix.relative(c.folder.path,u.path);if(E){const i=g.basename(u.path);this.matchFile(f,{base:c.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(D,c.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,R,f),{providerTime:m,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(c){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),d=(0,y.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:d,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},f,d,p){if(d===this.filePattern){const R=g.basename(this.filePattern);this.matchFile(p,{base:f,relativePath:this.filePattern,basename:R})}function D(R){const E=g.basename(R),a=g.dirname(R);let o=c[a];o||(o=c[a]=[],D(a)),o.push({base:f,relativePath:R,basename:E})}D(d)}matchDirectoryTree({rootEntries:c,pathToEntries:f},d,p){const D=this,R=this.filePattern;function E(a){const o=C.hasSiblingFn(()=>a.map(m=>m.basename));for(let m=0,t=a.length;m<t;m++){const u=a[m],{relativePath:r,basename:i}=u;if(!d.includedInQuerySync(r,i,R!==i?o:void 0))continue;const s=f[r];if(s)E(s);else{if(r===R)continue;D.matchFile(p,u)}if(D.isLimitHit)break}}E(c)}matchFile(c,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(f))}}class n{constructor(){this.sessions=new Map}fileSearch(c,f,d,p){const D=this.getSessionTokenSource(c.cacheKey),R=new T(c,f,D&&D.token);let E=0;const a=o=>{E+=o.length,d(o.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(R,n.BATCH_SIZE,a,p).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:o.stats}}))}clearCache(c){const f=this.getSessionTokenSource(c);f&&f.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:A.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,f,d,p){p.onCancellationRequested(()=>{c.cancel()});const D=E=>{E&&(R.push(E),f>0&&R.length>=f&&(d(R),R=[]))};let R=[];return c.search(D).then(E=>(R.length&&d(R),E),E=>(R.length&&d(R),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(fe[133],me([0,1,16,21,62,30,10,8,23,12,2,31]),function(J,e,g,L,k,C,A,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(a,o,m,t){this.query=a,this.provider=o,this.fileUtils=m,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,o){const m=this.query.folderQueries||[],t=new L.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((u,r)=>{this.collector=new d(a);let i=!1;const s=(l,h)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(l);D(l)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const _=this.resultSize(l);this.resultCount+=_,(_>0||!D(l))&&this.collector.add(l,h)}};Promise.all(m.map((l,h)=>this.searchInFolder(l,w=>s(w,h),t.token))).then(l=>{t.dispose(),this.collector.flush();const h=l.some(w=>!!w&&!!w.limitHit);u({limitHit:this.isLimitHit||h,messages:(0,g.flatten)(l.map(w=>w?.message?(0,T.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},l=>{t.dispose();const h=(0,k.toErrorMessage)(l);r(new Error(h))})})}resultSize(a){return D(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,o){const m=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:m.slice(0,o),preview:{matches:t.slice(0,o),text:a.preview.text},uri:a.uri}}async searchInFolder(a,o,m){const t=new I.QueryGlobTester(this.query,a),u=[],r={report:l=>{if(!this.validateProviderResult(l))return;const h=a.folder.scheme===A.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(l.uri))):void 0,w=y.relativePath(a.folder,l.uri);if(w){const _=t.includedInQuery(w,S.basename(w),h);(0,T.isPromise)(_)?u.push(_.then(v=>{v&&o(l)})):_&&o(l)}}},i=this.getSearchOptionsForFolder(a),s=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,m);return u.length&&await Promise.all(u),s}validateProviderResult(a){if(D(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const o=(0,I.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),m=(0,I.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:n.URI.from(a.folder),excludes:m,includes:o,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class d{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new R(512,o=>this.sendItems(o))}add(a,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!y.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(p(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=d;function p(E){return D(E)?{preview:{matches:(0,g.mapArrayOrNot)(E.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:E.preview.text},ranges:(0,g.mapArrayOrNot)(E.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function D(E){return!!E.preview}e.extensionResultIsMatch=D;class R{constructor(a,o){this.maxBatchSize=a,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,o){!a||this.addItemToBatch(a,o)}addItems(a,o){!a||this.addItemsToBatch(a,o)}addItemToBatch(a,o){this.batch.push(a),this.batchSize+=o,this.onUpdate()}addItemsToBatch(a,o){this.batch=this.batch.concat(a),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<R.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},R.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=R,R.TIMEOUT=4e3,R.START_BATCH_AFTER_COUNT=50}),define(fe[74],me([0,1,6,5,4,274,14,66,13,2,133]),function(J,e,g,L,k,C,A,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let I=class{constructor(p,D,R){this.extHostRpc=p,this._uriTransformer=D,this._logService=R,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,D){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const R=this._handlePool++;return this._textSearchProvider.set(R,D),this._proxy.$registerTextSearchProvider(R,this._transformScheme(p)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}registerFileSearchProvider(p,D){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const R=this._handlePool++;return this._fileSearchProvider.set(R,D),this._proxy.$registerFileSearchProvider(R,this._transformScheme(p)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}$provideFileSearchResults(p,D,R,E){const a=c(R),o=this._fileSearchProvider.get(p);if(o)return this._fileSearchManager.fileSearch(a,o,m=>{this._proxy.$handleFileMatch(p,D,m.map(t=>t.resource))},E);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,D,R,E){const a=this._textSearchProvider.get(p);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const o=c(R);return this.createTextSearchManager(o,a).search(t=>this._proxy.$handleTextMatch(p,D,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(p,D){return new n.TextSearchManager(p,D,{readdir:R=>Promise.resolve([]),toCanonicalName:R=>R},"textSearchProvider")}};I=Ge([We(0,A.IExtHostRpcService),We(1,S.IURITransformerService),We(2,y.ILogService)],I),e.ExtHostSearch=I;function c(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(f),extraFileResources:d.extraFileResources&&d.extraFileResources.map(p=>T.URI.revive(p))}}e.reviveQuery=c;function f(d){return{...d,folder:T.URI.revive(d.folder)}}}),define(fe[275],me([0,1,21,17,3,49,2,114,109,147,81,43,5,233,232,40,234,37,235,236,237,218,238,45,41,239,219,242,243,244,68,221,249,250,251,92,33,253,222,15,7,256,70,132,36,35,58,207,241,86,131,72,56,74,13,66,14,27,245,204,53,67,230,254,203,69,91,259,257,258,231,52,252,255,90,54,122,247,71,248,10,191,246,201,240]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a,o,m,t,u,r,i,s,l,h,w,_,v,P,b,F,M,q,G,U,z,O,N,x,B,H,$,Y,Q,de,_e,Ce,Te,$e,Be,He,j,ee,se,le,Z,ae,ve,Me,qe,Ye,Ze,ke,at,X,te,ge,je,tt,lt,ft,wt,Ct,ce,Pe,xe,Xe,ze,ot,Ae,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(ne){const ue=ne.get(se.IExtHostInitDataService),Ee=ne.get(je.IExtHostFileSystemInfo),we=ne.get(ke.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ke=ne.get(H.IExtHostWorkspace),Ve=ne.get(Ct.IExtHostTelemetry),Je=ne.get(R.IExtHostConfiguration),rt=ne.get(j.IURITransformerService),Ue=ne.get(ee.IExtHostRpcService),pe=ne.get(M.IExtHostStorage),be=ne.get(Ze.IExtensionStoragePaths),ie=ne.get(He.ILogService),K=ne.get(ae.IExtHostTunnelService),Se=ne.get(ve.IExtHostApiDeprecationService),Le=ne.get(B.IExtHostWindow),nt=ne.get(ft.IExtHostSecretState),Qe=ne.get(wt.IExtHostEditorTabs);Ue.set(c.ExtHostContext.ExtHostFileSystemInfo,Ee),Ue.set(c.ExtHostContext.ExtHostLogService,ie),Ue.set(c.ExtHostContext.ExtHostWorkspace,Ke),Ue.set(c.ExtHostContext.ExtHostConfiguration,Je),Ue.set(c.ExtHostContext.ExtHostExtensionService,Fe),Ue.set(c.ExtHostContext.ExtHostStorage,pe),Ue.set(c.ExtHostContext.ExtHostTunnelService,K),Ue.set(c.ExtHostContext.ExtHostWindow,Le),Ue.set(c.ExtHostContext.ExtHostSecretState,nt),Ue.set(c.ExtHostContext.ExtHostTelemetry,Ve),Ue.set(c.ExtHostContext.ExtHostEditorTabs,Qe);const gt=Ue.set(c.ExtHostContext.ExtHostDecorations,ne.get(Ce.IExtHostDecorations)),bt=Ue.set(c.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(u.IExtHostDocumentsAndEditors)),ht=Ue.set(c.ExtHostContext.ExtHostCommands,ne.get(p.IExtHostCommands)),pt=Ue.set(c.ExtHostContext.ExtHostTerminalService,ne.get(q.IExtHostTerminalService)),ut=Ue.set(c.ExtHostContext.ExtHostDebugService,ne.get($e.IExtHostDebugService)),yt=Ue.set(c.ExtHostContext.ExtHostSearch,ne.get(Be.IExtHostSearch)),Dt=Ue.set(c.ExtHostContext.ExtHostTask,ne.get(Te.IExtHostTask)),xt=Ue.set(c.ExtHostContext.ExtHostOutputService,ne.get(_.IExtHostOutputService)),$t=Ue.set(c.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(Ue)),Pt=Ue.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Ue,bt)),Wt=Ue.set(c.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(Ue,bt,ie)),en=Ue.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(ie,Pt,Ue.getProxy(c.MainContext.MainThreadBulkEdits))),Et=Ue.set(c.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(Ue,ht,bt,Pt,be)),Qt=Ue.set(c.ExtHostContext.ExtHostNotebookDocuments,new Ae.ExtHostNotebookDocuments(ie,Et)),jt=Ue.set(c.ExtHostContext.ExtHostNotebookEditors,new ot.ExtHostNotebookEditors(ie,Ue,Et)),tn=Ue.set(c.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(Ue,ue,Et,ht,ie)),nn=Ue.set(c.ExtHostContext.ExtHostNotebookRenderers,new xe.ExtHostNotebookRenderers(Ue,Et)),Tt=Ue.set(c.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(Ue,bt)),Xt=Ue.set(c.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Ue.getProxy(c.MainContext.MainThreadTreeViews),ht,ie)),bn=Ue.set(c.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Ue.getProxy(c.MainContext.MainThreadEditorInsets),Tt,ue)),Ht=Ue.set(c.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ue,ie,Ee)),zt=Ue.set(c.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ue,Pt,ht.converter,rt)),vt=Ue.set(c.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Ue,rt,Pt,ht,Ht,ie,Se)),rn=Ue.set(c.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Ue,vt)),Ot=Ue.set(c.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(Ue,ie,bt)),Nt=Ue.set(c.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(Ue,Ke,ht)),Yt=Ue.set(c.ExtHostContext.ExtHostSCM,new b.ExtHostSCM(Ue,ht,ie)),En=Ue.set(c.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(Ue,ht,Pt)),fn=Ue.set(c.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(Ue.getProxy(c.MainContext.MainThreadProgress))),_n=Ue.set(c.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(Ue)),mn=Ue.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ue)),sn=Ue.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(Ue)),on=Ue.set(c.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(Ue,ht)),qt=Ue.set(c.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Ue,{remote:ue.remote},Ke,ie,Se)),an=Ue.set(c.ExtHostContext.ExtHostWebviewPanels,new te.ExtHostWebviewPanels(Ue,qt,Ke)),Sn=Ue.set(c.ExtHostContext.ExtHostCustomEditors,new X.ExtHostCustomEditors(Ue,Pt,be,qt,an)),yn=Ue.set(c.ExtHostContext.ExtHostWebviewViews,new at.ExtHostWebviewViews(Ue,qt)),Gt=Ue.set(c.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(Ue,ht)),Jt=Ue.set(c.ExtHostContext.ExtHostUriOpeners,new lt.ExtHostUriOpeners(Ue));Ue.set(c.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Ue,Et,bt,ht));const Dn=(0,Y.values)(c.ExtHostContext);Ue.assertRegistered(Dn);const Cn=new ge.ExtHostBulkEdits(Ue,bt),ln=new d.ExtHostClipboard(Ue),cn=new w.ExtHostMessageService(Ue,ie),Vt=new a.ExtHostDialogs(Ue),Ft=new F.ExtHostStatusBar(Ue,ht.converter);return f.ExtHostApiCommands.register(ht),function(Ne,Rt,Kt){const _t=function(){let re=!Ne.isUnderDevelopment;function he(Re){re||(ie.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(ct){if(Array.isArray(ct))ct.forEach(Re);else if(typeof ct=="string")he(ct);else{const St=ct;typeof St.scheme=="undefined"&&he(ct),!Ne.enableProposedApi&&typeof St.exclusive=="boolean"&&(0,$.throwProposedApiError)(Ne)}return ct}}(),kn={getSession(re,he,Re){return Re?.forceNewSession&&(0,$.checkProposedApiEnabled)(Ne),sn.getSession(Ne,re,he,Re)},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,ct){return sn.registerAuthenticationProvider(re,he,Re,ct)}},In={registerCommand(re,he,Re){return ht.registerCommand(!0,re,he,Re)},registerTextEditorCommand(re,he,Re){return ht.registerCommand(!0,re,(...ct)=>{const St=Tt.getActiveTextEditor();if(!St){ie.warn("Cannot execute "+re+" because there is no active text editor.");return}return St.edit(It=>{he.apply(Re,[St,It,...ct])}).then(It=>{It||ie.warn("Edits from command "+re+" were not applied.")},It=>{ie.warn("An error occurred while running command "+re,It)})})},registerDiffInformationCommand:(re,he,Re)=>((0,$.checkProposedApiEnabled)(Ne),ht.registerCommand(!0,re,async(...ct)=>{const St=bt.activeEditor(!0);if(!St){ie.warn("Cannot execute "+re+" because there is no active text editor.");return}const It=await Tt.getDiffInformation(St.id);he.apply(Re,[It,...ct])})),executeCommand(re,...he){return ht.executeCommand(re,...he)},getCommands(re=!1){return ht.getCommands(re)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return pt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ve.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ve.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,he){return Le.openUri(re,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ue.environment.appUriScheme)return $t.createAppUri(re);try{return await Le.asExternalUri(re,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,ze.matchesScheme)(re,Xe.Schemas.http)||(0,ze.matchesScheme)(re,Xe.Schemas.https))return re;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,$.checkProposedApiEnabled)(Ne),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Pn={createTestController(re,he){return Gt.createTestController(re,he)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Ne),Gt.createTestObserver()},runTests(re){return(0,$.checkProposedApiEnabled)(Ne),Gt.runTests(re)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Ne),Gt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Ne),Gt.results}},Tn={getExtension(re){const he=Rt.getExtensionDescription(re);if(he)return new r.Extension(Fe,Ne.identifier,he,pn)},get all(){return Rt.getAllExtensionDescriptions().map(re=>new r.Extension(Fe,Ne.identifier,re,pn))},get onDidChange(){return Rt.onDidChange}},un={createDiagnosticCollection(re){return Ht.createDiagnosticCollection(Ne.identifier,re)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:re=>Ht.getDiagnostics(re),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(re,he){return zt.changeLanguage(re.uri,he)},match(re,he){return(0,n.score)(z.LanguageSelector.from(re),he.uri,he.languageId,!0)},registerCodeActionsProvider(re,he,Re){return vt.registerCodeActionProvider(Ne,_t(re),he,Re)},registerCodeLensProvider(re,he){return vt.registerCodeLensProvider(Ne,_t(re),he)},registerDefinitionProvider(re,he){return vt.registerDefinitionProvider(Ne,_t(re),he)},registerDeclarationProvider(re,he){return vt.registerDeclarationProvider(Ne,_t(re),he)},registerImplementationProvider(re,he){return vt.registerImplementationProvider(Ne,_t(re),he)},registerTypeDefinitionProvider(re,he){return vt.registerTypeDefinitionProvider(Ne,_t(re),he)},registerHoverProvider(re,he){return vt.registerHoverProvider(Ne,_t(re),he,Ne.identifier)},registerEvaluatableExpressionProvider(re,he){return vt.registerEvaluatableExpressionProvider(Ne,_t(re),he,Ne.identifier)},registerInlineValuesProvider(re,he){return vt.registerInlineValuesProvider(Ne,_t(re),he,Ne.identifier)},registerDocumentHighlightProvider(re,he){return vt.registerDocumentHighlightProvider(Ne,_t(re),he)},registerLinkedEditingRangeProvider(re,he){return vt.registerLinkedEditingRangeProvider(Ne,_t(re),he)},registerReferenceProvider(re,he){return vt.registerReferenceProvider(Ne,_t(re),he)},registerRenameProvider(re,he){return vt.registerRenameProvider(Ne,_t(re),he)},registerDocumentSymbolProvider(re,he,Re){return vt.registerDocumentSymbolProvider(Ne,_t(re),he,Re)},registerWorkspaceSymbolProvider(re){return vt.registerWorkspaceSymbolProvider(Ne,re)},registerDocumentFormattingEditProvider(re,he){return vt.registerDocumentFormattingEditProvider(Ne,_t(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return vt.registerDocumentRangeFormattingEditProvider(Ne,_t(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...ct){return vt.registerOnTypeFormattingEditProvider(Ne,_t(re),he,[Re].concat(ct))},registerDocumentSemanticTokensProvider(re,he,Re){return vt.registerDocumentSemanticTokensProvider(Ne,_t(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return vt.registerDocumentRangeSemanticTokensProvider(Ne,_t(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...ct){return typeof Re=="object"?vt.registerSignatureHelpProvider(Ne,_t(re),he,Re):vt.registerSignatureHelpProvider(Ne,_t(re),he,typeof Re=="undefined"?[]:[Re,...ct])},registerCompletionItemProvider(re,he,...Re){return vt.registerCompletionItemProvider(Ne,_t(re),he,Re)},registerInlineCompletionItemProvider(re,he){return(0,$.checkProposedApiEnabled)(Ne),vt.registerInlineCompletionsProvider(Ne,_t(re),he)},registerDocumentLinkProvider(re,he){return vt.registerDocumentLinkProvider(Ne,_t(re),he)},registerColorProvider(re,he){return vt.registerColorProvider(Ne,_t(re),he)},registerFoldingRangeProvider(re,he){return vt.registerFoldingRangeProvider(Ne,_t(re),he)},registerSelectionRangeProvider(re,he){return vt.registerSelectionRangeProvider(Ne,re,he)},registerCallHierarchyProvider(re,he){return vt.registerCallHierarchyProvider(Ne,re,he)},registerTypeHierarchyProvider(re,he){return vt.registerTypeHierarchyProvider(Ne,re,he)},setLanguageConfiguration:(re,he)=>vt.setLanguageConfiguration(Ne,re,he),getTokenInformationAtPosition(re,he){return(0,$.checkProposedApiEnabled)(Ne),zt.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return(0,$.checkProposedApiEnabled)(Ne),vt.registerInlayHintsProvider(Ne,re,he)},createLanguageStatusItem(re,he){return(0,$.checkProposedApiEnabled)(Ne),zt.createLanguageStatusItem(Ne,re,he)}},An={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(re,he,Re){const ct=await(A.URI.isUri(re)?Promise.resolve(vn.openTextDocument(re)):Promise.resolve(re));return Tt.showTextDocument(ct,he,Re)},createTextEditorDecorationType(re){return Tt.createTextEditorDecorationType(Ne,re)},onDidChangeActiveTextEditor(re,he,Re){return Tt.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return Tt.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return Tt.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return Tt.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return Tt.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return Tt.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return pt.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return pt.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return pt.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidWriteTerminalData(re,he,Re)},get state(){return Le.state},onDidChangeWindowState(re,he,Re){return Le.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return cn.showMessage(Ne,C.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return cn.showMessage(Ne,C.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return cn.showMessage(Ne,C.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Nt.showQuickPick(re,!!Ne.enableProposedApi,he,Re)},showWorkspaceFolderPick(re){return Nt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Nt.showInput(re,he)},showOpenDialog(re){return Vt.showOpenDialog(re)},showSaveDialog(re){return Vt.showSaveDialog(re)},createStatusBarItem(re,he,Re){let ct,St,It;return typeof re=="string"?(ct=re,St=he,It=Re):(St=re,It=he),Ft.createStatusBarEntry(Ne,ct,St,It)},setStatusBarMessage(re,he){return Ft.setStatusBarMessage(re,he)},withScmProgress(re){return Se.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:O.ProgressLocation.SourceControl},(he,Re)=>re({report(ct){}}))},withProgress(re,he){return fn.withProgress(Ne,re,he)},createOutputChannel(re){return xt.createOutputChannel(re,Ne)},createWebviewPanel(re,he,Re,ct){return an.createWebviewPanel(Ne,re,he,Re,ct)},createWebviewTextEditorInset(re,he,Re,ct){return(0,$.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(re,he,Re,ct,Ne)},createTerminal(re,he,Re){return typeof re=="object"?("location"in re&&(0,$.checkProposedApiEnabled)(Ne),"pty"in re?pt.createExtensionTerminal(re):pt.createTerminalFromOptions(re)):pt.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return pt.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return pt.registerProfileProvider(Ne,re,he)},registerTreeDataProvider(re,he){return Xt.registerTreeDataProvider(re,he,Ne)},createTreeView(re,he){return Xt.createTreeView(re,he,Ne)},registerWebviewPanelSerializer:(re,he)=>an.registerWebviewPanelSerializer(Ne,re,he),registerCustomEditorProvider:(re,he,Re={})=>Sn.registerCustomEditorProvider(Ne,re,he,Re),registerFileDecorationProvider(re){return gt.registerFileDecorationProvider(re,Ne.identifier)},registerUriHandler(re){return $t.registerUriHandler(Ne.identifier,re)},createQuickPick(){return Nt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Nt.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return mn.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return yn.registerWebviewViewProvider(Ne,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Ne),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return(0,$.checkProposedApiEnabled)(Ne),Et.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,re,he,Re)},get tabs(){return(0,$.checkProposedApiEnabled)(Ne),Qe.tabs},get activeTab(){return(0,$.checkProposedApiEnabled)(Ne),Qe.activeTab},get onDidChangeTabs(){return(0,$.checkProposedApiEnabled)(Ne),Qe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,$.checkProposedApiEnabled)(Ne),Qe.onDidChangeActiveTab},getInlineCompletionItemController(re){return(0,$.checkProposedApiEnabled)(Ne),l.InlineCompletionController.get(re)}},vn={get rootPath(){return Se.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ke.getPath()},set rootPath(re){throw L.readonly()},getWorkspaceFolder(re){return Ke.getWorkspaceFolder(re)},get workspaceFolders(){return Ke.getWorkspaceFolders()},get name(){return Ke.name},set name(re){throw L.readonly()},get workspaceFile(){return Ke.workspaceFile},set workspaceFile(re){throw L.readonly()},updateWorkspaceFolders:(re,he,...Re)=>Ke.updateWorkspaceFolders(Ne,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return Ke.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>Ke.getRelativePath(re,he),findFiles:(re,he,Re,ct)=>Ke.findFiles(z.GlobPattern.from(re),z.GlobPattern.from(he),Re,Ne.identifier,ct),findTextInFiles:(re,he,Re,ct)=>{let St,It;return typeof he=="object"?(St=he,It=Re):(St={},It=he,ct=Re),Ke.findTextInFiles(re,St||{},It,Ne.identifier,ct)},saveAll:re=>Ke.saveAll(re),applyEdit(re){return Cn.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,he,Re,ct)=>Ot.createFileSystemWatcher(z.GlobPattern.from(re),he,Re,ct),get textDocuments(){return Pt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw L.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(A.URI.file(re));else if(A.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=Pt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ct=>Pt.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(re,he,Re)=>Pt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>Pt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>Pt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>Pt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>en.getOnWillSaveTextDocumentEvent(Ne)(re,he,Re),get notebookDocuments(){return Et.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(A.URI.isUri(re))Re=re,await Et.openNotebookDocument(re);else if(typeof re=="string")Re=A.URI.revive(await Et.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,ct){return Et.registerNotebookSerializer(Ne,re,he,Re,Ne.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(re,he,Re,ct)=>((0,$.checkProposedApiEnabled)(Ne),Et.registerNotebookContentProvider(Ne,re,he,Re,Ne.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(re,he,Re)=>Kt.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,Kt.getConfiguration(re,he,Ne)},registerTextDocumentContentProvider(re,he){return Wt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(Se.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Ne,re,he)),registerFileSystemProvider(re,he,Re){return rn.registerFileSystemProvider(Ne.identifier,re,he,Re)},get fs(){return we.value},registerFileSearchProvider:(re,he)=>((0,$.checkProposedApiEnabled)(Ne),yt.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,$.checkProposedApiEnabled)(Ne),yt.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,$.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,$.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>Ot.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>Ot.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>Ot.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>Ot.getOnWillCreateFileEvent(Ne)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>Ot.getOnWillDeleteFileEvent(Ne)(re,he,Re),onWillRenameFiles:(re,he,Re)=>Ot.getOnWillRenameFileEvent(Ne)(re,he,Re),openTunnel:re=>((0,$.checkProposedApiEnabled)(Ne),K.openTunnel(Ne,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,$.checkProposedApiEnabled)(Ne),K.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,$.checkProposedApiEnabled)(Ne),K.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,$.checkProposedApiEnabled)(Ne),K.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,$.checkProposedApiEnabled)(Ne),on.registerTimelineProvider(re,he,Ne.identifier,ht.converter)),get isTrusted(){return Ke.trusted},requestWorkspaceTrust:re=>((0,$.checkProposedApiEnabled)(Ne),Ke.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>Ke.onDidGrantWorkspaceTrust(re,he,Re)},Rn={get inputBox(){return Se.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Ne)},createSourceControl(re,he,Re){return Yt.createSourceControl(Ne,re,he,Re)}},Ln={createCommentController(re,he){return En.createCommentController(Ne,re,he)}},Fn={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(re,he,Re){return ut.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return ut.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return ut.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return ut.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return ut.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return ut.registerDebugConfigurationProvider(re,he,Re||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return ut.registerDebugAdapterDescriptorFactory(Ne,re,he)},registerDebugAdapterTrackerFactory(re,he){return ut.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ut.startDebugging(re,he,{parentSession:Re}):ut.startDebugging(re,he,Re||{})},stopDebugging(re){return ut.stopDebugging(re)},addBreakpoints(re){return ut.addBreakpoints(re)},removeBreakpoints(re){return ut.removeBreakpoints(re)},asDebugSourceUri(re,he){return ut.asDebugSourceUri(re,he)}},Mn={registerTaskProvider:(re,he)=>Dt.registerTaskProvider(Ne,re,he),fetchTasks:re=>Dt.fetchTasks(re),executeTask:re=>Dt.executeTask(Ne,re),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(re,he,Re)=>Dt.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>Dt.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>Dt.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>Dt.onDidEndTaskProcess(re,he,Re)},On={createNotebookController(re,he,Re,ct,St){return tn.createNotebookController(Ne,re,he,Re,ct,Ne.enableProposedApi?St:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>Et.registerNotebookCellStatusBarItemProvider(Ne,re,he),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(re){return(0,$.checkProposedApiEnabled)(Ne),jt.createNotebookEditorDecorationType(re)},createRendererMessaging(re){return nn.createRendererMessaging(Ne,re)},onDidChangeNotebookDocumentMetadata(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Qt.onDidChangeNotebookDocumentMetadata(re,he,Re)},onDidChangeNotebookCells(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeNotebookCells(re,he,Re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeNotebookCellExecutionState(re,he,Re)},onDidChangeCellOutputs(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeCellOutputs(re,he,Re)},onDidChangeCellMetadata(re,he,Re){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeCellMetadata(re,he,Re)},createConcatTextDocument(re,he){return(0,$.checkProposedApiEnabled)(Ne),new Ye.ExtHostNotebookConcatDocument(Et,Pt,re,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:un,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:vn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:T.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:c.UIKind,Uri:A.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:Pe.TextSearchCompleteMessageType,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ie}),define(fe[276],me([0,1,82,68,36,131,37,40,45,33,72,56,74,92,53,67,132,91,52,90,122,54]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,g.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,g.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,g.registerSingleton)(R.IExtHostConsumerFileSystem,R.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,g.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,g.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,g.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,g.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(fe[93],me([0,1,16,13,31,71]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function S(I,c,f,d){const p=(0,g.mapArrayOrNot)(f,y),D=new k.TextSearchMatch(c,p,d),R=D.preview.matches;return{ranges:(0,g.mapArrayOrNot)(p,T),uri:I,preview:{text:D.preview.text,matches:(0,g.mapArrayOrNot)(R,T)}}}e.createTextSearchResult=S;function y(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function T(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let n=class{constructor(c,f){this.prefix=c,this.logService=f}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};n=Ge([We(1,L.ILogService)],n),e.OutputChannel=n}),define(fe[277],me([0,1,96,22]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,A=512,S=512*8,y=512*128;class T{constructor(u){this.iconvLiteDecoder=u}static async create(u){let r;if(u!==e.UTF8)r=(await new Promise((s,l)=>{J(["iconv-lite-umd"],s,l)})).getDecoder(f(u));else{const i=new TextDecoder;r={write(s){return i.decode(s,{stream:!0})},end(){return i.decode()}}}return new T(r)}write(u){return this.iconvLiteDecoder.write(u)}end(){return this.iconvLiteDecoder.end()}}function n(t,u){const r=u.minBytesRequiredForDetection??u.guessEncoding?S:A;return new Promise((i,s)=>{const l=(0,g.newWriteableStream)(P=>P.join("")),h=[];let w=0,_;const v=async()=>{try{const P=await m({buffer:L.VSBuffer.concat(h),bytesRead:w},u.guessEncoding);P.encoding=await u.overwriteEncoding(P.encoding),_=await T.create(P.encoding);const b=_.write(L.VSBuffer.concat(h).buffer);l.write(b),h.length=0,w=0,i({stream:l,detected:P})}catch(P){s(P)}};(0,g.listenStream)(t,{onData:async P=>{_?l.write(_.write(P.buffer)):(h.push(P),w+=P.byteLength,w>=r&&(t.pause(),await v(),setTimeout(()=>t.resume())))},onError:P=>l.error(P),onEnd:async()=>{_||await v(),l.end(_?.end())}})})}e.toDecodeStream=n;async function I(t,u,r){const s=(await new Promise((w,_)=>{J(["iconv-lite-umd"],w,_)})).getEncoder(f(u),r);let l=!1,h=!1;return{read(){if(h)return null;const w=t.read();if(typeof w!="string"){if(h=!0,!l&&r?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const _=s.end();return _&&_.length>0?(l=!0,L.VSBuffer.wrap(_)):null}return l=!0,L.VSBuffer.wrap(s.write(w))}}}e.toEncodeReadable=I;async function c(t){return(await new Promise((r,i)=>{J(["iconv-lite-umd"],r,i)})).encodingExists(f(t))}e.encodingExists=c;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function d(t,u){if(!t||u<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const s=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const p=["ascii","utf-16","utf-32"];async function D(t){const u=await new Promise((h,w)=>{J(["jschardet"],h,w)}),r=t.slice(0,y),i=a(r.buffer),s=u.detect(i);if(!s||!s.encoding)return null;const l=s.encoding.toLowerCase();return 0<=p.indexOf(l)?null:E(s.encoding)}const R={ibm866:"cp866",big5:"cp950"};function E(t){const u=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return R[u]||u}function a(t){let u="";for(let r=0;r<t.length;r++)u+=String.fromCharCode(t[r]);return u}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const u=t.match(/windows(\d+)/);return u?"windows-"+u[1]:t}}e.toCanonicalName=o;function m({buffer:t,bytesRead:u},r){let i=d(t,u),s=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let l=!0,h=!0,w=!1;for(let _=0;_<u&&_<C;_++){const v=_%2==1,P=t.readUInt8(_)===0;if(P&&(w=!0),l&&(v&&!P||!v&&P)&&(l=!1),h&&(v&&P||!v&&!P)&&(h=!1),P&&!l&&!h)break}w&&(l?i=e.UTF16le:h?i=e.UTF16be:s=!0)}return r&&!s&&!i&&t?D(t.slice(0,u)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:s,encoding:i}}e.detectEncodingFromBuffer=m,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[134],me([0,1,277,28,133]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends k.TextSearchManager{constructor(S,y,T=L,n="searchProcess"){super(S,y,{readdir:I=>T.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},n)}}e.NativeTextSearchManager=C}),define(fe[278],me([0,1,279,294,295,2,296]),function(J,e,g,L,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function S(I,c,f,d,p,D){const R=D.environment.useHostProxy,E=typeof R=="boolean"?R:!D.remote.isRemote,a=(0,A.createProxyResolver)({resolveProxy:m=>I.resolveProxy(m),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(m,t,...u)=>{switch(m){case A.LogLevel.Trace:d.trace(t,...u);break;case A.LogLevel.Debug:d.debug(t,...u);break;case A.LogLevel.Info:d.info(t,...u);break;case A.LogLevel.Warning:d.warn(t,...u);break;case A.LogLevel.Error:d.error(t,...u);break;case A.LogLevel.Critical:d.critical(t,...u);break;case A.LogLevel.Off:break;default:r(m,t,u);break}function r(i,s,...l){d.error("Unknown log level",i),d.error(s,...l)}},getLogLevel:()=>d.getLevel(),proxyResolveTelemetry:m=>{p.$publicLog2("resolveProxy",m)},useHostProxy:E,env:process.env}),o=y(c,a);return n(f,o)}e.connectProxyResolver=S;function y(I,c){const f={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(p=>{f.config=I.getConfiguration("http").get("proxySupport")||"off"});const d={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(p=>{d.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,A.createHttpPatch)(g,c,{config:"off"},d,!0)),on:Object.assign({},g,(0,A.createHttpPatch)(g,c,{config:"on"},d,!0)),override:Object.assign({},g,(0,A.createHttpPatch)(g,c,{config:"override"},d,!0)),onRequest:Object.assign({},g,(0,A.createHttpPatch)(g,c,f,d,!0)),default:Object.assign(g,(0,A.createHttpPatch)(g,c,f,d,!1))},https:{off:Object.assign({},L,(0,A.createHttpPatch)(L,c,{config:"off"},d,!0)),on:Object.assign({},L,(0,A.createHttpPatch)(L,c,{config:"on"},d,!0)),override:Object.assign({},L,(0,A.createHttpPatch)(L,c,{config:"override"},d,!0)),onRequest:Object.assign({},L,(0,A.createHttpPatch)(L,c,f,d,!0)),default:Object.assign(L,(0,A.createHttpPatch)(L,c,f,d,!1))},tls:Object.assign(k,(0,A.createTlsPatch)(k))}}const T=new Map;function n(I,c){return I.getExtensionPathIndex().then(f=>{const d=J.__$__nodeRequire("module"),p=d._load;d._load=function(R,E,a){if(R==="tls")return c.tls;if(R!=="http"&&R!=="https")return p.apply(this,arguments);const o=c[R],m=f.findSubstr(C.URI.file(E.filename).fsPath);let t=T.get(m);if(t||T.set(m,t={}),!t[R]){let u=o.default;m&&m.enableProposedApi&&(u=o[m.proxySupport]||o.onRequest),t[R]={...u}}return t[R]}})}}),define(fe[280],me([0,1,39,8,78,29,11,9,93,281]),function(J,e,g,L,k,C,A,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(a,o,m,t){const u=c(a,o,m,t),r=o.folder.fsPath;return{cmd:g.spawn(n,u.args,{cwd:r}),rgDiskPath:n,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}e.spawnRipgrepCmd=I;function c(a,o,m,t){const u=["--files","--hidden","--case-sensitive"];d([o],m,!1).forEach(i=>{const s=(0,y.anchorGlob)(i);if(u.push("-g",s),A.isMacintosh){const l=(0,k.normalizeNFD)(s);l!==s&&u.push("-g",l)}});const r=f([o],t,void 0,!1);return r.globArgs.forEach(i=>{const s=`!${(0,y.anchorGlob)(i)}`;if(u.push("-g",s),A.isMacintosh){const l=(0,k.normalizeNFD)(s);l!==s&&u.push("-g",l)}}),o.disregardIgnoreFiles!==!1?u.push("--no-ignore"):u.push("--no-ignore-parent"),o.ignoreSymlinks||u.push("--follow"),a.exists&&u.push("--quiet"),u.push("--no-config"),o.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function f(a,o,m,t=!0){const u=[];let r={};return a.forEach(i=>{const s=Object.assign({},i.excludePattern||{},o||{}),l=p(s,t?i.folder.fsPath:void 0,m);u.push(...l.globArgs),l.siblingClauses&&(r=Object.assign(r,l.siblingClauses))}),{globArgs:u,siblingClauses:r}}e.foldersToRgExcludeGlobs=f;function d(a,o,m=!0){const t=[];return a.forEach(u=>{const r=Object.assign({},o||{},u.includePattern||{}),i=p(r,m?u.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=d;function p(a,o,m){const t=[],u={};return Object.keys(a).forEach(r=>{if(m&&m.has(r)||!r)return;const i=a[r];r=R(o?D(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(E(r))):i&&i.when&&(u[r]=i)}),{globArgs:t,siblingClauses:u}}function D(a,o){return L.isAbsolute(o)?o:L.join(a,o)}e.getAbsoluteGlob=D;function R(a){return a=S.rtrim(a,"\\"),S.rtrim(a,"/")}function E(a){return C.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=E}),define(fe[282],me([0,1,39,50,8,104,16,62,30,78,29,11,46,9,12,28,31,280,101]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(r=>r())});class o{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(s=>{const l=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),h=s.folder.fsPath;i.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==h).forEach(w=>{(0,n.isEqualOrParent)(w,h)&&(l[k.relative(h,w)]=!0)}),this.folderExcludePatterns.set(h,new t(l,h))})}cancel(){this.isCanceled=!0}walk(i,s,l,h,w){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);s.forEach(_=>{const v=k.basename(_.fsPath);this.globalExcludePattern&&this.globalExcludePattern(_.fsPath,v)||this.matchFile(l,{relativePath:_.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(i,(_,v)=>{this.call(this.cmdTraversal,this,_,l,h,P=>{if(P){const b=(0,S.toErrorMessage)(P);console.error(b),this.errors.push(b),v(P,void 0)}else v(null,void 0)})},(_,v)=>{this.fileWalkSW.stop();const P=_?A.coalesce(_)[0]:null;w(P,this.isLimitHit)})}parallel(i,s,l){const h=new Array(i.length),w=new Array(i.length);let _=!1,v=0;if(i.length===0)return l(null,[]);i.forEach((P,b)=>{s(P,(F,M)=>{if(F?(_=!0,h[b]=null,w[b]=F):(h[b]=M,w[b]=null),++v===i.length)return l(_?w:null,h)})})}call(i,s,...l){try{i.apply(s,l)}catch(h){l[l.length-1](h)}}cmdTraversal(i,s,l,h){const w=i.folder.fsPath,_=I.isMacintosh;let v;const P=()=>v&&v.kill();a.add(P);let b=O=>{a.delete(P),b=()=>{},h(O)},F="";const M=this.initDirectoryTree();let q;const G=(0,R.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=G.cmd,q=!Object.keys(G.siblingClauses).length;const U=G.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let z=`${G.rgDiskPath} ${U}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),l({message:z}),this.cmdResultCount=0,this.collectStdout(v,"utf8",l,(O,N,x)=>{if(O){b(O);return}if(this.isLimitHit){b();return}const H=(F+(_?T.normalizeNFC(N||""):N)).split(`
`);if(x){const $=H.length;H[$-1]=H[$-1].trim(),H[$-1]||H.pop()}else F=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,q){for(const $ of H)if(this.matchFile(s,{base:w,relativePath:$,searchPath:this.getSearchPath(i,$)}),this.isLimitHit){P();break}(x||this.isLimitHit)&&b();return}this.addDirectoryEntries(i,M,w,H,s),x&&(this.matchDirectoryTree(M,w,s),b())})}spawnFindCmd(i){const s=this.folderExcludePatterns.get(i.folder.fsPath),l=s.getBasenameTerms(),h=s.getPathTerms(),w=["-L","."];if(l.length||h.length){w.push("-not","(","(");for(const _ of l)w.push("-name",_),w.push("-o");for(const _ of h)w.push("-path",_),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:i.folder.fsPath})}readStdout(i,s,l){let h="";this.collectStdout(i,s,()=>{},(w,_,v)=>{if(w){l(w);return}h+=_,v&&l(null,h)})}collectStdout(i,s,l,h){let w=(P,b,F)=>{(P||F)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),h(P,b,F)},_=!1;i.stdout?(this.forwardData(i.stdout,s,w),i.stdout.once("data",()=>_=!0)):l({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):l({message:"stderr is null"}),i.on("error",P=>{w(P)}),i.on("close",P=>{let b;!_&&(b=this.decodeData(v,s))&&u(b)?w(new Error(`command failed with error code ${P}: ${this.decodeData(v,s)}`)):(this.exists&&P===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(i,s,l){const h=new C.StringDecoder(s);return i.on("data",w=>{l(null,h.write(w))}),h}collectData(i){const s=[];return i.on("data",l=>{s.push(l)}),s}decodeData(i,s){const l=new C.StringDecoder(s);return i.map(h=>l.write(h)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:s},l,h,w){h.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const _=v=>{const P=k.basename(v),b=k.dirname(v);let F=s[b];F||(F=s[b]=[],_(b)),F.push({base:l,relativePath:v,basename:P,searchPath:this.getSearchPath(i,v)})};h.forEach(_)}matchDirectoryTree({rootEntries:i,pathToEntries:s},l,h){const w=this,_=this.folderExcludePatterns.get(l),v=this.filePattern;function P(b){w.directoriesWalked++;const F=y.hasSiblingFn(()=>b.map(M=>M.basename));for(let M=0,q=b.length;M<q;M++){const G=b[M],{relativePath:U,basename:z}=G;if(_.test(U,z,v!==z?F:void 0))continue;const O=s[U];if(O)P(O);else{if(w.filesWalked++,U===v)continue;w.matchFile(h,G)}if(w.isLimitHit)break}}P(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,s,l,h,w){const _=i.folder,v=y.hasSiblingFn(()=>l);this.parallel(l,(P,b)=>{if(this.isCanceled||this.isLimitHit)return b(null);const F=s?[s,P].join(k.sep):P;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,P,this.config.filePattern!==P?v:void 0))return b(null);const M=[_.fsPath,F].join(k.sep);L.lstat(M,(q,G)=>{if(q||this.isCanceled||this.isLimitHit)return b(null);this.statLinkIfNeeded(M,G,(U,z)=>U||this.isCanceled||this.isLimitHit?b(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(M,G,(O,N)=>O||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?b(null):(this.walkedPaths[N]=!0,p.Promises.readdir(M).then(x=>{if(this.isCanceled||this.isLimitHit)return b(null);this.doWalk(i,F,x,h,B=>b(B||null))},x=>{b(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&d.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(h,{base:_.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),b(null,void 0)))})},P=>{const b=P&&A.coalesce(P);return w(b&&b.length>0?b[0]:void 0)})}matchFile(i,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,k.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(s))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,s,l){return s.isSymbolicLink()?L.stat(i,l):l(null,s)}realPathIfNeeded(i,s,l){return s.isSymbolicLink()?L.realpath(i,(h,w)=>h?l(h):l(null,w)):l(null,i)}getSearchPath(i,s){return i.folderName?k.join(i.folderName,s):s}}e.FileWalker=o;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new o(i)}search(i,s,l){this.walker.walk(this.folderQueries,this.extraFiles,i,s,(h,w)=>{l(h,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class t{constructor(i,s){this.expression=i,this.root=s,this.init(i)}init(i){let s,l;Object.keys(i).filter(h=>i[h]).forEach(h=>{k.isAbsolute(h)?(s=s||y.getEmptyExpression(),s[h]=i[h]):(l=l||y.getEmptyExpression(),l[h]=i[h])}),this.absoluteParsedExpr=s&&y.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=l&&y.parse(l,{trimForExclusions:!0})}test(i,s,l){return this.relativeParsedExpr&&this.relativeParsedExpr(i,s,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),s,l)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function u(r){const i=r.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return f.uppercaseFirstLetter(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=u}),define(fe[135],me([0,1,39,297,104,16,58,30,8,9,2,31,71,298,281,93]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=d.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class R{constructor(_){this.outputChannel=_}provideTextSearchResults(_,v,P,b){return this.outputChannel.appendLine(`provideTextSearchResults ${_.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((F,M)=>{b.onCancellationRequested(()=>B());const q=u(_,v),G=v.folder.fsPath,U=q.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${D} ${U}
 - cwd: ${G}`);let z=g.spawn(D,q,{cwd:G});z.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),M((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let O=!1;const N=new o(v.maxResults,G,v.previewOptions);N.on("result",de=>{O=!0,$="",P.report(de)});let x=!1;const B=()=>{x=!0,z&&z.kill(),N&&N.cancel()};let H=!1;N.on("hitLimit",()=>{H=!0,B()});let $="";z.stdout.on("data",de=>{N.handleData(de),O||($+=de)});let Y=!1;z.stdout.once("data",()=>Y=!0);let Q="";z.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),Q+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),x)F({limitHit:H});else{N.flush(),z=null;let de;Q&&!Y&&(de=E(Q))?M((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):F({limitHit:H})}})})}}e.RipgrepTextSearchEngine=R;function E(w){const _=w.split(`
`),v=_[0].trim();if(_.some(b=>b.startsWith("regex parse error")))return new I.SearchError(a(_),I.SearchErrorCode.regexParseError);const P=v.match(/grep config error: unknown encoding: (.*)/);if(P)return new I.SearchError(`Unknown encoding: ${P[1]}`,I.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new I.SearchError(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new I.SearchError(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(v,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function a(w){const _=["Regex parse error"],v=w.filter(P=>P.startsWith("PCRE2:"));if(v.length>=1){const P=v[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const b=P.split(":")[1];_.push(":"+b)}}return _.join("")}e.buildRegexParseError=a;class o extends L.EventEmitter{constructor(_,v,P){super();this.maxResults=_,this.rootFolder=v,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(_,v){return super.on(_,v),this}handleData(_){if(this.isDone)return;const v=typeof _=="string"?_:this.stringDecoder.write(_);this.handleDecodedData(v)}handleDecodedData(_){let v=_.indexOf(`
`);const P=this.remainder+_;if(v>=0)v+=this.remainder.length;else{this.remainder=P;return}let b=0;for(;v>=0;)this.handleLine(P.substring(b,v).trim()),b=v+1,v=P.indexOf(`
`,b);this.remainder=P.substring(b)}handleLine(_){if(this.isDone||!_)return;let v;try{v=JSON.parse(_)}catch(P){throw new Error(`malformed line from rg: ${_}`)}if(v.type==="match"){const P=m(v.data.path),b=n.URI.file(y.join(this.rootFolder,P)),F=this.createTextSearchMatch(v.data,b);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const P=m(v.data.path),b=n.URI.file(y.join(this.rootFolder,P));this.createTextSearchContext(v.data,b).forEach(M=>this.onResult(M))}}createTextSearchMatch(_,v){const P=_.line_number-1,b=m(_.lines),F=Buffer.from(b);let M=0,q=0,G=P;_.submatches.length===0&&_.submatches.push(b.length?{start:0,end:1,match:{text:b[0]}}:{start:0,end:0,match:{text:""}});const U=(0,C.coalesce)(_.submatches.map((z,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const N=m(z.match),x=F.slice(M,z.start).toString().length,B=q+x,H=t(N),$=G,Y=H.numLines+$,Q=H.numLines>0?H.lastLineLength:H.lastLineLength+B;return M=z.end,q=Q,G=Y,new c.Range($,B,Y,Q)}));return(0,p.createTextSearchResult)(v,b,U,this.previewOptions)}createTextSearchContext(_,v){const P=m(_.lines),b=_.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,M)=>({text:F,uri:v,lineNumber:b+M}))}onResult(_){this.emit("result",_)}}e.RipgrepParser=o;function m(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const _=/\n/g;let v=0,P=-1,b;for(;b=_.exec(w);)v++,P=b.index;const F=P>=0?w.length-P-1:w.length;return{numLines:v,lastLineLength:F}}function u(w,_){const v=["--hidden"];v.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:b}=(0,A.groupBy)(_.includes,M=>M.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(b&&b.length){const M=new Set;b.forEach(q=>{M.add(q)}),v.push("-g","!*"),M.forEach(q=>{r(q).map(p.anchorGlob).forEach(G=>{v.push("-g",G)})})}P&&P.length&&P.forEach(M=>{v.push("-g",M)}),_.excludes.map(p.anchorGlob).forEach(M=>v.push("-g",`!${M}`)),_.maxFileSize&&v.push("--max-filesize",_.maxFileSize+""),_.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),_.followSymlinks&&v.push("--follow"),_.encoding&&_.encoding!=="utf8"&&v.push("--encoding",_.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,T.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),_.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),w.isRegExp&&(w.pattern=i(w.pattern),v.push("--auto-hybrid-regex"));let F;if(w.isWordMatch){const q=(0,T.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",q)}else if(w.isRegExp){let M=l(w.pattern);M=h(M),v.push("--regexp",M)}else F=w.pattern,v.push("--fixed-strings");return v.push("--no-config"),_.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),w.isMultiline&&v.push("--multiline"),_.beforeContext&&v.push("--before-context",_.beforeContext+""),_.afterContext&&v.push("--after-context",_.afterContext+""),v.push("--"),F&&v.push(F),v.push("."),v}function r(w){const _=(0,S.splitGlobAware)(w,"/");return _.map((v,P)=>_.slice(0,P+1).join("/"))}e.spreadGlobComponents=r;function i(w){const _=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(_);)w=w.replace(_,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(v);)w=w.replace(v,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=i;const s=w=>w.type==="Assertion"&&w.kind==="lookbehind";function l(w){let _;try{_=new f.RegExpParser().parsePattern(w)}catch{return w}let v="",P=0;const b=(q,G,U)=>{v+=w.slice(P,q)+U,P=G},F=[];return new f.RegExpVisitor({onCharacterEnter(q){if(q.raw!=="\\n")return;const G=F[0];if(!G)b(q.start,q.end,"\\r?\\n");else if(!F.some(s))if(G.type==="CharacterClass")if(G.negate){const U=w.slice(G.start+2,q.start)+w.slice(q.end,G.end-1);b(G.start,G.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=w.slice(G.start+1,q.start)+w.slice(q.end,G.end-1);b(G.start,G.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else G.type==="Quantifier"&&b(q.start,q.end,"(?:\\r?\\n)")},onQuantifierEnter(q){F.unshift(q)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(q){F.unshift(q)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(q){F.unshift(q)},onCharacterClassLeave(){F.shift()},onAssertionEnter(q){s(q)&&F.push(q)},onAssertionLeave(q){F[0]===q&&F.shift()}}).visit(_),v+=w.slice(P),v}e.fixRegexNewline=l;function h(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(fe[283],me([0,1,21,135,118,10]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,n,I,c){const f=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const d={...n,folder:n.folder.with({scheme:C.Schemas.file})},p=new k.Progress(D=>I.report({...D,uri:D.uri.with({scheme:n.folder.scheme})}));return this.withToken(c,D=>f.provideTextSearchResults(T,d,p,D))}else return this.withToken(c,d=>f.provideTextSearchResults(T,n,I,d))}async withToken(T,n){const I=S(T);this.inProgress.add(I);const c=await n(I.token);return this.inProgress.delete(I),c}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=A;function S(y){const T=new g.CancellationTokenSource;return y.onCancellationRequested(()=>T.cancel()),T}}),define(fe[284],me([0,1,28,135,134]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(y){this.query=y}search(y,T,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(f){n({message:f})}},c=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((f,d)=>c.search(p=>{T(p.map(A))},y).then(p=>f({limitHit:p.limitHit,type:"success",stats:p.stats}),d))}}e.TextSearchEngineAdapter=C;function A(S){return{path:S.resource&&S.resource.fsPath,results:S.results,numMatches:(S.results||[]).reduce((y,T)=>{if(T.ranges){const n=T;return y+(Array.isArray(n.ranges)?n.ranges.length:1)}else return y+1},0)}}}),define(fe[285],me([0,1,50,299,16,18,17,3,101,8,46,2,43,31,282,284]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class D{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let u;const r=a(t),i=new S.Emitter({onFirstListenerDidAdd:()=>{u=(0,C.createCancelablePromise)(s=>this.doFileSearchWithEngine(d.Engine,r,l=>i.fire(l),s)),u.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return i.event}textSearch(t){let u;const r=a(t),i=new S.Emitter({onFirstListenerDidAdd:()=>{u=(0,C.createCancelablePromise)(s=>this.ripgrepTextSearch(r,l=>i.fire(l),s)),u.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return i.event}ripgrepTextSearch(t,u,r){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(t).search(r,u,u)}doFileSearch(t,u,r){return this.doFileSearchWithEngine(d.Engine,t,u,r)}doFileSearchWithEngine(t,u,r,i,s=D.BATCH_SIZE){let l=0;const h=_=>{Array.isArray(_)?(l+=_.length,r(_.map(v=>this.rawMatchToSearchItem(v)))):_.relativePath?(l++,r(this.rawMatchToSearchItem(_))):r(_)};if(u.sortByScore){let _=this.trySortedSearchFromCache(u,h,i);if(!_){const v=u.maxResults?Object.assign({},u,{maxResults:null}):u,P=new t(v);_=this.doSortedSearch(P,u,r,h,i)}return new Promise((v,P)=>{_.then(([b,F])=>{const M=F.map(q=>this.rawMatchToSearchItem(q));this.sendProgress(M,r,s),v(b)},P)})}const w=new t(u);return this.doSearch(w,h,s,i).then(_=>({limitHit:_.limitHit,type:"success",stats:{detailStats:_.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,T.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,u,r,i,s){const l=new S.Emitter;let h=(0,C.createCancelablePromise)(_=>{let v=[];const P=b=>{Array.isArray(b)?v=b:(i(b),l.fire(b))};return this.doSearch(t,P,-1,_).then(b=>[b,v])}),w;if(u.cacheKey){w=this.getOrCreateCache(u.cacheKey);const _={promise:h,event:l.event,resolved:!1};w.resultsToSearchCache[u.filePattern||""]=_,h.then(()=>{_.resolved=!0},v=>{delete w.resultsToSearchCache[u.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([_,v])=>{const P=w?w.scorerCache:Object.create(null),b=(typeof u.maxResults!="number"||u.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(u,v,P,s).then(F=>{const M=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:_.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:F.length},messages:_.messages,limitHit:_.limitHit||typeof u.maxResults=="number"&&v.length>u.maxResults},F]})})}getOrCreateCache(t){const u=this.caches[t];return u||(this.caches[t]=new R)}trySortedSearchFromCache(t,u,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const s=this.getResultsFromCache(i,t.filePattern||"",u,r);if(s)return s.then(([l,h,w])=>{const _=n.StopWatch.create(!1);return this.sortResults(t,h,i.scorerCache,r).then(v=>{const P=_.elapsed(),b={fromCache:!0,detailStats:w,type:this.processType,resultCount:h.length,sortingTime:P};return[{type:"success",limitHit:l.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:b},v]})})}sortResults(t,u,r,i){const s=(0,y.prepareQuery)(t.filePattern||""),l=(w,_)=>(0,y.compareItemsByFuzzyScore)(w,_,s,!0,E,r),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(u,l,h,1e4,i)}sendProgress(t,u,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)u(t.slice(i,i+r));else u(t)}getResultsFromCache(t,u,r,i){const s=n.StopWatch.create(!1),l=u.indexOf(T.sep)>=0;let h;for(const P in t.resultsToSearchCache)if(u.startsWith(P)){if(l&&P.indexOf(T.sep)<0&&P!=="")continue;const b=t.resultsToSearchCache[P];h={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!h)return null;const w=s.elapsed(),_=n.StopWatch.create(!1),v=h.event(r);return i&&i.onCancellationRequested(()=>{v.dispose()}),h.promise.then(([P,b])=>{if(i&&i.isCancellationRequested)throw(0,A.canceled)();const F=[],M=(0,y.prepareQuery)(u).normalizedLowercase;for(const q of b)!(0,f.isFilePatternMatch)(q,M)||F.push(q);return[P,F,{cacheWasResolved:h.resolved,cacheLookupTime:w,cacheFilterTime:_.elapsed(),cacheEntryCount:b.length}]})}doSearch(t,u,r,i){return new Promise((s,l)=>{let h=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(r?(h.push(w),r>0&&h.length>=r&&(u(h),h=[])):u(w))},w=>{u(w)},(w,_)=>{h.length&&u(h),w?l(w):s(_)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,r){return t.then(u,r)}catch(u){return this.then(void 0,u)}finally(u){return t.finally(u)}}}}e.SearchService=D,D.BATCH_SIZE=512;class R{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(m){return(0,T.basename)(m.relativePath)}getItemDescription(m){return(0,T.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function a(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(o),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>I.URI.revive(t))}}function o(m){return{...m,folder:I.URI.revive(m.folder)}}}),define(fe[286],me([0,1,6,10,2,28,13,27,14,74,66,31,285,283,93,134]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends T.ExtHostSearch{constructor(E,a,o,m){super(E,o,m);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new d.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new f.RipgrepSearchProvider(t)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new d.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new f.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,a){const o=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(E)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(E,a,o,m){const t=(0,T.reviveQuery)(o);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,a,t,m):super.$provideFileSearchResults(E,a,o,m)}doInternalFileSearch(E,a,o,m){const t=u=>{if((0,I.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(E,a,u.map(r=>k.URI.file(r.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,t,m)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,a){return new p.NativeTextSearchManager(E,a,void 0,"textSearchProvider")}};D=Ge([We(0,y.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,n.IURITransformerService),We(3,A.ILogService)],D),e.NativeExtHostSearch=D}),define(fe[136],me([0,1,300,125,80,22,17,3,6,8,11,32,106,107,301]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(h){this.socket=h,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,A.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const w=_=>h(C.VSBuffer.wrap(_));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(h){const w=_=>{h({type:0,hadError:_,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,A.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,A.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((h,w)=>{if(this.socket.bufferSize===0){h();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),h()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=p;var D;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var R;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(R||(R={}));class E extends y.Disposable{constructor(h,w,_,v){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=v,w?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",P=>{console.error(P),(0,A.onUnexpectedError)(P),this._onClose.fire({type:0,hadError:!0,error:P})}),this._zlibInflate.on("data",P=>{this._pendingInflateData.push(P)}),_&&(this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{console.error(P),(0,A.onUnexpectedError)(P),this._onClose.fire({type:0,hadError:!0,error:P})}),this._zlibDeflate.on("data",P=>{this._pendingDeflateData.push(P)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(P=>this._acceptChunk(P))),this._register(this.socket.onClose(P=>this._onClose.fire(P)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(C.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,w){let _=2;h.byteLength<126?_+=0:h.byteLength<2**16?_+=2:_+=8;const v=C.VSBuffer.alloc(_);if(w?v.writeUInt8(194,0):v.writeUInt8(130,0),h.byteLength<126)v.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){v.writeUInt8(126,1);let P=1;v.writeUInt8(h.byteLength>>>8&255,++P),v.writeUInt8(h.byteLength>>>0&255,++P)}else{v.writeUInt8(127,1);let P=1;v.writeUInt8(0,++P),v.writeUInt8(0,++P),v.writeUInt8(0,++P),v.writeUInt8(0,++P),v.writeUInt8(h.byteLength>>>24&255,++P),v.writeUInt8(h.byteLength>>>16&255,++P),v.writeUInt8(h.byteLength>>>8&255,++P),v.writeUInt8(h.byteLength>>>0&255,++P)}this._totalOutgoingWireBytes+=v.byteLength+h.byteLength,this.socket.write(C.VSBuffer.concat([v,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),v=(w.readUInt8(0)&128)>>>7,P=w.readUInt8(1),b=(P&128)>>>7,F=P&127;this._state.state=2,this._state.readLen=2+(b?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),_=w.readUInt8(1),v=(_&128)>>>7;let P=_&127,b=1;P===126?P=w.readUInt8(++b)*2**8+w.readUInt8(++b):P===127&&(P=w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*2**24+w.readUInt8(++b)*2**16+w.readUInt8(++b)*2**8+w.readUInt8(++b));let F=0;v&&(F=w.readUInt8(++b)*2**24+w.readUInt8(++b)*2**16+w.readUInt8(++b)*2**8+w.readUInt8(++b)),this._state.state=3,this._state.readLen=P,this._state.mask=F}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);a(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const _=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=_.length,this._onData.fire(C.VSBuffer.wrap(_))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function a(l,h){if(h===0)return;let w=l.byteLength>>>2;for(let M=0;M<w;M++){const q=l.readUInt32BE(M*4);l.writeUInt32BE(q^h,M*4)}let _=w*4,v=l.byteLength-_;const P=h>>>24&255,b=h>>>16&255,F=h>>>8&255;v>=1&&l.writeUInt8(l.readUInt8(_)^P,_),v>=2&&l.writeUInt8(l.readUInt8(_+1)^b,_+1),v>=3&&l.writeUInt8(l.readUInt8(_+2)^F,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function m(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):h=(0,T.join)((0,k.tmpdir)(),`vscode-ipc-${l}.sock`),u(h),h}e.createRandomIPCHandle=m;function t(l,h,w){const _=(0,g.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${w}-${h}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${w}-${h}.sock`):v=(0,T.join)(l,`${w}-${h}.sock`),u(v),v}e.createStaticIPCHandle=t;function u(l){const h=o[n.platform];typeof h=="number"&&l.length>=h&&console.warn(`WARNING: IPC handle "${l}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{constructor(h){super(r.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const w=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map(w,_=>({protocol:new f.Protocol(new p(_)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(l){return new Promise((h,w)=>{const _=(0,L.createServer)();_.on("error",w),_.listen(l,()=>{_.removeListener("error",w),h(new r(_))})})}e.serve=i;function s(l,h){return new Promise((w,_)=>{const v=(0,L.createConnection)(l,()=>{v.removeListener("error",_),w(f.Client.fromSocket(new p(v),h))});v.once("error",_)})}e.connect=s}),define(fe[287],me([0,1,136,279,50,40,2,199,13]),function(J,e,g,L,k,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(c,f,d){this._commands=c,this.logService=f,this._ipcHandlePath=d,this._server=L.createServer((p,D)=>this.onRequest(p,D)),this.setup().catch(p=>(f.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,f){const d=[];c.setEncoding("utf8"),c.on("data",p=>d.push(p)),c.on("end",()=>{const p=JSON.parse(d.join(""));switch(p.type){case"open":this.open(p,f);break;case"openExternal":this.openExternal(p,f);break;case"status":this.getStatus(p,f);break;case"extensionManagement":this.manageExtensions(p,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${p.type}`,D=>{D&&this.logService.error(D)}),f.end();break}})}open(c,f){let{fileURIs:d,folderURIs:p,forceNewWindow:D,diffMode:R,addMode:E,forceReuseWindow:a,gotoLineMode:o,waitMarkerFilePath:m}=c;const t=[];if(Array.isArray(p))for(const u of p)try{t.push({folderUri:A.URI.parse(u)})}catch(r){}if(Array.isArray(d))for(const u of d)try{(0,S.hasWorkspaceFileExtension)(u)?t.push({workspaceUri:A.URI.parse(u)}):t.push({fileUri:A.URI.parse(u)})}catch(r){}if(t.length){const u=m?A.URI.file(m):void 0,i={forceNewWindow:D,diffMode:R,addMode:E,gotoLineMode:o,forceReuseWindow:a,preferNewWindow:!a&&!u&&!E,waitMarkerFileURI:u};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}f.writeHead(200),f.end()}async openExternal(c,f){for(const d of c.uris){const p=A.URI.parse(d),D=p.scheme==="file"?p:d;await this._commands.executeCommand("_remoteCLI.openExternal",D)}f.writeHead(200),f.end()}async manageExtensions(c,f){try{const d=R=>R?.map(E=>/\.vsix$/i.test(E)?A.URI.parse(E):E),p={list:c.list,install:d(c.install),uninstall:d(c.uninstall),force:c.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);f.writeHead(200),f.write(D)}catch(d){f.writeHead(500),f.write(String(d),p=>{p&&this.logService.error(p)})}f.end()}async getStatus(c,f){try{const d=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(d),f.end()}catch(d){f.writeHead(500),f.write(String(d),p=>{p&&this.logService.error(p)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let n=class extends T{constructor(c,f){super(c,f,(0,g.createRandomIPCHandle)())}};n=Ge([We(0,C.IExtHostCommands),We(1,y.ILogService)],n),e.CLIServer=n}),define(fe[288],me([0,1,73,275,270,5,278,41,260,2,10,7,287,105]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class d extends k.RequireInterceptor{_installInterceptor(){const R=this,E=J.__$__nodeRequire("module"),a=E._load;E._load=function(m,t,u){for(let r of R._alternatives){let i=r(m);if(i){m=i;break}}return R._factories.has(m)?R._factories.get(m).load(m,T.URI.file((0,f.realpathSync)(t.filename)),r=>a.apply(this,[r,t,u])):a.apply(this,arguments)}}}class p extends S.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const R=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(d,R,this._registry).install(),g.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const o=process.send,m=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?o.apply(process,t):(m.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(R){return R.main}_loadCommonJSModule(R,E,a){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let o=null;a.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{R&&g.mark(`code/extHost/willLoadExtensionCode/${R.value}`),o=J.__$__nodeRequire(E.fsPath)}catch(m){return Promise.reject(m)}finally{R&&g.mark(`code/extHost/didLoadExtensionCode/${R.value}`),a.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(R){if(!!this._initData.remote.isRemote)for(const E in R){const a=R[E];a===null?delete process.env[E]:process.env[E]=a}}}e.ExtHostExtensionService=p}),define(fe[289],me([0,1,82,261,263,272,271,286,288,228,264,56,41,68,74,72,33,53,13,69,262]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D,R,E,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(c.IExtHostExtensionService,y.ExtHostExtensionService),(0,g.registerSingleton)(E.ILogService,T.ExtHostLogService),(0,g.registerSingleton)(a.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,A.ExtHostDebugService),(0,g.registerSingleton)(f.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(d.IExtHostSearch,S.NativeExtHostSearch),(0,g.registerSingleton)(p.IExtHostTask,C.ExtHostTask),(0,g.registerSingleton)(D.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(R.IExtHostTunnelService,n.ExtHostTunnelService)}),define(fe[290],me([0,1,125,302,73,17,107,136,192,226,273,22,103,28,105,18,114,276,289]),function(J,e,g,L,k,C,A,S,y,T,n,I,c,f,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const R=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),s=i._load;i._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const E=process.exit.bind(process);function a(i){process.exit=function(s){if(i)E(s);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let o=function(i){E()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,s)=>{let l=null,h=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,_=3e5,v=new p.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),w),P=new p.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),_);process.on("message",(F,M)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const q=I.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let G;if(F.skipWebSocketFrames)G=new S.NodeSocket(M);else{const U=I.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));G=new S.WebSocketNodeSocket(new S.NodeSocket(M),F.permessageDeflate,U,!1)}l?(v.cancel(),P.cancel(),l.beginAcceptReconnection(G,q),l.endAcceptReconnection()):(clearTimeout(h),l=new A.PersistentProtocol(G,q),l.onDidDispose(()=>o("renderer disconnected")),i(l),l.onSocketClose(()=>{v.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(P.isScheduled())return;v.isScheduled()&&P.schedule()}});const b={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(b)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,l)=>{const h=g.createConnection(i,()=>{h.removeListener("error",l),s(new A.PersistentProtocol(new S.NodeSocket(h)))});h.once("error",l),h.on("close",()=>{o("renderer closed the socket")})})}}async function t(){const i=await m();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(s=>{(0,T.isMessageOfType)(s,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||i.send(s)}drain(){return i.drain()}}}function u(i){return new Promise(s=>{const l=i.onMessage(h=>{l.dispose();const w=JSON.parse(h.toString()),_=w.commit,v=y.default.commit;_&&v&&_!==v&&E(55);const P=[];process.on("unhandledRejection",(M,q)=>{P.push(q),setTimeout(()=>{const G=P.indexOf(q);G>=0&&q.catch(U=>{P.splice(G,1),(0,C.isPromiseCanceledError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,C.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const q=P.indexOf(M);q>=0&&P.splice(q,1)}),process.on("uncaughtException",function(M){(0,C.onUnexpectedError)(M)});let b=0;setInterval(function(){try{process.kill(w.parentPid,0),b=0}catch(M){M&&M.code==="EPERM"?(b++,b>=3&&o(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):o(`parent process ${w.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let F;try{F=J.__$__nodeRequire("native-watchdog"),F.start(w.parentPid)}catch(M){(0,C.onUnexpectedError)(M)}i.send((0,T.createMessageOfType)(0)),s({protocol:i,initData:w})});i.send((0,T.createMessageOfType)(1))})}async function r(){k.mark("code/extHost/willConnectToRenderer");const i=await t();k.mark("code/extHost/didConnectToRenderer");const s=await u(i);k.mark("code/extHost/didWaitForInitData");const{initData:l}=s;a(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=R.useHostProxy!==void 0?R.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,D.boolean)(R.skipWorkspaceStorageLock,!1);const h=new class{exit(P){E(P)}exists(P){return f.Promises.exists(P)}realpath(P){return(0,d.realpath)(P)}};let w=null;if(l.remote.authority&&R.uriTransformerPath)try{const P=J.__$__nodeRequire(R.uriTransformerPath)(l.remote.authority);w=new c.URITransformer(P)}catch(v){console.error(v)}const _=new n.ExtensionHostMain(s.protocol,l,h,w);o=v=>_.terminate(v)}e.startExtensionHostProcess=r}),define(fe[303],me([0,1,290]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1b9403cd461c9c975bcb9e48d84ba9e4ea86559e/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
